﻿note
	description: "Implementation of {STS_COMPLEX_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	COMPLEX_SET

inherit
	STS_COMPLEX_SET
		undefine
			has,
			with,
			without,
			cardinality,
			out,
			equals,
			is_subset,
			is_superset,
			is_comparable,
			is_strict_subset,
			is_strict_superset,
			is_trivial_subset,
			is_trivial_superset,
			is_proper_subset,
			is_proper_superset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented,
			intersected,
			subtracted,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
			equality_holds
		end

	NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		rename
			u as c,
			universe as complex_universe
		redefine
			eq,
			o, empty_set,
			singleton,
			unit,
			converted_element,
			element_to_boolean,
			element_to_element,
			element_to_natural,
			element_to_sets,
			element_to_tuple,
			tuple_extensor,
			any_anchor
		end

	SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		undefine
			equals,
			is_subset,
			is_superset,
			is_comparable,
			is_strict_subset,
			is_strict_superset,
			is_trivial_superset,
			is_proper_superset,
			is_disjoint,
			complemented,
			united,
			intersected,
			subtracted,
			subtracted_symmetricaly
		redefine
			make_singleton,
			make_extended,
			eq,
			o, empty_set,
			singleton,
			unit,
			converted_element,
			element_to_boolean,
			element_to_element,
			element_to_natural,
			element_to_sets,
			element_to_tuple,
			tuple_extensor,
			any_anchor,
			set_anchor,
			subset_anchor,
			superset_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended,
	make_from_set,
	make_from_numeric_set

convert
	make_from_set ({
		STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_COMPLEX_SET,

		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_COMPLEX_UNIVERSE,

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_REAL_EQUALITY],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_REAL_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [REAL_NUMBER]]
		}),
	make_from_numeric_set ({
		STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [REAL_NUMBER]]
		}),
	as_set_of_pairs: {
		SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],

		SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		}

feature {NONE} -- Initialization

	make_singleton (a: STS_COMPLEX_NUMBER)
			-- <Precursor>
		do
			others := O
			create any_storage.put (converted_element (a))
		end

	make_extended (a: STS_COMPLEX_NUMBER; s: STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY])
			-- <Precursor>
		do
			others := O.converted (s)
			create any_storage.put (converted_element (a))
		end

	make_from_numeric_set (s: STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]])
			-- Create a set equal to `s`.
		do
			if s.is_empty then
				make_empty
			else
				others := O.numeric_converted (s.others)
				create any_storage.put (converted_element (s.any))
			end
		ensure
			same_set: s ≍ Current
		end

feature -- Primitive

	eq: STS_COMPLEX_EQUALITY
			-- <Precursor>
		once
			create Result
		end

feature -- Access

	Zero: COMPLEX_NUMBER
			-- <Precursor>
		once
		ensure then
			class
		end

	c,
	complex_universe: COMPLEX_UNIVERSE
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Construction

	numeric_batch_extended (s: STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like superset_anchor
			-- Current set extended with every element in `s`
		require
			is_disjoint: s.is_disjoint (Current)
		local
			l_s: STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		do
			from
				Result := Current
				l_s := s
			invariant
				building_prefixed_s_up: (s ∖ l_s) ≍ Result.as_tuple.prefix (# (s ∖ l_s)).terms
				suffixed_current: Result.as_tuple.suffix (# Current).terms ≍ Current
			until
				l_s.is_empty
			loop
					check
						does_not_have: Result ∌ l_s.any -- Result ≍ (Current ∪ (s ∖ l_s))
					end
				Result := Result.extended (l_s.any)
				l_s := l_s.others
			variant
				cardinality: natural_as_integer (# l_s)
			end
		ensure
			prefixed_s: s ≍ Result.as_tuple.prefix (# s).terms
			suffixed_current: Result.as_tuple.suffix (# Current).terms ≍ Current
		end

feature -- Conversion

	as_set_of_pairs: SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
			-- Current complex set converted into a set of ordered pairs
			--| Ideally, {STS_COMPLEX_SET} could inherit from {STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]}, but
			--| {STS_COMPLEX_NUMBER} does not inherit from {STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]} (please see the note in
			--| the header of {STI_COMPLEX_NUMBER}). Besides, {COMPLEX_SET} cannot inherit from
			--| {SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]}, because it would inherit twice from {STS_SET [...]}, i.e. from
			--| {STS_SET {STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]} and from
			--| {STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]}; however, such a repeated inheritance is forbidden when the generic parameters of the repeatedly inherited
			--| class are not the same.
		local
			s: like subset_anchor
		do
			from
				create Result.make_empty
				s := Current
			invariant
				every_complex_number: (Current ∖ s) |∀ agent set_has_complex_number (Result, ?)
				nothing_else: # Result = # (Current ∖ s)
			until
				s.is_empty
			loop
					check
						does_not_have: Result ∌ s.any -- Loop invariant
					end
--				Result := Result.extended (s.any) -- TODO: Segmentation violation.
				Result := Result.extended (s.any.as_ordered_pair)
				s := s.others
			variant
				cardinality: natural_as_integer (# s)
			end
		ensure
--			every_complex_number: Current |∀ agent Result.has -- TODO: Contravariance would help here.
			every_complex_number: Current |∀ agent set_has_complex_number (Result, ?)
			nothing_else: # Result = # Current
		end

feature -- Factory

	o,
	empty_set: COMPLEX_SET
			-- <Precursor>
		once
			create Result.make_empty
		ensure then
			class
		end

	singleton (a: STS_COMPLEX_NUMBER): like set_anchor
			-- <Precursor>
			-- TODO: Redefine in others numeric sets.
		do
				check
					does_not_have: O ∌ a -- o.is_empty
				end
			Result := O.extended (a)
		ensure then
			class
		end

	unit: N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
			-- <Precursor>
		once
			create Result.make_unit
		end

	converted_element (z: STS_COMPLEX_NUMBER): like Any_anchor
			-- `z` converted to an element like `any'
		do
			if attached {like Any_anchor} z as l_z then
				Result := l_z
			else
				create Result.make_from_complex (z)
			end
		ensure then
			class
		end

	numeric_converted (s: STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_anchor
			-- `s` converted to a set like current one
		do
			if attached {like set_anchor} s as cs then
				Result := cs
			else
					check
						is_disjoint: s.is_disjoint (O) -- O.is_empty
					end
				Result := O.numeric_batch_extended (s)
			end
		ensure
			definition: s ≍ Result
		end

feature -- Predicate

	set_has_complex_number (
		s: STS_SET_OF_ORDERED_PAIRS [
			STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]
			]
		z: STS_COMPLEX_NUMBER
		): BOOLEAN
			-- Does `s' have the complex number `z'?
			--| TODO: `z' should be a {COMPLEX_NUMBER}, but since this feature is meant to be used as an agent in a `for_all' construct, it causes a CATcall.
		local
			l_z: like Any_anchor
		do
			if attached {like Any_anchor} z as exp_z then
				Result := s ∋ exp_z
			else
				create l_z.make_from_complex (z)
				Result := s ∋ l_z
			end
		ensure
			class
			definition: Result = s ∋ (create {like Any_anchor}.make_from_complex (z))
		end

feature -- Transformer

	element_to_boolean: TRANSFORMER [STS_COMPLEX_NUMBER, BOOLEAN, STS_COMPLEX_EQUALITY, STS_OBJECT_EQUALITY [BOOLEAN]]
			-- <Precursor>
		once
			create Result
		end

	element_to_element: TRANSFORMER [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
			-- <Precursor>
		once
			create Result
		end

	element_to_natural: TRANSFORMER [STS_COMPLEX_NUMBER, NATURAL, STS_COMPLEX_EQUALITY, STS_OBJECT_EQUALITY [NATURAL]]
			-- <Precursor>
		once
			create Result
		end

	element_to_sets: TRANSFORMER [STS_COMPLEX_NUMBER, STS_SET [STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY], STS_SET_EQUALITY [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]], STS_COMPLEX_EQUALITY, STS_SET_EQUALITY [STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY], STS_SET_EQUALITY [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]]]
			-- <Precursor>
		once
			create Result
		end

	element_to_tuple: TRANSFORMER [STS_COMPLEX_NUMBER, STS_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY], STS_COMPLEX_EQUALITY, STS_N_TUPLE_EQUALITY [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]]
			-- <Precursor>
		once
			create Result
		end

	tuple_extensor: TRANSFORMER [STS_ORDERED_PAIR [STS_COMPLEX_NUMBER, STS_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY], STS_COMPLEX_EQUALITY, STS_N_TUPLE_EQUALITY [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]], STS_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY], STS_ORDERED_PAIR_EQUALITY [STS_COMPLEX_NUMBER, STS_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY], STS_COMPLEX_EQUALITY, STS_N_TUPLE_EQUALITY [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]], STS_N_TUPLE_EQUALITY [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]]
			-- <Precursor>
		once
			create Result
		end

feature -- Anchor

	any_anchor: COMPLEX_NUMBER
			-- <Precursor>
		require else
			no_requirement: True
		once
		end

	set_anchor,
	subset_anchor,
	superset_anchor: COMPLEX_SET
			-- <Precursor>
		do
			Result := Current
		end

--	integer_anchor: INTEGER_NUMBER
--			-- <Precursor>
--		once
--		ensure then
--			class
--		end

invariant
	Zero: Zero ≍ Zero.Zero
--	O: O.is_empty -- TODO: Feature call on void target.
	Empty_set: Empty_set.is_empty -- TODO: Feature call on void target.
	Unit: Unit.is_unit

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
