﻿note
	description: "Implementation of {STS_INTEGER_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	INTEGER_SET

inherit
	STS_INTEGER_SET
		undefine
			has,
			with,
			without,
			cardinality,
			out,
			equals,
			is_subset,
			is_superset,
			is_comparable,
			is_strict_subset,
			is_strict_superset,
			is_trivial_subset,
			is_trivial_superset,
			is_proper_subset,
			is_proper_superset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented,
			intersected,
			subtracted,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
			equality_holds
		end

	ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			u as z,
			universe as integer_universe
		redefine
			eq,
			o, empty_set,
			unit,
			converted_element,
			element_to_boolean,
			element_to_element,
			element_to_natural,
			element_to_sets,
			element_to_tuple,
			tuple_extensor,
			any_anchor
		end

	SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		undefine
			equals,
			is_subset,
			is_superset,
			is_comparable,
			is_strict_subset,
			is_strict_superset,
			is_trivial_superset,
			is_proper_superset,
			is_disjoint,
			complemented,
			united,
			intersected,
			subtracted,
			subtracted_symmetricaly
		redefine
			make_singleton,
			make_extended,
			eq,
			o, empty_set,
			unit,
			converted_element,
			element_to_boolean,
			element_to_element,
			element_to_natural,
			element_to_sets,
			element_to_tuple,
			tuple_extensor,
			any_anchor,
			set_anchor,
			subset_anchor,
			superset_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended,
	make_from_set,
	make_from_numeric_set

convert
	make_from_set ({
		STS_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],
		SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],

		STS_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],
		NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],

		STS_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],
		ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],

		STS_INTEGER_SET,

		STS_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],
		UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],

		STS_INTEGER_UNIVERSE,

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [INTEGER_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [INTEGER_NUMBER]]
		}),
	make_from_numeric_set ({
		STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [REAL_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [INTEGER_NUMBER]],
		TRANSFORMABLE_SET [STS_INTEGER_NUMBER, INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [INTEGER_NUMBER]]
		}),
	as_complex_set: {
		COMPLEX_SET,
		STS_COMPLEX_SET,

		NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		},
	as_real_set: {
		REAL_SET,
		STS_REAL_SET,

		NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY],
		STS_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY]
		}

feature {NONE} -- Initialization

	make_singleton (a: STS_INTEGER_NUMBER)
			-- <Precursor>
		do
			others := O
			create any_storage.put (converted_element (a))
		end

	make_extended (a: STS_INTEGER_NUMBER; s: STS_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY])
			-- <Precursor>
		do
			others := O.converted (s)
			create any_storage.put (converted_element (a))
		end

	make_from_numeric_set (s: STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]])
			-- Create a set equal to `s`.
		do
			if s.is_empty then
				make_empty
			else
				others := O.numeric_converted (s.others)
				create any_storage.put (converted_element (s.any))
			end
		ensure
			same_set: s ≍ Current
		end

feature -- Primitive

	eq: STS_INTEGER_EQUALITY
			-- <Precursor>
		once
			create Result
		end

feature -- Access

	Zero: INTEGER_NUMBER
			-- <Precursor>
		once
		ensure then
			class
		end

	z,
	integer_universe: INTEGER_UNIVERSE
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Construction

	numeric_batch_extended (s: STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like superset_anchor
			-- Current set extended with every element in `s`
		require
			is_disjoint: s.is_disjoint (Current)
		local
			l_s: STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		do
			from
				Result := Current
				l_s := s
			invariant
				building_prefixed_s_up: (s ∖ l_s) ≍ Result.as_tuple.prefix (# (s ∖ l_s)).terms
				suffixed_current: Result.as_tuple.suffix (# Current).terms ≍ Current
			until
				l_s.is_empty
			loop
					check
						does_not_have: Result ∌ l_s.any -- Result ≍ (Current ∪ (s ∖ l_s))
					end
				Result := Result.extended (l_s.any)
				l_s := l_s.others
			variant
				cardinality: natural_as_integer (# l_s)
			end
		ensure
			prefixed_s: s ≍ Result.as_tuple.prefix (# s).terms
			suffixed_current: Result.as_tuple.suffix (# Current).terms ≍ Current
		end

feature -- Conversion

	as_complex_set: COMPLEX_SET
			-- <Precursor>
		local
			s: like subset_anchor
		do
			from
				Result := {COMPLEX_SET}.O
				s := Current
			invariant
				every_integer_number: (Current ∖ s) |∀ agent complex_set_has_integer_number (Result, ?)
				nothing_else: Result |∀ agent (Current ∖ s).has_complex_number
			until
				s.is_empty
			loop
				Result := Result.extended (s.any)
				s := s.others
			variant
				cardinality: (# s).as_integer_64
			end
		end

	as_real_set: REAL_SET
			-- <Precursor>
		local
			s: like subset_anchor
		do
			from
				Result := {REAL_SET}.O
				s := Current
			invariant
				every_integer_number: (Current ∖ s) |∀ agent real_set_has_integer_number (Result, ?)
				nothing_else: Result |∀ agent (Current ∖ s).has_real_number
			until
				s.is_empty
			loop
				Result := Result.extended (s.any)
				s := s.others
			variant
				cardinality: (# s).as_integer_64
			end
		end

feature -- Factory

	o,
	empty_set: INTEGER_SET
			-- <Precursor>
		once
			create Result.make_empty
		ensure then
			class
		end

	unit: N_TUPLE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
			-- <Precursor>
		once
			create Result.make_unit
		end

	converted_element (x: STS_INTEGER_NUMBER): like Any_anchor
			-- `x` converted to an element like `any'
		do
			if attached {like Any_anchor} x as l_x then
				Result := l_x
			else
				create Result.make_from_integer (x)
			end
		ensure then
			class
		end

	numeric_converted (s: STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_anchor
			-- `s` converted to a set like current one
		do
			if attached {like set_anchor} s as cs then
				Result := cs
			else
					check
						is_disjoint: s.is_disjoint (O) -- O.is_empty
					end
				Result := O.numeric_batch_extended (s)
			end
		ensure
			definition: s ≍ Result
		end

feature -- Transformer

	element_to_boolean: TRANSFORMER [STS_INTEGER_NUMBER, BOOLEAN, STS_INTEGER_EQUALITY, STS_OBJECT_EQUALITY [BOOLEAN]]
			-- <Precursor>
		once
			create Result
		end

	element_to_element: TRANSFORMER [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]
			-- <Precursor>
		once
			create Result
		end

	element_to_natural: TRANSFORMER [STS_INTEGER_NUMBER, NATURAL, STS_INTEGER_EQUALITY, STS_OBJECT_EQUALITY [NATURAL]]
			-- <Precursor>
		once
			create Result
		end

	element_to_sets: TRANSFORMER [STS_INTEGER_NUMBER, STS_SET [STS_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY], STS_SET_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]], STS_INTEGER_EQUALITY, STS_SET_EQUALITY [STS_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY], STS_SET_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]]]
			-- <Precursor>
		once
			create Result
		end

	element_to_tuple: TRANSFORMER [STS_INTEGER_NUMBER, STS_N_TUPLE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY], STS_INTEGER_EQUALITY, STS_N_TUPLE_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]]
			-- <Precursor>
		once
			create Result
		end

	tuple_extensor: TRANSFORMER [STS_ORDERED_PAIR [STS_INTEGER_NUMBER, STS_N_TUPLE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY], STS_INTEGER_EQUALITY, STS_N_TUPLE_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]], STS_N_TUPLE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY], STS_ORDERED_PAIR_EQUALITY [STS_INTEGER_NUMBER, STS_N_TUPLE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY], STS_INTEGER_EQUALITY, STS_N_TUPLE_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]], STS_N_TUPLE_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]]
			-- <Precursor>
		once
			create Result
		end

feature -- Anchor

	any_anchor: INTEGER_NUMBER
			-- <Precursor>
		require else
			no_requirement: True
		once
		end

	set_anchor,
	subset_anchor,
	superset_anchor: INTEGER_SET
			-- <Precursor>
		do
			Result := Current
		end

	integer_anchor: INTEGER_NUMBER
			-- <Precursor>
		once
		ensure then
			class
		end

invariant
	Zero: Zero.complex_equals (Zero.Zero)
--	O: O.is_empty -- TODO: VOID target!
	Empty_set: Empty_set.is_empty
	Unit: Unit.is_unit

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
