﻿note
	description: "Implementation of {STS_SET_TUPLE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	SET_TUPLE [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STS_SET_TUPLE [A, EQ]
		undefine
			has,
			set,
			sets,
			front,
			last,
			n,
			out,
			equals,
			exists,
			for_all,
			left_trimmed,
			right_trimmed,
			suffix,
			replacing,
			proper_right_reduced,
			indexed_set
		redefine
			for_all_tuples
		end

	N_TUPLE [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			term as set alias "[]",
			terms as sets,
			terms_out as sets_out,
			term_out as set_out,
			unit as unit_s,
			converted_terms as converted_sets,
			term_to_term as set_to_set,
			term_to_index as set_to_index,
			predicate_holds_to_term as predicate_holds_to_set,
			terms_are_equal as sets_are_equal,
			reversed_terms_are_equal as reversed_sets_are_equal,
			indexed_term as indexed_set,
			appending_term_out as appending_set_out,
			converted_term as converted_set,
			term_anchor as set_anchor,
			terms_anchor as sets_anchor
		redefine
			converted_set,
			set_anchor,
			tuple_anchor,
			trimmed_tuple_anchor,
			extended_tuple_anchor,
			sets_anchor
		end

create
	make_unit,
	make_after,
	make_n,
	make_from_tuple

convert
	make_from_tuple ({
		STS_N_TUPLE [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		N_TUPLE [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],
		TRANSFORMABLE_TUPLE [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],

		STS_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],
		TRANSFORMABLE_TUPLE [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		TRANSFORMABLE_TUPLE [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_TUPLE [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_TUPLE [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_TUPLE [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_TUPLE [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_TUPLE [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],
		TRANSFORMABLE_TUPLE [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],

		STS_SET_TUPLE [A, EQ]
		})

feature -- Quantifier

	for_all_tuples (p: PREDICATE [STS_N_TUPLE [A, EQ]]): BOOLEAN
			-- <Precursor>
		local
			cardinalities, row: N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]

			next_row: FUNCTION [N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], detachable N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]]
			choice_tuple: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], like unit]

			all_rows: FUNCTION [
				STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]],
				SET [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], STS_N_TUPLE_EQUALITY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]]
				]

			tuples_so_far: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]]

			how_many_rows,
			row_position,
			tuples_ahead: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], NATURAL]
		do
			cardinalities := {TRANSFORMER [STS_SET [A, EQ], NATURAL, STS_SET_EQUALITY [A, EQ], STS_OBJECT_EQUALITY [NATURAL]]}.tuple_map (Current, agent {STS_SET [A, EQ]}.cardinality)

			next_row := agent (ia_row, ia_cardinalities: N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]ia_n: NATURAL
					): detachable N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
						-- Next "row", relative to `ia_row', to be converted into a tuple.
					local
						il_row: N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
						i, d: NATURAL
					do
						from
							il_row := ia_row
							i := ia_n
						invariant
							n: il_row.n = ia_n
							terms: il_row.for_all (
								agent (j, x, ia_i: NATURAL; i2a_row, i2a_cardinalities: N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]): BOOLEAN
									do
										check
												-- j ∈ indices
											small_enough: j <= i2a_row.n -- i2a_row.n = n
											small_enough: j <= i2a_cardinalities.n -- i2a_cardinalities.n = n
											positive: 0 < j
										then
											Result := if j <= ia_i then
													x = i2a_row [j]
												else
													x = (i2a_row [j] + 1) \\ i2a_cardinalities [j]
												end
										end
									end (?, ?, i, ia_row, ia_cardinalities)
								)
						until
							i = 0 or d > 0
						loop
								check
										-- i ∈ indices
									small_enough: i <= il_row.n -- il_row.n = n
									small_enough: i <= ia_cardinalities.n -- ia_cardinalities.n = n
									positive: 0 < i
								end
							d := (il_row [i] + 1) \\ ia_cardinalities [i]
							il_row := il_row.replacing (i, d)
							i := i - 1
						variant
							i: i.as_integer_64
						end
						if d > 0 then
							Result := il_row
						end
					end (?, cardinalities, n)

			choice_tuple := agent (ia_row: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]): like unit
						-- N-tuple of `n_ary_product' chosen according to `ia_row'
					local
						il_row: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
						st: like trimmed_tuple_anchor
						choice_term: FUNCTION [NATURAL, like first, A]
					do
						choice_term := agent (d: NATURAL; s: like first): A
								-- The (`d' + 1)-th term in `s'.`as_tuple'
							local
								i: NATURAL
								il_s: like first
							do
								from
									il_s := s
									i := d
								invariant
									elements_ahead: # il_s = # s - (d - i)
								until
									i = 0
								loop
									il_s := il_s.others
									i := i - 1
								variant
									i: natural_as_integer (i)
								end
									check
										is_not_empty: not il_s.is_empty -- # il_s = # s - d > 0
									end
								Result := il_s.any
							end

						from
							Result := unit
							il_row := ia_row
							st := Current
						invariant
							n: Result.n = ia_row.n - il_row.n
							terms: Result.reversed.for_all (
								agent (i: NATURAL; x: A; i2a_row: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]; ia_choice_term: FUNCTION [NATURAL, like first, A]): BOOLEAN
									do
										check
												-- i ∈ indices
											positive: 0 < i
											small_enough: i ≤ i2a_row.n -- i2a_row.n ≤ n
											small_enough: i ≤ n
										then
											Result := o.eq (x, ia_choice_term (i2a_row [i], Current [i]))
										end
									end (?, ?, ia_row, choice_term)
								)
						until
							st.is_unit
						loop
								check
									is_not_unit: not il_row.is_unit -- il_row.n = st.n
								end
							Result := Result.after (choice_term (il_row.first, st.first))
							il_row := il_row.tail
							st := st.tail
						variant
							st_n: natural_as_integer (st.n)
						end
						Result := Result.reversed
					end

			how_many_rows := agent (ia_cardinalities: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]): NATURAL
					-- How many rows may be created out of `ia_cardinalities'?
				do
					Result := ia_cardinalities.left_reduced (
						1, agent  (acc, x: NATURAL): NATURAL
							do
								Result := acc * x
							end
						)
				end

			row_position := agent (
				ia_row, ia_cardinalities: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
				ia_how_many_rows: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], NATURAL]
				): NATURAL
					-- Which position does `ia_row' occupy in the sequence of rows determined by `ia_cardinalities'?
				do
					Result := ia_row.indexed_left_reduced (
						0, 1, agent (
							acc, i, x: NATURAL
							i2a_cardinalities: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
							i2a_how_many_rows: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], NATURAL]
							): NATURAL
							do
								Result := acc + x * i2a_how_many_rows (i2a_cardinalities.left_trimmed (i))
							end (?, ?, ?, ia_cardinalities, ia_how_many_rows)
						)
				end (?, cardinalities, how_many_rows)

			tuples_ahead := agent (
				ia_row: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
				ia_rows_count: NATURAL
				ia_row_position: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], NATURAL]
				): NATURAL
					-- Amount of "rows" to be processed after `ia_row'
				do
					Result := ia_rows_count - ia_row_position (ia_row) - 1
				end (?, how_many_rows (cardinalities), row_position)

			all_rows := agent (ia_cardinalities: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]): SET [
				STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]],
				STS_N_TUPLE_EQUALITY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
				]
					-- Set of all possible "rows" that may be produced out of `ia_cardinalities'
				local
					row_matrix: SET_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
					row_range: FUNCTION [NATURAL, SET [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]]
					natural_to_range: TRANSFORMER [
						NATURAL,
						STS_SET [NATURAL, STS_OBJECT_EQUALITY [NATURAL]],
						STS_OBJECT_EQUALITY [NATURAL],
						STS_SET_EQUALITY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
						]
				do
					row_range := agent (m: NATURAL): SET [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
							-- Set of natural numbers from 0 to `m' - 1, i.e. {0..`m' - 1}.
						local
							i: NATURAL
						do
							from
								create Result.make_empty
								i := m
							invariant
								cardinality: # Result = m - i
								elements: Result |∀ agent (x, ia_i: NATURAL): BOOLEAN
									do
										Result := x >= ia_i
									end (?, i)
							until
								i = 0
							loop
								i := i - 1
									check
										does_not_have: Result ∌ i -- Result = {(i + 1)...(m - 1)}
									end
								Result := Result.extended (i)
							variant
								i: natural_as_integer (i)
							end
						end

					create row_matrix.make_unit
					create natural_to_range
					row_matrix := row_matrix.converted (natural_to_range.tuple_map (ia_cardinalities, row_range))
					Result := row_matrix.n_ary_product
				end

			tuples_so_far := agent (
				ia_row: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
				ia_all_rows: SET [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], STS_N_TUPLE_EQUALITY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]]
				ia_row_position: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], NATURAL]
				ia_choice_tuple: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], like unit]
				): SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
				local
					rows_so_far: SET [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], STS_N_TUPLE_EQUALITY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]]
					row_to_n_tuple: TRANSFORMER [
						STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], STS_N_TUPLE [A, EQ],
						STS_N_TUPLE_EQUALITY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], STS_N_TUPLE_EQUALITY [A, EQ]
						]
				do
					rows_so_far := ia_all_rows | agent (
						t: STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
						current_row_position: NATURAL
						i2a_row_position: FUNCTION [STS_N_TUPLE [NATURAL, STS_OBJECT_EQUALITY [NATURAL]], NATURAL]
						): BOOLEAN
						do
							Result := i2a_row_position (t) <= current_row_position
						end (?, ia_row_position (ia_row), ia_row_position)

					create row_to_n_tuple
					Result := row_to_n_tuple.set_map (rows_so_far, ia_choice_tuple)
				end (?, all_rows (cardinalities), row_position, choice_tuple)

			if has (o) then
					check
						empty_product: n_ary_product.is_empty
					end
				Result := True -- Vacuous truth
			else
				from
					create row.make_n (n, 0)
					Result := p (choice_tuple (row))
				invariant
					definition: Result = (tuples_so_far (row) |∀ p)
				until
					not Result or else not attached next_row (row) as nr
				loop
					row := nr
					Result := p (choice_tuple (row))
				variant
					tuples_ahead: natural_as_integer (tuples_ahead (row))
				end
			end
		end

feature -- Operation

	n_ary_product alias "∏": SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			-- <Precursor>
		local
			st: like trimmed_tuple_anchor
		do
			from
				Result := unit.as_singleton
				st := reversed
			invariant
				definition: Result ≍ set_to_tuples.tuple_right_reduction (left_trimmed (st.n), agent {STS_SET [A, EQ]}.crossed_tuples, unit.as_singleton)
			until
				st.is_unit
			loop
				Result := st.first.crossed_tuples (Result)
				st := st.tail
			variant
				n: natural_as_integer (st.n)
			end
		end

feature -- Factory

	o,
	empty_set: like first.subset_anchor
			-- <Precursor>
		do
			if not is_unit then
				Result := first.o
			else
				create Result.make_empty
			end
		end

	unit: like first.n_tuple_anchor
			-- <Precursor>
		do
			create Result.make_unit
		end

	converted_set (s: STS_SET [A, EQ]): like set_anchor
			-- `s' converted to a set like `set'
		do
			Result := o.converted (s)
		end

feature -- Transformer

	set_to_tuples: TRANSFORMER [
		STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Anchor

	set_anchor: SET [A, EQ]
			-- Anchor for sets like `first`
		do
			Result := first
		end

	tuple_anchor,
	trimmed_tuple_anchor,
	extended_tuple_anchor: SET_TUPLE [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

	sets_anchor: SET_FAMILY [A, EQ]
			-- <Precursor>
		do
			Result := sets
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
