﻿note
	description: "Implementation of {STS_TRANSFORMABLE_TUPLE}."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

class
	TRANSFORMABLE_TUPLE [A, B, EQ_A -> STS_EQUALITY [A] create default_create end, EQ_B -> STS_EQUALITY [B] create default_create end]

inherit
	STS_TRANSFORMABLE_TUPLE [A, B, EQ_A, EQ_B]
		undefine
			has,
			term,
			terms,
			front,
			last,
			n,
			out,
			equals,
			exists,
			for_all,
			left_trimmed,
			right_trimmed,
			suffix,
			replacing,
			proper_right_reduced,
			indexed_term
		end

	N_TUPLE [A, EQ_A]
		rename
			eq as eq_a,
			mapped as mapped_to_same_kind,
			left_reduced as left_reduced_to_term_like,
			indexed_left_reduced as indexed_left_reduced_to_term_like,
			right_reduced as right_reduced_to_term_like,
			indexed_right_reduced as indexed_right_reduced_to_term_like
		redefine
			tuple_anchor,
			trimmed_tuple_anchor,
			extended_tuple_anchor,
			terms_anchor
		end

create
	make_unit,
	make_after,
	make_n,
	make_from_tuple

convert
	make_from_tuple ({
		STS_N_TUPLE [A, EQ_A],
		N_TUPLE [A, EQ_A],

		STS_TRANSFORMABLE_TUPLE [A, A, EQ_A, EQ_A],
		TRANSFORMABLE_TUPLE [A, A, EQ_A, EQ_A],

		STS_TRANSFORMABLE_TUPLE [A, B, EQ_A, EQ_B]
		})

feature -- Primitive

	eq_b: EQ_B
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Factory

	transformer: TRANSFORMER [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Anchor

	tuple_anchor,
	trimmed_tuple_anchor,
	extended_tuple_anchor: TRANSFORMABLE_TUPLE [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			Result := Current
		end

	terms_anchor: TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			Result := terms
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
