﻿note
	description: "Implementation of {STS_COMPOSABLE_ORDERED_PAIR}."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	COMPOSABLE_ORDERED_PAIR [
		W, A, B,
		EQ_W -> STS_EQUALITY [W] create default_create end,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	STS_COMPOSABLE_ORDERED_PAIR [W, A, B, EQ_W, EQ_A, EQ_B]
		undefine
			out
		end

	ORDERED_PAIR [A, B, EQ_A, EQ_B]
		redefine
			inverse,
			composed_with_homogeneous
		end

create
	make, make_from_pair

convert
	make_from_pair ({
		STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
		ORDERED_PAIR [A, B, EQ_A, EQ_B],

		STS_COMPOSABLE_ORDERED_PAIR [W, A, B, EQ_W, EQ_A, EQ_B],

		STS_COMPOSABLE_ORDERED_PAIR [A, A, B, EQ_A, EQ_A, EQ_B],
		COMPOSABLE_ORDERED_PAIR [A, A, B, EQ_A, EQ_A, EQ_B],

		STS_COMPOSABLE_ORDERED_PAIR [B, A, B, EQ_B, EQ_A, EQ_B],
		COMPOSABLE_ORDERED_PAIR [B, A, B, EQ_B, EQ_A, EQ_B]
		})

feature -- Primitive

	eq_w: EQ_W
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Operation

	inverse: COMPOSABLE_ORDERED_PAIR [W, B, A, EQ_W, EQ_B, EQ_A]
			-- <Precursor>
		do
			create Result.make (b, a)
		end

	composed_with_homogeneous (x1x2: STS_ORDERED_PAIR [A, A, EQ_A, EQ_A]): COMPOSABLE_ORDERED_PAIR [W, A, B, EQ_W, EQ_A, EQ_B]
			-- <Precursor>
		do
			create Result.make (x1x2.a, b)
		end

	composed alias "∘" (wx: STS_ORDERED_PAIR [W, A, EQ_W, EQ_A]): COMPOSABLE_ORDERED_PAIR [A, W, B, EQ_A, EQ_W, EQ_B]
			-- <Precursor>
		do
			create Result.make (wx.a, b)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
