﻿note
	description: "Implementation of {STS_HOMOGENEOUS_ORDERED_PAIR}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	HOMOGENEOUS_ORDERED_PAIR [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STS_HOMOGENEOUS_ORDERED_PAIR [A, EQ]
		undefine
			out
		end

	ORDERED_PAIR [A, A, EQ, EQ]
		rename
			eq_a as eq,
			eq_b as eq,
			composed_with_homogeneous as composed alias "∘"
		redefine
			eq,
			inverse,
			composed
		end

create
	make, make_from_pair

convert
	make_from_pair ({
		STS_ORDERED_PAIR [A, A, EQ, EQ],
		ORDERED_PAIR [A, A, EQ, EQ],

		STS_COMPOSABLE_ORDERED_PAIR [A, A, A, EQ, EQ, EQ],
		COMPOSABLE_ORDERED_PAIR [A, A, A, EQ, EQ, EQ],

		STS_HOMOGENEOUS_ORDERED_PAIR [A, EQ]
		}),

	as_tuple: {
		STS_N_TUPLE [A, EQ],
		N_TUPLE [A, EQ]
		}

feature -- Primitive

	eq: EQ
			-- Equality for objects like `first' and `second'
		do
			create Result
		end

feature -- Operation

	inverse: HOMOGENEOUS_ORDERED_PAIR [A, EQ]
			-- <Precursor>
		do
			create Result.make (b, a)
		end

	composed alias "∘" (x1x2: STS_ORDERED_PAIR [A, A, EQ, EQ]): HOMOGENEOUS_ORDERED_PAIR [A, EQ]
			-- <Precursor>
		do
			create Result.make (x1x2.a, b)
		end

feature -- Conversion

	as_tuple: N_TUPLE [A, EQ]
			-- <Precursor>
		do
			create Result.make_unit
			Result := Result.after (b).after (a)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
