﻿note
	description: "Implementation of {STS_SET_FAMILY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

class
	SET_FAMILY [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STS_SET_FAMILY [A, EQ]
		undefine
			has,
			with,
			without,
			cardinality,
			out,
			equals,
			is_subset,
			is_strict_subset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented,
			intersected,
			family_intersection,
			subtracted,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
			equality_holds
		end

	SET_OF_SETS [A, EQ]
		rename
			universe as family_union alias "⋃",
			sets_union as family_union alias "⋃",
			sets_intersection as family_intersection alias "⋂",
			o_s as o_f,
			empty_set_of_sets as empty_family,
			unit_s as unit_f,
			set_anchor as family_anchor,
			subset_anchor as subfamily_anchor,
			superset_anchor as superfamily_anchor
		redefine
			family_anchor,
			subfamily_anchor,
			superfamily_anchor
		end

	SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			o as o_f,
			empty_set as empty_family,
			unit as unit_f,
			converted_element as converted_member_set,
			element_to_element as set_to_set,
			element_to_natural as set_to_natural,
			element_to_boolean as set_to_boolean,
			element_to_tuple as set_to_tuple,
			n_tuple_anchor as set_tuple_anchor,
			set_anchor as family_anchor,
			subset_anchor as subfamily_anchor,
			superset_anchor as superfamily_anchor
		undefine
			converted_member_set,
			any_anchor,
			set_tuple_anchor
		redefine
			family_anchor,
			subfamily_anchor,
			superfamily_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended,
	make_from_set

convert
	make_from_set ({
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],
		TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],
		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],

		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],

		STS_SET_OF_SETS [A, EQ],
		SET_OF_SETS [A, EQ],

		STS_SET_FAMILY [A, EQ],

		STS_SET_PARTITION [A, EQ],

		STS_SUBSET_FAMILY [A, EQ],
		SUBSET_FAMILY [A, EQ],

		STS_SUBSET_FAMILY_STRUCTURE [A, EQ],
		SUBSET_FAMILY_STRUCTURE [A, EQ]
		})

feature -- Anchor

	family_anchor,
	subfamily_anchor,
	superfamily_anchor: SET_FAMILY [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
