﻿note
	description: "Implementation of {STS_SUBSET_FAMILY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	SUBSET_FAMILY [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STS_SUBSET_FAMILY [A, EQ]
		undefine
			has,
			with, -- todo: A bug in the compiler makes the post-condition of {STS_SUBSET_FAMILY}.with to run unchecked.
			cardinality,
			out,
			equals,
			is_subset,
			is_strict_subset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented, -- todo: A bug in the compiler makes the post-condition of {STS_SUBSET_FAMILY}.complemented to run unchecked.
			intersected, -- todo: A bug in the compiler makes the post-condition of {STS_SUBSET_FAMILY}.intersected to run unchecked.
			family_intersection,
			subtracted, -- todo: A bug in the compiler makes the post-condition of {STS_SUBSET_FAMILY}.subtracted to run unchecked.
			subtracted_symmetricaly, -- todo: A bug in the compiler makes the post-condition of {STS_SUBSET_FAMILY}.subtracted_symmetricaly to run unchecked.
			diagonal,
			crossed_tuples,
			equality_holds
		redefine
			without
		end

	SET_OF_SETS [A, EQ]
		rename
			make_empty as set_make_empty,
			make_extended as set_make_extended,
			universe as superset,
			extended as set_extended,
			batch_extended as set_batch_extended,
			member_sets_are_disjoint as subsets_are_disjoint,
			sets_union as family_union alias "⋃",
			sets_intersection as family_intersection alias "⋂",
			o_s as o_f,
			empty_set_of_sets as empty_family,
			unit_s as unit_f,
			empty_member_set as empty_subset,
			converted_member_set as converted_subset,
			some_set_has as some_subset_has,
			every_set_has as every_subset_has,
			set_anchor as family_anchor,
			subset_anchor as subfamily_anchor,
			superset_anchor as superfamily_anchor
		redefine
			set_make_empty,
			make_from_set,
			without,
			set_batch_extended,
			united,
			o, empty_subset,
			converted,
			family_anchor,
			subfamily_anchor,
			superfamily_anchor
		end

create
	set_make_empty,
	make_empty,
	make_singleton,
	set_make_extended,
	make_extended,
	make_from_set,
	make_from_family

convert
	make_from_set ({
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],
		TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],
		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],

		STS_SET_OF_SETS [A, EQ],
		SET_OF_SETS [A, EQ],

		STS_SET_FAMILY [A, EQ],
		SET_FAMILY [A, EQ],

		STS_SET_PARTITION [A, EQ],
		SET_PARTITION [A, EQ]
		}),

	make_from_family ({
		STS_SUBSET_FAMILY [A, EQ],
		STS_SUBSET_FAMILY_STRUCTURE [A, EQ]
		})

feature {NONE} -- Initialization

	set_make_empty
			-- Create an empty subset family, i.e. {} or ∅.
		do
			create superset.make_empty
			others := Current
		ensure then
			empty_superset: superset.is_empty
		end

	make_empty (s: STS_SET [A, EQ])
			-- Create an empty subset family whose `superset' is `s'.
		do
			set_make_empty
			superset := superset.converted (s)
		ensure
			is_empty: is_empty
			given_superset: superset ≍ s
		end

	make_singleton (s: STS_SET [A, EQ])
			-- Create a singleton subset family in the form {`s`}.
		do
			create others.make_empty (s)
			superset := others.superset
			create any_storage.put (superset)
		ensure then
			default_superset: superset ≍ s
		end

	set_make_extended (s: STS_SET [A, EQ]; ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]])
			-- Create a family whose `any' subset and `others' are, respectively, `s' and `ss'.
		do
			create others.set_make_empty
			others := others.converted (ss).extending_superset (s)
				check
					not_in_family: s ∉ others -- ss ∌ s
					already_a_subset: s ⊆ others.superset -- others ≍ others.converted (ss).extending_superset (s)
				end
			make_extended (s, others)
		ensure then
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} ss as sf implies superset ≍ (sf.superset ∪ s)
			when_not_a_family: not attached {STS_SUBSET_FAMILY [A, EQ]} ss implies superset ≍ (⋃ Current)
		end

	make_extended (s: STS_SET [A, EQ]; sf: STS_SUBSET_FAMILY [A, EQ])
			-- Create a subset family whose `any' set and `others' are, respectively `s' and `sf'.
		require
			not_in_family: s ∉ sf
			already_a_subset: s ⊆ sf.superset
		do
			create others.set_make_empty
			others := others.converted (sf)
			superset := others.superset
			create any_storage.put (superset.converted (s))
		ensure
			is_not_empty: not is_empty
			any: any ≍ s
			others: others ≍ sf
			same_superset: superset ≍ sf.superset
		end

	make_from_set (ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]])
			-- Create a subset family equal to `ss`.
		do
			if attached {STS_SUBSET_FAMILY [A, EQ]} ss as sf then
				make_from_family (sf)
			else
				Precursor {SET_OF_SETS} (ss)
			end
		ensure then
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} ss as sf implies superset ≍ sf.superset
		end

	make_from_family (sf: STS_SUBSET_FAMILY [A, EQ])
			-- Create a subset family equal to `sf`.
		do
			if sf.is_empty then
				make_empty (sf.superset)
			else
					check
							-- {STS_SUBSET_FAMILY} invariant
						not_in_family: sf.any ∉ sf.others
						already_a_subset: sf.any ⊆ sf.others.superset
					end
				make_extended (sf.any, sf.others)
			end
		ensure
			same_family: Current ≍ sf
			same_superset: superset ≍ sf.superset
		end

feature -- Primitive

	superset: like any.subset_anchor
			-- <Precursor>

feature -- Construction

	without alias "/" (s: STS_SET [A, EQ]): like subfamily_anchor
			-- <Precursor>
		local
			sf: like subfamily_anchor
			l_eq: like eq
		do
			from
				Result := o_f
				sf := Current
				l_eq := eq -- Better to avoid recreating `eq' over and over.
			invariant
				building_up: Result ≍ (Current ∖ sf)
				same_superset: Result.superset ≍ superset
				same_supersets: sf.superset ≍ Result.superset
			until
				sf.is_empty or else l_eq (sf.any, s)
			loop
					check
						not_in_family: sf.any ∉ Result -- Result ≍ (Current ∖ sf)
						already_a_subset: sf.any ⊆ Result.superset -- sf.superset ≍ Result.superset
					end
				Result := Result.extended (sf.any)
				sf := sf.others
			variant
				cardinality: natural_as_integer (# sf)
			end
			if sf.is_empty then
				Result := Current
			else
					check
						unwanted_subset_found: l_eq (sf.any, s) -- Previous loop exit
					end
				sf := sf.others
				if not sf.is_empty then
						check
							is_disjoint: sf.is_disjoint (Result) -- Result ≍ ((Current ∖ sf) / s)
							includes_superset: Result.superset ⊆ sf.superset -- sf.superset ≍ Result.superset
						end
					Result := sf.batch_extended (Result)
				end
			end
		end

	set_extended (s: STS_SET [A, EQ]): like superfamily_anchor
			-- This subset family extended with `s`
		do
			Result := extending_superset (s)
				check
					not_in_family: s ∉ Result -- Result ≍ Current
					already_a_subset: s ⊆ Result.superset -- `extending_superset' definition
				end
			Result := Result.extended (s)
		ensure then
			extended_superset: Result.superset ≍ (superset ∪ s)
		end

	extended (s: STS_SET [A, EQ]): like superfamily_anchor
			-- This subset family extended with `s'
		require
			not_in_family: s ∉ Current
			already_a_subset: s ⊆ superset
		do
			create Result.make_extended (s, Current)
		ensure
			is_not_empty: not Result.is_empty
			any: Result.any ≍ s
			others: Result.others ≍ Current
			same_superset: Result.superset ≍ superset
		end

	set_batch_extended (ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like superfamily_anchor
			-- This family extended with every subset in `ss`
		local
			sf: like converted
		do
			sf := converted (ss)
			Result := extending_superset (sf.superset)
				check
					is_disjoint: Result.is_disjoint (sf) -- Result ≍ Current
					includes_superset: sf.superset ⊆ Result.superset -- `extending_superset' definition
				end
			Result := Result.batch_extended (sf)
		ensure then
			extended_superset: Result.superset ≍ (superset ∪ converted (ss).superset)
		end

	batch_extended (sf: STS_SUBSET_FAMILY [A, EQ]): like superfamily_anchor
			-- This family extended with every subset in `sf'
		require
			is_disjoint: is_disjoint (sf)
			includes_superset: sf.superset ⊆ superset
		local
			l_sf: STS_SUBSET_FAMILY [A, EQ]
		do
			from
				Result := Current
				l_sf := sf
			invariant
				building_prefixed_sf_up: Result.as_tuple.prefix (# (sf ∖ l_sf)).sets ≍ (sf ∖ l_sf)
				suffixed_current: Result.as_tuple.suffix (# Current).sets ≍ Current
				same_superset: Result.superset ≍ superset
			until
				l_sf.is_empty
			loop
					check
						not_in_family: l_sf.any ∉ Result -- Result ≍ (Current ∪ (sf ∖ l_sf))
						already_a_subset: l_sf.any ⊆ Result.superset -- l_sf.superset ⊆ Result.superset
					end
				Result := Result.extended (l_sf.any)
				l_sf := l_sf.others
			variant
				cardinality: (# l_sf).as_integer_64
			end
		ensure
			prefixed_sf: Result.as_tuple.prefix (# sf).sets ≍ sf
			suffixed_current: Result.as_tuple.suffix (# Current).sets ≍ Current
			same_superset: Result.superset ≍ superset
		end

	extending_superset (s: STS_SET [A, EQ]): like family_anchor
			-- Family with the same subsets of this one, but whose superset is `superset' united with `s'.
		do
			if s ⊆ superset then
				Result := Current
			else
				create Result.make_empty (superset ∪ s)
					check
						is_disjoint: Result.is_disjoint (Current) -- Result.is_empty
						includes_superset: superset ⊆ Result.superset -- Result.superset ≍ (superset ∪ s)
					end
				Result := Result.batch_extended (Current)
			end
		ensure
			same_subsets: Result ≍ Current
			extended_superset: Result.superset ≍ (superset ∪ s)
		end

	replacing_superset (s: STS_SET [A, EQ]): like subfamily_anchor
			-- Family of subsets of `s' which are also in this family
		local
			sf: SUBSET_FAMILY [A, EQ]
		do
			if superset ⊆ s then
				Result := extending_superset (s)
			else
				from
					create Result.make_empty (converted_subset (s))
					sf := Current
				invariant
					building_up: Result ≍ ((Current ∖ sf) | agent s.is_superset)
					replaced_superset: Result.superset ≍ s
				until
					sf.is_empty
				loop
					if sf.any ⊆ Result.superset then
							check
								not_in_family: sf.any ∉ Result -- Result ≍ ((Current ∖ sf) | agent s.is_superset) ⊆ (Current ∖ sf)
							end
						Result := Result.extended (sf.any)
					end
					sf := sf.others
				variant
					cardinality: natural_as_integer (# sf)
				end
			end
		ensure
			definition: Result ≍ (Current | agent s.is_superset)
			replaced_superset: Result.superset ≍ s
		end

feature -- Operation

	united alias "∪" (ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like superfamily_anchor
			-- <Precursor>
		local
			diff: like family_anchor
		do
			diff := converted (ss) ∖ Current
			Result := extending_superset (diff.superset)
				check
					is_disjoint: Result.is_disjoint (diff) -- diff = ss ∖ Current
					includes_superset: diff.superset ⊆ Result.superset -- Result := extending_superset (diff.superset)
				end
			Result := Result.batch_extended (diff)
		end

feature -- Factory

	o,
	empty_subset: like superset.subset_anchor
			-- Empty subset like `superset'
		do
			Result := superset.o
		end

	converted (ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like family_anchor
			-- <Precursor>
		local
			l_ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			s: STS_SET [A, EQ]
		do
			if attached {like family_anchor} ss as sf then
				Result := sf
			elseif attached {STS_SUBSET_FAMILY [A, EQ]} ss as sf then
				Result := o_f.replacing_superset (sf.superset)
					check
						is_disjoint: Result.is_disjoint (sf) -- Result.is_empty
						includes_superset: sf.superset ⊆ Result.superset -- Result.superset ≍ sf.superset
					end
				Result := Result.batch_extended (sf)
			else
				if attached {STS_SET_OF_SETS [A, EQ]} ss as al_ss then
					s := ⋃ al_ss
				else
					from
						s := o
						l_ss := ss
					invariant
						building_up: s ≍ ⋃ (converted (ss ∖ l_ss))
					until
						l_ss.is_empty
					loop
						s := s ∪ l_ss.any
						l_ss := l_ss.others
					variant
						l_ss_cardinality_1: natural_as_integer (# l_ss)
					end
				end
				from
					Result := o_f.replacing_superset (s)
					l_ss := ss
				invariant
					building_up: Result ≍ (ss ∖ l_ss)
					same_superset: Result.superset ≍ s
				until
					l_ss.is_empty
				loop
						check
							not_in_family: l_ss.any ∉ Result -- Result ≍ (ss ∖ l_ss)
							already_a_subset: l_ss.any ⊆ Result.superset -- Result.superset ≍ s = ⋃ ss ⊇ l_ss
						end
					Result := Result.extended (l_ss.any)
					l_ss := l_ss.others
				variant
					l_ss_cardinality_2: natural_as_integer (# l_ss)
				end
			end
		end

feature -- Anchor

	family_anchor,
	subfamily_anchor,
	superfamily_anchor: SUBSET_FAMILY [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
