﻿note
	description: "Implementation of {STS_SUBSET_FAMILY_STRUCTURE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SUBSET_FAMILY_STRUCTURE [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STS_SUBSET_FAMILY_STRUCTURE [A, EQ]
		rename
			out as set_out
		undefine
			has,
			with,
			without,
			cardinality,
			set_out,
			set_equals,
			is_subset,
			is_strict_subset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented,
			intersected,
			family_intersection,
			subtracted,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
			equality_holds
		end

	ORDERED_PAIR [
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
		STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
		]
		rename
			a as sf,
			first as subset_family,
			b as s,
			second as superset,
			eq_a as eq_ss,
			eq_b as eq_s,
			make as make_pair
		redefine
			make_pair,
			make_from_pair,
			sf,
			s,
			eq_s,
			out
		select
			out
		end

	SUBSET_FAMILY [A, EQ]
		rename
			eq as eq_s,
			superset as s,
			is_in as set_is_in,
			is_not_in as set_is_not_in,
			out as set_out,
			equals as set_equals,
			unequals as set_unequals,
			as_singleton as set_as_singleton,
			family_anchor as family_structure_anchor,
			subfamily_anchor as subfamily_structure_anchor,
			superfamily_anchor as superfamily_structure_anchor
		redefine
			set_make_empty,
			make_singleton,
			set_make_extended,
			make_extended,
			s,
			eq_s,
			family_structure_anchor,
			subfamily_structure_anchor,
			superfamily_structure_anchor
		select
			s
		end

create
	set_make_empty,
	make_empty,
	make_singleton,
	set_make_extended,
	make_extended,
	make_from_set,
	make_from_family

convert
	make_from_set ({
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],
		TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],
		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],
		TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],

		STS_SET_OF_SETS [A, EQ],
		SET_OF_SETS [A, EQ],

		STS_SET_FAMILY [A, EQ],
		SET_FAMILY [A, EQ],

		STS_SET_PARTITION [A, EQ],
		SET_PARTITION [A, EQ]
		}),

	make_from_family ({
		STS_SUBSET_FAMILY [A, EQ],
		SUBSET_FAMILY [A, EQ],

		STS_SUBSET_FAMILY_STRUCTURE [A, EQ]
		})

feature {NONE} -- Initialization

	make_pair (ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]; a_s: STS_SET [A, EQ])
			-- Update `sf' and `s' to `ss' and `a_s', respectively.
			-- Notice: This redefinition is not a creator.			
		local
			old_any: like any
			old_others: like others
			old_s: like s
		do
			check
				keep_non_emptiness: ss.is_empty implies is_empty -- NOTICE: make it hold!
			then
				old_s := s
				if attached {STS_SUBSET_FAMILY [A, EQ]} ss as l_sf then
					if l_sf.is_empty then
						create s.make_empty
						s := s.converted (l_sf.superset)
					else
						old_others := others
						create others.set_make_empty
						others := others.converted (l_sf.others)
						s := others.s
						create any_storage.put (s.converted (l_sf.any))
					end
				else
					if ss.is_empty then
						create s.make_empty
					else
						old_others := others
						create others.set_make_empty
						others := others.converted (ss.others).extending_superset (ss.any)
						s := others.s
						if not is_empty then
							old_any := any
							check
								attached any_storage -- not is_empty
							then
								any_storage.put (s.converted (ss.any))
							end
						else
							create any_storage.put (s.converted (ss.any))
						end
					end
				end
				check
					consistent_superset: others.s ⊆ a_s -- NOTICE: make it hold!
				then
					others := others.extending_superset (a_s)
					s := others.s
				end
			end
		rescue
			if attached old_any then
				check
					attached any_storage -- attached old_any implies not is_empty
				then
					any_storage.put (old_any)
				end
			end
			if attached old_others then
				others := old_others
			end
			if attached old_s then
				s := old_s
			end
		end

	make_from_pair (
		ss_s: STS_ORDERED_PAIR [
			STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]]
		)
			-- Update `sf' and `s' to `ss_s`.`first` and `ss_s`.`second`, respectively.
			-- NOTICE: This redefinition is not a creator.			
		do
			make_pair (ss_s.first, ss_s.second)
		end

	set_make_empty
			-- Create a subset-family structure with no subset, i.e. the structure (∅, ∅).
		do
			sf := Current
			Precursor {SUBSET_FAMILY}
		end

	make_singleton (a_s: STS_SET [A, EQ])
			-- Create a subset-family structure in the form ({`a_s'}, `a_s').
		do
			Precursor {SUBSET_FAMILY}(a_s)
			sf := Current
		ensure then
			singleton_family: sf.set_equals (a_s.as_singleton)
		end

	set_make_extended (a_s: STS_SET [A, EQ]; ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]])
			-- Create a subset-family structure whose `any' subset and `others' are, respectively, `s' and `ss'.
		do
			set_make_empty
			Precursor {SUBSET_FAMILY} (a_s, ss)
		ensure then
			subset_family: sf.set_equals (ss & a_s)
		end

	make_extended (a_s: STS_SET [A, EQ]; a_sf: STS_SUBSET_FAMILY [A, EQ])
			-- Create a subset-family structure whose `any' set and `others' are, respectively `a_s' and `a_sf'.
		do
			set_make_empty
			Precursor {SUBSET_FAMILY}(a_s, a_sf)
		end

feature -- Primitive

	sf: like family_structure_anchor
			-- <Precursor>

	s: like any.subset_anchor
			-- <Precursor>

	eq_s: STS_SET_EQUALITY [A, EQ]
			-- Equality for sets like `superset`
		do
			create Result
		end

feature -- Output

	out: STRING
			-- <Precursor>
		do
			Result := "("
				check
					first_argument_not_void: set_out /= Void -- `set_out' definition
				end
			Result.append (set_out);
			Result.append_character (',')
				check
					second_argument_not_void: s.out /= Void -- `s'.`out' definition
				end
			Result.append (s.out)
			Result.append_character (')')
		end

feature -- Anchor

	family_structure_anchor,
	subfamily_structure_anchor,
	superfamily_structure_anchor: SUBSET_FAMILY_STRUCTURE [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
