﻿note
	description: "Implementation of {STS_TRANSFORMABLE_SET}."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	TRANSFORMABLE_SET [A, B, EQ_A -> STS_EQUALITY [A] create default_create end, EQ_B -> STS_EQUALITY [B] create default_create end]

inherit
	STS_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]
		undefine
			has,
			with,
			without,
			cardinality,
			out,
			equals,
			is_subset,
			is_strict_subset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented,
			intersected,
			subtracted,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
			equality_holds
		end

	SET [A, EQ_A]
		rename
			eq as eq_a,
			crossed as crossed_with_same_kind,
			mapped as mapped_to_same_kind,
			reduced as reduced_to_element_like
		redefine
			set_anchor,
			subset_anchor,
			superset_anchor,
			n_tuple_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended,
	make_from_set

convert
	make_from_set ({
		STS_SET [A, EQ_A],
		SET [A, EQ_A],

		STS_TRANSFORMABLE_SET [A, A, EQ_A, EQ_A],
		TRANSFORMABLE_SET [A, A, EQ_A, EQ_A],

		STS_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]
		})

feature -- Primitive

	eq_b: EQ_B
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Transformer

	transformer: TRANSFORMER [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			Result := Current
		end

	n_tuple_anchor: TRANSFORMABLE_TUPLE [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			Result := unit
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
