﻿note
	description: "Implementation of {STS_HOMOGENEOUS_GRAPH}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_HOMOGENEOUS_GRAPH [A, EQ -> STS_EQUALITY [A] create default_create end]

--inherit

--	STS_HOMOGENEOUS_GRAPH [A, EQ]
--		undefine
--			out,
--			with,
--			without,
--			cardinality,
--			equals,
--			is_strict_subset,
--			is_trivial_subset,
--			is_proper_subset,
--			is_disjoint,
--			exists,
--			exists_unique,
--			exists_pair,
--			exists_distinct_pair,
--			for_all,
--			for_all_pairs,
--			for_all_distinct_pairs,
--			trivial_subsets,
--			subtracted_symmetricaly,
--			diagonal,
--			crossed_tuples,
--			equality_holds,
--			equality_does_not_hold,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor,
--			tuple_anchor,
--			first_anchor,
--			second_anchor
--		redefine
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			inverse_anchor,
--			pair_anchor
--		end

--	STI_GRAPH [A, A, EQ, EQ]
--		rename
--			eq_b as eq_a
--		redefine
--			eq_a,
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			inverse_anchor,
--			pair_anchor,
--			any_anchor
--		end

--create
--	make_empty, make_singleton, make_extended, make_from_set

--convert
--	make_from_set ({
--		STS_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],
--		STI_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			A,
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			EQ
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			A,
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			EQ
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],

--		STS_SET_OF_PAIRS [A, A, EQ, EQ],
--		STI_SET_OF_PAIRS [A, A, EQ, EQ],

--		STS_RELATION_AWARE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],
--		STI_RELATION_AWARE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			A,
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			EQ
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			A,
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			EQ
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_ORDERED_PAIR [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ],
--			STS_PAIR_EQUALITY [A, A, EQ, EQ]
--			],

--		STS_GRAPH  [A, A, EQ, EQ],

--		STS_COMPOSABLE_GRAPH [A, A, A, EQ, EQ, EQ],
--		STI_COMPOSABLE_GRAPH [A, A, A, EQ, EQ, EQ]
--		})

--feature -- Primitive

--	eq_a: EQ
--			-- <Precursor>
--		do
--			create Result
--		ensure then
--			class
--		end

--feature -- Operation

--	composed alias "∘" (g: STS_GRAPH [A, A, EQ, EQ]): STI_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		local
--			composer: STI_RELATION_COMPOSER [A, A, A, EQ, EQ, EQ]
--			ws: STS_SET [A, EQ]
--			xs: STS_SET [A, EQ]
--			ys, ysi: STS_SET [A, EQ]
--			wy: STI_HOMOGENEOUS_PAIR [A, EQ]
--		do
--			from
--				create composer
--				create Result.make_empty
--				ws := π₁ g
--				xs := π₂ g ∩ π₁ Current
--				ys :=  π₂ Current
--			invariant
--				building_up: Result ≍ (((π₁ g ∖ ws) × ys) ｜ˣʸ agent composer.pair_is_composite (?, ?, g, Current))
--			until
--				ws.is_empty
--			loop
--				from
--					ysi := ys
--				invariant
--					preceding: attached (((π₁ g ∖ ws) × ys) ｜ˣʸ agent composer.pair_is_composite (?, ?, g, Current)) as preceding
--					succeeding: Result ≍ (preceding ∪ ((ws.singleton (ws.any) × (ys ∖ ysi)) ｜ˣʸ agent composer.pair_is_composite (?, ?, g, Current)))
--				until
--					ysi.is_empty
--				loop
--					if xs ∃ agent composer.x_is_common (ws.any, ?, ysi.any, g, Current) then
--						create wy.make (ws.any,  ysi.any)
--							check
--								does_not_have: Result ∌ wy -- loop invariant
--							end
--						Result := Result.extended (wy)
--					end
--					ysi := ysi.others
--				variant
--					ysi_cartinality: (# ysi).as_integer_64
--				end
--				ws := ws.others
--			variant
--				ws_cartinality: (# ws).as_integer_64
--			end
--		end

--feature -- Anchor

--	graph_anchor,
--	subgraph_anchor,
--	supergraph_anchor: STI_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	inverse_anchor: STI_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

--	pair_anchor (a: A; b: A): STI_HOMOGENEOUS_PAIR [A, EQ]
--			-- <Precursor>
--		do
--			Result := pair (a, b)
--		end

--	any_anchor: STI_HOMOGENEOUS_PAIR [A, EQ]
--			-- <Precursor>
--		do
--			Result := any
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
