﻿note
	description: "Implementation of {STS_ORDERED_TRIPLE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_ORDERED_TRIPLE [
		A, B, C,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end,
		EQ_C -> STS_EQUALITY [C]
			create default_create end
		]

--inherit

--	STS_ORDERED_TRIPLE [A, B, C, EQ_A, EQ_B, EQ_C]
--		redefine
--			out
--		end

--	STI_ORDERED_PAIR
--		[STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C]
--		rename
--			make as pair_make,
--			a as ab,
--			first as front,
--			b as c,
--			second as third alias "π₃",
--			eq_a as eq_ab,
--			eq_b as eq_c,
--			out as pair_out,
--			first_out as front_out,
--			second_out as third_out
--		redefine
--			pair_make,
--			make_from_pair,
--			ab,
--			composed_with_homogeneous,
--			as_singleton
--		select
--			pair_out
--		end

--	DEBUG_OUTPUT
--		rename
--				-- Output
--			debug_output as out
--		redefine
--				-- Output
--			out
--		end

--create
--	make, pair_make, make_from_pair, make_from_triple

--convert
--	make_from_pair ({
--		STS_ORDERED_PAIR [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C],
--		STI_ORDERED_PAIR [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C]
--		}),
--	make_from_triple ({STS_ORDERED_TRIPLE [A, B, C, EQ_A, EQ_B, EQ_C]})

--feature {NONE} -- Initialization

--	make (a_first: A; a_second: B; a_third: C)
--			-- Create the triple (`a_first', `a_second', `a_third').
--		do
--			create ab.make (a_first, a_second)
--			c := a_third
--		ensure
--			first: eq_a (a, a_first)
--			second: eq_b (b, a_second)
--			third: eq_c (c, a_third)
--		end

--	pair_make (xy: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]; z: C)
--			-- Create the triple (`xy`.`a', `xy`.`b', `z').
--		do
--			if attached {like ab} xy as l_ab then
--				ab := l_ab
--			else
--				ab := xy
--			end
--			c := z
--		end

--	make_from_pair (xyz: STS_ORDERED_PAIR [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C])
--			-- Create the triple (`xyz'.`a'.`a', `xyz'.`a'.`b', `xyz'.`b').
--		do
--			if attached {like ab} xyz.a as l_ab then
--				ab := l_ab
--			else
--				ab := xyz.a
--			end
--			c := xyz.b
--		end

--	make_from_triple (xyz: STS_ORDERED_TRIPLE [A, B, C, EQ_A, EQ_B, EQ_C])
--			-- Create the triple (`xyz'.`a'. `xyz'.`b', `xyz'.`c').
--		do
--			if attached {like ab} xyz.ab as l_ab then
--				ab := l_ab
--			else
--				ab := xyz.ab
--			end
--			c := xyz.c
--		ensure
--			first: eq_a (a, xyz.a)
--			second: eq_b (b, xyz.b)
--			third: eq_c (c, xyz.c)
--		end

--feature -- Primitive

--	ab: STI_ORDERED_PAIR [A, B, EQ_A, EQ_B]
--			-- First and second elements in this ordered triple

--feature -- Output

--	out: STRING
--			-- <Precursor>
--			-- todo: why is <Precursor> empty?
--		do
--			Result := "("
--				check
--					first_argument_not_void: ab.first_out (a) /= Void -- `ab'.`first_out' definition
--				end
--			Result.append (ab.first_out (a))
--			Result.append_character (',')
--				check
--					second_argument_not_void: ab.second_out (b) /= Void -- `ab'.`second_out' definition
--				end
--			Result.append (ab.second_out (b))
--			Result.append_character (',')
--				check
--					third_argument_not_void: third_out (c) /= Void -- `third_out' definition
--				end
--			Result.append (third_out (c))
--			Result.append_character (')')
--		ensure then
--			definition: Result ~ "(" + ab.first_out (a) + "," + ab.second_out (b) + "," + third_out (c) + ")"
--		end

--feature -- Operation

--	composed_with_homogeneous alias "₁∘₁" (
--		x1x2x3x4: STS_ORDERED_PAIR [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			]
--		): STI_ORDERED_TRIPLE [A, B, C, EQ_A, EQ_B, EQ_C]
--			-- Composition of this triple and `x1x2x3x4`, i.e. the triple (`x1x2x3x4`.`a'.`a', `x1x2x3x4`.`a'.`b', `c').
--		do
--			create Result.pair_make (x1x2x3x4.a, c)
--		end

--feature -- Conversion

--	as_singleton: STI_GRAPH [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C]
--			-- This triple alone into a singleton, i.e. {(`a', `b', `c')}.
--		do
--			create Result.make_singleton (Current)
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
