note
	description: "Object that checks whether the properties verified within set theory hold for an implementation of {STS_INTEGER_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	INTEGER_SET_PROPERTIES

inherit
	ORDERED_NUMERIC_SET_PROPERTIES [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			current_universe as z,
			universe_anchor as z_anchor
		end

feature -- Access

	zero: like integer_anchor
			-- The integer number 0
		deferred
		ensure then
			value: Result.value = 0
		end

feature -- Anchor

	integer_anchor: STS_INTEGER_NUMBER
			-- Anchor for integer numbers
		deferred
		end

	z_anchor: STS_INTEGER_SET
			-- Anchor for `r`
		deferred
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
