﻿note
	description: "Object that checks whether the properties verified within set theory hold for an implementation of {STS_SUBSET_FAMILY_STRUCTURE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	SUBSET_FAMILY_STRUCTURE_PROPERTIES [A, EQ -> STS_EQUALITY [A]]

inherit
	ORDERED_PAIR_PROPERTIES [
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
		STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
		]
		rename
			eq_a as eq_ss,
			eq_b as eq_s,
			equals_ok as opp_equals_ok
		end

	SUBSET_FAMILY_PROPERTIES [A, EQ]
		rename
			eq as eq_s,
			is_in_ok as set_is_ok,
			is_not_in_ok as set_is_not_in_ok,
			equals_ok as set_equals_ok,
			unequals_ok as set_unequals_ok,
			as_singleton_ok as set_as_singleton_ok
		end

feature

	equals_ok (sf1, sf2: STS_SUBSET_FAMILY_STRUCTURE [A, EQ]): BOOLEAN
			-- Do the properties verified within set theory hold for {STS_SUBSET_FAMILY_STRUCTURE}.equals?
		do
			check
				definition: sf1 ≍ sf2 = sf1.same_family (sf2)
			end
			Result := True
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
