﻿note
	description: "[
		Object that checks whether an implementation of {STS_COMPOSABLE_GRAPH} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_COMPOSABLE_GRAPH_PROPERTIES
		[W, A, B, EQ_W -> STS_EQUALITY [W], EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STP_GRAPH_PROPERTIES [A, B, EQ_A, EQ_B]

--feature -- Properties (Operation)

--	composed_ok (
--		h, h2: STS_COMPOSABLE_GRAPH [W, A, B, EQ_W, EQ_A, EQ_B]
--		g, g2: STS_COMPOSABLE_GRAPH [B, W, A, EQ_B, EQ_W, EQ_A]
--		f: STS_GRAPH [B, W, EQ_B, EQ_W];
--		ws: STS_RELATABLE_SET [W, A, EQ_W, EQ_A]
--		h3: STS_COMPOSABLE_GRAPH [W, A, A, EQ_W, EQ_A, EQ_A]
--		xs1, xs2: STS_SET [A, EQ_A]
--		): BOOLEAN
--			-- Do the properties verified within set theory hold for
--			-- {STS_COMPOSABLE_GRAPH}.composed?
--		do
--			u_ab := u_ab ∪ ((π₁ h ∪ π₁ h2 ∪ π₁ h3 ∪ π₂ g ∪ π₂ g2 ∪ π₂ h3 ∪ xs1 ∪ xs2) × (π₂ h ∪ π₂ h2 ∪ π₁ f))
--			check
--				definition: h ∘ g ≍ (w_x_b.cartesian_product (π₁ g, π₂ h) ｜ˣʸ agent (
--					ia_w: W; ia_y: B
--					i1a_g: STS_GRAPH [W, A, EQ_W, EQ_A]; i1a_h: STS_GRAPH [A, B, EQ_A, EQ_B]
--					): BOOLEAN
--					do
--						Result := u_a ∃ agent (
--							w: W; x: A; y: B
--							i2a_g: STS_GRAPH [W, A, EQ_W, EQ_A]; i2a_h: STS_GRAPH [A, B, EQ_A, EQ_B]
--							): BOOLEAN
--							do
--								Result := i2a_g (w, x) and i2a_h (x, y)
--							end (ia_w, ?, ia_y, i1a_g, i1a_h)
--					end (?, ?, g, h))
--				by_map: h ∘ g ≍ abwa_to_wb.set_map (
--					ab_x_wa.cartesian_product (h, g) ｜ˣʸ agent (
--						xy: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]
--						wx: STS_ORDERED_PAIR [W, A, EQ_W, EQ_A]
--						): BOOLEAN
--						do
--							Result := xy ≻ wx
--						end,
--					agent (
--						xywx: STS_ORDERED_PAIR [
--							STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--							STS_ORDERED_PAIR [W, A, EQ_W, EQ_A],
--							STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--							STS_PAIR_EQUALITY [W, A, EQ_W, EQ_A]
--							]
--						): STS_ORDERED_PAIR [W, B, EQ_W, EQ_B]
--						local
--							xy: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]
--							wx: STS_ORDERED_PAIR [W, A, EQ_W, EQ_A]
--						do
--							xy := xywx.a
--							wx := xywx.b
--								check
--									xy_succeeds_wx: xy ≻ wx -- previous filter
--								end
--							Result := ab_wa_composer (xy, wx)
--						end
--					)
--				inverse: ⁻¹(h ∘ g) ≍ (⁻¹g ∘ ⁻¹h)
--				associative: ((h ∘ g) ₂∘₁ f) ≍ (h ₂∘₁ (g ∘ f))
--				image: (h ∘ g) [ws] ≍ h [g [ws]]
--				first_projection: π₁ (h ∘ g) ⊆ π₁ g
--				second_projection: π₂ (h ∘ g) ⊆ π₂ h
--				after_union: (h ∪ h2) ∘ g ≍ ((h ∘ g) ∪ (h2 ∘ g))
--				before_intersection: h ∘ (g ∩ g2) ⊆ ((h ∘ g) ∩ (h ∘ g2))
--				before_difference: h ∘ (g ∖ g2) ⊇ ((h ∘ g) ∖ (h ∘ g2))
--				left_induced_inclusion: h ⊆ h2 implies h ∘ g ⊆ (h2 ∘ g)
--				right_induced_inclusion: g ⊆ g2 implies h ∘ g ⊆ (h ∘ g2)
--				graph_induced_inclusion: g ⊆ (ws × xs1) and h3 ⊆ (xs1 × xs2) implies h3 ∘ g ⊆ (ws × xs2)
--				left_restriction: (h ∘ g) ₁⊳ ws ≍ (h ∘ (g ₁⊳ ws))
--				right_restriction: (g ∘ f) ⊲ xs1 ≍ ((g ⊲ xs1) ∘ f)
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ ((π₁ h ∪ π₁ h2 ∪ π₁ h3 ∪ π₂ g ∪ π₂ g2 ∪ π₂ h3 ∪ xs1 ∪ xs2) × (π₂ h ∪ π₂ h2 ∪ π₁ f)))
--		end

--feature -- Transformer

--	w_x_b: STS_RELATION_PRODUCER [W, B, EQ_W, EQ_B]
--			-- Producer of relations between types derived from {W} and {B}
--		deferred
--		end

--	ab_x_wa: STS_RELATION_PRODUCER [
--		STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [W, A, EQ_W, EQ_A],
--		STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [W, A, EQ_W, EQ_A]
--		]
--			-- Producer of relations between sets of pairs in the form ({A}, {B}) and sets of pairs
--			-- in the form ({W}, {A})
--		deferred
--		end

--	abwa_to_wb: STS_RELATION_PRODUCER [
--		STS_ORDERED_PAIR [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [W, A, EQ_W, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [W, A, EQ_W, EQ_A]
--			],
--		STS_ORDERED_PAIR [W, B, EQ_W, EQ_B],
--		STS_PAIR_EQUALITY [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [W, A, EQ_W, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [W, A, EQ_W, EQ_A]
--			],
--		STS_PAIR_EQUALITY [W, B, EQ_W, EQ_B]
--		]
--			-- Producer of relations like the compositions of graphs of pairs in the form ({A}, {B})
--			-- and graphs of pairs in the form ({W}, {A})
--		deferred
--		end

--	ab_wa_composer: STS_PAIR_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- Composer for pairs in the form ({A}, {B}) and ({W}, {A})
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
