﻿note
	description: "[
		Object that checks whether an implementation of {STS_ENDORELATION} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_ENDORELATION_PROPERTIES [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STP_BINARY_RELATION_PROPERTIES [A, A, EQ, EQ]

--feature -- Properties (Access)

--	underlying_set_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.underlying_set?
--		do
--			u_a := u_a & r.ab -- todo: rename/redefine u_a etc?
--			u_b := u_b & r.g
--			check
--				domain_inside_underlying_set: 𝐝𝐨𝐦 r ⊆ r.a
--				range_inside_underlying_set: 𝐫𝐚𝐧 r ⊆ r.a
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--feature -- Properties (Quality)

--	is_reflexive_ok (r, s: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_reflexive?
--		do
--			u_a := u_a & r.ab & s.ab
--			u_b := u_b & r.g & s.g
--			check
--				definition: r.is_reflexive = Δ r.a ⊆ r.g
--				inverse: r.is_reflexive = (⁻¹r).is_reflexive
--				union: r.is_reflexive and s.is_reflexive implies (r ∪ s).is_reflexive
--				intersection: r.is_reflexive and s.is_reflexive implies (r ∩ s).is_reflexive
--				general_union: r.a ≍ s.a and r.is_reflexive implies (r ∪ s).is_reflexive
--				composite_with_inverse: r.is_reflexive implies (r ∘ ⁻¹r).is_reflexive
--				inverse_composed: r.is_reflexive implies (⁻¹r ∘ r).is_reflexive
--				composite_graph: r.is_reflexive implies r.g ⊆ (r.g ∘ r.g)
--				composite: r.is_reflexive implies (r ∘ r).is_reflexive
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab & s.ab)
--			u_b: u_b ⊇ old (u_b & r.g & s.g)
--		end

--	is_not_reflexive_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_reflexive?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_reflexive = r.a ∃ agent r.predicate_holds_for_xx (agent r.does_not_hold, ?)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_irreflexive_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_irreflexive?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_irreflexive = r.g.is_disjoint (Δ r.a)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_not_irreflexive_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_irreflexive?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_irreflexive = r.a ∃ agent r.predicate_holds_for_xx (agent r.holds, ?)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_symmetric_ok (r, s: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_symmetric?
--		do
--			u_a := u_a & r.ab & s.ab
--			u_b := u_b & r.g & s.g
--			check
--				definition: r.is_symmetric = r ≍ ⁻¹r
--				inverse_composites: r.is_symmetric implies (⁻¹r ∘ r) ≍ (r ∘ ⁻¹r)
--				union: r.is_symmetric and s.is_symmetric implies (r ∪ s).is_symmetric
--				intersection: r.is_symmetric and s.is_symmetric implies (r ∩ s).is_symmetric
--				union_with_iinverse: r.is_symmetric implies (r ∪ ⁻¹r).is_symmetric
--				intersection_with_iinverse: r.is_symmetric implies (r ∩ ⁻¹r).is_symmetric
--				composite_with_inverse: r.is_symmetric implies (r ∘ ⁻¹r).is_symmetric
--				inverse_composed: r.is_symmetric implies (⁻¹r ∘ r).is_symmetric
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab & s.ab)
--			u_b: u_b ⊇ old (u_b & r.g & s.g)
--		end

--	is_not_symmetric_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_symmetric?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_symmetric = r.a ∃² agent (r.a).pair_anded (agent r.holds, agent r.flipped (agent r.does_not_hold, ?, ?), ?, ?)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_asymmetric_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_asymmetric?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_asymmetric = r.g.is_disjoint (⁻¹r.g)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_not_asymmetric_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_asymmetric?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_asymmetric = r.a ∃² agent (r.a).pair_anded (agent r.holds, agent r.flipped (agent r.holds, ?, ?), ?, ?)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_antisymmetric_ok (r, s: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_antisymmetric?
--		do
--			u_a := u_a & r.ab & s.ab
--			u_b := u_b & r.g & s.g
--			check
--				definition: r.is_antisymmetric = r.g ∩ ⁻¹(r.g) ⊆ Δ r.a
--				inverse: r.is_antisymmetric implies (⁻¹r).is_antisymmetric
--				intersection: r.is_antisymmetric and s.is_antisymmetric implies (r ∩ s).is_antisymmetric
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab & s.ab)
--			u_b: u_b ⊇ old (u_b & r.g & s.g)
--		end

--	is_not_antisymmetric_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_antisymmetric?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_antisymmetric = r.a ∃² agent (r.a).pair_anded (agent (r.a).pair_anded (agent r.holds, agent r.flipped (agent r.holds, ?, ?), ?, ?), agent (r.a).equality_does_not_hold, ?, ?)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_transitive_ok (r, s: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_transitive?
--		do
--			u_a := u_a & r.ab & s.ab
--			u_b := u_b & r.g & s.g
--			check
--				definition: r.is_transitive = r.g ∘ r.g ⊆ r.g
--				inverse: r.is_transitive implies (⁻¹r).is_transitive
--				intersection: r.is_transitive and s.is_transitive implies (r ∩ s).is_transitive
--				composite: r.is_transitive implies (r ∘ r).is_transitive
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab & s.ab)
--			u_b: u_b ⊇ old (u_b & r.g & s.g)
--		end

--	is_not_transitive_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_transitive?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_transitive = r.a ∃³ agent (x, y, z: A; ia_r: STS_ENDORELATION [A, EQ]): BOOLEAN
--					do
--						Result := ia_r (x, y) and ia_r (y, z) and not ia_r (x, z)
--					end (?, ?, ?, r)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_intransitive_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_intransitive?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_intransitive = (r.g ∘ r.g).is_disjoint (r.g)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

--	is_not_intransitive_ok (r: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_ENDORELATION}.is_not_intransitive?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				definition: r.is_not_intransitive = r.a ∃³ agent (x, y, z: A; ia_r: STS_ENDORELATION [A, EQ]): BOOLEAN
--					do
--						Result := ia_r (x, y) and ia_r (y, z) and ia_r (x, z)
--					end (?, ?, ?, r)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
