﻿note
	description: "[
		Object that checks whether an implementation of {STS_GRAPH} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

deferred class
	STP_GRAPH_PROPERTIES [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STP_SET_OF_PAIRS_PROPERTIES [A, B, EQ_A, EQ_B]
--		redefine
--				-- Access
--			u_ab
--		end

--feature -- Access

--	u_ab: STS_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		deferred
----		attribute
----			Result := o_ab
--		end

--	o_ab: STS_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		deferred
--		end

--	u_a: STS_SET [A, EQ_A]
--			-- "Universe" of elements like {A}
--		deferred
----		attribute
----			Result := π₁ u_ab
--		end

--	u_b: STS_SET [B, EQ_B]
--			-- "Universe" of elements like {B}
--		deferred
----		attribute
----			Result := π₂ u_ab
--		end

--feature -- Properties (Definition)

--	invariant_ok (g: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH} invariant?
--		do
--			u_ab := u_ab ∪ (π₁ g × π₂ g)
--			check
--				definition: g ∀ agent (ia_z: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]): BOOLEAN
--					do
--						Result := u_ab ∃ˣʸ agent (x: A; y: B; z: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]): BOOLEAN
--							do
--								Result := z ≍ pair (x, y)
--							end (?, ?, ia_z)
--					end
--				subset_of_projections: g ⊆ (π₁ g × π₂ g)
--				first_projection: (⁻¹g) [g [π₁ g]] ≍ π₁ g
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ (π₁ g × π₂ g))
--		end

--feature -- Properties (Operation)

--	first_projection_ok (g, h: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH}.first_projection?
--		do
--			u_ab := u_ab ∪ (π₁ g × π₂ g) ∪ (π₁ h × π₂ h)
--			check
--				definition: π₁ g ≍ (u_a | agent (ia_x: A; i1a_g: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--					do
--						Result := u_b ∃ agent (x: A; y: B; i2a_g: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--							do
--								Result := pair (x, y) ∈ i2a_g
--							end (ia_x, ?, i1a_g)
--					end (?, g))
--				induced_emptiness: π₁ g ≍ o_a implies g ≍ o_ab
--				union: π₁ (g ∪ h) ≍ (π₁ g ∪ π₁ h)
--				difference: π₁ g ∖ π₁ h ⊆ π₁ (g ∖ h)
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ (π₁ g × π₂ g) ∪ (π₁ h × π₂ h))
--		end

--	second_projection_ok (g, h: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH}.second_projection?
--		do
--			u_ab := u_ab ∪ (π₁ g × π₂ g) ∪ (π₁ h × π₂ h)
--			check
--				definition: π₂ g ≍ (u_b | agent (ia_y: B; i1a_g: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--					do
--						Result := u_a ∃ agent (x: A; y: B; i2a_g: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--							do
--								Result := pair (x, y) ∈ i2a_g
--							end (?, ia_y, i1a_g)
--					end (?, g))
--				induced_emptiness: π₂ g ≍ o_b implies g ≍ o_ab
--				union: π₂ (g ∪ h) ≍ (π₂ g ∪ π₂ h)
--				difference: π₂ g ∖ π₂ h ⊆ π₂ (g ∖ h)
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ (π₁ g × π₂ g) ∪ (π₁ h × π₂ h))
--		end

--	inverse_ok (g, h: STS_GRAPH [A, B, EQ_A, EQ_B]; xs: STS_RELATABLE_SET [A, B, EQ_A, EQ_B]; ys: STS_RELATABLE_SET [B, A, EQ_B, EQ_A]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH}.inverse?
--		do
--			u_ab := u_ab ∪ ((π₁ g ∪ π₁ h ∪ xs) × (π₂ g ∪ π₂ h ∪ ys))
--			check
--				first_projection: π₁ ⁻¹g ≍ π₂ g
--				second_projection: π₂ ⁻¹g ≍ π₁ g
--				involutive: ⁻¹(⁻¹g) ≍ g
--				inverse_product: ⁻¹(xs × ys) ≍ (ys × xs)
--				inverse_union: ⁻¹(g ∪ h) ≍ (⁻¹g ∪ ⁻¹h)
--				inverse_intersection: ⁻¹(g ∩ h) ≍ (⁻¹g ∩ ⁻¹h)
--				inverse_difference: ⁻¹(g ∖ h) ≍ (⁻¹g ∖ ⁻¹h)
--				inclusion: g ⊆ h = ⁻¹g ⊆ ⁻¹h
--				product_inclusion: g ⊆ (xs × ys) implies ⁻¹g ⊆ (ys × xs)
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ ((π₁ g ∪ π₁ h ∪ xs) × (π₂ g ∪ π₂ h ∪ ys)))
--		end

--	image_ok (g, h: STS_GRAPH [A, B, EQ_A, EQ_B]; s1, s2: STS_SET [A, EQ_A]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH}.image?
--		do
--			u_ab := u_ab ∪ ((π₁ g ∪ s1 ∪ s2) × π₂ g)
--			check
--				first_projection_image: g [π₁ g] ≍ π₂ g
--				empty_image: g [o_a] ≍ o_b
--				graph_induced_inclusion: g ⊆ h implies g [s1] ⊆ h [s1]
--				set_induced_inclusion: s1 ⊆ s2 implies g [s1] ⊆ g [s2]
--				union: g [s1 ∪ s2] ≍ (g [s1] ∪ g [s2])
--				intersection: g [s1 ∩ s2] ⊆ (g [s1] ∩ g [s2])
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ ((π₁ g ∪ s1 ∪ s2) × π₂ g))
--		end

--	inverse_image_ok (g, h: STS_GRAPH [A, B, EQ_A, EQ_B]; xs: STS_SET [A, EQ_A]; ys: STS_SET [B, EQ_B]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH}.inverse_image?
--		do
--			u_ab := u_ab ∪ ((π₁ g ∪ π₁ h ∪ xs) × (π₂ g ∪ π₂ h ∪ ys))
--			check
--				definition: g.inverse_image (ys) ≍ π₁ (g ⊲ ys)
--				second_projection_inverse_image: g.inverse_image (π₂ g) ≍ π₁ g
--				empty_inverse_image: g.inverse_image (o_b) ≍ o_a
--				quasi_involutive: xs ⊆ π₁ g implies g.inverse_image (g [xs]) ⊇ xs
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ ((π₁ g ∪ π₁ h ∪ xs) × (π₂ g ∪ π₂ h ∪ ys)))
--		end

--	left_restricted_ok (g: STS_GRAPH [A, B, EQ_A, EQ_B]; s1: STS_RELATABLE_SET [A, B, EQ_A, EQ_B]; s2: STS_SET [A, EQ_A]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_GRAPH}.left_restricted?
--			-- todo: write the right-side counterpart.
--		do
--			u_ab := u_ab ∪ ((π₁ g ∪ s1 ∪ s2) × π₂ g)
--			check
--				definition: g ₁⊳ s1 ≍ (g ∩ (s1 × π₂ g))
--				union: g ₁⊳ (s1 ∪ s2) ≍ ((g ₁⊳ s1) ∪ (g ₁⊳ s2))
--				intersection: g ₁⊳ (s1 ∩ s2) ≍ ((g ₁⊳ s1) ∩ (g ₁⊳ s2))
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ ((π₁ g ∪ s1 ∪ s2) × π₂ g))
--		end

--feature -- Factory

--	pair (a: A; b: B): STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]
--			-- The ordered pair (`a', `b')
--		deferred
--		ensure
--			first: eq_a (Result.a, a)
--			second: eq_b (Result.b, b)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
