﻿note
	description: "[
		Object that checks whether an implementation of {STS_RELATION_COMPOSER} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_RELATION_COMPOSER_PROPERTIES [
		W, A, B,
		EQ_W -> STS_EQUALITY [W], EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]
		]

inherit

	STP_ORDERED_PAIR_COMPOSER_PROPERTIES [W, A, B, EQ_W, EQ_A, EQ_B]

feature -- Properties (Operation)

	composite_graph_ok (
		ab: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]
		pc_wab: STS_ORDERED_PAIR_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
		wa: STS_ORDERED_PAIR [W, A, EQ_W, EQ_A]
		ww: STS_ORDERED_PAIR [W, W, EQ_W, EQ_W]
		): BOOLEAN
			-- Does {STS_RELATION_COMPOSER}.composite_graph bear the properties determined by set theory?
		do
			-- todo: discard it?
		ensure
			u_w: u_w ⊇ old (u_w & π₁ wa & π₁ ww & π₂ ww)
			u_a: u_a ⊇ old (u_a & ab.a & π₂ wa)
			u_b: u_b ⊇ old (u_b & ab.b)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
