﻿note
	description: "Equality that compares rational numbers according to {RATIONAL_NUMBER}.equals, i.e. the rational ≍ operator."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	RATIONAL_EQUALITY

inherit
	NUMERIC_EQUALITY [RATIONAL_NUMBER]
		redefine
			holds
		end

feature -- Relationship

	holds alias "()" (pq_1, pq_2: RATIONAL_NUMBER): BOOLEAN
			-- Does this equality hold for `pq_1` and `pq_2`?
		do
			Result := pq_1 ≍ pq_2
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
