﻿note
	description: "Set of complex numbers, i.e. a subset of ℂ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	COMPLEX_SET

inherit
	NUMERIC_SET [COMPLEX_NUMBER, COMPLEX_EQUALITY]
		rename
			u as c,
			universe as complex_universe
		redefine
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Access

--	zero: like complex_anchor
--			-- The complex number 0 + 0i
--		deferred
--		ensure
--			real: Result.a = 0
--			imagina: Resul.b= 0
--		end

	c,
	complex_universe: COMPLEX_UNIVERSE
			-- Set that has every representable complex number, i.e. ℂ.
		deferred
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: COMPLEX_SET
			-- <Precursor>
		deferred
		end

--	complex_anchor: COMPLEX_NUMBER
--			-- Anchor for complex numbers
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
