﻿note
	description: "Set whose elements are numbers"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	NUMERIC_SET [A -> COMPLEX_NUMBER, EQ -> NUMERIC_EQUALITY [A]] -- TODO: Replace {COMPLEX_NUMBER} by {NUMBER}?

inherit
	SET [A, EQ]
		redefine
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Access

	zero: A
			-- The number 0
		deferred
		ensure
			definition: Result ≍ Result.zero
		end

	u,
	universe: UNIVERSE [A, EQ]
			-- Set that has every number of type {A}
		deferred
		end

feature -- Restriction

	without_zero: like subset_anchor
			-- Current set deprived of the number zero
		do
			Result := Current / zero
		ensure
			definition: Result ≍ (Current / zero)
		end

feature -- Operation

	complement alias "∁": like set_anchor
			-- Complement of current set relative to the universe
		do
				check
					is_subset: Current ⊆ u -- `u' includes every set.
				end
			Result := Current ∁ u
		ensure
			is_subset: Current ⊆ u -- `u' includes every set.
			definition: Result ≍ (Current ∁ u)
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: NUMERIC_SET [A, EQ]
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
