﻿note
	description: "Set of real numbers, i.e. a subset of ℝ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	REAL_SET

inherit
	ORDERED_NUMERIC_SET [REAL_NUMBER, REAL_EQUALITY]
		rename
			u as r,
			universe as real_universe
		redefine
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Access

--	zero: like real_anchor
--			-- The real number 0
--		deferred
--		end

feature -- Conversion

	as_complex_set: COMPLEX_SET
			-- Current real set converted into a set of complex numbers
		deferred
		ensure
--			every_real_number: Current |∀ agent Result.has -- TODO: Contravariance would be ok.
			every_real_number: Current |∀ agent complex_set_has_real_number (Result, ?)
			nothing_else: Result |∀ agent has_complex_number
		end

feature -- Predicate

	complex_set_has_real_number (zs: NUMERIC_SET [COMPLEX_NUMBER, COMPLEX_EQUALITY]; x: REAL_NUMBER): BOOLEAN
			-- Does `zs' have `x'?
		do
			Result := zs ∋ x
		ensure
			class
			definition: Result = zs ∋ x
		end

	has_complex_number (z: COMPLEX_NUMBER): BOOLEAN
			-- Does current set have `z'?
		do
			Result := z.is_real and z.a ∈ Current
		ensure
			definition: Result = (z.is_real and z.a ∈ Current)
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: REAL_SET
			-- <Precursor>
		deferred
		end

--	real_anchor: REAL_NUMBER
--			-- Anchor for real numbers
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
