﻿note
	description: "[
		Equality that compares ordered pairs according to {ORDERED_PAIR}.equals, i.e. the ordered pair ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

class
	ORDERED_PAIR_EQUALITY [A, B, EQ_A -> EQUALITY [A], EQ_B -> EQUALITY [B]]

inherit
	INSTANCE_FREE_EQUALITY [ORDERED_PAIR [A, B, EQ_A, EQ_B]]

feature -- Relationship

	holds alias "()" (a, b: ORDERED_PAIR [A, B, EQ_A, EQ_B]): BOOLEAN
			-- <Precursor>
		do
			Result := a ≍ b
		ensure then
			definition: Result = (a ≍ b)
		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
