﻿note
	description: "[
		Ordered pair equipped with a composition operation with pairs whose first-element type is possibly unrelated to the types of elements in current pair
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

deferred class
	COMPOSABLE_ORDERED_PAIR [W, A, B, EQ_W -> EQUALITY [W], EQ_A -> EQUALITY [A], EQ_B -> EQUALITY [B]]

inherit
	ORDERED_PAIR [A, B, EQ_A, EQ_B]

feature -- Primitive

	eq_w: EQ_W
			-- Equality for objects like {W}
		deferred
		end

feature -- Operation

	inverse: COMPOSABLE_ORDERED_PAIR [W, B, A, EQ_W, EQ_B, EQ_A]
			-- <Precursor>
		deferred
		end

	composed_with_homogeneous (x1x2: ORDERED_PAIR [A, A, EQ_A, EQ_A]): COMPOSABLE_ORDERED_PAIR [W, A, B, EQ_W, EQ_A, EQ_B]
			-- <Precursor>
		deferred
		end

	composed alias "∘" (wx: ORDERED_PAIR [W, A, EQ_W, EQ_A]): COMPOSABLE_ORDERED_PAIR [A, W, B, EQ_A, EQ_W, EQ_B]
			-- Composition of current pair and `wx', i.e. the pair (`wx'.`a', `b').
		require
			succeeds: Current ≽ wx
		deferred
		ensure
			first: eq_w (Result.a, wx.a)
			second: eq_b (Result.b, b)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
