﻿note
	description: "Ordered pair whose elements are of a same kind"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

deferred class
	HOMOGENEOUS_ORDERED_PAIR [A, EQ -> EQUALITY [A]]

inherit
	ORDERED_PAIR [A, A, EQ, EQ]
		rename
			eq_a as eq,
			eq_b as eq,
			composed_with_homogeneous as composed alias "∘"
		end

feature -- Quality

	is_identical: BOOLEAN
			-- Does `a' equal `b'?
		do
			Result := eq (a, b)
		ensure
			definition: Result = eq (a, b)
		end

feature -- Operation

	inverse: HOMOGENEOUS_ORDERED_PAIR [A, EQ]
			-- <Precursor>
		deferred
		end

	composed alias "∘" (x1x2: ORDERED_PAIR [A, A, EQ, EQ]): HOMOGENEOUS_ORDERED_PAIR [A, EQ]
			-- Composition of current pair and `x1x2`, i.e. the pair (`x1x2`.`first', `second').
		deferred
		end

feature -- Conversion

	as_tuple: N_TUPLE [A, EQ]
			-- Current pair converted to an n-tuple
		deferred
		ensure
			n: Result.n = 2
			is_not_unit: not Result.is_unit -- n > 0
			first: eq (Result.first, a)
			last: eq (Result.last, b)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
