﻿note
	description: "[
		Object able to compose two ordered pairs when the right-hand side pair have a first-element type possibly unrelated to the types of the elements in left-hand side pair
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

deferred class
	ORDERED_PAIR_COMPOSER [
		W, A, B,
		EQ_W -> EQUALITY [W], EQ_A -> EQUALITY [A], EQ_B -> EQUALITY [B]
		]

inherit
	ELEMENT

feature -- Operation

	composite_pair alias "()" (xy: ORDERED_PAIR [A, B, EQ_A, EQ_B]; wx: ORDERED_PAIR [W, A, EQ_W, EQ_A]): COMPOSABLE_ORDERED_PAIR [A, W, B, EQ_A, EQ_W, EQ_B]
			-- Composition of `xy' and `wx', i.e. the pair (`wx'.`a', `xy'.`b').
		require
			xy_succeeds_wx: xy ≽ wx
		deferred
		ensure
			first: wx.eq_a (Result.a, wx.a)
			second: xy.eq_b (Result.b, xy.b)
		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
