﻿note
	description: "Set whose elements are sets, disregarding any superset, in contrast with {SUBSET_FAMILY}."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

deferred class
	SET_FAMILY [A, EQ -> EQUALITY [A]]

inherit
	SET_OF_SETS [A, EQ]
		rename
			universe as family_union alias "⋃",
			sets_union as family_union alias "⋃",
			sets_intersection as family_intersection alias "⋂",
			o_s as o_f,
			empty_set_of_sets as empty_family,
			unit_s as unit_f,
			set_anchor as family_anchor,
			subset_anchor as subfamily_anchor,
			superset_anchor as superfamily_anchor
		redefine
			family_anchor,
			subfamily_anchor,
			superfamily_anchor
		end


feature -- Anchor

	family_anchor,
	subfamily_anchor,
	superfamily_anchor: SET_FAMILY [A, EQ]
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
