﻿note
	description: "Set of sets that is a partition"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

deferred class
	SET_PARTITION [A, EQ -> EQUALITY [A]]

inherit
	SET_FAMILY [A, EQ]
		rename
			with as family_with,
			family_union as partition_union alias "⋃",
			family_intersection as partition_intersection alias "⋂",
			o_f as o_p,
			empty_family as empty_partition,
			unit_f as unit_p,
			converted as family_converted,
			subfamily_anchor as subpartition_anchor
		redefine
			subpartition_anchor
		end

feature -- Construction

	with alias "&" (s: SET [A, EQ]): like superpartition_anchor
			-- Every set in current partition, together with `s`.
		require
			is_not_empty: not s.is_empty
			set_is_pair_wise_disjoint: (Current / s).set_is_disjoint (s)
		deferred
		ensure
			definition: Result ≍ family_with (s)
		end

feature -- Anchor

	partition_anchor: SET_PARTITION [A, EQ]
			-- Anchor for partitions like current one
		deferred
		end

	subpartition_anchor: SET_PARTITION [A, EQ]
			-- Anchor for subpartitions of current partition
		deferred
		end

	superpartition_anchor: SET_PARTITION [A, EQ]
			-- Anchor for superpartitions of current partition
		deferred
		end

invariant
	is_partition: is_partition

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
