﻿note
	description: "Binary relation whose departure and arrival are the same set"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_ENDORELATION [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_BINARY_RELATION [A, A, EQ, EQ]
--		rename
--			departure as underlying_set,
--			b as a,
--			arrival as underlying_set,
--			departure_anchor as underlying_set_anchor,
--			arrival_anchor as underlying_set_anchor,
--			united as binary_relation_united,
--			intersected as binary_relation_intersected
--		redefine
--			underlying_set_anchor,
--			relation_anchor,
--			inverse_anchor,
--			graph_anchor
--		end

--feature -- Primitive

--	ab,
--	related_sets: STS_HOMOGENEOUS_PAIR [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
--			-- <Precursor>
--		deferred
--		end

--feature -- Quality

--	is_reflexive: BOOLEAN
--			-- Does this relation hold for every pair (x, x), where x ∈ `underlying_set'?
--		do
--			Result := a ∀ agent predicate_holds_for_xx (agent holds, ?)
--		ensure
--			definition: Result = (a ∀ agent predicate_holds_for_xx (agent holds, ?))
--		end

--	is_not_reflexive: BOOLEAN
--			-- Is there an element x in `underlying_set' such that this relation does not hold for (x, x)?
--		do
--			Result := not is_reflexive
--		ensure
--			definition: Result = not is_reflexive
--		end

--	is_irreflexive: BOOLEAN
--			-- Does this relation hold for no pair (x, x), where x ∈ `underlying_set'?
--		do
--			Result := a ∀ agent predicate_holds_for_xx (agent does_not_hold, ?)
--		ensure
--			definition: Result = (a ∀ agent predicate_holds_for_xx (agent does_not_hold, ?))
--		end

--	is_not_irreflexive: BOOLEAN
--			-- Does this relation hold for some pair (x, x), where x ∈ `underlying_set'?
--		do
--			Result := not is_irreflexive
--		ensure
--			definition: Result = not is_irreflexive
--		end

--	is_symmetric: BOOLEAN
--			-- If this relation holds for (x, y), then does it hold for (y, x)?
--		do
--			Result := a ∀² agent a.pair_implied (agent holds, agent flipped (agent holds, ?, ?), ?, ?)
--		ensure
--			definition: Result = a ∀² agent a.pair_implied (agent holds, agent flipped (agent holds, ?, ?), ?, ?)
--		end

--	is_not_symmetric: BOOLEAN
--			-- Does `underlying_set' have two elements x and y such that this relation holds for (x, y) but not for (y, x)?
--		do
--			Result := not is_symmetric
--		ensure
--			definition: Result = not is_symmetric
--		end

--	is_asymmetric: BOOLEAN
--			-- If this relation holds for (x, y), then does it not hold for (y, x)?
--		do
--			Result := a ∀² agent a.pair_implied (agent holds, agent does_not_hold, ?, ?)
--		ensure
--			definition: Result = a ∀² agent a.pair_implied (agent holds, agent does_not_hold, ?, ?)
--		end

--	is_not_asymmetric: BOOLEAN
--			-- Does `underlying_set' have two elements x and y such that this relation holds for (x, y) and for (y, x)?
--		do
--			Result := not is_asymmetric
--		ensure
--			definition: Result = not is_asymmetric
--		end

--	is_antisymmetric: BOOLEAN
--			-- If this relation holds for (x, y) and (y, x), then does x equal y?
--		do
--			Result := a ∀² agent a.pair_implied (agent a.pair_anded (agent holds, agent flipped (agent holds, ?, ?), ?, ?), agent a.equality_holds, ?, ?)
--		ensure
--			definition: Result = a ∀² agent a.pair_implied (agent a.pair_anded (agent holds, agent flipped (agent holds, ?, ?), ?, ?), agent a.equality_holds, ?, ?)
--		end

--	is_not_antisymmetric: BOOLEAN
--			-- Does `underlying_set' have two unequal elements x and y such that this relation holds for (x, y) and (y, x)?
--		do
--			Result := not is_antisymmetric
--		ensure
--			definition: Result = not is_antisymmetric
--		end

--	is_transitive: BOOLEAN
--			-- If this relation hold for (x, y) and (y, z), then does it hold for (x, z)?
--		do
--			Result := a ∀³ agent predicate_holds_transitively (agent holds, ?, ?, ?)
--		ensure
--			definition: Result = a ∀³ agent predicate_holds_transitively (agent holds, ?, ?, ?)
--		end

--	is_not_transitive: BOOLEAN
--			-- Does `underlying_set' have three elements (x, y, z) such that this relation holds for (x, y) and (y, z) but not for (x, z)?
--		do
--			Result := not is_transitive
--		ensure
--			definition: Result = not is_transitive
--		end

--	is_intransitive: BOOLEAN
--			-- If this relation hold for (x, y) and (y, z), then does not it hold for (x, z)?
--		do
--			Result := a ∀³ agent predicate_holds_intransitively (agent holds, ?, ?, ?)
--		ensure
--			definition: Result = a ∀³ agent predicate_holds_intransitively (agent holds, ?, ?, ?)
--		end

--	is_not_intransitive: BOOLEAN
--			-- Does `underlying_set' have three elements (x, y, z) such that this relation holds for (x, y), (y, z) and (x, z)?
--		do
--			Result := not is_intransitive
--		ensure
--			definition: Result = not is_intransitive
--		end

--feature -- Operation

--	united alias "∪" (r: STS_ENDORELATION [A, EQ]): like relation_anchor
--			-- Union of this endorelatioin and `r', i.e. the relation (`a' ∪ `r'.`a', `a' ∪ `r'.`a', `g' ∪ `r'.`g').
--		deferred
--		ensure
--			underlying_set: Result.a ≍ (a ∪ r.a)
--			graph: Result.g ≍ (g ∪ r.g)
--		end

--	intersected alias "∩" (r: STS_ENDORELATION [A, EQ]): like relation_anchor
--			-- Intersection of this endorelatioin and `r', i.e. the relation (`a' ∪ `r'.`a', `a' ∪ `r'.`a', `g' ∩ `r'.`g').
--		deferred
--		ensure
--			underlying_set: Result.a ≍ (a ∪ r.a)
--			graph: Result.g ≍ (g ∩ r.g)
--		end

--	composed alias "∘" (r: STS_BINARY_RELATION [A, A, EQ, EQ]): like relation_anchor
--			-- This relation composed with `r'
--		deferred
--		ensure
--			underlying_set: Result.a ≍ (a ∪ r.a)
--			graph: Result.g ≍ (g ∘ r.g)
--		end

--feature -- Predicate

--	predicate_holds_for_xx (p: PREDICATE [A, A]; x: A): BOOLEAN
--			-- Does `p' (`x', `x') hold?
--		do
--			Result := p (x, x)
--		ensure
--			class
--			definition: Result = p (x, x)
--		end

--	flipped (p: PREDICATE [A, A]; x, y: A): BOOLEAN
--			-- `p' applied to (`x', `y') in flipped order, i.e. `p' (`y', `x')
--		do
--			Result := p (y, x)
--		ensure
--			class
--			definition: Result = p (y, x)
--		end

--	predicate_holds_transitively (p: PREDICATE [A, A]; x, y, z: A): BOOLEAN
--			-- If `p' (`x', `y') and `p' (`y', `z') hold, then does necessarily `p' (`x', `z') hold?
--		do
--			Result := p (x, y) and p (y, z) implies p (x, z) -- todo: why not Current (x, y)?
--		ensure
--			class
--			definition: Result = (p (x, y) and p (y, z) implies p (x, z))
--		end

--	predicate_holds_intransitively (p: PREDICATE [A, A]; x, y, z: A): BOOLEAN
--			-- If `p' (`x', `y') and `p' (`y', `z') hold, then must `p' (`x', `z') necessarily not hold?
--		do
--			Result := p (x, y) and p (y, z) implies not p (x, z) -- todo: why not Current (x, y)?
--		ensure
--			class
--			definition: Result = (p (x, y) and p (y, z) implies not p (x, z))
--		end

--feature -- Anchor

--	underlying_set_anchor: STS_RELATABLE_SET [A, A, EQ, EQ]
--			-- Anchor for sets like `underlying_set'
--		do
--			Result := a
--		end

--	relation_anchor,
--	inverse_anchor: STS_ENDORELATION [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	graph_anchor: STS_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := g
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
