﻿note
	description: "Set with the ordered pairs of a binary relation"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_GRAPH [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STS_SET_OF_PAIRS [A, B, EQ_A, EQ_B]
--		rename
--				-- Anchor
--			set_anchor as graph_anchor,
--			subset_anchor as subgraph_anchor,
--			superset_anchor as supergraph_anchor
--		undefine
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor
--		end

--	STS_RELATION_AWARE_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		rename
--				-- Transformer
--			element_to_element as pair_to_pair,
--			element_to_natural as pair_to_natural,
--			element_to_boolean as pair_to_boolean,
--			element_to_tuple as pair_to_tuple,
--			element_to_sets as pair_to_sets,
--				-- Anchor
--			set_anchor as graph_anchor,
--			subset_anchor as subgraph_anchor,
--			superset_anchor as supergraph_anchor
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor
--		end

--feature -- Primitive

--	eq_a: EQ_A
--			-- Equality for objects like those in `first_projection'
--		deferred
--		end

--	eq_b: EQ_B
--			-- Equality for objects like those in `second_projection'
--		deferred
--		end

--feature -- Quality

--	is_functional: BOOLEAN
--			-- Is this a functional graph, i.e. todo: complete description?
--		do
--			Result := π₁ Current ∀ agent x_has_just_one_value
--		ensure
--			definition: Result = (π₁ Current ∀ agent x_has_just_one_value)
--		end

--feature -- Relationship

--	correspond alias "()" (a: A; b: B): BOOLEAN
--			-- Does `b' correspond to `a' by this graph?
--		do
--			Result := pair (a, b) ∈ Current
--		ensure
--			definition: Result = pair (a, b) ∈ Current
--		end

--feature -- Operation

--	definition,
--	first_projection alias "π₁": like first_anchor
--			-- Set with the first element of every pair in this graph
--		do
--			Result := Current ↦₁ agent {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}.a
--		ensure
--			definition: Result ≍ (Current ↦₁ agent {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}.a)
--		end

--	values,
--	second_projection alias "π₂": like second_anchor
--			-- Set with the second element of every pair in this graph
--		do
--			Result := Current ↦₂ agent {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}.b
--		ensure
--			definition: Result ≍ (Current ↦₂ agent {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}.b)
--		end

--	inverse alias "⁻¹": like inverse_anchor
--			-- Graph with the inverse of every pair in this graph
--		do
--			Result := Current ↦₂ｘ₁ agent {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}.inverse
--		ensure
--			definition: Result ≍ (Current ↦₂ｘ₁ agent {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}.inverse)
--		end

--	image alias "[]" (s: STS_SET [A, EQ_A]): like second_anchor
--			-- Set with the second element of every pair in this graph whose first element is in `s'
--		do
--			Result := π₂ (Current ₁⊳ s)
--		ensure
--			definition: Result ≍ π₂ (Current ₁⊳ s)
--		end

--	inverse_image (s: STS_SET [B, EQ_B]): like first_anchor
--			-- Image of `s' by `inverse'
--		do
--			Result := (⁻¹ Current) [s]
--		ensure
--		    definition: Result ≍ (⁻¹ Current) [s]
--		end

--	left_restricted alias "₁⊳" (s: STS_SET [A, EQ_A]): like subgraph_anchor
--			-- Every pair in this graph whose first element is in `s'
--			-- todo: make the set-respective feature...
--		do
--			Result := Current ｜ˣʸ agent s_has_x (?, ?, s)
--		ensure
--			definition: Result ≍ (Current ｜ˣʸ agent s_has_x (?, ?, s))
--		end

--	right_restricted alias "⊲" (s: STS_SET [B, EQ_B]): like subgraph_anchor
--			-- Every pair in this graph whose second element is in `s'
--		do
--			Result := Current ｜ˣʸ agent s_has_y (?, ?, s)
--		ensure
--			definition: Result ≍ (Current ｜ˣʸ agent s_has_y (?, ?, s))
--		end

--	composed_with_homogeneous alias "₁∘₁"
--		(g: STS_GRAPH [A, A, EQ_A, EQ_A]): like composer_with_homogeneous.composite_graph
--			-- This graph composed with `g'
--		do
--			Result := composer_with_homogeneous.composite_graph (Current, g)
--		ensure
--			definition: Result ≍ composer_with_homogeneous.composite_graph (Current, g)
--		end

--	composed_with_inverse_like alias "₂∘₁"
--		(g: STS_GRAPH [B, A, EQ_B, EQ_A]): like composer_with_inverse_like.composite_graph
--			-- This graph composed with `g'
--		do
--			Result := composer_with_inverse_like.composite_graph (Current, g)
--		ensure
--			definition: Result ≍ composer_with_inverse_like.composite_graph (Current, g)
--		end

--feature -- Transformation

--	mapped_to_first_projection_like alias "↦₁"
--		(f: FUNCTION [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A]): like first_anchor
--			-- This graph mapped to a `first_projection'-like set
--		deferred
--		ensure
--			definition: Result ≍ pair_to_first.set_map (Current, f)
--		end

--	mapped_to_second_projection_like alias "↦₂"
--		(f: FUNCTION [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B]): like second_anchor
--			-- This graph mapped to a `second_projection'-like set
--		deferred
--		ensure
--			definition: Result ≍ pair_to_second.set_map (Current, f)
--		end

--	mapped_to_inverse_like alias "↦₂ｘ₁" (
--		f: FUNCTION [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [B, A, EQ_B, EQ_A]]
--		): like inverse_anchor
--			-- This graph mapped to an `inverse'-like graph
--		deferred
--		ensure
--			definition: Result ≍ pair_to_inverse.set_map (Current, f)
--		end

--feature -- Factory

--	pair (a: A; b: B): like pair_anchor
--			-- Ordered pair in the form (`a', `b')
--		deferred
--		ensure
--			first: eq_a (Result.a, a)
--			second: eq_b (Result.b, b)
--		end

--feature -- Predicate

--	x_has_just_one_value (x: A): BOOLEAN
--			-- Does `x' have just one corresponding value in `second_projection'?
--		do
--			Result := π₂ Current ∀² agent y_is_unique (x, ?, ?)
--		ensure
--			definition: Result = π₂ Current ∀² agent y_is_unique (x, ?, ?)
--		end

--	y_is_unique (x: A; y1, y2: B): BOOLEAN
--			-- If this graph has (`x', `y1') and (`x', `y2'), then does `y1' equal `y2'?
--		do
--			Result := pair (x, y1) ∈ Current and pair (x, y2) ∈ Current implies eq_b (y1, y2)
--		ensure
--			definition:
--				Result = (pair (x, y1) ∈ Current and pair (x, y2) ∈ Current implies eq_b (y1, y2))
--		end

--	s_has_x (x: A; y: B; s: STS_SET [A, EQ_A]): BOOLEAN
--			-- Does `s' have `x'?
--		do
--			Result := s ∋ x
--		ensure
--			class
--			definition: Result = s ∋ x
--		end

--	s_has_y (x: A; y: B; s: STS_SET [B, EQ_B]): BOOLEAN
--			-- Does `s' have `y'?
--		do
--			Result := s ∋ y
--		ensure
--			class
--			definition: Result = s ∋ y
--		end

--feature -- Transformer

--	pair_to_pair: STS_ENDORELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			-- Producer or relations between types derived from {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]}
--		deferred
--		end

--	pair_to_natural: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], NATURAL, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_OBJECT_EQUALITY [NATURAL]]
--			-- Producer or relations between types derived from {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]} and {NATURAL}
--		deferred
--		end

--	pair_to_boolean: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], BOOLEAN, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_OBJECT_EQUALITY [BOOLEAN]]
--			-- Producer or relations between types derived from {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]} and BOOLEAN
--		deferred
--		end

--	pair_to_tuple: STS_RELATION_PRODUCER [
--		STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--		STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--		STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--		STS_N_TUPLE_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		]
--			-- Producer or relations between types derived from {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]} and {STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]}
--		deferred
--		end

--	pair_to_sets: STS_RELATION_PRODUCER [
--		STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--		STS_SET [
--			STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			],
--		STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--		STS_SET_EQUALITY [
--			STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			]
--		]
--			-- Producer or relations between types derived from {STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]} and {
--			--	STS_SET [
--			--		STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			--		STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			--		]
--			--	}
--		deferred
--		end

--	tuple_extensor: STS_RELATION_PRODUCER [
--		STS_ORDERED_PAIR [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_N_TUPLE_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			],
--		STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--		STS_PAIR_EQUALITY [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_N_TUPLE_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			],
--		STS_N_TUPLE_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		]
--			-- Producer or relations between types derived from {
--			--	STS_ORDERED_PAIR [
--			--		STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			--		STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			--		STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			--		STS_N_TUPLE_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			--		]
--			--	} and {STS_N_TUPLE [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]}
--		deferred
--		end

--	pair_to_first: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_A]
--			-- Producer of relations between ordered pairs and objects like their first elements
--		deferred
--		end

--	pair_to_second: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_B]
--			-- Producer of relations between ordered pairs and objects like their second elements
--		deferred
--		end

--	pair_to_inverse: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [B, A, EQ_B, EQ_A], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]]
--			-- Producer of relations between ordered pairs and pairs like their inverses
--		deferred
--		end

--	composer_with_homogeneous: STS_RELATION_COMPOSER [A, A, B, EQ_A, EQ_A, EQ_B]
--			-- Composer for graphs like this one and those whose pairs have elements of kind {A}
--			-- only
--		deferred
--		end

--	composer_with_inverse_like: STS_RELATION_COMPOSER [B, A, B, EQ_B, EQ_A, EQ_B]
--			-- Composer for graphs like this one and those whose pairs are like inverses of those in
--			-- this one
--		deferred
--		end

--feature -- Anchor

--	graph_anchor,
--	subgraph_anchor,
--	supergraph_anchor: STS_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	first_anchor: STS_RELATABLE_SET [A, B, EQ_A, EQ_B]
--			-- Anchor for sets like `first_projection'
--		do
--			Result := π₁ Current
--		end

--	second_anchor: STS_RELATABLE_SET [B, A, EQ_B, EQ_A]
--			-- Anchor for sets like `second_projection'
--		do
--			Result := π₂ Current
--		end

--	inverse_anchor: STS_GRAPH [B, A, EQ_B, EQ_A]
--			-- Anchor for graphs like `inverse'
--		do
--			Result := ⁻¹ Current
--		end

--	pair_anchor (a: A; b: B): STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]
--			-- Anchor for ordered pairs
--		do
--			Result := pair (a, b)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
