﻿note
	description: "Ordered pair whose first element is an ordered pair"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_ORDERED_TRIPLE [
		A, B, C,
		EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B], EQ_C -> STS_EQUALITY [C]
		]

--inherit
--	STS_ORDERED_PAIR
--		[STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C]
--		rename
--			a as ab,
--			first as front,
--			b as c,
--			second as third alias "π₃",
--			eq_a as eq_ab,
--			eq_b as eq_c
--		end

--feature -- Access

--	a,
--	first alias "π₁": A
--			-- First element in this ordered triple
--		do
--			Result := ab.a
--		ensure
--			definition: eq_a (Result, ab.a)
--		end

--	b,
--	second alias "π₂": B
--			-- Second element in this ordered triple
--		do
--			Result := ab.b
--		ensure
--			definition: eq_b (Result, ab.b)
--		end

--	eq_a: EQ_A
--			-- Equality for objects like `first'
--		do
--			Result := ab.eq_a
--		ensure
--			definition: Result ~ ab.eq_a
--		end

--	eq_b: EQ_B
--			-- Equality for objects like `second'
--		do
--			Result := ab.eq_b
--		ensure
--			definition: Result ~ ab.eq_b
--		end

--feature -- Operation

--	composed_with_homogeneous alias "₁∘₁" (x1x2: STS_ORDERED_PAIR [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]): STS_ORDERED_TRIPLE [A, B, C, EQ_A, EQ_B, EQ_C]
--			-- <Precursor>
--		deferred
--		end

--feature -- Conversion

--	as_singleton: STS_GRAPH [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], C, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_C]
--			-- <Precursor>
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
