﻿note
	description: "Endorelation that factors out features common to orders regardless they are strict or not."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_ORDER_LIKE [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_ENDORELATION [A, EQ]
--		rename
--			inverse as opposite alias "⁻¹",
--			inverse_image as opposite_image,
--			inverse_anchor as opposite_anchor
--		redefine
--			opposite_anchor
--		end

--feature -- Quality

--	is_partial: BOOLEAN
--			-- Does `underlying_set' have a pair of distinct elements unordered by this relation?
--		deferred
--		ensure
--			definition: Result = a.exists_distinct_pair (agent does_not_compare)
--		end

--	is_total: BOOLEAN
--			-- Is every pair of distinct elements in `underlying_set' ordered by this relation?
--		deferred
--		ensure
--			definition: Result = a.for_all_distinct_pairs (agent compares)
--		end

--feature -- Relationship

--	compares (x, y: A): BOOLEAN
--			-- Does this order hold for (`x', `y') or (`y', `x')?
--		do
--			Result := holds (x, y) or holds (y, x)
--		ensure
--			definition: Result = (holds (x, y) or holds (y, x))
--		end

--	does_not_compare (x, y: A): BOOLEAN
--			-- Does not this order hold for (`x', `y') or (`y', `x')?
--		do
--			Result := not compares (x, y)
--		ensure
--			definition: Result = not compares (x, y)
--		end

--	holds_oppositely (x, y: A): BOOLEAN
--			-- Does this order hold for (`y', `x')?
--		do
--			Result := holds (y, x)
--		ensure
--			definition: Result = holds (y, x)
--		end

--	holds_strictly (x, y: A): BOOLEAN
--			-- Are `x' and `y' unequal and does this order hold for them?
--		do
--			Result := not a.eq_a (x, y) and holds (x, y)
--		ensure
--			definition: Result = (not a.eq_a (x, y) and holds (x, y)) -- todo: eq_a?
--		end

--	holds_oppositely_and_strictly (x, y: A): BOOLEAN
--			-- Does this order hold strictly for (`y', `x')?
--		do
--			Result := holds_strictly (y, x)
--		ensure
--			definition: Result = holds_strictly (y, x)
--		end

--	holds_consecutively (x, z: A): BOOLEAN
--			-- Does this order hold strictly for (`x', `z') and does not there exist any y such that this order holds strictly for (`x', y) and for (y, `z')?
--		do
--			Result :=holds_strictly (x, z) and a ∄ agent a.anded (agent holds_strictly (x, ?), agent holds_strictly (?, z), ?)
--		ensure
--			definition: Result =(holds_strictly (x, z) and a ∄ agent a.anded (agent holds_strictly (x, ?), agent holds_strictly (?, z), ?))
--		end

--feature -- Operation

--	successors (x: A): like image
--			-- Set of elements in `underlying_set' that succeed `x' by this order
--		do
--			Result := Current [a.singleton (x)]
--		ensure
--			definition: Result ≍ Current [a.singleton (x)]
--		end

--	predecessors (y: A): like opposite_image
--			-- Set of elements in `underlying_set' that precede `y' by this order
--		do
--			Result := opposite_image (a.singleton (y))
--		ensure
--			definition: Result ≍ opposite_image (a.singleton (y))
--		end

--	strict_successors (x: A): like successors
--			-- Successors of `x' by this order that unequals `x'
--		do
--			Result := successors (x) / x
--		ensure
--			definition: Result ≍ (successors (x) / x)
--		end

--	strict_predecessors (y: A): like predecessors
--			-- Predecessors of `y' by this order that unequals `y'
--		do
--			Result := predecessors (y) / y
--		ensure
--			definition: Result ≍ (predecessors (y) / y)
--		end

--feature -- Anchor

--	opposite_anchor: STS_ORDER_LIKE [A, EQ]
--			-- Anchor for relations like `opposite`
--		do
--			Result := Current
--		end

--invariant
--	is_transitive: is_transitive

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
