﻿note
	description: "Set equipped with an order relation"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_ORDERED_SET [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_RELATION_AWARE_SET [A, EQ]

--feature -- Primitive

--	order: STS_ORDER [A, EQ]
--			-- Relation that defines an order, say "<=", to the elements in this set.
--		deferred
--		ensure
--		    covers_this_set: Result.a ⊇ Current
--		end

--feature -- Quality

--	has_minimum: BOOLEAN
--			-- Does this set has a minimum element?
--		do
--			Result := Current ∃ agent is_minimum
--		ensure
--			definition: Result = (Current ∃ agent is_minimum)
--		end

--	has_maximum: BOOLEAN
--			-- Does this set has a maximum element?
--		do
--			Result := Current ∃ agent is_maximum
--		ensure
--			definition: Result = (Current ∃ agent is_maximum)
--		end

--	is_bounded_below: BOOLEAN
--			-- Does this set have any lower bound?
--		do
--			Result := ｍ Current ≭ o
--		ensure
--			definition: Result = ｍ Current ≭ o
--		end

--	is_bounded_above: BOOLEAN
--			-- Does this set have any upper bound?
--		do
--			Result := Ｍ Current ≭ o
--		ensure
--			definition: Result = Ｍ Current ≭ o
--		end

--	is_bounded: BOOLEAN
--			-- Is this set bounded above and below?
--		do
--			Result := is_bounded_below and is_bounded_above
--		ensure
--			definition: Result = (is_bounded_below and is_bounded_above)
--		end

--	infimum_exists: BOOLEAN
--			-- Do the lower bounds of this set have a maximum?
--		do
--			Result := (ｍ Current).has_maximum
--		ensure
--			definition: Result = (ｍ Current).has_maximum
--		end

--	supremum_exists: BOOLEAN
--			-- Do the upper bounds of this set have a minimum?
--		do
--			Result := (Ｍ Current).has_minimum
--		ensure
--			definition: Result = (Ｍ Current).has_minimum
--		end

--	is_lattice: BOOLEAN
--			-- Does this set have the infimum and the supremum of every pair of its elements?
--		deferred
--		ensure
--		    definition: Current ∀² agent has_infimum_and_supremum_of_pair
--		end

--	is_linear: BOOLEAN
--			-- Is this set totally ordered?
--		deferred
--		ensure
----		    definition: (order ↾ Current).is_total
--		end

--	is_well_ordered: BOOLEAN
--			-- Is `order' a well-order?
--		deferred
--		ensure
----		    definition: Result = (order ↾ Current).is_well
--		end

--feature -- Extremum

--	is_minimum (a: A): BOOLEAN
--			-- Does this set have `a' and does `a' precede every element in this
--			-- set?
--		deferred
--		ensure
--			definition:
--				Result = (Current ∋ a and (Current ∀ agent order.holds (a, ?)))
--		end

--	minimum alias "ｍｉｎ": A
--			-- Element in this set that precedes every element in this set
--		note
--			--EIS: "name=Math symbols", "protocol=URI",
--				--"src=$(system_path)\eis\set_theory.html#math-symbols"
--		require
--		    has_minimum: has_minimum
--		deferred
--		ensure
--		    definition: (Current | agent is_minimum) ∋ Result
--		end

--	is_maximum (b: A): BOOLEAN
--			-- Does this set have `b' and does every element in this set
--			-- precede `b'?
--		deferred
--		ensure
--			definition:
--				Result = (Current ∋ b and (Current ∀ agent order.holds (?, b)))
--		end

--	maximum alias "ｍａｘ": A
--			-- Elementt in this set that succeeds every element in this set
--		note
--			--EIS: "name=Math symbols", "protocol=URI",
--				--"src=$(system_path)\eis\set_theory.html#math-symbols"
--		require
--		    has_maximum: has_maximum
--		deferred
--		ensure
--		    definition: (Current | agent is_maximum) ∋ Result
--		end

--	is_minimal (a: A): BOOLEAN
--			-- Does this set have `a' and does no element in this set precede
--			-- `a' strictly?
--		deferred
--		ensure
--			definition: Result =
--				(Current ∋ a and Current ∄ agent order.holds_strictly (?, a))
--		end

--	is_maximal (b: A): BOOLEAN
--			-- Does this set have `b' and does no element in this set succeeds
--			-- `b' strictly?
--		deferred
--		ensure
--			definition: Result =
--				(Current ∋ b and Current ∄ agent order.holds_strictly (b, ?))
--		end

--	is_lower_bound (a: A): BOOLEAN
--			-- Is `a' a lower bound for this set, i.e. does `a' precede every
--			-- element in this set?
--		deferred
--		ensure
--			definition: Result = (Current ∀ agent order.holds (a, ?))
--		end

--	lower_bounds alias "ｍ": STS_ORDERED_SET [A, EQ]
--			-- Elements in `order'.`field' that precede every element in this
--			-- set
--		note
--			--EIS: "name=Math symbols", "protocol=URI",
--				--"src=$(system_path)\eis\set_theory.html#math-symbols"
--		deferred
--		ensure
--		    set: Result ≍ (order.a | agent is_lower_bound)
----		    same_order: has_same_order (Result)
--		end

--	is_upper_bound (b: A): BOOLEAN
--			-- Is `b' an upper bound for this set, i.e. does every element in
--			-- this set precede `b'?
--		deferred
--		ensure
--			definition: Result = (Current ∀ agent order.holds (?, b))
--		end

--	upper_bounds alias "Ｍ": STS_ORDERED_SET [A, EQ]
--			-- Elements in `order'.`field' that succeed every element in this
--			-- set
--		note
--			--EIS: "name=Math symbols", "protocol=URI",
--				--"src=$(system_path)\eis\set_theory.html#math-symbols"
--		deferred
--		ensure
--		    set: Result ≍ (order.a | agent is_upper_bound)
----		    same_order: has_same_order (Result)
--		end

--	is_infimum (a: A): BOOLEAN
--			-- Is `a' the maximum element of the lower bounds of this set?
--		deferred
--		ensure
--			definition: Result = (ｍ Current).is_maximum (a)
--		end

--	infimum alias "ｉｎｆ": A
--			-- Maximum element of the lower bounds of this set
--		note
--			--EIS: "name=Math symbols", "protocol=URI",
--				--"src=$(system_path)\eis\set_theory.html#math-symbols"
--		require
--			infimum_exists: infimum_exists
--		deferred
--		ensure
--			lower_bounds_has_maximum:
--				(ｍ Current).has_maximum -- `infimum_exists'
--		    definition: eq (Result, ｍａｘ (ｍ Current))
--		end

--	is_supremum (b: A): BOOLEAN
--			-- Is `b' the minimum element of the upper bounds of this set?
--		deferred
--		ensure
--			definition: Result = (Ｍ Current).is_minimum (b)
--		end

--	supremum alias "ｓｕｐ": A
--			-- Minimum element of the upper bounds of this set
--		note
--			--EIS: "name=Math symbols", "protocol=URI",
--				--"src=$(system_path)\eis\set_theory.html#math-symbols"
--		require
--			supremum_exists: supremum_exists
--		deferred
--		ensure
--			upper_bounds_has_minimum:
--				(Ｍ Current).has_minimum -- `supremum_exists'
--		    definition: eq (Result, ｍｉｎ (Ｍ Current))
--		end

--feature -- Predicate

--	has_infimum_and_supremum_of_pair (x, y: A): BOOLEAN
--			-- Does this set have the infimum and the supremum of {`x', `y'}?
--		deferred
--		ensure
----		    definition: Result = (
----		    	has_infimum (subset_from_pair (x, y)) and
----		    	has_supremum (subset_from_pair (x, y))
----		    	)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
