﻿note
	description: "[
		Object able to compose two graphs when the right-hand side graph have a first-element type
		possibly unrelated to the types of the elements in left-hand side graph
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_RELATION_COMPOSER [
		W, A, B,
		EQ_W -> STS_EQUALITY [W], EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]
		]

--inherit

--	STS_PAIR_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
--		rename
--				-- Operation
--			composite_pair as composite_pair
--		end

--feature -- Operation

--	composite_graph (
--		h: STS_GRAPH [A, B, EQ_A, EQ_B]; g: STS_GRAPH [W, A, EQ_W, EQ_A]
--		): STS_COMPOSABLE_GRAPH [A, W, B, EQ_A, EQ_W, EQ_B]
--			-- Composition of `h' and `g', i.e. graph whose pairs are compositions of the pairs in
--			-- `h' and in `g'.
--		deferred
--		ensure
--			definition: Result ≍
--				(w_x_b.cartesian_product (π₁ g, π₂ h) ｜ˣʸ agent pair_is_composite (?, ?, g, h))
--		end

--	composite_relation (
--		r2: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]; r1: STS_BINARY_RELATION [W, A, EQ_W, EQ_A]
--		): STS_COMPOSABLE_RELATION [A, W, B, EQ_A, EQ_W, EQ_B]
--			-- Composition of `r2' and `r1', i.e. relation whose graph is the composition of the graphs of `r2' and `r1'.
--		deferred
--		ensure
--			departure: Result.a ≍ r1.a
--			arrival: Result.b ≍ r2.b
--			graph: Result.g ≍ composite_graph (r2.g, r1.g)
--		end

--feature -- Predicate

--	pair_is_composite
--		(w: W; y: B; g: STS_GRAPH [W, A, EQ_W, EQ_A]; h: STS_GRAPH [A, B, EQ_A, EQ_B]): BOOLEAN
--			-- Is the pair (`w', `y') composed from a pair in `h' and a pair in `g'?
--		do
--			Result := (π₂ g ∩ π₁ h) ∃ agent x_is_common (w, ?, y, g, h)
--		ensure
--			definition: Result = ((π₂ g ∩ π₁ h) ∃ agent x_is_common (w, ?, y, g, h))
--		end

--	x_is_common (
--		w: W; x: A; y: B; g: STS_GRAPH [W, A, EQ_W, EQ_A]; h: STS_GRAPH [A, B, EQ_A, EQ_B]
--		): BOOLEAN
--			-- Is `x' the common element that makes (`w', `y') the composite of a pair in `h' and a
--			-- pair in `g'?
--		do
--			Result := g (w, x) and h (x, y)
--		ensure
--			class
--			definition: Result = (g (w, x) and h (x, y))
--		end

--feature -- Transformer

--	w_x_b: STS_RELATION_PRODUCER [W, B, EQ_W, EQ_B]
--			-- Producer of relations between types derived from {W} and {B}
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
