note
	description: "[
		Descendant of {STI_COMPLEX_NUMBER} whose features with restricted access are available to be tested. Notice that inheriting from an expanded class is a
		non-conformant inheritance.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

expanded class
	COMPLEX_NUMBER

inherit
	STI_COMPLEX_NUMBER
		export {COMPLEX_NUMBER_PROPERTIES, COMPLEX_NUMBER_TESTS}
			value_is_negative_zero,
			value_is_positive_zero,
			c_hypot,
			c_atan2,
			product_from_native_reals,
			quotient_from_native_reals,
			c_copysign
		end

create
	default_create,
	make,
	make_from_expanded,
	make_from_complex,
	make_from_native_real,
	make_from_native_real_ref,
	make_from_native_double_real,
	make_from_native_double_real_ref,
	make_from_real,
	make_from_native_integer,
	make_from_native_integer_ref,
	make_from_integer,
	make_from_native_natural,
	make_from_native_natural_ref,
	make_from_ordered_pair

convert
	make_from_complex ({STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER}),
	make_from_native_real ({REAL}),
	make_from_native_real_ref ({REAL_REF}),
	make_from_native_double_real ({DOUBLE}),
	make_from_native_double_real_ref ({DOUBLE_REF}),
	make_from_real ({STS_REAL_NUMBER}),
	make_from_native_integer ({INTEGER}),
	make_from_native_integer_ref ({INTEGER_REF}),
	make_from_integer ({STS_INTEGER_NUMBER}),
	make_from_native_natural ({NATURAL}),
	make_from_native_natural_ref ({NATURAL_32_REF}),
	make_from_ordered_pair ({
		STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_EQUALITY [STS_REAL_NUMBER], STS_EQUALITY [STS_REAL_NUMBER]],
		STI_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STI_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],

		STS_ORDERED_PAIR [STI_REAL_NUMBER, STI_REAL_NUMBER, STS_EQUALITY [STI_REAL_NUMBER], STS_EQUALITY [STI_REAL_NUMBER]],
		STI_ORDERED_PAIR [STI_REAL_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]],

		STS_HOMOGENEOUS_ORDERED_PAIR [STS_REAL_NUMBER, STS_EQUALITY [STS_REAL_NUMBER]],
		STI_HOMOGENEOUS_ORDERED_PAIR [STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STI_HOMOGENEOUS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_EQUALITY],

		STS_HOMOGENEOUS_ORDERED_PAIR [STI_REAL_NUMBER, STS_EQUALITY [STI_REAL_NUMBER]],
		STI_HOMOGENEOUS_ORDERED_PAIR [STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		}),
	as_ordered_pair: {
		STI_HOMOGENEOUS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_EQUALITY],
		STI_HOMOGENEOUS_ORDERED_PAIR [STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STI_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],
		STI_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		},
	as_tuple: {
		STS_N_TUPLE [STS_REAL_NUMBER, STS_REAL_EQUALITY],
		STI_N_TUPLE [STS_REAL_NUMBER, STS_REAL_EQUALITY]
		},
	as_parent: {STI_COMPLEX_NUMBER}

feature -- Conversion

	as_parent: like complex_anchor
			-- Current complex number converted to the type of its parent
		do
			create Result.make_from_expanded (a, b)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
