note
	description: "Descendant of {STI_INTEGER_UNIVERSE} adapted to allow testing of (partially) non-exported features and/or for better performance on testings."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	INTEGER_UNIVERSE

inherit
	STI_INTEGER_UNIVERSE
		export
			{STI_INTEGER_UNIVERSE, INTEGER_UNIVERSE_PROPERTIES, INTEGER_UNIVERSE_TESTS}
				i_is_within_interval
			{INTEGER_UNIVERSE_PROPERTIES, INTEGER_UNIVERSE_TESTS}
				make_empty,
				make_singleton,
				make_extended,
				make_from_set,
				make_from_numeric_set,
				stored_value_interval,
				integer_from_stored_value
		end

create
	default_create,
	make_from_universe

convert
	make_from_universe ({
		STS_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],
		STI_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]],

		STS_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],
		STI_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY],

		STS_INTEGER_UNIVERSE,
		STI_INTEGER_UNIVERSE
		}),
	as_complex_set: {
		STI_COMPLEX_SET,
		STS_COMPLEX_SET,

		STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		},
	as_real_set: {
		STI_REAL_SET,
		STS_REAL_SET,

		STI_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY],
		STS_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY]
		}

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
