note
	description: "Descendant of {STI_COMPLEX_SET} meant to run quickly by turning its assertions off."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	QUICK_COMPLEX_SET

inherit
	STI_COMPLEX_SET
		redefine
			O, Empty_set,
			Unit,
			set_anchor,
			subset_anchor,
			superset_anchor,
			n_tuple_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended,
	make_from_set,
	make_from_numeric_set

convert
	make_from_set ({
		STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STI_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_COMPLEX_SET,
		STI_COMPLEX_SET,

		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_COMPLEX_UNIVERSE,

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_REAL_EQUALITY],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_REAL_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [REAL_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [REAL_NUMBER]]
		}),
	make_from_numeric_set ({
		STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [COMPLEX_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY],

		STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [REAL_NUMBER]],
		STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [REAL_NUMBER]]
		}),
	as_set_of_pairs: {
		STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],

		STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		}

feature -- Factory

	O,
	Empty_set: QUICK_COMPLEX_SET
			-- <Precursor>
		once
			create Result.make_empty
		end

	Unit: QUICK_COMPLEX_TUPLE
			-- <Precursor>
		once
			Result := {QUICK_COMPLEX_TUPLE}.Unit
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: QUICK_COMPLEX_SET
			-- <Precursor>
		do
			Result := Current
		end

	n_tuple_anchor: QUICK_COMPLEX_TUPLE
			-- <Precursor>
		once
			Result := Unit
		ensure then
			class
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
