﻿note
	description: "Descendant of {STI_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]} meant to run quickly by turning its assertions off."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	QUICK_COMPLEX_TUPLE

inherit
	STI_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		redefine
			eq,
			unit,
			converted_term,
			term_anchor,
			tuple_anchor,
			trimmed_tuple_anchor,
			extended_tuple_anchor,
			terms_anchor
		end

create
	make_unit,
	make_after,
	make_n,
	make_from_tuple

convert
	make_from_tuple ({
		STS_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STI_N_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_TRANSFORMABLE_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY],
		STI_TRANSFORMABLE_TUPLE [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
		})

feature -- Primitive

	eq: STS_COMPLEX_EQUALITY
			-- <Precursor>
		once
			create Result
		end

feature -- Factory

	Unit: QUICK_COMPLEX_TUPLE
			-- <Precursor>
		once
			create Result.make_unit
		ensure then
			class
		end

	converted_term (z: STS_COMPLEX_NUMBER): like Term_anchor
			-- `z` converted to a term like `term`
			-- TODO: Test it.
			-- TODO: DRY ({SET}.converted_element)
		do
			if attached {STI_COMPLEX_NUMBER} z as l_z then
				Result := l_z
			else
				Result := z
			end
		end

feature -- Anchor

	term_anchor: STI_COMPLEX_NUMBER
			-- <Precursor>
		once
		end

	tuple_anchor,
	trimmed_tuple_anchor,
	extended_tuple_anchor: QUICK_COMPLEX_TUPLE
			-- <Precursor>
		do
			Result := Current
		end

	terms_anchor: QUICK_COMPLEX_SET
			-- <Precursor>
		once
			Result := {QUICK_COMPLEX_SET}.O
		ensure then
			class
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
