﻿note
	description: "Descendant of {STI_COMPLEX_UNIVERSE} meant to run quickly by turning its assertions off."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	QUICK_COMPLEX_UNIVERSE

inherit
	STI_COMPLEX_UNIVERSE
		undefine
			o, Empty_set,
			Unit,
			set_anchor,
			subset_anchor,
			n_tuple_anchor
		redefine
			Without_zero,
			Complement,
			As_tuple
		end

	QUICK_COMPLEX_SET
		rename
			Cardinality as Cardinality,
			superset_anchor as itself
		undefine
			default_create,
			make_empty,
			make_singleton,
			make_extended,
			make_from_set,
			make_from_numeric_set,
			Is_empty,
			Any,
			has,
			with,
			extended,
			Is_singleton,
			equals,
			is_subset,
			is_superset,
			is_comparable,
			is_not_comparable,
			is_strict_subset,
			is_strict_superset,
			is_trivial_subset,
			is_trivial_superset,
			is_proper_subset,
			is_proper_superset,
			is_disjoint,
			Cardinality,
			Out,
			Subsets, Powerset,
			Trivial_subsets,
			Proper_subsets,
			complemented,
			united,
			intersected,
			subtracted_symmetricaly,
			Squared,
			Diagonal,
			As_singleton,
			as_set_of_pairs,
			itself
		redefine
			Without_zero,
			Complement,
			As_tuple
		end

create
	default_create,
	make_from_universe

convert
	make_from_universe ({
		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_COMPLEX_UNIVERSE,
		STI_COMPLEX_UNIVERSE,
		COMPLEX_UNIVERSE
		}),
	as_set_of_pairs: {
		STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],

		STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		}

feature -- Restriction

	without_zero: QUICK_COMPLEX_SET
			-- <Precursor>
		once
			Result := Precursor {QUICK_COMPLEX_SET}
		end

feature -- Operation

	complement alias "∁": QUICK_COMPLEX_SET
			-- <Precursor>
		once
			Result := O
		end

feature -- Conversion

	as_tuple: QUICK_COMPLEX_TUPLE
			-- <Precursor>
		once
			Result := Precursor {QUICK_COMPLEX_SET}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
