note
	description: "Descendant of {STI_SET_PARTITION} whose features with restricted access are available to be tested"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	EXPOSED_SET_PARTITION [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STI_SET_PARTITION [A, EQ]
		export {SET_PARTITION_PROPERTIES, SET_PARTITION_TESTS}
			family_make_singleton,
			family_make_extended,
			family_make_from_set
		redefine
			partition_anchor,
			subpartition_anchor,
			superpartition_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended,
	make_from_partition

convert
	make_from_partition ({STS_SET_PARTITION [A, EQ]})

feature -- Anchor

	partition_anchor,
	subpartition_anchor,
	superpartition_anchor: EXPOSED_SET_PARTITION [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
