﻿note
	description: "Descendant of {STI_SUBSET_FAMILY_STRUCTURE} whose features with restricted access are available to be tested"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	EXPOSED_SUBSET_FAMILY_STRUCTURE [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STI_SUBSET_FAMILY_STRUCTURE [A, EQ]
		export {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
			make_pair,
			make_from_pair
		redefine
				-- todo: Why are these redefinitions needed?
			set_make_empty,
			make_singleton,
			make_from_set,
				-- todo: end
			family_structure_anchor,
			subfamily_structure_anchor,
			superfamily_structure_anchor
		end

create
	set_make_empty,
	make_empty,
	make_singleton,
	set_make_extended,
	make_extended,
	make_from_set,
	make_from_family

convert
	make_from_set ({
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		STI_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],
		STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],
		STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],
		STI_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],
		STI_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			],

		STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],
		STI_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			],

		STS_SET_OF_SETS [A, EQ],
		STI_SET_OF_SETS [A, EQ],

		STS_SET_FAMILY [A, EQ],
		STI_SET_FAMILY [A, EQ],

		STS_SET_PARTITION [A, EQ],
		STI_SET_PARTITION [A, EQ]
		}),

	make_from_family ({
		STS_SUBSET_FAMILY [A, EQ],
		STI_SUBSET_FAMILY [A, EQ], -- todo: test it.

		STS_SUBSET_FAMILY_STRUCTURE [A, EQ],
		STI_SUBSET_FAMILY_STRUCTURE [A, EQ]
		})

feature {NONE} -- Initialization

	set_make_empty
			-- <Precursor>
		do
			sf := Current
			create s.make_empty
			others := Current
		end

	make_singleton (a_s: STS_SET [A, EQ])
			-- <Precursor>
		do
			create others.make_empty (a_s)
			s := others.s
			create any_storage.put (s)
			sf := Current
		end

	make_from_set (ss: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]])
			-- <Precursor>
		do
			if attached {STS_SUBSET_FAMILY [A, EQ]} ss as l_sf then
				make_from_family (l_sf)
			else
				if ss.is_empty then
					set_make_empty
				else
						check
							does_not_have: ss.others ∌ ss.any -- {STS_SET} invariant
						end
					set_make_extended (ss.any, ss.others)
				end
			end
		end

feature -- Anchor

	family_structure_anchor,
	subfamily_structure_anchor,
	superfamily_structure_anchor: EXPOSED_SUBSET_FAMILY_STRUCTURE [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
