﻿note
	description: "[
		Implementation of {
			STP_COMPOSABLE_ORDERED_PAIR_PROPERTIES
				[STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
			}
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	COMPOSABLE_ORDERED_PAIR_PROPERTIES_RRR

inherit
	STP_COMPOSABLE_ORDERED_PAIR_PROPERTIES
		[STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
		rename
			eq_a as eq,
			eq_b as eq,
			eq_w as eq,
			current_universe_a as current_universe,
			current_universe_b as current_universe,
			current_universe_w as current_universe,
			ab_to_a as ab_to_r,
			ab_to_b as ab_to_r
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
			--| TODO: what about turning post-conditions into invariants?
		do
			eq := {STI_REAL_SET}.eq
		end

feature -- Access

	eq: STS_REAL_EQUALITY
			-- Equality for real numbers

	current_universe: STI_TRANSFORMABLE_SET [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
			-- <Precursor>
		once
			create Result.make_from_set ({STI_REAL_SET}.R)
		ensure then
			class
		end

feature -- Transformer

	ab_to_r: STI_TRANSFORMER [
		STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY], STS_REAL_NUMBER,
		STS_ORDERED_PAIR_EQUALITY [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY], STS_REAL_EQUALITY
		]
			-- Transformer between types derived from {STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]} and
			-- {STS_REAL_NUMBER}
		once
			create Result
		ensure then
			class
		end

feature {NONE} -- Implementation

	max_supersets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
