note
	description: "Implementation of {STP_HOMOGENEOUS_ORDERED_PAIR_PROPERTIES [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	HOMOGENEOUS_ORDERED_PAIR_PROPERTIES_I

inherit
	STP_HOMOGENEOUS_ORDERED_PAIR_PROPERTIES [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			ab_to_a as ab_to_i,
			ab_to_b as ab_to_i
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
			--| TODO: what about turning post-conditions into invariants?
		do
			create transformable_set_properties
			eq := transformable_set_properties.eq_a
		end

feature -- Access

	eq: STS_INTEGER_EQUALITY
			-- Equality for integer numbers

	current_universe: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]
			-- <Precursor>
		once
			create Result.make_from_set ({STI_INTEGER_SET}.Z)
		ensure then
			class
		end

	transformable_set_properties: TRANSFORMABLE_SET_PROPERTIES [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]
			-- Object that checks whether the properties verified within set theory hold for an implementation of
			-- {STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]}

feature -- Factory

	pair (p, q: STS_INTEGER_NUMBER): STI_RATIONAL_NUMBER
			-- The rational number `a' / `b'
		do
			create Result.make (p, q) -- TODO: What about the precondition?!
		end

feature -- Transformer

	ab_to_i: STI_TRANSFORMER [
		STS_ORDERED_PAIR [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY], STS_INTEGER_NUMBER,
		STS_ORDERED_PAIR_EQUALITY [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY], STS_INTEGER_EQUALITY
		]
			-- Transformer between types derived from {STS_ORDERED_PAIR [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]} and
			-- {STS_INTEGER_NUMBER}
		once
			create Result
		ensure then
			class
		end

feature {NONE} -- Implementation

	max_supersets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
