﻿note
	description: "Implementation of {STP_EQUALITY_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	EQUALITY_PROPERTIES [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STP_EQUALITY_PROPERTIES [A, EQ]
		redefine
			default_create,
			holds_ok
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
		do
			create set_properties
		end

feature -- Access

	current_universe: like set_properties.universe_anchor
			-- <Precursor>
		do
			Result := set_properties.current_universe
		end

	set_properties: SET_PROPERTIES [A, EQ]
			-- Object that checks whether the properties verified within set theory hold for an implementation of {STS_SET [A, EQ]}

feature -- Properties (Relationship)

	holds_ok (a, b: A; eq: EQ): BOOLEAN
			-- <Precursor>
		local
			s: STS_SET [A, EQ]
		do
			if set_properties.type_is_predefined_expanded (({A}).type_id) then
				s := set_properties.singleton (a) & b -- This makes `a' and `b' collectible by `current_universe'.
			end
			Result := Precursor {STP_EQUALITY_PROPERTIES}(a, b, eq)
		end

feature {NONE} -- Implementation

	max_supersets: NATURAL = 1_048_576
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
