note
	description: "Implementation of {STP_SET_TUPLE_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	SET_TUPLE_PROPERTIES [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STP_SET_TUPLE_PROPERTIES [A, EQ]
		undefine
			equals_ok,
			unequals_ok
		redefine
			default_create
		end

	N_TUPLE_PROPERTIES [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			o as o_s,
			eq as eq_s,
			unit as unit_s,
			current_universe as current_universe_s,
			unit_ok as unit_s_ok,
			singleton as set_singleton,
			universe_anchor as universe_s_anchor
		undefine
			mapped_ok
		redefine
			default_create,
			o_s,
			set_properties,
			tuple_anchor,
			universe_s_anchor
		end

feature {NONE} -- Initialization

	default_create
			-- <Precursor>
			--| todo: what about turning post-conditions into invariants?
		do
			Precursor {N_TUPLE_PROPERTIES}
			create unit.make_unit
		end

feature -- Access

	o_s: like universe_s_anchor.subfamily_anchor
			-- <Precursor>

	unit: like universe_s_anchor.family_union.n_tuple_anchor
			-- <Precursor>

	set_properties: SET_FAMILY_PROPERTIES [A, EQ]
			-- Object that checks whether the properties verified within set theory hold for an implementation of {SET_FAMILY}

feature -- Transformer

	set_to_natural: STI_TRANSFORMER [STS_SET [A, EQ], NATURAL, STS_SET_EQUALITY [A, EQ], STS_OBJECT_EQUALITY [NATURAL]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Anchor

	tuple_anchor: STI_SET_TUPLE [A, EQ]
			-- <Precursor>
		do
			Result := unit_s
		end

	universe_s_anchor: STI_SET_FAMILY [A, EQ]
			-- <Precursor>
		do
			Result := o_s
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
