﻿note
	description: "Implementation of {STP_TRANSFORMABLE_TUPLE_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

class
	TRANSFORMABLE_TUPLE_PROPERTIES [A, B, EQ_A -> STS_EQUALITY [A] create default_create end, EQ_B -> STS_EQUALITY [B] create default_create end]

inherit
	STP_TRANSFORMABLE_TUPLE_PROPERTIES [A, B, EQ_A, EQ_B]
		undefine
			equals_ok,
			unequals_ok,
			mapped_to_same_kind_ok
		redefine
			default_create,
			mapped_ok
		end

	N_TUPLE_PROPERTIES [A, EQ_A]
		rename
			o as o_a,
			unit as unit_a,
			eq as eq_a,
			current_universe as current_universe_a,
			mapped_ok as mapped_to_same_kind_ok,
			left_reduced_ok as left_reduced_to_term_like_ok,
			indexed_left_reduced_ok as indexed_left_reduced_to_term_like_ok,
			right_reduced_ok as right_reduced_to_term_like_ok,
			indexed_right_reduced_ok as indexed_right_reduced_to_term_like_ok,
			term_to_tuple as term_to_tuple_of_same_kind,
			universe_anchor as universe_a_anchor
		redefine
			default_create,
			o_a,
			set_properties,
			tuple_anchor
		end

feature {NONE} -- Initialization

	default_create
			-- <Precursor>
			--| todo: what about turning post-conditions into invariants?
		do
			Precursor {N_TUPLE_PROPERTIES}
			eq_b := set_properties.eq_b
			create unit_b.make_unit
		end

feature -- Access

	o_a: like universe_a_anchor.subset_anchor
			-- <Precursor>

	unit_b: like current_universe_b.n_tuple_anchor
			-- <Precursor>

	eq_b: EQ_B
			-- <Precursor>

	current_universe_b: like set_properties.current_universe_b
			-- <Precursor>
		do
			Result := set_properties.current_universe_b
		end

	set_properties: TRANSFORMABLE_SET_PROPERTIES [A, B, EQ_A, EQ_B]
			-- <Precursor>

feature -- Properties (Transformation)

	mapped_ok (t: STS_TRANSFORMABLE_TUPLE [A, B, EQ_A, EQ_B] f: FUNCTION [A, B]): BOOLEAN
			-- <Precursor>
		local
			s: STS_SET [B, EQ_B]
		do
			s := t.terms ↦ f -- This makes `f' (x) collectible by `current_universe_b', for every x ∈ `t'.`terms'.
			Result := Precursor {STP_TRANSFORMABLE_TUPLE_PROPERTIES}(t, f)
		end

feature -- Factory

	term_to_tuple: STI_TRANSFORMER [A, STS_N_TUPLE [B, EQ_B], EQ_A, STS_N_TUPLE_EQUALITY [B, EQ_B]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Anchor

	tuple_anchor: STI_TRANSFORMABLE_TUPLE [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			Result := unit_a
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
