note
	description: "Implementation of {STP_HOMOGENEOUS_ORDERED_PAIR_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	HOMOGENEOUS_ORDERED_PAIR_PROPERTIES [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STP_HOMOGENEOUS_ORDERED_PAIR_PROPERTIES [A, EQ]
		redefine
			default_create
		end

	ORDERED_PAIR_PROPERTIES [A, A, EQ, EQ]
		rename
			eq_a as eq,
			eq_b as eq,
			current_universe_a as current_universe,
			current_universe_b as current_universe,
			transformable_set_properties_ab as transformable_set_properties,
			transformable_set_properties_ba as transformable_set_properties,
			equals_ok as opp_equals_ok,
			composed_with_homogeneous_ok as composed_ok
		redefine
			default_create,
			eq,
			current_universe,
			transformable_set_properties
		end

feature {NONE} -- Initialization

	default_create
			-- <Precursor>
		do
			create transformable_set_properties
			eq := transformable_set_properties.eq_a
		end

feature -- Access

	eq: EQ
			-- Equality for objects like {A}

	current_universe: like transformable_set_properties.universe_a_anchor
			-- <Precursor>
		do
			Result := transformable_set_properties.current_universe_a
		end

	transformable_set_properties: TRANSFORMABLE_SET_PROPERTIES [A, A, EQ, EQ]
			-- Object that checks whether the properties verified within set theory hold for an implementation of {STS_TRANSFORMABLE_SET [A, A, EQ, EQ]}

feature -- Factory

	pair (a1, a2: A): STI_HOMOGENEOUS_ORDERED_PAIR [A, EQ]
			-- <Precursor>
		do
			create Result.make (a1, a2)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
