note
	description: "Implementation of {STP_ORDERED_PAIR_COMPOSER_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	ORDERED_PAIR_COMPOSER_PROPERTIES [
		W, A, B,
		EQ_W -> STS_EQUALITY [W] create default_create end,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	STP_ORDERED_PAIR_COMPOSER_PROPERTIES [W, A, B, EQ_W, EQ_A, EQ_B]
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
			--| TODO: what about turning post-conditions into invariants?
		do
			create set_properties_wb
		end

feature -- Access

	current_universe_w: like set_properties_wb.universe_a_anchor
			-- <Precursor>
		do
			Result := set_properties_wb.current_universe_a
		end

	current_universe_b: like set_properties_wb.current_universe_b
			-- <Precursor>
		do
			Result := set_properties_wb.current_universe_b
		end

	set_properties_wb: TRANSFORMABLE_SET_PROPERTIES [W, B, EQ_W, EQ_B]
		-- Object that checks whether the properties verified within set theory hold for an implementation of {STS_TRANSFORMABLE_SET [W, B, EQ_W, EQ_B]}

invariant

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
