note
	description: "Implementation of {STP_ORDERED_PAIR_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	ORDERED_PAIR_PROPERTIES [
		A, B,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	STP_ORDERED_PAIR_PROPERTIES [A, B, EQ_A, EQ_B]
		redefine
			default_create
		end

	TEST_LIMITS
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
			--| TODO: what about turning post-conditions into invariants?
		do
			create transformable_set_properties_ab
			create transformable_set_properties_ba
			eq_a := transformable_set_properties_ab.eq_a
			eq_b := transformable_set_properties_ab.eq_b
		end

feature -- Access

	eq_a: EQ_A
			-- <Precursor>

	eq_b: EQ_B
			-- <Precursor>

	current_universe_a: like transformable_set_properties_ab.universe_a_anchor
			-- <Precursor>
		do
			Result := transformable_set_properties_ab.current_universe_a
		end

	current_universe_b: like transformable_set_properties_ba.universe_a_anchor
			-- <Precursor>
		do
			Result := transformable_set_properties_ba.current_universe_a
		end

	transformable_set_properties_ab: TRANSFORMABLE_SET_PROPERTIES [A, B, EQ_A, EQ_B]
			-- Object that checks whether the properties verified within set theory hold for an implementation of {STS_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]}

	transformable_set_properties_ba: TRANSFORMABLE_SET_PROPERTIES [B, A, EQ_B, EQ_A]
			-- Object that checks whether the properties verified within set theory hold for an implementation of {STS_TRANSFORMABLE_SET [B, A, EQ_B, EQ_A}

feature -- Transformer

	ab_to_a: STI_TRANSFORMER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A, STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_A]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	ab_to_b: STI_TRANSFORMER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B, STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_B]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature {NONE} -- Implementation

	max_supersets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
