note
	description: "Implementation of {STP_SET_FAMILY_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	SET_FAMILY_PROPERTIES [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SET_OF_SETS_PROPERTIES [A, EQ]
		rename
			set_anchor as family_anchor
		undefine
			mapped_ok
		redefine
			family_anchor,
			universe_s_anchor
		end

	SET_PROPERTIES [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			o as o_s,
			o_ok as o_s_ok,
			current_universe as current_universe_s,
			empty_set_ok as empty_set_of_sets_ok,
			singleton as singleton_s,
			set_anchor as family_anchor,
			universe_anchor as universe_s_anchor
		undefine
			has_ok,
			with_ok,
			without_ok,
			subsets_ok,
			powerset_ok,
			united_ok,
			intersected_ok,
			subtracted_ok,
			subtracted_symmetricaly_ok,
			singleton_ok
		redefine
			family_anchor,
			universe_s_anchor
		end

feature -- Anchor

	family_anchor: STI_SET_FAMILY [A, EQ]
			-- Anchor for set families whose properties must be checked
		do
			Result := o_s
		end

	universe_s_anchor: STI_SET_FAMILY [A, EQ]
			-- <Precursor>
		do
			Result := o_s
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
