note
	description: "Implementation of {STP_SET_OF_ORDERED_PAIRS_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	SET_OF_ORDERED_PAIRS_PROPERTIES [
		A, B,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	STP_SET_OF_ORDERED_PAIRS_PROPERTIES [A, B, EQ_A, EQ_B]
		undefine
			default_create,
			mapped_ok
		end

	SET_PROPERTIES [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
		rename
			o as o_ab,
			eq as eq_ab,
			current_universe as current_universe_ab,
			pair as pair_of_pairs,
			universe_anchor as universe_ab_anchor
		undefine
			has_ok,
			with_ok,
			without_ok,
			subsets_ok,
			powerset_ok,
			united_ok,
			intersected_ok,
			subtracted_ok,
			subtracted_symmetricaly_ok,
			singleton_ok
		redefine
			set_anchor,
			universe_ab_anchor
		end

feature -- Anchor

	set_anchor,
	universe_ab_anchor: STI_SET_OF_ORDERED_PAIRS [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			Result := o_ab
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
