﻿note
	description: "Implementation of {STP_SET_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

class
	SET_PROPERTIES [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STP_SET_PROPERTIES [A, EQ]
		redefine
			default_create,
			has_ok,
			with_ok,
			without_ok,
			subsets_ok,
			powerset_ok,
			united_ok,
			intersected_ok,
			subtracted_ok,
			subtracted_symmetricaly_ok,
			mapped_ok,
			singleton_ok
		end

	TEST_LIMITS
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
			--| TODO: what about turning post-conditions into invariants?
		do
			create o.make_empty
			create unit.make_unit
			create eq
		end

feature -- Access

	o: like universe_anchor.subset_anchor
			-- <Precursor>

	unit: like universe_anchor.n_tuple_anchor
			-- <Precursor>

	eq: EQ
			-- <Precursor>

	current_universe: like universe_anchor
			-- <Precursor>
		local
			a_type_id: like {TYPE [A]}.type_id
			mem_map: HASH_TABLE [ARRAYED_LIST [ANY], INTEGER]
			estimated_universe_size: NATURAL
			check_ops: BOOLEAN
		do
			Result := o
--			if not ({A}).is_attached then -- TODO: "Non-separate" Void must be avoided, since it may require a "separate" Void when e.g. mapping via some
--										  -- f (Void).
--				if {A} /~ {separate A} then -- TODO: System crashes when an agent gets a "separate" Void actual argument.
--						check
--							has_default: ({A}).has_default -- {A} is a detachable type.
--							does_not_have: Result ∌ ({A}).default -- Result.is_empty
--						end
--					Result := Result.extended (({A}).default)
--				end
--			end
			a_type_id := ({detachable A}).type_id
			mem_map := {MEMORY}.memory_map
			if type_is_predefined_expanded (a_type_id) then
				across
					mem_map as al
				from
					Result := o
				loop
					if {ISE_RUNTIME}.type_conforms_to (al.key, ({detachable STS_ORDERED_PAIR [A, A, STS_EQUALITY [A], STS_EQUALITY [A]]}).type_id) then
						estimated_universe_size := estimated_universe_size + 2 * al.item.count.as_natural_32
						print (estimated_universe_size) print ('%N')
						if estimated_universe_size > {SETS_TESTS_RESOURCES_UNARY_N}.Max_asserted_elements then
							check_ops := {ISE_RUNTIME}.check_assert (False)
						end
							across
								al.item is x
							loop
								check
									ab: attached {STS_ORDERED_PAIR [A, A, STS_EQUALITY [A], STS_EQUALITY [A]]} x as ab
										-- Every object collected into al.item conforms to
										-- {detachable STS_ORDERED_PAIR [A, A, STS_EQUALITY [A], STS_EQUALITY [A]]}.
								then
									Result := Result & ab.a & ab.b
								end
							end
						if check_ops then
							check_ops := {ISE_RUNTIME}.check_assert (True)
						end
					elseif
						{ISE_RUNTIME}.type_conforms_to (
							al.key, ({detachable STS_ORDERED_PAIR [A, detachable ANY, STS_EQUALITY [A], STS_EQUALITY [detachable ANY]]}).type_id
							)
					then
						estimated_universe_size := estimated_universe_size + 2 * al.item.count.as_natural_32
						print (estimated_universe_size) print ('%N')
						if estimated_universe_size > {SETS_TESTS_RESOURCES_UNARY_N}.Max_asserted_elements then
							check_ops := {ISE_RUNTIME}.check_assert (False)
						end
							across
								al.item is x
							loop
								check
									ay: attached {STS_ORDERED_PAIR [A, detachable ANY, STS_EQUALITY [A], STS_EQUALITY [detachable ANY]]} x as ay
										-- Every object collected into al.item conforms to
										-- {detachable STS_ORDERED_PAIR [A, detachable ANY, STS_EQUALITY [A], STS_EQUALITY [detachable ANY]]}.
								then
									Result := Result & ay.a
								end
							end
						if check_ops then
							check_ops := {ISE_RUNTIME}.check_assert (True)
						end
					elseif
						{ISE_RUNTIME}.type_conforms_to (
							al.key, ({detachable STS_ORDERED_PAIR [detachable ANY, A, STS_EQUALITY [detachable ANY], STS_EQUALITY [A]]}).type_id
							)
					then
						estimated_universe_size := estimated_universe_size + 2 * al.item.count.as_natural_32
						print (estimated_universe_size) print ('%N')
						if estimated_universe_size > {SETS_TESTS_RESOURCES_UNARY_N}.Max_asserted_elements then
							check_ops := {ISE_RUNTIME}.check_assert (False)
						end
							across
								al.item is x
							loop
								check
									xb: attached {STS_ORDERED_PAIR [detachable ANY, A, STS_EQUALITY [detachable ANY], STS_EQUALITY [A]]} x as xb
										-- Every object collected into al.item conforms to
										-- {detachable STS_ORDERED_PAIR [detachable ANY, A, STS_EQUALITY [detachable ANY], STS_EQUALITY [A]]}.
								then
									Result := Result & xb.b
								end
							end
						if check_ops then
							check_ops := {ISE_RUNTIME}.check_assert (True)
						end
					elseif {ISE_RUNTIME}.type_conforms_to (al.key, ({detachable STS_SET [A, STS_EQUALITY [A]]}).type_id) then
						estimated_universe_size := estimated_universe_size + {SETS_TESTS_RESOURCES}.Max_count * al.item.count.as_natural_32
						print (estimated_universe_size) print ('%N')
						if estimated_universe_size > {SETS_TESTS_RESOURCES_UNARY_N}.Max_asserted_elements then
							check_ops := {ISE_RUNTIME}.check_assert (False)
						end
							across
								al.item is x
							loop
								check
									sa: attached {STS_SET [A, STS_EQUALITY [A]]} x as sa
										-- Every object collected into al.item conforms to {detachable STS_SET [A, STS_EQUALITY [A]]}.
								then
									Result := Result ∪ converted_set (sa)
								end
							end
						if check_ops then
							check_ops := {ISE_RUNTIME}.check_assert (True)
						end
					elseif {ISE_RUNTIME}.type_conforms_to (al.key, ({detachable STS_N_TUPLE [A, STS_EQUALITY [A]]}).type_id) then
						estimated_universe_size := estimated_universe_size + {SETS_TESTS_RESOURCES}.Max_count * al.item.count.as_natural_32
						print (estimated_universe_size) print ('%N')
						if estimated_universe_size > {SETS_TESTS_RESOURCES_UNARY_N}.Max_asserted_elements then
							check_ops := {ISE_RUNTIME}.check_assert (False)
						end
							across
								al.item is x
							loop
								check
									ta: attached {STS_N_TUPLE [A, STS_EQUALITY [A]]} x as ta
										-- Every object collected into al.item conforms to {detachable STS_N_TUPLE [A, STS_EQUALITY [A]]}.
								then
									Result := Result ∪ converted_set (ta.terms)
								end
							end
						if check_ops then
							check_ops := {ISE_RUNTIME}.check_assert (True)
						end
					end
				end
			else
				across
					mem_map as al
				loop
					if {ISE_RUNTIME}.type_conforms_to (al.key, a_type_id) then
						estimated_universe_size := estimated_universe_size + al.item.count.as_natural_32
						print (estimated_universe_size) print ('%N')
						if estimated_universe_size > 1_708 then -- TODO: Magic number!
							check_ops := {ISE_RUNTIME}.check_assert (False)
						end
							across
								al.item is x
							loop
								check
									a: attached {A} x as a -- {ISE_RUNTIME}.type_conforms_to (al.key, a_type_id)
								then
									Result := Result & a
								end
							end
						if check_ops then
							check_ops := {ISE_RUNTIME}.check_assert (True)
						end
					end
				end
			end
		end

feature -- Properties (Initialization)

	make_empty_ok: BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.make_empty?
		do
			check
				u: attached current_universe as u
				s: attached (create {like set_anchor}.make_empty) as s
				definition: s ≍ (u | agent (x: A): BOOLEAN do Result := False end)
				has_nothing: u |∀ agent s.does_not_have
				uniqueness: s ≍ o
				cardinality: # s = 0
			end
			Result := True
		end

	make_singleton_ok (a: A): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.make_singleton?
		do
			check
				u: attached if type_is_predefined_expanded (({A}).type_id) then
						current_universe & a -- Perhaps `a' is not in `u'.
					else
						current_universe
					end as u

				s: attached (create {like set_anchor}.make_singleton (a)) as s
				definition: s ≍ (u | agent u.equality_holds (?, a))
				exists_unique: s |∃! agent s.equality_holds (?, a)
				nothing_else: s |∀ agent s.equality_holds (?, a)
				is_not_empty: not s.is_empty
				any: eq (s.any, a)
				others: s.others ≍ o
				cardinality: # s = 1
			end
			Result := True
		end

	make_extended_ok (a: A; s: STS_SET [A, EQ]): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.make_extended?
		do
			if s ∌ a then
				check
					ext_set: attached (create {like set_anchor}.make_extended (a, s)) as ext_set
					definition: ext_set ≍ (s & a)
					decomposed: (ext_set / a) ≍ s
					cardinality: # ext_set = # s + 1
				end
			end
			Result := True
		end

feature -- Properties (Membership)

	has_ok (s: STS_SET [A, EQ]; a: A): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(s, a)
		end

feature -- Properties (Construction)

	with_ok (s: STS_SET [A, EQ]; a: A): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(s, a)
		end

	without_ok (s: STS_SET [A, EQ]; a: A): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(s, a)
		end

	extended_ok (s: STI_SET [A, EQ]; a: A): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.extended?
		do
			if s ∌ a then
				check
					definition: s.extended (a) ≍ (s & a)
					decomposed: (s.extended (a) / a) ≍ s
					cardinality: # s.extended (a) = # s + 1
				end
			end
			Result := True
		end

	batch_extended_ok (s0: STS_SET [A, EQ]; s: STI_SET [A, EQ]): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.batch_extended?
		do
			check
				cardinality: s.is_disjoint (s0) implies # s.batch_extended (s0) = # s + # s0
			end
			Result := True
		end

feature -- Properties (Operation)

	subsets_ok (a: A; s0, s1, s2: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(a, s0, s1, s2)
		end

	powerset_ok (a: A; s0, s1, s2: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(a, s0, s1, s2)
		end

	united_ok (a: A; s1, s2, s3, s4: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(a, s1, s2, s3, s4)
		end

	intersected_ok (a: A; s1, s2, s3, s4: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(a, s1, s2, s3, s4)
		end

	subtracted_ok (a: A; s1, s2, s3, s4, s5: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(a, s1, s2, s3, s4, s5)
		end

	subtracted_symmetricaly_ok (a: A; s1, s2, s3: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(a, s1, s2, s3)
		end

	singleton_crossed_tuples_ok (
		s: STI_SET [A, EQ]; x: A; ts: STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.singleton_crossed_tuples?
		do
			check
				u: attached if type_is_predefined_expanded (({A}).type_id) then
						 current_universe & -- Perhaps predefined expanded instances are not in `u'.
						 x ∪ {like tuple_to_set}.set_map (ts, agent {STS_N_TUPLE [A, EQ]}.terms).reduced (o, agent {STS_SET [A, EQ]}.united)
					else
						 current_universe
					end as u
				ns: attached {like tuple_to_natural}.set_map (
					ts, agent (t: STS_N_TUPLE [A, EQ]): NATURAL
						do
							Result := t.n + 1
						end
					) as ns
				m: attached {like natural_to_real_64}.set_reduction (
					ns, 0, agent (ia_u: STS_SET [A, EQ]; acc: REAL_64; n: NATURAL): REAL_64
						do
							Result := acc + (# ia_u) ^ n
						end (u, ?, ?)
					) as m
				definition: m ≤ Max_tuples implies s.singleton_crossed_tuples (x, ts) ≍ (
					{like natural_to_tuple_set}.set_reduction (
						ns, ts.o, agent (
							ia_u: STS_SET [A, EQ]; acc: STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]; n: NATURAL
							): STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							do
								Result := acc ∪ (ia_u ^ n)
							end (u, ?, ?)
						) | agent (t: STS_N_TUPLE [A, EQ]; ia_x: A; ia_ts: STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]): BOOLEAN
							do
								Result := (not t.is_unit and then eq (ia_x, t.first)) and ia_ts ∋ t.tail
							end (?, x, ts)
					)
				cardinality: # s.singleton_crossed_tuples (x, ts) = # ts
			end
			Result := True
		end

feature -- Properties (Transformation)

	mapped_ok (s: STS_SET [A, EQ]; f: FUNCTION [A, A]): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
			chk_mp: BOOLEAN
		do
			chk_mp := {ISE_RUNTIME}.check_assert (False)
				sa := s ↦ f -- This makes `f' (x) collectible by `current_universe', for every x ∈ `s'.
			chk_mp := {ISE_RUNTIME}.check_assert (chk_mp)
			Result := Precursor {STP_SET_PROPERTIES}(s, f)
		end

	reduced_ok (s: STI_SET [A, EQ]; left_most: A; f: FUNCTION [A, A, A]): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.reduced?
		do
			check
				definition: eq (s.reduced (left_most, f), s.as_tuple.left_reduced (left_most, f))
					-- NOTICE: This property applies to {STI_SET}.reduced implementation; other implementations need not comply to such a property. Please see
					-- the comment at {STS_SET}.reduced header.
			end
			Result := True
		end

feature -- Properties (Factory)

	singleton_ok (s: STS_SET [A, EQ]; a: A): BOOLEAN
			-- <Precursor>
		local
			sa: STS_SET [A, EQ]
		do
			if type_is_predefined_expanded (({A}).type_id) then
				sa := singleton (a) -- This makes `a' collectible by `current_universe'.
			end
			Result := Precursor {STP_SET_PROPERTIES}(s, a)
		end

	pair_ok (s: STI_SET [A, EQ]; a, b: A): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.pair?
		do
			check
				u: attached if type_is_predefined_expanded (({A}).type_id) then -- Perhaps `a' and `b' are not in `current_universe'.
					 	current_universe & a & b
					 else
					 	 current_universe
					end as u
				definition: (# u ^ 2) ≤ Max_elements implies s.pair (a, b).as_singleton ≍
					(× u).filtered_xy (agent (u.element_to_element).anded (agent s.equality_holds (?, a), ?, agent s.equality_holds (?, b), ?))
			end
			Result := True
		end

feature -- Properties (Predicate)

	subset_relation_holds_ok (s: STI_SET [A, EQ]; s1, s2, s3: STS_SET [A, EQ]): BOOLEAN
			-- Do the properties verified within set theory hold for {STI_SET}.subset_relation_holds?
		do
			check
				u: attached current_universe as u
				definition: s.subset_relation_holds (s1, s2) = (u |∀ agent implied (agent s1.has, agent s2.has, ?))
				by_difference: s.subset_relation_holds (s1, s2) = (s1 ∖ s2) ≍ o
				reflexive: s.subset_relation_holds (s1, s1)
				transitive: s.subset_relation_holds (s1, s2) and s.subset_relation_holds (s2, s3) implies s.subset_relation_holds (s1, s3)
				antisymmetric: s.subset_relation_holds (s1, s2) and s.subset_relation_holds (s2, s1) implies s1 ≍ s2
				everything_includes_o: s.subset_relation_holds (o, s1)
				u_includes_everything: s.subset_relation_holds (s1, u)
				equality: s1 ≍ s2 = (s.subset_relation_holds (s1, s2) and s.subset_relation_holds (s2, s1))
				o_includes_only_o: s.subset_relation_holds (s1, o) implies s1 ≍ o
				only_u_includes_u: s.subset_relation_holds (u, s1) implies s1 ≍ u
				cardinality: s.subset_relation_holds (s1, s2) implies # s1 ≤ # s2
			end
			Result := True
		end

feature -- Conversion

	converted_set (s: STS_SET [A, STS_EQUALITY [A]]): STI_SET [A, EQ]
			-- Set with every element in `s', but compared by {EQ}.
		local
			l_s: STS_SET [A, STS_EQUALITY [A]]
		do
			from
				Result := o
				l_s := s
			invariant
				every_element: (s ∖ l_s) |∀ agent Result.has
				nothing_else: # Result ≤ # (s ∖ l_s)
			until
				l_s.is_empty
			loop
				Result := Result & l_s.any
				l_s := l_s.others
			variant
				cardinality: (# l_s).as_integer_64
			end
		ensure
			every_element: s |∀ agent Result.has
			nothing_else: # Result ≤ # s
		end

feature -- Factory

	pair (x, y: A): STI_ORDERED_PAIR [A, A, EQ, EQ]
			-- <Precursor>
		do
			create Result.make (x, y)
		end

feature -- Predicate

	type_is_predefined_expanded (t_id: INTEGER): BOOLEAN
			-- Does `t_id' represent a predefined expanded type (i.e. INTEGER, CHAR, REAL etc.)?
		do
			Result := t_id = ({POINTER}).type_id or
				t_id = ({CHARACTER_8}).type_id or
				t_id = ({CHARACTER_32}).type_id or
				t_id = ({BOOLEAN}).type_id or
				t_id = ({INTEGER_8}).type_id or
				t_id = ({INTEGER_16}).type_id or
				t_id = ({INTEGER_32}).type_id or
				t_id = ({INTEGER_64}).type_id or
				t_id = ({NATURAL_8}).type_id or
				t_id = ({NATURAL_16}).type_id or
				t_id = ({NATURAL_32}).type_id or
				t_id = ({NATURAL_64}).type_id or
				t_id = ({REAL_32}).type_id or
				t_id = ({REAL_64}).type_id
		ensure
			definition: Result = (
				t_id = ({POINTER}).type_id or
				t_id = ({CHARACTER_8}).type_id or
				t_id = ({CHARACTER_32}).type_id or
				t_id = ({BOOLEAN}).type_id or
				t_id = ({INTEGER_8}).type_id or
				t_id = ({INTEGER_16}).type_id or
				t_id = ({INTEGER_32}).type_id or
				t_id = ({INTEGER_64}).type_id or
				t_id = ({NATURAL_8}).type_id or
				t_id = ({NATURAL_16}).type_id or
				t_id = ({NATURAL_32}).type_id or
				t_id = ({NATURAL_64}).type_id or
				t_id = ({REAL_32}).type_id or
				t_id = ({REAL_64}).type_id
				)
		end

feature -- Transformer

	set_to_set: STI_TRANSFORMER [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	element_to_pair: STI_TRANSFORMER [A, STS_ORDERED_PAIR [A, A, EQ, EQ], EQ, STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	element_to_pairs: STI_TRANSFORMER [
		A, STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
		EQ, STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
		]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	element_to_boolean: STI_TRANSFORMER [A, BOOLEAN, EQ, STS_OBJECT_EQUALITY [BOOLEAN]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	tuple_to_natural: STI_TRANSFORMER [STS_N_TUPLE [A, EQ], NATURAL, STS_N_TUPLE_EQUALITY [A, EQ], STS_OBJECT_EQUALITY [NATURAL]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	natural_to_real_64: STI_TRANSFORMER [NATURAL, REAL_64, STS_OBJECT_EQUALITY [NATURAL], STS_OBJECT_EQUALITY [REAL_64]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	natural_to_tuple_set: STI_TRANSFORMER [
		NATURAL,
		STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STS_OBJECT_EQUALITY [NATURAL],
		STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	element_to_set: STI_TRANSFORMER [A, STS_SET [A, EQ], EQ, STS_SET_EQUALITY [A, EQ]]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	element_to_sets: STI_TRANSFORMER [
		A, STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		EQ, STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

	tuple_to_set: STI_TRANSFORMER [
		STS_N_TUPLE [A, EQ], STS_SET [A, EQ],
		STS_N_TUPLE_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]
		]
			-- <Precursor>
		do
			create Result
		ensure then
			class
		end

feature -- Anchor

	set_anchor: STI_SET [A, EQ]
			-- Anchor for sets whose properties must be checked
		do
			Result := o
		end

	universe_anchor: STI_SET [A, EQ]
			-- <Precursor>
		do
			Result := o
		end

feature {NONE} -- Implementation

	max_asserted_elements: NATURAL
			-- <Precursor>
			--| TODO: Pull it up to a target-dependant class.
		once
			Result := 2_304 -- 2 ^ (2 ^ 3) * (3 ^ 2)
		ensure then
			class
		end

	max_elements: NATURAL
			-- <Precursor>
			--| TODO: Pull it up to a target-dependant class.
		once
			Result := 2_097_152 -- 2 ^ (2 ^ 4 + 1) * (4 ^ 2)
		ensure then
			class
		end

	max_asserted_subsets: NATURAL
			-- <Precursor>
			--| TODO: Pull it up to a target-dependant class.
		once
			Result := 256 -- 2 ^ 8
		ensure then
			class
		end

	max_subsets: NATURAL
			-- <Precursor>
			--| TODO: Pull it up to a target-dependant class.
		once
			Result := 131_072 -- 2 ^ 17
		ensure then
			class
		end

	max_tuples: NATURAL
			-- <Precursor>
			--| TODO: Pull it up to a target-dependant class.
		once
			Result := 46_656 -- 6 ^ 6
		ensure then
			class
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
