note
	description: "Implementation of {STP_SUBSET_FAMILY_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SUBSET_FAMILY_STRUCTURE_PROPERTIES [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	STP_SUBSET_FAMILY_STRUCTURE_PROPERTIES [A, EQ]
		undefine
			mapped_ok
		redefine
			default_create
		end

	ORDERED_PAIR_PROPERTIES [
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
		STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
		]
		rename
			eq_a as eq_ss,
			eq_b as eq_s,
			equals_ok as opp_equals_ok
		redefine
			default_create,
			eq_s
		end

	SUBSET_FAMILY_PROPERTIES [A, EQ]
		rename
			eq as eq_s,
			is_in_ok as set_is_ok,
			is_not_in_ok as set_is_not_in_ok,
			equals_ok as set_equals_ok,
			unequals_ok as set_unequals_ok,
			as_singleton_ok as set_as_singleton_ok,
			family_anchor as family_structure_anchor
		redefine
			default_create,
			eq_s,
			family_structure_anchor
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize current property checker
			--| todo: what about turning post-conditions into invariants?
		do
			Precursor {ORDERED_PAIR_PROPERTIES}
			Precursor {SUBSET_FAMILY_PROPERTIES}
		end

feature -- Access

	eq_s: STS_SET_EQUALITY [A, EQ]
			-- Equality for sets of elements like {A}

feature -- Anchor

	family_structure_anchor: EXPOSED_SUBSET_FAMILY_STRUCTURE [A, EQ]
			-- Anchor for subset-family structure whose properties must be checked
		do
			Result := o_s
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
