note
	description: "[
		{NUMBERS_TESTS_RESOURCES}, derived for {STS_COMPLEX_NUMBER} generic parameter, compared by {STS_NUMERIC_EQUALITY}.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	NUMBERS_TESTS_NUMERIC_RESOURCES_C

inherit
	NUMBERS_TESTS_RESOURCES [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		rename
			some_object_a as some_complex
		redefine
			on_prepare
		end

feature -- Access

--	Zero: STI_COMPLEX_NUMBER
--			-- The complex number 0 + 0i
--		once
--		ensure
--			class
--			real: Result.a.value = 0
--			imaginary: Result.b.value = 0
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create eq_a
		end

feature -- Predicate

	p_x (x: STS_COMPLEX_NUMBER): BOOLEAN
			-- <Precursor>
		do
			Result := (x.a + x.b).value.truncated_to_integer \\ 2 = 0
		ensure then
			class
		end

	p_x1_x2 (x1, x2: STS_COMPLEX_NUMBER): BOOLEAN
			-- <Precursor>
		do
			Result := (x1.a + x1.b).value.truncated_to_integer \\ 2 /= ((x1.a + x1.b).value.truncated_to_integer + (x2.a + x2.b).value.truncated_to_integer) \\ 2
		ensure then
			class
		end

feature -- Mapping

	f_x (x: STS_COMPLEX_NUMBER): STS_COMPLEX_NUMBER
			-- <Precursor>
		do
			Result := x + (create {STI_COMPLEX_NUMBER}.make ({NUMBERS_TESTS_RESOURCES_R}.f_x (x.a), {NUMBERS_TESTS_RESOURCES_R}.f_x (x.b)))
		ensure then
			class
		end

feature -- Reduction

	f_acc_x (acc, x: STS_COMPLEX_NUMBER): STS_COMPLEX_NUMBER
			-- <Precursor>
		do
			Result := acc - x
		ensure then
			class
		end

	f_acc_i_x (acc: STS_COMPLEX_NUMBER; a_i: NATURAL; x: STS_COMPLEX_NUMBER): STS_COMPLEX_NUMBER
			-- Function that reduces (`acc', `a_i', `x') to a value like `acc'
		do
			Result := f_acc_x (f_acc_x (acc, create {STI_COMPLEX_NUMBER}.make_from_native_natural (a_i)), x)
		ensure then
			class
		end

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL
			-- <Precursor>
		once
			Result := # C - 1
		ensure then
			class
		end

invariant
--	zero_real: Zero.a.value = 0
--	zero_imaginary: Zero.b.value = 0

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
