note
	description: "[
		{NUMBERS_TESTS_RESOURCES}, derived for {STS_RATIONAL_NUMBER} generic parameter, compared by
		{STS_NUMERIC_EQUALITY}.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	NUMBERS_TESTS_NUMERIC_RESOURCES_Q

inherit
	NUMBERS_TESTS_RESOURCES [STS_RATIONAL_NUMBER, STS_NUMERIC_EQUALITY [STS_RATIONAL_NUMBER]]
		rename
			some_object_a as some_rational
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create eq_a
		end

feature -- Predicate

	p_x (x: STS_RATIONAL_NUMBER): BOOLEAN
			-- <Precursor>
		do
			Result := (x.p + x.q).value \\ 2 = 0
		ensure then
			class
		end

	p_x1_x2 (x1, x2: STS_RATIONAL_NUMBER): BOOLEAN
			-- <Precursor>
		do
			Result := (x1.p + x1.q).value \\ 2 /= ((x1.p + x1.q).value + (x2.p + x2.q).value) \\ 2
		ensure then
			class
		end

feature -- Mapping

	f_x (x: STS_RATIONAL_NUMBER): STS_RATIONAL_NUMBER
			-- <Precursor>
		do
			Result := x + (create {STI_RATIONAL_NUMBER}.make ({NUMBERS_TESTS_RESOURCES_I}.f_x (x.p), {NUMBERS_TESTS_RESOURCES_I}.f_x (x.q)))
		ensure then
			class
		end

feature -- Reduction

	f_acc_x (acc, x: STS_RATIONAL_NUMBER): STS_RATIONAL_NUMBER
			-- <Precursor>
		do
			Result := acc - x
		ensure then
			class
		end

	f_acc_i_x (acc: STS_RATIONAL_NUMBER; a_i: NATURAL; x: STS_RATIONAL_NUMBER): STS_RATIONAL_NUMBER
			-- Function that reduces (`acc', `a_i', `x') to a value like `acc'
		do
			Result := f_acc_x (f_acc_x (acc, create {STI_RATIONAL_NUMBER}.make_from_native_natural (a_i)), x)
		ensure then
			class
		end

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL
			-- <Precursor>
		once
			Result := # C - 1 -- TODO: Take `Q' instead.
		ensure then
			class
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
