note
	description: "[
		{NUMBERS_TESTS_RESOURCES}, derived for {STS_REAL_NUMBER} generic parameter, compared by
		{STS_NUMERIC_EQUALITY}.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	NUMBERS_TESTS_NUMERIC_RESOURCES_R

inherit
	NUMBERS_TESTS_RESOURCES [STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		rename
			some_object_a as some_real
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create eq_a
		end

feature -- Predicate

	p_x (x: STS_REAL_NUMBER): BOOLEAN
			-- <Precursor>
		do
			Result := x.value.truncated_to_integer \\ 2 = 0
		ensure then
			class
		end

	p_x1_x2 (x1, x2: STS_REAL_NUMBER): BOOLEAN
			-- <Precursor>
		do
			Result := x1.value.truncated_to_integer \\ 2 /= (x1.value.truncated_to_integer + x2.value.truncated_to_integer) \\ 2
		ensure then
			class
		end

feature -- Mapping

	f_x (x: STS_REAL_NUMBER): STS_REAL_NUMBER
			-- <Precursor>
		do
			Result := x + (create {STI_REAL_NUMBER}.make (2))
		ensure then
			class
		end

feature -- Reduction

	f_acc_x (acc, x: STS_REAL_NUMBER): STS_REAL_NUMBER
			-- <Precursor>
		do
			Result := acc - x
		ensure then
			class
		end

	f_acc_i_x (acc: STS_REAL_NUMBER; i: NATURAL; x: STS_REAL_NUMBER): STS_REAL_NUMBER
			-- <Precursor>
		do
			Result := f_acc_x (f_acc_x (acc, create {STI_REAL_NUMBER}.make_from_native_natural (i)), x)
		ensure then
			class
		end

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL
			-- <Precursor>
		once
			Result := # R
		ensure then
			class
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
