﻿note
	description: "[
		{SETS_TESTS_RESOURCES_BINARY}, derived for {STS_INTEGER_NUMBER} and {STS_INTEGER_NUMBER} generic parameters, both compared by
		{STS_INTEGER_EQUALITY}.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SETS_TESTS_RESOURCES_BINARY_INT_INT

inherit
	SETS_TESTS_RESOURCES_BINARY [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]
		rename
			some_integer as some_native_integer,
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_object_a as some_integer
		undefine
			some_native_integer,
			some_element
		redefine
			on_prepare,
			some_pair_ab,
			same_pair_ab
--			some_preceding_pair_aa,
--			some_preceding_pair_ba,
--			some_preceding_pair_bb
		end

	NUMBERS_TESTS_RESOURCES_I
		rename
			f_x as f_x_to_same_kind,
			f_acc_x as f_acc_x_to_same_kind,
			f_x_acc as f_x_acc_to_same_kind,
			f_acc_i_x as f_acc_i_x_to_same_kind,
			f_i_x_acc as f_i_x_acc_to_same_kind
		undefine
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_transformer,
			some_pair_composer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a
		redefine
			on_prepare
		end

feature -- Access

	resources_b: NUMBERS_TESTS_RESOURCES_I
			-- Pool of features for integer numbers

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {NUMBERS_TESTS_RESOURCES_I}
			create resources_b
			create eq_b
		end

feature -- Factory (ordered pair)

	some_pair_ab: STS_ORDERED_PAIR [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]
			-- Randomly fetched polymorphic ordered pair of integer numbers
		do
			inspect
				next_random_item \\ 3
			when 0 then
				Result := some_expanded_rational
			when 1 then
--				Result := some_exposed_rational
				Result := some_expanded_rational
			when 2 then
				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}
			end
		end

	same_pair_ab (ab: STS_ORDERED_PAIR [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]): like some_pair_ab
			-- <Precursor>
			-- TODO: What about the preconditions?!
		do
			if ab.b ≍ One and next_random_item \\ 2 = 0 then
				inspect
					next_random_item \\ 2
				when 0 then
					create {like some_expanded_rational} Result.make_from_integer (ab.a)
				when 1 then
--					create {like some_exposed_rational} Result.make_from_integer (ab.a)
					create {like some_expanded_rational} Result.make_from_integer (ab.a)
				end
			else
				inspect
					next_random_item \\ 5
				when 0 then
					create {like some_expanded_rational} Result.make (ab.a, ab.b)
				when 1 then
					create {like some_expanded_rational} Result.make_from_expanded (ab.a, ab.b)
				when 2 then
--					create {like some_exposed_rational} Result.make (ab.a, ab.b)
					create {like some_expanded_rational} Result.make (ab.a, ab.b)
				when 3 then
--					create {like some_exposed_rational} Result.make_from_expanded (ab.a, ab.b)
					create {like some_expanded_rational} Result.make_from_expanded (ab.a, ab.b)
				when 4 then
					Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(ab)
				end
			end
		end

--	some_preceding_pair_aa (a: STS_INTEGER_NUMBER): like some_pair_aa
--			-- Randomly created polymorphic ordered pair in the form ({STS_INTEGER_NUMBER}, `a`), meant to "precede" another pair in the form
--			-- (`a`, y).
--			-- TODO: What about the preconditions?!
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				create {like some_expanded_rational} Result.make (some_integer, a)
--			when 1 then
----				create {like some_exposed_rational} Result.make (some_integer, a)
--				create {like some_expanded_rational} Result.make (some_integer, a)
--			when 2 then
--				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(a)
--			end
--		end

--	some_preceding_pair_ba (a: STS_INTEGER_NUMBER): like some_pair_ba
--			-- Randomly created polymorphic ordered pair in the form ({STS_INTEGER_NUMBER}, `a`), meant to "precede" another pair in the form
--			-- (`a`, y).
--			-- TODO: What about the preconditions?!
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				create {like some_expanded_rational} Result.make (some_integer, a)
--			when 1 then
----				create {like some_exposed_rational} Result.make (some_integer, a)
--				create {like some_expanded_rational} Result.make (some_integer, a)
--			when 2 then
--				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(a)
--			end
--		end

--	some_preceding_pair_bb (b: STS_INTEGER_NUMBER): like some_pair_bb
--			-- Randomly created polymorphic ordered pair in the form ({STS_INTEGER_NUMBER}, `b`), meant to "precede" another pair in the form
--			-- (`b`, y).
--			-- TODO: What about the preconditions?!
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				create {like some_expanded_rational} Result.make (some_integer, b)
--			when 1 then
----				create {like some_exposed_rational} Result.make (some_integer, b)
--				create {like some_expanded_rational} Result.make (some_integer, b)
--			when 2 then
--				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(b)
--			end
--		end

feature -- Mapping

	f_x (x: STS_INTEGER_NUMBER): STS_INTEGER_NUMBER
			-- Function that maps `x' to a {STS_INTEGER_NUMBER} value
		do
			Result := resources_b.f_x (x)
		end

feature -- Reduction

	f_acc_x (acc: STS_INTEGER_NUMBER; x: STS_INTEGER_NUMBER): STS_INTEGER_NUMBER
			-- <Precursor>
		do
			Result := resources_b.f_acc_x (acc, x)
		end

	f_acc_i_x (acc: STS_INTEGER_NUMBER; i: NATURAL; x: STS_INTEGER_NUMBER): STS_INTEGER_NUMBER
			-- Function that maps (`acc', `i', `x') to a {STS_INTEGER_NUMBER} value
		do
			Result := f_acc_x (f_acc_x (acc, create {STI_INTEGER_NUMBER}.make_from_native_natural (i)), x)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
