﻿note
	description: "[
		{SETS_TESTS_RESOURCES_BINARY}, derived for {STS_REAL_NUMBER} and {STS_REAL_NUMBER} generic parameters, both compared by
		{STS_REAL_EQUALITY}.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SETS_TESTS_RESOURCES_BINARY_RR

inherit
	SETS_TESTS_RESOURCES_BINARY [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
		rename
			some_integer as some_native_integer,
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_object_a as some_real
		undefine
			some_native_integer,
			some_element
		redefine
			on_prepare,
			some_pair_ab,
			same_pair_ab,
			some_preceding_pair_aa,
			some_preceding_pair_ba,
			some_preceding_pair_bb
		end

	NUMBERS_TESTS_RESOURCES_R
		rename
			f_x as f_x_to_same_kind,
			f_acc_x as f_acc_x_to_same_kind,
			f_x_acc as f_x_acc_to_same_kind,
			f_acc_i_x as f_acc_i_x_to_same_kind,
			f_i_x_acc as f_i_x_acc_to_same_kind
		undefine
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_transformer,
			some_pair_composer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a
		redefine
			on_prepare
		end

feature -- Access

--	zero: STI_INTEGER_NUMBER
--			-- The natural number 0
--		once
--		ensure
--			class
--		end

	resources_b: NUMBERS_TESTS_RESOURCES_R
			-- Pool of features for real numbers

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {NUMBERS_TESTS_RESOURCES_R}
			create resources_b
			create eq_b
		end

feature -- Factory (ordered pair)

	some_pair_ab: STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
			-- Randomly fetched polymorphic ordered pair of real numbers
		do
			inspect
				next_random_item \\ 3
			when 0 then
--				Result := some_expanded_complex -- TODO: Segmentation violation!
				Result := some_expanded_complex.as_ordered_pair
			when 1 then
--				Result := some_exposed_complex -- TODO: Segmentation violation!
				Result := some_exposed_complex.as_ordered_pair
			when 2 then
				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}
			end
		end

	same_pair_ab (ab: STS_ORDERED_PAIR [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]): like some_pair_ab
			-- <Precursor>
		do
			if ab.b ≍ Zero and next_random_item \\ 2 = 0 then
				inspect
					next_random_item \\ 2
				when 0 then
					create {like some_expanded_complex} Result.make_from_real (ab.a)
				when 1 then
					create {like some_exposed_complex} Result.make_from_real (ab.a)
				end
			else
				inspect
					next_random_item \\ 5
				when 0 then
					create {like some_expanded_complex} Result.make (ab.a, ab.b)
				when 1 then
					create {like some_expanded_complex} Result.make_from_expanded (ab.a, ab.b)
				when 2 then
					create {like some_exposed_complex} Result.make (ab.a, ab.b)
				when 3 then
					create {like some_exposed_complex} Result.make_from_expanded (ab.a, ab.b)
				when 4 then
					Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(ab)
				end
			end
				-- TODO: Segmentation violation!
			if attached {like some_expanded_complex} Result as exp_ab then
				Result := exp_ab.as_ordered_pair
			elseif attached {like some_exposed_complex} Result as exp_ab then
				Result := exp_ab.as_ordered_pair
			end
		end

	some_preceding_pair_aa (a: STS_REAL_NUMBER): like some_pair_aa
			-- Randomly created polymorphic ordered pair in the form ({STS_REAL_NUMBER}, `a`), meant to "precede" another pair in the form
			-- (`a`, y).
		do
			inspect
				next_random_item \\ 3
			when 0 then
				create {like some_expanded_complex} Result.make (some_real, a)
			when 1 then
				create {like some_exposed_complex} Result.make (some_real, a)
			when 2 then
				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(a)
			end
		end

	some_preceding_pair_ba (a: STS_REAL_NUMBER): like some_pair_ba
			-- Randomly created polymorphic ordered pair in the form ({STS_REAL_NUMBER}, `a`), meant to "precede" another pair in the form
			-- (`a`, y).
		do
			inspect
				next_random_item \\ 3
			when 0 then
				create {like some_expanded_complex} Result.make (some_real, a)
			when 1 then
				create {like some_exposed_complex} Result.make (some_real, a)
			when 2 then
				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(a)
			end
		end

	some_preceding_pair_bb (b: STS_REAL_NUMBER): like some_pair_bb
			-- Randomly created polymorphic ordered pair in the form ({STS_REAL_NUMBER}, `b`), meant to "precede" another pair in the form
			-- (`b`, y).
		do
			inspect
				next_random_item \\ 3
			when 0 then
				create {like some_expanded_complex} Result.make (some_real, b)
			when 1 then
				create {like some_exposed_complex} Result.make (some_real, b)
			when 2 then
				Result := Precursor {SETS_TESTS_RESOURCES_BINARY}(b)
			end
		end

feature -- Mapping

	f_x (x: STS_REAL_NUMBER): STS_REAL_NUMBER
			-- Function that maps `x' to a {STS_REAL_NUMBER} value
		do
			Result := resources_b.f_x (x)
		end

feature -- Reduction

	f_acc_x (acc: STS_REAL_NUMBER; x: STS_REAL_NUMBER): STS_REAL_NUMBER
			-- <Precursor>
		do
			Result := resources_b.f_acc_x (acc, x)
		end

	f_acc_i_x (acc: STS_REAL_NUMBER; i: NATURAL; x: STS_REAL_NUMBER): STS_REAL_NUMBER
			-- Function that maps (`acc', `i', `x') to a {STS_REAL_NUMBER} value
		do
			Result := f_acc_x (f_acc_x (acc, create {STI_INTEGER_NUMBER}.make_from_native_natural (i)), x)
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
