note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY} whose generic parameter is an ordered pair
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SETS_TESTS_RESOURCES_UNARY_AB [
		A, B,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	SETS_TESTS_RESOURCES_UNARY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
		rename
			eq_a as eq_ab,
			some_object_a as some_pair_ab,
			same_object_a as same_pair_ab,
			object_twin_a as pair_twin_ab,
			new_eq_a as new_eq_ab,
			new_reference_equality_a as new_reference_equality_ab,
			new_object_equality_a as new_object_equality_ab,
			new_reference_equality_aa as new_reference_equality_ab_ab,
			new_object_equality_aa as new_object_equality_ab_ab,
			new_pair_equality_aa as new_pair_equality_ab_ab,
			new_reference_equality_sa as new_reference_equality_sab,
			new_object_equality_sa as new_object_equality_sab,
			new_set_equality_a as new_set_equality_ab,
			new_reference_equality_ta as new_reference_equality_tab,
			new_object_equality_ta as new_object_equality_tab,
			new_n_tuple_equality_a as new_n_tuple_equality_ab,
			some_pair_aa as some_pair_ab_ab,
			new_pair_aa as new_pair_ab_ab,
			new_composable_pair_aaa as new_composable_pair_ab_ab_ab,
			new_homogeneous_pair_a as new_homogeneous_pair_ab,
			new_pair_a_ta as new_pair_ab_tab,
			new_references_a as new_references_ab,
			new_objects_a as new_objects_ab,
			some_set_a as some_set_ab,
			new_set_a as new_set_ab,
			new_transformable_set_aa as new_transformable_set_ab_ab,
			same_set_a as same_set_ab,
			new_references_aa as new_references_ab_ab,
			new_objects_aa as new_objects_ab_ab,
			new_math_set_aa as new_math_set_ab_ab,
			new_transformable_set_aa_a as new_transformable_set_ab_ab_ab,
			new_set_of_pairs_aa as new_set_of_pairs_ab_ab,
			some_set_sa as some_set_sab,
			some_references_sa as some_references_sab,
			new_references_sa as new_references_sab,
			some_objects_sa as some_objects_sab,
			new_objects_sa as new_objects_sab,
			some_math_set_sa as some_math_set_sab,
			new_math_set_sa as new_math_set_sab,
			new_transformable_set_sa_ta as new_transformable_set_sab_tab,
			some_set_of_sets_a as some_set_of_sets_ab,
			some_set_family_a as some_set_family_ab,
			new_set_family_a as new_set_family_ab,
			some_set_partition_a as some_set_partition_ab,
			some_direct_set_partition_a as some_direct_set_partition_ab,
			new_set_partition_a as new_set_partition_ab,
			partitioned_set_a as partitioned_set_ab,
			some_subset_family_a as some_subset_family_ab,
			some_direct_subset_family_a as some_direct_subset_family_ab,
			new_subset_family_a as new_subset_family_ab,
			some_set_ta as some_set_tab,
			some_references_ta as some_references_tab,
			new_references_ta as new_references_tab,
			some_objects_ta as some_objects_tab,
			new_objects_ta as new_objects_tab,
			some_math_set_ta as some_math_set_tab,
			new_math_set_ta as new_math_set_tab,
			new_transformable_set_ta_sa as new_transformable_set_tab_sab,
			new_pair_composer_aaa as new_pair_composer_ab_ab_ab,
			new_transformer_aa as new_transformer_ab_ab,
			some_n_tuple_a as some_n_tuple_ab,
			new_n_tuple_a as new_n_tuple_ab,
			new_transformable_tuple_aa as new_transformable_tuple_ab_ab,
			same_n_tuple_a as same_n_tuple_ab,
			new_n_tuple_sa as new_n_tuple_sab,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sab_tab,
			new_set_tuple_a as new_set_tuple_ab
		redefine
			some_equality,
			some_pair,
			same_pair_ab,
			some_set,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		end

feature -- Access

	eq_a: EQ_A
			-- Equality for objects like {A}

	eq_b: EQ_B
			-- Equality for objects like {B}

	resources_ab: SETS_TESTS_RESOURCES_BINARY [A, B, EQ_A, EQ_B]
			-- Pool of features for ordered pairs like ({A},{B})
		deferred
		end

feature -- Factory (object)

	some_object_a: A
			-- Randomly fetched object like {A}
		do
			Result := resources_ab.some_object_a
		end

	some_object_b: B
			-- Randomly fetched object like {B}
		do
			Result := resources_ab.some_object_b
		end

feature -- Factory (equality)

	some_equality: STS_EQUALITY [detachable separate ANY]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_ab.some_equality
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (ordered pair)

	some_pair: STS_ORDERED_PAIR [
		detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY], STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_ab.some_pair
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

	some_pair_ab: like resources_ab.some_pair_ab
			-- Randomly fetched polymorphic ordered pair like ({A}, {B})
		do
			Result := resources_ab.some_pair_ab
		end

	same_pair_ab (ab: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]): like some_pair_ab
			-- Ordered pair mathematically equal to `ab`, with type randomly chosen.
		do
			if attached {STI_ORDERED_PAIR [A, B, EQ_A, EQ_B]} ab as sti_ab then
				Result := resources_ab.same_pair_ab (sti_ab)
			else
				Result := resources_ab.same_pair_ab (ab)
			end
		end

feature -- Factory (set)

	some_set: STI_SET [detachable separate ANY, STS_EQUALITY [detachable separate ANY]]
			-- <Precursor>
		do
			inspect next_random_item \\ 2
			when 0 then
				Result := resources_ab.some_set
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (pair composer)

	some_pair_composer: STI_ORDERED_PAIR_COMPOSER [
		detachable separate ANY, detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY],
		STS_EQUALITY [detachable separate ANY],
		STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_ab.some_pair_composer
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (transformer)

	some_transformer: STI_TRANSFORMER [
		detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY], STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_ab.some_transformer
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (n-tuple)

	some_n_tuple: STI_N_TUPLE [detachable separate ANY, STS_EQUALITY [detachable separate ANY]]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_ab.some_n_tuple
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Predicate

	p_xy (x: A; y: B): BOOLEAN
			-- Predicate over (`x', `y')
		do
			Result := p_x (create {like resources_ab.new_pair_ab}.make (x, y))
		end

feature -- Mapping

	f_x (x: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]): STI_ORDERED_PAIR [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			create Result.make
 (resources_ab.f_x_to_same_kind (x.a), resources_ab.resources_b.f_x (x.b))
		end

feature -- Reduction

	f_acc_x (acc, x: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]): STI_ORDERED_PAIR [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			create Result.make (resources_ab.f_acc_x_to_same_kind (acc.a, x.a),
			resources_ab.resources_b.f_acc_x (acc.b, x.b)
			)
		end

	f_acc_i_x (
		acc: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]; i: NATURAL; x: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]
		): STI_ORDERED_PAIR [A, B, EQ_A, EQ_B]
			-- <Precursor>
		do
			create Result.make (resources_ab.f_acc_i_x_to_same_kind (acc.a, i, x.a),
			resources_ab.resources_b.f_acc_i_x (acc.b, i, x.b)
			)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
