﻿note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY} whose generic parameter is a set
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SETS_TESTS_RESOURCES_UNARY_SA [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SETS_TESTS_RESOURCES_UNARY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			eq_a as eq_sa,
			some_object_a as some_set_a,
			same_object_a as same_set_a,
			object_twin_a as set_twin_a,
			new_eq_a as new_eq_sa,
			new_reference_equality_a as new_reference_equality_sa,
			new_object_equality_a as new_object_equality_sa,
			new_reference_equality_aa as new_reference_equality_sa_sa,
			new_object_equality_aa as new_object_equality_sa_sa,
			new_pair_equality_aa as new_pair_equality_sa_sa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_set_equality_a as new_set_equality_sa,
			new_reference_equality_ta as new_reference_equality_tsa,
			new_object_equality_ta as new_object_equality_tsa,
			new_n_tuple_equality_a as new_n_tuple_equality_sa,
			some_pair_aa as some_pair_sa_sa,
			new_pair_aa as new_pair_sa_sa,
			new_composable_pair_aaa as new_composable_pair_sa_sa_sa,
			new_homogeneous_pair_a as new_homogeneous_pair_sa,
			new_pair_a_ta as new_pair_sa_tsa,
			new_references_a as new_references_sa,
			new_objects_a as new_objects_sa,
			some_set_a as some_set_sa,
			new_set_a as new_set_sa,
			new_transformable_set_aa as new_transformable_set_sa_sa,
			same_set_a as same_set_sa,
			new_references_aa as new_references_sa_sa,
			new_objects_aa as new_objects_sa_sa,
			new_math_set_aa as new_math_set_sa_sa,
			new_transformable_set_aa_a as new_transformable_set_sa_sa_sa,
			new_set_of_pairs_aa as new_set_of_pairs_sa_sa,
			some_set_sa as some_set_ssa,
			some_references_sa as some_references_ssa,
			new_references_sa as new_references_ssa,
			some_objects_sa as some_objects_ssa,
			new_objects_sa as new_objects_ssa,
			some_math_set_sa as some_math_set_ssa,
			new_math_set_sa as new_math_set_ssa,
			new_transformable_set_sa_ta as new_transformable_set_ssa_tsa,
			some_set_of_sets_a as some_set_of_sets_sa,
			some_set_family_a as some_set_family_sa,
			some_direct_set_family_a as some_direct_set_family_sa,
			new_set_family_a as new_set_family_sa,
			some_set_partition_a as some_set_partition_sa,
			some_direct_set_partition_a as some_direct_set_partition_sa,
			new_set_partition_a as new_set_partition_sa,
			partitioned_set_a as partitioned_set_sa,
			some_subset_family_a as some_subset_family_sa,
			some_direct_subset_family_a as some_direct_subset_family_sa,
			new_subset_family_a as new_subset_family_sa,
			same_subset_family_a as same_subset_family_sa,
			some_subset_family_structure_a as some_subset_family_structure_sa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_sa,
			new_subset_family_structure_a as new_subset_family_structure_sa,
			some_set_ta as some_set_tsa,
			some_references_ta as some_references_tsa,
			new_references_ta as new_references_tsa,
			some_objects_ta as some_objects_tsa,
			new_objects_ta as new_objects_tsa,
			some_math_set_ta as some_math_set_tsa,
			new_math_set_ta as new_math_set_tsa,
			new_transformable_set_ta_sa as new_transformable_set_tsa_ssa,
			new_pair_composer_aaa as new_pair_composer_sa_sa_sa,
			new_transformer_aa as new_transformer_sa_sa,
			some_n_tuple_a as some_n_tuple_sa,
			new_n_tuple_a as new_n_tuple_sa,
			new_transformable_tuple_aa as new_transformable_tuple_sa_sa,
			same_n_tuple_a as same_n_tuple_sa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_ssa_tsa,
			new_set_tuple_a as new_set_tuple_sa
		redefine
			some_equality,
			some_pair,
			some_set,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		end

feature -- Access

	resources_a: SETS_TESTS_RESOURCES_UNARY [A, EQ]
			-- Pool of features for objects like {A}
		deferred
		end

feature -- Factory (object)

	some_object_a: A
			-- Randomly fetched object like {A}
		do
			Result := resources_a.some_object_a
		end

feature -- Factory (equality)

	some_equality: STS_EQUALITY [detachable separate ANY]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_equality
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (ordered pair)

	some_pair: STS_ORDERED_PAIR [
		detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY], STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_pair
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (set)

	some_set: STI_SET [detachable separate ANY, STS_EQUALITY [detachable separate ANY]]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_set
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

	some_set_a: like resources_a.some_set_a
			-- Randomly fetched polymorphic set of elements like {A}, whose equality is checked by
			-- {EQ_A}.
		do
			Result := resources_a.some_set_a
		end

	same_set_a (s: STS_SET [A, EQ]): like some_set_a
			-- Set mathematically equal to `s`, with type randomly chosen.
		do
			if attached {STI_SET [A, EQ]} s as sti_s then
				Result := resources_a.same_set_a (sti_s)
			else
				Result := resources_a.same_set_a (s)
			end
		end

feature -- Factory (pair composer)

	some_pair_composer: STI_ORDERED_PAIR_COMPOSER [
		detachable separate ANY, detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY],
		STS_EQUALITY [detachable separate ANY],
		STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_pair_composer
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (transformer)

	some_transformer: STI_TRANSFORMER [
		detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY], STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_transformer
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (n-tuple)

	some_n_tuple: STI_N_TUPLE [detachable separate ANY, STS_EQUALITY [detachable separate ANY]]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_n_tuple
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Predicate

	p_x (x: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := # x \\ 2 = 0
		end

	p_x1_x2 (x1, x2: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := # x1 \\ 2 /= (# x1 + # x2) \\ 2
		end

	p_t (t: STS_N_TUPLE [A, EQ]): BOOLEAN
			-- Predicate over `t'
		do
			Result := # t.terms \\ 2 = 0
		end

feature -- Mapping

	f_x (x: STS_SET [A, EQ]): STS_SET [A, EQ]
			-- <Precursor>
		do
			Result := x ↦ agent resources_a.f_x
		end

feature -- Reduction

	f_acc_x (acc, x: STS_SET [A, EQ]): STS_SET [A, EQ]
			-- <Precursor>
		do
			if # acc > # x then
				Result := acc ∖ x
			else
				Result := acc ∪ x
			end
		end

	f_acc_i_x (acc: STS_SET [A, EQ]; i: NATURAL; x: STS_SET [A, EQ]): STS_SET [A, EQ]
			-- <Precursor>
		do
			if # acc > i then
				Result := f_acc_x (acc, x)
			else
				Result := f_acc_x (x, acc)
			end
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
