﻿note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY} whose generic parameter is an n-tuple
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SETS_TESTS_RESOURCES_UNARY_TA [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SETS_TESTS_RESOURCES_UNARY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		rename
			eq_a as eq_ta,
			some_object_a as some_n_tuple_a,
			same_object_a as same_n_tuple_a,
			object_twin_a as n_tuple_twin_a,
			new_eq_a as new_eq_ta,
			new_reference_equality_a as new_reference_equality_ta,
			new_object_equality_a as new_object_equality_ta,
			new_reference_equality_aa as new_reference_equality_ta_ta,
			new_object_equality_aa as new_object_equality_ta_ta,
			new_pair_equality_aa as new_pair_equality_ta_ta,
			new_reference_equality_sa as new_reference_equality_sta,
			new_object_equality_sa as new_object_equality_sta,
			new_set_equality_a as new_set_equality_ta,
			new_reference_equality_ta as new_reference_equality_tta,
			new_object_equality_ta as new_object_equality_tta,
			new_n_tuple_equality_a as new_n_tuple_equality_ta,
			some_pair_aa as some_pair_ta_ta,
			new_pair_aa as new_pair_ta_ta,
			new_composable_pair_aaa as new_composable_pair_ta_ta_ta,
			new_homogeneous_pair_a as new_homogeneous_pair_ta,
			new_pair_a_ta as new_pair_ta_tta,
			new_references_a as new_references_ta,
			new_objects_a as new_objects_ta,
			some_set_a as some_set_ta,
			new_set_a as new_set_ta,
			new_transformable_set_aa as new_transformable_set_ta_ta,
			same_set_a as same_set_ta,
			new_references_aa as new_references_ta_ta,
			new_objects_aa as new_objects_ta_ta,
			new_math_set_aa as new_math_set_ta_ta,
			new_transformable_set_aa_a as new_transformable_set_ta_ta_ta,
			new_set_of_pairs_aa as new_set_of_pairs_ta_ta,
			some_set_sa as some_set_sta,
			some_references_sa as some_references_sta,
			new_references_sa as new_references_sta,
			some_objects_sa as some_objects_sta,
			new_objects_sa as new_objects_sta,
			some_math_set_sa as some_math_set_sta,
			new_math_set_sa as new_math_set_sta,
			new_transformable_set_sa_ta as new_transformable_set_sta_tta,
			some_set_of_sets_a as some_set_of_sets_ta,
			some_set_family_a as some_set_family_ta,
			new_set_family_a as new_set_family_ta,
			some_set_partition_a as some_set_partition_ta,
			some_direct_set_partition_a as some_direct_set_partition_ta,
			new_set_partition_a as new_set_partition_ta,
			partitioned_set_a as partitioned_set_ta,
			some_subset_family_a as some_subset_family_ta,
			some_direct_subset_family_a as some_direct_subset_family_ta,
			new_subset_family_a as new_subset_family_ta,
			some_set_ta as some_set_tta,
			some_references_ta as some_references_tta,
			new_references_ta as new_references_tta,
			some_objects_ta as some_objects_tta,
			new_objects_ta as new_objects_tta,
			some_math_set_ta as some_math_set_tta,
			new_math_set_ta as new_math_set_tta,
			new_transformable_set_ta_sa as new_transformable_set_tta_sta,
			new_pair_composer_aaa as new_pair_composer_ta_ta_ta,
			new_transformer_aa as new_transformer_ta_ta,
			some_n_tuple_a as some_n_tuple_ta,
			new_n_tuple_a as new_n_tuple_ta,
			new_transformable_tuple_aa as new_transformable_tuple_ta_ta,
			same_n_tuple_a as same_n_tuple_ta,
			new_n_tuple_sa as new_n_tuple_sta,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sta_tta,
			new_set_tuple_a as new_set_tuple_ta
		redefine
			some_equality,
			some_pair,
			some_set,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			same_n_tuple_a
		end

feature -- Access

	resources_a: SETS_TESTS_RESOURCES_UNARY [A, EQ]
			-- Pool of features for objects like {A}
		deferred
		end

feature -- Factory (equality)

	some_equality: STS_EQUALITY [detachable separate ANY]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_equality
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (ordered pair)

	some_pair: STS_ORDERED_PAIR [
		detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY], STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_pair
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (set)

	some_set: STI_SET [detachable separate ANY, STS_EQUALITY [detachable separate ANY]]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_set
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (pair composer)

	some_pair_composer: STI_ORDERED_PAIR_COMPOSER [
		detachable separate ANY, detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY],
		STS_EQUALITY [detachable separate ANY],
		STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_pair_composer
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (transformer)

	some_transformer: STI_TRANSFORMER [
		detachable separate ANY, detachable separate ANY,
		STS_EQUALITY [detachable separate ANY], STS_EQUALITY [detachable separate ANY]
		]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_transformer
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

feature -- Factory (n-tuple)

	some_n_tuple: STI_N_TUPLE [detachable separate ANY, STS_EQUALITY [detachable separate ANY]]
			-- <Precursor>
		do
			inspect
				next_random_item \\ 2
			when 0 then
				Result := resources_a.some_n_tuple
			when 1 then
				Result := Precursor {SETS_TESTS_RESOURCES_UNARY}
			end
		end

	some_n_tuple_a: like resources_a.some_n_tuple_a
			-- Randomly fetched polymorphic n-tuple of terms like {A}
		do
			Result := resources_a.some_n_tuple_a
		end

	same_n_tuple_a (t: STS_N_TUPLE [A, EQ]): like some_n_tuple_a
			-- N-tuple mathematically equal to `t`, with type randomly chosen.
		do
			if attached {STI_N_TUPLE [A, EQ]} t as sti_t then
				Result := resources_a.same_n_tuple_a (sti_t)
			else
				Result := resources_a.same_n_tuple_a (t)
			end
		end

feature -- Predicate

	p_x (x: STS_N_TUPLE [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := x.n \\ 2 = 0
		end

	p_x1_x2 (x1, x2: STS_N_TUPLE [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := x1.n \\ 2 /= (x1.n + x2.n) \\ 2
		end

feature -- Mapping

	f_x (x: STS_N_TUPLE [A, EQ]): STS_N_TUPLE [A, EQ]
			-- <Precursor>
		do
			Result := x ↦ agent resources_a.f_x
		end

feature -- Reduction

	f_acc_x (acc, x: STS_N_TUPLE [A, EQ]): STS_N_TUPLE [A, EQ]
			-- <Precursor>
		do
			if acc.n > x.n then
				Result := acc.left_trimmed (x.n)
			else
				Result := acc + x
			end
		end

	f_acc_i_x (acc: STS_N_TUPLE [A, EQ]; i: NATURAL; x: STS_N_TUPLE [A, EQ]): STS_N_TUPLE [A, EQ]
			-- <Precursor>
		do
			if acc.n > i then
				Result := f_acc_x (acc, x)
			else
				Result := f_acc_x (x, acc)
			end
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
