note
	description: "[
		{SETS_TESTS_RESOURCES_BINARY}, derived for {NATURAL} and {detachable INTEGER_REF} generic parameters, both compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SETS_TESTS_RESOURCES_BINARY_NI

inherit
	SETS_TESTS_RESOURCES_BINARY [
	NATURAL, detachable INTEGER_REF,
	STS_OBJECT_EQUALITY [NATURAL], STS_OBJECT_EQUALITY [detachable INTEGER_REF]
	]
		rename
			some_object_a as some_natural
		redefine
			on_prepare
		end

	SETS_TESTS_RESOURCES_UNARY_N
		rename
			f_x as f_x_to_same_kind,
			f_acc_x as f_acc_x_to_same_kind,
			f_x_acc as f_x_acc_to_same_kind,
			f_acc_i_x as f_acc_i_x_to_same_kind,
			f_i_x_acc as f_i_x_acc_to_same_kind
		undefine
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_transformer,
			some_pair_composer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a
		redefine
			on_prepare
		end

feature -- Access

	resources_b: SETS_TESTS_RESOURCES_UNARY_I
			-- Pool of features for integer-number references

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_UNARY_N}
			create resources_b
			create eq_b
		end

feature -- Mapping

	f_x (x: NATURAL): detachable INTEGER_REF
			-- Function that maps `x' to a {detachable INTEGER_REF} value
		do
			Result := resources_b.f_x (x.as_integer_32)
		end

feature -- Reduction

	f_acc_x (acc: detachable INTEGER_REF; x: NATURAL): detachable INTEGER_REF
			-- Function that maps (`acc', `x') to a {detachable INTEGER_REF} value
		do
			Result := resources_b.f_acc_x (acc, x.as_integer_32)
		end

	f_acc_i_x (acc: detachable INTEGER_REF; i, x: NATURAL): detachable INTEGER_REF
			-- Function that maps (`acc', `i', `x') to a {detachable INTEGER_REF} value
		do
			Result := f_acc_x (f_acc_x (acc, i), x)
		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
