note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY}, derived for {detachable separate CHARACTER_REF} generic parameter, compared by object reference.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SETS_TESTS_RESOURCES_UNARY_C

inherit
	SETS_TESTS_RESOURCES_UNARY [detachable separate CHARACTER_REF, STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]]
		rename
			some_object_a as some_character_ref
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create eq_a
		end

feature -- Predicate
	-- TODO: explain.

	p_x (x: detachable separate CHARACTER_REF): BOOLEAN
			-- <Precursor>
		do
			if attached x then
				Result := x.natural_32_code \\ 2 = 0
			end
		end

	p_x1_x2 (x1, x2: detachable separate CHARACTER_REF): BOOLEAN
			-- <Precursor>
		do
			if attached x1 and attached x2 then
				Result := x1.natural_32_code \\ 2 /= (x1.natural_32_code + x2.natural_32_code) \\ 2
			end
		end

feature -- Mapping
	-- TODO: explain.

	f_x (x: detachable separate CHARACTER_REF): detachable separate CHARACTER_REF
			-- <Precursor>
		do
			if attached x then
					check
							-- class invariant: (Min_character.natural_32_code + Max_count - 1).is_valid_character_code
						valid_character: ((x |-| Min_character + 2) \\ Max_count.as_integer_32 + Min_character.code).is_valid_character_8_code
					end
				Result := ((x |-| Min_character + 2) \\ Max_count.as_integer_32 + Min_character.code).to_character_8
			end
		end

feature -- Reduction
	-- TODO: explain.

	f_acc_x (acc, x: detachable separate CHARACTER_REF): detachable separate CHARACTER_REF
			-- <Precursor>
		do
			if attached acc and attached x then
					check
							-- class invariant: (Min_character.natural_32_code + Max_count - 1).is_valid_character_code
						valid_character: ((acc |-| x.item).abs \\ Max_count.as_integer_32 + Min_character.code).is_valid_character_8_code
					end
				Result := ((acc |-| x.item).abs \\ Max_count.as_integer_32 + Min_character.code).to_character_8
			end
		end

	f_acc_i_x (acc: detachable separate CHARACTER_REF; i: NATURAL; x: detachable separate CHARACTER_REF): detachable separate CHARACTER_REF
			-- <Precursor>
		do
				check
						-- (i & {CHARACTER}.Max_value.as_natural_32) <= {CHARACTER_8}.max_value.to_natural_32
					valid_character: (i & {CHARACTER}.Max_value.as_natural_32).is_valid_character_8_code
				end
			Result := f_acc_x (f_acc_x (acc, (i & {CHARACTER}.Max_value.as_natural_32).to_character_8), x)
		end

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
