note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY}, derived for {detachable INTEGER_REF} generic parameter, compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SETS_TESTS_RESOURCES_UNARY_I

inherit
	SETS_TESTS_RESOURCES_UNARY [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		rename
			some_object_a as some_integer_ref
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create eq_a
		end

feature -- Predicate

	p_x (x: detachable INTEGER_REF): BOOLEAN
			-- <Precursor>
		do
			if attached x then
				Result := x.item \\ 2 = 0
			end
		end

	p_x1_x2 (x1, x2: detachable INTEGER_REF): BOOLEAN
			-- <Precursor>
		do
			if attached x1 and attached x2 then
				Result := x1.item \\ 2 /= (x1.item + x2.item) \\ 2
			end
		end

feature -- Mapping

	f_x (x: detachable INTEGER_REF): detachable INTEGER_REF
			-- <Precursor>
		do
			if attached x then
				Result := (x + 2) \\ Max_count.as_integer_32 - Max_count.as_integer_32 // 2
			end
		end

feature -- Reduction

	f_acc_x (acc, x: detachable INTEGER_REF): detachable INTEGER_REF
			-- <Precursor>
		do
			if attached acc and attached x then
				Result := (acc - x).abs \\ Max_count.as_integer_32 - Max_count.as_integer_32 // 2
			end
		end

	f_acc_i_x (acc: detachable INTEGER_REF; i: NATURAL; x: detachable INTEGER_REF): detachable INTEGER_REF
			-- <Precursor>
		do
			Result := f_acc_x (f_acc_x (acc, i.as_integer_32), x)
		end

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
