note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY}, derived for {NATURAL} generic parameter, compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SETS_TESTS_RESOURCES_UNARY_N

inherit
	SETS_TESTS_RESOURCES_UNARY [NATURAL, STS_OBJECT_EQUALITY [NATURAL]]
		rename
			some_object_a as some_natural
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create eq_a
		end

feature -- Predicate

	p_x (x: NATURAL): BOOLEAN
			-- <Precursor>
		do
			Result := x \\ 2 = 0
		end

	p_x1_x2 (x1, x2: NATURAL): BOOLEAN
			-- <Precursor>
		do
			Result := x1 \\ 2 /= (x1 + x2) \\ 2
		end

feature -- Mapping

	f_x (x: NATURAL): NATURAL
			-- <Precursor>
		do
			Result := (x + 2) \\ Max_count
		end

feature -- Reduction

	f_acc_x (acc, x: NATURAL): NATURAL
			-- <Precursor>
		do
			Result := (acc.max (x) - x) \\ Max_count
		end

	f_acc_i_x (acc, i, x: NATURAL): NATURAL
			-- <Precursor>
		do
			Result := f_acc_x (f_acc_x (acc, i), x)
		end

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
