note
	description: "Test suite for {STS_N_TUPLE_EQUALITY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	N_TUPLE_EQUALITY_TESTS [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	EQUALITY_TESTS [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		rename
			eq_a as eq_ta,
			some_object_a as some_n_tuple_a,
			same_object_a as same_n_tuple_a,
			object_twin_a as n_tuple_twin_a,
			new_eq_a as new_eq_ta,
			new_reference_equality_a as new_reference_equality_ta,
			new_object_equality_a as new_object_equality_ta,
			new_reference_equality_aa as new_reference_equality_ta_ta,
			new_object_equality_aa as new_object_equality_ta_ta,
			new_pair_equality_aa as new_pair_equality_ta_ta,
			new_reference_equality_sa as new_reference_equality_sta,
			new_object_equality_sa as new_object_equality_sta,
			new_set_equality_a as new_set_equality_ta,
			new_reference_equality_ta as new_reference_equality_tta,
			new_object_equality_ta as new_object_equality_tta,
			new_n_tuple_equality_a as new_n_tuple_equality_ta,
			some_pair_aa as some_pair_ta_ta,
			new_pair_aa as new_pair_ta_ta,
			new_composable_pair_aaa as new_composable_pair_ta_ta_ta,
			new_homogeneous_pair_a as new_homogeneous_pair_ta,
			new_pair_a_ta as new_pair_ta_tta,
			new_references_a as new_references_ta,
			new_objects_a as new_objects_ta,
			some_set_a as some_set_ta,
			new_set_a as new_set_ta,
			new_transformable_set_aa as new_transformable_set_ta_ta,
			same_set_a as same_set_ta,
			new_references_aa as new_references_ta_ta,
			new_objects_aa as new_objects_ta_ta,
			new_math_set_aa as new_math_set_ta_ta,
			new_transformable_set_aa_a as new_transformable_set_ta_ta_ta,
			new_set_of_pairs_aa as new_set_of_pairs_ta_ta,
			some_set_sa as some_set_sta,
			some_references_sa as some_references_sta,
			new_references_sa as new_references_sta,
			some_objects_sa as some_objects_sta,
			new_objects_sa as new_objects_sta,
			some_math_set_sa as some_math_set_sta,
			new_math_set_sa as new_math_set_sta,
			new_transformable_set_sa_ta as new_transformable_set_sta_tta,
			some_set_of_sets_a as some_set_of_sets_ta,
			some_set_family_a as some_set_family_ta,
			new_set_family_a as new_set_family_ta,
			some_set_partition_a as some_set_partition_ta,
			some_direct_set_partition_a as some_direct_set_partition_ta,
			new_set_partition_a as new_set_partition_ta,
			partitioned_set_a as partitioned_set_ta,
			some_subset_family_a as some_subset_family_ta,
			some_direct_subset_family_a as some_direct_subset_family_ta,
			new_subset_family_a as new_subset_family_ta,
			some_set_ta as some_set_tta,
			some_references_ta as some_references_tta,
			new_references_ta as new_references_tta,
			some_objects_ta as some_objects_tta,
			new_objects_ta as new_objects_tta,
			some_math_set_ta as some_math_set_tta,
			new_math_set_ta as new_math_set_tta,
			new_transformable_set_ta_sa as new_transformable_set_tta_sta,
			new_pair_composer_aaa as new_pair_composer_ta_ta_ta,
			new_transformer_aa as new_transformer_ta_ta,
			some_n_tuple_a as some_n_tuple_ta,
			new_n_tuple_a as new_n_tuple_ta,
			new_transformable_tuple_aa as new_transformable_tuple_ta_ta,
			same_n_tuple_a as same_n_tuple_ta,
			new_n_tuple_sa as new_n_tuple_sta,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sta_tta,
			new_set_tuple_a as new_set_tuple_ta
		undefine
			some_equality,
			some_pair,
			some_set,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			same_n_tuple_a
		redefine
			test_holds,
			test_holds_successively
		end

	SETS_TESTS_RESOURCES_UNARY_TA [A, EQ]

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_N_TUPLE_EQUALITY}.holds.
		note
			testing: "covers/{STS_N_TUPLE_EQUALITY}.holds"
		local
			eq: like equality_to_be_tested
			t1, t2: like some_n_tuple_a
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			t1 := some_n_tuple_a
			t2 := same_n_tuple_a (t1)
			assert ("same_n_tuple", eq (t1, t2))
			assert ("same_n_tuple_ok", properties.holds_ok (t1, t2, eq))
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively
			-- Test {STS_N_TUPLE_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_N_TUPLE_EQUALITY}.holds_successively"
		local
			eq: like equality_to_be_tested
			t1, t2, t3: like some_n_tuple_a
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			t1 := some_n_tuple_a
			t2 := same_n_tuple_a (t1)
			t3 := same_n_tuple_a (t2)
			assert ("same_n_tuple", eq.holds_successively (t1, t2, t3))
			assert ("same_n_tuples_ok", properties.holds_successively_ok (t1, t2, t3, eq))
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
