note
	description: "Test suite for {STS_OBJECT_EQUALITY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	OBJECT_EQUALITY_TESTS [A] -- todo: class gets unclickable after a factoring rename, until after closing its tab and issuing an F8.

inherit
	EQUALITY_TESTS [A, STS_OBJECT_EQUALITY [A]]
		redefine
			test_holds,
			test_holds_successively
		end

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_OBJECT_EQUALITY}.holds.
		note
			testing: "covers/{STS_OBJECT_EQUALITY}.holds"
		local
			eq: like equality_to_be_tested
			a1, a2: like some_object_a
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			a1 := some_object_a
			a2 := object_twin_a (a1)
			assert ("twin_object", eq (a1, a2))
			assert ("twin_object_ok", properties.holds_ok (a1, a2, eq))
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively.
			-- Test {STS_OBJECT_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_OBJECT_EQUALITY}.holds_successively"
		local
			eq: like equality_to_be_tested
			a1, a2, a3: like some_object_a
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			a1 := some_object_a
			a2 := object_twin_a (a1)
			a3 := object_twin_a (a2)
			assert ("twin_objects", eq.holds_successively (a1, a2, a3))
			assert ("twin_objects_ok", properties.holds_successively_ok (a1, a2, a3, eq))
		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
