note
	description: "Test suite for {STS_ORDERED_PAIR_EQUALITY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	ORDERED_PAIR_EQUALITY_TESTS [
		A, B,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	EQUALITY_TESTS [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
		rename
			eq_a as eq_ab,
			some_object_a as some_pair_ab,
			same_object_a as same_pair_ab,
			object_twin_a as pair_twin_ab,
			new_eq_a as new_eq_ab,
			new_reference_equality_a as new_reference_equality_ab,
			new_object_equality_a as new_object_equality_ab,
			new_reference_equality_aa as new_reference_equality_ab_ab,
			new_object_equality_aa as new_object_equality_ab_ab,
			new_pair_equality_aa as new_pair_equality_ab_ab,
			new_reference_equality_sa as new_reference_equality_sab,
			new_object_equality_sa as new_object_equality_sab,
			new_set_equality_a as new_set_equality_ab,
			new_reference_equality_ta as new_reference_equality_tab,
			new_object_equality_ta as new_object_equality_tab,
			new_n_tuple_equality_a as new_n_tuple_equality_ab,
			some_pair_aa as some_pair_ab_ab,
			new_pair_aa as new_pair_ab_ab,
			new_composable_pair_aaa as new_composable_pair_ab_ab_ab,
			new_homogeneous_pair_a as new_homogeneous_pair_ab,
			new_pair_a_ta as new_pair_ab_tab,
			new_references_a as new_references_ab,
			new_objects_a as new_objects_ab,
			some_set_a as some_set_ab,
			new_set_a as new_set_ab,
			new_transformable_set_aa as new_transformable_set_ab_ab,
			same_set_a as same_set_ab,
			new_references_aa as new_references_ab_ab,
			new_objects_aa as new_objects_ab_ab,
			new_math_set_aa as new_math_set_ab_ab,
			new_transformable_set_aa_a as new_transformable_set_ab_ab_ab,
			new_set_of_pairs_aa as new_set_of_pairs_ab_ab,
			some_set_sa as some_set_sab,
			some_references_sa as some_references_sab,
			new_references_sa as new_references_sab,
			some_objects_sa as some_objects_sab,
			new_objects_sa as new_objects_sab,
			some_math_set_sa as some_math_set_sab,
			new_math_set_sa as new_math_set_sab,
			new_transformable_set_sa_ta as new_transformable_set_sab_tab,
			some_set_of_sets_a as some_set_of_sets_ab,
			some_set_family_a as some_set_family_ab,
			new_set_family_a as new_set_family_ab,
			some_set_partition_a as some_set_partition_ab,
			some_direct_set_partition_a as some_direct_set_partition_ab,
			new_set_partition_a as new_set_partition_ab,
			partitioned_set_a as partitioned_set_ab,
			some_subset_family_a as some_subset_family_ab,
			some_direct_subset_family_a as some_direct_subset_family_ab,
			new_subset_family_a as new_subset_family_ab,
			some_set_ta as some_set_tab,
			some_references_ta as some_references_tab,
			new_references_ta as new_references_tab,
			some_objects_ta as some_objects_tab,
			new_objects_ta as new_objects_tab,
			some_math_set_ta as some_math_set_tab,
			new_math_set_ta as new_math_set_tab,
			new_transformable_set_ta_sa as new_transformable_set_tab_sab,
			new_pair_composer_aaa as new_pair_composer_ab_ab_ab,
			new_transformer_aa as new_transformer_ab_ab,
			some_n_tuple_a as some_n_tuple_ab,
			new_n_tuple_a as new_n_tuple_ab,
			new_transformable_tuple_aa as new_transformable_tuple_ab_ab,
			same_n_tuple_a as same_n_tuple_ab,
			new_n_tuple_sa as new_n_tuple_sab,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sab_tab,
			new_set_tuple_a as new_set_tuple_ab
		undefine
			some_equality,
			some_pair,
			some_set,
			same_pair_ab,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		redefine
			test_holds,
			test_holds_successively
		end

	SETS_TESTS_RESOURCES_UNARY_AB [A, B, EQ_A, EQ_B]

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_ORDERED_PAIR_EQUALITY}.holds.
		note
			testing: "covers/{STS_ORDERED_PAIR_EQUALITY}.holds"
		local
			eq: like equality_to_be_tested
			ab_1, ab_2: like some_pair_ab
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			ab_1 := some_pair_ab
			ab_2 := same_pair_ab (ab_1)
			assert ("same_pair", eq (ab_1, ab_2))
			assert ("same_pair_ok", properties.holds_ok (ab_1, ab_2, eq))
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively.
			-- Test {STS_ORDERED_PAIR_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_ORDERED_PAIR_EQUALITY}.holds_successively"
		local
			eq: like equality_to_be_tested
			ab_1, ab_2, ab_3: like some_pair_ab
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			ab_1 := some_pair_ab
			ab_2 := same_pair_ab (ab_1)
			ab_3 := same_pair_ab (ab_2)
			assert ("same_pair", eq.holds_successively (ab_1, ab_2, ab_3))
			assert ("same_pair_ok", properties.holds_successively_ok (ab_1, ab_2, ab_3, eq))
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
