note
	description: "Test suite for {STS_SET_EQUALITY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SET_EQUALITY_TESTS [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	EQUALITY_TESTS [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			eq_a as eq_sa,
			some_object_a as some_set_a,
			same_object_a as same_set_a,
			object_twin_a as set_twin_a,
			new_eq_a as new_eq_sa,
			new_reference_equality_a as new_reference_equality_sa,
			new_object_equality_a as new_object_equality_sa,
			new_reference_equality_aa as new_reference_equality_sa_sa,
			new_object_equality_aa as new_object_equality_sa_sa,
			new_pair_equality_aa as new_pair_equality_sa_sa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_set_equality_a as new_set_equality_sa,
			new_reference_equality_ta as new_reference_equality_tsa,
			new_object_equality_ta as new_object_equality_tsa,
			new_n_tuple_equality_a as new_n_tuple_equality_sa,
			some_pair_aa as some_pair_sa_sa,
			new_pair_aa as new_pair_sa_sa,
			new_composable_pair_aaa as new_composable_pair_sa_sa_sa,
			new_homogeneous_pair_a as new_homogeneous_pair_sa,
			new_pair_a_ta as new_pair_sa_tsa,
			new_references_a as new_references_sa,
			new_objects_a as new_objects_sa,
			some_set_a as some_set_sa,
			new_set_a as new_set_sa,
			new_transformable_set_aa as new_transformable_set_sa_sa,
			same_set_a as same_set_sa,
			new_references_aa as new_references_sa_sa,
			new_objects_aa as new_objects_sa_sa,
			new_math_set_aa as new_math_set_sa_sa,
			new_transformable_set_aa_a as new_transformable_set_sa_sa_sa,
			new_set_of_pairs_aa as new_set_of_pairs_sa_sa,
			some_set_sa as some_set_ssa,
			some_references_sa as some_references_ssa,
			new_references_sa as new_references_ssa,
			some_objects_sa as some_objects_ssa,
			new_objects_sa as new_objects_ssa,
			some_math_set_sa as some_math_set_ssa,
			new_math_set_sa as new_math_set_ssa,
			new_transformable_set_sa_ta as new_transformable_set_ssa_tsa,
			some_set_of_sets_a as some_set_of_sets_sa,
			some_set_family_a as some_set_family_sa,
			some_direct_set_family_a as some_direct_set_family_sa,
			new_set_family_a as new_set_family_sa,
			some_set_partition_a as some_set_partition_sa,
			some_direct_set_partition_a as some_direct_set_partition_sa,
			new_set_partition_a as new_set_partition_sa,
			partitioned_set_a as partitioned_set_sa,
			some_subset_family_a as some_subset_family_sa,
			some_direct_subset_family_a as some_direct_subset_family_sa,
			new_subset_family_a as new_subset_family_sa,
			same_subset_family_a as same_subset_family_sa,
			some_subset_family_structure_a as some_subset_family_structure_sa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_sa,
			new_subset_family_structure_a as new_subset_family_structure_sa,
			some_set_ta as some_set_tsa,
			some_references_ta as some_references_tsa,
			new_references_ta as new_references_tsa,
			some_objects_ta as some_objects_tsa,
			new_objects_ta as new_objects_tsa,
			some_math_set_ta as some_math_set_tsa,
			new_math_set_ta as new_math_set_tsa,
			new_transformable_set_ta_sa as new_transformable_set_tsa_ssa,
			new_pair_composer_aaa as new_pair_composer_sa_sa_sa,
			new_transformer_aa as new_transformer_sa_sa,
			some_n_tuple_a as some_n_tuple_sa,
			new_n_tuple_a as new_n_tuple_sa,
			new_transformable_tuple_aa as new_transformable_tuple_sa_sa,
			same_n_tuple_a as same_n_tuple_sa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_ssa_tsa,
			new_set_tuple_a as new_set_tuple_sa
		undefine
			some_equality,
			some_pair,
			some_set,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		redefine
			test_holds,
			test_holds_successively
		end

	SETS_TESTS_RESOURCES_UNARY_SA [A, EQ]

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_SET_EQUALITY}.holds.
		note
			testing: "covers/{STS_SET_EQUALITY}.holds"
		local
			eq: like equality_to_be_tested
			s1, s2: like some_set_a
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			s1 := some_set_a
			s2 := same_set_a (s1)
			assert ("same_set", eq (s1, s2))
			assert ("same_set_ok", properties.holds_ok (s1, s2, eq))
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively.
			-- Test {STS_SET_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_SET_EQUALITY}.holds_successively"
		local
			eq: like equality_to_be_tested
			s1, s2, s3: like some_set_a
		do
			Precursor {EQUALITY_TESTS}
			eq := equality_to_be_tested
			s1 := some_set_a
			s2 := same_set_a (s1)
			s3 := same_set_a (s2)
			assert ("same_set", eq.holds_successively (s1, s2, s3))
			assert ("same_sets_ok", properties.holds_successively_ok (s1, s2, s3, eq))
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
