﻿note
	description: "Test suite for {STI_SET_TUPLE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SET_TUPLE_TESTS [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	N_TUPLE_TESTS [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			test_term as test_set,
			test_terms as test_sets,
			test_terms_out as test_sets_out,
			test_term_out as test_set_out,
			test_unit as test_unit_s,
			test_converted_terms as test_converted_sets,
			test_predicate_holds_to_term as test_predicate_holds_to_set,
			test_terms_are_equal as test_sets_are_equal,
			test_reversed_terms_are_equal as test_reversed_sets_are_equal,
			test_indexed_term as test_indexed_set,
			test_appending_term_out as test_appending_set_out,
			eq_a as eq_sa,
			some_object_a as some_set_a,
			same_object_a as same_set_a,
			object_twin_a as set_twin_a,
			new_eq_a as new_eq_sa,
			new_reference_equality_a as new_reference_equality_sa,
			new_object_equality_a as new_object_equality_sa,
			new_reference_equality_aa as new_reference_equality_sa_sa,
			new_object_equality_aa as new_object_equality_sa_sa,
			new_pair_equality_aa as new_pair_equality_sa_sa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_set_equality_a as new_set_equality_sa,
			new_reference_equality_ta as new_reference_equality_tsa,
			new_object_equality_ta as new_object_equality_tsa,
			new_n_tuple_equality_a as new_n_tuple_equality_sa,
			some_pair_aa as some_pair_sa_sa,
			new_pair_aa as new_pair_sa_sa,
			new_composable_pair_aaa as new_composable_pair_sa_sa_sa,
			new_homogeneous_pair_a as new_homogeneous_pair_sa,
			new_pair_a_ta as new_pair_sa_tsa,
			new_references_a as new_references_sa,
			new_objects_a as new_objects_sa,
			some_set_a as some_set_sa,
			new_set_a as new_set_sa,
			new_transformable_set_aa as new_transformable_set_sa_sa,
			same_set_a as same_set_sa,
			new_references_aa as new_references_sa_sa,
			new_objects_aa as new_objects_sa_sa,
			new_math_set_aa as new_math_set_sa_sa,
			new_transformable_set_aa_a as new_transformable_set_sa_sa_sa,
			new_set_of_pairs_aa as new_set_of_pairs_sa_sa,
			some_set_sa as some_set_ssa,
			some_references_sa as some_references_ssa,
			new_references_sa as new_references_ssa,
			some_objects_sa as some_objects_ssa,
			new_objects_sa as new_objects_ssa,
			some_math_set_sa as some_math_set_ssa,
			new_math_set_sa as new_math_set_ssa,
			new_transformable_set_sa_ta as new_transformable_set_ssa_tsa,
			some_set_of_sets_a as some_set_of_sets_sa,
			some_set_family_a as some_set_family_sa,
			some_direct_set_family_a as some_direct_set_family_sa,
			new_set_family_a as new_set_family_sa,
			some_set_partition_a as some_set_partition_sa,
			some_direct_set_partition_a as some_direct_set_partition_sa,
			new_set_partition_a as new_set_partition_sa,
			partitioned_set_a as partitioned_set_sa,
			some_subset_family_a as some_subset_family_sa,
			some_direct_subset_family_a as some_direct_subset_family_sa,
			new_subset_family_a as new_subset_family_sa,
			same_subset_family_a as same_subset_family_sa,
			some_subset_family_structure_a as some_subset_family_structure_sa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_sa,
			new_subset_family_structure_a as new_subset_family_structure_sa,
			some_set_ta as some_set_tsa,
			some_references_ta as some_references_tsa,
			new_references_ta as new_references_tsa,
			some_objects_ta as some_objects_tsa,
			new_objects_ta as new_objects_tsa,
			some_math_set_ta as some_math_set_tsa,
			new_math_set_ta as new_math_set_tsa,
			new_transformable_set_ta_sa as new_transformable_set_tsa_ssa,
			new_pair_composer_aaa as new_pair_composer_sa_sa_sa,
			new_transformer_aa as new_transformer_sa_sa,
			some_n_tuple_a as some_n_tuple_sa,
			new_n_tuple_a as new_n_tuple_sa,
			new_transformable_tuple_aa as new_transformable_tuple_sa_sa,
			same_n_tuple_a as same_n_tuple_sa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_ssa_tsa,
			new_set_tuple_a as new_set_tuple_sa
		undefine
			some_equality,
			some_pair,
			some_set,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		redefine
			test_make_from_tuple,
			tuple_to_be_tested,
			tuple_from_ta,
			tuple_from_taa
		end

	SETS_TESTS_RESOURCES_UNARY_SA [A, EQ]

feature -- Access

	properties: SET_TUPLE_PROPERTIES [A, EQ]
			-- Object that checks the set-theory properties of {STI_SET_TUPLE}
		deferred
		end

feature -- Test routines (Initialization)

	test_make_from_tuple
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.make_from_tuple.
		note
			testing: "covers/{STI_N_TUPLE}.make_from_tuple"
			testing: "covers/{STI_SET_TUPLE}.make_from_tuple"
		do
			Precursor {N_TUPLE_TESTS}
			assert ("convert_from_sti_ta", attached tuple_from_sti_ta (some_n_tuple_sa))
			assert (
				"convert_from_sa_a",
				attached tuple_from_sa_a (create {STI_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]}.make_from_tuple (some_n_tuple_sa))
				)
			assert (
				"convert_from_sti_sa_a",
				attached tuple_from_sti_sa_a (
					create {STI_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert ("convert_from_sti_saa", attached tuple_from_sti_saa (new_transformable_tuple_sa_sa))
			assert ("convert_from_sa_ta", attached tuple_from_sa_ta (resources_a.new_transformable_tuple_sa_ta))
			assert ("convert_from_sti_sa_ta", attached tuple_from_sti_sa_ta (resources_a.new_transformable_tuple_sa_ta))
			assert (
				"convert_from_sa_ssa", attached tuple_from_sa_ssa (
					create {
						STI_TRANSFORMABLE_TUPLE [
							STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
							]
						}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert (
				"convert_from_sti_sa_ssa", attached tuple_from_sti_sa_ssa (
					create {
						STI_TRANSFORMABLE_TUPLE [
							STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
							]
						}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert (
				"convert_from_sa_sta", attached tuple_from_sa_sta (
					create {
						STI_TRANSFORMABLE_TUPLE [
							STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							]
						}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert (
				"convert_from_sti_sa_sta", attached tuple_from_sti_sa_sta (
					create {
						STI_TRANSFORMABLE_TUPLE [
							STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							]
						}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert (
				"convert_from_sa_aa", attached tuple_from_sa_aa (
					create {
						STI_TRANSFORMABLE_TUPLE [
							STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
							STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
							]
						}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert (
				"convert_from_sti_sa_aa", attached tuple_from_sti_sa_aa (
					create {
						STI_TRANSFORMABLE_TUPLE [
							STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
							STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
							]
						}.make_from_tuple (some_n_tuple_sa)
					)
				)
			assert ("convert_from_set_tuple", attached tuple_from_set_tuple (resources_a.new_set_tuple_a)
			)
		end

feature -- Test routines (Quantifier)

	test_for_all_tuples
			-- Test {STI_SET_TUPLE}.for_all_tuples.
		note
			testing: "covers/{STI_SET_TUPLE}.for_all_tuples"
		local
			sp: like resources_a.some_set_partition_a
			st: like tuple_to_be_tested
			p: PREDICATE [STS_N_TUPLE [A, EQ]]
			chk_ops: BOOLEAN
		do
			sp := resources_a.some_set_partition_a

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				if # sp \\ 2 = 1 then
					sp := sp.others
				end
				p := agent p_t
				st := tuple_to_be_tested.converted (sp.as_tuple)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("st_for_all_tuples_p", st.for_all_tuples (p))
			assert ("st_for_all_tuples_p_ok", properties.for_all_tuples_ok (st, p))

			st := tuple_to_be_tested
			assert ("for_all_tuples", st.for_all_tuples (p) implies True)
			assert ("for_all_tuples_ok", properties.for_all_tuples_ok (st, p))
		end

feature -- Test routines (Operation)

	test_n_ary_union
			-- Test {STS_SET_TUPLE}.n_ary_union.
			-- Test {STI_SET_TUPLE}.n_ary_union.
		note
			testing: "covers/{STS_SET_TUPLE}.n_ary_union"
			testing: "covers/{STI_SET_TUPLE}.n_ary_union"
		local
			st: like tuple_to_be_tested
		do
			st := tuple_to_be_tested
			assert ("n_ary_union", attached (⋃ st))
			assert ("n_ary_union_ok", properties.n_ary_union_ok (st))
		end

	test_n_ary_intersection
			-- Test {STS_SET_TUPLE}.n_ary_intersection.
			-- Test {STI_SET_TUPLE}.n_ary_intersection.
		note
			testing: "covers/{STS_SET_TUPLE}.n_ary_intersection"
			testing: "covers/{STI_SET_TUPLE}.n_ary_intersection"
		local
			st: like tuple_to_be_tested
		do
			st := tuple_to_be_tested
			assert ("n_ary_intersection", attached (⋂ st))
			assert ("n_ary_intersection_ok", properties.n_ary_intersection_ok (st))
		end

	test_n_ary_product
			-- Test {STI_SET_TUPLE}.n_ary_product.
		note
			testing: "covers/{STI_SET_TUPLE}.n_ary_product"
		local
			st: like tuple_to_be_tested
			chk_n, chk_prod: BOOLEAN
			n: NATURAL
		do
			st := tuple_to_be_tested

			chk_n := {ISE_RUNTIME}.check_assert (False)
				n := {
					STI_TRANSFORMER [STS_SET [A, EQ], NATURAL, STS_SET_EQUALITY [A, EQ], STS_OBJECT_EQUALITY [NATURAL]]
					}.tuple_left_reduction (
						st, 1, agent (acc: NATURAL; s: STS_SET [A, EQ]): NATURAL
							do
								Result := acc * # s
							end
						)
			chk_n := {ISE_RUNTIME}.check_assert (chk_n)

			if n ≤ max_tuples then
				if n > max_asserted_tuples then
					chk_prod := {ISE_RUNTIME}.check_assert (False)
				end
					assert ("n_ary_product", attached (∏ st))
				if chk_prod then
					chk_prod := {ISE_RUNTIME}.check_assert (True)
				end
			end

			assert ("n_ary_product_ok", properties.n_ary_product_ok (st))
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_SET_TUPLE}.o.
		note
			testing: "covers/{STI_SET_TUPLE}.o"
		do
			assert ("o", attached tuple_to_be_tested.o)
		end

	test_empty_set
			-- Test {STI_SET_TUPLE}.empty_set.
		note
			testing: "covers/{STI_SET_TUPLE}.empty_set"
		do
			assert ("empty_set", attached tuple_to_be_tested.empty_set)
		end

	test_unit
			-- Test {STI_SET_TUPLE}.unit.
		note
			testing: "covers/{STI_SET_TUPLE}.unit"
		do
			assert ("unit", attached tuple_to_be_tested.unit)
		end

	test_converted_set
			-- Test {STI_SET_TUPLE}.converted_set.
		note
			testing: "covers/{STI_SET_TUPLE}.converted_set"
		do
			assert ("converted_set", attached tuple_to_be_tested.converted_set (some_set_a))
		end

feature {NONE} -- Factory (element to be tested)

	tuple_to_be_tested: like resources_a.new_set_tuple_a
			-- Set tuple meant to be under tests
		do
			check
				new_st: attached {FUNCTION [like resources_a.new_set_tuple_a]} agent resources_a.new_set_tuple_a as new_st

					-- `some_direct_instance' and `resources_a'.`new_set_tuple_a' definitions
				st: attached {like resources_a.new_set_tuple_a} some_direct_instance (new_st) as st
				monomorphic: st.generating_type ~ {detachable like resources_a.new_set_tuple_a}
			then
				Result := st
			end
		end

feature {NONE} -- Conversion

	tuple_from_ta (ta: STS_N_TUPLE [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like tuple_to_be_tested
			-- <Precursor>
		do
			Result := ta
		end

	tuple_from_sti_ta (ta: STI_N_TUPLE [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like tuple_to_be_tested
			-- `ta' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := ta
		ensure
			same_tuple: Result ≍ ta
		end

	tuple_from_sa_a (
		sa_a: STS_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]
		): like tuple_to_be_tested
			-- `sa_a' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_a
		ensure
			same_tuple: Result ≍ sa_a
		end

	tuple_from_sti_sa_a (
		sa_a: STI_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]
		): like tuple_to_be_tested
			-- `sa_a' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_a
		ensure
			same_tuple: Result ≍ sa_a
		end

	tuple_from_taa (
		taa: STS_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]
		): like tuple_to_be_tested
			-- <Precursor>
		do
			Result := taa
		end

	tuple_from_sti_saa (
		saa: STI_TRANSFORMABLE_TUPLE [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]
		): like tuple_to_be_tested
			-- `saa' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := saa
		ensure
			same_tuple: Result ≍ saa
		end

	tuple_from_sa_ta (
		sa_ta: STS_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ], STS_N_TUPLE [A, EQ],
		STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]
		]
		): like tuple_to_be_tested
			-- `sa_ta' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_ta
		ensure
			same_tuple: Result ≍ sa_ta
		end

	tuple_from_sti_sa_ta (
		sa_ta: STI_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ], STS_N_TUPLE [A, EQ],
		STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]
		]
		): like tuple_to_be_tested
			-- `sa_ta' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_ta
		ensure
			same_tuple: Result ≍ sa_ta
		end

	tuple_from_sa_ssa (
		sa_ssa: STS_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		]
		): like tuple_to_be_tested
			-- `sa_ssa' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_ssa
		ensure
			same_tuple: Result ≍ sa_ssa
		end

	tuple_from_sti_sa_ssa (
		sa_ssa: STI_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		]
		): like tuple_to_be_tested
			-- `sa_ssa' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_ssa
		ensure
			same_tuple: Result ≍ sa_ssa
		end

	tuple_from_sa_sta (
		sa_sta: STS_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ],
		STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		]
		): like tuple_to_be_tested
			-- `sa_sta' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_sta
		ensure
			same_tuple: Result ≍ sa_sta
		end

	tuple_from_sti_sa_sta (
		sa_sta: STI_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ],
		STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		]
		): like tuple_to_be_tested
			-- `sa_sta' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_sta
		ensure
			same_tuple: Result ≍ sa_sta
		end

	tuple_from_sa_aa (
		sa_aa: STS_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ],
		STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
		]
		): like tuple_to_be_tested
			-- `sa_aa' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_aa
		ensure
			same_tuple: Result ≍ sa_aa
		end

	tuple_from_sti_sa_aa (
		sa_aa: STI_TRANSFORMABLE_TUPLE [
		STS_SET [A, EQ],
		STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
		]
		): like tuple_to_be_tested
			-- `sa_aa' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := sa_aa
		ensure
			same_tuple: Result ≍ sa_aa
		end

	tuple_from_set_tuple (st: STS_SET_TUPLE [A, EQ]): like tuple_to_be_tested
			-- `st' converted to a set tuple like `tuple_to_be_tested'
		do
			Result := st
		ensure
			same_tuple: Result ≍ st
		end

feature {NONE} -- Implementation

	max_tuples: NATURAL = 46_656 -- 6 ^ 6
			-- Maximum number of n-tuples to be checked within property feature tests

	max_asserted_tuples: NATURAL = 729 -- 3 ^ 6
			-- Maximum number of n-tuples to be checked with assertions enabled within feature tests
			--| todo: DRY

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
