﻿note
	description: "Test suite for {STI_PAIR_COMPOSER}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	ORDERED_PAIR_COMPOSER_TESTS [
		W, A, B,
		EQ_W -> STS_EQUALITY [W] create default_create end,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	ELEMENT_TESTS
		rename
			element_to_be_tested as composer_to_be_tested
		redefine
			composer_to_be_tested
		end

	SETS_TESTS_RESOURCES_TERNARY [W, A, B, EQ_W, EQ_A, EQ_B]

feature -- Access

	properties: ORDERED_PAIR_COMPOSER_PROPERTIES [W, A, B, EQ_W, EQ_A, EQ_B]
			-- Object that checks the set-theory properties of {STI_PAIR_COMPOSER}
		deferred
		end

feature -- Test routines (Operation)

	test_composite_pair
			-- Test {STI_ORDERED_PAIR_COMPOSER}.composite_pair.
		note
			testing: "covers/{STI_ORDERED_PAIR_COMPOSER}.composite_pair"
		local
			ab: like some_pair_ab
			pc_wab: like composer_to_be_tested
			wa: like some_preceding_pair_wa
			ww: like some_preceding_pair_ww
		do
			pc_wab := composer_to_be_tested
			ab := some_pair_ab
			wa := some_preceding_pair_wa (ab.a)
			assert ("ab_succeeds_wa", ab ≽ wa)
			assert ("ab_o_wa", attached pc_wab (ab, wa))
			ww := some_preceding_pair_ww (wa.a)
			assert ("wa_succeeds_ww", wa ≽ ww)
			assert ("bw_o_ab_o_wa_o_ww_ok", properties.composite_pair_ok (ab, pc_wab, wa, ww))

			pc_wab := composer_to_be_tested
			ab := some_pair_ab
			wa := some_preceding_pair_wa (some_object_a)
			assert ("composite_pair", ab ≽ wa implies attached pc_wab (ab, wa))
			ww := some_preceding_pair_ww (some_object_w)
			assert ("composite_pair_ok", properties.composite_pair_ok (ab, pc_wab, wa, ww))
		end

feature {NONE} -- Factory (element to be tested)

	composer_to_be_tested: like some_direct_pair_composer_wab
			-- Pair composer meant to be under tests
		do
			Result := some_direct_pair_composer_wab
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
