﻿note
	description: "Test suite for {STI_SET_FAMILY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SET_FAMILY_TESTS [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SET_OF_SETS_TESTS [A, EQ]
		rename
			test_sets_union as test_family_union,
			test_sets_intersection as test_family_intersection,
			test_o_s as test_o_f,
			test_empty_set_of_sets as test_empty_family,
			test_unit_s as test_unit_f,
			set_to_be_tested as set_family_to_be_tested,
			set_from_sa as family_from_sa,
			set_from_saa as family_from_saa
		end

	SET_TESTS [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			test_empty_set as test_empty_family,
			test_o as test_o_f,
			test_unit as test_unit_f,
			set_to_be_tested as set_family_to_be_tested,
			some_object_a as some_set_a,
			same_object_a as same_set_a,
			object_twin_a as set_twin_a,
			new_eq_a as new_eq_sa,
			new_reference_equality_a as new_reference_equality_sa,
			new_object_equality_a as new_object_equality_sa,
			new_reference_equality_aa as new_reference_equality_sa_sa,
			new_object_equality_aa as new_object_equality_sa_sa,
			new_pair_equality_aa as new_pair_equality_sa_sa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_set_equality_a as new_set_equality_sa,
			new_reference_equality_ta as new_reference_equality_tsa,
			new_object_equality_ta as new_object_equality_tsa,
			new_n_tuple_equality_a as new_n_tuple_equality_sa,
			some_pair_aa as some_pair_sa_sa,
			new_pair_aa as new_pair_sa_sa,
			new_composable_pair_aaa as new_composable_pair_sa_sa_sa,
			new_homogeneous_pair_a as new_homogeneous_pair_sa,
			new_pair_a_ta as new_pair_sa_tsa,
			new_references_a as new_references_sa,
			new_objects_a as new_objects_sa,
			some_set_a as some_set_sa,
			new_set_a as new_set_sa,
			new_transformable_set_aa as new_transformable_set_sa_sa,
			same_set_a as same_set_sa,
			new_references_aa as new_references_sa_sa,
			new_objects_aa as new_objects_sa_sa,
			new_math_set_aa as new_math_set_sa_sa,
			new_transformable_set_aa_a as new_transformable_set_sa_sa_sa,
			new_set_of_pairs_aa as new_set_of_pairs_sa_sa,
			some_set_sa as some_set_ssa,
			some_references_sa as some_references_ssa,
			new_references_sa as new_references_ssa,
			some_objects_sa as some_objects_ssa,
			new_objects_sa as new_objects_ssa,
			some_math_set_sa as some_math_set_ssa,
			new_math_set_sa as new_math_set_ssa,
			new_transformable_set_sa_ta as new_transformable_set_ssa_tsa,
			some_set_of_sets_a as some_set_of_sets_sa,
			some_set_family_a as some_set_family_sa,
			some_direct_set_family_a as some_direct_set_family_sa,
			new_set_family_a as new_set_family_sa,
			some_set_partition_a as some_set_partition_sa,
			some_direct_set_partition_a as some_direct_set_partition_sa,
			new_set_partition_a as new_set_partition_sa,
			partitioned_set_a as partitioned_set_sa,
			some_subset_family_a as some_subset_family_sa,
			some_direct_subset_family_a as some_direct_subset_family_sa,
			new_subset_family_a as new_subset_family_sa,
			same_subset_family_a as same_subset_family_sa,
			some_subset_family_structure_a as some_subset_family_structure_sa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_sa,
			new_subset_family_structure_a as new_subset_family_structure_sa,
			some_set_ta as some_set_tsa,
			some_references_ta as some_references_tsa,
			new_references_ta as new_references_tsa,
			some_objects_ta as some_objects_tsa,
			new_objects_ta as new_objects_tsa,
			some_math_set_ta as some_math_set_tsa,
			new_math_set_ta as new_math_set_tsa,
			new_transformable_set_ta_sa as new_transformable_set_tsa_ssa,
			new_pair_composer_aaa as new_pair_composer_sa_sa_sa,
			new_transformer_aa as new_transformer_sa_sa,
			some_n_tuple_a as some_n_tuple_sa,
			new_n_tuple_a as new_n_tuple_sa,
			new_transformable_tuple_aa as new_transformable_tuple_sa_sa,
			same_n_tuple_a as same_n_tuple_sa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_ssa_tsa,
			new_set_tuple_a as new_set_tuple_sa,
			test_converted_element as test_converted_member_set,
			set_from_sa as family_from_sa,
			set_from_saa as family_from_saa
		undefine
			some_equality,
			some_pair,
			some_set,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		redefine
			test_make_from_set,
			set_family_to_be_tested,
			family_from_sa,
			family_from_saa
		end

feature -- Access

	properties: SET_FAMILY_PROPERTIES [A, EQ]
			-- Object that checks the set-theory properties of {STI_SET_FAMILY}
		deferred
		end

feature -- Test routines (Initialization)

	test_make_from_set
			-- Test {STI_SET_FAMILY}.make_from_set.
		note
			testing: "covers/{STI_SET_FAMILY}.make_from_set"
		do
			Precursor {SET_TESTS}
			assert ("convert_from_sti_sa", attached family_from_sti_sa (some_set_sa))
			assert (
				"convert_from_sa_a",
				attached family_from_sa_a (create {STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]}.make_from_set (some_set_sa))
				)
			assert (
				"convert_from_sti_sa_a",
				attached family_from_sti_sa_a (create {STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]}.make_from_set (some_set_sa))
				)
			assert ("convert_from_sti_saa", attached family_from_sti_saa (new_transformable_set_sa_sa))
			assert ("convert_from_sa_ta", attached family_from_sa_ta (resources_a.new_transformable_set_sa_ta))
			assert ("convert_from_sti_sa_ta", attached family_from_sti_sa_ta (resources_a.new_transformable_set_sa_ta))
			assert (
				"convert_from_sa_ssa", attached family_from_sa_ssa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sti_sa_ssa", attached family_from_sti_sa_ssa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sa_sta", attached family_from_sa_sta (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sti_sa_sta", attached family_from_sti_sa_sta (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sa_aa", attached family_from_sa_aa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sti_sa_aa", attached family_from_sti_sa_aa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert ("convert_from_set_of_sets", attached family_from_set_of_sets (resources_a.some_set_of_sets_a))
			assert ("convert_from_set_family", attached family_from_sf (resources_a.some_set_family_a))
			assert ("convert_from_set_partition", attached family_from_set_partition (resources_a.some_set_partition_a))
			assert ("convert_from_sti_set_of_sets", attached family_from_sti_set_of_sets (resources_a.some_set_of_sets_a))
			assert ("convert_from_subset_family", attached family_from_subset_family (resources_a.some_subset_family_a))
			assert ("convert_from_sti_subset_family", attached family_from_sti_subset_family (resources_a.some_subset_family_a))
			assert ("convert_from_subset_family_structure", attached family_from_subset_family_structure (resources_a.some_subset_family_structure_a))
			assert ("convert_from_sti_subset_family_structure", attached family_from_sti_subset_family_structure (resources_a.some_subset_family_structure_a))
		end

feature {NONE} -- Factory (element to be tested)

	set_family_to_be_tested: like resources_a.some_direct_set_family_a
			-- Set family meant to be under tests
		do
			Result := resources_a.some_direct_set_family_a
		end

feature {NONE} -- Conversion

	family_from_sa (sa: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like set_family_to_be_tested
			-- `sa` converted to a family like `set_family_to_be_tested`
		do
			Result := sa
		end

	family_from_sti_sa (sa: STI_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like set_family_to_be_tested
			-- `sa' converted to a family like `set_family_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
		end

	family_from_sa_a (
		sa_a: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]
		): like set_family_to_be_tested
			-- `sa_a' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_a
		ensure
			same_set: Result ≍ sa_a
		end

	family_from_sti_sa_a (sa_a: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]): like set_family_to_be_tested
			-- `sa_a' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_a
		ensure
			same_set: Result ≍ sa_a
		end

	family_from_saa (saa: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]): like set_family_to_be_tested
			-- `saa` converted to a family like `set_family_to_be_tested`
		do
			Result := saa
		end

	family_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]): like set_family_to_be_tested
			-- `saa' converted to a family like `set_family_to_be_tested'
		do
			Result := saa
		ensure
			same_set: Result ≍ saa
		end

	family_from_sa_ta (
		sa_ta: STS_TRANSFORMABLE_SET [
		STS_SET [A, EQ], STS_N_TUPLE [A, EQ],
		STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]
		]
		): like set_family_to_be_tested
			-- `sa_ta' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_ta
		ensure
			same_set: Result ≍ sa_ta
		end

	family_from_sti_sa_ta (
		sa_ta: STI_TRANSFORMABLE_SET [
		STS_SET [A, EQ], STS_N_TUPLE [A, EQ],
		STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]
		]
		): like set_family_to_be_tested
			-- `sa_ta' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_ta
		ensure
			same_set: Result ≍ sa_ta
		end

	family_from_sa_ssa (
		sa_ssa: STS_TRANSFORMABLE_SET [
		STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		]
		): like set_family_to_be_tested
			-- `sa_ssa' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_ssa
		ensure
			same_set: Result ≍ sa_ssa
		end

	family_from_sti_sa_ssa (
		sa_ssa: STI_TRANSFORMABLE_SET [
		STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		]
		): like set_family_to_be_tested
			-- `sa_ssa' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_ssa
		ensure
			same_set: Result ≍ sa_ssa
		end

	family_from_sa_sta (
		sa_sta: STS_TRANSFORMABLE_SET [
		STS_SET [A, EQ],
		STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		]
		): like set_family_to_be_tested
			-- `sa_sta' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_sta
		ensure
			same_set: Result ≍ sa_sta
		end

	family_from_sti_sa_sta (
		sa_sta: STI_TRANSFORMABLE_SET [
		STS_SET [A, EQ],
		STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
		]
		): like set_family_to_be_tested
			-- `sa_sta' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_sta
		ensure
			same_set: Result ≍ sa_sta
		end

	family_from_sa_aa (
		sa_aa: STS_TRANSFORMABLE_SET [
		STS_SET [A, EQ],
		STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
		]
		): like set_family_to_be_tested
			-- `sa_aa' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_aa
		ensure
			same_set: Result ≍ sa_aa
		end

	family_from_sti_sa_aa (
		sa_aa: STI_TRANSFORMABLE_SET [
		STS_SET [A, EQ],
		STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
		STS_SET_EQUALITY [A, EQ],
		STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
		]
		): like set_family_to_be_tested
			-- `sa_aa' converted to a family like `set_family_to_be_tested'
		do
			Result := sa_aa
		ensure
			same_set: Result ≍ sa_aa
		end

	family_from_set_of_sets (ss: STS_SET_OF_SETS [A, EQ]): like set_family_to_be_tested
			-- `ss' converted to a family like `set_family_to_be_tested'
		do
			Result := ss
		ensure
			same_set: Result ≍ ss
		end

	family_from_sti_set_of_sets (ss: STI_SET_OF_SETS [A, EQ]): like set_family_to_be_tested
			-- `ss' converted to a family like `set_family_to_be_tested'
		do
			Result := ss
		ensure
			same_set: Result ≍ ss
		end

	family_from_sf (sf: STS_SET_FAMILY [A, EQ]): like set_family_to_be_tested
			-- `sf' converted to a family like `set_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
		end

	family_from_set_partition (sp: STS_SET_PARTITION [A, EQ]): like set_family_to_be_tested
			-- `sp' converted to a family like `set_family_to_be_tested'
		do
			Result := sp
		ensure
			same_set: Result ≍ sp
		end

	family_from_subset_family (sf: STS_SUBSET_FAMILY [A, EQ]): like set_family_to_be_tested
			-- `sf' converted to a family like `set_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
		end

	family_from_sti_subset_family (sf: STI_SUBSET_FAMILY [A, EQ]): like set_family_to_be_tested
			-- `sf' converted to a family like `set_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
		end

	family_from_subset_family_structure (sf: STS_SUBSET_FAMILY_STRUCTURE [A, EQ]): like set_family_to_be_tested
			-- `sf' converted to a family like `set_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
		end

	family_from_sti_subset_family_structure (sf: STS_SUBSET_FAMILY_STRUCTURE [A, EQ]): like set_family_to_be_tested
			-- `sf' converted to a family like `set_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
