﻿note
	description: "Test suite for {STI_SET_OF_ORDERED_PAIRS}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SET_OF_ORDERED_PAIRS_TESTS [
		A, B,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	SET_TESTS [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
		rename
			some_object_a as some_pair_ab,
			same_object_a as same_pair_ab,
			object_twin_a as pair_twin_ab,
			new_eq_a as new_eq_ab,
			new_reference_equality_a as new_reference_equality_ab,
			new_object_equality_a as new_object_equality_ab,
			new_reference_equality_aa as new_reference_equality_ab_ab,
			new_object_equality_aa as new_object_equality_ab_ab,
			new_pair_equality_aa as new_pair_equality_ab_ab,
			new_reference_equality_sa as new_reference_equality_sab,
			new_object_equality_sa as new_object_equality_sab,
			new_set_equality_a as new_set_equality_ab,
			new_reference_equality_ta as new_reference_equality_tab,
			new_object_equality_ta as new_object_equality_tab,
			new_n_tuple_equality_a as new_n_tuple_equality_ab,
			some_pair_aa as some_pair_ab_ab,
			new_pair_aa as new_pair_ab_ab,
			new_composable_pair_aaa as new_composable_pair_ab_ab_ab,
			new_homogeneous_pair_a as new_homogeneous_pair_ab,
			new_pair_a_ta as new_pair_ab_tab,
			new_references_a as new_references_ab,
			new_objects_a as new_objects_ab,
			some_set_a as some_set_ab,
			new_set_a as new_set_ab,
			new_transformable_set_aa as new_transformable_set_ab_ab,
			same_set_a as same_set_ab,
			new_references_aa as new_references_ab_ab,
			new_objects_aa as new_objects_ab_ab,
			new_math_set_aa as new_math_set_ab_ab,
			new_transformable_set_aa_a as new_transformable_set_ab_ab_ab,
			new_set_of_pairs_aa as new_set_of_pairs_ab_ab,
			some_set_sa as some_set_sab,
			some_references_sa as some_references_sab,
			new_references_sa as new_references_sab,
			some_objects_sa as some_objects_sab,
			new_objects_sa as new_objects_sab,
			some_math_set_sa as some_math_set_sab,
			new_math_set_sa as new_math_set_sab,
			new_transformable_set_sa_ta as new_transformable_set_sab_tab,
			some_set_of_sets_a as some_set_of_sets_ab,
			some_set_family_a as some_set_family_ab,
			new_set_family_a as new_set_family_ab,
			some_set_partition_a as some_set_partition_ab,
			some_direct_set_partition_a as some_direct_set_partition_ab,
			new_set_partition_a as new_set_partition_ab,
			partitioned_set_a as partitioned_set_ab,
			some_subset_family_a as some_subset_family_ab,
			some_direct_subset_family_a as some_direct_subset_family_ab,
			new_subset_family_a as new_subset_family_ab,
			some_set_ta as some_set_tab,
			some_references_ta as some_references_tab,
			new_references_ta as new_references_tab,
			some_objects_ta as some_objects_tab,
			new_objects_ta as new_objects_tab,
			some_math_set_ta as some_math_set_tab,
			new_math_set_ta as new_math_set_tab,
			new_transformable_set_ta_sa as new_transformable_set_tab_sab,
			new_pair_composer_aaa as new_pair_composer_ab_ab_ab,
			new_transformer_aa as new_transformer_ab_ab,
			some_n_tuple_a as some_n_tuple_ab,
			new_n_tuple_a as new_n_tuple_ab,
			new_transformable_tuple_aa as new_transformable_tuple_ab_ab,
			same_n_tuple_a as same_n_tuple_ab,
			new_n_tuple_sa as new_n_tuple_sab,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sab_tab,
			new_set_tuple_a as new_set_tuple_ab,
			test_converted_element as test_converted_pair
		undefine
			some_equality,
			some_pair,
			same_pair_ab,
			some_set,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		redefine
			test_make_from_set,
			set_to_be_tested,
			set_from_sa,
			set_from_saa
		end

	SETS_TESTS_RESOURCES_UNARY_AB [A, B, EQ_A, EQ_B]
		rename
			eq_ab as eq
		end

feature -- Access

	properties: SET_OF_ORDERED_PAIRS_PROPERTIES [A, B, EQ_A, EQ_B]
			-- Object that checks the set-theory properties of {STI_SET_OF_ORDERED_PAIRS}
		deferred
		end

feature -- Test routines (Initialization)

	test_make_from_set
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.make_from_set.
		note
			testing: "covers/{STI_SET}.make_from_set"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.make_from_set"
		do
			Precursor {SET_TESTS}
			assert ("convert_from_sti_sa", attached set_from_sti_sa (some_set_ab))
			assert ("convert_from_sti_saa", attached set_from_sti_saa (new_transformable_set_ab_ab))
			assert ("convert_from_sa1", attached set_from_sa1 (resources_ab.new_transformable_set_ab_a))
			assert ("convert_from_sti_sa1", attached set_from_sti_sa1 (resources_ab.new_transformable_set_ab_a))
			assert ("convert_from_sa2", attached set_from_sa2 (resources_ab.new_transformable_set_ab_b))
			assert ("convert_from_sti_sa2", attached set_from_sti_sa2 (resources_ab.new_transformable_set_ab_b))
			assert (
				"convert_from_sa21", attached set_from_sa21 (
					create {
						STI_TRANSFORMABLE_SET [
							STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
							STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
							STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
							STS_ORDERED_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
							]
						}.make_from_set (some_set_ab)
					)
				)
			assert (
				"convert_from_sti_sa21", attached set_from_sti_sa21 (
					create {
						STI_TRANSFORMABLE_SET [
							STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
							STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
							STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
							STS_ORDERED_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
							]
						}.make_from_set (some_set_ab)
					)
				)
			assert ("convert_from_abs", attached set_from_abs (resources_ab.some_set_of_pairs_ab))
		end

feature -- Test routines (Quantifier)

	test_exist_xy
			-- Test {STS_SET_OF_ORDERED_PAIRS}.exist_xy.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.exist_xy.
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.exist_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.exist_xy"
		local
			ab: like some_pair_ab
			s: like set_to_be_tested
			p: PREDICATE [A, B]
			chk_with: BOOLEAN
		do
			p := agent p_xy
			from
				ab := some_pair_ab
			until
				p (ab.a, ab.b)
			loop
				ab := some_pair_ab
			end

			chk_with := {ISE_RUNTIME}.check_assert (False)
				s := set_to_be_tested & ab
			chk_with := {ISE_RUNTIME}.check_assert (chk_with)

			assert ("s_exist_xy_p", s.exist_xy (p))
			assert ("s_exist_xy_p_ok", properties.exist_xy_ok (s, p))

			s := set_to_be_tested
			assert ("exist_xy", s.exist_xy (p) implies True)
			assert ("exist_xy_ok", properties.exist_xy_ok (s, p))
		end

	test_do_not_exist_xy
			-- Test {STS_SET_OF_ORDERED_PAIRS}.do_not_exist_xy.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.do_not_exist_xy.
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.do_not_exist_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.do_not_exist_xy"
		local
			s: like set_to_be_tested
			p: PREDICATE [A, B]
			chk_filt: BOOLEAN
		do
			p := agent p_xy
			s := set_to_be_tested

			chk_filt := {ISE_RUNTIME}.check_assert (False)
				s := s.filtered_xy (agent negated_xy (p, ?, ?))
			chk_filt := {ISE_RUNTIME}.check_assert (chk_filt)

			assert ("s_do_not_exist_xy_p", s.do_not_exist_xy (p))
			assert ("s_do_not_exist_xy_p_ok", properties.do_not_exist_xy_ok (s, p))

			s := set_to_be_tested
			assert ("do_not_exist_xy", s.do_not_exist_xy (p) implies True)
			assert ("do_not_exist_xy_ok", properties.do_not_exist_xy_ok (s, p))
		end

	test_for_all_xy
			-- Test {STS_SET_OF_ORDERED_PAIRS}.for_all_xy.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.for_all_xy.
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.for_all_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.for_all_xy"
		local
			s: like set_to_be_tested
			p: PREDICATE [A, B]
			chk_filt: BOOLEAN
		do
			p := agent p_xy

			chk_filt := {ISE_RUNTIME}.check_assert (False)
				s := set_to_be_tested.filtered_xy (p)
			chk_filt := {ISE_RUNTIME}.check_assert (chk_filt)
			
			assert ("s_for_all_xy_p", s.for_all_xy (p))
			assert ("s_for_all_xy_p_ok", properties.for_all_xy_ok (s, p))

			s := set_to_be_tested
			assert ("for_all_xy", s.for_all_xy (p) implies True)
			assert ("for_all_xy_ok", properties.for_all_xy_ok (s, p))
		end

feature -- Test routines (Operation)

	test_filtered_xy
			-- Test {STS_SET_OF_ORDERED_PAIRS}.filtered_xy.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.filtered_xy.
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.filtered_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.filtered_xy"
		local
			s: like set_to_be_tested
			p: PREDICATE [A, B]
		do
			p := agent p_xy
			s := set_to_be_tested
			assert ("filtered_xy", attached s.filtered_xy (p))
			assert ("filtered_xy_ok", properties.filtered_xy_ok (s, p))
		end

feature -- Test routines (Predicate)

	test_predicate_holds_to_xy
			-- Test {STS_SET_OF_ORDERED_PAIRS}.predicate_holds_to_xy.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.predicate_holds_to_xy.
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.predicate_holds_to_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.predicate_holds_to_xy"
		local
			p: PREDICATE [A, B]
			ab: like some_pair_ab
		do
			p := agent p_xy
			from
				ab := some_pair_ab
			until
				p (ab.a, ab.b)
			loop
				ab := some_pair_ab
			end
			assert ("p_x_holds_to_ab", {like set_to_be_tested}.predicate_holds_to_xy (p, ab))
			ab := some_pair_ab
			assert ("predicate_holds_to_xy", {like set_to_be_tested}.predicate_holds_to_xy (p, ab) implies True)
		end

feature {NONE} -- Factory (element to be tested)

	set_to_be_tested: like resources_ab.some_direct_set_of_pairs_ab
			-- Set of pairs meant to be under tests
		do
			Result := resources_ab.some_direct_set_of_pairs_ab
		end

feature {NONE} -- Conversion

	set_from_sa (sa: STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]): like set_to_be_tested
			-- <Precursor>
		do
			Result := sa
		end

	set_from_sti_sa (sa: STI_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]): like set_to_be_tested
			-- `sa' converted to a set like `set_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
		end

	set_from_saa (
		saa: STS_TRANSFORMABLE_SET [
			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
			STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
			]
		): like set_to_be_tested
			-- <Precursor>
		do
			Result := saa
		end

	set_from_sti_saa (
		saa: STI_TRANSFORMABLE_SET [
			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
			STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
			]
		): like set_to_be_tested
			-- `saa' converted to a set like `set_to_be_tested'
		do
			Result := saa
		ensure
			same_set: Result ≍ saa
		end

	set_from_sa1 (sa1: STS_TRANSFORMABLE_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A, STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_A]): like set_to_be_tested
			-- `sa1' converted to a set like `set_to_be_tested'
		do
			Result := sa1
		ensure
			same_set: Result ≍ sa1
		end

	set_from_sti_sa1 (sa1: STI_TRANSFORMABLE_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A, STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_A]): like set_to_be_tested
			-- `sa1' converted to a set like `set_to_be_tested'
		do
			Result := sa1
		ensure
			same_set: Result ≍ sa1
		end

	set_from_sa2 (sa2: STS_TRANSFORMABLE_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B, STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_B]): like set_to_be_tested
			-- `sa2' converted to a set like `set_to_be_tested'
		do
			Result := sa2
		ensure
			same_set: Result ≍ sa2
		end

	set_from_sti_sa2 (sa2: STI_TRANSFORMABLE_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B, STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_B]): like set_to_be_tested
			-- `sa2' converted to a set like `set_to_be_tested'
		do
			Result := sa2
		ensure
			same_set: Result ≍ sa2
		end

	set_from_sa21 (
		sa21: STS_TRANSFORMABLE_SET [
			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
			STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
			]
		): like set_to_be_tested
			-- `sa21' converted to a set like `set_to_be_tested'
		do
			Result := sa21
		ensure
			same_set: Result ≍ sa21
		end

	set_from_sti_sa21 (
		sa21: STI_TRANSFORMABLE_SET [
			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
			STS_ORDERED_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
			]
		): like set_to_be_tested
			-- `sa21' converted to a set like `set_to_be_tested'
		do
			Result := sa21
		ensure
			same_set: Result ≍ sa21
		end

	set_from_abs (abs: STS_SET_OF_ORDERED_PAIRS [A, B, EQ_A, EQ_B]): like set_to_be_tested
			-- `abs' converted to a set like `set_to_be_tested'
		do
			Result := abs
		ensure
			same_set: Result ≍ abs
		end

feature -- Predicate

	negated_xy (p: PREDICATE [A, B]; x: A; y: B): BOOLEAN
			-- Logical negation of `p` (`x`, `y'), i.e. is `p` (`x`, `y') false?
		do
			Result := not p (x, y)
		ensure
			class
			definition: Result = not p (x, y)
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
