﻿note
	description: "Test suite for {STI_SET_OF_SETS}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SET_OF_SETS_TESTS [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SET_TESTS [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			test_empty_set as test_empty_set_of_sets,
			test_o as test_o_s,
			test_unit as test_unit_s,
			some_object_a as some_set_a,
			same_object_a as same_set_a,
			object_twin_a as set_twin_a,
			new_eq_a as new_eq_sa,
			new_reference_equality_a as new_reference_equality_sa,
			new_object_equality_a as new_object_equality_sa,
			new_reference_equality_aa as new_reference_equality_sa_sa,
			new_object_equality_aa as new_object_equality_sa_sa,
			new_pair_equality_aa as new_pair_equality_sa_sa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_set_equality_a as new_set_equality_sa,
			new_reference_equality_ta as new_reference_equality_tsa,
			new_object_equality_ta as new_object_equality_tsa,
			new_n_tuple_equality_a as new_n_tuple_equality_sa,
			some_pair_aa as some_pair_sa_sa,
			new_pair_aa as new_pair_sa_sa,
			new_composable_pair_aaa as new_composable_pair_sa_sa_sa,
			new_homogeneous_pair_a as new_homogeneous_pair_sa,
			new_pair_a_ta as new_pair_sa_tsa,
			new_references_a as new_references_sa,
			new_objects_a as new_objects_sa,
			some_set_a as some_set_sa,
			new_set_a as new_set_sa,
			new_transformable_set_aa as new_transformable_set_sa_sa,
			same_set_a as same_set_sa,
			new_references_aa as new_references_sa_sa,
			new_objects_aa as new_objects_sa_sa,
			new_math_set_aa as new_math_set_sa_sa,
			new_transformable_set_aa_a as new_transformable_set_sa_sa_sa,
			new_set_of_pairs_aa as new_set_of_pairs_sa_sa,
			some_set_sa as some_set_ssa,
			some_references_sa as some_references_ssa,
			new_references_sa as new_references_ssa,
			some_objects_sa as some_objects_ssa,
			new_objects_sa as new_objects_ssa,
			some_math_set_sa as some_math_set_ssa,
			new_math_set_sa as new_math_set_ssa,
			new_transformable_set_sa_ta as new_transformable_set_ssa_tsa,
			some_set_of_sets_a as some_set_of_sets_sa,
			some_set_family_a as some_set_family_sa,
			some_direct_set_family_a as some_direct_set_family_sa,
			new_set_family_a as new_set_family_sa,
			some_set_partition_a as some_set_partition_sa,
			some_direct_set_partition_a as some_direct_set_partition_sa,
			new_set_partition_a as new_set_partition_sa,
			partitioned_set_a as partitioned_set_sa,
			some_subset_family_a as some_subset_family_sa,
			some_direct_subset_family_a as some_direct_subset_family_sa,
			new_subset_family_a as new_subset_family_sa,
			same_subset_family_a as same_subset_family_sa,
			some_subset_family_structure_a as some_subset_family_structure_sa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_sa,
			new_subset_family_structure_a as new_subset_family_structure_sa,
			some_set_ta as some_set_tsa,
			some_references_ta as some_references_tsa,
			new_references_ta as new_references_tsa,
			some_objects_ta as some_objects_tsa,
			new_objects_ta as new_objects_tsa,
			some_math_set_ta as some_math_set_tsa,
			new_math_set_ta as new_math_set_tsa,
			new_transformable_set_ta_sa as new_transformable_set_tsa_ssa,
			new_pair_composer_aaa as new_pair_composer_sa_sa_sa,
			new_transformer_aa as new_transformer_sa_sa,
			some_n_tuple_a as some_n_tuple_sa,
			new_n_tuple_a as new_n_tuple_sa,
			new_transformable_tuple_aa as new_transformable_tuple_sa_sa,
			same_n_tuple_a as same_n_tuple_sa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_ssa_tsa,
			new_set_tuple_a as new_set_tuple_sa,
			test_converted_element as test_converted_member_set
		undefine
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_eq,
			test_natural_as_integer,
			test_pair,
			test_unit_s,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			set_to_be_tested,
			some_equality,
			some_pair,
			some_set,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			set_from_sa,
			set_from_saa
		end

	SETS_TESTS_RESOURCES_UNARY_SA [A, EQ]
		rename
			eq_sa as eq
		end

feature -- Access

	properties: SET_OF_SETS_PROPERTIES [A, EQ]
			-- Object that checks the set-theory properties of {STI_SET_OF_SETS}
		deferred
		end

feature -- Test routines (Quality)

	test_is_partition
			-- Test {STS_SET_OF_SETS}.is_partition.
			-- Test {STI_SET_OF_SETS}.is_partition.
		note
			testing: "covers/{STS_SET_OF_SETS}.is_partition"
			testing: "covers/{STI_SET_OF_SETS}.is_partition"
		local
			s1, s2, si: like some_set_a
			ss: like set_to_be_tested
			j: NATURAL
			chk_ops: BOOLEAN
		do
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					s1 := some_set_a
					ss := set_to_be_tested.o_s
					si := s1
				invariant
					building_ss_up: (s1 ∖ si).is_partitioned (ss)
				until
					si.is_empty
				loop
					from
						s2 := some_set_a.o
							check
								positive: 0 < # si -- not si.is_empty
							end
						j := some_index_up_to (# si)
					invariant
						building_s2_up: s2 ≍ (s1 ∖ si ∖ (⋃ ss))
						si_emptiness: j > 0 implies not si.is_empty
						s2_emptiness: j = 0 implies not s2.is_empty
					until
						j = 0
					loop
							check
								si_is_not_empty: not si.is_empty -- j > 0
								s2_does_not_have_si_any: s2 ∌ si.any -- s2 ≍ (s1 ∖ si...)
							end
						s2 := s2.extended (si.any)
						si := si.others
						j := j - 1
					variant
						j: {like some_set_a}.natural_as_integer (j)
					end
						check
							ss_does_not_have_s2: ss ∌ s2 -- s2 ≍ (s1 ∖ si ∖ (⋃ ss)); j = 0 implies not s2.is_empty.
						end
					ss := ss.extended (s2)
				variant
					cardinality: {like some_set_a}.natural_as_integer (# si)
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("ss_is_partition", ss.is_partition)
			assert ("ss_is_partition_ok", properties.is_partition_ok (ss))

			ss := set_to_be_tested
			assert ("is_partition", ss.is_partition implies True)
			assert ("is_partition_ok", properties.is_partition_ok (ss))
		end

	test_member_sets_are_disjoint
			-- Test {STS_SET_OF_SETS}.member_sets_are_disjoint.
			-- Test {STI_SET_OF_SETS}.member_sets_are_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.member_sets_are_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.member_sets_are_disjoint"
		local
			s1, s2, si: like some_set_a
			ss: like set_to_be_tested
			j: NATURAL
			chk_ops: BOOLEAN
		do
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					s1 := some_set_a
					ss := set_to_be_tested.o_s
					si := s1
				invariant
					building_ss_up: ⋃ ss ≍ (s1 ∖ si)
					ss_member_sets_are_disjoint: ss.member_sets_are_disjoint
				until
					si.is_empty
				loop
					from
						s2 := some_set_a.o
						j := some_count.min (# si)
					invariant
						building_s2_up: s2 ≍ (s1 ∖ si ∖ (⋃ ss))
						si_emptiness: j > 0 implies not si.is_empty
					until
						j = 0
					loop
							check
								si_is_not_empty: not si.is_empty -- <== j > 0
								s2_does_not_have_si_any: s2 ∌ si.any -- s2 ≍ (s1 ∖ si...)
							end
						s2 := s2.extended (si.any)
						si := si.others
						j := j - 1
					variant
						j: {like some_set_a}.natural_as_integer (j)
					end
					ss := ss & s2
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("ss_member_sets_are_disjoint", ss.member_sets_are_disjoint)

			assert ("member_sets_are_disjoint", set_to_be_tested.member_sets_are_disjoint implies True)
		end

feature -- Test routines (Relationship)

	test_set_is_disjoint
			-- Test {STS_SET_OF_SETS}.set_is_disjoint.
			-- Test {STI_SET_OF_SETS}.set_is_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.set_is_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.set_is_disjoint"
		local
			ss: like set_to_be_tested
			s: like some_set_a
			chk_ops: BOOLEAN
		do
			ss := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∖ (⋃ ss)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("ss_set_is_disjoint_s", ss.set_is_disjoint (s))
			assert ("ss_set_is_disjoint_s_ok", properties.set_is_disjoint_ok (s, ss))

			ss := set_to_be_tested
			s := some_set_a
			assert ("set_is_disjoint", ss.set_is_disjoint (s) implies True)
			assert ("set_is_disjoint_ok", properties.set_is_disjoint_ok (s, ss))
		end

	test_sets_are_disjoint
			-- Test {STS_SET_OF_SETS}.sets_are_disjoint.
			-- Test {STI_SET_OF_SETS}.sets_are_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.sets_are_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.sets_are_disjoint"
		local
			ss1: like set_to_be_tested
			ss2: like some_set_sa
			chk_ops: BOOLEAN
		do
			ss1 := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				across
					1 |..| some_count.as_integer_32 as i
				from
					create ss2.make_empty
				loop
					ss2 := ss2 & (some_set_a ∖ (⋃ ss1))
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("ss1_sets_are_disjoint_ss2", ss1.sets_are_disjoint (ss2))

			assert ("sets_are_disjoint", set_to_be_tested.sets_are_disjoint (some_set_sa) implies True)
		end

feature -- Test routines (Operation)

	test_sets_union
			-- Test {STI_SET_OF_SETS}.sets_union.
		note
			testing: "covers/{STI_SET_OF_SETS}.sets_union"
		local
			ss: like set_to_be_tested
		do
			ss := set_to_be_tested
			assert ("sets_union", attached (⋃ ss))
			assert ("sets_union_ok", properties.sets_union_ok (ss))
		end

	test_sets_intersection
			-- Test {STI_SET_OF_SETS}.sets_intersection.
		note
			testing: "covers/{STI_SET_OF_SETS}.sets_intersection"
		local
			ss: like set_to_be_tested
		do
			from
				ss := set_to_be_tested
			until
				not ss.is_empty
			loop
				ss := set_to_be_tested
			end
			assert ("ss_sets_intersection", attached (⋂ ss))
			assert ("ss_sets_intersection_ok", properties.sets_intersection_ok (ss))

			ss := set_to_be_tested.o_s
			assert ("empty_ss_sets_intersection", attached (⋂ ss))
			assert ("empty_ss_sets_intersection_ok", properties.sets_intersection_ok (ss))

			ss := set_to_be_tested
			assert ("sets_intersection", attached (⋂ ss))
			assert ("sets_intersection_ok", properties.sets_intersection_ok (ss))
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_SET_OF_SETS}.o.
		note
			testing: "covers/{STI_SET_OF_SETS}.o"
		local
			ss: like set_to_be_tested
		do
			ss := set_to_be_tested
			assert ("o", attached ss.o)
			assert ("o_ok", properties.o_ok (ss))
		end

	test_empty_member_set
			-- Test {STI_SET_OF_SETS}.empty_member_set.
		note
			testing: "covers/{STI_SET_OF_SETS}.empty_member_set"
		local
			ss: like set_to_be_tested
		do
			ss := set_to_be_tested
			assert ("empty_member_set", attached ss.empty_member_set)
			assert ("empty_member_set_ok", properties.empty_member_set_ok (ss))
		end

feature -- Test routines (Predicate)

	test_some_set_has
			-- Test {STS_SET_OF_SETS}.some_set_has.
			-- Test {STI_SET_OF_SETS}.some_set_has.
		note
			testing: "covers/{STS_SET_OF_SETS}.some_set_has"
			testing: "covers/{STI_SET_OF_SETS}.some_set_has"
		local
			a: A
			s: like some_set_a
			ss: like set_to_be_tested
			chk_ops: BOOLEAN
		do
			a := some_object_a

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a & a
				ss := set_to_be_tested & s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("ss_some_set_has_a", ss.some_set_has (a))

			a := some_object_a
			ss := set_to_be_tested
			assert ("some_set_has", ss.some_set_has (a) implies True)
		end

	test_every_set_has
			-- Test {STS_SET_OF_SETS}.every_set_has.
			-- Test {STI_SET_OF_SETS}.every_set_has.
		note
			testing: "covers/{STS_SET_OF_SETS}.every_set_has"
			testing: "covers/{STI_SET_OF_SETS}.every_set_has"
		local
			a: A
			ss: like set_to_be_tested
			chk_ops: BOOLEAN
		do
			a := some_object_a
			ss := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				ss := ss.converted (ss ↦ agent {STS_SET [A, EQ]}.with (a))
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("ss_every_set_has_a", ss.every_set_has (a))

			assert ("every_set_has", set_to_be_tested.every_set_has (some_object_a) implies True)
		end

feature {NONE} -- Factory (element to be tested)

	set_to_be_tested: like resources_a.some_set_of_sets_a
			-- Set of (member) sets meant to be under tests
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
