﻿note
	description: "Test suite for features that {STI_SUBSET_FAMILY_STRUCTURE} inherit from {STI_SUBSET_FAMILY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SUBSET_FAMILY_TESTS [A, EQ]
		rename
			test_eq as test_eq_s,
			test_is_in as test_set_is_in,
			test_is_not_in as test_set_is_not_in,
			test_equals as test_set_equals,
			test_unequals as test_set_unequals,
			test_as_singleton as test_set_as_singleton,
			subset_family_to_be_tested as subset_family_structure_to_be_tested,
			subset_family_from_sa as subset_family_structure_from_sa,
			subset_family_from_sti_sa as subset_family_structure_from_sti_sa,
			subset_family_from_sa_a as subset_family_structure_from_sa_a,
			subset_family_from_sti_sa_a as subset_family_structure_from_sti_sa_a,
			subset_family_from_saa as subset_family_structure_from_saa,
			subset_family_from_sti_saa as subset_family_structure_from_sti_saa,
			subset_family_from_sa_ta as subset_family_structure_from_sa_ta,
			subset_family_from_sti_sa_ta as subset_family_structure_from_sti_sa_ta,
			subset_family_from_sa_ssa as subset_family_structure_from_sa_ssa,
			subset_family_from_sti_sa_ssa as subset_family_structure_from_sti_sa_ssa,
			subset_family_from_sa_sta as subset_family_structure_from_sa_sta,
			subset_family_from_sti_sa_sta as subset_family_structure_from_sti_sa_sta,
			subset_family_from_sa_aa as subset_family_structure_from_sa_aa,
			subset_family_from_sti_sa_aa as subset_family_structure_from_sti_sa_aa,
			subset_family_from_set_of_sets as subset_family_structure_from_set_of_sets,
			subset_family_from_sti_set_of_sets as subset_family_structure_from_sti_set_of_sets,
			subset_family_from_set_family as subset_family_structure_from_set_family,
			subset_family_from_sti_set_family as subset_family_structure_from_sti_set_family,
			subset_family_from_set_partition as subset_family_structure_from_set_partition,
			subset_family_from_sti_set_partition as subset_family_structure_from_sti_set_partition,
			subset_family_from_sf as subset_family_structure_from_sf,
			subset_family_from_subset_family_structure as subset_family_structure_from_subset_family_structure
		redefine
			test_make_from_family,
			subset_family_structure_to_be_tested,
			subset_family_structure_from_sa,
			subset_family_structure_from_sti_sa,
			subset_family_structure_from_sa_a,
			subset_family_structure_from_sti_sa_a,
			subset_family_structure_from_saa,
			subset_family_structure_from_sti_saa,
			subset_family_structure_from_sa_ta,
			subset_family_structure_from_sti_sa_ta,
			subset_family_structure_from_sa_ssa,
			subset_family_structure_from_sti_sa_ssa,
			subset_family_structure_from_sa_sta,
			subset_family_structure_from_sti_sa_sta,
			subset_family_structure_from_sa_aa,
			subset_family_structure_from_sti_sa_aa,
			subset_family_structure_from_set_of_sets,
			subset_family_structure_from_sti_set_of_sets,
			subset_family_structure_from_set_family,
			subset_family_structure_from_sti_set_family,
			subset_family_structure_from_set_partition,
			subset_family_structure_from_sti_set_partition,
			subset_family_structure_from_sf,
			subset_family_structure_from_subset_family_structure
		end

feature -- Access

	properties: SUBSET_FAMILY_STRUCTURE_PROPERTIES [A, EQ]
			-- Object that checks the set-theory properties of {STI_SUBSET_FAMILY_STRUCTURE}
		deferred
		end

feature -- Test routines (Initialization)

	test_make_from_family
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_from_family.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_from_family"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_from_family"
		do
			Precursor {SUBSET_FAMILY_TESTS}
			assert ("convert_from_sti_subset_family", attached subset_family_structure_from_sti_subset_family (resources_a.some_subset_family_a))
		end

feature {NONE} -- Factory (element to be tested)

	subset_family_structure_from_sa (sa: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_structure_to_be_tested
			-- `sa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa
		end

feature {NONE} -- Conversion

	subset_family_structure_from_sti_sa (sa: STI_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_structure_to_be_tested
			-- `sa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa
		end

	subset_family_structure_from_sa_a (sa_a: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]): like subset_family_structure_to_be_tested
			-- `sa_a` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_a
		end

	subset_family_structure_from_sti_sa_a (sa_a: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]): like subset_family_structure_to_be_tested
			-- `sa_a` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_a
		end

	subset_family_structure_from_saa (saa: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_structure_to_be_tested
			-- `saa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := saa
		end

	subset_family_structure_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_structure_to_be_tested
			-- `saa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := saa
		end

	subset_family_structure_from_sa_ta (sa_ta: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]): like subset_family_structure_to_be_tested
			-- `sa_ta` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_ta
		end

	subset_family_structure_from_sti_sa_ta (sa_ta: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]): like subset_family_structure_to_be_tested
			-- `sa_ta` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_ta
		end

	subset_family_structure_from_sa_ssa (sa_ssa: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]]): like subset_family_structure_to_be_tested
			-- `sa_ssa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_ssa
		end

	subset_family_structure_from_sti_sa_ssa (sa_ssa: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]]): like subset_family_structure_to_be_tested
			-- `sa_ssa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_ssa
		end

	subset_family_structure_from_sa_sta (sa_sta: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]]): like subset_family_structure_to_be_tested
			-- `sa_sta` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_sta
		end

	subset_family_structure_from_sti_sa_sta (sa_sta: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]]): like subset_family_structure_to_be_tested
			-- `sa_sta` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_sta
		end

	subset_family_structure_from_sa_aa (sa_aa: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]]): like subset_family_structure_to_be_tested
			-- `sa_aa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_aa
		end

	subset_family_structure_from_sti_sa_aa (sa_aa: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]]): like subset_family_structure_to_be_tested
			-- `sa_aa` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sa_aa
		end

	subset_family_structure_to_be_tested: like resources_a.some_direct_subset_family_structure_a
			-- Subset-family structure meant to be under tests
		do
			Result := resources_a.some_direct_subset_family_structure_a
		end

	subset_family_structure_from_set_of_sets (ss: STS_SET_OF_SETS [A, EQ]): like subset_family_structure_to_be_tested
			-- `ss` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := ss
		end

	subset_family_structure_from_sti_set_of_sets (ss: STI_SET_OF_SETS [A, EQ]): like subset_family_structure_to_be_tested
			-- `ss` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := ss
		end

	subset_family_structure_from_set_family (sf: STS_SET_FAMILY [A, EQ]): like subset_family_structure_to_be_tested
			-- `sf` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sf
		end

	subset_family_structure_from_sti_set_family (sf: STI_SET_FAMILY [A, EQ]): like subset_family_structure_to_be_tested
			-- `sf` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sf
		end

	subset_family_structure_from_set_partition (sp: STS_SET_PARTITION [A, EQ]): like subset_family_structure_to_be_tested
			-- `sp` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sp
		end

	subset_family_structure_from_sti_set_partition (sp: STI_SET_PARTITION [A, EQ]): like subset_family_structure_to_be_tested
			-- `sp` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sp
		end

	subset_family_structure_from_sf (sf: STS_SUBSET_FAMILY [A, EQ]): like subset_family_structure_to_be_tested
			-- `sf` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sf
		end

	subset_family_structure_from_sti_subset_family (sf: STI_SUBSET_FAMILY [A, EQ]): like subset_family_structure_to_be_tested
			-- `sf` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sf
		ensure
			same_subsets: Result.set_equals (sf)
			same_superset: Result.s ≍ sf.superset
		end

	subset_family_structure_from_subset_family_structure (sf: STS_SUBSET_FAMILY_STRUCTURE [A, EQ]): like subset_family_structure_to_be_tested
			-- `sf` converted to a subset family like `subset_family_structure_to_be_tested`
		do
			Result := sf
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
