﻿note
	description: "Test suite for {STI_SUBSET_FAMILY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	SUBSET_FAMILY_TESTS [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SET_OF_SETS_TESTS [A, EQ]
		rename
			test_make_empty as test_set_make_empty,
			test_make_extended as test_set_make_extended,
			test_extended as test_set_extended,
			test_batch_extended as test_set_batch_extended,
			test_member_sets_are_disjoint as test_subsets_are_disjoint,
			test_sets_union as test_family_union,
			test_sets_intersection as test_family_intersection,
			test_o_s as test_o_f,
			test_empty_set_of_sets as test_empty_family,
			test_unit_s as test_unit_f,
			test_empty_member_set as test_empty_subset,
			test_converted_member_set as test_converted_subset,
			test_some_set_has as test_some_subset_has,
			test_every_set_has as test_every_subset_has,
			set_to_be_tested as subset_family_to_be_tested,
			set_from_sa as subset_family_from_sa,
			set_from_saa as subset_family_from_saa
		redefine
			test_family_union
		end

	SET_TESTS [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			test_make_empty as test_set_make_empty,
			test_make_extended as test_set_make_extended,
			test_extended as test_set_extended,
			test_batch_extended as test_set_batch_extended,
			test_empty_set as test_empty_family,
			test_o as test_o_f,
			test_unit as test_unit_f,
			set_to_be_tested as subset_family_to_be_tested,
			some_object_a as some_set_a,
			same_object_a as same_set_a,
			object_twin_a as set_twin_a,
			new_eq_a as new_eq_sa,
			new_reference_equality_a as new_reference_equality_sa,
			new_object_equality_a as new_object_equality_sa,
			new_reference_equality_aa as new_reference_equality_sa_sa,
			new_object_equality_aa as new_object_equality_sa_sa,
			new_pair_equality_aa as new_pair_equality_sa_sa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_set_equality_a as new_set_equality_sa,
			new_reference_equality_ta as new_reference_equality_tsa,
			new_object_equality_ta as new_object_equality_tsa,
			new_n_tuple_equality_a as new_n_tuple_equality_sa,
			some_pair_aa as some_pair_sa_sa,
			new_pair_aa as new_pair_sa_sa,
			new_composable_pair_aaa as new_composable_pair_sa_sa_sa,
			new_homogeneous_pair_a as new_homogeneous_pair_sa,
			new_pair_a_ta as new_pair_sa_tsa,
			new_references_a as new_references_sa,
			new_objects_a as new_objects_sa,
			some_set_a as some_set_sa,
			new_set_a as new_set_sa,
			new_transformable_set_aa as new_transformable_set_sa_sa,
			same_set_a as same_set_sa,
			new_references_aa as new_references_sa_sa,
			new_objects_aa as new_objects_sa_sa,
			new_math_set_aa as new_math_set_sa_sa,
			new_transformable_set_aa_a as new_transformable_set_sa_sa_sa,
			new_set_of_pairs_aa as new_set_of_pairs_sa_sa,
			some_set_sa as some_set_ssa,
			some_references_sa as some_references_ssa,
			new_references_sa as new_references_ssa,
			some_objects_sa as some_objects_ssa,
			new_objects_sa as new_objects_ssa,
			some_math_set_sa as some_math_set_ssa,
			new_math_set_sa as new_math_set_ssa,
			new_transformable_set_sa_ta as new_transformable_set_ssa_tsa,
			some_set_of_sets_a as some_set_of_sets_sa,
			some_set_family_a as some_set_family_sa,
			some_direct_set_family_a as some_direct_set_family_sa,
			new_set_family_a as new_set_family_sa,
			some_set_partition_a as some_set_partition_sa,
			some_direct_set_partition_a as some_direct_set_partition_sa,
			new_set_partition_a as new_set_partition_sa,
			partitioned_set_a as partitioned_set_sa,
			some_subset_family_a as some_subset_family_sa,
			some_direct_subset_family_a as some_direct_subset_family_sa,
			new_subset_family_a as new_subset_family_sa,
			same_subset_family_a as same_subset_family_sa,
			some_subset_family_structure_a as some_subset_family_structure_sa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_sa,
			new_subset_family_structure_a as new_subset_family_structure_sa,
			some_set_ta as some_set_tsa,
			some_references_ta as some_references_tsa,
			new_references_ta as new_references_tsa,
			some_objects_ta as some_objects_tsa,
			new_objects_ta as new_objects_tsa,
			some_math_set_ta as some_math_set_tsa,
			new_math_set_ta as new_math_set_tsa,
			new_transformable_set_ta_sa as new_transformable_set_tsa_ssa,
			new_pair_composer_aaa as new_pair_composer_sa_sa_sa,
			new_transformer_aa as new_transformer_sa_sa,
			some_n_tuple_a as some_n_tuple_sa,
			new_n_tuple_a as new_n_tuple_sa,
			new_transformable_tuple_aa as new_transformable_tuple_sa_sa,
			same_n_tuple_a as same_n_tuple_sa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_ssa_tsa,
			new_set_tuple_a as new_set_tuple_sa,
			test_converted_element as test_converted_subset,
			set_from_sa as subset_family_from_sa,
			set_from_saa as subset_family_from_saa
		undefine
			some_equality,
			some_pair,
			some_set,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple
		redefine
			test_make_from_set,
			subset_family_to_be_tested,
			subset_family_from_sa,
			subset_family_from_saa
		end

feature -- Access

	properties: SUBSET_FAMILY_PROPERTIES [A, EQ]
			-- Object that checks the set-theory properties of {STI_SUBSET_FAMILY}
		deferred
		end

feature -- Test routines (Initialization)

	test_make_empty
			-- Test {STI_SUBSET_FAMILY}.make_empty.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_empty"
		local
			s: like some_set_a
		do
			s := some_set_a
			assert ("make_empty", attached (create {like subset_family_to_be_tested}.make_empty (s)))
			assert ("make_empty_ok", properties.make_empty_ok (s))
		end

	test_make_extended
			-- Test {STI_SUBSET_FAMILY}.make_extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_extended"
		local
			s: like some_set_a
			sf: like resources_a.some_subset_family_a
			chk_ops: BOOLEAN
		do
			s := some_set_a

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				sf := resources_a.some_subset_family_a.extending_superset (s) / s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("s_not_in_sf", s ∉ sf)
			assert ("s_already_a_subset_sf_superset", s ⊆ sf.superset)
			assert ("make_extended_s_sf", attached (create {like subset_family_to_be_tested}.make_extended (s, sf)))
			assert ("make_extended_s_sf_ok", properties.make_extended_ok (s, sf))

			s := some_set_a
			sf := resources_a.some_subset_family_a
			assert ("make_extended", s ∉ sf and s ⊆ sf.superset implies attached (create {like subset_family_to_be_tested}.make_extended (s, sf)))
			assert ("make_extended_ok", properties.make_extended_ok (s, sf))
		end

	test_make_from_set
			-- Test {STI_SUBSET_FAMILY}.make_from_set.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_from_set"
		do
			Precursor {SET_TESTS}
			assert ("convert_from_sti_sa", attached subset_family_from_sti_sa (some_set_sa))
			assert (
				"convert_from_sa_a",
				attached subset_family_from_sa_a (create {STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]}.make_from_set (some_set_sa))
				)
			assert (
				"convert_from_sti_sa_a",
				attached subset_family_from_sti_sa_a
					(create {STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]}.make_from_set (some_set_sa))
				)
			assert ("convert_from_sti_saa", attached subset_family_from_sti_saa (new_transformable_set_sa_sa))
			assert ("convert_from_sa_ta", attached subset_family_from_sa_ta (resources_a.new_transformable_set_sa_ta))
			assert ("convert_from_sti_sa_ta", attached subset_family_from_sti_sa_ta (resources_a.new_transformable_set_sa_ta))
			assert (
				"convert_from_sa_ssa", attached subset_family_from_sa_ssa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sti_sa_ssa", attached subset_family_from_sti_sa_ssa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sa_sta", attached subset_family_from_sa_sta (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sti_sa_sta", attached subset_family_from_sti_sa_sta (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sa_aa", attached subset_family_from_sa_aa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert (
				"convert_from_sti_sa_aa", attached subset_family_from_sti_sa_aa (
					create {
						STI_TRANSFORMABLE_SET [
							STS_SET [A, EQ],
							STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
							STS_SET_EQUALITY [A, EQ],
							STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
							]
						}.make_from_set (some_set_sa)
					)
				)
			assert ("convert_from_set_of_sets", attached subset_family_from_set_of_sets (resources_a.some_set_of_sets_a))
			assert ("convert_from_set_family", attached subset_family_from_set_family (resources_a.some_set_family_a))
			assert ("convert_from_set_partition", attached subset_family_from_set_partition (resources_a.some_set_partition_a))
			assert ("convert_from_sti_set_of_sets", attached subset_family_from_sti_set_of_sets (resources_a.some_set_of_sets_a))
			assert ("convert_from_sti_set_family", attached subset_family_from_sti_set_family (resources_a.some_set_family_a))
			assert ("convert_from_sti_set_partition", attached subset_family_from_sti_set_partition (resources_a.some_set_partition_a))
		end

	test_make_from_family
			-- Test {STI_SUBSET_FAMILY}.make_from_family.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_from_family"
		local
			sf: like resources_a.some_subset_family_a
		do
			sf := resources_a.some_subset_family_a
			assert ("make_from_family", attached (create {like subset_family_to_be_tested}.make_from_family (sf)))

			assert ("convert_from_subset_family", attached subset_family_from_sf (resources_a.some_subset_family_a))
			assert ("convert_from_subset_family_structure", attached subset_family_from_subset_family_structure (resources_a.some_subset_family_structure_a))
		end

feature -- Test routines (Primitive)

	test_superset
			-- Test {STI_SUBSET_FAMILY}.superset.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.superset"
		local
			sf: like subset_family_to_be_tested
		do
			sf := subset_family_to_be_tested
			assert ("superset", attached sf.superset)
		end

feature -- Test routines (Construction)

	test_extended
			-- Test {STI_SUBSET_FAMILY}.extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.extended"
		local
			s: like some_set_a
			sf: like subset_family_to_be_tested
			chk_ops: BOOLEAN
		do
			s := some_set_a

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				sf := subset_family_to_be_tested.extending_superset (s) / s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("s_not_in_sf", s ∉ sf)
			assert ("s_already_a_subset_sf_superset", s ⊆ sf.superset)
			assert ("sf_extended_s", attached sf.extended (s))
			assert ("sf_extended_s_ok", properties.extended_ok (s, sf))

			s := some_set_a
			sf := subset_family_to_be_tested
			assert ("extended", s ∉ sf and s ⊆ sf.superset implies attached sf.extended (s))
			assert ("extended_ok", properties.extended_ok (s, sf))
		end

	test_batch_extended
			-- Test {STI_SUBSET_FAMILY}.batch_extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.batch_extended"
		local
			sf0: like resources_a.some_subset_family_a
			sf: like subset_family_to_be_tested
			chk_ops: BOOLEAN
		do
			sf0 := resources_a.some_subset_family_a

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				sf := subset_family_to_be_tested.extending_superset (sf0.superset) ∖ sf0
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("sf_is_disjoint_sf0", sf.is_disjoint (sf0))
			assert ("sf_superset_includes_sf0_superset", sf0.superset ⊆ sf.superset)
			assert ("sf_batch_extended_sf0", attached sf.batch_extended (sf0))
			assert ("sf_batch_extended_sf0_ok", properties.batch_extended_ok (sf0, sf))

			sf0 := resources_a.some_subset_family_a
			sf := subset_family_to_be_tested
			assert ("extended", sf.is_disjoint (sf0) and sf0.superset ⊆ sf.superset implies attached sf.batch_extended (sf0))
			assert ("batch_extended_ok", properties.batch_extended_ok (sf0, sf))
		end

	test_extending_superset
			-- Test {STI_SUBSET_FAMILY}.extending_superset.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.extending_superset"
		do
			assert ("extending_superset", attached subset_family_to_be_tested.extending_superset (some_set_a))
		end

	test_replacing_superset
			-- Test {STI_SUBSET_FAMILY}.replacing_superset.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.replacing_superset"
		local
			s: like some_set_a
			sf: like subset_family_to_be_tested
		do
			s := some_set_a
			sf := subset_family_to_be_tested
			assert ("replacing_superset", attached sf.replacing_superset (s))
			assert ("replacing_superset_ok", properties.replacing_superset_ok (s, sf))
		end

feature -- Test routines (Comparison)

	test_same_family
			-- Test {STS_SUBSET_FAMILY}.same_family.
			-- Test {STI_SUBSET_FAMILY}.same_family.
		note
			testing: "covers/{STS_SUBSET_FAMILY}.same_family"
			testing: "covers/{STI_SUBSET_FAMILY}.same_family"
		local
			sf1: like subset_family_to_be_tested
			sf2: like resources_a.some_subset_family_a
		do
			sf1 := subset_family_to_be_tested
			sf2 := sf1
			assert ("same_reference", sf1.same_family (sf2))
			assert ("same_reference_ok", properties.same_family_ok (sf1, sf2))

			sf1 := subset_family_to_be_tested
			sf2 := resources_a.same_subset_family_a (sf1)
			assert ("same_value", sf1.same_family (sf2))
			assert ("same_value_ok", properties.same_family_ok (sf1, sf2))

			sf1 := subset_family_to_be_tested
			sf2 := resources_a.some_subset_family_a
			assert ("same_family", sf1.same_family (sf2) implies True)
			assert ("same_family_ok", properties.same_family_ok (sf1, sf2))
		end

feature -- Test routines (Operation)

	test_complemented_family
			-- Test {STS_SUBSET_FAMILY}.complemented_family.
			-- Test {STI_SUBSET_FAMILY}.complemented_family.
		note
			testing: "covers/{STS_SUBSET_FAMILY}.complemented_family"
			testing: "covers/{STI_SUBSET_FAMILY}.complemented_family"
		local
			sf: like subset_family_to_be_tested
			chk_ops, chk_tests: BOOLEAN
			n: like subset_family_to_be_tested.cardinality
		do
			sf := subset_family_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # sf.superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			if (2 ^ n) ≤ Max_subsets then
				if 2 ^ n > Max_asserted_subsets then
					chk_tests := {ISE_RUNTIME}.check_assert (False)
				end
					assert ("complemented_family", attached (∁ sf))
				if chk_tests then
					chk_tests := {ISE_RUNTIME}.check_assert (chk_tests)
				end
			end

			assert ("complemented_family_ok", properties.complemented_family_ok (sf))
		end

	test_family_union
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY}.family_union.
		note
			testing: "covers/{STI_SET_OF_SETS}.sets_union"
			testing: "covers/{STI_SUBSET_FAMILY}.family_union"
		local
			sf: like subset_family_to_be_tested
		do
			sf := subset_family_to_be_tested
			assert ("family_union", attached (⋃ sf))
			assert ("family_union_ok", properties.family_union_ok (sf))
		end

feature {NONE} -- Factory (element to be tested)

	subset_family_to_be_tested: like resources_a.some_direct_subset_family_a
			-- Subset family meant to be under tests
		do
			Result := resources_a.some_direct_subset_family_a
		end

feature {NONE} -- Conversion

	subset_family_from_sa (sa: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_to_be_tested
			-- `sa` converted to a subset family like `subset_family_to_be_tested`
		do
			Result := sa
		ensure then
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} sa as sf implies Result.superset ≍ sf.superset
			when_not_a_family: not attached {STS_SUBSET_FAMILY [A, EQ]} sa implies Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_sa (sa: STI_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_to_be_tested
			-- `sa' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} sa as sf implies Result.superset ≍ sf.superset
			when_not_a_family: not attached {STS_SUBSET_FAMILY [A, EQ]} sa implies Result.superset ≍ ⋃ Result
		end

	subset_family_from_sa_a (sa_a: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]): like subset_family_to_be_tested
			-- `sa_a' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_a
		ensure
			same_set: Result ≍ sa_a
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_sa_a (sa_a: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], A, STS_SET_EQUALITY [A, EQ], EQ]): like subset_family_to_be_tested
			-- `sa_a' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_a
		ensure
			same_set: Result ≍ sa_a
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_saa (saa: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_to_be_tested
			-- `saa` converted to a subset family like `subset_family_to_be_tested`
		do
			Result := saa
		ensure then
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [A, EQ]]): like subset_family_to_be_tested
			-- `saa' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := saa
		ensure
			same_set: Result ≍ saa
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sa_ta
		(sa_ta: STS_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]): like subset_family_to_be_tested
			-- `sa_ta' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_ta
		ensure
			same_set: Result ≍ sa_ta
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_sa_ta
		(sa_ta: STI_TRANSFORMABLE_SET [STS_SET [A, EQ], STS_N_TUPLE [A, EQ], STS_SET_EQUALITY [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]): like subset_family_to_be_tested
			-- `sa_ta' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_ta
		ensure
			same_set: Result ≍ sa_ta
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sa_ssa (
		sa_ssa: STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			]
		): like subset_family_to_be_tested
			-- `sa_ssa' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_ssa
		ensure
			same_set: Result ≍ sa_ssa
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_sa_ssa (
		sa_ssa: STI_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
			]
		): like subset_family_to_be_tested
			-- `sa_ssa' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_ssa
		ensure
			same_set: Result ≍ sa_ssa
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sa_sta (
		sa_sta: STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			]
		): like subset_family_to_be_tested
			-- `sa_sta' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_sta
		ensure
			same_set: Result ≍ sa_sta
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_sa_sta (
		sa_sta: STI_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_N_TUPLE [A, EQ], STS_N_TUPLE_EQUALITY [A, EQ]]
			]
		): like subset_family_to_be_tested
			-- `sa_sta' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_sta
		ensure
			same_set: Result ≍ sa_sta
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sa_aa (
		sa_aa: STS_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			]
		): like subset_family_to_be_tested
			-- `sa_aa' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_aa
		ensure
			same_set: Result ≍ sa_aa
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_sa_aa (
		sa_aa: STI_TRANSFORMABLE_SET [
			STS_SET [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]],
			STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_ORDERED_PAIR_EQUALITY [A, A, EQ, EQ]]
			]
		): like subset_family_to_be_tested
			-- `sa_aa' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sa_aa
		ensure
			same_set: Result ≍ sa_aa
			superset: Result.superset ≍ ⋃ Result
		end

	subset_family_from_set_of_sets (ss: STS_SET_OF_SETS [A, EQ]): like subset_family_to_be_tested
			-- `ss' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := ss
		ensure
			same_set: Result ≍ ss
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} ss as sf implies Result.superset ≍ sf.superset
			when_not_a_family: not attached {STS_SUBSET_FAMILY [A, EQ]} ss implies Result.superset ≍ ⋃ Result
		end

	subset_family_from_sti_set_of_sets (ss: STI_SET_OF_SETS [A, EQ]): like subset_family_to_be_tested
			-- `ss' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := ss
		ensure
			same_set: Result ≍ ss
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} ss as sf implies Result.superset ≍ sf.superset
			when_not_a_family: not attached {STS_SUBSET_FAMILY [A, EQ]} ss implies Result.superset ≍ ⋃ Result
		end

	subset_family_from_set_family (sf: STS_SET_FAMILY [A, EQ]): like subset_family_to_be_tested
			-- `sf' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
			superset: Result.superset ≍ ⋃ sf
		end

	subset_family_from_sti_set_family (sf: STI_SET_FAMILY [A, EQ]): like subset_family_to_be_tested
			-- `sf' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} sf as ssf implies Result.superset ≍ ssf.superset
		end

	subset_family_from_set_partition (sp: STS_SET_PARTITION [A, EQ]): like subset_family_to_be_tested
			-- `sp' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sp
		ensure
			same_set: Result ≍ sp
			superset: Result.superset ≍ ⋃ sp
		end

	subset_family_from_sti_set_partition (sp: STI_SET_PARTITION [A, EQ]): like subset_family_to_be_tested
			-- `sp' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sp
		ensure
			same_set: Result ≍ sp
			when_a_family: attached {STS_SUBSET_FAMILY [A, EQ]} sp as ssf implies Result.superset ≍ ssf.superset
		end

	subset_family_from_sf (sf: STS_SUBSET_FAMILY [A, EQ]): like subset_family_to_be_tested
			-- `sf' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
			same_superset: Result.superset ≍ sf.superset
		end

	subset_family_from_subset_family_structure (sf: STS_SUBSET_FAMILY_STRUCTURE [A, EQ]): like subset_family_to_be_tested
			-- `sf' converted to a subset family like `subset_family_to_be_tested'
		do
			Result := sf
		ensure
			same_set: Result ≍ sf
			same_superset: Result.superset ≍ sf.superset
		end

--feature {NONE} -- Implementation

--	max_subsets: NATURAL = 1_048_576 -- 2 ^ 20
--			-- Maximum number of subsets to be checked within feature tests

--	max_asserted_subsets: NATURAL = 16 -- 2 ^ 4
--			-- Maximum number of subsets to be checked with assertions enabled within feature tests

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
