note
	description: "Test suite for {STS_OBJECT_EQUALITY [detachable INTEGER_REF]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	OBJECT_EQUALITY_TESTS_I

inherit
	OBJECT_EQUALITY_TESTS [detachable INTEGER_REF]
		rename
			some_object_a as some_integer_ref,
			f_x as f_x_to_same_kind,
			f_acc_x as f_acc_x_to_same_kind,
			f_x_acc as f_x_acc_to_same_kind,
			f_acc_i_x as f_acc_i_x_to_same_kind,
			f_i_x_acc as f_i_x_acc_to_same_kind
		undefine
			on_prepare,
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a
		redefine
			test_is_in,
			test_is_not_in,
			test_holds,
			test_holds_successively
		end

	ELEMENT_TESTS_NIC
		rename
			element_to_be_tested as equality_to_be_tested
		undefine
			equality_to_be_tested
		redefine
			properties,
			test_is_in,
			test_is_not_in
		end

feature -- Access

	properties: EQUALITY_PROPERTIES [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
			-- <Precursor>
--		once
--			create Result
--		end

feature -- Test routines (Membership)

	test_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STS_EQUALITY}.is_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_in.
			-- Test {STS_OBJECT_EQUALITY}.is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_EQUALITY}.is_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_in"
			testing: "covers/{STS_OBJECT_EQUALITY}.is_in"
		do
			Precursor {OBJECT_EQUALITY_TESTS}
		end

	test_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STS_EQUALITY}.is_not_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_not_in.
			-- Test {STS_OBJECT_EQUALITY}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_EQUALITY}.is_not_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_not_in"
			testing: "covers/{STS_OBJECT_EQUALITY}.is_not_in"
		do
			Precursor {OBJECT_EQUALITY_TESTS}
		end

feature -- Test routines (Relationship)

	test_holds
			-- <Precursor>
		note
			testing: "covers/{STS_OBJECT_EQUALITY}.holds"
		local
			eq: like equality_to_be_tested
			i1, i2: detachable INTEGER_REF
		do
			Precursor {OBJECT_EQUALITY_TESTS}
			eq := equality_to_be_tested
			from
				i1 := some_direct_integer_ref
			until
				attached i1
			loop
				i1 := some_direct_integer_ref
			end
			i2 := i1.item
			assert ("same_integer", i1.item ~ i2)
			assert ("different_types", not eq (i1, i2))
			assert ("different_types_ok", properties.holds_ok (i1, i2, eq))
		end

	test_holds_successively
			-- <Precursor>
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_OBJECT_EQUALITY}.holds_successively"
		do
			Precursor {OBJECT_EQUALITY_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
