note
	description: "Test suite for {STS_PAIR_EQUALITY [detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	ORDERED_PAIR_EQUALITY_TESTS_IC

inherit
	ORDERED_PAIR_EQUALITY_TESTS [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		undefine
			on_prepare
		redefine
			test_is_in,
			test_is_not_in,
			test_holds,
			test_holds_successively
		end

	SETS_TESTS_RESOURCES_UNARY_IC

feature -- Access

	properties: EQUALITY_PROPERTIES [
		STS_ORDERED_PAIR [
			detachable INTEGER_REF, detachable separate CHARACTER_REF,
			STS_OBJECT_EQUALITY [detachable INTEGER_REF],
			STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
			],
		STS_ORDERED_PAIR_EQUALITY [
			detachable INTEGER_REF, detachable separate CHARACTER_REF,
			STS_OBJECT_EQUALITY [detachable INTEGER_REF],
			STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
			]
		]
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Test routines (Membership)

	test_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STS_EQUALITY}.is_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_in.
			-- Test {STS_ORDERED_PAIR_EQUALITY}.is_in.
			--| todo: renamed classes get unclickable.
			--| todo: renamed classes breaks metrics.
			--| todo: renamed classes breaks AutoTest filter.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_EQUALITY}.is_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_in"
			testing: "covers/{STS_ORDERED_PAIR_EQUALITY}.is_in"
		do
			Precursor {ORDERED_PAIR_EQUALITY_TESTS}
		end

	test_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STS_EQUALITY}.is_not_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_not_in.
			-- Test {STS_ORDERED_PAIR_EQUALITY}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_EQUALITY}.is_not_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_not_in"
			testing: "covers/{STS_ORDERED_PAIR_EQUALITY}.is_not_in"
		do
			Precursor {ORDERED_PAIR_EQUALITY_TESTS}
		end

feature -- Test routines (Relationship)

	test_holds
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR_EQUALITY}.holds"
		do
			Precursor {ORDERED_PAIR_EQUALITY_TESTS}
		end

	test_holds_successively
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR_EQUALITY}.holds_successively"
		do
			Precursor {ORDERED_PAIR_EQUALITY_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
