note
	description: "Test suite for {STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	REFERENCE_EQUALITY_TESTS_C

inherit
	REFERENCE_EQUALITY_TESTS [detachable separate CHARACTER_REF]
		rename
			some_object_a as some_character_ref
		undefine
			on_prepare
		redefine
			test_is_in,
			test_is_not_in,
			test_holds,
			test_holds_successively
		end

	SETS_TESTS_RESOURCES_UNARY_C

feature -- Access

	properties: EQUALITY_PROPERTIES [detachable separate CHARACTER_REF, STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]]
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Test routines (Membership)

	test_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STS_EQUALITY}.is_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_in.
			-- Test {STS_REFERENCE_EQUALITY}.is_in.
			--| todo: renamed classes get unclickable.
			--| todo: renamed classes breaks metrics.
			--| todo: renamed classes breaks AutoTest filter.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_EQUALITY}.is_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_in"
			testing: "covers/{STS_REFERENCE_EQUALITY}.is_in"
		do
			Precursor {REFERENCE_EQUALITY_TESTS}
		end

	test_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STS_EQUALITY}.is_not_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_not_in.
			-- Test {STS_REFERENCE_EQUALITY}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_EQUALITY}.is_not_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_not_in"
			testing: "covers/{STS_REFERENCE_EQUALITY}.is_not_in"
		do
			Precursor {REFERENCE_EQUALITY_TESTS}
		end

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_REFERENCE_EQUALITY}.holds.
		note
			testing: "covers/{STS_REFERENCE_EQUALITY}.holds"
		local
			eq: like equality_to_be_tested
			c1, c2: detachable separate CHARACTER_REF
		do
			Precursor {REFERENCE_EQUALITY_TESTS}
			eq := equality_to_be_tested
			from
				c1 := some_direct_character_ref
			until
				attached c1
			loop
				c1 := some_direct_character_ref
			end
			separate c1 as sep_c1 do
				c2 := sep_c1.item.to_reference
			end
			assert ("same_character", c1 ~ c2)
			assert ("different_references", not eq (c1, c2))
			assert ("different_references_ok", properties.holds_ok (c1, c2, eq))

			eq := equality_to_be_tested
			from
				c1 := some_direct_character_ref
			until
				attached c1
			loop
				c1 := some_direct_character_ref
			end
			separate c1 as sep_c1 do
				c2 := sep_c1.item
				assert ("still_same_character", sep_c1.item ~ c2)
			end
			assert ("same_character_different_types", c1 /~ c2)
			assert ("different_references_different_types", not eq (c1, c2))
			assert ("different_references_different_types_ok", properties.holds_ok (c1, c2, eq))
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively.
			-- Test {STS_REFERENCE_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_REFERENCE_EQUALITY}.holds_successively"
		do
			Precursor {REFERENCE_EQUALITY_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
