note
	description: "Test suite for {STI_TRANSFORMER [detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	TRANSFORMER_TESTS_IC

inherit
	TRANSFORMER_TESTS [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		rename
			some_object_a as some_integer_ref
		undefine
			on_prepare,
			some_equality,
			some_pair,
			some_preceding_pair_dsa_a,
			some_pair_aa,
			some_preceding_pair_aa,
			some_pair_ab,
			same_pair_ab,
			some_pair_ba,
			some_preceding_pair_ba,
			some_pair_bb,
			some_preceding_pair_bb,
			some_set,
			some_set_a,
			same_set_a,
			some_set_b,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a,
			some_n_tuple_b
		redefine
			test_is_in,
			test_is_not_in,
			test_cartesian_product,
			test_singleton_crossed_set,
			test_set_map,
			test_set_reduction,
			test_tuple_map,
			test_tuple_left_reduction,
			test_tuple_indexed_left_reduction,
			test_tuple_right_reduction,
			test_tuple_indexed_right_reduction,
			test_natural_as_integer,
			test_pair,
			test_o,
			test_empty_product,
			test_anded,
			test_every_pair_is_in_set,
			test_pair_is_in_set,
			test_target_set_has_value,
			test_source_set_has_argument,
			test_argument_is_mapped_to_value,
			test_target_tuple_has_value,
			test_source_tuple_has_argument,
			test_flipped,
			test_indexed_flipped,
			test_flipped_index_is_small_enough
		end

	ELEMENT_TESTS_NIC
		rename
			element_to_be_tested as transformer_to_be_tested
		undefine
			transformer_to_be_tested
		redefine
			properties,
			test_is_in,
			test_is_not_in
		end

feature -- Access

	properties: TRANSFORMER_PROPERTIES [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		end

feature -- Test routines (Membership)

	test_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STI_TRANSFORMER}.is_in.
			--| todo: renamed classes get unclickable.
			--| todo: renamed classes breaks metrics.
			--| todo: renamed classes breaks AutoTest filter.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STI_TRANSFORMER}.is_in"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STI_TRANSFORMER}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STI_TRANSFORMER}.is_not_in"
		do
			Precursor {TRANSFORMER_TESTS}
		end

feature -- Test routines (Operation)

	test_cartesian_product
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.cartesian_product"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_singleton_crossed_set
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.singleton_crossed_set"
		do
			Precursor {TRANSFORMER_TESTS}
		end

feature -- Test routines (Transformation)

	test_set_map
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.set_map"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_set_reduction
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.set_reduction"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_tuple_map
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.tuple_map"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_tuple_left_reduction
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.tuple_left_reduction"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_tuple_indexed_left_reduction
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.tuple_indexed_left_reduction"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_tuple_right_reduction
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.tuple_right_reduction"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_tuple_indexed_right_reduction
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.tuple_indexed_right_reduction"
		do
			Precursor {TRANSFORMER_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.natural_as_integer"
		do
			Precursor {TRANSFORMER_TESTS}
		end

feature -- Test routines (Factory)

	test_pair
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.pair"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_o
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.o"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_empty_product
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.empty_product"
		do
			Precursor {TRANSFORMER_TESTS}
		end

feature -- Test routines (Predicate)

	test_anded
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.anded"
			testing: "covers/{STI_TRANSFORMER}.anded"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_every_pair_is_in_set
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.every_pair_is_in_set"
			testing: "covers/{STI_TRANSFORMER}.every_pair_is_in_set"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_pair_is_in_set
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.pair_is_in_set"
			testing: "covers/{STI_TRANSFORMER}.pair_is_in_set"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_target_set_has_value
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.target_set_has_value"
			testing: "covers/{STI_TRANSFORMER}.target_set_has_value"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_source_set_has_argument
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.source_set_has_argument"
			testing: "covers/{STI_TRANSFORMER}.source_set_has_argument"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_argument_is_mapped_to_value
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.argument_is_mapped_to_value"
			testing: "covers/{STI_TRANSFORMER}.argument_is_mapped_to_value"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_target_tuple_has_value
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.target_tuple_has_value"
			testing: "covers/{STI_TRANSFORMER}.target_tuple_has_value"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_source_tuple_has_argument
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMER}.source_tuple_has_argument"
			testing: "covers/{STI_TRANSFORMER}.source_tuple_has_argument"
		do
			Precursor {TRANSFORMER_TESTS}
		end

feature -- Test routines (Reduction)

	test_flipped
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.flipped"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_indexed_flipped
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.indexed_flipped"
		do
			Precursor {TRANSFORMER_TESTS}
		end

	test_flipped_index_is_small_enough
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMER}.flipped_index_is_small_enough"
		do
			Precursor {TRANSFORMER_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
