note
	description: "Test suite for {STI_N_TUPLE [detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	N_TUPLE_TESTS_C

inherit
	N_TUPLE_TESTS [detachable separate CHARACTER_REF, STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]]
		rename
			some_object_a as some_character_ref
		undefine
			on_prepare
		redefine
			test_make_unit,
			test_make_after,
			test_make_n,
			test_make_from_tuple,
			test_is_unit,
			test_first,
			test_tail,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_indices,
			test_term,
			test_terms,
			test_front,
			test_last,
			test_before,
			test_after,
			test_out,
			test_terms_out,
			test_term_out,
			test_n,
			test_equals,
			test_unequals,
			test_exists,
			test_does_not_exist,
			test_for_all,
			test_left_trimmed,
			test_right_trimmed,
			test_prefix,
			test_suffix,
			test_reversed,
			test_replacing,
			test_concatenated,
			test_mapped,
			test_left_reduced,
			test_indexed_left_reduced,
			test_proper_left_reduced,
			test_right_reduced,
			test_indexed_right_reduced,
			test_proper_right_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_first_tail,
			test_front_last,
			test_unit,
			test_converted,
			test_converted_terms,
			test_predicate_holds_to_term,
			test_negated,
			test_terms_are_equal,
			test_reversed_terms_are_equal,
			test_index_is_positive,
			test_index_is_less_equal,
			test_just_index,
			test_indexed_term,
			test_appending_term_out
		end

	SETS_TESTS_RESOURCES_UNARY_C

feature -- Access

	properties: N_TUPLE_PROPERTIES [detachable separate CHARACTER_REF, STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]]
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Test routines (Initialization)

	test_make_unit
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.make_unit"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_make_after
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.make_after"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_make_n
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.make_n"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_make_from_tuple
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.make_from_tuple"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_unit
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.is_unit"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_first
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.first"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_tail
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.tail"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_eq
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.eq"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_N_TUPLE}.element_is_in.
			-- Test {STI_N_TUPLE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_N_TUPLE}.element_is_in"
			testing: "covers/{STI_N_TUPLE}.element_is_in"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_N_TUPLE}.element_is_not_in.
			-- Test {STI_N_TUPLE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_N_TUPLE}.element_is_not_in"
			testing: "covers/{STI_N_TUPLE}.element_is_not_in"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_is_in
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.is_in"
			testing: "covers/{STI_N_TUPLE}.is_in"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_is_not_in
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.is_not_in"
			testing: "covers/{STI_N_TUPLE}.is_not_in"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_has
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.has"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_does_not_have
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.does_not_have"
			testing: "covers/{STI_N_TUPLE}.does_not_have"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Access)

	test_indices
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.indices"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_term
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.term"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_terms
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.terms"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_front
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.front"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_last
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.last"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Construction)

	test_before
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.before"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_after
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.after"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Measurement)

	test_n
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.n"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.out"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_terms_out
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.terms_out"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_term_out
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.term_out"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.equals"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_unequals
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.unequals"
			testing: "covers/{STI_N_TUPLE}.unequals"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.exists"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.does_not_exist"
			testing: "covers/{STI_N_TUPLE}.does_not_exist"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_for_all
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.for_all"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Operation)

	test_left_trimmed
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.left_trimmed"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_right_trimmed
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.right_trimmed"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_prefix
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.prefix"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_suffix
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.suffix"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_reversed
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.reversed"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_replacing
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.replacing"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_concatenated
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.concatenated"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.mapped"
			testing: "covers/{STI_N_TUPLE}.mapped"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_left_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.left_reduced"
			testing: "covers/{STI_N_TUPLE}.left_reduced"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_indexed_left_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.indexed_left_reduced"
			testing: "covers/{STI_N_TUPLE}.indexed_left_reduced"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_proper_left_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.proper_left_reduced"
			testing: "covers/{STI_N_TUPLE}.proper_left_reduced"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_right_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.right_reduced"
			testing: "covers/{STI_N_TUPLE}.right_reduced"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_indexed_right_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.indexed_right_reduced"
			testing: "covers/{STI_N_TUPLE}.indexed_right_reduced"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_proper_right_reduced
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.proper_right_reduced"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.natural_as_integer"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_as_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.as_singleton"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_first_tail
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.first_tail"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_front_last
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.front_last"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Factory)

	test_unit
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.unit"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_converted
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.converted"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_converted_terms
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.converted_terms"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Predicate)

	test_predicate_holds_to_term
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.predicate_holds_to_term"
			testing: "covers/{STI_N_TUPLE}.predicate_holds_to_term"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_negated
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.negated"
			testing: "covers/{STI_N_TUPLE}.negated"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_terms_are_equal
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.terms_are_equal"
			testing: "covers/{STI_N_TUPLE}.terms_are_equal"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_reversed_terms_are_equal
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.reversed_terms_are_equal"
			testing: "covers/{STI_N_TUPLE}.reversed_terms_are_equal"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_index_is_positive
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.index_is_positive"
			testing: "covers/{STI_N_TUPLE}.index_is_positive"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_index_is_less_equal
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.index_is_less_equal"
			testing: "covers/{STI_N_TUPLE}.index_is_less_equal"
		do
			Precursor {N_TUPLE_TESTS}
		end

feature -- Test routines (Reduction)

	test_just_index
			-- <Precursor>
		note
			testing: "covers/{STS_N_TUPLE}.just_index"
			testing: "covers/{STI_N_TUPLE}.just_index"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_indexed_term
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.indexed_term"
		do
			Precursor {N_TUPLE_TESTS}
		end

	test_appending_term_out
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.appending_term_out"
		do
			Precursor {N_TUPLE_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
