note
	description: "Test suite for {STI_SET_TUPLE [detachable INTEGER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SET_TUPLE_TESTS_I

inherit
	SET_TUPLE_TESTS [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		undefine
			on_prepare
		redefine
			test_make_unit,
			test_make_after,
			test_make_n,
			test_make_from_tuple,
			test_is_unit,
			test_first,
			test_tail,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_indices,
			test_set,
			test_sets,
			test_front,
			test_last,
			test_before,
			test_after,
			test_out,
			test_sets_out,
			test_set_out,
			test_n,
			test_equals,
			test_unequals,
			test_exists,
			test_does_not_exist,
			test_for_all,
			test_for_all_tuples,
			test_left_trimmed,
			test_right_trimmed,
			test_prefix,
			test_suffix,
			test_reversed,
			test_replacing,
			test_concatenated,
			test_n_ary_union,
			test_n_ary_intersection,
			test_n_ary_product,
			test_mapped,
			test_left_reduced,
			test_indexed_left_reduced,
			test_proper_left_reduced,
			test_right_reduced,
			test_indexed_right_reduced,
			test_proper_right_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_first_tail,
			test_front_last,
			test_o,
			test_empty_set,
			test_unit_s,
			test_converted,
			test_converted_sets,
			test_unit,
			test_converted_set,
			test_predicate_holds_to_set,
			test_negated,
			test_sets_are_equal,
			test_reversed_sets_are_equal,
			test_index_is_positive,
			test_index_is_less_equal,
			test_just_index,
			test_indexed_set,
			test_appending_set_out
		end

	SETS_TESTS_RESOURCES_UNARY_SI

feature -- Access

	properties: SET_TUPLE_PROPERTIES [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Test routines (Initialization)

	test_make_unit
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.make_unit.
		note
			testing: "covers/{STI_N_TUPLE}.make_unit"
			testing: "covers/{STI_SET_TUPLE}.make_unit"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_make_after
			-- Test {STI_N_TUPLE}.make_after.
			-- Test {STI_SET_TUPLE}.make_after.
		note
			testing: "covers/{STI_N_TUPLE}.make_after"
			testing: "covers/{STI_SET_TUPLE}.make_after"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_make_n
			-- Test {STI_N_TUPLE}.make_n.
			-- Test {STI_SET_TUPLE}.make_n.
		note
			testing: "covers/{STI_N_TUPLE}.make_n"
			testing: "covers/{STI_SET_TUPLE}.make_n"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_make_from_tuple
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.make_from_tuple"
			testing: "covers/{STI_SET_TUPLE}.make_from_tuple"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_unit
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.is_unit.
		note
			testing: "covers/{STI_N_TUPLE}.is_unit"
			testing: "covers/{STI_SET_TUPLE}.is_unit"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_first
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.first.
		note
			testing: "covers/{STI_N_TUPLE}.first"
			testing: "covers/{STI_SET_TUPLE}.first"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_tail
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.tail.
		note
			testing: "covers/{STI_N_TUPLE}.tail"
			testing: "covers/{STI_SET_TUPLE}.tail"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_eq
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.eq.
		note
			testing: "covers/{STI_N_TUPLE}.eq"
			testing: "covers/{STI_SET_TUPLE}.eq"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_N_TUPLE}.element_is_in.
			-- Test {STI_N_TUPLE}.element_is_in.
			-- Test {STS_SET_TUPLE}.element_is_in.
			-- Test {STI_SET_TUPLE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_N_TUPLE}.element_is_in"
			testing: "covers/{STI_N_TUPLE}.element_is_in"
			testing: "covers/{STS_SET_TUPLE}.element_is_in"
			testing: "covers/{STI_SET_TUPLE}.element_is_in"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_N_TUPLE}.element_is_not_in.
			-- Test {STI_N_TUPLE}.element_is_not_in.
			-- Test {STS_SET_TUPLE}.element_is_not_in.
			-- Test {STI_SET_TUPLE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_N_TUPLE}.element_is_not_in"
			testing: "covers/{STI_N_TUPLE}.element_is_not_in"
			testing: "covers/{STS_SET_TUPLE}.element_is_not_in"
			testing: "covers/{STI_SET_TUPLE}.element_is_not_in"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.is_in.
			-- Test {STI_SET_TUPLE}.is_in.
		note
			testing: "covers/{STS_N_TUPLE}.is_in"
			testing: "covers/{STI_N_TUPLE}.is_in"
			testing: "covers/{STS_SET_TUPLE}.is_in"
			testing: "covers/{STI_SET_TUPLE}.is_in"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.is_not_in.
			-- Test {STI_SET_TUPLE}.is_not_in.
		note
			testing: "covers/{STS_N_TUPLE}.is_not_in"
			testing: "covers/{STI_N_TUPLE}.is_not_in"
			testing: "covers/{STS_SET_TUPLE}.is_not_in"
			testing: "covers/{STI_SET_TUPLE}.is_not_in"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_has
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.has.
		note
			testing: "covers/{STI_N_TUPLE}.has"
			testing: "covers/{STI_SET_TUPLE}.has"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.does_not_have.
			-- Test {STI_SET_TUPLE}.does_not_have.
		note
			testing: "covers/{STS_N_TUPLE}.does_not_have"
			testing: "covers/{STI_N_TUPLE}.does_not_have"
			testing: "covers/{STS_SET_TUPLE}.does_not_have"
			testing: "covers/{STI_SET_TUPLE}.does_not_have"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Access)

	test_indices
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.indices.
		note
			testing: "covers/{STI_N_TUPLE}.indices"
			testing: "covers/{STI_SET_TUPLE}.indices"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_set
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.set.
		note
			testing: "covers/{STI_N_TUPLE}.term"
			testing: "covers/{STI_SET_TUPLE}.set"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_sets
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.sets.
		note
			testing: "covers/{STI_N_TUPLE}.terms"
			testing: "covers/{STI_SET_TUPLE}.sets"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_front
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.front.
		note
			testing: "covers/{STI_N_TUPLE}.front"
			testing: "covers/{STI_SET_TUPLE}.front"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_last
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.last.
		note
			testing: "covers/{STI_N_TUPLE}.last"
			testing: "covers/{STI_SET_TUPLE}.last"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Construction)

	test_before
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.before.
		note
			testing: "covers/{STI_N_TUPLE}.before"
			testing: "covers/{STI_SET_TUPLE}.before"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_after
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.after.
		note
			testing: "covers/{STI_N_TUPLE}.after"
			testing: "covers/{STI_SET_TUPLE}.after"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.out.
		note
			testing: "covers/{STI_N_TUPLE}.out"
			testing: "covers/{STI_SET_TUPLE}.out"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_sets_out
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.sets_out.
		note
			testing: "covers/{STI_N_TUPLE}.terms_out"
			testing: "covers/{STI_SET_TUPLE}.sets_out"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_set_out
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.set_out.
		note
			testing: "covers/{STI_N_TUPLE}.term_out"
			testing: "covers/{STI_SET_TUPLE}.set_out"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Measurement)

	test_n
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.n.
		note
			testing: "covers/{STI_N_TUPLE}.n"
			testing: "covers/{STI_SET_TUPLE}.n"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.equals.
		note
			testing: "covers/{STI_N_TUPLE}.equals"
			testing: "covers/{STI_SET_TUPLE}.equals"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.unequals.
			-- Test {STI_SET_TUPLE}.unequals.
		note
			testing: "covers/{STS_N_TUPLE}.unequals"
			testing: "covers/{STI_N_TUPLE}.unequals"
			testing: "covers/{STS_SET_TUPLE}.unequals"
			testing: "covers/{STI_SET_TUPLE}.unequals"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.exists.
		note
			testing: "covers/{STI_N_TUPLE}.exists"
			testing: "covers/{STI_SET_TUPLE}.exists"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.does_not_exist.
			-- Test {STI_SET_TUPLE}.does_not_exist.
		note
			testing: "covers/{STS_N_TUPLE}.does_not_exist"
			testing: "covers/{STI_N_TUPLE}.does_not_exist"
			testing: "covers/{STS_SET_TUPLE}.does_not_exist"
			testing: "covers/{STI_SET_TUPLE}.does_not_exist"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.for_all.
		note
			testing: "covers/{STI_N_TUPLE}.for_all"
			testing: "covers/{STI_SET_TUPLE}.for_all"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_for_all_tuples
			-- <Precursor>
		note
			testing: "covers/{STI_SET_TUPLE}.for_all_tuples"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Operation)

	test_left_trimmed
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.left_trimmed.
		note
			testing: "covers/{STI_N_TUPLE}.left_trimmed"
			testing: "covers/{STI_SET_TUPLE}.left_trimmed"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_right_trimmed
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.right_trimmed.
		note
			testing: "covers/{STI_N_TUPLE}.right_trimmed"
			testing: "covers/{STI_SET_TUPLE}.right_trimmed"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_prefix
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.prefix.
		note
			testing: "covers/{STI_N_TUPLE}.prefix"
			testing: "covers/{STI_SET_TUPLE}.prefix"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_suffix
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.suffix.
		note
			testing: "covers/{STI_N_TUPLE}.suffix"
			testing: "covers/{STI_SET_TUPLE}.suffix"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_reversed
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.reversed.
		note
			testing: "covers/{STI_N_TUPLE}.reversed"
			testing: "covers/{STI_SET_TUPLE}.reversed"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_replacing
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.replacing.
		note
			testing: "covers/{STI_N_TUPLE}.replacing"
			testing: "covers/{STI_SET_TUPLE}.replacing"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_concatenated
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.concatenated.
		note
			testing: "covers/{STI_N_TUPLE}.concatenated"
			testing: "covers/{STI_SET_TUPLE}.concatenated"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_n_ary_union
			-- <Precursor>
		note
			testing: "covers/{STS_SET_TUPLE}.n_ary_union"
			testing: "covers/{STI_SET_TUPLE}.n_ary_union"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_n_ary_intersection
			-- <Precursor>
		note
			testing: "covers/{STS_SET_TUPLE}.n_ary_intersection"
			testing: "covers/{STI_SET_TUPLE}.n_ary_intersection"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_n_ary_product
			-- <Precursor>
		note
			testing: "covers/{STI_SET_TUPLE}.n_ary_product"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.mapped.
			-- Test {STI_SET_TUPLE}.mapped.
		note
			testing: "covers/{STS_N_TUPLE}.mapped"
			testing: "covers/{STI_N_TUPLE}.mapped"
			testing: "covers/{STS_SET_TUPLE}.mapped"
			testing: "covers/{STI_SET_TUPLE}.mapped"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_left_reduced
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.left_reduced.
			-- Test {STI_SET_TUPLE}.left_reduced.
		note
			testing: "covers/{STS_N_TUPLE}.left_reduced"
			testing: "covers/{STI_N_TUPLE}.left_reduced"
			testing: "covers/{STS_SET_TUPLE}.left_reduced"
			testing: "covers/{STI_SET_TUPLE}.left_reduced"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_indexed_left_reduced
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.indexed_left_reduced.
			-- Test {STI_SET_TUPLE}.indexed_left_reduced.
		note
			testing: "covers/{STS_N_TUPLE}.indexed_left_reduced"
			testing: "covers/{STI_N_TUPLE}.indexed_left_reduced"
			testing: "covers/{STS_SET_TUPLE}.indexed_left_reduced"
			testing: "covers/{STI_SET_TUPLE}.indexed_left_reduced"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_proper_left_reduced
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.proper_left_reduced.
			-- Test {STI_SET_TUPLE}.proper_left_reduced.
		note
			testing: "covers/{STS_N_TUPLE}.proper_left_reduced"
			testing: "covers/{STI_N_TUPLE}.proper_left_reduced"
			testing: "covers/{STS_SET_TUPLE}.proper_left_reduced"
			testing: "covers/{STI_SET_TUPLE}.proper_left_reduced"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_right_reduced
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.right_reduced.
			-- Test {STI_SET_TUPLE}.right_reduced.
		note
			testing: "covers/{STS_N_TUPLE}.right_reduced"
			testing: "covers/{STI_N_TUPLE}.right_reduced"
			testing: "covers/{STS_SET_TUPLE}.right_reduced"
			testing: "covers/{STI_SET_TUPLE}.right_reduced"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_indexed_right_reduced
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.indexed_right_reduced.
			-- Test {STI_SET_TUPLE}.indexed_right_reduced.
		note
			testing: "covers/{STS_N_TUPLE}.indexed_right_reduced"
			testing: "covers/{STI_N_TUPLE}.indexed_right_reduced"
			testing: "covers/{STS_SET_TUPLE}.indexed_right_reduced"
			testing: "covers/{STI_SET_TUPLE}.indexed_right_reduced"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_proper_right_reduced
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.proper_right_reduced.
		note
			testing: "covers/{STI_N_TUPLE}.proper_right_reduced"
			testing: "covers/{STI_SET_TUPLE}.proper_right_reduced"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.natural_as_integer.
		note
			testing: "covers/{STI_N_TUPLE}.natural_as_integer"
			testing: "covers/{STI_SET_TUPLE}.natural_as_integer"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.as_singleton.
		note
			testing: "covers/{STI_N_TUPLE}.as_singleton"
			testing: "covers/{STI_SET_TUPLE}.as_singleton"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_first_tail
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.first_tail.
		note
			testing: "covers/{STI_N_TUPLE}.first_tail"
			testing: "covers/{STI_SET_TUPLE}.first_tail"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_front_last
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.front_last.
		note
			testing: "covers/{STI_N_TUPLE}.front_last"
			testing: "covers/{STI_SET_TUPLE}.front_last"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_SET_TUPLE}.o.
		note
			testing: "covers/{STI_SET_TUPLE}.o"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_empty_set
			-- Test {STI_SET_TUPLE}.empty_set.
		note
			testing: "covers/{STI_SET_TUPLE}.empty_set"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_unit_s
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.unit_s.
		note
			testing: "covers/{STI_N_TUPLE}.unit"
			testing: "covers/{STI_SET_TUPLE}.unit_s"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.converted.
		note
			testing: "covers/{STI_N_TUPLE}.converted"
			testing: "covers/{STI_SET_TUPLE}.converted"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_converted_sets
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.converted_sets.
		note
			testing: "covers/{STI_N_TUPLE}.converted_terms"
			testing: "covers/{STI_SET_TUPLE}.converted_sets"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_unit
			-- <Precursor>
		note
			testing: "covers/{STI_SET_TUPLE}.unit"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_converted_set
			-- <Precursor>
		note
			testing: "covers/{STI_SET_TUPLE}.converted_set"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Predicate)

	test_predicate_holds_to_set
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.predicate_holds_to_set.
			-- Test {STI_SET_TUPLE}.predicate_holds_to_set.
		note
			testing: "covers/{STS_N_TUPLE}.predicate_holds_to_term"
			testing: "covers/{STI_N_TUPLE}.predicate_holds_to_term"
			testing: "covers/{STS_SET_TUPLE}.predicate_holds_to_set"
			testing: "covers/{STI_SET_TUPLE}.predicate_holds_to_set"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_negated
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.negated.
			-- Test {STI_SET_TUPLE}.negated.
		note
			testing: "covers/{STS_N_TUPLE}.negated"
			testing: "covers/{STI_N_TUPLE}.negated"
			testing: "covers/{STS_SET_TUPLE}.negated"
			testing: "covers/{STI_SET_TUPLE}.negated"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_sets_are_equal
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.sets_are_equal.
			-- Test {STI_SET_TUPLE}.sets_are_equal.
		note
			testing: "covers/{STS_N_TUPLE}.terms_are_equal"
			testing: "covers/{STI_N_TUPLE}.terms_are_equal"
			testing: "covers/{STS_SET_TUPLE}.sets_are_equal"
			testing: "covers/{STI_SET_TUPLE}.sets_are_equal"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_reversed_sets_are_equal
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.reversed_sets_are_equal.
			-- Test {STI_SET_TUPLE}.reversed_sets_are_equal.
		note
			testing: "covers/{STS_N_TUPLE}.reversed_terms_are_equal"
			testing: "covers/{STI_N_TUPLE}.reversed_terms_are_equal"
			testing: "covers/{STS_SET_TUPLE}.reversed_sets_are_equal"
			testing: "covers/{STI_SET_TUPLE}.reversed_sets_are_equal"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_index_is_positive
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.index_is_positive.
			-- Test {STI_SET_TUPLE}.index_is_positive.
		note
			testing: "covers/{STS_N_TUPLE}.index_is_positive"
			testing: "covers/{STI_N_TUPLE}.index_is_positive"
			testing: "covers/{STS_SET_TUPLE}.index_is_positive"
			testing: "covers/{STI_SET_TUPLE}.index_is_positive"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_index_is_less_equal
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.index_is_less_equal.
			-- Test {STI_SET_TUPLE}.index_is_less_equal.
		note
			testing: "covers/{STS_N_TUPLE}.index_is_less_equal"
			testing: "covers/{STI_N_TUPLE}.index_is_less_equal"
			testing: "covers/{STS_SET_TUPLE}.index_is_less_equal"
			testing: "covers/{STI_SET_TUPLE}.index_is_less_equal"
		do
			Precursor {SET_TUPLE_TESTS}
		end

feature -- Test routines (Reduction)

	test_just_index
			-- <Precursor>
			-- Test {STS_SET_TUPLE}.just_index.
			-- Test {STI_SET_TUPLE}.just_index.
		note
			testing: "covers/{STS_N_TUPLE}.just_index"
			testing: "covers/{STI_N_TUPLE}.just_index"
			testing: "covers/{STS_SET_TUPLE}.just_index"
			testing: "covers/{STI_SET_TUPLE}.just_index"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_indexed_set
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.indexed_set.
		note
			testing: "covers/{STI_N_TUPLE}.indexed_term"
			testing: "covers/{STI_SET_TUPLE}.indexed_set"
		do
			Precursor {SET_TUPLE_TESTS}
		end

	test_appending_set_out
			-- <Precursor>
			-- Test {STI_SET_TUPLE}.appending_set_out.
		note
			testing: "covers/{STI_N_TUPLE}.appending_term_out"
			testing: "covers/{STI_SET_TUPLE}.appending_set_out"
		do
			Precursor {SET_TUPLE_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
