note
	description: "Test suite for {STI_TRANSFORMABLE_TUPLE [detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	TRANSFORMABLE_TUPLE_TESTS_IC

inherit
	TRANSFORMABLE_TUPLE_TESTS [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF], STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		rename
			some_object_a as some_integer_ref
		undefine
			on_prepare,
			some_equality,
			some_pair,
			some_preceding_pair_dsa_a,
			some_pair_aa,
			some_preceding_pair_aa,
			some_pair_ab,
			same_pair_ab,
			some_pair_ba,
			some_preceding_pair_ba,
			some_pair_bb,
			some_preceding_pair_bb,
			some_set,
			some_set_a,
			same_set_a,
			some_set_b,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a,
			some_n_tuple_b
		redefine
			test_make_unit,
			test_make_after,
			test_make_n,
			test_make_from_tuple,
			test_is_unit,
			test_first,
			test_tail,
			test_eq_a,
			test_eq_b,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_indices,
			test_term,
			test_terms,
			test_front,
			test_last,
			test_before,
			test_after,
			test_out,
			test_terms_out,
			test_term_out,
			test_n,
			test_equals,
			test_unequals,
			test_exists,
			test_does_not_exist,
			test_for_all,
			test_left_trimmed,
			test_right_trimmed,
			test_prefix,
			test_suffix,
			test_reversed,
			test_replacing,
			test_concatenated,
			test_mapped_to_same_kind,
			test_mapped,
			test_left_reduced_to_term_like,
			test_left_reduced,
			test_indexed_left_reduced_to_term_like,
			test_indexed_left_reduced,
			test_proper_left_reduced,
			test_right_reduced_to_term_like,
			test_right_reduced,
			test_indexed_right_reduced_to_term_like,
			test_indexed_right_reduced,
			test_proper_right_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_first_tail,
			test_front_last,
			test_unit,
			test_converted,
			test_converted_terms,
			test_predicate_holds_to_term,
			test_negated,
			test_terms_are_equal,
			test_reversed_terms_are_equal,
			test_index_is_positive,
			test_index_is_less_equal,
			test_just_index,
			test_indexed_term,
			test_appending_term_out
		end

	N_TUPLE_TESTS_I
		rename
			test_eq as test_eq_a,
			test_mapped as test_mapped_to_same_kind,
			test_left_reduced as test_left_reduced_to_term_like,
			test_indexed_left_reduced as test_indexed_left_reduced_to_term_like,
			test_right_reduced as test_right_reduced_to_term_like,
			test_indexed_right_reduced as test_indexed_right_reduced_to_term_like
		undefine
			tuple_to_be_tested,
			tuple_from_ta,
			tuple_from_taa
		redefine
			properties,
			test_make_unit,
			test_make_after,
			test_make_n,
			test_make_from_tuple,
			test_is_unit,
			test_first,
			test_tail,
			test_eq_a,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_indices,
			test_term,
			test_terms,
			test_front,
			test_last,
			test_before,
			test_after,
			test_out,
			test_terms_out,
			test_term_out,
			test_n,
			test_equals,
			test_unequals,
			test_exists,
			test_does_not_exist,
			test_for_all,
			test_left_trimmed,
			test_right_trimmed,
			test_prefix,
			test_suffix,
			test_reversed,
			test_replacing,
			test_concatenated,
			test_mapped_to_same_kind,
			test_left_reduced_to_term_like,
			test_indexed_left_reduced_to_term_like,
			test_proper_left_reduced,
			test_right_reduced_to_term_like,
			test_indexed_right_reduced_to_term_like,
			test_proper_right_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_first_tail,
			test_front_last,
			test_unit,
			test_converted,
			test_converted_terms,
			test_predicate_holds_to_term,
			test_negated,
			test_terms_are_equal,
			test_reversed_terms_are_equal,
			test_index_is_positive,
			test_index_is_less_equal,
			test_just_index,
			test_indexed_term,
			test_appending_term_out
		end

feature -- Access

	properties: TRANSFORMABLE_TUPLE_PROPERTIES [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF], STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		end

feature -- Test routines (Initialization)

	test_make_unit
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.make_unit.
		note
			testing: "covers/{STI_N_TUPLE}.make_unit"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.make_unit"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_make_after
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.make_after.
		note
			testing: "covers/{STI_N_TUPLE}.make_after"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.make_after"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_make_n
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.make_n.
		note
			testing: "covers/{STI_N_TUPLE}.make_n"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.make_n"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_make_from_tuple
			-- <Precursor>
		note
			testing: "covers/{STI_N_TUPLE}.make_from_tuple"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.make_from_tuple"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_unit
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.is_unit.
		note
			testing: "covers/{STI_N_TUPLE}.is_unit"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.is_unit"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_first
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.first.
		note
			testing: "covers/{STI_N_TUPLE}.first"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.first"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_tail
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.tail.
		note
			testing: "covers/{STI_N_TUPLE}.tail"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.tail"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_eq_a
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.eq_a.
		note
			testing: "covers/{STI_N_TUPLE}.eq"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.eq_a"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_eq_b
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.eq_b"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_N_TUPLE}.element_is_in.
			-- Test {STI_N_TUPLE}.element_is_in.
			-- Test {STS_TRANSFORMABLE_TUPLE}.element_is_in.
			-- Test {STI_TRANSFORMABLE_TUPLE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_N_TUPLE}.element_is_in"
			testing: "covers/{STI_N_TUPLE}.element_is_in"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.element_is_in"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.element_is_in"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_N_TUPLE}.element_is_not_in.
			-- Test {STI_N_TUPLE}.element_is_not_in.
			-- Test {STS_TRANSFORMABLE_TUPLE}.element_is_not_in.
			-- Test {STI_TRANSFORMABLE_TUPLE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_N_TUPLE}.element_is_not_in"
			testing: "covers/{STI_N_TUPLE}.element_is_not_in"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.element_is_not_in"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.element_is_not_in"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.is_in.
			-- Test {STI_TRANSFORMABLE_TUPLE}.is_in.
		note
			testing: "covers/{STS_N_TUPLE}.is_in"
			testing: "covers/{STI_N_TUPLE}.is_in"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.is_in"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.is_in"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.is_not_in.
			-- Test {STI_TRANSFORMABLE_TUPLE}.is_not_in.
		note
			testing: "covers/{STS_N_TUPLE}.is_not_in"
			testing: "covers/{STI_N_TUPLE}.is_not_in"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.is_not_in"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.is_not_in"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_has
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.has.
		note
			testing: "covers/{STI_N_TUPLE}.has"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.has"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.does_not_have.
			-- Test {STI_TRANSFORMABLE_TUPLE}.does_not_have.
		note
			testing: "covers/{STS_N_TUPLE}.does_not_have"
			testing: "covers/{STI_N_TUPLE}.does_not_have"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.does_not_have"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.does_not_have"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Access)

	test_indices
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.indices.
		note
			testing: "covers/{STI_N_TUPLE}.indices"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.indices"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_term
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.term.
		note
			testing: "covers/{STI_N_TUPLE}.term"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.term"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_terms
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.terms.
		note
			testing: "covers/{STI_N_TUPLE}.terms"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.terms"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_front
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.front.
		note
			testing: "covers/{STI_N_TUPLE}.front"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.front"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_last
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.last.
		note
			testing: "covers/{STI_N_TUPLE}.last"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.last"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Construction)

	test_before
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.before.
		note
			testing: "covers/{STI_N_TUPLE}.before"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.before"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_after
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.after.
		note
			testing: "covers/{STI_N_TUPLE}.after"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.after"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.out.
		note
			testing: "covers/{STI_N_TUPLE}.out"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.out"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_terms_out
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.terms_out.
		note
			testing: "covers/{STI_N_TUPLE}.terms_out"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.terms_out"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_term_out
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.term_out.
		note
			testing: "covers/{STI_N_TUPLE}.term_out"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.term_out"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Measurement)

	test_n
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.n.
		note
			testing: "covers/{STI_N_TUPLE}.n"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.n"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.equals.
		note
			testing: "covers/{STI_N_TUPLE}.equals"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.equals"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.unequals.
			-- Test {STI_TRANSFORMABLE_TUPLE}.unequals.
		note
			testing: "covers/{STS_N_TUPLE}.unequals"
			testing: "covers/{STI_N_TUPLE}.unequals"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.unequals"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.unequals"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.exists.
		note
			testing: "covers/{STI_N_TUPLE}.exists"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.exists"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.does_not_exist.
			-- Test {STI_TRANSFORMABLE_TUPLE}.does_not_exist.
		note
			testing: "covers/{STS_N_TUPLE}.does_not_exist"
			testing: "covers/{STI_N_TUPLE}.does_not_exist"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.does_not_exist"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.does_not_exist"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.for_all.
		note
			testing: "covers/{STI_N_TUPLE}.for_all"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.for_all"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Operation)

	test_left_trimmed
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.left_trimmed.
		note
			testing: "covers/{STI_N_TUPLE}.left_trimmed"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.left_trimmed"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_right_trimmed
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.right_trimmed.
		note
			testing: "covers/{STI_N_TUPLE}.right_trimmed"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.right_trimmed"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_prefix
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.prefix.
		note
			testing: "covers/{STI_N_TUPLE}.prefix"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.prefix"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_suffix
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.suffix.
		note
			testing: "covers/{STI_N_TUPLE}.suffix"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.suffix"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_reversed
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.reversed.
		note
			testing: "covers/{STI_N_TUPLE}.reversed"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.reversed"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_replacing
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.replacing.
		note
			testing: "covers/{STI_N_TUPLE}.replacing"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.replacing"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_concatenated
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.concatenated.
		note
			testing: "covers/{STI_N_TUPLE}.concatenated"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.concatenated"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.mapped"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.mapped"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_mapped_to_same_kind
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.mapped_to_same_kind.
			-- Test {STI_TRANSFORMABLE_TUPLE}.mapped_to_same_kind.
		note
			testing: "covers/{STS_N_TUPLE}.mapped"
			testing: "covers/{STI_N_TUPLE}.mapped"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.mapped_to_same_kind"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.mapped_to_same_kind"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_left_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.left_reduced"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.left_reduced"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_left_reduced_to_term_like
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.left_reduced_to_term_like.
			-- Test {STI_TRANSFORMABLE_TUPLE}.left_reduced_to_term_like.
		note
			testing: "covers/{STS_N_TUPLE}.left_reduced"
			testing: "covers/{STI_N_TUPLE}.left_reduced"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.left_reduced_to_term_like"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.left_reduced_to_term_like"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_indexed_left_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.indexed_left_reduced"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.indexed_left_reduced"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_indexed_left_reduced_to_term_like
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.indexed_left_reduced_to_term_like.
			-- Test {STI_TRANSFORMABLE_TUPLE}.indexed_left_reduced_to_term_like.
		note
			testing: "covers/{STS_N_TUPLE}.indexed_left_reduced"
			testing: "covers/{STI_N_TUPLE}.indexed_left_reduced"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.indexed_left_reduced_to_term_like"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.indexed_left_reduced_to_term_like"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_proper_left_reduced
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.proper_left_reduced.
			-- Test {STI_TRANSFORMABLE_TUPLE}.proper_left_reduced.
		note
			testing: "covers/{STS_N_TUPLE}.proper_left_reduced"
			testing: "covers/{STI_N_TUPLE}.proper_left_reduced"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.proper_left_reduced"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.proper_left_reduced"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_right_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.right_reduced"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.right_reduced"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_right_reduced_to_term_like
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.right_reduced_to_term_like.
			-- Test {STI_TRANSFORMABLE_TUPLE}.right_reduced_to_term_like.
		note
			testing: "covers/{STS_N_TUPLE}.right_reduced"
			testing: "covers/{STI_N_TUPLE}.right_reduced"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.right_reduced_to_term_like"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.right_reduced_to_term_like"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_indexed_right_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.indexed_right_reduced"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.indexed_right_reduced"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_indexed_right_reduced_to_term_like
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.indexed_right_reduced_to_term_like.
			-- Test {STI_TRANSFORMABLE_TUPLE}.indexed_right_reduced_to_term_like.
		note
			testing: "covers/{STS_N_TUPLE}.indexed_right_reduced"
			testing: "covers/{STI_N_TUPLE}.indexed_right_reduced"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.indexed_right_reduced_to_term_like"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.indexed_right_reduced_to_term_like"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_proper_right_reduced
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.proper_right_reduced.
		note
			testing: "covers/{STI_N_TUPLE}.proper_right_reduced"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.proper_right_reduced"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.natural_as_integer.
		note
			testing: "covers/{STI_N_TUPLE}.natural_as_integer"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.natural_as_integer"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.as_singleton.
		note
			testing: "covers/{STI_N_TUPLE}.as_singleton"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.as_singleton"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_first_tail
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.first_tail.
		note
			testing: "covers/{STI_N_TUPLE}.first_tail"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.first_tail"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_front_last
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.front_last.
		note
			testing: "covers/{STI_N_TUPLE}.front_last"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.front_last"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Factory)

	test_unit
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.unit.
		note
			testing: "covers/{STI_N_TUPLE}.unit"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.unit"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.converted.
		note
			testing: "covers/{STI_N_TUPLE}.converted"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.converted"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_converted_terms
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.converted_terms.
		note
			testing: "covers/{STI_N_TUPLE}.converted_terms"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.converted_terms"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Predicate)

	test_predicate_holds_to_term
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.predicate_holds_to_term.
			-- Test {STI_TRANSFORMABLE_TUPLE}.predicate_holds_to_term.
		note
			testing: "covers/{STS_N_TUPLE}.predicate_holds_to_term"
			testing: "covers/{STI_N_TUPLE}.predicate_holds_to_term"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.predicate_holds_to_term"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.predicate_holds_to_term"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_negated
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.negated.
			-- Test {STI_TRANSFORMABLE_TUPLE}.negated.
		note
			testing: "covers/{STS_N_TUPLE}.negated"
			testing: "covers/{STI_N_TUPLE}.negated"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.negated"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.negated"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_terms_are_equal
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.terms_are_equal.
			-- Test {STI_TRANSFORMABLE_TUPLE}.terms_are_equal.
		note
			testing: "covers/{STS_N_TUPLE}.terms_are_equal"
			testing: "covers/{STI_N_TUPLE}.terms_are_equal"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.terms_are_equal"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.terms_are_equal"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_reversed_terms_are_equal
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.reversed_terms_are_equal.
			-- Test {STI_TRANSFORMABLE_TUPLE}.reversed_terms_are_equal.
		note
			testing: "covers/{STS_N_TUPLE}.reversed_terms_are_equal"
			testing: "covers/{STI_N_TUPLE}.reversed_terms_are_equal"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.reversed_terms_are_equal"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.reversed_terms_are_equal"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_index_is_positive
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.index_is_positive.
			-- Test {STI_TRANSFORMABLE_TUPLE}.index_is_positive.
		note
			testing: "covers/{STS_N_TUPLE}.index_is_positive"
			testing: "covers/{STI_N_TUPLE}.index_is_positive"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.index_is_positive"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.index_is_positive"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_index_is_less_equal
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.index_is_less_equal.
			-- Test {STI_TRANSFORMABLE_TUPLE}.index_is_less_equal.
		note
			testing: "covers/{STS_N_TUPLE}.index_is_less_equal"
			testing: "covers/{STI_N_TUPLE}.index_is_less_equal"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.index_is_less_equal"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.index_is_less_equal"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

feature -- Test routines (Reduction)

	test_just_index
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_TUPLE}.just_index.
			-- Test {STI_TRANSFORMABLE_TUPLE}.just_index.
		note
			testing: "covers/{STS_N_TUPLE}.just_index"
			testing: "covers/{STI_N_TUPLE}.just_index"
			testing: "covers/{STS_TRANSFORMABLE_TUPLE}.just_index"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.just_index"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_indexed_term
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.indexed_term.
		note
			testing: "covers/{STI_N_TUPLE}.indexed_term"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.indexed_term"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

	test_appending_term_out
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_TUPLE}.appending_term_out.
		note
			testing: "covers/{STI_N_TUPLE}.appending_term_out"
			testing: "covers/{STI_TRANSFORMABLE_TUPLE}.appending_term_out"
		do
			Precursor {TRANSFORMABLE_TUPLE_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
