note
	description: "[
		Test suite for {STI_COMPOSABLE_ORDERED_PAIR [NATURAL, detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	COMPOSABLE_ORDERED_PAIR_TESTS_NIC

inherit
	COMPOSABLE_ORDERED_PAIR_TESTS [
		NATURAL, detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [NATURAL],
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		rename
			some_object_a as some_integer_ref
		undefine
			on_prepare
		redefine
			test_make,
			test_make_from_pair,
			test_a, test_first,
			test_b, test_second,
			test_eq_a,
			test_eq_b,
			test_eq_w,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_out,
			test_first_out,
			test_second_out,
			test_equals,
			test_unequals,
			test_succeeds,
			test_inverse,
			test_composed_with_homogeneous,
			test_composed_with_inverse_like,
			test_composed,
			test_as_singleton
		end

	ORDERED_PAIR_TESTS_IC
		undefine
			pair_to_be_tested,
			pair_from_ab,
			pair_from_aab,
			pair_from_bab
		redefine
			properties,
			test_make,
			test_make_from_pair,
			test_a, test_first,
			test_b, test_second,
			test_eq_a,
			test_eq_b,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_out,
			test_first_out,
			test_second_out,
			test_equals,
			test_unequals,
			test_succeeds,
			test_inverse,
			test_composed_with_homogeneous,
			test_composed_with_inverse_like,
			test_as_singleton
		end

feature -- Access

	properties: COMPOSABLE_ORDERED_PAIR_PROPERTIES [
		NATURAL, detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [NATURAL],
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		end

feature -- Test routines (Initialization)

	test_make
			-- Test {STI_ORDERED_PAIR}.make.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.make.
		note
			testing: "covers/{STI_ORDERED_PAIR}.make"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.make"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_make_from_pair
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.make_from_pair"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.make_from_pair"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Primitive)

	test_a
			-- Test {STI_ORDERED_PAIR}.a.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.a.
		note
			testing: "covers/{STI_ORDERED_PAIR}.a"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.a"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_first
			-- Test {STI_ORDERED_PAIR}.first.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.first.
		note
			testing: "covers/{STI_ORDERED_PAIR}.first"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.first"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_b
			-- Test {STI_ORDERED_PAIR}.b.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.b.
		note
			testing: "covers/{STI_ORDERED_PAIR}.b"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.b"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_second
			-- Test {STI_ORDERED_PAIR}.second.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.second.
		note
			testing: "covers/{STI_ORDERED_PAIR}.second"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.second"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_eq_a
			-- Test {STI_ORDERED_PAIR}.eq_a.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.eq_a.
		note
			testing: "covers/{STI_ORDERED_PAIR}.eq_a"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.eq_a"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_eq_b
			-- Test {STI_ORDERED_PAIR}.eq_b.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.eq_b.
		note
			testing: "covers/{STI_ORDERED_PAIR}.eq_b"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.eq_b"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_eq_w
			-- <Precursor>
		note
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.eq_w"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STS_ORDERED_PAIR}.element_is_in.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.element_is_in.
			-- Test {STI_ORDERED_PAIR}.element_is_in.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_ORDERED_PAIR}.element_is_in"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.element_is_in"
			testing: "covers/{STI_ORDERED_PAIR}.element_is_in"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.element_is_in"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_element_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STS_ORDERED_PAIR}.element_is_not_in.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.element_is_not_in.
			-- Test {STI_ORDERED_PAIR}.element_is_not_in.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_ORDERED_PAIR}.element_is_not_in"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.element_is_not_in"
			testing: "covers/{STI_ORDERED_PAIR}.element_is_not_in"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.element_is_not_in"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_is_in
			-- Test {STS_ORDERED_PAIR}.is_in.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.is_in.
			-- Test {STI_ORDERED_PAIR}.is_in.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.is_in.
		note
			testing: "covers/{STS_ORDERED_PAIR}.is_in"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.is_in"
			testing: "covers/{STI_ORDERED_PAIR}.is_in"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.is_in"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_is_not_in
			-- Test {STS_ORDERED_PAIR}.is_not_in.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.is_not_in.
			-- Test {STI_ORDERED_PAIR}.is_not_in.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.is_not_in.
		note
			testing: "covers/{STS_ORDERED_PAIR}.is_not_in"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.is_not_in"
			testing: "covers/{STI_ORDERED_PAIR}.is_not_in"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.is_not_in"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- Test {STI_ORDERED_PAIR}.out.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.out.
		note
			testing: "covers/{STI_ORDERED_PAIR}.out"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.out"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_first_out
			-- Test {STI_ORDERED_PAIR}.first_out.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.first_out.
		note
			testing: "covers/{STI_ORDERED_PAIR}.first_out"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.first_out"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_second_out
			-- Test {STI_ORDERED_PAIR}.second_out.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.second_out.
		note
			testing: "covers/{STI_ORDERED_PAIR}.second_out"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.second_out"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- Test {STS_ORDERED_PAIR}.equals.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.equals.
			-- Test {STI_ORDERED_PAIR}.equals.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.equals.
		note
			testing: "covers/{STS_ORDERED_PAIR}.equals"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.equals"
			testing: "covers/{STI_ORDERED_PAIR}.equals"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.equals"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_unequals
			-- Test {STS_ORDERED_PAIR}.unequals.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.unequals.
			-- Test {STI_ORDERED_PAIR}.unequals.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.unequals.
		note
			testing: "covers/{STS_ORDERED_PAIR}.unequals"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.unequals"
			testing: "covers/{STI_ORDERED_PAIR}.unequals"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.unequals"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_succeeds
			-- Test {STS_ORDERED_PAIR}.succeeds.
			-- Test {STS_COMPOSABLE_ORDERED_PAIR}.succeeds.
			-- Test {STI_ORDERED_PAIR}.succeeds.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.succeeds.
		note
			testing: "covers/{STS_ORDERED_PAIR}.succeeds"
			testing: "covers/{STS_COMPOSABLE_ORDERED_PAIR}.succeeds"
			testing: "covers/{STI_ORDERED_PAIR}.succeeds"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.succeeds"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Operation)

	test_inverse
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.inverse.
		note
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.inverse"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_composed_with_homogeneous
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.composed_with_homogeneous.
		note
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.composed_with_homogeneous"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_composed_with_inverse_like
			-- Test {STI_ORDERED_PAIR}.composed_with_inverse_like.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.composed_with_inverse_like.
		note
			testing: "covers/{STI_ORDERED_PAIR}.composed_with_inverse_like"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.composed_with_inverse_like"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

	test_composed
			-- <Precursor>
		note
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.composed"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Conversion)

	test_as_singleton
			-- Test {STI_ORDERED_PAIR}.as_singleton.
			-- Test {STI_COMPOSABLE_ORDERED_PAIR}.as_singleton.
		note
			testing: "covers/{STI_ORDERED_PAIR}.as_singleton"
			testing: "covers/{STI_COMPOSABLE_ORDERED_PAIR}.as_singleton"
		do
			Precursor {COMPOSABLE_ORDERED_PAIR_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
