note
	description: "Test suite for {STI_ORDERED_PAIR [detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	ORDERED_PAIR_TESTS_IC

inherit
	ORDERED_PAIR_TESTS [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		rename
			some_object_a as some_integer_ref
		undefine
			on_prepare,
			some_equality,
			some_pair,
			some_preceding_pair_dsa_a,
			some_pair_aa,
			some_preceding_pair_aa,
			some_pair_ab,
			same_pair_ab,
			some_pair_ba,
			some_preceding_pair_ba,
			some_pair_bb,
			some_preceding_pair_bb,
			some_set,
			some_set_a,
			same_set_a,
			some_set_b,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a,
			some_n_tuple_b
		redefine
			test_make,
			test_make_from_pair,
			test_a, test_first,
			test_b, test_second,
			test_eq_a,
			test_eq_b,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_out,
			test_first_out,
			test_second_out,
			test_equals,
			test_unequals,
			test_succeeds,
			test_inverse,
			test_composed_with_homogeneous,
			test_composed_with_inverse_like,
			test_as_singleton
		end

	ELEMENT_TESTS_NIC
		rename
			test_is_in as test_element_is_in,
			test_is_not_in as test_element_is_not_in,
			element_to_be_tested as pair_to_be_tested
		undefine
			pair_to_be_tested
		redefine
			properties,
			test_element_is_in,
			test_element_is_not_in
		end

feature -- Access

	properties: ORDERED_PAIR_PROPERTIES [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		end

feature -- Test routines (Initialization)

	test_make
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.make"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_make_from_pair
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.make_from_pair"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Primitive)

	test_a
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.a"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_first
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.first"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_b
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.b"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_second
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.second"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_eq_a
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.eq_a"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_eq_b
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.eq_b"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_ORDERED_PAIR}.element_is_in.
			-- Test {STI_ORDERED_PAIR}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_ORDERED_PAIR}.element_is_in"
			testing: "covers/{STI_ORDERED_PAIR}.element_is_in"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_ORDERED_PAIR}.element_is_not_in.
			-- Test {STI_ORDERED_PAIR}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_ORDERED_PAIR}.element_is_not_in"
			testing: "covers/{STI_ORDERED_PAIR}.element_is_not_in"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_is_in
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR}.is_in"
			testing: "covers/{STI_ORDERED_PAIR}.is_in"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_is_not_in
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR}.is_not_in"
			testing: "covers/{STI_ORDERED_PAIR}.is_not_in"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.out"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_first_out
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.first_out"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_second_out
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.second_out"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR}.equals"
			testing: "covers/{STI_ORDERED_PAIR}.equals"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_unequals
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR}.unequals"
			testing: "covers/{STI_ORDERED_PAIR}.unequals"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_succeeds
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR}.succeeds"
			testing: "covers/{STI_ORDERED_PAIR}.succeeds"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Operation)

	test_inverse
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.inverse"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_composed_with_homogeneous
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.composed_with_homogeneous"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

	test_composed_with_inverse_like
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.composed_with_inverse_like"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

feature -- Test routines (Conversion)

	test_as_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR}.as_singleton"
		do
			Precursor {ORDERED_PAIR_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
