note
	description: "Test suite for {STI_SET_OF_ORDERED_PAIRS [detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SET_OF_ORDERED_PAIRS_TESTS_IC

inherit
	SET_OF_ORDERED_PAIRS_TESTS [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		redefine
			on_prepare,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_exist_xy,
			test_do_not_exist_xy,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_for_all_xy,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_filtered_xy,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_pair,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_predicate_holds_to_xy,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SETS_TESTS_RESOURCES_UNARY_IC
		rename
			eq_ab as eq
		redefine
			on_prepare
		end

feature -- Access

	properties: SET_OF_ORDERED_PAIRS_PROPERTIES [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		ensure then
--			class
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_UNARY_IC}
			create properties
		end

feature -- Test routines (Initialization)

	test_make_empty
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.make_empty.
		note
			testing: "covers/{STI_SET}.make_empty"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.make_empty"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_make_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.make_singleton.
		note
			testing: "covers/{STI_SET}.make_singleton"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.make_singleton"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_make_extended
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.make_extended.
		note
			testing: "covers/{STI_SET}.make_extended"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.make_extended"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_make_from_set
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.make_from_set"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.make_from_set"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_empty.
		note
			testing: "covers/{STI_SET}.is_empty"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_empty"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_any
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.any.
		note
			testing: "covers/{STI_SET}.any"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.any"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.others"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_eq
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.eq.
		note
			testing: "covers/{STI_SET}.eq"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.element_is_in"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_SET_OF_ORDERED_PAIRS}.element_is_in.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.element_is_in"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.element_is_in"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_SET_OF_ORDERED_PAIRS}.element_is_not_in.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.element_is_not_in"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.element_is_not_in"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_in.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_in"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_in"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_not_in.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_not_in"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_not_in"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_has
			-- Test {STI_SET_OF_ORDERED_PAIRS}.has.
		note
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.has"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.does_not_have.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.does_not_have"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.does_not_have"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.with.
		note
			testing: "covers/{STI_SET}.with"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.with"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_without
			-- Test {STI_SET_OF_ORDERED_PAIRS}.without.
		note
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.without"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.extended.
		note
			testing: "covers/{STI_SET}.extended"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.extended"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.batch_extended"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.out.
		note
			testing: "covers/{STI_SET}.out"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.out"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_singleton.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_singleton.
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_singleton"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_singleton"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.cardinality.
		note
			testing: "covers/{STI_SET}.cardinality"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.cardinality"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.equals.
		note
			testing: "covers/{STI_SET}.equals"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.equals"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.unequals.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.unequals"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.unequals"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_subset.
		note
			testing: "covers/{STI_SET}.is_subset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_subset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_not_subset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_not_subset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_not_subset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_superset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_superset.
		note
			testing: "covers/{STS_SET}.is_superset"
			testing: "covers/{STI_SET}.is_superset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_superset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_superset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_not_superset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_not_superset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_not_superset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_comparable.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_comparable.
		note
			testing: "covers/{STS_SET}.is_comparable"
			testing: "covers/{STI_SET}.is_comparable"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_comparable"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_comparable"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_not_comparable.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_not_comparable.
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_not_comparable"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_not_comparable"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_strict_subset.
		note
			testing: "covers/{STI_SET}.is_strict_subset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_strict_subset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_not_strict_subset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_not_strict_subset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_not_strict_subset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_strict_superset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_strict_superset.
		note
			testing: "covers/{STS_SET}.is_strict_superset"
			testing: "covers/{STI_SET}.is_strict_superset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_strict_superset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_strict_superset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_not_strict_superset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_not_strict_superset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_not_strict_superset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_trivial_subset.
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_trivial_subset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_trivial_superset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_trivial_superset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_trivial_superset.
		note
			testing: "covers/{STS_SET}.is_trivial_superset"
			testing: "covers/{STI_SET}.is_trivial_superset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_trivial_superset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_trivial_superset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_proper_subset.
		note
			testing: "covers/{STI_SET}.is_proper_subset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_proper_subset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_proper_superset.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_proper_superset.
		note
			testing: "covers/{STS_SET}.is_proper_superset"
			testing: "covers/{STI_SET}.is_proper_superset"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_proper_superset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_proper_superset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_disjoint.
		note
			testing: "covers/{STI_SET}.is_disjoint"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_disjoint"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.intersects.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.intersects"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.intersects"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.is_partitioned.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.is_partitioned"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.is_partitioned"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.exists"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.does_not_exist.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.does_not_exist"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.does_not_exist"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.exists_unique"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.exists_pair"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.does_not_exist_pair.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.does_not_exist_pair"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.does_not_exist_pair"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.exists_distinct_pair"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_exist_xy
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.exist_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.exist_xy"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_do_not_exist_xy
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.do_not_exist_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.do_not_exist_xy"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.for_all"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.for_all_pairs"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.for_all_distinct_pairs"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_for_all_xy
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.for_all_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.for_all_xy"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.subsets.
		note
			testing: "covers/{STI_SET}.subsets"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.subsets"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_powerset
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.powerset.
		note
			testing: "covers/{STI_SET}.powerset"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.powerset"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_trivial_subsets
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.trivial_subsets.
		note
			testing: "covers/{STI_SET}.trivial_subsets"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.trivial_subsets"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_proper_subsets
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.proper_subsets.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.proper_subsets.
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.proper_subsets"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.proper_subsets"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.filtered"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_filtered_xy
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.filtered_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.filtered_xy"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.complemented.
		note
			testing: "covers/{STI_SET}.complemented"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.complemented"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_united
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.united.
		note
			testing: "covers/{STI_SET}.united"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.united"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.intersected.
		note
			testing: "covers/{STI_SET}.intersected"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.intersected"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_subtracted
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.subtracted.
		note
			testing: "covers/{STI_SET}.subtracted"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.subtracted"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.subtracted_symmetricaly"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.crossed.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.crossed"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.crossed"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_squared
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.squared.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.squared.
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.squared"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.squared"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_diagonal
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.diagonal.
		note
			testing: "covers/{STI_SET}.diagonal"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.diagonal"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.raised.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.raised"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.raised"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.crossed_tuples"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.singleton_crossed_tuples"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.mapped.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.mapped"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.mapped"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.reduced.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.reduced"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.reduced"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.proper_reduced.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.proper_reduced"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.proper_reduced"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.natural_as_integer"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.as_singleton.
		note
			testing: "covers/{STI_SET}.as_singleton"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.as_singleton"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.n_times"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_as_tuple
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.as_tuple.
		note
			testing: "covers/{STI_SET}.as_tuple"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.as_tuple"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Factory)

	test_o
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.o.
		note
			testing: "covers/{STI_SET}.o"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.o"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_empty_set
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.empty_set.
		note
			testing: "covers/{STI_SET}.empty_set"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.empty_set"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.singleton.
		note
			testing: "covers/{STI_SET}.singleton"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.singleton"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.pair"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.converted"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_converted_pair
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.converted_pair.
		note
			testing: "covers/{STI_SET}.converted_element"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.converted_pair"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_unit
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.unit.
		note
			testing: "covers/{STI_SET}.unit"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.unit"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.ored.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.ored"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.ored"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.xored.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.xored"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.xored"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.iff.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.iff"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.iff"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_SET_OF_ORDERED_PAIRS}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.equality_holds"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_subset_relation_holds
			-- Test {STI_SET_OF_ORDERED_PAIRS}.subset_relation_holds.
		note
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.subset_relation_holds"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_predicate_holds_to_xy
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.predicate_holds_to_xy"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.predicate_holds_to_xy"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.second_after_first.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.second_after_first"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.second_after_first"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.natural_successor.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.natural_successor"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.natural_successor"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.disjunction.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.disjunction"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.disjunction"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.conjunction.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.conjunction"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.conjunction"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_SET_OF_ORDERED_PAIRS}.sets_plus_same_sets_with_element.
			-- Test {STI_SET_OF_ORDERED_PAIRS}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SET_OF_ORDERED_PAIRS}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET_OF_ORDERED_PAIRS}.sets_plus_same_sets_with_element"
		do
			Precursor {SET_OF_ORDERED_PAIRS_TESTS}
		end

feature {NONE} -- Implementation

	max_asserted_tuples: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

	max_asserted_subsets: NATURAL = 1024 -- 2 ^ 10
			-- <Precursor>

	max_subsets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

	max_tuples: NATURAL = 46_656 -- 6 ^ 6
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
