note
	description: "Test suite for {STI_SET_PARTITION [detachable INTEGER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SET_PARTITION_TESTS_I

inherit
	SET_PARTITION_TESTS [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		undefine
			on_prepare
		redefine
			test_make_empty,
			test_family_make_singleton,
			test_make_singleton,
			test_family_make_extended,
			test_make_extended,
			test_family_make_from_set,
			test_make_from_partition,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_family_with,
			test_with,
			test_without,
			test_family_extended,
			test_extended,
			test_family_batch_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_is_partition,
			test_member_sets_are_disjoint,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_set_is_disjoint,
			test_sets_are_disjoint,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_partition_union,
			test_intersected,
			test_partition_intersection,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o_p,
			test_empty_partition,
			test_singleton,
			test_pair,
			test_family_converted,
			test_converted,
			test_unit_p,
			test_o,
			test_empty_member_set,
			test_converted_member_set,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_some_set_has,
			test_every_set_has,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SET_FAMILY_TESTS_I
		rename
			test_make_singleton as test_family_make_singleton,
			test_make_extended as test_family_make_extended,
			test_make_from_set as test_family_make_from_set,
			test_with as test_family_with,
			test_extended as test_family_extended,
			test_batch_extended as test_family_batch_extended,
			test_family_union as test_partition_union,
			test_family_intersection as test_partition_intersection,
			test_o_f as test_o_p,
			test_empty_family as test_empty_partition,
			test_unit_f as test_unit_p,
			test_converted as test_family_converted,
			set_family_to_be_tested as partition_to_be_tested,
			family_from_set_partition as partition_from_sp
		undefine
			partition_to_be_tested,
			family_from_sa,
			family_from_sti_sa,
			family_from_sa_a,
			family_from_sti_sa_a,
			family_from_saa,
			family_from_sti_saa,
			family_from_sa_ta,
			family_from_sti_sa_ta,
			family_from_sa_ssa,
			family_from_sti_sa_ssa,
			family_from_sa_sta,
			family_from_sti_sa_sta,
			family_from_sa_aa,
			family_from_sti_sa_aa,
			family_from_set_of_sets,
			family_from_sti_set_of_sets,
			family_from_sf,
			partition_from_sp,
			family_from_subset_family,
			family_from_sti_subset_family,
			family_from_subset_family_structure,
			family_from_sti_subset_family_structure
		redefine
			properties,
			test_make_empty,
			test_family_make_singleton,
			test_family_make_extended,
			test_family_batch_extended,
			test_family_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_family_with,
			test_without,
			test_family_extended,
			test_out,
			test_is_singleton,
			test_is_partition,
			test_member_sets_are_disjoint,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_set_is_disjoint,
			test_sets_are_disjoint,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_partition_union,
			test_intersected,
			test_partition_intersection,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o_p,
			test_empty_partition,
			test_singleton,
			test_pair,
			test_family_converted,
			test_unit_p,
			test_o,
			test_empty_member_set,
			test_converted_member_set,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_some_set_has,
			test_every_set_has,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

feature -- Access

	properties: SET_PARTITION_PROPERTIES [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
			-- <Precursor>
--		once
--			create Result
--		ensure then
--			class
--		end

feature -- Test routines (Initialization)

	test_make_empty
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.make_empty.
			-- Test {STI_SET_FAMILY}.make_empty.
			-- Test {STI_SET_PARTITION}.make_empty.
		note
			testing: "covers/{STI_SET}.make_empty"
			testing: "covers/{STI_SET_OF_SETS}.make_empty"
			testing: "covers/{STI_SET_FAMILY}.make_empty"
			testing: "covers/{STI_SET_PARTITION}.make_empty"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_family_make_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.family_make_singleton"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_make_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.make_singleton"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_family_make_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.family_make_extended"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_make_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.make_extended"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_family_make_from_set
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.family_make_from_set"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_make_from_partition
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.make_from_partition"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_empty.
			-- Test {STI_SET_FAMILY}.is_empty.
			-- Test {STI_SET_PARTITION}.is_empty.
		note
			testing: "covers/{STI_SET}.is_empty"
			testing: "covers/{STI_SET_OF_SETS}.is_empty"
			testing: "covers/{STI_SET_FAMILY}.is_empty"
			testing: "covers/{STI_SET_PARTITION}.is_empty"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_any
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.any.
			-- Test {STI_SET_FAMILY}.any.
			-- Test {STI_SET_PARTITION}.any.
		note
			testing: "covers/{STI_SET}.any"
			testing: "covers/{STI_SET_OF_SETS}.any"
			testing: "covers/{STI_SET_FAMILY}.any"
			testing: "covers/{STI_SET_PARTITION}.any"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.others.
			-- Test {STI_SET_FAMILY}.others.
			-- Test {STI_SET_PARTITION}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_SET_OF_SETS}.others"
			testing: "covers/{STI_SET_FAMILY}.others"
			testing: "covers/{STI_SET_PARTITION}.others"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_eq
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.eq.
			-- Test {STI_SET_FAMILY}.eq.
			-- Test {STI_SET_PARTITION}.eq.
		note
			testing: "covers/{STI_SET}.eq"
			testing: "covers/{STI_SET_OF_SETS}.eq"
			testing: "covers/{STI_SET_FAMILY}.eq"
			testing: "covers/{STI_SET_PARTITION}.eq"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_SET_OF_SETS}.element_is_in.
			-- Test {STI_SET_OF_SETS}.element_is_in.
			-- Test {STS_SET_FAMILY}.element_is_in.
			-- Test {STI_SET_FAMILY}.element_is_in.
			-- Test {STS_SET_PARTITION}.element_is_in.
			-- Test {STI_SET_PARTITION}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_SET_OF_SETS}.element_is_in"
			testing: "covers/{STI_SET_OF_SETS}.element_is_in"
			testing: "covers/{STS_SET_FAMILY}.element_is_in"
			testing: "covers/{STI_SET_FAMILY}.element_is_in"
			testing: "covers/{STS_SET_PARTITION}.element_is_in"
			testing: "covers/{STI_SET_PARTITION}.element_is_in"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_SET_OF_SETS}.element_is_not_in.
			-- Test {STI_SET_OF_SETS}.element_is_not_in.
			-- Test {STS_SET_FAMILY}.element_is_not_in.
			-- Test {STI_SET_FAMILY}.element_is_not_in.
			-- Test {STS_SET_PARTITION}.element_is_not_in.
			-- Test {STI_SET_PARTITION}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_SET_OF_SETS}.element_is_not_in"
			testing: "covers/{STI_SET_OF_SETS}.element_is_not_in"
			testing: "covers/{STS_SET_FAMILY}.element_is_not_in"
			testing: "covers/{STI_SET_FAMILY}.element_is_not_in"
			testing: "covers/{STS_SET_PARTITION}.element_is_not_in"
			testing: "covers/{STI_SET_PARTITION}.element_is_not_in"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_in.
			-- Test {STI_SET_OF_SETS}.is_in.
			-- Test {STS_SET_FAMILY}.is_in.
			-- Test {STI_SET_FAMILY}.is_in.
			-- Test {STS_SET_PARTITION}.is_in.
			-- Test {STI_SET_PARTITION}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_SET_OF_SETS}.is_in"
			testing: "covers/{STI_SET_OF_SETS}.is_in"
			testing: "covers/{STS_SET_FAMILY}.is_in"
			testing: "covers/{STI_SET_FAMILY}.is_in"
			testing: "covers/{STS_SET_PARTITION}.is_in"
			testing: "covers/{STI_SET_PARTITION}.is_in"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_in.
			-- Test {STI_SET_OF_SETS}.is_not_in.
			-- Test {STS_SET_FAMILY}.is_not_in.
			-- Test {STI_SET_FAMILY}.is_not_in.
			-- Test {STS_SET_PARTITION}.is_not_in.
			-- Test {STI_SET_PARTITION}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_SET_OF_SETS}.is_not_in"
			testing: "covers/{STI_SET_OF_SETS}.is_not_in"
			testing: "covers/{STS_SET_FAMILY}.is_not_in"
			testing: "covers/{STI_SET_FAMILY}.is_not_in"
			testing: "covers/{STS_SET_PARTITION}.is_not_in"
			testing: "covers/{STI_SET_PARTITION}.is_not_in"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_has
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.has.
			-- Test {STI_SET_FAMILY}.has.
			-- Test {STI_SET_PARTITION}.has.
		note
			testing: "covers/{STI_SET}.has"
			testing: "covers/{STI_SET_OF_SETS}.has"
			testing: "covers/{STI_SET_FAMILY}.has"
			testing: "covers/{STI_SET_PARTITION}.has"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.does_not_have.
			-- Test {STI_SET_OF_SETS}.does_not_have.
			-- Test {STS_SET_FAMILY}.does_not_have.
			-- Test {STI_SET_FAMILY}.does_not_have.
			-- Test {STS_SET_PARTITION}.does_not_have.
			-- Test {STI_SET_PARTITION}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_SET_OF_SETS}.does_not_have"
			testing: "covers/{STI_SET_OF_SETS}.does_not_have"
			testing: "covers/{STS_SET_FAMILY}.does_not_have"
			testing: "covers/{STI_SET_FAMILY}.does_not_have"
			testing: "covers/{STS_SET_PARTITION}.does_not_have"
			testing: "covers/{STI_SET_PARTITION}.does_not_have"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Construction)

	test_family_with
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.with.
			-- Test {STI_SET_FAMILY}.with.
			-- Test {STI_SET_PARTITION}.family_with.
		note
			testing: "covers/{STI_SET}.with"
			testing: "covers/{STI_SET_OF_SETS}.with"
			testing: "covers/{STI_SET_FAMILY}.with"
			testing: "covers/{STI_SET_PARTITION}.family_with"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_with
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.with"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_without
			-- Test {STI_SET_PARTITION}.without.
		note
			testing: "covers/{STI_SET_PARTITION}.without"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_family_extended
			-- Test {STI_SET_PARTITION}.family_extended.
		note
			testing: "covers/{STI_SET_PARTITION}.family_extended"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.extended"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_family_batch_extended
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.batch_extended.
			-- Test {STI_SET_FAMILY}.batch_extended.
			-- Test {STI_SET_PARTITION}.family_batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_SET_OF_SETS}.batch_extended"
			testing: "covers/{STI_SET_FAMILY}.batch_extended"
			testing: "covers/{STI_SET_PARTITION}.family_batch_extended"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_batch_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.batch_extended"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.out.
			-- Test {STI_SET_FAMILY}.out.
			-- Test {STI_SET_PARTITION}.out.
		note
			testing: "covers/{STI_SET}.out"
			testing: "covers/{STI_SET_OF_SETS}.out"
			testing: "covers/{STI_SET_FAMILY}.out"
			testing: "covers/{STI_SET_PARTITION}.out"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_singleton.
			-- Test {STI_SET_OF_SETS}.is_singleton.
			-- Test {STS_SET_FAMILY}.is_singleton.
			-- Test {STI_SET_FAMILY}.is_singleton.
			-- Test {STS_SET_PARTITION}.is_singleton.
			-- Test {STI_SET_PARTITION}.is_singleton.
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
			testing: "covers/{STS_SET_OF_SETS}.is_singleton"
			testing: "covers/{STI_SET_OF_SETS}.is_singleton"
			testing: "covers/{STS_SET_FAMILY}.is_singleton"
			testing: "covers/{STI_SET_FAMILY}.is_singleton"
			testing: "covers/{STS_SET_PARTITION}.is_singleton"
			testing: "covers/{STI_SET_PARTITION}.is_singleton"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_partition
			-- Test {STI_SET_PARTITION}.is_partition.
		note
			testing: "covers/{STI_SET_PARTITION}.is_partition"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_member_sets_are_disjoint
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.member_sets_are_disjoint"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.cardinality"
			testing: "covers/{STI_SET_OF_SETS}.cardinality"
			testing: "covers/{STI_SET_FAMILY}.cardinality"
			testing: "covers/{STI_SET_PARTITION}.cardinality"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.equals.
			-- Test {STI_SET_FAMILY}.equals.
			-- Test {STI_SET_PARTITION}.equals.
		note
			testing: "covers/{STI_SET}.equals"
			testing: "covers/{STI_SET_OF_SETS}.equals"
			testing: "covers/{STI_SET_FAMILY}.equals"
			testing: "covers/{STI_SET_PARTITION}.equals"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.unequals.
			-- Test {STI_SET_OF_SETS}.unequals.
			-- Test {STS_SET_FAMILY}.unequals.
			-- Test {STI_SET_FAMILY}.unequals.
			-- Test {STS_SET_PARTITION}.unequals.
			-- Test {STI_SET_PARTITION}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_SET_OF_SETS}.unequals"
			testing: "covers/{STI_SET_OF_SETS}.unequals"
			testing: "covers/{STS_SET_FAMILY}.unequals"
			testing: "covers/{STI_SET_FAMILY}.unequals"
			testing: "covers/{STS_SET_PARTITION}.unequals"
			testing: "covers/{STI_SET_PARTITION}.unequals"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_subset.
			-- Test {STI_SET_FAMILY}.is_subset.
			-- Test {STI_SET_PARTITION}.is_subset.
		note
			testing: "covers/{STI_SET}.is_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_subset"
			testing: "covers/{STI_SET_FAMILY}.is_subset"
			testing: "covers/{STI_SET_PARTITION}.is_subset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_subset.
			-- Test {STI_SET_OF_SETS}.is_not_subset.
			-- Test {STS_SET_FAMILY}.is_not_subset.
			-- Test {STI_SET_FAMILY}.is_not_subset.
			-- Test {STS_SET_PARTITION}.is_not_subset.
			-- Test {STI_SET_PARTITION}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_subset"
			testing: "covers/{STS_SET_FAMILY}.is_not_subset"
			testing: "covers/{STI_SET_FAMILY}.is_not_subset"
			testing: "covers/{STS_SET_PARTITION}.is_not_subset"
			testing: "covers/{STI_SET_PARTITION}.is_not_subset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_superset.
			-- Test {STI_SET_OF_SETS}.is_superset.
			-- Test {STS_SET_FAMILY}.is_superset.
			-- Test {STI_SET_FAMILY}.is_superset.
			-- Test {STS_SET_PARTITION}.is_superset.
			-- Test {STI_SET_PARTITION}.is_superset.
		note
			testing: "covers/{STS_SET}.is_superset"
			testing: "covers/{STI_SET}.is_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_superset"
			testing: "covers/{STS_SET_FAMILY}.is_superset"
			testing: "covers/{STI_SET_FAMILY}.is_superset"
			testing: "covers/{STS_SET_PARTITION}.is_superset"
			testing: "covers/{STI_SET_PARTITION}.is_superset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_superset.
			-- Test {STI_SET_OF_SETS}.is_not_superset.
			-- Test {STS_SET_FAMILY}.is_not_superset.
			-- Test {STI_SET_FAMILY}.is_not_superset.
			-- Test {STS_SET_PARTITION}.is_not_superset.
			-- Test {STI_SET_PARTITION}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_superset"
			testing: "covers/{STS_SET_FAMILY}.is_not_superset"
			testing: "covers/{STI_SET_FAMILY}.is_not_superset"
			testing: "covers/{STS_SET_PARTITION}.is_not_superset"
			testing: "covers/{STI_SET_PARTITION}.is_not_superset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_comparable.
			-- Test {STI_SET_OF_SETS}.is_comparable.
			-- Test {STS_SET_FAMILY}.is_comparable.
			-- Test {STI_SET_FAMILY}.is_comparable.
			-- Test {STS_SET_PARTITION}.is_comparable.
			-- Test {STI_SET_PARTITION}.is_comparable.
		note
			testing: "covers/{STS_SET}.is_comparable"
			testing: "covers/{STI_SET}.is_comparable"
			testing: "covers/{STS_SET_OF_SETS}.is_comparable"
			testing: "covers/{STI_SET_OF_SETS}.is_comparable"
			testing: "covers/{STS_SET_FAMILY}.is_comparable"
			testing: "covers/{STI_SET_FAMILY}.is_comparable"
			testing: "covers/{STS_SET_PARTITION}.is_comparable"
			testing: "covers/{STI_SET_PARTITION}.is_comparable"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_comparable.
			-- Test {STI_SET_OF_SETS}.is_not_comparable.
			-- Test {STS_SET_FAMILY}.is_not_comparable.
			-- Test {STI_SET_FAMILY}.is_not_comparable.
			-- Test {STS_SET_PARTITION}.is_not_comparable.
			-- Test {STI_SET_PARTITION}.is_not_comparable.
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
			testing: "covers/{STS_SET_OF_SETS}.is_not_comparable"
			testing: "covers/{STI_SET_OF_SETS}.is_not_comparable"
			testing: "covers/{STS_SET_FAMILY}.is_not_comparable"
			testing: "covers/{STI_SET_FAMILY}.is_not_comparable"
			testing: "covers/{STS_SET_PARTITION}.is_not_comparable"
			testing: "covers/{STI_SET_PARTITION}.is_not_comparable"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_strict_subset.
			-- Test {STI_SET_FAMILY}.is_strict_subset.
			-- Test {STI_SET_PARTITION}.is_strict_subset.
		note
			testing: "covers/{STI_SET}.is_strict_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_strict_subset"
			testing: "covers/{STI_SET_FAMILY}.is_strict_subset"
			testing: "covers/{STI_SET_PARTITION}.is_strict_subset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_strict_subset.
			-- Test {STI_SET_OF_SETS}.is_not_strict_subset.
			-- Test {STS_SET_FAMILY}.is_not_strict_subset.
			-- Test {STI_SET_FAMILY}.is_not_strict_subset.
			-- Test {STS_SET_PARTITION}.is_not_strict_subset.
			-- Test {STI_SET_PARTITION}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_strict_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_strict_subset"
			testing: "covers/{STS_SET_FAMILY}.is_not_strict_subset"
			testing: "covers/{STI_SET_FAMILY}.is_not_strict_subset"
			testing: "covers/{STS_SET_PARTITION}.is_not_strict_subset"
			testing: "covers/{STI_SET_PARTITION}.is_not_strict_subset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_strict_superset.
			-- Test {STI_SET_OF_SETS}.is_strict_superset.
			-- Test {STS_SET_FAMILY}.is_strict_superset.
			-- Test {STI_SET_FAMILY}.is_strict_superset.
			-- Test {STS_SET_PARTITION}.is_strict_superset.
			-- Test {STI_SET_PARTITION}.is_strict_superset.
		note
			testing: "covers/{STS_SET}.is_strict_superset"
			testing: "covers/{STI_SET}.is_strict_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_strict_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_strict_superset"
			testing: "covers/{STS_SET_FAMILY}.is_strict_superset"
			testing: "covers/{STI_SET_FAMILY}.is_strict_superset"
			testing: "covers/{STS_SET_PARTITION}.is_strict_superset"
			testing: "covers/{STI_SET_PARTITION}.is_strict_superset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_strict_superset.
			-- Test {STI_SET_OF_SETS}.is_not_strict_superset.
			-- Test {STS_SET_FAMILY}.is_not_strict_superset.
			-- Test {STI_SET_FAMILY}.is_not_strict_superset.
			-- Test {STS_SET_PARTITION}.is_not_strict_superset.
			-- Test {STI_SET_PARTITION}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_strict_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_strict_superset"
			testing: "covers/{STS_SET_FAMILY}.is_not_strict_superset"
			testing: "covers/{STI_SET_FAMILY}.is_not_strict_superset"
			testing: "covers/{STS_SET_PARTITION}.is_not_strict_superset"
			testing: "covers/{STI_SET_PARTITION}.is_not_strict_superset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_trivial_subset.
			-- Test {STI_SET_FAMILY}.is_trivial_subset.
			-- Test {STI_SET_PARTITION}.is_trivial_subset.
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_trivial_subset"
			testing: "covers/{STI_SET_FAMILY}.is_trivial_subset"
			testing: "covers/{STI_SET_PARTITION}.is_trivial_subset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_trivial_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_trivial_superset.
			-- Test {STI_SET_OF_SETS}.is_trivial_superset.
			-- Test {STS_SET_FAMILY}.is_trivial_superset.
			-- Test {STI_SET_FAMILY}.is_trivial_superset.
			-- Test {STS_SET_PARTITION}.is_trivial_superset.
			-- Test {STI_SET_PARTITION}.is_trivial_superset.
		note
			testing: "covers/{STS_SET}.is_trivial_superset"
			testing: "covers/{STI_SET}.is_trivial_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_trivial_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_trivial_superset"
			testing: "covers/{STS_SET_FAMILY}.is_trivial_superset"
			testing: "covers/{STI_SET_FAMILY}.is_trivial_superset"
			testing: "covers/{STS_SET_PARTITION}.is_trivial_superset"
			testing: "covers/{STI_SET_PARTITION}.is_trivial_superset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_proper_subset.
			-- Test {STI_SET_FAMILY}.is_proper_subset.
			-- Test {STI_SET_PARTITION}.is_proper_subset.
		note
			testing: "covers/{STI_SET}.is_proper_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_proper_subset"
			testing: "covers/{STI_SET_FAMILY}.is_proper_subset"
			testing: "covers/{STI_SET_PARTITION}.is_proper_subset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_proper_superset.
			-- Test {STI_SET_OF_SETS}.is_proper_superset.
			-- Test {STS_SET_FAMILY}.is_proper_superset.
			-- Test {STI_SET_FAMILY}.is_proper_superset.
			-- Test {STS_SET_PARTITION}.is_proper_superset.
			-- Test {STI_SET_PARTITION}.is_proper_superset.
		note
			testing: "covers/{STS_SET}.is_proper_superset"
			testing: "covers/{STI_SET}.is_proper_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_proper_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_proper_superset"
			testing: "covers/{STS_SET_FAMILY}.is_proper_superset"
			testing: "covers/{STI_SET_FAMILY}.is_proper_superset"
			testing: "covers/{STS_SET_PARTITION}.is_proper_superset"
			testing: "covers/{STI_SET_PARTITION}.is_proper_superset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_disjoint.
			-- Test {STI_SET_FAMILY}.is_disjoint.
			-- Test {STI_SET_PARTITION}.is_disjoint.
		note
			testing: "covers/{STI_SET}.is_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.is_disjoint"
			testing: "covers/{STI_SET_FAMILY}.is_disjoint"
			testing: "covers/{STI_SET_PARTITION}.is_disjoint"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.intersects.
			-- Test {STI_SET_OF_SETS}.intersects.
			-- Test {STS_SET_FAMILY}.intersects.
			-- Test {STI_SET_FAMILY}.intersects.
			-- Test {STS_SET_PARTITION}.intersects.
			-- Test {STI_SET_PARTITION}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_SET_OF_SETS}.intersects"
			testing: "covers/{STI_SET_OF_SETS}.intersects"
			testing: "covers/{STS_SET_FAMILY}.intersects"
			testing: "covers/{STI_SET_FAMILY}.intersects"
			testing: "covers/{STS_SET_PARTITION}.intersects"
			testing: "covers/{STI_SET_PARTITION}.intersects"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_partitioned.
			-- Test {STI_SET_OF_SETS}.is_partitioned.
			-- Test {STS_SET_FAMILY}.is_partitioned.
			-- Test {STI_SET_FAMILY}.is_partitioned.
			-- Test {STS_SET_PARTITION}.is_partitioned.
			-- Test {STI_SET_PARTITION}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_SET_OF_SETS}.is_partitioned"
			testing: "covers/{STI_SET_OF_SETS}.is_partitioned"
			testing: "covers/{STS_SET_FAMILY}.is_partitioned"
			testing: "covers/{STI_SET_FAMILY}.is_partitioned"
			testing: "covers/{STS_SET_PARTITION}.is_partitioned"
			testing: "covers/{STI_SET_PARTITION}.is_partitioned"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_set_is_disjoint
			-- <Precursor>
			-- Test {STS_SET_FAMILY}.set_is_disjoint.
			-- Test {STI_SET_FAMILY}.set_is_disjoint.
			-- Test {STS_SET_PARTITION}.set_is_disjoint.
			-- Test {STI_SET_PARTITION}.set_is_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.set_is_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.set_is_disjoint"
			testing: "covers/{STS_SET_FAMILY}.set_is_disjoint"
			testing: "covers/{STI_SET_FAMILY}.set_is_disjoint"
			testing: "covers/{STS_SET_PARTITION}.set_is_disjoint"
			testing: "covers/{STI_SET_PARTITION}.set_is_disjoint"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_sets_are_disjoint
			-- <Precursor>
			-- Test {STS_SET_FAMILY}.sets_are_disjoint.
			-- Test {STI_SET_FAMILY}.sets_are_disjoint.
			-- Test {STS_SET_PARTITION}.sets_are_disjoint.
			-- Test {STI_SET_PARTITION}.sets_are_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.sets_are_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.sets_are_disjoint"
			testing: "covers/{STS_SET_FAMILY}.sets_are_disjoint"
			testing: "covers/{STI_SET_FAMILY}.sets_are_disjoint"
			testing: "covers/{STS_SET_PARTITION}.sets_are_disjoint"
			testing: "covers/{STI_SET_PARTITION}.sets_are_disjoint"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_SET_OF_SETS}.exists"
			testing: "covers/{STI_SET_FAMILY}.exists"
			testing: "covers/{STI_SET_PARTITION}.exists"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.does_not_exist.
			-- Test {STI_SET_OF_SETS}.does_not_exist.
			-- Test {STS_SET_FAMILY}.does_not_exist.
			-- Test {STI_SET_FAMILY}.does_not_exist.
			-- Test {STS_SET_PARTITION}.does_not_exist.
			-- Test {STI_SET_PARTITION}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_SET_OF_SETS}.does_not_exist"
			testing: "covers/{STI_SET_OF_SETS}.does_not_exist"
			testing: "covers/{STS_SET_FAMILY}.does_not_exist"
			testing: "covers/{STI_SET_FAMILY}.does_not_exist"
			testing: "covers/{STS_SET_PARTITION}.does_not_exist"
			testing: "covers/{STI_SET_PARTITION}.does_not_exist"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.exists_unique.
			-- Test {STI_SET_FAMILY}.exists_unique.
			-- Test {STI_SET_PARTITION}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_SET_OF_SETS}.exists_unique"
			testing: "covers/{STI_SET_FAMILY}.exists_unique"
			testing: "covers/{STI_SET_PARTITION}.exists_unique"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_exists_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_SET_OF_SETS}.exists_pair"
			testing: "covers/{STI_SET_FAMILY}.exists_pair"
			testing: "covers/{STI_SET_PARTITION}.exists_pair"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.does_not_exist_pair.
			-- Test {STI_SET_OF_SETS}.does_not_exist_pair.
			-- Test {STS_SET_FAMILY}.does_not_exist_pair.
			-- Test {STI_SET_FAMILY}.does_not_exist_pair.
			-- Test {STS_SET_PARTITION}.does_not_exist_pair.
			-- Test {STI_SET_PARTITION}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_SET_OF_SETS}.does_not_exist_pair"
			testing: "covers/{STI_SET_OF_SETS}.does_not_exist_pair"
			testing: "covers/{STS_SET_FAMILY}.does_not_exist_pair"
			testing: "covers/{STI_SET_FAMILY}.does_not_exist_pair"
			testing: "covers/{STS_SET_PARTITION}.does_not_exist_pair"
			testing: "covers/{STI_SET_PARTITION}.does_not_exist_pair"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_SET_OF_SETS}.exists_distinct_pair"
			testing: "covers/{STI_SET_FAMILY}.exists_distinct_pair"
			testing: "covers/{STI_SET_PARTITION}.exists_distinct_pair"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.for_all.
			-- Test {STI_SET_FAMILY}.for_all.
			-- Test {STI_SET_PARTITION}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_SET_OF_SETS}.for_all"
			testing: "covers/{STI_SET_FAMILY}.for_all"
			testing: "covers/{STI_SET_PARTITION}.for_all"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.for_all_pairs.
			-- Test {STI_SET_FAMILY}.for_all_pairs.
			-- Test {STI_SET_PARTITION}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_SET_OF_SETS}.for_all_pairs"
			testing: "covers/{STI_SET_FAMILY}.for_all_pairs"
			testing: "covers/{STI_SET_PARTITION}.for_all_pairs"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.for_all_distinct_pairs.
			-- Test {STI_SET_FAMILY}.for_all_distinct_pairs.
			-- Test {STI_SET_PARTITION}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_SET_OF_SETS}.for_all_distinct_pairs"
			testing: "covers/{STI_SET_FAMILY}.for_all_distinct_pairs"
			testing: "covers/{STI_SET_PARTITION}.for_all_distinct_pairs"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subsets.
			-- Test {STI_SET_FAMILY}.subsets.
			-- Test {STI_SET_PARTITION}.subsets.
		note
			testing: "covers/{STI_SET}.subsets"
			testing: "covers/{STI_SET_OF_SETS}.subsets"
			testing: "covers/{STI_SET_FAMILY}.subsets"
			testing: "covers/{STI_SET_PARTITION}.subsets"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_powerset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.powerset.
			-- Test {STI_SET_FAMILY}.powerset.
			-- Test {STI_SET_PARTITION}.powerset.
		note
			testing: "covers/{STI_SET}.powerset"
			testing: "covers/{STI_SET_OF_SETS}.powerset"
			testing: "covers/{STI_SET_FAMILY}.powerset"
			testing: "covers/{STI_SET_PARTITION}.powerset"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_trivial_subsets
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.trivial_subsets.
			-- Test {STI_SET_FAMILY}.trivial_subsets.
			-- Test {STI_SET_PARTITION}.trivial_subsets.
		note
			testing: "covers/{STI_SET}.trivial_subsets"
			testing: "covers/{STI_SET_OF_SETS}.trivial_subsets"
			testing: "covers/{STI_SET_FAMILY}.trivial_subsets"
			testing: "covers/{STI_SET_PARTITION}.trivial_subsets"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_proper_subsets
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.proper_subsets.
			-- Test {STI_SET_OF_SETS}.proper_subsets.
			-- Test {STS_SET_FAMILY}.proper_subsets.
			-- Test {STI_SET_FAMILY}.proper_subsets.
			-- Test {STS_SET_PARTITION}.proper_subsets.
			-- Test {STI_SET_PARTITION}.proper_subsets.
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
			testing: "covers/{STS_SET_OF_SETS}.proper_subsets"
			testing: "covers/{STI_SET_OF_SETS}.proper_subsets"
			testing: "covers/{STS_SET_FAMILY}.proper_subsets"
			testing: "covers/{STI_SET_FAMILY}.proper_subsets"
			testing: "covers/{STS_SET_PARTITION}.proper_subsets"
			testing: "covers/{STI_SET_PARTITION}.proper_subsets"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_filtered
			-- Test {STI_SET_PARTITION}.filtered.
		note
			testing: "covers/{STI_SET_PARTITION}.filtered"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.complemented.
			-- Test {STI_SET_FAMILY}.complemented.
			-- Test {STI_SET_PARTITION}.complemented.
		note
			testing: "covers/{STI_SET}.complemented"
			testing: "covers/{STI_SET_OF_SETS}.complemented"
			testing: "covers/{STI_SET_FAMILY}.complemented"
			testing: "covers/{STI_SET_PARTITION}.complemented"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_united
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.united.
			-- Test {STI_SET_FAMILY}.united.
			-- Test {STI_SET_PARTITION}.united.
		note
			testing: "covers/{STI_SET}.united"
			testing: "covers/{STI_SET_OF_SETS}.united"
			testing: "covers/{STI_SET_FAMILY}.united"
			testing: "covers/{STI_SET_PARTITION}.united"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_partition_union
			-- Test {STI_SET_PARTITION}.partition_union.
		note
			testing: "covers/{STI_SET_PARTITION}.partition_union"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.intersected.
			-- Test {STI_SET_FAMILY}.intersected.
			-- Test {STI_SET_PARTITION}.intersected.
		note
			testing: "covers/{STI_SET}.intersected"
			testing: "covers/{STI_SET_OF_SETS}.intersected"
			testing: "covers/{STI_SET_FAMILY}.intersected"
			testing: "covers/{STI_SET_PARTITION}.intersected"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_partition_intersection
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.partition_intersection"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_subtracted
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subtracted.
			-- Test {STI_SET_FAMILY}.subtracted.
			-- Test {STI_SET_PARTITION}.subtracted.
		note
			testing: "covers/{STI_SET}.subtracted"
			testing: "covers/{STI_SET_OF_SETS}.subtracted"
			testing: "covers/{STI_SET_FAMILY}.subtracted"
			testing: "covers/{STI_SET_PARTITION}.subtracted"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subtracted_symmetricaly.
			-- Test {STI_SET_FAMILY}.subtracted_symmetricaly.
			-- Test {STI_SET_PARTITION}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_SET_OF_SETS}.subtracted_symmetricaly"
			testing: "covers/{STI_SET_FAMILY}.subtracted_symmetricaly"
			testing: "covers/{STI_SET_PARTITION}.subtracted_symmetricaly"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.crossed.
			-- Test {STI_SET_OF_SETS}.crossed.
			-- Test {STS_SET_FAMILY}.crossed.
			-- Test {STI_SET_FAMILY}.crossed.
			-- Test {STS_SET_PARTITION}.crossed.
			-- Test {STI_SET_PARTITION}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_SET_OF_SETS}.crossed"
			testing: "covers/{STI_SET_OF_SETS}.crossed"
			testing: "covers/{STS_SET_FAMILY}.crossed"
			testing: "covers/{STI_SET_FAMILY}.crossed"
			testing: "covers/{STS_SET_PARTITION}.crossed"
			testing: "covers/{STI_SET_PARTITION}.crossed"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_squared
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.squared.
			-- Test {STI_SET_OF_SETS}.squared.
			-- Test {STS_SET_FAMILY}.squared.
			-- Test {STI_SET_FAMILY}.squared.
			-- Test {STS_SET_PARTITION}.squared.
			-- Test {STI_SET_PARTITION}.squared.
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
			testing: "covers/{STS_SET_OF_SETS}.squared"
			testing: "covers/{STI_SET_OF_SETS}.squared"
			testing: "covers/{STS_SET_FAMILY}.squared"
			testing: "covers/{STI_SET_FAMILY}.squared"
			testing: "covers/{STS_SET_PARTITION}.squared"
			testing: "covers/{STI_SET_PARTITION}.squared"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_diagonal
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.diagonal.
			-- Test {STI_SET_FAMILY}.diagonal.
			-- Test {STI_SET_PARTITION}.diagonal.
		note
			testing: "covers/{STI_SET}.diagonal"
			testing: "covers/{STI_SET_OF_SETS}.diagonal"
			testing: "covers/{STI_SET_FAMILY}.diagonal"
			testing: "covers/{STI_SET_PARTITION}.diagonal"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.raised.
			-- Test {STI_SET_OF_SETS}.raised.
			-- Test {STS_SET_FAMILY}.raised.
			-- Test {STI_SET_FAMILY}.raised.
			-- Test {STS_SET_PARTITION}.raised.
			-- Test {STI_SET_PARTITION}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_SET_OF_SETS}.raised"
			testing: "covers/{STI_SET_OF_SETS}.raised"
			testing: "covers/{STS_SET_FAMILY}.raised"
			testing: "covers/{STI_SET_FAMILY}.raised"
			testing: "covers/{STS_SET_PARTITION}.raised"
			testing: "covers/{STI_SET_PARTITION}.raised"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.crossed_tuples.
			-- Test {STI_SET_FAMILY}.crossed_tuples.
			-- Test {STI_SET_PARTITION}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_SET_OF_SETS}.crossed_tuples"
			testing: "covers/{STI_SET_FAMILY}.crossed_tuples"
			testing: "covers/{STI_SET_PARTITION}.crossed_tuples"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.singleton_crossed_tuples.
			-- Test {STI_SET_FAMILY}.singleton_crossed_tuples.
			-- Test {STI_SET_PARTITION}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_SET_OF_SETS}.singleton_crossed_tuples"
			testing: "covers/{STI_SET_FAMILY}.singleton_crossed_tuples"
			testing: "covers/{STI_SET_PARTITION}.singleton_crossed_tuples"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.mapped.
			-- Test {STI_SET_OF_SETS}.mapped.
			-- Test {STS_SET_FAMILY}.mapped.
			-- Test {STI_SET_FAMILY}.mapped.
			-- Test {STS_SET_PARTITION}.mapped.
			-- Test {STI_SET_PARTITION}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_SET_OF_SETS}.mapped"
			testing: "covers/{STI_SET_OF_SETS}.mapped"
			testing: "covers/{STS_SET_FAMILY}.mapped"
			testing: "covers/{STI_SET_FAMILY}.mapped"
			testing: "covers/{STS_SET_PARTITION}.mapped"
			testing: "covers/{STI_SET_PARTITION}.mapped"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.reduced.
			-- Test {STI_SET_OF_SETS}.reduced.
			-- Test {STS_SET_FAMILY}.reduced.
			-- Test {STI_SET_FAMILY}.reduced.
			-- Test {STS_SET_PARTITION}.reduced.
			-- Test {STI_SET_PARTITION}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_SET_OF_SETS}.reduced"
			testing: "covers/{STI_SET_OF_SETS}.reduced"
			testing: "covers/{STS_SET_FAMILY}.reduced"
			testing: "covers/{STI_SET_FAMILY}.reduced"
			testing: "covers/{STS_SET_PARTITION}.reduced"
			testing: "covers/{STI_SET_PARTITION}.reduced"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.proper_reduced.
			-- Test {STI_SET_OF_SETS}.proper_reduced.
			-- Test {STS_SET_FAMILY}.proper_reduced.
			-- Test {STI_SET_FAMILY}.proper_reduced.
			-- Test {STS_SET_PARTITION}.proper_reduced.
			-- Test {STI_SET_PARTITION}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_SET_OF_SETS}.proper_reduced"
			testing: "covers/{STI_SET_OF_SETS}.proper_reduced"
			testing: "covers/{STS_SET_FAMILY}.proper_reduced"
			testing: "covers/{STI_SET_FAMILY}.proper_reduced"
			testing: "covers/{STS_SET_PARTITION}.proper_reduced"
			testing: "covers/{STI_SET_PARTITION}.proper_reduced"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.natural_as_integer.
			-- Test {STI_SET_FAMILY}.natural_as_integer.
			-- Test {STI_SET_PARTITION}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_SET_OF_SETS}.natural_as_integer"
			testing: "covers/{STI_SET_FAMILY}.natural_as_integer"
			testing: "covers/{STI_SET_PARTITION}.natural_as_integer"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.as_singleton.
			-- Test {STI_SET_FAMILY}.as_singleton.
			-- Test {STI_SET_PARTITION}.as_singleton.
		note
			testing: "covers/{STI_SET}.as_singleton"
			testing: "covers/{STI_SET_OF_SETS}.as_singleton"
			testing: "covers/{STI_SET_FAMILY}.as_singleton"
			testing: "covers/{STI_SET_PARTITION}.as_singleton"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.n_times.
			-- Test {STI_SET_FAMILY}.n_times.
			-- Test {STI_SET_PARTITION}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_SET_OF_SETS}.n_times"
			testing: "covers/{STI_SET_FAMILY}.n_times"
			testing: "covers/{STI_SET_PARTITION}.n_times"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_as_tuple
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.as_tuple.
			-- Test {STI_SET_FAMILY}.as_tuple.
			-- Test {STI_SET_PARTITION}.as_tuple.
		note
			testing: "covers/{STI_SET}.as_tuple"
			testing: "covers/{STI_SET_OF_SETS}.as_tuple"
			testing: "covers/{STI_SET_FAMILY}.as_tuple"
			testing: "covers/{STI_SET_PARTITION}.as_tuple"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Factory)

	test_o_p
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.o_s.
			-- Test {STI_SET_FAMILY}.o_f.
			-- Test {STI_SET_PARTITION}.o_p.
		note
			testing: "covers/{STI_SET}.o"
			testing: "covers/{STI_SET_OF_SETS}.o_s"
			testing: "covers/{STI_SET_FAMILY}.o_f"
			testing: "covers/{STI_SET_PARTITION}.o_p"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_empty_partition
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.empty_set_of_sets.
			-- Test {STI_SET_FAMILY}.empty_family.
			-- Test {STI_SET_PARTITION}.empty_partition.
		note
			testing: "covers/{STI_SET}.empty_set"
			testing: "covers/{STI_SET_OF_SETS}.empty_set_of_sets"
			testing: "covers/{STI_SET_FAMILY}.empty_family"
			testing: "covers/{STI_SET_PARTITION}.empty_partition"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.singleton.
			-- Test {STI_SET_FAMILY}.singleton.
			-- Test {STI_SET_PARTITION}.singleton.
		note
			testing: "covers/{STI_SET}.singleton"
			testing: "covers/{STI_SET_OF_SETS}.singleton"
			testing: "covers/{STI_SET_FAMILY}.singleton"
			testing: "covers/{STI_SET_PARTITION}.singleton"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.pair.
			-- Test {STI_SET_FAMILY}.pair.
			-- Test {STI_SET_PARTITION}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_SET_OF_SETS}.pair"
			testing: "covers/{STI_SET_FAMILY}.pair"
			testing: "covers/{STI_SET_PARTITION}.pair"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_family_converted
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.converted.
			-- Test {STI_SET_FAMILY}.converted.
			-- Test {STI_SET_PARTITION}.family_converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_SET_OF_SETS}.converted"
			testing: "covers/{STI_SET_FAMILY}.converted"
			testing: "covers/{STI_SET_PARTITION}.family_converted"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_converted
			-- <Precursor>
		note
			testing: "covers/{STI_SET_PARTITION}.converted"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_unit_p
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.unit_s.
			-- Test {STI_SET_FAMILY}.unit_f.
			-- Test {STI_SET_PARTITION}.unit_p.
		note
			testing: "covers/{STI_SET}.unit"
			testing: "covers/{STI_SET_OF_SETS}.unit_s"
			testing: "covers/{STI_SET_FAMILY}.unit_f"
			testing: "covers/{STI_SET_PARTITION}.unit_p"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_o
			-- <Precursor>
			-- Test {STI_SET_FAMILY}.o.
			-- Test {STI_SET_PARTITION}.o.
		note
			testing: "covers/{STI_SET_OF_SETS}.o"
			testing: "covers/{STI_SET_FAMILY}.o"
			testing: "covers/{STI_SET_PARTITION}.o"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_empty_member_set
			-- <Precursor>
			-- Test {STI_SET_FAMILY}.empty_member_set.
			-- Test {STI_SET_PARTITION}.empty_member_set.
		note
			testing: "covers/{STI_SET_OF_SETS}.empty_member_set"
			testing: "covers/{STI_SET_FAMILY}.empty_member_set"
			testing: "covers/{STI_SET_PARTITION}.empty_member_set"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_converted_member_set
			-- Test {STI_SET_OF_SETS}.converted_member_set.
			-- Test {STI_SET_FAMILY}.converted_member_set.
			-- Test {STI_SET_PARTITION}.converted_member_set.
		note
			testing: "covers/{STI_SET_OF_SETS}.converted_member_set"
			testing: "covers/{STI_SET_FAMILY}.converted_member_set"
			testing: "covers/{STI_SET_PARTITION}.converted_member_set"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.ored.
			-- Test {STI_SET_OF_SETS}.ored.
			-- Test {STS_SET_FAMILY}.ored.
			-- Test {STI_SET_FAMILY}.ored.
			-- Test {STS_SET_PARTITION}.ored.
			-- Test {STI_SET_PARTITION}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_SET_OF_SETS}.ored"
			testing: "covers/{STI_SET_OF_SETS}.ored"
			testing: "covers/{STS_SET_FAMILY}.ored"
			testing: "covers/{STI_SET_FAMILY}.ored"
			testing: "covers/{STS_SET_PARTITION}.ored"
			testing: "covers/{STI_SET_PARTITION}.ored"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.xored.
			-- Test {STI_SET_OF_SETS}.xored.
			-- Test {STS_SET_FAMILY}.xored.
			-- Test {STI_SET_FAMILY}.xored.
			-- Test {STS_SET_PARTITION}.xored.
			-- Test {STI_SET_PARTITION}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_SET_OF_SETS}.xored"
			testing: "covers/{STI_SET_OF_SETS}.xored"
			testing: "covers/{STS_SET_FAMILY}.xored"
			testing: "covers/{STI_SET_FAMILY}.xored"
			testing: "covers/{STS_SET_PARTITION}.xored"
			testing: "covers/{STI_SET_PARTITION}.xored"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.iff.
			-- Test {STI_SET_OF_SETS}.iff.
			-- Test {STS_SET_FAMILY}.iff.
			-- Test {STI_SET_FAMILY}.iff.
			-- Test {STS_SET_PARTITION}.iff.
			-- Test {STI_SET_PARTITION}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_SET_OF_SETS}.iff"
			testing: "covers/{STI_SET_OF_SETS}.iff"
			testing: "covers/{STS_SET_FAMILY}.iff"
			testing: "covers/{STI_SET_FAMILY}.iff"
			testing: "covers/{STS_SET_PARTITION}.iff"
			testing: "covers/{STI_SET_PARTITION}.iff"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.equality_holds.
			-- Test {STI_SET_FAMILY}.equality_holds.
			-- Test {STI_SET_PARTITION}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_SET_OF_SETS}.equality_holds"
			testing: "covers/{STI_SET_FAMILY}.equality_holds"
			testing: "covers/{STI_SET_PARTITION}.equality_holds"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subset_relation_holds.
			-- Test {STI_SET_FAMILY}.subset_relation_holds.
			-- Test {STI_SET_PARTITION}.subset_relation_holds.
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
			testing: "covers/{STI_SET_OF_SETS}.subset_relation_holds"
			testing: "covers/{STI_SET_FAMILY}.subset_relation_holds"
			testing: "covers/{STI_SET_PARTITION}.subset_relation_holds"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_some_set_has
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_SETS}.some_set_has"
			testing: "covers/{STI_SET_OF_SETS}.some_set_has"
			testing: "covers/{STS_SET_FAMILY}.some_set_has"
			testing: "covers/{STI_SET_FAMILY}.some_set_has"
			testing: "covers/{STS_SET_PARTITION}.some_set_has"
			testing: "covers/{STI_SET_PARTITION}.some_set_has"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_every_set_has
			-- <Precursor>
		note
			testing: "covers/{STS_SET_OF_SETS}.every_set_has"
			testing: "covers/{STI_SET_OF_SETS}.every_set_has"
			testing: "covers/{STS_SET_FAMILY}.every_set_has"
			testing: "covers/{STI_SET_FAMILY}.every_set_has"
			testing: "covers/{STS_SET_PARTITION}.every_set_has"
			testing: "covers/{STI_SET_PARTITION}.every_set_has"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.second_after_first.
			-- Test {STI_SET_OF_SETS}.second_after_first.
			-- Test {STS_SET_FAMILY}.second_after_first.
			-- Test {STI_SET_FAMILY}.second_after_first.
			-- Test {STS_SET_PARTITION}.second_after_first.
			-- Test {STI_SET_PARTITION}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_SET_OF_SETS}.second_after_first"
			testing: "covers/{STI_SET_OF_SETS}.second_after_first"
			testing: "covers/{STS_SET_FAMILY}.second_after_first"
			testing: "covers/{STI_SET_FAMILY}.second_after_first"
			testing: "covers/{STS_SET_PARTITION}.second_after_first"
			testing: "covers/{STI_SET_PARTITION}.second_after_first"
		do
			Precursor {SET_PARTITION_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.natural_successor.
			-- Test {STI_SET_OF_SETS}.natural_successor.
			-- Test {STS_SET_FAMILY}.natural_successor.
			-- Test {STI_SET_FAMILY}.natural_successor.
			-- Test {STS_SET_PARTITION}.natural_successor.
			-- Test {STI_SET_PARTITION}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_SET_OF_SETS}.natural_successor"
			testing: "covers/{STI_SET_OF_SETS}.natural_successor"
			testing: "covers/{STS_SET_FAMILY}.natural_successor"
			testing: "covers/{STI_SET_FAMILY}.natural_successor"
			testing: "covers/{STS_SET_PARTITION}.natural_successor"
			testing: "covers/{STI_SET_PARTITION}.natural_successor"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.disjunction.
			-- Test {STI_SET_OF_SETS}.disjunction.
			-- Test {STS_SET_FAMILY}.disjunction.
			-- Test {STI_SET_FAMILY}.disjunction.
			-- Test {STS_SET_PARTITION}.disjunction.
			-- Test {STI_SET_PARTITION}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_SET_OF_SETS}.disjunction"
			testing: "covers/{STI_SET_OF_SETS}.disjunction"
			testing: "covers/{STS_SET_FAMILY}.disjunction"
			testing: "covers/{STI_SET_FAMILY}.disjunction"
			testing: "covers/{STS_SET_PARTITION}.disjunction"
			testing: "covers/{STI_SET_PARTITION}.disjunction"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.conjunction.
			-- Test {STI_SET_OF_SETS}.conjunction.
			-- Test {STS_SET_FAMILY}.conjunction.
			-- Test {STI_SET_FAMILY}.conjunction.
			-- Test {STS_SET_PARTITION}.conjunction.
			-- Test {STI_SET_PARTITION}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_SET_OF_SETS}.conjunction"
			testing: "covers/{STI_SET_OF_SETS}.conjunction"
			testing: "covers/{STS_SET_FAMILY}.conjunction"
			testing: "covers/{STI_SET_FAMILY}.conjunction"
			testing: "covers/{STS_SET_PARTITION}.conjunction"
			testing: "covers/{STI_SET_PARTITION}.conjunction"
		do
			Precursor {SET_PARTITION_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.sets_plus_same_sets_with_element.
			-- Test {STI_SET_OF_SETS}.sets_plus_same_sets_with_element.
			-- Test {STS_SET_FAMILY}.sets_plus_same_sets_with_element.
			-- Test {STI_SET_FAMILY}.sets_plus_same_sets_with_element.
			-- Test {STS_SET_PARTITION}.sets_plus_same_sets_with_element.
			-- Test {STI_SET_PARTITION}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SET_OF_SETS}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET_OF_SETS}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SET_FAMILY}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET_FAMILY}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SET_PARTITION}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET_PARTITION}.sets_plus_same_sets_with_element"
		do
			Precursor {SET_PARTITION_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
