note
	description: "Test suite for {STI_SET [detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SET_TESTS_C

inherit
	SET_TESTS [detachable separate CHARACTER_REF, STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]]
		rename
			some_object_a as some_character_ref
		redefine
			on_prepare,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SETS_TESTS_RESOURCES_UNARY_C
		rename
			eq_a as eq
		redefine
			on_prepare
		end

feature -- Access

	properties: SET_PROPERTIES [detachable separate CHARACTER_REF, STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]]
			-- <Precursor>
--		once
--			create Result
--		ensure then
--			class
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_UNARY_C}
			create properties
		end

feature -- Test routines (Initialization)

	test_make_empty
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.make_empty"
		do
			Precursor {SET_TESTS}
		end

	test_make_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.make_singleton"
		do
			Precursor {SET_TESTS}
		end

	test_make_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.make_extended"
		do
			Precursor {SET_TESTS}
		end

	test_make_from_set
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.make_from_set"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_empty"
		do
			Precursor {SET_TESTS}
		end

	test_any
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.any"
		do
			Precursor {SET_TESTS}
		end

	test_others
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.others"
		do
			Precursor {SET_TESTS}
		end

	test_eq
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.eq"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
		do
			Precursor {SET_TESTS}
		end

	test_element_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
		do
			Precursor {SET_TESTS}
		end

	test_is_in
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
		do
			Precursor {SET_TESTS}
		end

	test_is_not_in
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
		do
			Precursor {SET_TESTS}
		end

	test_has
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.has"
		do
			Precursor {SET_TESTS}
		end

	test_does_not_have
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.with"
		do
			Precursor {SET_TESTS}
		end

	test_without
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.without"
		do
			Precursor {SET_TESTS}
		end

	test_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.extended"
		do
			Precursor {SET_TESTS}
		end

	test_batch_extended
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.batch_extended"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.out"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.cardinality"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.equals"
		do
			Precursor {SET_TESTS}
		end

	test_unequals
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
		do
			Precursor {SET_TESTS}
		end

	test_is_subset
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_subset"
		do
			Precursor {SET_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
		do
			Precursor {SET_TESTS}
		end

	test_is_superset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_superset"
			testing: "covers/{STI_SET}.is_superset"
		do
			Precursor {SET_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
		do
			Precursor {SET_TESTS}
		end

	test_is_comparable
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_comparable"
			testing: "covers/{STI_SET}.is_comparable"
		do
			Precursor {SET_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
		do
			Precursor {SET_TESTS}
		end

	test_is_strict_subset
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_strict_subset"
		do
			Precursor {SET_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
		do
			Precursor {SET_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_strict_superset"
			testing: "covers/{STI_SET}.is_strict_superset"
		do
			Precursor {SET_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
		do
			Precursor {SET_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
		do
			Precursor {SET_TESTS}
		end

	test_is_trivial_superset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_trivial_superset"
			testing: "covers/{STI_SET}.is_trivial_superset"
		do
			Precursor {SET_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_proper_subset"
		do
			Precursor {SET_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_proper_superset"
			testing: "covers/{STI_SET}.is_proper_superset"
		do
			Precursor {SET_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_disjoint"
		do
			Precursor {SET_TESTS}
		end

	test_intersects
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists"
		do
			Precursor {SET_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
		do
			Precursor {SET_TESTS}
		end

	test_exists_unique
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists_unique"
		do
			Precursor {SET_TESTS}
		end

	test_exists_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists_pair"
		do
			Precursor {SET_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
		do
			Precursor {SET_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
		do
			Precursor {SET_TESTS}
		end

	test_for_all
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.for_all"
		do
			Precursor {SET_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.for_all_pairs"
		do
			Precursor {SET_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subsets"
		do
			Precursor {SET_TESTS}
		end

	test_powerset
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.powerset"
		do
			Precursor {SET_TESTS}
		end

	test_trivial_subsets
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.trivial_subsets"
		do
			Precursor {SET_TESTS}
		end

	test_proper_subsets
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
		do
			Precursor {SET_TESTS}
		end

	test_filtered
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.filtered"
		do
			Precursor {SET_TESTS}
		end

	test_complemented
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.complemented"
		do
			Precursor {SET_TESTS}
		end

	test_united
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.united"
		do
			Precursor {SET_TESTS}
		end

	test_intersected
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.intersected"
		do
			Precursor {SET_TESTS}
		end

	test_subtracted
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subtracted"
		do
			Precursor {SET_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subtracted_symmetricaly"
		do
			Precursor {SET_TESTS}
		end

	test_crossed
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
		do
			Precursor {SET_TESTS}
		end

	test_squared
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
		do
			Precursor {SET_TESTS}
		end

	test_diagonal
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.diagonal"
		do
			Precursor {SET_TESTS}
		end

	test_raised
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
		do
			Precursor {SET_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.crossed_tuples"
		do
			Precursor {SET_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
		do
			Precursor {SET_TESTS}
		end

	test_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
		do
			Precursor {SET_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.natural_as_integer"
		do
			Precursor {SET_TESTS}
		end

	test_as_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.as_singleton"
		do
			Precursor {SET_TESTS}
		end

	test_n_times
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.n_times"
		do
			Precursor {SET_TESTS}
		end

	test_as_tuple
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.as_tuple"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Factory)

	test_o
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.o"
		do
			Precursor {SET_TESTS}
		end

	test_empty_set
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.empty_set"
		do
			Precursor {SET_TESTS}
		end

	test_singleton
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.singleton"
		do
			Precursor {SET_TESTS}
		end

	test_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.pair"
		do
			Precursor {SET_TESTS}
		end

	test_converted
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.converted"
		do
			Precursor {SET_TESTS}
		end

	test_converted_element
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.converted_element"
		do
			Precursor {SET_TESTS}
		end

	test_unit
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.unit"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
		do
			Precursor {SET_TESTS}
		end

	test_xored
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
		do
			Precursor {SET_TESTS}
		end

	test_iff
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
		do
			Precursor {SET_TESTS}
		end

	test_equality_holds
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.equality_holds"
		do
			Precursor {SET_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
		do
			Precursor {SET_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
		do
			Precursor {SET_TESTS}
		end

	test_disjunction
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
		do
			Precursor {SET_TESTS}
		end

	test_conjunction
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
		do
			Precursor {SET_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
		do
			Precursor {SET_TESTS}
		end

feature {NONE} -- Implementation

	max_asserted_tuples: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

	max_asserted_subsets: NATURAL = 1024 -- 2 ^ 10
			-- <Precursor>

	max_subsets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

	max_tuples: NATURAL = 46_656 -- 6 ^ 6
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
