﻿note
	description: "Test suite for {SUBSET_FAMILY_STRUCTURE_TESTS [detachable INTEGER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR_I

inherit
	SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		redefine
			on_prepare,
			test_make_pair,
			test_make_from_pair,
			test_sf,
			test_subset_family,
			test_s,
			test_superset,
			test_eq_ss,
			test_eq_s,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_out,
			test_first_out,
			test_second_out,
			test_equals,
			test_unequals,
			test_succeeds,
			test_inverse,
			test_composed_with_homogeneous,
			test_composed_with_inverse_like,
			test_as_singleton
		end

	SETS_TESTS_RESOURCES_BINARY_SSI_SI
		redefine
			on_prepare
		end

feature -- Access

	properties: SUBSET_FAMILY_STRUCTURE_PROPERTIES [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
			-- <Precursor>

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_BINARY_SSI_SI}
			create properties
		end

feature -- Test routines (Initialization)

	test_make_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_pair"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_make_from_pair
			-- <Precursor>
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_from_pair"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature -- Test routines (Primitive)

	test_sf
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.sf.
		note
			testing: "covers/{STI_ORDERED_PAIR}.a"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.sf"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_subset_family
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.subset_family.
		note
			testing: "covers/{STI_ORDERED_PAIR}.first"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.subset_family"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_s
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.s.
		note
			testing: "covers/{STI_ORDERED_PAIR}.b"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.s"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_superset
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.superset.
		note
			testing: "covers/{STI_ORDERED_PAIR}.second"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_eq_ss
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.eq_ss.
		note
			testing: "covers/{STI_ORDERED_PAIR}.eq_a"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.eq_ss"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_eq_s
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.eq_s.
		note
			testing: "covers/{STI_ORDERED_PAIR}.eq_b"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.eq_s"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_ORDERED_PAIR}.element_is_in.
			-- Test {STI_ORDERED_PAIR}.element_is_in.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.element_is_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_ORDERED_PAIR}.element_is_in"
			testing: "covers/{STI_ORDERED_PAIR}.element_is_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.element_is_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.element_is_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_ORDERED_PAIR}.element_is_not_in.
			-- Test {STI_ORDERED_PAIR}.element_is_not_in.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.element_is_not_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_ORDERED_PAIR}.element_is_not_in"
			testing: "covers/{STI_ORDERED_PAIR}.element_is_not_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.element_is_not_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.element_is_not_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_in.
		note
			testing: "covers/{STS_ORDERED_PAIR}.is_in"
			testing: "covers/{STI_ORDERED_PAIR}.is_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_not_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_not_in.
		note
			testing: "covers/{STS_ORDERED_PAIR}.is_not_in"
			testing: "covers/{STI_ORDERED_PAIR}.is_not_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_not_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_not_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature -- Test routines (Output)

	test_out
			-- Test {STI_ORDERED_PAIR}.out.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.out"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_first_out
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.first_out.
		note
			testing: "covers/{STI_ORDERED_PAIR}.first_out"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.first_out"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_second_out
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.second_out.
		note
			testing: "covers/{STI_ORDERED_PAIR}.second_out"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.second_out"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
		note
			testing: "covers/{STS_ORDERED_PAIR}.equals"
			testing: "covers/{STI_ORDERED_PAIR}.equals"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.equals"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.equals"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.unequals.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.unequals.
		note
			testing: "covers/{STS_ORDERED_PAIR}.unequals"
			testing: "covers/{STI_ORDERED_PAIR}.unequals"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.unequals"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.unequals"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_succeeds
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.succeeds.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.succeeds.
		note
			testing: "covers/{STS_ORDERED_PAIR}.succeeds"
			testing: "covers/{STI_ORDERED_PAIR}.succeeds"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.succeeds"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.succeeds"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature -- Test routines (Operation)

	test_inverse
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.inverse.
		note
			testing: "covers/{STI_ORDERED_PAIR}.inverse"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.inverse"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_composed_with_homogeneous
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.composed_with_homogeneous.
		note
			testing: "covers/{STI_ORDERED_PAIR}.composed_with_homogeneous"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.composed_with_homogeneous"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

	test_composed_with_inverse_like
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.composed_with_inverse_like.
		note
			testing: "covers/{STI_ORDERED_PAIR}.composed_with_inverse_like"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.composed_with_inverse_like"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature -- Test routines (Conversion)

	test_as_singleton
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.as_singleton.
		note
			testing: "covers/{STI_ORDERED_PAIR}.as_singleton"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.as_singleton"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR}
		end

feature {NONE} -- Specific data

	specific_sf_ss0_ss_s0_s: TUPLE [like subset_family_structure_to_be_tested, like some_set_sa, like some_set_sa, like some_set_a, like some_set_a]
			-- <Precursor>
		local
			sf: like subset_family_structure_to_be_tested
			ss0, ss: like some_set_sa
			s0, s: like some_set_a
		do
			check
				p0x8897598: attached {INTEGER_REF} (-2).to_reference as p0x8897598
				p0x88970F8: attached {INTEGER_REF} (1).to_reference as p0x88970F8
				p0x8897158: attached {INTEGER_REF} (2).to_reference as p0x8897158
				p0x88971B8: attached {INTEGER_REF} (-2).to_reference as p0x88971B8
				p0x8897A98: attached {INTEGER_REF} (1).to_reference as p0x8897A98
				p0x8898BC8: attached {INTEGER_REF} (2).to_reference as p0x8898BC8
				p0x7644788: attached {INTEGER_REF} (1).to_reference as p0x7644788
				p0x764FED8: attached {INTEGER_REF} (-1).to_reference as p0x764FED8
				p0x7644C98: attached {INTEGER_REF} (-2).to_reference as p0x7644C98
				p0x7645738: attached {INTEGER_REF} (1).to_reference as p0x7645738
				p0x7645618: attached {INTEGER_REF} (-1).to_reference as p0x7645618
				p0x8899678: attached {INTEGER_REF} (-2).to_reference as p0x8899678
				p0x7644828: attached {INTEGER_REF} (1).to_reference as p0x7644828
				p0x76447C8: attached {INTEGER_REF} (0).to_reference as p0x76447C8
			then
				sf := subset_family_structure_to_be_tested.o_f & some_set_a.o & (some_set_a.o & p0x8897598 & 1)
				sf := sf.replacing_superset (some_set_a.o & 1 & p0x8897598)
				ss0 := some_set_sa.o
				ss := some_set_sa.o & some_set_a.o & (some_set_a.o & 0 & 2 & -2) & (some_set_a.o & p0x88970F8 & p0x8897158 & p0x88971B8)
				s0 := some_set_a.o & 0 & 2 & -2
				s := some_set_a.o & p0x8897A98 & -1 & 0 & p0x88971B8 & p0x8897158 & -2 & 2
				assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
				assert ("ss0_violates_keep_non_emptiness", make_from_pair_got_rescued (sf, ss0, ss, s0, s))

				sf := sf.o_f & (s.o & 2 & p0x88970F8) & s.o
				sf := sf.replacing_superset (s.o & p0x88970F8 & 2)
				ss0 := ss0.o & (s0.o & p0x8897A98 & -1 & 0 & p0x88971B8) & (s0.o & 0) & (s0.o & 2 & p0x8898BC8 & p0x88971B8)
				ss := ss.o & (s.o & p0x7644788 & -2 & 2 & p0x764FED8)
				s0 := s0.o & 2
				s := s.o & p0x764FED8 & -2 & 2 & p0x88970F8
				assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
				assert ("ss0_s0_violates_consistent_superset", make_from_pair_got_rescued (sf, ss0, ss, s0, s))

				sf := sf.o_f & (s.o & 0) & (s.o & -2 & p0x8897A98 & 1 & p0x7644C98)
				sf := sf.replacing_superset (s.o & p0x7644C98 & p0x8897A98 & 1 & -1 & 0 & -2)
				ss0 := ss0.o & s0.o & (s0.o & 0 & 2 & -2) & (s0.o & p0x88970F8 & p0x8897158 & p0x88971B8)
				ss := ss.o & (s.o & p0x7645738 & -2 & 2 & p0x7645618)
				s0 := s0.o & p0x8899678 & p0x7644828 & p0x76447C8
				s := s.o & p0x7645618 & -2 & 2 & p0x88970F8
				assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := s ∪ sf.converted (ss).superset
				assert ("ss0_s_violates_consistent_superset", make_from_pair_got_rescued (sf, ss0, ss, s0, s))
			end
			Result := [sf, ss0, ss, s0, s]
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
