note
	description: "Test suite for {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY [detachable INTEGER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY_I

inherit
	SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		undefine
			on_prepare
		redefine
			test_set_make_empty,
			test_make_empty,
			test_make_singleton,
			test_set_make_extended,
			test_make_extended,
			test_make_from_set,
			test_make_from_family,
			test_is_empty,
			test_any,
			test_others,
			test_eq_s,
			test_superset,
			test_element_is_in,
			test_element_is_not_in,
			test_set_is_in,
			test_set_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_set_extended,
			test_extended,
			test_set_batch_extended,
			test_batch_extended,
			test_extending_superset,
			test_replacing_superset,
			test_out,
			test_is_singleton,
			test_is_partition,
			test_subsets_are_disjoint,
			test_cardinality,
			test_set_equals,
			test_set_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_same_family,
			test_is_partitioned,
			test_set_is_disjoint,
			test_sets_are_disjoint,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_complemented_family,
			test_united,
			test_family_union,
			test_intersected,
			test_family_intersection,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_set_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o_f,
			test_empty_family,
			test_singleton,
			test_pair,
			test_converted,
			test_unit_f,
			test_o,
			test_empty_subset,
			test_converted_subset,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_some_subset_has,
			test_every_subset_has,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SUBSET_FAMILY_TESTS_I
		rename
			test_eq as test_eq_s,
			test_is_in as test_set_is_in,
			test_is_not_in as test_set_is_not_in,
			test_equals as test_set_equals,
			test_unequals as test_set_unequals,
			test_as_singleton as test_set_as_singleton,
			subset_family_to_be_tested as subset_family_structure_to_be_tested,
			subset_family_from_sa as subset_family_structure_from_sa,
			subset_family_from_sti_sa as subset_family_structure_from_sti_sa,
			subset_family_from_sa_a as subset_family_structure_from_sa_a,
			subset_family_from_sti_sa_a as subset_family_structure_from_sti_sa_a,
			subset_family_from_saa as subset_family_structure_from_saa,
			subset_family_from_sti_saa as subset_family_structure_from_sti_saa,
			subset_family_from_sa_ta as subset_family_structure_from_sa_ta,
			subset_family_from_sti_sa_ta as subset_family_structure_from_sti_sa_ta,
			subset_family_from_sa_ssa as subset_family_structure_from_sa_ssa,
			subset_family_from_sti_sa_ssa as subset_family_structure_from_sti_sa_ssa,
			subset_family_from_sa_sta as subset_family_structure_from_sa_sta,
			subset_family_from_sti_sa_sta as subset_family_structure_from_sti_sa_sta,
			subset_family_from_sa_aa as subset_family_structure_from_sa_aa,
			subset_family_from_sti_sa_aa as subset_family_structure_from_sti_sa_aa,
			subset_family_from_set_of_sets as subset_family_structure_from_set_of_sets,
			subset_family_from_sti_set_of_sets as subset_family_structure_from_sti_set_of_sets,
			subset_family_from_set_family as subset_family_structure_from_set_family,
			subset_family_from_sti_set_family as subset_family_structure_from_sti_set_family,
			subset_family_from_set_partition as subset_family_structure_from_set_partition,
			subset_family_from_sti_set_partition as subset_family_structure_from_sti_set_partition,
			subset_family_from_sf as subset_family_structure_from_sf,
			subset_family_from_subset_family_structure as subset_family_structure_from_subset_family_structure
		undefine
			subset_family_structure_to_be_tested,
			subset_family_structure_from_sa,
			subset_family_structure_from_sti_sa,
			subset_family_structure_from_sa_a,
			subset_family_structure_from_sti_sa_a,
			subset_family_structure_from_saa,
			subset_family_structure_from_sti_saa,
			subset_family_structure_from_sa_ta,
			subset_family_structure_from_sti_sa_ta,
			subset_family_structure_from_sa_ssa,
			subset_family_structure_from_sti_sa_ssa,
			subset_family_structure_from_sa_sta,
			subset_family_structure_from_sti_sa_sta,
			subset_family_structure_from_sa_aa,
			subset_family_structure_from_sti_sa_aa,
			subset_family_structure_from_set_of_sets,
			subset_family_structure_from_sti_set_of_sets,
			subset_family_structure_from_set_family,
			subset_family_structure_from_sti_set_family,
			subset_family_structure_from_set_partition,
			subset_family_structure_from_sti_set_partition,
			subset_family_structure_from_sf,
			subset_family_structure_from_subset_family_structure
		redefine
			properties,
			test_set_make_empty,
			test_make_empty,
			test_make_singleton,
			test_set_make_extended,
			test_make_extended,
			test_make_from_set,
			test_make_from_family,
			test_is_empty,
			test_any,
			test_others,
			test_eq_s,
			test_superset,
			test_element_is_in,
			test_element_is_not_in,
			test_set_is_in,
			test_set_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_set_extended,
			test_extended,
			test_set_batch_extended,
			test_batch_extended,
			test_extending_superset,
			test_replacing_superset,
			test_out,
			test_is_singleton,
			test_is_partition,
			test_subsets_are_disjoint,
			test_cardinality,
			test_set_equals,
			test_set_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_same_family,
			test_is_partitioned,
			test_set_is_disjoint,
			test_sets_are_disjoint,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_complemented_family,
			test_united,
			test_family_union,
			test_intersected,
			test_family_intersection,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_set_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o_f,
			test_empty_family,
			test_singleton,
			test_pair,
			test_converted,
			test_unit_f,
			test_o,
			test_empty_subset,
			test_converted_subset,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_some_subset_has,
			test_every_subset_has,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

feature -- Access

	properties: SUBSET_FAMILY_STRUCTURE_PROPERTIES [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
			-- Object that checks the set-theory properties of {STI_SUBSET_FAMILY_STRUCTURE}
--		once
--			create Result
--		end

feature -- Test routines ({NONE} Initialization)

	test_set_make_empty
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_make_empty.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_make_empty"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_make_empty
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_empty.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_empty"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_empty"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_make_singleton
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_singleton.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_singleton"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_make_extended
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_make_extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_make_extended"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_make_extended
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_extended"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_make_from_set
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_from_set.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_from_set"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_from_set"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_make_from_family
			-- <Precursor>
		note
			testing: "covers/{STI_SUBSET_FAMILY}.make_from_family"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_from_family"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_empty.
			-- Test {STI_SUBSET_FAMILY}.is_empty.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_empty.
		note
			testing: "covers/{STI_SET}.is_empty"
			testing: "covers/{STI_SET_OF_SETS}.is_empty"
			testing: "covers/{STI_SUBSET_FAMILY}.is_empty"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_empty"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_any
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.any.
			-- Test {STI_SUBSET_FAMILY}.any.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.any.
		note
			testing: "covers/{STI_SET}.any"
			testing: "covers/{STI_SET_OF_SETS}.any"
			testing: "covers/{STI_SUBSET_FAMILY}.any"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.any"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_others
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.others.
			-- Test {STI_SUBSET_FAMILY}.others.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_SET_OF_SETS}.others"
			testing: "covers/{STI_SUBSET_FAMILY}.others"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.others"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_eq_s
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.eq.
			-- Test {STI_SUBSET_FAMILY}.eq.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.eq_s.
		note
			testing: "covers/{STI_SET}.eq"
			testing: "covers/{STI_SET_OF_SETS}.eq"
			testing: "covers/{STI_SUBSET_FAMILY}.eq"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.eq_s"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_superset
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY}.superset
		note
			testing: "covers/{STI_SUBSET_FAMILY}.superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_SET_OF_SETS}.element_is_in.
			-- Test {STI_SET_OF_SETS}.element_is_in.
			-- Test {STS_SUBSET_FAMILY}.element_is_in.
			-- Test {STI_SUBSET_FAMILY}.element_is_in.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.element_is_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_SET_OF_SETS}.element_is_in"
			testing: "covers/{STI_SET_OF_SETS}.element_is_in"
			testing: "covers/{STS_SUBSET_FAMILY}.element_is_in"
			testing: "covers/{STI_SUBSET_FAMILY}.element_is_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.element_is_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.element_is_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_SET_OF_SETS}.element_is_not_in.
			-- Test {STI_SET_OF_SETS}.element_is_not_in.
			-- Test {STS_SUBSET_FAMILY}.element_is_not_in.
			-- Test {STI_SUBSET_FAMILY}.element_is_not_in.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.element_is_not_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_SET_OF_SETS}.element_is_not_in"
			testing: "covers/{STI_SET_OF_SETS}.element_is_not_in"
			testing: "covers/{STS_SUBSET_FAMILY}.element_is_not_in"
			testing: "covers/{STI_SUBSET_FAMILY}.element_is_not_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.element_is_not_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.element_is_not_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_is_in
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_in.
			-- Test {STI_SET_OF_SETS}.is_in.
			-- Test {STS_SUBSET_FAMILY}.is_in.
			-- Test {STI_SUBSET_FAMILY}.is_in.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.set_is_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_SET_OF_SETS}.is_in"
			testing: "covers/{STI_SET_OF_SETS}.is_in"
			testing: "covers/{STS_SUBSET_FAMILY}.is_in"
			testing: "covers/{STI_SUBSET_FAMILY}.is_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.set_is_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_is_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_is_not_in
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_in.
			-- Test {STI_SET_OF_SETS}.is_not_in.
			-- Test {STS_SUBSET_FAMILY}.is_not_in.
			-- Test {STI_SUBSET_FAMILY}.is_not_in.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.set_is_not_in.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_SET_OF_SETS}.is_not_in"
			testing: "covers/{STI_SET_OF_SETS}.is_not_in"
			testing: "covers/{STS_SUBSET_FAMILY}.is_not_in"
			testing: "covers/{STI_SUBSET_FAMILY}.is_not_in"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.set_is_not_in"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_is_not_in"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_has
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.has.
			-- Test {STI_SUBSET_FAMILY}.has.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.has.
		note
			testing: "covers/{STI_SET}.has"
			testing: "covers/{STI_SET_OF_SETS}.has"
			testing: "covers/{STI_SUBSET_FAMILY}.has"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.has"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.does_not_have.
			-- Test {STI_SET_OF_SETS}.does_not_have.
			-- Test {STS_SUBSET_FAMILY}.does_not_have.
			-- Test {STI_SUBSET_FAMILY}.does_not_have.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.does_not_have.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_SET_OF_SETS}.does_not_have"
			testing: "covers/{STI_SET_OF_SETS}.does_not_have"
			testing: "covers/{STS_SUBSET_FAMILY}.does_not_have"
			testing: "covers/{STI_SUBSET_FAMILY}.does_not_have"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.does_not_have"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.does_not_have"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.with.
			-- Test {STI_SUBSET_FAMILY}.with.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.with.
		note
			testing: "covers/{STI_SET}.with"
			testing: "covers/{STI_SET_OF_SETS}.with"
			testing: "covers/{STI_SUBSET_FAMILY}.with"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.with"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_without
			-- Test {STI_SUBSET_FAMILY}.without.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.without.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.without"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.without"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_extended
			-- Test {STI_SUBSET_FAMILY}.set_extended.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.set_extended"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_extended"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.extended
		note
			testing: "covers/{STI_SUBSET_FAMILY}.extended"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.extended"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_batch_extended
			-- Test {STI_SUBSET_FAMILY}.set_batch_extended.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_batch_extended.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.set_batch_extended"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_batch_extended"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.batch_extended
		note
			testing: "covers/{STI_SUBSET_FAMILY}.batch_extended"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.batch_extended"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_extending_superset
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.extending_superset
		note
			testing: "covers/{STI_SUBSET_FAMILY}.extending_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.extending_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_replacing_superset
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.replacing_superset
		note
			testing: "covers/{STI_SUBSET_FAMILY}.replacing_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.replacing_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.out.
			-- Test {STI_SUBSET_FAMILY}.out.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_out.
		note
			testing: "covers/{STI_SET}.out"
			testing: "covers/{STI_SET_OF_SETS}.out"
			testing: "covers/{STI_SUBSET_FAMILY}.out"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_out"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_singleton.
			-- Test {STI_SET_OF_SETS}.is_singleton.
			-- Test {STS_SUBSET_FAMILY}.is_singleton.
			-- Test {STI_SUBSET_FAMILY}.is_singleton.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_singleton.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_singleton.
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
			testing: "covers/{STS_SET_OF_SETS}.is_singleton"
			testing: "covers/{STI_SET_OF_SETS}.is_singleton"
			testing: "covers/{STS_SUBSET_FAMILY}.is_singleton"
			testing: "covers/{STI_SUBSET_FAMILY}.is_singleton"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_singleton"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_singleton"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_partition
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY}.is_partition.
			-- Test {STI_SUBSET_FAMILY}.is_partition.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_partition.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_partition.
		note
			testing: "covers/{STS_SET_OF_SETS}.is_partition"
			testing: "covers/{STI_SET_OF_SETS}.is_partition"
			testing: "covers/{STS_SUBSET_FAMILY}.is_partition"
			testing: "covers/{STI_SUBSET_FAMILY}.is_partition"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_partition"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_partition"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_subsets_are_disjoint
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY}.subsets_are_disjoint.
			-- Test {STI_SUBSET_FAMILY}.subsets_are_disjoint.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.subsets_are_disjoint.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.subsets_are_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.member_sets_are_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.member_sets_are_disjoint"
			testing: "covers/{STS_SUBSET_FAMILY}.subsets_are_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY}.subsets_are_disjoint"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.subsets_are_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.subsets_are_disjoint"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.cardinality.
			-- Test {STI_SUBSET_FAMILY}.cardinality.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.cardinality.
		note
			testing: "covers/{STI_SET}.cardinality"
			testing: "covers/{STI_SET_OF_SETS}.cardinality"
			testing: "covers/{STI_SUBSET_FAMILY}.cardinality"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.cardinality"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Comparison)

	test_set_equals
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.equals.
			-- Test {STI_SUBSET_FAMILY}.equals.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_equals.
		note
			testing: "covers/{STI_SET}.equals"
			testing: "covers/{STI_SET_OF_SETS}.equals"
			testing: "covers/{STI_SUBSET_FAMILY}.equals"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_equals"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_unequals
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.unequals.
			-- Test {STI_SET_OF_SETS}.unequals.
			-- Test {STS_SUBSET_FAMILY}.unequals.
			-- Test {STI_SUBSET_FAMILY}.unequals.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.set_unequals.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_SET_OF_SETS}.unequals"
			testing: "covers/{STI_SET_OF_SETS}.unequals"
			testing: "covers/{STS_SUBSET_FAMILY}.unequals"
			testing: "covers/{STI_SUBSET_FAMILY}.unequals"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.set_unequals"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_unequals"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_subset.
			-- Test {STI_SUBSET_FAMILY}.is_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_subset.
		note
			testing: "covers/{STI_SET}.is_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_subset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_subset.
			-- Test {STI_SET_OF_SETS}.is_not_subset.
			-- Test {STS_SUBSET_FAMILY}.is_not_subset.
			-- Test {STI_SUBSET_FAMILY}.is_not_subset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_not_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_subset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_not_subset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_not_subset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_not_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_not_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_superset.
			-- Test {STI_SET_OF_SETS}.is_superset.
			-- Test {STS_SUBSET_FAMILY}.is_superset.
			-- Test {STI_SUBSET_FAMILY}.is_superset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_superset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_superset.
		note
			testing: "covers/{STS_SET}.is_superset"
			testing: "covers/{STI_SET}.is_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_superset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_superset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_superset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_superset.
			-- Test {STI_SET_OF_SETS}.is_not_superset.
			-- Test {STS_SUBSET_FAMILY}.is_not_superset.
			-- Test {STI_SUBSET_FAMILY}.is_not_superset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_not_superset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_superset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_not_superset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_not_superset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_not_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_not_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_comparable.
			-- Test {STI_SET_OF_SETS}.is_comparable.
			-- Test {STS_SUBSET_FAMILY}.is_comparable.
			-- Test {STI_SUBSET_FAMILY}.is_comparable.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_comparable.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_comparable.
		note
			testing: "covers/{STS_SET}.is_comparable"
			testing: "covers/{STI_SET}.is_comparable"
			testing: "covers/{STS_SET_OF_SETS}.is_comparable"
			testing: "covers/{STI_SET_OF_SETS}.is_comparable"
			testing: "covers/{STS_SUBSET_FAMILY}.is_comparable"
			testing: "covers/{STI_SUBSET_FAMILY}.is_comparable"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_comparable"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_comparable"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_comparable.
			-- Test {STI_SET_OF_SETS}.is_not_comparable.
			-- Test {STS_SUBSET_FAMILY}.is_not_comparable.
			-- Test {STI_SUBSET_FAMILY}.is_not_comparable.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_not_comparable.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_not_comparable.
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
			testing: "covers/{STS_SET_OF_SETS}.is_not_comparable"
			testing: "covers/{STI_SET_OF_SETS}.is_not_comparable"
			testing: "covers/{STS_SUBSET_FAMILY}.is_not_comparable"
			testing: "covers/{STI_SUBSET_FAMILY}.is_not_comparable"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_not_comparable"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_not_comparable"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_strict_subset.
			-- Test {STI_SUBSET_FAMILY}.is_strict_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_strict_subset.
		note
			testing: "covers/{STI_SET}.is_strict_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_strict_subset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_strict_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_strict_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_strict_subset.
			-- Test {STI_SET_OF_SETS}.is_not_strict_subset.
			-- Test {STS_SUBSET_FAMILY}.is_not_strict_subset.
			-- Test {STI_SUBSET_FAMILY}.is_not_strict_subset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_not_strict_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_strict_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_strict_subset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_not_strict_subset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_not_strict_subset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_not_strict_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_not_strict_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_strict_superset.
			-- Test {STI_SET_OF_SETS}.is_strict_superset.
			-- Test {STS_SUBSET_FAMILY}.is_strict_superset.
			-- Test {STI_SUBSET_FAMILY}.is_strict_superset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_strict_superset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_strict_superset.
		note
			testing: "covers/{STS_SET}.is_strict_superset"
			testing: "covers/{STI_SET}.is_strict_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_strict_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_strict_superset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_strict_superset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_strict_superset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_strict_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_strict_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_not_strict_superset.
			-- Test {STI_SET_OF_SETS}.is_not_strict_superset.
			-- Test {STS_SUBSET_FAMILY}.is_not_strict_superset.
			-- Test {STI_SUBSET_FAMILY}.is_not_strict_superset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_not_strict_superset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_not_strict_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_not_strict_superset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_not_strict_superset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_not_strict_superset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_not_strict_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_not_strict_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_trivial_subset.
			-- Test {STI_SUBSET_FAMILY}.is_trivial_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_trivial_subset.
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_trivial_subset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_trivial_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_trivial_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_trivial_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_trivial_superset.
			-- Test {STI_SET_OF_SETS}.is_trivial_superset.
			-- Test {STS_SUBSET_FAMILY}.is_trivial_superset.
			-- Test {STI_SUBSET_FAMILY}.is_trivial_superset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_trivial_superset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_trivial_superset.
		note
			testing: "covers/{STS_SET}.is_trivial_superset"
			testing: "covers/{STI_SET}.is_trivial_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_trivial_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_trivial_superset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_trivial_superset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_trivial_superset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_trivial_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_trivial_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_proper_subset.
			-- Test {STI_SUBSET_FAMILY}.is_proper_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_proper_subset.
		note
			testing: "covers/{STI_SET}.is_proper_subset"
			testing: "covers/{STI_SET_OF_SETS}.is_proper_subset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_proper_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_proper_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_proper_superset.
			-- Test {STI_SET_OF_SETS}.is_proper_superset.
			-- Test {STS_SUBSET_FAMILY}.is_proper_superset.
			-- Test {STI_SUBSET_FAMILY}.is_proper_superset.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_proper_superset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_proper_superset.
		note
			testing: "covers/{STS_SET}.is_proper_superset"
			testing: "covers/{STI_SET}.is_proper_superset"
			testing: "covers/{STS_SET_OF_SETS}.is_proper_superset"
			testing: "covers/{STI_SET_OF_SETS}.is_proper_superset"
			testing: "covers/{STS_SUBSET_FAMILY}.is_proper_superset"
			testing: "covers/{STI_SUBSET_FAMILY}.is_proper_superset"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_proper_superset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_proper_superset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.is_disjoint.
			-- Test {STI_SUBSET_FAMILY}.is_disjoint.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_disjoint.
		note
			testing: "covers/{STI_SET}.is_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.is_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY}.is_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_disjoint"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.intersects.
			-- Test {STI_SET_OF_SETS}.intersects.
			-- Test {STS_SUBSET_FAMILY}.intersects.
			-- Test {STI_SUBSET_FAMILY}.intersects.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.intersects.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_SET_OF_SETS}.intersects"
			testing: "covers/{STI_SET_OF_SETS}.intersects"
			testing: "covers/{STS_SUBSET_FAMILY}.intersects"
			testing: "covers/{STI_SUBSET_FAMILY}.intersects"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.intersects"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.intersects"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_same_family
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.same_family.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.same_family.
		note
			testing: "covers/{STS_SUBSET_FAMILY}.same_family"
			testing: "covers/{STI_SUBSET_FAMILY}.same_family"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.same_family"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.same_family"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.is_partitioned.
			-- Test {STI_SET_OF_SETS}.is_partitioned.
			-- Test {STS_SUBSET_FAMILY}.is_partitioned.
			-- Test {STI_SUBSET_FAMILY}.is_partitioned.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.is_partitioned.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_SET_OF_SETS}.is_partitioned"
			testing: "covers/{STI_SET_OF_SETS}.is_partitioned"
			testing: "covers/{STS_SUBSET_FAMILY}.is_partitioned"
			testing: "covers/{STI_SUBSET_FAMILY}.is_partitioned"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.is_partitioned"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.is_partitioned"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_is_disjoint
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY}.set_is_disjoint.
			-- Test {STI_SUBSET_FAMILY}.set_is_disjoint.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.set_is_disjoint.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_is_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.set_is_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.set_is_disjoint"
			testing: "covers/{STS_SUBSET_FAMILY}.set_is_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY}.set_is_disjoint"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.set_is_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_is_disjoint"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_sets_are_disjoint
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY}.sets_are_disjoint.
			-- Test {STI_SUBSET_FAMILY}.sets_are_disjoint.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.sets_are_disjoint.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.sets_are_disjoint.
		note
			testing: "covers/{STS_SET_OF_SETS}.sets_are_disjoint"
			testing: "covers/{STI_SET_OF_SETS}.sets_are_disjoint"
			testing: "covers/{STS_SUBSET_FAMILY}.sets_are_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY}.sets_are_disjoint"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.sets_are_disjoint"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.sets_are_disjoint"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.exists.
			-- Test {STI_SUBSET_FAMILY}.exists.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_SET_OF_SETS}.exists"
			testing: "covers/{STI_SUBSET_FAMILY}.exists"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.exists"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.does_not_exist.
			-- Test {STI_SET_OF_SETS}.does_not_exist.
			-- Test {STS_SUBSET_FAMILY}.does_not_exist.
			-- Test {STI_SUBSET_FAMILY}.does_not_exist.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.does_not_exist.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_SET_OF_SETS}.does_not_exist"
			testing: "covers/{STI_SET_OF_SETS}.does_not_exist"
			testing: "covers/{STS_SUBSET_FAMILY}.does_not_exist"
			testing: "covers/{STI_SUBSET_FAMILY}.does_not_exist"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.does_not_exist"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.does_not_exist"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.exists_unique.
			-- Test {STI_SUBSET_FAMILY}.exists_unique.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_SET_OF_SETS}.exists_unique"
			testing: "covers/{STI_SUBSET_FAMILY}.exists_unique"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.exists_unique"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.exists_pair.
			-- Test {STI_SUBSET_FAMILY}.exists_pair.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_SET_OF_SETS}.exists_pair"
			testing: "covers/{STI_SUBSET_FAMILY}.exists_pair"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.exists_pair"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.does_not_exist_pair.
			-- Test {STI_SET_OF_SETS}.does_not_exist_pair.
			-- Test {STS_SUBSET_FAMILY}.does_not_exist_pair.
			-- Test {STI_SUBSET_FAMILY}.does_not_exist_pair.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.does_not_exist_pair.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_SET_OF_SETS}.does_not_exist_pair"
			testing: "covers/{STI_SET_OF_SETS}.does_not_exist_pair"
			testing: "covers/{STS_SUBSET_FAMILY}.does_not_exist_pair"
			testing: "covers/{STI_SUBSET_FAMILY}.does_not_exist_pair"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.does_not_exist_pair"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.does_not_exist_pair"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.exists_distinct_pair.
			-- Test {STI_SUBSET_FAMILY}.exists_distinct_pair.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_SET_OF_SETS}.exists_distinct_pair"
			testing: "covers/{STI_SUBSET_FAMILY}.exists_distinct_pair"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.exists_distinct_pair"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.for_all.
			-- Test {STI_SUBSET_FAMILY}.for_all.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_SET_OF_SETS}.for_all"
			testing: "covers/{STI_SUBSET_FAMILY}.for_all"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.for_all"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.for_all_pairs.
			-- Test {STI_SUBSET_FAMILY}.for_all_pairs.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_SET_OF_SETS}.for_all_pairs"
			testing: "covers/{STI_SUBSET_FAMILY}.for_all_pairs"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.for_all_pairs"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.for_all_distinct_pairs.
			-- Test {STI_SUBSET_FAMILY}.for_all_distinct_pairs.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_SET_OF_SETS}.for_all_distinct_pairs"
			testing: "covers/{STI_SUBSET_FAMILY}.for_all_distinct_pairs"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.for_all_distinct_pairs"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subsets.
			-- Test {STI_SUBSET_FAMILY}.subsets.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.subsets.
		note
			testing: "covers/{STI_SET}.subsets"
			testing: "covers/{STI_SET_OF_SETS}.subsets"
			testing: "covers/{STI_SUBSET_FAMILY}.subsets"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.subsets"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_powerset
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.powerset.
			-- Test {STI_SUBSET_FAMILY}.powerset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.powerset.
		note
			testing: "covers/{STI_SET}.powerset"
			testing: "covers/{STI_SET_OF_SETS}.powerset"
			testing: "covers/{STI_SUBSET_FAMILY}.powerset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.powerset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_trivial_subsets
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.trivial_subsets.
			-- Test {STI_SUBSET_FAMILY}.trivial_subsets.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.trivial_subsets.
		note
			testing: "covers/{STI_SET}.trivial_subsets"
			testing: "covers/{STI_SET_OF_SETS}.trivial_subsets"
			testing: "covers/{STI_SUBSET_FAMILY}.trivial_subsets"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.trivial_subsets"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_proper_subsets
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.proper_subsets.
			-- Test {STI_SET_OF_SETS}.proper_subsets.
			-- Test {STS_SUBSET_FAMILY}.proper_subsets.
			-- Test {STI_SUBSET_FAMILY}.proper_subsets.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.proper_subsets.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.proper_subsets.
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
			testing: "covers/{STS_SET_OF_SETS}.proper_subsets"
			testing: "covers/{STI_SET_OF_SETS}.proper_subsets"
			testing: "covers/{STS_SUBSET_FAMILY}.proper_subsets"
			testing: "covers/{STI_SUBSET_FAMILY}.proper_subsets"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.proper_subsets"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.proper_subsets"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.filtered.
			-- Test {STI_SUBSET_FAMILY}.filtered.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_SET_OF_SETS}.filtered"
			testing: "covers/{STI_SUBSET_FAMILY}.filtered"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.filtered"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.complemented.
			-- Test {STI_SUBSET_FAMILY}.complemented.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.complemented.
		note
			testing: "covers/{STI_SET}.complemented"
			testing: "covers/{STI_SET_OF_SETS}.complemented"
			testing: "covers/{STI_SUBSET_FAMILY}.complemented"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.complemented"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_complemented_family
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.complemented_family.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.complemented_family.
		note
			testing: "covers/{STS_SUBSET_FAMILY}.complemented_family"
			testing: "covers/{STI_SUBSET_FAMILY}.complemented_family"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.complemented_family"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.complemented_family"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_united
			-- Test {STI_SUBSET_FAMILY}.united.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.united.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.united"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.united"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_family_union
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.family_union.
		note
			testing: "covers/{STI_SET_OF_SETS}.sets_union"
			testing: "covers/{STI_SUBSET_FAMILY}.family_union"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.family_union"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.intersected.
			-- Test {STI_SUBSET_FAMILY}.intersected.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.intersected.
		note
			testing: "covers/{STI_SET}.intersected"
			testing: "covers/{STI_SET_OF_SETS}.intersected"
			testing: "covers/{STI_SUBSET_FAMILY}.intersected"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.intersected"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_family_intersection
			-- <Precursor>
			-- Test {STI_SUBSET_FAMILY}.family_intersection.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.family_intersection.
		note
			testing: "covers/{STI_SET_OF_SETS}.sets_intersection"
			testing: "covers/{STI_SUBSET_FAMILY}.family_intersection"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.family_intersection"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_subtracted
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subtracted.
			-- Test {STI_SUBSET_FAMILY}.subtracted.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.subtracted.
		note
			testing: "covers/{STI_SET}.subtracted"
			testing: "covers/{STI_SET_OF_SETS}.subtracted"
			testing: "covers/{STI_SUBSET_FAMILY}.subtracted"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.subtracted"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subtracted_symmetricaly.
			-- Test {STI_SUBSET_FAMILY}.subtracted_symmetricaly.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_SET_OF_SETS}.subtracted_symmetricaly"
			testing: "covers/{STI_SUBSET_FAMILY}.subtracted_symmetricaly"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.subtracted_symmetricaly"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.crossed.
			-- Test {STI_SET_OF_SETS}.crossed.
			-- Test {STS_SUBSET_FAMILY}.crossed.
			-- Test {STI_SUBSET_FAMILY}.crossed.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.crossed.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_SET_OF_SETS}.crossed"
			testing: "covers/{STI_SET_OF_SETS}.crossed"
			testing: "covers/{STS_SUBSET_FAMILY}.crossed"
			testing: "covers/{STI_SUBSET_FAMILY}.crossed"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.crossed"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.crossed"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_squared
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.squared.
			-- Test {STI_SET_OF_SETS}.squared.
			-- Test {STS_SUBSET_FAMILY}.squared.
			-- Test {STI_SUBSET_FAMILY}.squared.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.squared.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.squared.
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
			testing: "covers/{STS_SET_OF_SETS}.squared"
			testing: "covers/{STI_SET_OF_SETS}.squared"
			testing: "covers/{STS_SUBSET_FAMILY}.squared"
			testing: "covers/{STI_SUBSET_FAMILY}.squared"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.squared"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.squared"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_diagonal
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.diagonal.
			-- Test {STI_SUBSET_FAMILY}.diagonal.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.diagonal.
		note
			testing: "covers/{STI_SET}.diagonal"
			testing: "covers/{STI_SET_OF_SETS}.diagonal"
			testing: "covers/{STI_SUBSET_FAMILY}.diagonal"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.diagonal"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.raised.
			-- Test {STI_SET_OF_SETS}.raised.
			-- Test {STS_SUBSET_FAMILY}.raised.
			-- Test {STI_SUBSET_FAMILY}.raised.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.raised.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_SET_OF_SETS}.raised"
			testing: "covers/{STI_SET_OF_SETS}.raised"
			testing: "covers/{STS_SUBSET_FAMILY}.raised"
			testing: "covers/{STI_SUBSET_FAMILY}.raised"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.raised"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.raised"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.crossed_tuples.
			-- Test {STI_SUBSET_FAMILY}.crossed_tuples.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_SET_OF_SETS}.crossed_tuples"
			testing: "covers/{STI_SUBSET_FAMILY}.crossed_tuples"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.crossed_tuples"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.singleton_crossed_tuples.
			-- Test {STI_SUBSET_FAMILY}.singleton_crossed_tuples.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_SET_OF_SETS}.singleton_crossed_tuples"
			testing: "covers/{STI_SUBSET_FAMILY}.singleton_crossed_tuples"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.singleton_crossed_tuples"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.mapped.
			-- Test {STI_SET_OF_SETS}.mapped.
			-- Test {STS_SUBSET_FAMILY}.mapped.
			-- Test {STI_SUBSET_FAMILY}.mapped.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.mapped.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_SET_OF_SETS}.mapped"
			testing: "covers/{STI_SET_OF_SETS}.mapped"
			testing: "covers/{STS_SUBSET_FAMILY}.mapped"
			testing: "covers/{STI_SUBSET_FAMILY}.mapped"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.mapped"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.mapped"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.reduced.
			-- Test {STI_SET_OF_SETS}.reduced.
			-- Test {STS_SUBSET_FAMILY}.reduced.
			-- Test {STI_SUBSET_FAMILY}.reduced.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.reduced.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_SET_OF_SETS}.reduced"
			testing: "covers/{STI_SET_OF_SETS}.reduced"
			testing: "covers/{STS_SUBSET_FAMILY}.reduced"
			testing: "covers/{STI_SUBSET_FAMILY}.reduced"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.reduced"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.reduced"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.proper_reduced.
			-- Test {STI_SET_OF_SETS}.proper_reduced.
			-- Test {STS_SUBSET_FAMILY}.proper_reduced.
			-- Test {STI_SUBSET_FAMILY}.proper_reduced.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.proper_reduced.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_SET_OF_SETS}.proper_reduced"
			testing: "covers/{STI_SET_OF_SETS}.proper_reduced"
			testing: "covers/{STS_SUBSET_FAMILY}.proper_reduced"
			testing: "covers/{STI_SUBSET_FAMILY}.proper_reduced"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.proper_reduced"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.proper_reduced"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.natural_as_integer.
			-- Test {STI_SUBSET_FAMILY}.natural_as_integer.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_SET_OF_SETS}.natural_as_integer"
			testing: "covers/{STI_SUBSET_FAMILY}.natural_as_integer"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.natural_as_integer"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_set_as_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.as_singleton.
			-- Test {STI_SUBSET_FAMILY}.as_singleton.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.set_as_singleton.
		note
			testing: "covers/{STI_SET}.as_singleton"
			testing: "covers/{STI_SET_OF_SETS}.as_singleton"
			testing: "covers/{STI_SUBSET_FAMILY}.as_singleton"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.set_as_singleton"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.n_times.
			-- Test {STI_SUBSET_FAMILY}.n_times.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_SET_OF_SETS}.n_times"
			testing: "covers/{STI_SUBSET_FAMILY}.n_times"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.n_times"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_as_tuple
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.as_tuple.
			-- Test {STI_SUBSET_FAMILY}.as_tuple.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.as_tuple.
		note
			testing: "covers/{STI_SET}.as_tuple"
			testing: "covers/{STI_SET_OF_SETS}.as_tuple"
			testing: "covers/{STI_SUBSET_FAMILY}.as_tuple"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.as_tuple"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Factory)

	test_o_f
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.o_s.
			-- Test {STI_SUBSET_FAMILY}.o_f.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.o_f.
		note
			testing: "covers/{STI_SET}.o_s"
			testing: "covers/{STI_SET_OF_SETS}.o_s"
			testing: "covers/{STI_SUBSET_FAMILY}.o_f"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.o_f"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_empty_family
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.empty_set_of_sets.
			-- Test {STI_SUBSET_FAMILY}.empty_family.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.empty_family.
		note
			testing: "covers/{STI_SET}.empty_set"
			testing: "covers/{STI_SET_OF_SETS}.empty_set_of_sets"
			testing: "covers/{STI_SUBSET_FAMILY}.empty_family"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.empty_family"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_singleton
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.singleton.
			-- Test {STI_SUBSET_FAMILY}.singleton.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.singleton.
		note
			testing: "covers/{STI_SET}.singleton"
			testing: "covers/{STI_SET_OF_SETS}.singleton"
			testing: "covers/{STI_SUBSET_FAMILY}.singleton"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.singleton"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.pair.
			-- Test {STI_SUBSET_FAMILY}.pair.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_SET_OF_SETS}.pair"
			testing: "covers/{STI_SUBSET_FAMILY}.pair"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.pair"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_converted
			-- Test {STI_SUBSET_FAMILY}.converted.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.converted.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.converted"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.converted"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_unit_f
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.unit_s.
			-- Test {STI_SUBSET_FAMILY}.unit_f.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.unit_f.
		note
			testing: "covers/{STI_SET}.unit"
			testing: "covers/{STI_SET_OF_SETS}.unit_s"
			testing: "covers/{STI_SUBSET_FAMILY}.unit_f"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.unit_f"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_o
			-- Test {STI_SUBSET_FAMILY}.o.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.o.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.o"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.o"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_empty_subset
			-- Test {STI_SUBSET_FAMILY}.empty_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.empty_subset.
		note
			testing: "covers/{STI_SUBSET_FAMILY}.empty_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.empty_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_converted_subset
			-- Test {STI_SET_OF_SETS}.converted_member_set.
			-- Test {STI_SUBSET_FAMILY}.converted_subset.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.converted_subset.
		note
			testing: "covers/{STI_SET_OF_SETS}.converted_member_set"
			testing: "covers/{STI_SUBSET_FAMILY}.converted_subset"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.converted_subset"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.ored.
			-- Test {STI_SET_OF_SETS}.ored.
			-- Test {STS_SUBSET_FAMILY}.ored.
			-- Test {STI_SUBSET_FAMILY}.ored.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.ored.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_SET_OF_SETS}.ored"
			testing: "covers/{STI_SET_OF_SETS}.ored"
			testing: "covers/{STS_SUBSET_FAMILY}.ored"
			testing: "covers/{STI_SUBSET_FAMILY}.ored"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.ored"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.ored"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.xored.
			-- Test {STI_SET_OF_SETS}.xored.
			-- Test {STS_SUBSET_FAMILY}.xored.
			-- Test {STI_SUBSET_FAMILY}.xored.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.xored.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_SET_OF_SETS}.xored"
			testing: "covers/{STI_SET_OF_SETS}.xored"
			testing: "covers/{STS_SUBSET_FAMILY}.xored"
			testing: "covers/{STI_SUBSET_FAMILY}.xored"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.xored"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.xored"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.iff.
			-- Test {STI_SET_OF_SETS}.iff.
			-- Test {STS_SUBSET_FAMILY}.iff.
			-- Test {STI_SUBSET_FAMILY}.iff.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.iff.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_SET_OF_SETS}.iff"
			testing: "covers/{STI_SET_OF_SETS}.iff"
			testing: "covers/{STS_SUBSET_FAMILY}.iff"
			testing: "covers/{STI_SUBSET_FAMILY}.iff"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.iff"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.iff"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.equality_holds.
			-- Test {STI_SUBSET_FAMILY}.equality_holds.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_SET_OF_SETS}.equality_holds"
			testing: "covers/{STI_SUBSET_FAMILY}.equality_holds"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.equality_holds"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_subset_relation_holds
			-- <Precursor>
			-- Test {STI_SET_OF_SETS}.subset_relation_holds.
			-- Test {STI_SUBSET_FAMILY}.subset_relation_holds.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.subset_relation_holds.
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
			testing: "covers/{STI_SET_OF_SETS}.subset_relation_holds"
			testing: "covers/{STI_SUBSET_FAMILY}.subset_relation_holds"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.subset_relation_holds"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_some_subset_has
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY}.some_subset_has.
			-- Test {STI_SUBSET_FAMILY}.some_subset_has.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.some_subset_has.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.some_subset_has.
		note
			testing: "covers/{STS_SET_OF_SETS}.some_set_has"
			testing: "covers/{STI_SET_OF_SETS}.some_set_has"
			testing: "covers/{STS_SUBSET_FAMILY}.some_subset_has"
			testing: "covers/{STI_SUBSET_FAMILY}.some_subset_has"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.some_subset_has"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.some_subset_has"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_every_subset_has
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY}.every_subset_has.
			-- Test {STI_SUBSET_FAMILY}.every_subset_has.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.every_subset_has.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.every_subset_has.
		note
			testing: "covers/{STS_SET_OF_SETS}.every_set_has"
			testing: "covers/{STI_SET_OF_SETS}.every_set_has"
			testing: "covers/{STS_SUBSET_FAMILY}.every_subset_has"
			testing: "covers/{STI_SUBSET_FAMILY}.every_subset_has"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.every_subset_has"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.every_subset_has"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.second_after_first.
			-- Test {STI_SET_OF_SETS}.second_after_first.
			-- Test {STS_SUBSET_FAMILY}.second_after_first.
			-- Test {STI_SUBSET_FAMILY}.second_after_first.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.second_after_first.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_SET_OF_SETS}.second_after_first"
			testing: "covers/{STI_SET_OF_SETS}.second_after_first"
			testing: "covers/{STS_SUBSET_FAMILY}.second_after_first"
			testing: "covers/{STI_SUBSET_FAMILY}.second_after_first"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.second_after_first"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.second_after_first"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.natural_successor.
			-- Test {STI_SET_OF_SETS}.natural_successor.
			-- Test {STS_SUBSET_FAMILY}.natural_successor.
			-- Test {STI_SUBSET_FAMILY}.natural_successor.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.natural_successor.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_SET_OF_SETS}.natural_successor"
			testing: "covers/{STI_SET_OF_SETS}.natural_successor"
			testing: "covers/{STS_SUBSET_FAMILY}.natural_successor"
			testing: "covers/{STI_SUBSET_FAMILY}.natural_successor"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.natural_successor"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.natural_successor"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.disjunction.
			-- Test {STI_SET_OF_SETS}.disjunction.
			-- Test {STS_SUBSET_FAMILY}.disjunction.
			-- Test {STI_SUBSET_FAMILY}.disjunction.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.disjunction.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_SET_OF_SETS}.disjunction"
			testing: "covers/{STI_SET_OF_SETS}.disjunction"
			testing: "covers/{STS_SUBSET_FAMILY}.disjunction"
			testing: "covers/{STI_SUBSET_FAMILY}.disjunction"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.disjunction"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.disjunction"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.conjunction.
			-- Test {STI_SET_OF_SETS}.conjunction.
			-- Test {STS_SUBSET_FAMILY}.conjunction.
			-- Test {STI_SUBSET_FAMILY}.conjunction.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.conjunction.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_SET_OF_SETS}.conjunction"
			testing: "covers/{STI_SET_OF_SETS}.conjunction"
			testing: "covers/{STS_SUBSET_FAMILY}.conjunction"
			testing: "covers/{STI_SUBSET_FAMILY}.conjunction"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.conjunction"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.conjunction"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_SET_OF_SETS}.sets_plus_same_sets_with_element.
			-- Test {STI_SET_OF_SETS}.sets_plus_same_sets_with_element.
			-- Test {STS_SUBSET_FAMILY}.sets_plus_same_sets_with_element.
			-- Test {STI_SUBSET_FAMILY}.sets_plus_same_sets_with_element.
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.sets_plus_same_sets_with_element.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SET_OF_SETS}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET_OF_SETS}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SUBSET_FAMILY}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SUBSET_FAMILY}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_SUBSET_FAMILY_STRUCTURE}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.sets_plus_same_sets_with_element"
		do
			Precursor {SUBSET_FAMILY_STRUCTURE_TESTS_FOR_SUBSET_FAMILY}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
