note
	description: "Test suite for {STI_TRANSFORMABLE_SET [detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	TRANSFORMABLE_SET_TESTS_IC

inherit
	TRANSFORMABLE_SET_TESTS [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		rename
			some_object_a as some_integer_ref
		undefine
			some_equality,
			some_pair,
			some_preceding_pair_dsa_a,
			some_pair_aa,
			some_preceding_pair_aa,
			some_pair_ab,
			same_pair_ab,
			some_pair_ba,
			some_preceding_pair_ba,
			some_pair_bb,
			some_preceding_pair_bb,
			some_set,
			some_set_a,
			same_set_a,
			some_set_b,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a,
			some_n_tuple_b
		redefine
			on_prepare,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq_a,
			test_eq_b,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_crossed_with_same_kind,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped_to_same_kind,
			test_mapped,
			test_reduced_to_element_like,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SET_TESTS_I
		rename
			eq as eq_a,
			test_eq as test_eq_a,
			test_crossed as test_crossed_with_same_kind,
			test_mapped as test_mapped_to_same_kind,
			test_reduced as test_reduced_to_element_like
		undefine
			set_to_be_tested,
			set_from_sa,
			set_from_saa
		redefine
			properties,
			on_prepare,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq_a,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed_with_same_kind,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped_to_same_kind,
			test_reduced_to_element_like,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

feature -- Access

	properties: TRANSFORMABLE_SET_PROPERTIES [
		detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SET_TESTS_I}
			create properties
		end

feature -- Test routines (Initialization)

	test_make_empty
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.make_empty.
		note
			testing: "covers/{STI_SET}.make_empty"
			testing: "covers/{STI_TRANSFORMABLE_SET}.make_empty"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_make_singleton
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.make_singleton.
		note
			testing: "covers/{STI_SET}.make_singleton"
			testing: "covers/{STI_TRANSFORMABLE_SET}.make_singleton"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_make_extended
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.make_extended.
		note
			testing: "covers/{STI_SET}.make_extended"
			testing: "covers/{STI_TRANSFORMABLE_SET}.make_extended"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_make_from_set
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.make_from_set"
			testing: "covers/{STI_TRANSFORMABLE_SET}.make_from_set"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.is_empty.
		note
			testing: "covers/{STI_SET}.is_empty"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_empty"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_any
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.any.
		note
			testing: "covers/{STI_SET}.any"
			testing: "covers/{STI_TRANSFORMABLE_SET}.any"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_TRANSFORMABLE_SET}.others"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_eq_a
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.eq_a.
		note
			testing: "covers/{STI_SET}.eq"
			testing: "covers/{STI_TRANSFORMABLE_SET}.eq_a"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_eq_b
			-- <Precursor>
		note
			testing: "covers/{STI_TRANSFORMABLE_SET}.eq_b"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_TRANSFORMABLE_SET}.element_is_in.
			-- Test {STI_TRANSFORMABLE_SET}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_TRANSFORMABLE_SET}.element_is_in"
			testing: "covers/{STI_TRANSFORMABLE_SET}.element_is_in"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_TRANSFORMABLE_SET}.element_is_not_in.
			-- Test {STI_TRANSFORMABLE_SET}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_TRANSFORMABLE_SET}.element_is_not_in"
			testing: "covers/{STI_TRANSFORMABLE_SET}.element_is_not_in"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_in.
			-- Test {STI_TRANSFORMABLE_SET}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_in"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_in"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_not_in.
			-- Test {STI_TRANSFORMABLE_SET}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_not_in"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_not_in"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_has
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.has.
		note
			testing: "covers/{STI_SET}.has"
			testing: "covers/{STI_TRANSFORMABLE_SET}.has"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.does_not_have.
			-- Test {STI_TRANSFORMABLE_SET}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_TRANSFORMABLE_SET}.does_not_have"
			testing: "covers/{STI_TRANSFORMABLE_SET}.does_not_have"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.with.
		note
			testing: "covers/{STI_SET}.with"
			testing: "covers/{STI_TRANSFORMABLE_SET}.with"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_without
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.without.
		note
			testing: "covers/{STI_SET}.without"
			testing: "covers/{STI_TRANSFORMABLE_SET}.without"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.extended.
		note
			testing: "covers/{STI_SET}.extended"
			testing: "covers/{STI_TRANSFORMABLE_SET}.extended"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_TRANSFORMABLE_SET}.batch_extended"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.out.
		note
			testing: "covers/{STI_SET}.out"
			testing: "covers/{STI_TRANSFORMABLE_SET}.out"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_singleton.
			-- Test {STI_TRANSFORMABLE_SET}.is_singleton.
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_singleton"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_singleton"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.cardinality.
		note
			testing: "covers/{STI_SET}.cardinality"
			testing: "covers/{STI_TRANSFORMABLE_SET}.cardinality"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.equals"
			testing: "covers/{STI_TRANSFORMABLE_SET}.equals"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.unequals.
			-- Test {STI_TRANSFORMABLE_SET}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_TRANSFORMABLE_SET}.unequals"
			testing: "covers/{STI_TRANSFORMABLE_SET}.unequals"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_subset
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_subset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_subset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_not_subset.
			-- Test {STI_TRANSFORMABLE_SET}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_not_subset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_not_subset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_superset.
			-- Test {STI_TRANSFORMABLE_SET}.is_superset.
		note
			testing: "covers/{STS_SET}.is_superset"
			testing: "covers/{STI_SET}.is_superset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_superset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_superset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_not_superset.
			-- Test {STI_TRANSFORMABLE_SET}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_not_superset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_not_superset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_comparable.
			-- Test {STI_TRANSFORMABLE_SET}.is_comparable.
		note
			testing: "covers/{STS_SET}.is_comparable"
			testing: "covers/{STI_SET}.is_comparable"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_comparable"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_comparable"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_not_comparable.
			-- Test {STI_TRANSFORMABLE_SET}.is_not_comparable.
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_not_comparable"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_not_comparable"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.is_strict_subset.
		note
			testing: "covers/{STI_SET}.is_strict_subset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_strict_subset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_not_strict_subset.
			-- Test {STI_TRANSFORMABLE_SET}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_not_strict_subset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_not_strict_subset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_strict_superset.
			-- Test {STI_TRANSFORMABLE_SET}.is_strict_superset.
		note
			testing: "covers/{STS_SET}.is_strict_superset"
			testing: "covers/{STI_SET}.is_strict_superset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_strict_superset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_strict_superset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_not_strict_superset.
			-- Test {STI_TRANSFORMABLE_SET}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_not_strict_superset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_not_strict_superset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.is_trivial_subset.
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_trivial_subset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_trivial_superset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_trivial_superset.
			-- Test {STI_TRANSFORMABLE_SET}.is_trivial_superset.
		note
			testing: "covers/{STS_SET}.is_trivial_superset"
			testing: "covers/{STI_SET}.is_trivial_superset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_trivial_superset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_trivial_superset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.is_proper_subset.
		note
			testing: "covers/{STI_SET}.is_proper_subset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_proper_subset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_proper_superset.
			-- Test {STI_TRANSFORMABLE_SET}.is_proper_superset.
		note
			testing: "covers/{STS_SET}.is_proper_superset"
			testing: "covers/{STI_SET}.is_proper_superset"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_proper_superset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_proper_superset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.is_disjoint"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_disjoint"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.intersects.
			-- Test {STI_TRANSFORMABLE_SET}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_TRANSFORMABLE_SET}.intersects"
			testing: "covers/{STI_TRANSFORMABLE_SET}.intersects"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.is_partitioned.
			-- Test {STI_TRANSFORMABLE_SET}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_TRANSFORMABLE_SET}.is_partitioned"
			testing: "covers/{STI_TRANSFORMABLE_SET}.is_partitioned"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_TRANSFORMABLE_SET}.exists"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.does_not_exist.
			-- Test {STI_TRANSFORMABLE_SET}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_TRANSFORMABLE_SET}.does_not_exist"
			testing: "covers/{STI_TRANSFORMABLE_SET}.does_not_exist"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_TRANSFORMABLE_SET}.exists_unique"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_TRANSFORMABLE_SET}.exists_pair"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.does_not_exist_pair.
			-- Test {STI_TRANSFORMABLE_SET}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_TRANSFORMABLE_SET}.does_not_exist_pair"
			testing: "covers/{STI_TRANSFORMABLE_SET}.does_not_exist_pair"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_TRANSFORMABLE_SET}.exists_distinct_pair"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_TRANSFORMABLE_SET}.for_all"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_TRANSFORMABLE_SET}.for_all_pairs"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_TRANSFORMABLE_SET}.for_all_distinct_pairs"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.subsets.
		note
			testing: "covers/{STI_SET}.subsets"
			testing: "covers/{STI_TRANSFORMABLE_SET}.subsets"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_powerset
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.powerset.
		note
			testing: "covers/{STI_SET}.powerset"
			testing: "covers/{STI_TRANSFORMABLE_SET}.powerset"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_trivial_subsets
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.trivial_subsets.
		note
			testing: "covers/{STI_SET}.trivial_subsets"
			testing: "covers/{STI_TRANSFORMABLE_SET}.trivial_subsets"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_proper_subsets
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.proper_subsets.
			-- Test {STI_TRANSFORMABLE_SET}.proper_subsets.
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
			testing: "covers/{STS_TRANSFORMABLE_SET}.proper_subsets"
			testing: "covers/{STI_TRANSFORMABLE_SET}.proper_subsets"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_TRANSFORMABLE_SET}.filtered"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.complemented.
		note
			testing: "covers/{STI_SET}.complemented"
			testing: "covers/{STI_TRANSFORMABLE_SET}.complemented"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_united
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.united"
			testing: "covers/{STI_TRANSFORMABLE_SET}.united"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_intersected
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.intersected"
			testing: "covers/{STI_TRANSFORMABLE_SET}.intersected"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_subtracted
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subtracted"
			testing: "covers/{STI_TRANSFORMABLE_SET}.subtracted"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_TRANSFORMABLE_SET}.subtracted_symmetricaly"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_crossed
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_SET}.crossed"
			testing: "covers/{STI_TRANSFORMABLE_SET}.crossed"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_crossed_with_same_kind
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.crossed_with_same_kind.
			-- Test {STI_TRANSFORMABLE_SET}.crossed_with_same_kind.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_TRANSFORMABLE_SET}.crossed_with_same_kind"
			testing: "covers/{STI_TRANSFORMABLE_SET}.crossed_with_same_kind"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_squared
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.squared.
			-- Test {STI_TRANSFORMABLE_SET}.squared.
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
			testing: "covers/{STS_TRANSFORMABLE_SET}.squared"
			testing: "covers/{STI_TRANSFORMABLE_SET}.squared"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_diagonal
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.diagonal.
		note
			testing: "covers/{STI_SET}.diagonal"
			testing: "covers/{STI_TRANSFORMABLE_SET}.diagonal"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.raised.
			-- Test {STI_TRANSFORMABLE_SET}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_TRANSFORMABLE_SET}.raised"
			testing: "covers/{STI_TRANSFORMABLE_SET}.raised"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_TRANSFORMABLE_SET}.crossed_tuples"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_TRANSFORMABLE_SET}.singleton_crossed_tuples"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_SET}.mapped"
			testing: "covers/{STI_TRANSFORMABLE_SET}.mapped"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_mapped_to_same_kind
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.mapped_to_same_kind.
			-- Test {STI_TRANSFORMABLE_SET}.mapped_to_same_kind.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_TRANSFORMABLE_SET}.mapped_to_same_kind"
			testing: "covers/{STI_TRANSFORMABLE_SET}.mapped_to_same_kind"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_reduced
			-- <Precursor>
		note
			testing: "covers/{STS_TRANSFORMABLE_SET}.reduced"
			testing: "covers/{STI_TRANSFORMABLE_SET}.reduced"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_reduced_to_element_like
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.reduced_to_element_like.
			-- Test {STI_TRANSFORMABLE_SET}.reduced_to_element_like.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_TRANSFORMABLE_SET}.reduced_to_element_like"
			testing: "covers/{STI_TRANSFORMABLE_SET}.reduced_to_element_like"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.proper_reduced.
			-- Test {STI_TRANSFORMABLE_SET}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_TRANSFORMABLE_SET}.proper_reduced"
			testing: "covers/{STI_TRANSFORMABLE_SET}.proper_reduced"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_TRANSFORMABLE_SET}.natural_as_integer"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.as_singleton.
		note
			testing: "covers/{STI_SET}.as_singleton"
			testing: "covers/{STI_TRANSFORMABLE_SET}.as_singleton"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_TRANSFORMABLE_SET}.n_times"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_as_tuple
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.as_tuple.
		note
			testing: "covers/{STI_SET}.as_tuple"
			testing: "covers/{STI_TRANSFORMABLE_SET}.as_tuple"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Factory)

	test_o
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.o.
		note
			testing: "covers/{STI_SET}.o"
			testing: "covers/{STI_TRANSFORMABLE_SET}.o"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_empty_set
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.empty_set.
		note
			testing: "covers/{STI_SET}.empty_set"
			testing: "covers/{STI_TRANSFORMABLE_SET}.empty_set"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_singleton
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.singleton.
		note
			testing: "covers/{STI_SET}.singleton"
			testing: "covers/{STI_TRANSFORMABLE_SET}.singleton"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_TRANSFORMABLE_SET}.pair"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_TRANSFORMABLE_SET}.converted"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_converted_element
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.converted_element.
		note
			testing: "covers/{STI_SET}.converted_element"
			testing: "covers/{STI_TRANSFORMABLE_SET}.converted_element"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_unit
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.unit.
		note
			testing: "covers/{STI_SET}.unit"
			testing: "covers/{STI_TRANSFORMABLE_SET}.unit"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.ored.
			-- Test {STI_TRANSFORMABLE_SET}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_TRANSFORMABLE_SET}.ored"
			testing: "covers/{STI_TRANSFORMABLE_SET}.ored"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.xored.
			-- Test {STI_TRANSFORMABLE_SET}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_TRANSFORMABLE_SET}.xored"
			testing: "covers/{STI_TRANSFORMABLE_SET}.xored"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.iff.
			-- Test {STI_TRANSFORMABLE_SET}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_TRANSFORMABLE_SET}.iff"
			testing: "covers/{STI_TRANSFORMABLE_SET}.iff"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_TRANSFORMABLE_SET}.equality_holds"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
			-- Test {STI_TRANSFORMABLE_SET}.subset_relation_holds.
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
			testing: "covers/{STI_TRANSFORMABLE_SET}.subset_relation_holds"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.second_after_first.
			-- Test {STI_TRANSFORMABLE_SET}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_TRANSFORMABLE_SET}.second_after_first"
			testing: "covers/{STI_TRANSFORMABLE_SET}.second_after_first"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.natural_successor.
			-- Test {STI_TRANSFORMABLE_SET}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_TRANSFORMABLE_SET}.natural_successor"
			testing: "covers/{STI_TRANSFORMABLE_SET}.natural_successor"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.disjunction.
			-- Test {STI_TRANSFORMABLE_SET}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_TRANSFORMABLE_SET}.disjunction"
			testing: "covers/{STI_TRANSFORMABLE_SET}.disjunction"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.conjunction.
			-- Test {STI_TRANSFORMABLE_SET}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_TRANSFORMABLE_SET}.conjunction"
			testing: "covers/{STI_TRANSFORMABLE_SET}.conjunction"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_TRANSFORMABLE_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_TRANSFORMABLE_SET}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_TRANSFORMABLE_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_TRANSFORMABLE_SET}.sets_plus_same_sets_with_element"
		do
			Precursor {TRANSFORMABLE_SET_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
