note
	description: "Test suite for {STS_INTEGER_EQUALITY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	INTEGER_EQUALITY_TESTS

inherit
	EQUALITY_TESTS [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_integer as some_native_integer,
			some_object_a as some_integer
		undefine
			some_native_integer,
			some_element,
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_n_tuple
		redefine
			on_prepare,
			test_is_in,
			test_is_not_in,
			test_holds,
			test_holds_successively
		end

	NUMBERS_TESTS_RESOURCES_I
		redefine
			on_prepare
		end

feature -- Access

	properties: EQUALITY_PROPERTIES [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
			-- <Precursor>
--		once
--			create Result
--		ensure then
--			class
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {NUMBERS_TESTS_RESOURCES_I}
			create properties
		end

feature -- Test routines (Membership)

	test_is_in
			-- <Precursor>
			-- Test {STS_EQUALITY}.is_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_in.
			-- Test {STS_NUMERIC_EQUALITY}.is_in.
			-- Test {STS_INTEGER_EQUALITY}.is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_EQUALITY}.is_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_in"
			testing: "covers/{STS_NUMERIC_EQUALITY}.is_in"
			testing: "covers/{STS_INTEGER_EQUALITY}.is_in"
		do
			Precursor {EQUALITY_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_EQUALITY}.is_not_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_not_in.
			-- Test {STS_NUMERIC_EQUALITY}.is_not_in.
			-- Test {STS_INTEGER_EQUALITY}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_EQUALITY}.is_not_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_not_in"
			testing: "covers/{STS_NUMERIC_EQUALITY}.is_not_in"
			testing: "covers/{STS_INTEGER_EQUALITY}.is_not_in"
		do
			Precursor {EQUALITY_TESTS}
		end

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_INTEGER_EQUALITY}.holds.
		note
			testing: "covers/{STS_INTEGER_EQUALITY}.holds"
		do
			Precursor {EQUALITY_TESTS}
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively.
			-- Test {STS_NUMERIC_EQUALITY}.holds_successively.
			-- Test {STS_INTEGER_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_NUMERIC_EQUALITY}.holds_successively"
			testing: "covers/{STS_NEW_COMPLEX_EQUALITY}.holds_successively"
			testing: "covers/{STS_INTEGER_EQUALITY}.holds_successively"
		do
			Precursor {EQUALITY_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
