note
	description: "Test suite for {STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	NUMERIC_EQUALITY_TESTS_I

inherit
	NUMERIC_EQUALITY_TESTS [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		rename
			some_object_a as some_integer
		undefine
			on_prepare,
			some_native_integer,
			some_element,
			some_equality,
			some_pair,
			some_set,
			some_n_tuple
		redefine
			test_is_in,
			test_is_not_in,
			test_holds,
			test_holds_successively
		end

	NUMBERS_TESTS_NUMERIC_RESOURCES_I

feature -- Access

	properties: EQUALITY_PROPERTIES [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
			-- <Precursor>
		once
			create Result
		ensure then
			class
		end

feature -- Test routines (Membership)

	test_is_in
			-- <Precursor>
			-- Test {STS_EQUALITY}.is_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_in.
			-- Test {STS_NUMERIC_EQUALITY}.is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_EQUALITY}.is_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_in"
			testing: "covers/{STS_NUMERIC_EQUALITY}.is_in"
		do
			Precursor {NUMERIC_EQUALITY_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_EQUALITY}.is_not_in.
			-- Test {STS_INSTANCE_FREE_EQUALITY}.is_not_in.
			-- Test {STS_NUMERIC_EQUALITY}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_EQUALITY}.is_not_in"
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.is_not_in"
			testing: "covers/{STS_NUMERIC_EQUALITY}.is_not_in"
		do
			Precursor {NUMERIC_EQUALITY_TESTS}
		end

feature -- Test routines (Relationship)

	test_holds
			-- Test {STS_NUMERIC_EQUALITY}.holds.
		note
			testing: "covers/{STS_NUMERIC_EQUALITY}.holds"
		do
			Precursor {NUMERIC_EQUALITY_TESTS}
		end

	test_holds_successively
			-- Test {STS_INSTANCE_FREE_EQUALITY}.holds_successively.
			-- Test {STS_NUMERIC_EQUALITY}.holds_successively.
		note
			testing: "covers/{STS_INSTANCE_FREE_EQUALITY}.holds_successively"
			testing: "covers/{STS_NUMERIC_EQUALITY}.holds_successively"
		do
			Precursor {NUMERIC_EQUALITY_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
