﻿note
	description: "Test suite for {STI_COMPLEX_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	COMPLEX_SET_TESTS

inherit
	NUMERIC_SET_TESTS [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		rename
			some_object_a as some_complex,
			Z as Z_universe,
			test_u as test_c,
			test_universe as test_complex_universe
		undefine
			some_native_integer,
			some_element,
			some_equality,
			some_set,
			some_set_a,
			same_set_a,
			same_n_tuple_a
		redefine
			on_prepare,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_zero,
			test_c,
			test_complex_universe,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_without_zero,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_complement,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SET_TESTS [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		rename
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_integer as some_native_integer,
			some_object_a as some_complex
		undefine
			some_native_integer,
			some_element,
			some_equality,
			some_pair,
			some_set,
			some_set_a,
			same_set_a,
			some_n_tuple,
			same_n_tuple_a
		redefine
			on_prepare,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			set_to_be_tested,
			set_from_sa,
			set_from_saa
		end

	NUMBERS_TESTS_RESOURCES_C
		rename
			eq_a as eq,
			Z as Z_universe
		redefine
			on_prepare
		end

feature -- Access

	properties: COMPLEX_SET_PROPERTIES
			-- Object that checks the set-theory properties of {STI_COMPLEX_SET}
--		once
--			create Result
--		ensure then
--			class
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {NUMBERS_TESTS_RESOURCES_C}
			create properties
		end

feature -- Test routines (Initialization)

	test_make_empty
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.make_empty.
			-- Test {STI_COMPLEX_SET}.make_empty.
		note
			testing: "covers/{STI_SET}.make_empty"
			testing: "covers/{STI_NUMERIC_SET}.make_empty"
			testing: "covers/{STI_COMPLEX_SET}.make_empty"
		do
			Precursor {SET_TESTS}
		end

	test_make_singleton
			-- Test {STI_COMPLEX_SET}.make_singleton.
		note
			testing: "covers/{STI_COMPLEX_SET}.make_singleton"
		do
			Precursor {SET_TESTS}
		end

	test_make_extended
			-- Test {STI_COMPLEX_SET}.make_extended.
		note
			testing: "covers/{STI_COMPLEX_SET}.make_extended"
		do
			Precursor {SET_TESTS}
		end

	test_make_from_set
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.make_from_set.
			-- Test {STI_COMPLEX_SET}.make_from_set.
		note
			testing: "covers/{STI_SET}.make_from_set"
			testing: "covers/{STI_NUMERIC_SET}.make_from_set"
			testing: "covers/{STI_COMPLEX_SET}.make_from_set"
		local
			sti_sa: like some_set_a
			numeric_set: STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
			complex_set: like some_complex_set
			complexes_to_numeric_complexes: STI_TRANSFORMABLE_SET
				[STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
			complexes_to_complexes: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
			complexes_to_expanded_complexes: STI_TRANSFORMABLE_SET
				[STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
			complexes_to_numeric_reals: STI_TRANSFORMABLE_SET
				[STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
			complexes_to_expanded_reals:
				STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
			sti_saa: like new_transformable_set_aa
			chk_ops, chk_tests: BOOLEAN
			n: like some_set.cardinality
		do
			Precursor {SET_TESTS}

			sti_sa := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # sti_sa
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_sti_sa", attached set_from_sti_sa (sti_sa))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			numeric_set := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # numeric_set
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_numeric_set", attached set_from_numeric_set (numeric_set))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			numeric_set := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # numeric_set
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_sti_numeric_set", attached set_from_sti_numeric_set (numeric_set))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			complex_set := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_complex_set", attached set_from_complex_set (complex_set))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # C
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_universe", attached set_from_universe (C))
				assert ("set_from_sti_universe", attached set_from_sti_universe (C))
				assert ("set_from_complex_universe", attached set_from_complex_universe (C))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			sti_saa := new_transformable_set_aa
			assert ("set_from_sti_saa", attached set_from_sti_saa (sti_saa))

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_numeric_complexes := some_set_a
				n := # complexes_to_numeric_complexes
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_transformable_complexes_to_numeric_complexes",
					attached set_from_transformable_complexes_to_numeric_complexes (complexes_to_numeric_complexes)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_numeric_complexes := some_set_a
				n := # complexes_to_numeric_complexes
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_sti_transformable_complexes_to_numeric_complexes",
					attached set_from_sti_transformable_complexes_to_numeric_complexes (complexes_to_numeric_complexes)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_complexes := some_set_a
				n := # complexes_to_complexes
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert
					("set_from_transformable_complexes_to_complexes", attached set_from_transformable_complexes_to_complexes (complexes_to_complexes))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_complexes := some_set_a
				n := # complexes_to_complexes
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_sti_transformable_complexes_to_complexes",
					attached set_from_sti_transformable_complexes_to_complexes (complexes_to_complexes)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_expanded_complexes := some_set_a
				n := # complexes_to_expanded_complexes
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_transformable_complexes_to_expanded_complexes",
					attached set_from_transformable_complexes_to_expanded_complexes (complexes_to_expanded_complexes)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_expanded_complexes := some_set_a
				n := # complexes_to_expanded_complexes
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_sti_transformable_complexes_to_expanded_complexes",
					attached set_from_sti_transformable_complexes_to_expanded_complexes (complexes_to_expanded_complexes)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_numeric_reals := some_set_a
				n := # complexes_to_numeric_reals
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_transformable_complexes_to_numeric_reals",
					attached set_from_transformable_complexes_to_numeric_reals (complexes_to_numeric_reals)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_numeric_reals := some_set_a
				n := # complexes_to_numeric_reals
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_sti_transformable_complexes_to_numeric_reals",
					attached set_from_sti_transformable_complexes_to_numeric_reals (complexes_to_numeric_reals)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_expanded_reals := some_set_a
				n := # complexes_to_expanded_reals
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_transformable_complexes_to_expanded_reals",
					attached set_from_transformable_complexes_to_expanded_reals (complexes_to_expanded_reals)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				complexes_to_expanded_reals := some_set_a
				n := # complexes_to_expanded_reals
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert (
					"set_from_sti_transformable_complexes_to_expanded_reals",
					attached set_from_sti_transformable_complexes_to_expanded_reals (complexes_to_expanded_reals)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
		end

	test_make_from_numeric_set
			-- Test {STI_COMPLEX_SET}.make_from_numeric_set.
		note
			testing: "covers/{STI_COMPLEX_SET}.make_from_numeric_set"
		local
			sc: like some_complex_numbers
			numeric_set: STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
			complexes_to_numeric_complexes: STI_TRANSFORMABLE_SET
				[STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
			complexes_to_complexes:
				STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY]
			complexes_to_expanded_complexes: STI_TRANSFORMABLE_SET
				[STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
			scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY]
			complexes_to_expanded_reals:
				STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
			n: like some_complex_numbers.cardinality
			chk_ops, chk_tests: BOOLEAN
		do
			sc := some_complex_numbers

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # sc
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("make_from_numeric_set", attached (create {like set_to_be_tested}.make_from_numeric_set (sc)))
				assert ("set_from_sc", attached set_from_sc (sc))
				assert ("set_from_sti_sc", attached set_from_sti_sc (sc))

				complexes_to_numeric_complexes := sc
				assert (
					"set_from_transformable_numeric_complexes_to_numeric_complexes",
					attached set_from_transformable_numeric_complexes_to_numeric_complexes (complexes_to_numeric_complexes)
					)
				assert (
					"set_from_sti_transformable_numeric_complexes_to_numeric_complexes",
					attached set_from_sti_transformable_numeric_complexes_to_numeric_complexes (complexes_to_numeric_complexes)
					)

				complexes_to_complexes := sc
				assert
					("set_from_transformable_numeric_complexes_to_complexes", attached set_from_transformable_numeric_complexes_to_complexes (complexes_to_complexes))
				assert (
					"set_from_sti_transformable_numeric_complexes_to_complexes",
					attached set_from_sti_transformable_numeric_complexes_to_complexes (complexes_to_complexes)
					)

				complexes_to_expanded_complexes := sc
				assert (
					"set_from_transformable_numeric_complexes_to_expanded_complexes",
					attached set_from_transformable_numeric_complexes_to_expanded_complexes (complexes_to_expanded_complexes)
					)
				assert (
					"set_from_sti_transformable_numeric_complexes_to_expanded_complexes",
					attached set_from_sti_transformable_numeric_complexes_to_expanded_complexes (complexes_to_expanded_complexes)
					)

				scc := sc
				assert ("set_from_scr", attached set_from_scr (scc))
				assert ("set_from_sti_scr", attached set_from_sti_scr (scc))

				assert ("set_from_transformable_numeric_complexes_to_reals", attached set_from_transformable_numeric_complexes_to_reals (scc))
				assert ("set_from_sti_transformable_numeric_complexes_to_reals", attached set_from_sti_transformable_numeric_complexes_to_reals (scc))

				complexes_to_expanded_reals := sc
				assert (
					"set_from_transformable_numeric_complexes_to_expanded_reals",
					attached set_from_transformable_numeric_complexes_to_expanded_reals (complexes_to_expanded_reals)
					)
				assert (
					"set_from_sti_transformable_numeric_complexes_to_expanded_reals",
					attached set_from_sti_transformable_numeric_complexes_to_expanded_reals (complexes_to_expanded_reals)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			numeric_set := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # numeric_set
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_numeric_complexes", attached set_from_numeric_complexes (numeric_set))
				assert ("set_from_sti_numeric_complexes", attached set_from_sti_numeric_complexes (numeric_set))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			assert ("set_from_numeric_universe", attached set_from_numeric_universe (C))
			assert ("set_from_sti_numeric_universe", attached set_from_sti_numeric_universe (C))
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.is_empty.
			-- Test {STI_COMPLEX_SET}.is_empty.
		note
			testing: "covers/{STI_SET}.is_empty"
			testing: "covers/{STI_NUMERIC_SET}.is_empty"
			testing: "covers/{STI_COMPLEX_SET}.is_empty"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_any
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.any.
			-- Test {STI_COMPLEX_SET}.any.
		note
			testing: "covers/{STI_SET}.any"
			testing: "covers/{STI_NUMERIC_SET}.any"
			testing: "covers/{STI_COMPLEX_SET}.any"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.others.
			-- Test {STI_COMPLEX_SET}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_NUMERIC_SET}.others"
			testing: "covers/{STI_COMPLEX_SET}.others"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_eq
			-- Test {STI_COMPLEX_SET}.eq.
		note
			testing: "covers/{STI_COMPLEX_SET}.eq"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_NUMERIC_SET}.element_is_in.
			-- Test {STI_NUMERIC_SET}.element_is_in.
			-- Test {STS_COMPLEX_SET}.element_is_in.
			-- Test {STI_COMPLEX_SET}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_in"
			testing: "covers/{STS_COMPLEX_SET}.element_is_in"
			testing: "covers/{STI_COMPLEX_SET}.element_is_in"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_NUMERIC_SET}.element_is_not_in.
			-- Test {STI_NUMERIC_SET}.element_is_not_in.
			-- Test {STS_COMPLEX_SET}.element_is_not_in.
			-- Test {STI_COMPLEX_SET}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STS_COMPLEX_SET}.element_is_not_in"
			testing: "covers/{STI_COMPLEX_SET}.element_is_not_in"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_in.
			-- Test {STI_NUMERIC_SET}.is_in.
			-- Test {STS_COMPLEX_SET}.is_in.
			-- Test {STI_COMPLEX_SET}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_NUMERIC_SET}.is_in"
			testing: "covers/{STI_NUMERIC_SET}.is_in"
			testing: "covers/{STS_COMPLEX_SET}.is_in"
			testing: "covers/{STI_COMPLEX_SET}.is_in"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_in.
			-- Test {STI_NUMERIC_SET}.is_not_in.
			-- Test {STS_COMPLEX_SET}.is_not_in.
			-- Test {STI_COMPLEX_SET}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.is_not_in"
			testing: "covers/{STS_COMPLEX_SET}.is_not_in"
			testing: "covers/{STI_COMPLEX_SET}.is_not_in"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_has
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.has.
			-- Test {STI_COMPLEX_SET}.has.
		note
			testing: "covers/{STI_SET}.has"
			testing: "covers/{STI_NUMERIC_SET}.has"
			testing: "covers/{STI_COMPLEX_SET}.has"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_have.
			-- Test {STI_NUMERIC_SET}.does_not_have.
			-- Test {STS_COMPLEX_SET}.does_not_have.
			-- Test {STI_COMPLEX_SET}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_NUMERIC_SET}.does_not_have"
			testing: "covers/{STI_NUMERIC_SET}.does_not_have"
			testing: "covers/{STS_COMPLEX_SET}.does_not_have"
			testing: "covers/{STI_COMPLEX_SET}.does_not_have"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Access)

	test_zero
			-- Test {STI_COMPLEX_SET}.Zero.
		note
			testing: "covers/{STI_COMPLEX_SET}.zero"
		local
			s: like set_to_be_tested
		do
			Precursor {NUMERIC_SET_TESTS}

			s := set_to_be_tested

			assert ("-NaN-NaN*i ok", properties.zero_ok (s, -Nan - Nan*i))
			assert ("NaN-NaN*i ok", properties.zero_ok (s, Nan - Nan*i))
			assert ("-Infinity-NaN*i ok", properties.zero_ok (s, Negative_infinity - Nan*i))
			assert ("Infinity-NaN*i ok", properties.zero_ok (s, Positive_infinity - Nan*i))
			assert ("-NaN*i ok", properties.zero_ok (s, -Nan*i))
			assert ("-0-NaN*i ok", properties.zero_ok (s, -0.0 - Nan*i))
			assert ("0-NaN*i ok", properties.zero_ok (s, 0 - Nan*i))
			assert ("a-NaN*i ok", properties.zero_ok (s, some_real - Nan*i))

			assert ("-NaN+NaN*i ok", properties.zero_ok (s, -Nan + Nan*i))
			assert ("NaN+NaN*i ok", properties.zero_ok (s, Nan + Nan*i))
			assert ("-Infinity+NaN*i ok", properties.zero_ok (s, Negative_infinity + Nan*i))
			assert ("Infinity+NaN*i ok", properties.zero_ok (s, Positive_infinity + Nan*i))
			assert ("NaN*i ok", properties.zero_ok (s, Nan*i))
			assert ("-0+NaN*i ok", properties.zero_ok (s, -0.0 + Nan*i))
			assert ("0+NaN*i ok", properties.zero_ok (s, 0 + Nan*i))
			assert ("a+NaN*i ok", properties.zero_ok (s, some_real + Nan*i))

			assert ("-NaN-Infinity*i ok", properties.zero_ok (s, -Nan + Negative_infinity*i))
			assert ("NaN-Infinity*i ok", properties.zero_ok (s, Nan + Negative_infinity*i))
			assert ("-Infinity-Infinity*i ok", properties.zero_ok (s, Negative_infinity + Negative_infinity*i))
			assert ("Infinity-Infinity*i ok", properties.zero_ok (s, Positive_infinity + Negative_infinity*i))
			assert ("-Infinity*i ok", properties.zero_ok (s, Negative_infinity*i))
			assert ("-0-Infinity*i ok", properties.zero_ok (s, -0.0 + Negative_infinity*i))
			assert ("0-Infinity*i ok", properties.zero_ok (s, 0 + Negative_infinity*i))
			assert ("a-Infinity*i ok", properties.zero_ok (s, some_real + Negative_infinity*i))

			assert ("-NaN+Infinity*i ok", properties.zero_ok (s, -Nan + Positive_infinity*i))
			assert ("NaN+Infinity*i ok", properties.zero_ok (s, Nan + Positive_infinity*i))
			assert ("-Infinity+Infinity*i ok", properties.zero_ok (s, Negative_infinity + Positive_infinity*i))
			assert ("Infinity+Infinity*i ok", properties.zero_ok (s, Positive_infinity + Positive_infinity*i))
			assert ("Infinity*i ok", properties.zero_ok (s, Positive_infinity*i))
			assert ("-0+Infinity*i ok", properties.zero_ok (s, -0.0 + Positive_infinity*i))
			assert ("0+Infinity*i ok", properties.zero_ok (s, 0 + Positive_infinity*i))
			assert ("a+Infinity*i ok", properties.zero_ok (s, some_real + Positive_infinity*i))

			assert ("-NaN-0*i ok", properties.zero_ok (s, -Nan - 0*i))
			assert ("NaN-0*i ok", properties.zero_ok (s, Nan - 0*i))
			assert ("-Infinity-0*i ok", properties.zero_ok (s, Negative_infinity - 0*i))
			assert ("Infinity-0*i ok", properties.zero_ok (s, Positive_infinity - 0*i))
			assert ("-0*i ok", properties.zero_ok (s, -0.0*i))
			assert ("-0-0*i ok", properties.zero_ok (s, -0.0 - 0*i))
			assert ("0-0*i ok", properties.zero_ok (s, 0 - 0*i))
			assert ("a-0*i ok", properties.zero_ok (s, some_real - 0*i))

			assert ("-NaN ok", properties.zero_ok (s, -Nan))
			assert ("-NaN+0*i ok", properties.zero_ok (s, -Nan + 0*i))
			assert ("NaN ok", properties.zero_ok (s, Nan))
			assert ("NaN+0*i ok", properties.zero_ok (s, Nan + 0*i))
			assert ("-Infinity ok", properties.zero_ok (s, Negative_infinity))
			assert ("-Infinity+0*i ok", properties.zero_ok (s, Negative_infinity + 0*i))
			assert ("Infinity ok", properties.zero_ok (s, Positive_infinity))
			assert ("Infinity+0*i ok", properties.zero_ok (s, Positive_infinity + 0*i))
			assert ("0 ok", properties.zero_ok (s, Zero))
			assert ("0*i ok", properties.zero_ok (s, 0*i))
			assert ("-0+0*i ok", properties.zero_ok (s, -0.0 + 0*i))
			assert ("0+0*i ok", properties.zero_ok (s, 0 + 0*i))
			assert ("a ok", properties.zero_ok (s, some_real))
			assert ("a+0*i ok", properties.zero_ok (s, some_real + 0*i))

			assert ("-NaN+bi ok", properties.zero_ok (s, -Nan + some_real*i))
			assert ("NaN+bi ok", properties.zero_ok (s, Nan + some_real*i))
			assert ("-Infinity+bi ok", properties.zero_ok (s, Negative_infinity + some_real*i))
			assert ("Infinity+bi ok", properties.zero_ok (s, Positive_infinity + some_real*i))
			assert ("bi ok", properties.zero_ok (s, some_real*i))
			assert ("-0+bi ok", properties.zero_ok (s, -0.0 + some_real*i))
			assert ("0+bi ok", properties.zero_ok (s, 0 + some_real*i))
			assert ("a+bi ok", properties.zero_ok (s, some_real + some_real*i))
		end

	test_c
			-- Test {STI_COMPLEX_SET}.c.
		note
			testing: "covers/{STI_COMPLEX_SET}.c"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_complex_universe
			-- Test {STI_COMPLEX_SET}.complex_universe.
		note
			testing: "covers/{STI_COMPLEX_SET}.complex_universe"
		local
			chk_tests: BOOLEAN
			s: like set_to_be_tested
		do
			s := set_to_be_tested
			chk_tests := {ISE_RUNTIME}.check_assert (False) -- This creation is too expensive.
				assert ("complex_universe", attached s.complex_universe)
			chk_tests := {ISE_RUNTIME}.check_assert (chk_tests)
			assert ("ℂ is well formed.", s.complex_universe ∋ Zero) -- This checks the invariant of s.complex_universe.
			assert ("universe_ok", properties.universe_ok (s, some_complex))
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.with.
			-- Test {STI_COMPLEX_SET}.with.
		note
			testing: "covers/{STI_SET}.with"
			testing: "covers/{STI_NUMERIC_SET}.with"
			testing: "covers/{STI_COMPLEX_SET}.with"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_without
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.without.
			-- Test {STI_COMPLEX_SET}.without.
		note
			testing: "covers/{STI_SET}.without"
			testing: "covers/{STI_NUMERIC_SET}.without"
			testing: "covers/{STI_COMPLEX_SET}.without"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.extended.
		note
			testing: "covers/{STI_SET}.extended"
			testing: "covers/{STI_COMPLEX_SET}.extended"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.batch_extended.
			-- Test {STI_COMPLEX_SET}.batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_NUMERIC_SET}.batch_extended"
			testing: "covers/{STI_COMPLEX_SET}.batch_extended"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_numeric_batch_extended
			-- Test {STI_COMPLEX_SET}.numeric_batch_extended.
		note
			testing: "covers/{STI_COMPLEX_SET}.numeric_batch_extended"
		local
			s0: like some_complex_numbers
			s: like set_to_be_tested
			chk_ops, chk_tests: BOOLEAN
			n: NATURAL_32
		do
			s0 := some_complex_numbers
			s := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s0
				print (n) print ('%N')
				s := s | agent s0.does_not_have
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("s0_is_disjoint_s", s0.is_disjoint (s))
				assert ("s_numeric_batch_extended_s0", attached s.numeric_batch_extended (s0))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("s_numeric_batch_extended_s0_ok", properties.numeric_batch_extended_ok (s0, s))

			s0 := some_complex_numbers
			s := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s0
				print (n) print ('%N')
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("numeric_batch_extended", s0.is_disjoint (s) implies attached s.numeric_batch_extended (s0))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("numeric_batch_extended_ok", properties.numeric_batch_extended_ok (s0, s))
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.out.
			-- Test {STI_COMPLEX_SET}.out.
		note
			testing: "covers/{STI_SET}.out"
			testing: "covers/{STI_NUMERIC_SET}.out"
			testing: "covers/{STI_COMPLEX_SET}.out"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_singleton.
			-- Test {STI_NUMERIC_SET}.is_singleton.
			-- Test {STS_COMPLEX_SET}.is_singleton.
			-- Test {STI_COMPLEX_SET}.is_singleton.
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
			testing: "covers/{STS_NUMERIC_SET}.is_singleton"
			testing: "covers/{STI_NUMERIC_SET}.is_singleton"
			testing: "covers/{STS_COMPLEX_SET}.is_singleton"
			testing: "covers/{STI_COMPLEX_SET}.is_singleton"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.cardinality.
			-- Test {STI_COMPLEX_SET}.cardinality.
		note
			testing: "covers/{STI_SET}.cardinality"
			testing: "covers/{STI_NUMERIC_SET}.cardinality"
			testing: "covers/{STI_COMPLEX_SET}.cardinality"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.equals.
		note
			testing: "covers/{STI_NUMERIC_SET}.equals"
			testing: "covers/{STI_COMPLEX_SET}.equals"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.unequals.
			-- Test {STI_NUMERIC_SET}.unequals.
			-- Test {STS_COMPLEX_SET}.unequals.
			-- Test {STI_COMPLEX_SET}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_NUMERIC_SET}.unequals"
			testing: "covers/{STI_NUMERIC_SET}.unequals"
			testing: "covers/{STS_COMPLEX_SET}.unequals"
			testing: "covers/{STI_COMPLEX_SET}.unequals"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_subset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_subset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_subset.
			-- Test {STI_NUMERIC_SET}.is_not_subset.
			-- Test {STS_COMPLEX_SET}.is_not_subset.
			-- Test {STI_COMPLEX_SET}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_subset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_superset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_COMPLEX_SET}.is_not_superset.
			-- Test {STI_COMPLEX_SET}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_superset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_comparable.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_comparable"
			testing: "covers/{STI_COMPLEX_SET}.is_comparable"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STS_COMPLEX_SET}.is_not_comparable.
			-- Test {STI_COMPLEX_SET}.is_not_comparable.
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
			testing: "covers/{STS_NUMERIC_SET}.is_not_comparable"
			testing: "covers/{STI_NUMERIC_SET}.is_not_comparable"
			testing: "covers/{STS_COMPLEX_SET}.is_not_comparable"
			testing: "covers/{STI_COMPLEX_SET}.is_not_comparable"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_strict_subset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_strict_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_strict_subset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STS_COMPLEX_SET}.is_not_strict_subset.
			-- Test {STI_COMPLEX_SET}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_strict_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_strict_subset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_strict_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_strict_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_strict_superset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STS_COMPLEX_SET}.is_not_strict_superset.
			-- Test {STI_COMPLEX_SET}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_strict_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_strict_superset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_trivial_subset.
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_trivial_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_trivial_subset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_trivial_superset
			-- Test {STI_NUMERIC_SET}.is_trivial_superset.
			-- Test {STI_COMPLEX_SET}.is_trivial_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_trivial_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_trivial_superset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_proper_subset.
		note
			testing: "covers/{STI_SET}.is_proper_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_proper_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_proper_subset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_proper_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_proper_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_proper_superset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.is_disjoint.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_disjoint"
			testing: "covers/{STI_COMPLEX_SET}.is_disjoint"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.intersects.
			-- Test {STI_NUMERIC_SET}.intersects.
			-- Test {STS_COMPLEX_SET}.intersects.
			-- Test {STI_COMPLEX_SET}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_NUMERIC_SET}.intersects"
			testing: "covers/{STI_NUMERIC_SET}.intersects"
			testing: "covers/{STS_COMPLEX_SET}.intersects"
			testing: "covers/{STI_COMPLEX_SET}.intersects"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_partitioned.
			-- Test {STI_NUMERIC_SET}.is_partitioned.
			-- Test {STS_COMPLEX_SET}.is_partitioned.
			-- Test {STI_COMPLEX_SET}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STI_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STS_COMPLEX_SET}.is_partitioned"
			testing: "covers/{STI_COMPLEX_SET}.is_partitioned"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists.
			-- Test {STI_COMPLEX_SET}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_NUMERIC_SET}.exists"
			testing: "covers/{STI_COMPLEX_SET}.exists"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist.
			-- Test {STI_NUMERIC_SET}.does_not_exist.
			-- Test {STS_COMPLEX_SET}.does_not_exist.
			-- Test {STI_COMPLEX_SET}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STS_COMPLEX_SET}.does_not_exist"
			testing: "covers/{STI_COMPLEX_SET}.does_not_exist"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_unique.
			-- Test {STI_COMPLEX_SET}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_NUMERIC_SET}.exists_unique"
			testing: "covers/{STI_COMPLEX_SET}.exists_unique"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_pair.
			-- Test {STI_COMPLEX_SET}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_pair"
			testing: "covers/{STI_COMPLEX_SET}.exists_pair"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STI_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STS_COMPLEX_SET}.does_not_exist_pair.
			-- Test {STI_COMPLEX_SET}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STS_COMPLEX_SET}.does_not_exist_pair"
			testing: "covers/{STI_COMPLEX_SET}.does_not_exist_pair"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_distinct_pair.
			-- Test {STI_COMPLEX_SET}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_distinct_pair"
			testing: "covers/{STI_COMPLEX_SET}.exists_distinct_pair"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all.
			-- Test {STI_COMPLEX_SET}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_NUMERIC_SET}.for_all"
			testing: "covers/{STI_COMPLEX_SET}.for_all"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_pairs.
			-- Test {STI_COMPLEX_SET}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_pairs"
			testing: "covers/{STI_COMPLEX_SET}.for_all_pairs"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_distinct_pairs.
			-- Test {STI_COMPLEX_SET}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_COMPLEX_SET}.for_all_distinct_pairs"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Restriction)

	test_without_zero
			-- <Precursor>
			-- Test {STS_COMPLEX_SET}.without_zero.
			-- Test {STI_COMPLEX_SET}.without_zero.
		note
			testing: "covers/{STS_NUMERIC_SET}.without_zero"
			testing: "covers/{STI_NUMERIC_SET}.without_zero"
			testing: "covers/{STS_COMPLEX_SET}.without_zero"
			testing: "covers/{STI_COMPLEX_SET}.without_zero"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.subsets.
			-- Test {STI_COMPLEX_SET}.subsets.
		note
			testing: "covers/{STI_SET}.subsets"
			testing: "covers/{STI_NUMERIC_SET}.subsets"
			testing: "covers/{STI_COMPLEX_SET}.subsets"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_powerset
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.powerset.
			-- Test {STI_COMPLEX_SET}.powerset.
		note
			testing: "covers/{STI_SET}.powerset"
			testing: "covers/{STI_NUMERIC_SET}.powerset"
			testing: "covers/{STI_COMPLEX_SET}.powerset"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_trivial_subsets
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.trivial_subsets.
			-- Test {STI_COMPLEX_SET}.trivial_subsets.
		note
			testing: "covers/{STI_SET}.trivial_subsets"
			testing: "covers/{STI_NUMERIC_SET}.trivial_subsets"
			testing: "covers/{STI_COMPLEX_SET}.trivial_subsets"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_proper_subsets
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.proper_subsets.
			-- Test {STI_NUMERIC_SET}.proper_subsets.
			-- Test {STS_COMPLEX_SET}.proper_subsets.
			-- Test {STI_COMPLEX_SET}.proper_subsets.
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
			testing: "covers/{STS_NUMERIC_SET}.proper_subsets"
			testing: "covers/{STI_NUMERIC_SET}.proper_subsets"
			testing: "covers/{STS_COMPLEX_SET}.proper_subsets"
			testing: "covers/{STI_COMPLEX_SET}.proper_subsets"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.filtered.
			-- Test {STI_COMPLEX_SET}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_NUMERIC_SET}.filtered"
			testing: "covers/{STI_COMPLEX_SET}.filtered"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.complemented.
		note
			testing: "covers/{STI_NUMERIC_SET}.complemented"
			testing: "covers/{STI_COMPLEX_SET}.complemented"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_complement
			-- <Precursor>
			-- Test {STS_COMPLEX_SET}.complement.
			-- Test {STI_COMPLEX_SET}.complement.
		note
			testing: "covers/{STS_NUMERIC_SET}.complement"
			testing: "covers/{STI_NUMERIC_SET}.complement"
			testing: "covers/{STS_COMPLEX_SET}.complement"
			testing: "covers/{STI_COMPLEX_SET}.complement"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_united
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.united.
		note
			testing: "covers/{STI_NUMERIC_SET}.united"
			testing: "covers/{STI_COMPLEX_SET}.united"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.intersected.
		note
			testing: "covers/{STI_NUMERIC_SET}.intersected"
			testing: "covers/{STI_COMPLEX_SET}.intersected"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_subtracted
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.subtracted.
		note
			testing: "covers/{STI_NUMERIC_SET}.subtracted"
			testing: "covers/{STI_COMPLEX_SET}.subtracted"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_NUMERIC_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_COMPLEX_SET}.subtracted_symmetricaly"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.crossed.
			-- Test {STI_NUMERIC_SET}.crossed.
			-- Test {STS_COMPLEX_SET}.crossed.
			-- Test {STI_COMPLEX_SET}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_NUMERIC_SET}.crossed"
			testing: "covers/{STI_NUMERIC_SET}.crossed"
			testing: "covers/{STS_COMPLEX_SET}.crossed"
			testing: "covers/{STI_COMPLEX_SET}.crossed"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_squared
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.squared.
			-- Test {STI_NUMERIC_SET}.squared.
			-- Test {STS_COMPLEX_SET}.squared.
			-- Test {STI_COMPLEX_SET}.squared.
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
			testing: "covers/{STS_NUMERIC_SET}.squared"
			testing: "covers/{STI_NUMERIC_SET}.squared"
			testing: "covers/{STS_COMPLEX_SET}.squared"
			testing: "covers/{STI_COMPLEX_SET}.squared"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_diagonal
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.diagonal.
			-- Test {STI_COMPLEX_SET}.diagonal.
		note
			testing: "covers/{STI_SET}.diagonal"
			testing: "covers/{STI_NUMERIC_SET}.diagonal"
			testing: "covers/{STI_COMPLEX_SET}.diagonal"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.raised.
			-- Test {STI_NUMERIC_SET}.raised.
			-- Test {STS_COMPLEX_SET}.raised.
			-- Test {STI_COMPLEX_SET}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_NUMERIC_SET}.raised"
			testing: "covers/{STI_NUMERIC_SET}.raised"
			testing: "covers/{STS_COMPLEX_SET}.raised"
			testing: "covers/{STI_COMPLEX_SET}.raised"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.crossed_tuples.
			-- Test {STI_COMPLEX_SET}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.crossed_tuples"
			testing: "covers/{STI_COMPLEX_SET}.crossed_tuples"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.singleton_crossed_tuples.
			-- Test {STI_COMPLEX_SET}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_COMPLEX_SET}.singleton_crossed_tuples"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.mapped.
			-- Test {STI_NUMERIC_SET}.mapped.
			-- Test {STS_COMPLEX_SET}.mapped.
			-- Test {STI_COMPLEX_SET}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_NUMERIC_SET}.mapped"
			testing: "covers/{STI_NUMERIC_SET}.mapped"
			testing: "covers/{STS_COMPLEX_SET}.mapped"
			testing: "covers/{STI_COMPLEX_SET}.mapped"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.reduced.
			-- Test {STI_NUMERIC_SET}.reduced.
			-- Test {STS_COMPLEX_SET}.reduced.
			-- Test {STI_COMPLEX_SET}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_NUMERIC_SET}.reduced"
			testing: "covers/{STI_NUMERIC_SET}.reduced"
			testing: "covers/{STS_COMPLEX_SET}.reduced"
			testing: "covers/{STI_COMPLEX_SET}.reduced"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.proper_reduced.
			-- Test {STI_NUMERIC_SET}.proper_reduced.
			-- Test {STS_COMPLEX_SET}.proper_reduced.
			-- Test {STI_COMPLEX_SET}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STI_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STS_COMPLEX_SET}.proper_reduced"
			testing: "covers/{STI_COMPLEX_SET}.proper_reduced"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.natural_as_integer.
			-- Test {STI_COMPLEX_SET}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_NUMERIC_SET}.natural_as_integer"
			testing: "covers/{STI_COMPLEX_SET}.natural_as_integer"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.as_singleton.
			-- Test {STI_COMPLEX_SET}.as_singleton.
		note
			testing: "covers/{STI_SET}.as_singleton"
			testing: "covers/{STI_NUMERIC_SET}.as_singleton"
			testing: "covers/{STI_COMPLEX_SET}.as_singleton"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.n_times.
			-- Test {STI_COMPLEX_SET}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_NUMERIC_SET}.n_times"
			testing: "covers/{STI_COMPLEX_SET}.n_times"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_as_tuple
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.as_tuple.
			-- Test {STI_COMPLEX_SET}.as_tuple.
		note
			testing: "covers/{STI_SET}.as_tuple"
			testing: "covers/{STI_NUMERIC_SET}.as_tuple"
			testing: "covers/{STI_COMPLEX_SET}.as_tuple"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_as_set_of_pairs
			-- Test {STI_COMPLEX_SET}.as_set_of_pairs.
		note
			testing: "covers/{STI_COMPLEX_SET}.as_set_of_pairs"
		do
			assert ("as_set_of_pairs", attached set_to_be_tested.as_set_of_pairs)
			assert ("complex_set_to_sti_set_of_pairs", attached complex_set_to_sti_set_of_pairs)
			assert ("complex_set_to_set_of_pairs", attached complex_set_to_set_of_pairs)
			assert ("complex_set_to_sti_set_of_numeric_pairs", attached complex_set_to_sti_set_of_numeric_pairs)
			assert ("complex_set_to_set_of_numeric_pairs", attached complex_set_to_set_of_numeric_pairs)
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_COMPLEX_SET}.o.
		note
			testing: "covers/{STI_COMPLEX_SET}.o"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_empty_set
			-- Test {STI_COMPLEX_SET}.empty_set.
		note
			testing: "covers/{STI_COMPLEX_SET}.empty_set"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_singleton
			-- Test {STI_COMPLEX_SET}.singleton.
		note
			testing: "covers/{STI_COMPLEX_SET}.singleton"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.pair.
			-- Test {STI_COMPLEX_SET}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_NUMERIC_SET}.pair"
			testing: "covers/{STI_COMPLEX_SET}.pair"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.converted.
			-- Test {STI_COMPLEX_SET}.converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_NUMERIC_SET}.converted"
			testing: "covers/{STI_COMPLEX_SET}.converted"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_numeric_converted
			-- Test {STI_COMPLEX_SET}.numeric_converted.
		note
			testing: "covers/{STI_COMPLEX_SET}.numeric_converted"
		do
			assert ("converted", attached set_to_be_tested.numeric_converted (some_complex_numbers))
		end

	test_converted_element
			-- Test {STI_COMPLEX_SET}.converted_element.
		note
			testing: "covers/{STI_COMPLEX_SET}.converted_element"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_unit
			-- Test {STI_COMPLEX_SET}.unit.
		note
			testing: "covers/{STI_COMPLEX_SET}.unit"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.ored.
			-- Test {STI_NUMERIC_SET}.ored.
			-- Test {STS_COMPLEX_SET}.ored.
			-- Test {STI_COMPLEX_SET}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_NUMERIC_SET}.ored"
			testing: "covers/{STI_NUMERIC_SET}.ored"
			testing: "covers/{STS_COMPLEX_SET}.ored"
			testing: "covers/{STI_COMPLEX_SET}.ored"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.xored.
			-- Test {STI_NUMERIC_SET}.xored.
			-- Test {STS_COMPLEX_SET}.xored.
			-- Test {STI_COMPLEX_SET}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_NUMERIC_SET}.xored"
			testing: "covers/{STI_NUMERIC_SET}.xored"
			testing: "covers/{STS_COMPLEX_SET}.xored"
			testing: "covers/{STI_COMPLEX_SET}.xored"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.iff.
			-- Test {STI_NUMERIC_SET}.iff.
			-- Test {STS_COMPLEX_SET}.iff.
			-- Test {STI_COMPLEX_SET}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_NUMERIC_SET}.iff"
			testing: "covers/{STI_NUMERIC_SET}.iff"
			testing: "covers/{STS_COMPLEX_SET}.iff"
			testing: "covers/{STI_COMPLEX_SET}.iff"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.equality_holds.
			-- Test {STI_COMPLEX_SET}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_NUMERIC_SET}.equality_holds"
			testing: "covers/{STI_COMPLEX_SET}.equality_holds"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
		do
			Precursor {SET_TESTS}
		end

	test_set_has_complex_number
			-- Test {STI_COMPLEX_SET}.set_has_complex_number.
		note
			testing: "covers/{STI_COMPLEX_SET}.set_has_complex_number"
		local
			s: STS_SET_OF_ORDERED_PAIRS [
				STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]
				]
			z: like some_expanded_complex
		do
			across
				1 |..| (some_count.as_integer_32) as j
			from
				inspect
					next_random_item \\ 2
				when 0 then
					create {
						STI_SET_OF_ORDERED_PAIRS [
							STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]
							]
						} s.make_empty
				when 1 then
					create {STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]} s.make_empty
				end
			loop
				inspect
					next_random_item \\ 2
				when 0 then
					s := s & some_expanded_complex.as_ordered_pair
				when 1 then
					s := s & some_exposed_complex.as_ordered_pair
				end
			end
			z := some_expanded_complex
			s := s & z.as_ordered_pair
			assert ("s ∋ z", set_to_be_tested.set_has_complex_number (s, z))

			z := some_expanded_complex
--			s := s / z -- TODO: Segmentation violation!
			s := s / z.as_ordered_pair
			assert ("s ∌ z", not set_to_be_tested.set_has_complex_number (s, z))

			z := some_expanded_complex
			assert ("set_has_complex_number", set_to_be_tested.set_has_complex_number (s, z) implies True)
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.second_after_first.
			-- Test {STI_NUMERIC_SET}.second_after_first.
			-- Test {STS_COMPLEX_SET}.second_after_first.
			-- Test {STI_COMPLEX_SET}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_NUMERIC_SET}.second_after_first"
			testing: "covers/{STI_NUMERIC_SET}.second_after_first"
			testing: "covers/{STS_COMPLEX_SET}.second_after_first"
			testing: "covers/{STI_COMPLEX_SET}.second_after_first"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.natural_successor.
			-- Test {STI_NUMERIC_SET}.natural_successor.
			-- Test {STS_COMPLEX_SET}.natural_successor.
			-- Test {STI_COMPLEX_SET}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_NUMERIC_SET}.natural_successor"
			testing: "covers/{STI_NUMERIC_SET}.natural_successor"
			testing: "covers/{STS_COMPLEX_SET}.natural_successor"
			testing: "covers/{STI_COMPLEX_SET}.natural_successor"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.disjunction.
			-- Test {STI_NUMERIC_SET}.disjunction.
			-- Test {STS_COMPLEX_SET}.disjunction.
			-- Test {STI_COMPLEX_SET}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_NUMERIC_SET}.disjunction"
			testing: "covers/{STI_NUMERIC_SET}.disjunction"
			testing: "covers/{STS_COMPLEX_SET}.disjunction"
			testing: "covers/{STI_COMPLEX_SET}.disjunction"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.conjunction.
			-- Test {STI_NUMERIC_SET}.conjunction.
			-- Test {STS_COMPLEX_SET}.conjunction.
			-- Test {STI_COMPLEX_SET}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_NUMERIC_SET}.conjunction"
			testing: "covers/{STI_NUMERIC_SET}.conjunction"
			testing: "covers/{STS_COMPLEX_SET}.conjunction"
			testing: "covers/{STI_COMPLEX_SET}.conjunction"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_COMPLEX_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_COMPLEX_SET}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_COMPLEX_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_COMPLEX_SET}.sets_plus_same_sets_with_element"
		do
			Precursor {NUMERIC_SET_TESTS}
		end

feature {NONE} -- Factory (element to be tested)

	set_to_be_tested: like some_direct_complex_set
			-- <Precursor>
		do
			Result := some_direct_complex_set
		end

feature {NONE} -- Conversion

	set_from_sa (sa: STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- <Precursor>
		do
			Result := sa
		end

	set_from_saa (saa: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- <Precursor>
		do
			Result := saa
		end

	set_from_sti_sa (sa: STI_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- `sa` converted to a set like `set_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
		end

	set_from_numeric_set (ns: STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- `ns` converted to a set like `set_to_be_tested'
		do
			Result := ns
		ensure
			same_set: Result ≍ ns
		end

	set_from_sti_numeric_set (ns: STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- `ns` converted to a set like `set_to_be_tested'
		do
			Result := ns
		ensure
			same_set: Result ≍ ns
		end

	set_from_complex_set (sa: STS_COMPLEX_SET): like set_to_be_tested
			-- `sa` converted to a set like `set_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
		end

	set_from_universe (u: STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: Result ≍ u
		end

	set_from_sti_universe (u: STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: Result ≍ u
		end

	set_from_complex_universe (u: STS_COMPLEX_UNIVERSE): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: Result ≍ u
		end

	set_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]): like set_to_be_tested
			-- `saa' converted to a set like `set_to_be_tested'
		do
			Result := saa
		ensure
			same_set: Result ≍ saa
		end

	set_from_transformable_complexes_to_numeric_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: Result ≍ scc
		end

	set_from_sti_transformable_complexes_to_numeric_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: Result ≍ scc
		end

	set_from_transformable_complexes_to_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: Result ≍ scc
		end

	set_from_sti_transformable_complexes_to_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: Result ≍ scc
		end

	set_from_transformable_complexes_to_expanded_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: Result ≍ scc
		end

	set_from_sti_transformable_complexes_to_expanded_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: Result ≍ scc
		end

	set_from_transformable_complexes_to_numeric_reals (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like set_to_be_tested
			-- `scr' converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: Result ≍ scr
		end

	set_from_sti_transformable_complexes_to_numeric_reals (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like set_to_be_tested
			-- `scr' converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: Result ≍ scr
		end

	set_from_transformable_complexes_to_expanded_reals (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `scr' converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: Result ≍ scr
		end

	set_from_sti_transformable_complexes_to_expanded_reals (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `scr' converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: Result ≍ scr
		end

	set_from_sc (sc: STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_to_be_tested
			-- `sc` converted to a set like `set_to_be_tested'
		do
			Result := sc
		ensure
			same_set: sc ≍ Result
		end

	set_from_sti_sc (sc: STI_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_to_be_tested
			-- `sc` converted to a set like `set_to_be_tested'
		do
			Result := sc
		ensure
			same_set: sc ≍ Result
		end

	set_from_scr (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scr` converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: scr ≍ Result
		end

	set_from_sti_scr (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scr` converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: scr ≍ Result
		end

	set_from_numeric_complexes (nc: STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_to_be_tested
			-- `nc` converted to a set like `set_to_be_tested'
		do
			Result := nc
		ensure
			same_set: nc ≍ Result
		end

	set_from_sti_numeric_complexes (nc: STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_to_be_tested
			-- `nc` converted to a set like `set_to_be_tested'
		do
			Result := nc
		ensure
			same_set: nc ≍ Result
		end

	set_from_numeric_universe (u: STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: u ≍ Result
		end

	set_from_sti_numeric_universe (u: STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: u ≍ Result
		end

	set_from_transformable_numeric_complexes_to_numeric_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_sti_transformable_numeric_complexes_to_numeric_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_transformable_numeric_complexes_to_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_sti_transformable_numeric_complexes_to_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_transformable_numeric_complexes_to_expanded_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_sti_transformable_numeric_complexes_to_expanded_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_transformable_numeric_complexes_to_reals (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_sti_transformable_numeric_complexes_to_reals (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY]
		): like set_to_be_tested
			-- `scc' converted to a set like `set_to_be_tested'
		do
			Result := scc
		ensure
			same_set: scc ≍ Result
		end

	set_from_transformable_numeric_complexes_to_expanded_reals (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `scr' converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: scr ≍ Result
		end

	set_from_sti_transformable_numeric_complexes_to_expanded_reals (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `scr' converted to a set like `set_to_be_tested'
		do
			Result := scr
		ensure
			same_set: scr ≍ Result
		end

	complex_set_to_sti_set_of_pairs: STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
			-- `set_to_be_tested' converted into an effective set of ordered pairs of real numbers
		do
			Result := set_to_be_tested
		end

	complex_set_to_set_of_pairs: STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY]
			-- `set_to_be_tested' converted into a set of ordered pairs of real numbers
		do
			Result := set_to_be_tested
		end

	complex_set_to_sti_set_of_numeric_pairs: STI_SET_OF_ORDERED_PAIRS [
		STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]
		]
			-- `set_to_be_tested' converted into an effective set of ordered pairs of real numbers compared by {STS_NUMERIC_EQUALITY}
		do
			Result := set_to_be_tested
		end

	complex_set_to_set_of_numeric_pairs: STS_SET_OF_ORDERED_PAIRS [
		STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]
		]
			-- `set_to_be_tested' converted into a set of ordered pairs of real numbers
		do
			Result := set_to_be_tested
		end

feature {NONE} -- Predicate

--	set_has_complex_number (
--		s: STS_SET_OF_ORDERED_PAIRS [
--				STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]
--				]
--		z: STI_COMPLEX_NUMBER
--		): BOOLEAN
--			-- Does `s' have the complex number `z'?
--		do
--			Result := s ∋ z
--		ensure
--			class
--			definition: Result = s ∋ z
--		end

feature {NONE} -- Implementation

	max_asserted_tuples: NATURAL
			-- <Precursor>
		once
				check
--					good_divisor: (# C).divisible (Max_count) -- Max_count /= 0 -- TODO: Segmentation violation:
					good_divisor: Max_count /= 0
				end
			Result := # C // Max_count
		ensure then
			class
		end

	max_asserted_subsets: NATURAL = 1024 -- 2 ^ 10
			-- <Precursor>

	max_subsets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

	max_tuples: NATURAL = 46_656 -- 6 ^ 6
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
