﻿note
	description: "Test suite for {STI_COMPLEX_UNIVERSE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	COMPLEX_UNIVERSE_TESTS

inherit
	UNIVERSE_TESTS [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		rename
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_integer as some_native_integer,
			some_object_a as some_complex
		undefine
			on_prepare,
			some_native_integer,
			some_element,
			some_equality,
			some_pair,
			some_set,
			some_set_a,
			same_set_a,
			some_n_tuple,
			same_n_tuple_a
		redefine
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_is_singleton,
			test_out,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_intersects,
			test_is_disjoint,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			set_from_sa,
			set_from_saa
		end

	COMPLEX_SET_TESTS
		rename
			set_to_be_tested as universe_to_be_tested
		redefine
			Properties,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_make_from_numeric_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_zero,
			test_c,
			test_complex_universe,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_numeric_batch_extended,
			test_is_singleton,
			test_out,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_intersects,
			test_is_disjoint,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_without_zero,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_complement,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_as_set_of_pairs,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_numeric_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_set_has_complex_number,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			universe_to_be_tested,
			set_from_sa,
			set_from_saa,
			set_from_sti_sa,
			set_from_numeric_set,
			set_from_sti_numeric_set,
			set_from_complex_set,
			set_from_universe,
			set_from_sti_universe,
			set_from_complex_universe,
			set_from_sti_saa,
			set_from_transformable_complexes_to_numeric_complexes,
			set_from_sti_transformable_complexes_to_numeric_complexes,
			set_from_transformable_complexes_to_complexes,
			set_from_sti_transformable_complexes_to_complexes,
			set_from_transformable_complexes_to_expanded_complexes,
			set_from_sti_transformable_complexes_to_expanded_complexes,
			set_from_transformable_complexes_to_numeric_reals,
			set_from_sti_transformable_complexes_to_numeric_reals,
			set_from_transformable_complexes_to_expanded_reals,
			set_from_sti_transformable_complexes_to_expanded_reals,
			set_from_sc,
			set_from_sti_sc,
			set_from_scr,
			set_from_sti_scr,
			set_from_numeric_complexes,
			set_from_sti_numeric_complexes,
			set_from_numeric_universe,
			set_from_sti_numeric_universe,
			set_from_transformable_numeric_complexes_to_numeric_complexes,
			set_from_sti_transformable_numeric_complexes_to_numeric_complexes,
			set_from_transformable_numeric_complexes_to_complexes,
			set_from_sti_transformable_numeric_complexes_to_complexes,
			set_from_transformable_numeric_complexes_to_expanded_complexes,
			set_from_sti_transformable_numeric_complexes_to_expanded_complexes,
			set_from_transformable_numeric_complexes_to_reals,
			set_from_sti_transformable_numeric_complexes_to_reals,
			set_from_transformable_numeric_complexes_to_expanded_reals,
			set_from_sti_transformable_numeric_complexes_to_expanded_reals
		end

feature -- Access

	properties: COMPLEX_UNIVERSE_PROPERTIES
			-- Object that checks the set-theory properties of {STI_COMPLEX_UNIVERSE}
--		once
--			create Result
--		end

feature -- Test routines (Initialization)

	test_default_create
			-- Test {STI_COMPLEX_UNIVERSE}.default_create.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.default_create"
		local
			chk_tests: BOOLEAN
			l_c: like Universe_to_be_tested
		do
			chk_tests := {ISE_RUNTIME}.check_assert (False) -- This creation is too expensive.
				create l_c
			chk_tests := {ISE_RUNTIME}.check_assert (chk_tests)
			assert ("ℂ is well formed.", l_c ∋ Zero) -- This checks the invariant of l_c.
		end

	test_make_empty
			-- Test {STI_UNIVERSE}.make_empty.
			-- Test {STI_COMPLEX_UNIVERSE}.make_empty.
		note
			testing: "covers/{STI_UNIVERSE}.make_empty"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.make_empty"
		local
			make_empty_is_broken: BOOLEAN
			exp_c: like Exposed_universe_to_be_tested
			chk_ops: BOOLEAN
		do
			if not make_empty_is_broken then
				chk_ops := {ISE_RUNTIME}.check_assert (False)
					create exp_c -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
				exp_c.make_empty
			end
		rescue
			if {EXCEPTIONS}.tag_name ~ "is_empty" then
				make_empty_is_broken := True
				retry
			end
		end

	test_make_singleton
			-- Test {STI_UNIVERSE}.make_singleton.
			-- Test {STI_COMPLEX_UNIVERSE}.make_singleton.
		note
			testing: "covers/{STI_UNIVERSE}.make_singleton"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.make_singleton"
		local
			make_singleton_is_broken: BOOLEAN
			exp_c: like Exposed_universe_to_be_tested
			chk_ops: BOOLEAN
		do
			if not make_singleton_is_broken then
				chk_ops := {ISE_RUNTIME}.check_assert (False)
					create exp_c -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
				exp_c.make_singleton (some_real)
			end
		rescue
			if {EXCEPTIONS}.recipient_name ~ "make_singleton" then
				make_singleton_is_broken := True
				retry
			end
		end

	test_make_extended
			-- Test {STI_COMPLEX_UNIVERSE}.make_extended.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.make_extended"
		local
			exp_c: like Exposed_universe_to_be_tested
			make_extended_got_rescued: PREDICATE [like Exposed_universe_to_be_tested, like some_complex, like some_complex, like some_set_a, like some_set_a]
			z0, z: like some_complex
			s0, s: like some_set_a
			chk_ops, chk_tests: BOOLEAN
			n: like some_set.cardinality
		do
			make_extended_got_rescued := agent
				(ia_exp_c: like Exposed_universe_to_be_tested; ia_z0, ia_z: STS_COMPLEX_NUMBER; ia_s0, ia_s: like some_set_a): BOOLEAN
				require
					s0_has_no_z0: ia_s0 ∌ ia_z0
					s_has_no_z: ia_s ∌ ia_z
					same_any: ia_z ≍ ia_exp_c.Any
					almost_the_universe: # ia_s = # C - 1
				local
					z0_s0_failed, z_s0_failed: BOOLEAN
				do
					if not z0_s0_failed then
						ia_exp_c.make_extended (ia_z0, ia_s0)
					elseif not z_s0_failed and ia_s0 ∌ ia_z then
						ia_exp_c.make_extended (ia_z, ia_s0)
					elseif ia_s ∌ ia_z0 then
						ia_exp_c.make_extended (ia_z0, ia_s)
					else
						ia_exp_c.make_extended (ia_z, ia_s)
					end
					Result := True
				ensure
					z0_s0: ia_z0 ≍ ia_exp_c.Any and # ia_s0 = # C - 1 implies ia_exp_c ≍ ia_s0.extended (ia_z0)
					z_s0: ia_z0 ≭ ia_exp_c.Any and # ia_s0 = # C - 1 and ia_s0 ∌ ia_z implies ia_exp_c ≍ ia_s0.extended (ia_z)
					z0_s: ia_z0 ≍ ia_exp_c.Any and # ia_s0 /= # C - 1 implies ia_exp_c ≍ ia_s.extended (ia_z0)
					z_s: ia_z0 ≭ ia_exp_c.Any or # ia_s0 /= # C - 1 implies ia_exp_c ≍ ia_s.extended (ia_z)
				rescue
					if not z0_s0_failed then
						z0_s0_failed := True
						retry
					elseif not z_s0_failed then
						z_s0_failed := True
						retry
					end
				end

			z := C.Any
			from
				z0 := some_complex
			until
				z0 ≭ z
			loop
				z0 := some_complex
			end
			s0 := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_c -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				s0 := s0 / z0
				s := same_set_a (exp_c) / z
				n := # s0 ∨ # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("s0_has_no_z0", s0 ∌ z0)
				assert ("s_has_no_z", s ∌ z)
				assert ("same_any", z ≍ exp_c.Any)
				assert ("almost_the_universe", # s = # C - 1)
				assert ("z0_s0_fail", make_extended_got_rescued (exp_c, z0, z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("consistent exp_c", C ≍ exp_c)
			assert ("z0_s0_fail ok", Properties.make_extended_ok (z0, s0))
			assert ("z_s0 try ok", Properties.make_extended_ok (z, s0))
			assert ("z0_s try ok", Properties.make_extended_ok (z0, s))
			assert ("z_s ok", Properties.make_extended_ok (z, s))

			z0 := some_complex
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					s0 := some_set_a
				until
					exp_c ≭ s0
				loop
					s0 := some_set_a
				end
				s0 := s0 / z0
				s := same_set_a (exp_c) / z
				n := # s0 ∨ # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("s0_has_no_z0", s0 ∌ z0)
				assert ("s_has_no_z", s ∌ z)
				assert ("same_any", z ≍ exp_c.Any)
				assert ("almost_the_universe", # s = # C - 1)
				assert ("z0_s0_fail", make_extended_got_rescued (exp_c, z0, z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("consistent exp_c", C ≍ exp_c)
			assert ("z0_s0_fail ok", Properties.make_extended_ok (z0, s0))
			assert ("z_s0 try ok", Properties.make_extended_ok (z, s0))
			assert ("z0_s try ok", Properties.make_extended_ok (z0, s))
			assert ("z_s ok", Properties.make_extended_ok (z, s))

			z0 := some_complex
			s0 := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s0 := s0 / z0
				s := same_set_a (exp_c) / z
				n := # s0 ∨ # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("s0_has_no_z0", s0 ∌ z0)
				assert ("s_has_no_z", s ∌ z)
				assert ("same_any", z ≍ exp_c.Any)
				assert ("almost_the_universe", # s = # C - 1)
				assert ("make_extended", make_extended_got_rescued (exp_c, z0, z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("consistent exp_c", C ≍ exp_c)
			assert ("z0_s0 try ok", Properties.make_extended_ok (z0, s0))
			assert ("z_s0 try ok", Properties.make_extended_ok (z, s0))
			assert ("z0_s try ok", Properties.make_extended_ok (z0, s))
			assert ("z_s ok", Properties.make_extended_ok (z, s))
		end

	test_make_from_set
			-- Test {STI_COMPLEX_UNIVERSE}.make_from_set.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.make_from_set"
		local
			exp_c: like Exposed_universe_to_be_tested
			make_from_set_got_rescued: PREDICATE [like Exposed_universe_to_be_tested, like some_set_a, like some_set_a]
			s0, s: like some_set_a
			chk_ops, chk_tests: BOOLEAN
			n: like some_set.cardinality
		do
			make_from_set_got_rescued := agent (ia_exp_c: like Exposed_universe_to_be_tested; ia_s0, ia_s: like some_set_a): BOOLEAN
				require
					the_universe: # ia_s = # ia_exp_c
				local
					s0_failed: BOOLEAN
				do
					if not s0_failed then
						ia_exp_c.make_from_set (ia_s0)
					else
						ia_exp_c.make_from_set (ia_s)
					end
					Result := True
				ensure
					s0: # ia_s0 = # ia_exp_c implies ia_exp_c ≍ ia_s0
					s: # ia_s0 /= # ia_exp_c implies ia_exp_c ≍ ia_s
				rescue
					if not s0_failed then
						s0_failed := True
						retry
					end
					print (ia_exp_c) print (", ")
					print (ia_s0) print (", ")
					print (ia_s) print ('%N')
				end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_c -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				s0 := some_set_a / some_real
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			s := same_set_a (exp_c)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_c)
				assert ("s0 is not the universe", make_from_set_got_rescued (exp_c, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_c ≍ C)

			s0 := some_set_a
			s := same_set_a (exp_c)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_c)
				assert ("try s0", make_from_set_got_rescued (exp_c, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_c ≍ C)
		end

	test_make_from_numeric_set
			-- Test {STI_COMPLEX_UNIVERSE}.make_from_numeric_set.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.make_from_numeric_set"
		local
			exp_c: like Exposed_universe_to_be_tested
			make_from_numeric_set_got_rescued: PREDICATE [like Exposed_universe_to_be_tested, like some_complex_numbers, like some_complex_numbers]
			s0, s: like some_complex_numbers
			chk_ops, chk_tests: BOOLEAN
			n: like some_set.cardinality
		do
			make_from_numeric_set_got_rescued := agent (ia_exp_c: like Exposed_universe_to_be_tested; ia_s0, ia_s: like some_complex_numbers): BOOLEAN
				require
					the_universe: # ia_s = # ia_exp_c
				local
					s0_failed: BOOLEAN
				do
					if not s0_failed then
						ia_exp_c.make_from_numeric_set (ia_s0)
					else
						ia_exp_c.make_from_numeric_set (ia_s)
					end
					Result := True
				ensure
					s0: # ia_s0 = # ia_exp_c implies ia_s0 ≍ ia_exp_c
					s: # ia_s0 /= # ia_exp_c implies ia_s ≍ ia_exp_c
				rescue
					if not s0_failed then
						s0_failed := True
						retry
					end
				end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_c -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				s0 := some_complex_numbers / some_complex
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			s := same_complex_numbers (exp_c)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_c)
				assert ("s0 is not the universe", make_from_numeric_set_got_rescued (exp_c, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_c ≍ C)

			s0 := some_complex_numbers
			s := same_complex_numbers (exp_c)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_c)
				assert ("try s0", make_from_numeric_set_got_rescued (exp_c, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_c ≍ C)
		end

	test_make_from_universe
			-- Test {STI_COMPLEX_UNIVERSE}.make_from_universe.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.make_from_universe"
		local
			u: like some_complex_universe
		do
			u := some_complex_universe
			assert ("make_from_universe", attached (create {like universe_to_be_tested}.make_from_universe (u)))
			assert ("universe_from_numeric_universe", attached universe_from_numeric_universe (u))
			assert ("universe_from_sti_numeric_universe", attached universe_from_sti_numeric_universe (u))
			assert ("universe_from_universe", attached universe_from_universe (u))
			assert ("universe_from_sti_universe", attached universe_from_sti_universe (u))
			assert ("universe_from_complex_universe", attached universe_from_complex_universe (u))
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_empty.
		note
			testing: "covers/{STI_UNIVERSE}.is_empty"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_empty"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_any
			-- Test {STI_COMPLEX_UNIVERSE}.any.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.any"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.others.
			-- Test {STI_COMPLEX_SET}.others.
			-- Test {STI_COMPLEX_UNIVERSE}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_NUMERIC_SET}.others"
			testing: "covers/{STI_COMPLEX_SET}.others"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.others"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_eq
			-- Test {STI_COMPLEX_SET}.eq.
			-- Test {STI_COMPLEX_UNIVERSE}.eq.
		note
			testing: "covers/{STI_COMPLEX_SET}.eq"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.eq"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_NUMERIC_SET}.element_is_in.
			-- Test {STI_NUMERIC_SET}.element_is_in.
			-- Test {STS_COMPLEX_SET}.element_is_in.
			-- Test {STI_COMPLEX_SET}.element_is_in.
			-- Test {STS_COMPLEX_UNIVERSE}.element_is_in.
			-- Test {STI_COMPLEX_UNIVERSE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_in"
			testing: "covers/{STS_COMPLEX_SET}.element_is_in"
			testing: "covers/{STI_COMPLEX_SET}.element_is_in"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.element_is_in"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.element_is_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_NUMERIC_SET}.element_is_not_in.
			-- Test {STI_NUMERIC_SET}.element_is_not_in.
			-- Test {STS_COMPLEX_SET}.element_is_not_in.
			-- Test {STI_COMPLEX_SET}.element_is_not_in.
			-- Test {STS_COMPLEX_UNIVERSE}.element_is_not_in.
			-- Test {STI_COMPLEX_UNIVERSE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STS_COMPLEX_SET}.element_is_not_in"
			testing: "covers/{STI_COMPLEX_SET}.element_is_not_in"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.element_is_not_in"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.element_is_not_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_in.
			-- Test {STI_NUMERIC_SET}.is_in.
			-- Test {STS_COMPLEX_SET}.is_in.
			-- Test {STI_COMPLEX_SET}.is_in.
			-- Test {STS_UNIVERSE}.is_in.
			-- Test {STI_UNIVERSE}.is_in.
			-- Test {STS_COMPLEX_UNIVERSE}.is_in.
			-- Test {STI_COMPLEX_UNIVERSE}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_NUMERIC_SET}.is_in"
			testing: "covers/{STI_NUMERIC_SET}.is_in"
			testing: "covers/{STS_COMPLEX_SET}.is_in"
			testing: "covers/{STI_COMPLEX_SET}.is_in"
			testing: "covers/{STS_UNIVERSE}.is_in"
			testing: "covers/{STI_UNIVERSE}.is_in"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_in"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_in.
			-- Test {STI_NUMERIC_SET}.is_not_in.
			-- Test {STS_COMPLEX_SET}.is_not_in.
			-- Test {STI_COMPLEX_SET}.is_not_in.
			-- Test {STS_UNIVERSE}.is_not_in.
			-- Test {STI_UNIVERSE}.is_not_in.
			-- Test {STS_COMPLEX_UNIVERSE}.is_not_in.
			-- Test {STI_COMPLEX_UNIVERSE}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.is_not_in"
			testing: "covers/{STS_COMPLEX_SET}.is_not_in"
			testing: "covers/{STI_COMPLEX_SET}.is_not_in"
			testing: "covers/{STS_UNIVERSE}.is_not_in"
			testing: "covers/{STI_UNIVERSE}.is_not_in"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_not_in"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_not_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_has
			-- Test {STS_UNIVERSE}.has.
			-- Test {STI_UNIVERSE}.has.
			-- Test {STS_COMPLEX_UNIVERSE}.has.
			-- Test {STI_COMPLEX_UNIVERSE}.has.
		note
			testing: "covers/{STS_UNIVERSE}.has"
			testing: "covers/{STI_UNIVERSE}.has"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.has"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.has"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_have.
			-- Test {STI_NUMERIC_SET}.does_not_have.
			-- Test {STS_COMPLEX_SET}.does_not_have.
			-- Test {STI_COMPLEX_SET}.does_not_have.
			-- Test {STS_UNIVERSE}.does_not_have.
			-- Test {STI_UNIVERSE}.does_not_have.
			-- Test {STS_COMPLEX_UNIVERSE}.does_not_have.
			-- Test {STI_COMPLEX_UNIVERSE}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_NUMERIC_SET}.does_not_have"
			testing: "covers/{STI_NUMERIC_SET}.does_not_have"
			testing: "covers/{STS_COMPLEX_SET}.does_not_have"
			testing: "covers/{STI_COMPLEX_SET}.does_not_have"
			testing: "covers/{STS_UNIVERSE}.does_not_have"
			testing: "covers/{STI_UNIVERSE}.does_not_have"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.does_not_have"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.does_not_have"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Access)

	test_zero
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.Zero.
		note
			testing: "covers/{STI_COMPLEX_SET}.zero"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.zero"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

	test_c
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.c.
		note
			testing: "covers/{STI_COMPLEX_SET}.c"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.c"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

	test_complex_universe
			-- <Precursor>
			-- Test {STI_COMPLEX_SET}.complex_universe.
		note
			testing: "covers/{STI_COMPLEX_SET}.complex_universe"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.complex_universe"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.with.
		note
			testing: "covers/{STI_UNIVERSE}.with"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.with"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_without
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.without.
			-- Test {STI_COMPLEX_SET}.without.
			-- Test {STI_COMPLEX_UNIVERSE}.without.
		note
			testing: "covers/{STI_SET}.without"
			testing: "covers/{STI_UNIVERSE}.without"
			testing: "covers/{STI_NUMERIC_SET}.without"
			testing: "covers/{STI_COMPLEX_SET}.without"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.without"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.extended.
		note
			testing: "covers/{STI_UNIVERSE}.extended"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.extended"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.batch_extended.
			-- Test {STI_COMPLEX_SET}.batch_extended.
			-- Test {STI_COMPLEX_UNIVERSE}.batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_NUMERIC_SET}.batch_extended"
			testing: "covers/{STI_COMPLEX_SET}.batch_extended"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.batch_extended"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_numeric_batch_extended
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.numeric_batch_extended.
		note
			testing: "covers/{STI_COMPLEX_SET}.numeric_batch_extended"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.numeric_batch_extended"
		local
			s0: like some_complex_numbers
			s: like universe_to_be_tested
		do
			s0 := some_complex_numbers.o
			s := universe_to_be_tested

			assert ("s0_is_disjoint_s", s0.is_disjoint (s)) -- s0 = {}
			assert ("s_numeric_batch_extended_s0", attached s.numeric_batch_extended (s0))
			assert ("s_numeric_batch_extended_s0_ok", Properties.numeric_batch_extended_ok (s0, s))

			s0 := some_complex_numbers
			s := universe_to_be_tested
			assert ("numeric_batch_extended", s0.is_disjoint (s) implies attached s.numeric_batch_extended (s0))
			assert ("numeric_batch_extended_ok", Properties.numeric_batch_extended_ok (s0, s))
		end

feature -- Test routines (Output)

	test_out
			-- Test {STI_COMPLEX_UNIVERSE}.out.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.out"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- Test {STI_COMPLEX_UNIVERSE}.is_singleton.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_singleton"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- Test {STI_COMPLEX_UNIVERSE}.cardinality.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.cardinality"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_instance_free_cardinality
			-- Test {STI_COMPLEX_UNIVERSE}.instance_free_cardinality.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.instance_free_cardinality"
		do
			assert ("instance_free_cardinality", attached (# Universe_to_be_tested))
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.equals.
		note
			testing: "covers/{STI_UNIVERSE}.equals"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.equals"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.unequals.
			-- Test {STI_NUMERIC_SET}.unequals.
			-- Test {STS_COMPLEX_SET}.unequals.
			-- Test {STI_COMPLEX_SET}.unequals.
			-- Test {STS_COMPLEX_UNIVERSE}.unequals.
			-- Test {STI_COMPLEX_UNIVERSE}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_NUMERIC_SET}.unequals"
			testing: "covers/{STI_NUMERIC_SET}.unequals"
			testing: "covers/{STS_COMPLEX_SET}.unequals"
			testing: "covers/{STI_COMPLEX_SET}.unequals"
			testing: "covers/{STS_UNIVERSE}.unequals"
			testing: "covers/{STI_UNIVERSE}.unequals"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.unequals"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.unequals"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_subset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_subset.
			-- Test {STI_NUMERIC_SET}.is_not_subset.
			-- Test {STS_COMPLEX_SET}.is_not_subset.
			-- Test {STI_COMPLEX_SET}.is_not_subset.
			-- Test {STS_COMPLEX_UNIVERSE}.is_not_subset.
			-- Test {STI_COMPLEX_UNIVERSE}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_subset"
			testing: "covers/{STS_UNIVERSE}.is_not_subset"
			testing: "covers/{STI_UNIVERSE}.is_not_subset"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_not_subset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_not_subset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_superset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_superset.
			-- Test {STI_NUMERIC_SET}.is_not_superset.
			-- Test {STS_COMPLEX_SET}.is_not_superset.
			-- Test {STI_COMPLEX_SET}.is_not_superset.
			-- Test {STS_COMPLEX_UNIVERSE}.is_not_superset.
			-- Test {STI_COMPLEX_UNIVERSE}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_superset"
			testing: "covers/{STS_UNIVERSE}.is_not_superset"
			testing: "covers/{STI_UNIVERSE}.is_not_superset"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_not_superset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_not_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_comparable.
		note
			testing: "covers/{STI_UNIVERSE}.is_comparable"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_comparable"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_not_comparable.
		note
			testing: "covers/{STI_UNIVERSE}.is_not_comparable"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_not_comparable"
		do
			Precursor {UNIVERSE_TESTS}
			assert ("csp_is_not_comparable_ok", properties.csp_is_not_comparable_ok (Universe_to_be_tested, some_set_a))
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_strict_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_strict_subset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_strict_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STS_COMPLEX_SET}.is_not_strict_subset.
			-- Test {STI_COMPLEX_SET}.is_not_strict_subset.
			-- Test {STS_COMPLEX_UNIVERSE}.is_not_strict_subset.
			-- Test {STI_COMPLEX_UNIVERSE}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_strict_subset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_strict_subset"
			testing: "covers/{STS_UNIVERSE}.is_not_strict_subset"
			testing: "covers/{STI_UNIVERSE}.is_not_strict_subset"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_not_strict_subset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_not_strict_subset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_strict_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_strict_superset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_strict_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STS_COMPLEX_SET}.is_not_strict_superset.
			-- Test {STI_COMPLEX_SET}.is_not_strict_superset.
			-- Test {STS_COMPLEX_UNIVERSE}.is_not_strict_superset.
			-- Test {STI_COMPLEX_UNIVERSE}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STS_COMPLEX_SET}.is_not_strict_superset"
			testing: "covers/{STI_COMPLEX_SET}.is_not_strict_superset"
			testing: "covers/{STS_UNIVERSE}.is_not_strict_superset"
			testing: "covers/{STI_UNIVERSE}.is_not_strict_superset"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_not_strict_superset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_not_strict_superset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_trivial_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_trivial_subset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_trivial_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_trivial_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_trivial_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_trivial_superset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_trivial_superset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_proper_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_proper_subset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_proper_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_proper_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_proper_superset"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_proper_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.is_disjoint.
		note
			testing: "covers/{STI_UNIVERSE}.is_disjoint"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_disjoint"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {COMPLEX_SET_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.intersects.
			-- Test {STI_NUMERIC_SET}.intersects.
			-- Test {STS_COMPLEX_SET}.intersects.
			-- Test {STI_COMPLEX_SET}.intersects.
			-- Test {STS_COMPLEX_UNIVERSE}.intersects.
			-- Test {STI_COMPLEX_UNIVERSE}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_NUMERIC_SET}.intersects"
			testing: "covers/{STI_NUMERIC_SET}.intersects"
			testing: "covers/{STS_COMPLEX_SET}.intersects"
			testing: "covers/{STI_COMPLEX_SET}.intersects"
			testing: "covers/{STS_UNIVERSE}.intersects"
			testing: "covers/{STI_UNIVERSE}.intersects"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.intersects"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.intersects"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_partitioned.
			-- Test {STI_NUMERIC_SET}.is_partitioned.
			-- Test {STS_COMPLEX_SET}.is_partitioned.
			-- Test {STI_COMPLEX_SET}.is_partitioned.
			-- Test {STS_UNIVERSE}.is_partitioned.
			-- Test {STI_UNIVERSE}.is_partitioned.
			-- Test {STS_COMPLEX_UNIVERSE}.is_partitioned.
			-- Test {STI_COMPLEX_UNIVERSE}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STI_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STS_COMPLEX_SET}.is_partitioned"
			testing: "covers/{STI_COMPLEX_SET}.is_partitioned"
			testing: "covers/{STS_UNIVERSE}.is_partitioned"
			testing: "covers/{STI_UNIVERSE}.is_partitioned"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.is_partitioned"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.is_partitioned"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists.
			-- Test {STI_COMPLEX_SET}.exists.
			-- Test {STI_COMPLEX_UNIVERSE}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_NUMERIC_SET}.exists"
			testing: "covers/{STI_COMPLEX_SET}.exists"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.exists"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist.
			-- Test {STI_NUMERIC_SET}.does_not_exist.
			-- Test {STS_COMPLEX_SET}.does_not_exist.
			-- Test {STI_COMPLEX_SET}.does_not_exist.
			-- Test {STS_UNIVERSE}.does_not_exist.
			-- Test {STI_UNIVERSE}.does_not_exist.
			-- Test {STS_COMPLEX_UNIVERSE}.does_not_exist.
			-- Test {STI_COMPLEX_UNIVERSE}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STS_COMPLEX_SET}.does_not_exist"
			testing: "covers/{STI_COMPLEX_SET}.does_not_exist"
			testing: "covers/{STS_UNIVERSE}.does_not_exist"
			testing: "covers/{STI_UNIVERSE}.does_not_exist"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.does_not_exist"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.does_not_exist"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_unique.
			-- Test {STI_COMPLEX_SET}.exists_unique.
			-- Test {STI_COMPLEX_UNIVERSE}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_NUMERIC_SET}.exists_unique"
			testing: "covers/{STI_COMPLEX_SET}.exists_unique"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.exists_unique"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_pair.
			-- Test {STI_COMPLEX_SET}.exists_pair.
			-- Test {STI_COMPLEX_UNIVERSE}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_pair"
			testing: "covers/{STI_COMPLEX_SET}.exists_pair"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.exists_pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STI_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STS_COMPLEX_SET}.does_not_exist_pair.
			-- Test {STI_COMPLEX_SET}.does_not_exist_pair.
			-- Test {STS_UNIVERSE}.does_not_exist_pair.
			-- Test {STI_UNIVERSE}.does_not_exist_pair.
			-- Test {STS_COMPLEX_UNIVERSE}.does_not_exist_pair.
			-- Test {STI_COMPLEX_UNIVERSE}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STS_COMPLEX_SET}.does_not_exist_pair"
			testing: "covers/{STI_COMPLEX_SET}.does_not_exist_pair"
			testing: "covers/{STS_UNIVERSE}.does_not_exist_pair"
			testing: "covers/{STI_UNIVERSE}.does_not_exist_pair"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.does_not_exist_pair"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.does_not_exist_pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_distinct_pair.
			-- Test {STI_COMPLEX_SET}.exists_distinct_pair.
			-- Test {STI_COMPLEX_UNIVERSE}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_distinct_pair"
			testing: "covers/{STI_COMPLEX_SET}.exists_distinct_pair"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.exists_distinct_pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all.
			-- Test {STI_COMPLEX_SET}.for_all.
			-- Test {STI_COMPLEX_UNIVERSE}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_NUMERIC_SET}.for_all"
			testing: "covers/{STI_COMPLEX_SET}.for_all"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.for_all"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_pairs.
			-- Test {STI_COMPLEX_SET}.for_all_pairs.
			-- Test {STI_COMPLEX_UNIVERSE}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_pairs"
			testing: "covers/{STI_COMPLEX_SET}.for_all_pairs"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.for_all_pairs"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_distinct_pairs.
			-- Test {STI_COMPLEX_SET}.for_all_distinct_pairs.
			-- Test {STI_COMPLEX_UNIVERSE}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_COMPLEX_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.for_all_distinct_pairs"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Restriction)

	test_without_zero
			-- Test {STI_COMPLEX_UNIVERSE}.without_zero.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.without_zero"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- Test {STI_COMPLEX_UNIVERSE}.subsets.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.subsets"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_powerset
			-- Test {STI_COMPLEX_UNIVERSE}.powerset.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.powerset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_trivial_subsets
			-- Test {STI_COMPLEX_UNIVERSE}.trivial_subsets.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.trivial_subsets"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_proper_subsets
			-- Test {STI_COMPLEX_UNIVERSE}.proper_subsets.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.proper_subsets"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.filtered.
			-- Test {STI_COMPLEX_SET}.filtered.
			-- Test {STI_COMPLEX_UNIVERSE}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_NUMERIC_SET}.filtered"
			testing: "covers/{STI_COMPLEX_SET}.filtered"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.filtered"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.complemented.
		note
			testing: "covers/{STI_UNIVERSE}.complemented"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.complemented"
		do
			Precursor {COMPLEX_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_complement
			-- Test {STI_COMPLEX_UNIVERSE}.complement.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.complement"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

	test_united
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.united.
		note
			testing: "covers/{STI_UNIVERSE}.united"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.united"
		do
			Precursor {COMPLEX_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.intersected.
		note
			testing: "covers/{STI_UNIVERSE}.intersected"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.intersected"
		do
			Precursor {COMPLEX_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_subtracted
			-- Test {STI_NUMERIC_SET}.subtracted.
			-- Test {STI_COMPLEX_SET}.subtracted.
			-- Test {STI_COMPLEX_UNIVERSE}.subtracted.
		note
			testing: "covers/{STI_NUMERIC_SET}.subtracted"
			testing: "covers/{STI_COMPLEX_SET}.subtracted"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.subtracted"
		do
			Precursor {COMPLEX_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_UNIVERSE}.subtracted_symmetricaly"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.subtracted_symmetricaly"
		do
			Precursor {COMPLEX_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.crossed.
			-- Test {STI_NUMERIC_SET}.crossed.
			-- Test {STS_COMPLEX_SET}.crossed.
			-- Test {STI_COMPLEX_SET}.crossed.
			-- Test {STS_UNIVERSE}.crossed.
			-- Test {STI_UNIVERSE}.crossed.
			-- Test {STS_COMPLEX_UNIVERSE}.crossed.
			-- Test {STI_COMPLEX_UNIVERSE}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_NUMERIC_SET}.crossed"
			testing: "covers/{STI_NUMERIC_SET}.crossed"
			testing: "covers/{STS_COMPLEX_SET}.crossed"
			testing: "covers/{STI_COMPLEX_SET}.crossed"
			testing: "covers/{STS_UNIVERSE}.crossed"
			testing: "covers/{STI_UNIVERSE}.crossed"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.crossed"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.crossed"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_squared
			-- Test {STI_COMPLEX_UNIVERSE}.squared.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.squared"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_diagonal
			-- Test {STI_COMPLEX_UNIVERSE}.diagonal.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.diagonal"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.raised.
			-- Test {STI_NUMERIC_SET}.raised.
			-- Test {STS_COMPLEX_SET}.raised.
			-- Test {STI_COMPLEX_SET}.raised.
			-- Test {STS_UNIVERSE}.raised.
			-- Test {STI_UNIVERSE}.raised.
			-- Test {STS_COMPLEX_UNIVERSE}.raised.
			-- Test {STI_COMPLEX_UNIVERSE}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_NUMERIC_SET}.raised"
			testing: "covers/{STI_NUMERIC_SET}.raised"
			testing: "covers/{STS_COMPLEX_SET}.raised"
			testing: "covers/{STI_COMPLEX_SET}.raised"
			testing: "covers/{STS_UNIVERSE}.raised"
			testing: "covers/{STI_UNIVERSE}.raised"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.raised"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.raised"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.crossed_tuples.
			-- Test {STI_COMPLEX_SET}.crossed_tuples.
			-- Test {STI_COMPLEX_UNIVERSE}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.crossed_tuples"
			testing: "covers/{STI_COMPLEX_SET}.crossed_tuples"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.crossed_tuples"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.singleton_crossed_tuples.
			-- Test {STI_COMPLEX_SET}.singleton_crossed_tuples.
			-- Test {STI_COMPLEX_UNIVERSE}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_COMPLEX_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.singleton_crossed_tuples"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.mapped.
			-- Test {STI_NUMERIC_SET}.mapped.
			-- Test {STS_COMPLEX_SET}.mapped.
			-- Test {STI_COMPLEX_SET}.mapped.
			-- Test {STS_UNIVERSE}.mapped.
			-- Test {STI_UNIVERSE}.mapped.
			-- Test {STS_COMPLEX_UNIVERSE}.mapped.
			-- Test {STI_COMPLEX_UNIVERSE}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_NUMERIC_SET}.mapped"
			testing: "covers/{STI_NUMERIC_SET}.mapped"
			testing: "covers/{STS_COMPLEX_SET}.mapped"
			testing: "covers/{STI_COMPLEX_SET}.mapped"
			testing: "covers/{STS_UNIVERSE}.mapped"
			testing: "covers/{STI_UNIVERSE}.mapped"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.mapped"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.mapped"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.reduced.
			-- Test {STI_NUMERIC_SET}.reduced.
			-- Test {STS_COMPLEX_SET}.reduced.
			-- Test {STI_COMPLEX_SET}.reduced.
			-- Test {STS_UNIVERSE}.reduced.
			-- Test {STI_UNIVERSE}.reduced.
			-- Test {STS_COMPLEX_UNIVERSE}.reduced.
			-- Test {STI_COMPLEX_UNIVERSE}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_NUMERIC_SET}.reduced"
			testing: "covers/{STI_NUMERIC_SET}.reduced"
			testing: "covers/{STS_COMPLEX_SET}.reduced"
			testing: "covers/{STI_COMPLEX_SET}.reduced"
			testing: "covers/{STS_UNIVERSE}.reduced"
			testing: "covers/{STI_UNIVERSE}.reduced"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.reduced"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.reduced"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.proper_reduced.
			-- Test {STI_NUMERIC_SET}.proper_reduced.
			-- Test {STS_COMPLEX_SET}.proper_reduced.
			-- Test {STI_COMPLEX_SET}.proper_reduced.
			-- Test {STS_UNIVERSE}.proper_reduced.
			-- Test {STI_UNIVERSE}.proper_reduced.
			-- Test {STS_COMPLEX_UNIVERSE}.proper_reduced.
			-- Test {STI_COMPLEX_UNIVERSE}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STI_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STS_COMPLEX_SET}.proper_reduced"
			testing: "covers/{STI_COMPLEX_SET}.proper_reduced"
			testing: "covers/{STS_UNIVERSE}.proper_reduced"
			testing: "covers/{STI_UNIVERSE}.proper_reduced"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.proper_reduced"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.proper_reduced"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.natural_as_integer.
			-- Test {STI_COMPLEX_SET}.natural_as_integer.
			-- Test {STI_COMPLEX_UNIVERSE}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_NUMERIC_SET}.natural_as_integer"
			testing: "covers/{STI_COMPLEX_SET}.natural_as_integer"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.natural_as_integer"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_as_singleton
			-- Test {STI_COMPLEX_UNIVERSE}.as_singleton.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.as_singleton"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.n_times.
			-- Test {STI_COMPLEX_SET}.n_times.
			-- Test {STI_COMPLEX_UNIVERSE}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_NUMERIC_SET}.n_times"
			testing: "covers/{STI_COMPLEX_SET}.n_times"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.n_times"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_as_tuple
			-- Test {STI_COMPLEX_UNIVERSE}.as_tuple.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.as_tuple"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_as_set_of_pairs
			-- Test {STI_COMPLEX_UNIVERSE}.as_set_of_pairs.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.as_set_of_pairs"
		do
			Precursor {COMPLEX_SET_TESTS}
			assert (
				"as_set_of_pairs_ok",
				properties.as_set_of_pairs_ok (Universe_to_be_tested)
				)
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_COMPLEX_SET}.o.
			-- Test {STI_COMPLEX_UNIVERSE}.o.
		note
			testing: "covers/{STI_COMPLEX_SET}.o"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.o"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_empty_set
			-- Test {STI_COMPLEX_SET}.empty_set.
			-- Test {STI_COMPLEX_UNIVERSE}.empty_set.
		note
			testing: "covers/{STI_COMPLEX_SET}.empty_set"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.empty_set"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_singleton
			-- Test {STI_COMPLEX_SET}.singleton.
			-- Test {STI_COMPLEX_UNIVERSE}.singleton.
		note
			testing: "covers/{STI_COMPLEX_SET}.singleton"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.singleton"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.pair.
			-- Test {STI_COMPLEX_SET}.pair.
			-- Test {STI_COMPLEX_UNIVERSE}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_NUMERIC_SET}.pair"
			testing: "covers/{STI_COMPLEX_SET}.pair"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.converted.
			-- Test {STI_COMPLEX_SET}.converted.
			-- Test {STI_COMPLEX_UNIVERSE}.converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_NUMERIC_SET}.converted"
			testing: "covers/{STI_COMPLEX_SET}.converted"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.converted"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_numeric_converted
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.numeric_converted.
		note
			testing: "covers/{STI_COMPLEX_SET}.numeric_converted"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.numeric_converted"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

	test_converted_element
			-- Test {STI_COMPLEX_SET}.converted_element.
			-- Test {STI_COMPLEX_UNIVERSE}.converted_element.
		note
			testing: "covers/{STI_COMPLEX_SET}.converted_element"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.converted_element"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_unit
			-- Test {STI_COMPLEX_SET}.unit.
			-- Test {STI_COMPLEX_UNIVERSE}.unit.
		note
			testing: "covers/{STI_COMPLEX_SET}.unit"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.unit"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_r
			-- Test {STI_COMPLEX_UNIVERSE}.r.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.r"
		local
			u: like Universe_to_be_tested
		do
			u := Universe_to_be_tested
			assert ("R", attached u.R)
			assert ("R ok", properties.r_ok (u))
		end

	test_real_universe
			-- Test {STI_COMPLEX_UNIVERSE}.real_universe.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.real_universe"
		local
			u: like Universe_to_be_tested
		do
			u := Universe_to_be_tested
			assert ("Real_universe", attached u.Real_universe)
			assert ("Real_universe ok", properties.real_universe_ok (u))
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.ored.
			-- Test {STI_NUMERIC_SET}.ored.
			-- Test {STS_COMPLEX_SET}.ored.
			-- Test {STI_COMPLEX_SET}.ored.
			-- Test {STS_UNIVERSE}.ored.
			-- Test {STI_UNIVERSE}.ored.
			-- Test {STS_COMPLEX_UNIVERSE}.ored.
			-- Test {STI_COMPLEX_UNIVERSE}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_NUMERIC_SET}.ored"
			testing: "covers/{STI_NUMERIC_SET}.ored"
			testing: "covers/{STS_COMPLEX_SET}.ored"
			testing: "covers/{STI_COMPLEX_SET}.ored"
			testing: "covers/{STS_UNIVERSE}.ored"
			testing: "covers/{STI_UNIVERSE}.ored"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.ored"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.ored"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.xored.
			-- Test {STI_NUMERIC_SET}.xored.
			-- Test {STS_COMPLEX_SET}.xored.
			-- Test {STI_COMPLEX_SET}.xored.
			-- Test {STS_UNIVERSE}.xored.
			-- Test {STI_UNIVERSE}.xored.
			-- Test {STS_COMPLEX_UNIVERSE}.xored.
			-- Test {STI_COMPLEX_UNIVERSE}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_NUMERIC_SET}.xored"
			testing: "covers/{STI_NUMERIC_SET}.xored"
			testing: "covers/{STS_COMPLEX_SET}.xored"
			testing: "covers/{STI_COMPLEX_SET}.xored"
			testing: "covers/{STS_UNIVERSE}.xored"
			testing: "covers/{STI_UNIVERSE}.xored"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.xored"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.xored"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.iff.
			-- Test {STI_NUMERIC_SET}.iff.
			-- Test {STS_COMPLEX_SET}.iff.
			-- Test {STI_COMPLEX_SET}.iff.
			-- Test {STS_UNIVERSE}.iff.
			-- Test {STI_UNIVERSE}.iff.
			-- Test {STS_COMPLEX_UNIVERSE}.iff.
			-- Test {STI_COMPLEX_UNIVERSE}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_NUMERIC_SET}.iff"
			testing: "covers/{STI_NUMERIC_SET}.iff"
			testing: "covers/{STS_COMPLEX_SET}.iff"
			testing: "covers/{STI_COMPLEX_SET}.iff"
			testing: "covers/{STS_UNIVERSE}.iff"
			testing: "covers/{STI_UNIVERSE}.iff"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.iff"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.iff"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.equality_holds.
			-- Test {STI_COMPLEX_SET}.equality_holds.
			-- Test {STI_COMPLEX_UNIVERSE}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_NUMERIC_SET}.equality_holds"
			testing: "covers/{STI_COMPLEX_SET}.equality_holds"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.equality_holds"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.subset_relation_holds.
			-- Test {STI_COMPLEX_SET}.subset_relation_holds.
			-- Test {STI_COMPLEX_UNIVERSE}.subset_relation_holds.
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
			testing: "covers/{STI_NUMERIC_SET}.subset_relation_holds"
			testing: "covers/{STI_COMPLEX_SET}.subset_relation_holds"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.subset_relation_holds"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_set_has_complex_number
			-- <Precursor>
			-- Test {STI_COMPLEX_UNIVERSE}.set_has_complex_number.
		note
			testing: "covers/{STI_COMPLEX_SET}.set_has_complex_number"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.set_has_complex_number"
		do
			Precursor {COMPLEX_SET_TESTS}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.second_after_first.
			-- Test {STI_NUMERIC_SET}.second_after_first.
			-- Test {STS_COMPLEX_SET}.second_after_first.
			-- Test {STI_COMPLEX_SET}.second_after_first.
			-- Test {STS_UNIVERSE}.second_after_first.
			-- Test {STI_UNIVERSE}.second_after_first.
			-- Test {STS_COMPLEX_UNIVERSE}.second_after_first.
			-- Test {STI_COMPLEX_UNIVERSE}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_NUMERIC_SET}.second_after_first"
			testing: "covers/{STI_NUMERIC_SET}.second_after_first"
			testing: "covers/{STS_COMPLEX_SET}.second_after_first"
			testing: "covers/{STI_COMPLEX_SET}.second_after_first"
			testing: "covers/{STS_UNIVERSE}.second_after_first"
			testing: "covers/{STI_UNIVERSE}.second_after_first"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.second_after_first"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.second_after_first"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_complex_from_pair
			-- Test {STI_COMPLEX_UNIVERSE}.complex_from_pair.
		note
			testing: "covers/{STI_COMPLEX_UNIVERSE}.complex_from_pair"
		local
			res_r: NUMBERS_TESTS_RESOURCES_R
		do
			create res_r
			assert ("complex_from_pair", attached Universe_to_be_tested.complex_from_pair (res_r.some_pair_aa))
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.natural_successor.
			-- Test {STI_NUMERIC_SET}.natural_successor.
			-- Test {STS_COMPLEX_SET}.natural_successor.
			-- Test {STI_COMPLEX_SET}.natural_successor.
			-- Test {STS_UNIVERSE}.natural_successor.
			-- Test {STI_UNIVERSE}.natural_successor.
			-- Test {STS_COMPLEX_UNIVERSE}.natural_successor.
			-- Test {STI_COMPLEX_UNIVERSE}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_NUMERIC_SET}.natural_successor"
			testing: "covers/{STI_NUMERIC_SET}.natural_successor"
			testing: "covers/{STS_COMPLEX_SET}.natural_successor"
			testing: "covers/{STI_COMPLEX_SET}.natural_successor"
			testing: "covers/{STS_UNIVERSE}.natural_successor"
			testing: "covers/{STI_UNIVERSE}.natural_successor"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.natural_successor"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.natural_successor"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.disjunction.
			-- Test {STI_NUMERIC_SET}.disjunction.
			-- Test {STS_COMPLEX_SET}.disjunction.
			-- Test {STI_COMPLEX_SET}.disjunction.
			-- Test {STS_UNIVERSE}.disjunction.
			-- Test {STI_UNIVERSE}.disjunction.
			-- Test {STS_COMPLEX_UNIVERSE}.disjunction.
			-- Test {STI_COMPLEX_UNIVERSE}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_NUMERIC_SET}.disjunction"
			testing: "covers/{STI_NUMERIC_SET}.disjunction"
			testing: "covers/{STS_COMPLEX_SET}.disjunction"
			testing: "covers/{STI_COMPLEX_SET}.disjunction"
			testing: "covers/{STS_UNIVERSE}.disjunction"
			testing: "covers/{STI_UNIVERSE}.disjunction"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.disjunction"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.disjunction"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.conjunction.
			-- Test {STI_NUMERIC_SET}.conjunction.
			-- Test {STS_COMPLEX_SET}.conjunction.
			-- Test {STI_COMPLEX_SET}.conjunction.
			-- Test {STS_UNIVERSE}.conjunction.
			-- Test {STI_UNIVERSE}.conjunction.
			-- Test {STS_COMPLEX_UNIVERSE}.conjunction.
			-- Test {STI_COMPLEX_UNIVERSE}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_NUMERIC_SET}.conjunction"
			testing: "covers/{STI_NUMERIC_SET}.conjunction"
			testing: "covers/{STS_COMPLEX_SET}.conjunction"
			testing: "covers/{STI_COMPLEX_SET}.conjunction"
			testing: "covers/{STS_UNIVERSE}.conjunction"
			testing: "covers/{STI_UNIVERSE}.conjunction"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.conjunction"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.conjunction"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_COMPLEX_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_COMPLEX_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_UNIVERSE}.sets_plus_same_sets_with_element.
			-- Test {STI_UNIVERSE}.sets_plus_same_sets_with_element.
			-- Test {STS_COMPLEX_UNIVERSE}.sets_plus_same_sets_with_element.
			-- Test {STI_COMPLEX_UNIVERSE}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_COMPLEX_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_COMPLEX_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_UNIVERSE}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_UNIVERSE}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_COMPLEX_UNIVERSE}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_COMPLEX_UNIVERSE}.sets_plus_same_sets_with_element"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature {NONE} -- Factory (element to be tested)

	universe_to_be_tested: STI_COMPLEX_UNIVERSE
			-- <Precursor>
		once
			Result := C
		ensure then
			class
		end

	exposed_universe_to_be_tested: COMPLEX_UNIVERSE
			-- Complex universe meant to be under tests, whose features with restricted access are available to be tested.
		once
			Result := Exposed_c
		ensure then
			class
		end

feature {NONE} -- Conversion

	set_from_sa (sa: STS_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `sa` converted to a set like `some_direct_complex_set'
		do
			Result := sa
		end

	set_from_saa (saa: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `saa` converted to a set like `some_direct_complex_set'
		do
			Result := saa
		end

	set_from_sti_sa (sa: STI_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `sa` converted to a set like `some_direct_complex_set'
		do
			Result := sa
		end

	set_from_numeric_set (ns: STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `ns` converted to a set like `some_direct_complex_set'
		do
			Result := ns
		end

	set_from_sti_numeric_set (ns: STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `ns` converted to a set like `some_direct_complex_set'
		do
			Result := ns
		end

	set_from_complex_set (sa: STS_COMPLEX_SET): like some_direct_complex_set
			-- `sa` converted to a set like `some_direct_complex_set'
		do
			Result := sa
		end

	set_from_universe (u: STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `u` converted to a set like `some_direct_complex_set'
		do
			Result := u
		end

	set_from_sti_universe (u: STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `u` converted to a set like `some_direct_complex_set'
		do
			Result := u
		end

	set_from_complex_universe (u: STS_COMPLEX_UNIVERSE): like some_direct_complex_set
			-- `u` converted to a set like `some_direct_complex_set'
		do
			Result := u
		end

	set_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]): like some_direct_complex_set
			-- `saa' converted to a set like `some_direct_complex_set'
		do
			Result := saa
		end

	set_from_transformable_complexes_to_numeric_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_complexes_to_numeric_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_complexes_to_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_complexes_to_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_COMPLEX_EQUALITY]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_complexes_to_expanded_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_complexes_to_expanded_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_complexes_to_numeric_reals (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr' converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_sti_transformable_complexes_to_numeric_reals (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr' converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_transformable_complexes_to_expanded_reals (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr' converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_sti_transformable_complexes_to_expanded_reals (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_COMPLEX_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr' converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_sc (sc: STS_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like some_direct_complex_set
			-- `sc` converted to a set like `some_direct_complex_set'
		do
			Result := sc
		end

	set_from_sti_sc (sc: STI_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like some_direct_complex_set
			-- `sc` converted to a set like `some_direct_complex_set'
		do
			Result := sc
		end

	set_from_scr (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr` converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_sti_scr (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr` converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_numeric_complexes (nc: STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like some_direct_complex_set
			-- `nc` converted to a set like `some_direct_complex_set'
		do
			Result := nc
		end

	set_from_sti_numeric_complexes (nc: STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like some_direct_complex_set
			-- `nc` converted to a set like `some_direct_complex_set'
		do
			Result := nc
		end

	set_from_numeric_universe (u: STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like some_direct_complex_set -- TODO: Change it.
			-- `u` converted to a set like `some_direct_complex_set'
		do
			Result := u
		end

	set_from_sti_numeric_universe (u: STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like some_direct_complex_set -- TODO: Change it.
			-- `u` converted to a set like `some_direct_complex_set'
		do
			Result := u
		end

	set_from_transformable_numeric_complexes_to_numeric_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_numeric_complexes_to_numeric_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_numeric_complexes_to_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_numeric_complexes_to_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_COMPLEX_EQUALITY]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_numeric_complexes_to_expanded_complexes (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_numeric_complexes_to_expanded_complexes (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_numeric_complexes_to_reals (
		scc: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_sti_transformable_numeric_complexes_to_reals (
		scc: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_REAL_EQUALITY]
		): like some_direct_complex_set
			-- `scc' converted to a set like `some_direct_complex_set'
		do
			Result := scc
		end

	set_from_transformable_numeric_complexes_to_expanded_reals (
		scr: STS_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr' converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	set_from_sti_transformable_numeric_complexes_to_expanded_reals (
		scr: STI_TRANSFORMABLE_SET [STS_COMPLEX_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_complex_set
			-- `scr' converted to a set like `some_direct_complex_set'
		do
			Result := scr
		end

	universe_from_numeric_universe (u: STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: u ≍ Result
		end

	universe_from_sti_numeric_universe (u: STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: u ≍ Result
		end

	universe_from_universe (u: STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: Result ≍ u
		end

	universe_from_sti_universe (u: STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: Result ≍ u
		end

	universe_from_complex_universe (u: STS_COMPLEX_UNIVERSE): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: Result ≍ u
		end

invariant
	monomorphic_Universe_to_be_tested: Universe_to_be_tested.generating_type ~ {detachable like Universe_to_be_tested}

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
