﻿note
	description: "Test suite for {STI_INTEGER_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	INTEGER_SET_TESTS

inherit
	ORDERED_NUMERIC_SET_TESTS [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			some_object_a as some_integer,
			test_u as test_z,
			test_universe as test_integer_universe
		undefine
			some_pair_aa,
			some_set_a,
			same_set_a
		redefine
			on_prepare,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_zero,
			test_z,
			test_integer_universe,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_without_zero,
			test_non_positive,
			test_non_negative,
			test_negative,
			test_positive,
			test_closed_interval,
			test_left_closed_right_open_interval,
			test_left_open_right_closed_interval,
			test_open_interval,
			test_left_closed_right_unbounded_interval,
			test_left_open_right_unbounded_interval,
			test_left_unbounded_right_closed_interval,
			test_left_unbounded_right_open_interval,
			test_unbounded_interval,
			test_min,
			test_max,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_complement,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_anded,
			test_number_is_less,
			test_number_is_less_equal,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element
		end

	SET_TESTS [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_integer as some_native_integer,
			some_object_a as some_integer
		undefine
			some_native_integer,
			some_element,
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_n_tuple
		redefine
			on_prepare,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_out,
			test_is_singleton,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_is_disjoint,
			test_intersects,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			set_to_be_tested,
			set_from_sa,
			set_from_saa
		end

	NUMBERS_TESTS_RESOURCES_I
		rename
			eq_a as eq
		redefine
			on_prepare
		end

feature -- Access

--	zero: STI_INTEGER_NUMBER
--			-- The integer number 0
--		once
--		ensure then
--			class
--		end

	properties: INTEGER_SET_PROPERTIES
			-- Object that checks the set-theory properties of {STI_INTEGER_SET}
--		once
--			create Result
--		ensure then
--			class
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {NUMBERS_TESTS_RESOURCES_I}
			create properties
		end

feature -- Test routines (Initialization)

	test_make_empty
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.make_empty.
			-- Test {STI_ORDERED_NUMERIC_SET}.make_empty.
			-- Test {STI_INTEGER_SET}.make_empty.
		note
			testing: "covers/{STI_SET}.make_empty"
			testing: "covers/{STI_NUMERIC_SET}.make_empty"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.make_empty"
			testing: "covers/{STI_INTEGER_SET}.make_empty"
		do
			Precursor {SET_TESTS}
		end

	test_make_singleton
			-- Test {STI_INTEGER_SET}.make_singleton.
		note
			testing: "covers/{STI_INTEGER_SET}.make_singleton"
		do
			Precursor {SET_TESTS}
		end

	test_make_extended
			-- Test {STI_INTEGER_SET}.make_extended.
		note
			testing: "covers/{STI_INTEGER_SET}.make_extended"
		do
			Precursor {SET_TESTS}
		end

	test_make_from_set
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.make_from_set.
			-- Test {STI_ORDERED_NUMERIC_SET}.make_from_set.
			-- Test {STI_INTEGER_SET}.make_from_set.
		note
			testing: "covers/{STI_SET}.make_from_set"
			testing: "covers/{STI_NUMERIC_SET}.make_from_set"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.make_from_set"
			testing: "covers/{STI_INTEGER_SET}.make_from_set"
		local
			sti_sa: like some_set_a
			numeric_set: STI_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
			ordered_numeric_set: STI_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
			integer_set: like some_integer_set
			integers_to_numeric_complexes: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
			integers_to_complexes: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY]
			integers_to_expanded_complexes: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
			integers_to_numeric_reals: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
			integers_to_reals: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY]
			integers_to_expanded_reals: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
			integers_to_numeric_integers: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
			integers_to_expanded_integers:
				STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
			sti_saa: like new_transformable_set_aa
			chk_ops: BOOLEAN
		do
			Precursor {SET_TESTS}

			sti_sa := some_set_a
			assert ("set_from_sti_sa", attached set_from_sti_sa (sti_sa))

			numeric_set := some_integer_set
			assert ("set_from_numeric_set", attached set_from_numeric_set (numeric_set))

			numeric_set := some_integer_set
			assert ("set_from_sti_numeric_set", attached set_from_sti_numeric_set (numeric_set))

			ordered_numeric_set := some_integer_set
			assert ("set_from_ordered_numeric_set", attached set_from_ordered_numeric_set (ordered_numeric_set))

			ordered_numeric_set := some_integer_set
			assert ("set_from_sti_ordered_numeric_set", attached set_from_sti_ordered_numeric_set (ordered_numeric_set))

			integer_set := some_integer_set
			assert ("set_from_integer_set", attached set_from_integer_set (integer_set))

			assert ("set_from_universe", attached set_from_universe (Z))
			assert ("set_from_sti_universe", attached set_from_sti_universe (Z))
			assert ("set_from_integer_universe", attached set_from_integer_universe (Z))

			sti_saa := new_transformable_set_aa
			assert ("set_from_sti_saa", attached set_from_sti_saa (sti_saa))

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_numeric_complexes := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_transformable_integers_to_numeric_complexes",
				attached set_from_transformable_integers_to_numeric_complexes (integers_to_numeric_complexes)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_numeric_complexes := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_numeric_complexes",
				attached set_from_sti_transformable_integers_to_numeric_complexes (integers_to_numeric_complexes)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_complexes := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert
				("set_from_transformable_integers_to_complexes", attached set_from_transformable_integers_to_complexes (integers_to_complexes))

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_complexes := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_complexes",
				attached set_from_sti_transformable_integers_to_complexes (integers_to_complexes)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_expanded_complexes := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_transformable_integers_to_expanded_complexes",
				attached set_from_transformable_integers_to_expanded_complexes (integers_to_expanded_complexes)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_expanded_complexes := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_expanded_complexes",
				attached set_from_sti_transformable_integers_to_expanded_complexes (integers_to_expanded_complexes)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_numeric_reals := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_transformable_integers_to_numeric_reals",
				attached set_from_transformable_integers_to_numeric_reals (integers_to_numeric_reals)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_numeric_reals := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_numeric_reals",
				attached set_from_sti_transformable_integers_to_numeric_reals (integers_to_numeric_reals)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_reals := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert
				("set_from_transformable_integers_to_reals", attached set_from_transformable_integers_to_reals (integers_to_reals))

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_reals := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_reals",
				attached set_from_sti_transformable_integers_to_reals (integers_to_reals)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_expanded_reals := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_transformable_integers_to_expanded_reals",
				attached set_from_transformable_integers_to_expanded_reals (integers_to_expanded_reals)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_expanded_reals := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_expanded_reals",
				attached set_from_sti_transformable_integers_to_expanded_reals (integers_to_expanded_reals)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_numeric_integers := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_transformable_integers_to_numeric_integers",
				attached set_from_transformable_integers_to_numeric_integers (integers_to_numeric_integers)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_numeric_integers := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_numeric_integers",
				attached set_from_sti_transformable_integers_to_numeric_integers (integers_to_numeric_integers)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_expanded_integers := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_transformable_integers_to_expanded_integers",
				attached set_from_transformable_integers_to_expanded_integers (integers_to_expanded_integers)
				)

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				integers_to_expanded_integers := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert (
				"set_from_sti_transformable_integers_to_expanded_integers",
				attached set_from_sti_transformable_integers_to_expanded_integers (integers_to_expanded_integers)
				)
		end

	test_make_from_numeric_set
			-- Test {STI_INTEGER_SET}.make_from_numeric_set.
		note
			testing: "covers/{STI_INTEGER_SET}.make_from_numeric_set"
		local
			si: like some_integer_numbers
			numeric_set: STI_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
			ordered_numeric_set: STI_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
			integers_to_numeric_complexes: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
			integers_to_complexes:
				STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY]
			integers_to_expanded_complexes: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
			integers_to_numeric_reals: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
			integers_to_reals:
				STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY]
			integers_to_expanded_reals: STI_TRANSFORMABLE_SET
				[STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
			sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY]
			integers_to_expanded_integers:
				STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
			n: like some_integer_numbers.cardinality
			chk_ops, chk_tests: BOOLEAN
		do
			si := some_integer_numbers
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # si
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("make_from_numeric_set", attached (create {like set_to_be_tested}.make_from_numeric_set (si)))
				assert ("set_from_si", attached set_from_si (si))
				assert ("set_from_sti_si", attached set_from_sti_si (si))

				integers_to_numeric_complexes := si
				assert (
					"set_from_transformable_numeric_integers_to_numeric_complexes",
					attached set_from_transformable_numeric_integers_to_numeric_complexes (integers_to_numeric_complexes)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_numeric_complexes",
					attached set_from_sti_transformable_numeric_integers_to_numeric_complexes (integers_to_numeric_complexes)
					)

				integers_to_complexes := si
				assert (
					"set_from_transformable_numeric_integers_to_complexes",
					attached set_from_transformable_numeric_integers_to_complexes (integers_to_complexes)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_complexes",
					attached set_from_sti_transformable_numeric_integers_to_complexes (integers_to_complexes)
					)

				integers_to_expanded_complexes := si
				assert (
					"set_from_transformable_numeric_integers_to_expanded_complexes",
					attached set_from_transformable_numeric_integers_to_expanded_complexes (integers_to_expanded_complexes)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_expanded_complexes",
					attached set_from_sti_transformable_numeric_integers_to_expanded_complexes (integers_to_expanded_complexes)
					)

				integers_to_numeric_reals := si
				assert (
					"set_from_transformable_numeric_integers_to_numeric_reals",
					attached set_from_transformable_numeric_integers_to_numeric_reals (integers_to_numeric_reals)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_numeric_reals",
					attached set_from_sti_transformable_numeric_integers_to_numeric_reals (integers_to_numeric_reals)
					)

				integers_to_reals := si
				assert (
					"set_from_transformable_numeric_integers_to_reals",
					attached set_from_transformable_numeric_integers_to_reals (integers_to_reals)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_reals",
					attached set_from_sti_transformable_numeric_integers_to_reals (integers_to_reals)
					)

				integers_to_expanded_reals := si
				assert (
					"set_from_transformable_numeric_integers_to_expanded_reals",
					attached set_from_transformable_numeric_integers_to_expanded_reals (integers_to_expanded_reals)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_expanded_reals",
					attached set_from_sti_transformable_numeric_integers_to_expanded_reals (integers_to_expanded_reals)
					)

				sii := si
				assert ("set_from_sii", attached set_from_sii (sii))
				assert ("set_from_sti_sii", attached set_from_sti_sii (sii))

				assert ("set_from_transformable_numeric_integers_to_integers", attached set_from_transformable_numeric_integers_to_integers (sii))
				assert ("set_from_sti_transformable_numeric_integers_to_integers", attached set_from_sti_transformable_numeric_integers_to_integers (sii))

				integers_to_expanded_integers := si
				assert (
					"set_from_transformable_numeric_integers_to_expanded_integers",
					attached set_from_transformable_numeric_integers_to_expanded_integers (integers_to_expanded_integers)
					)
				assert (
					"set_from_sti_transformable_numeric_integers_to_expanded_integers",
					attached set_from_sti_transformable_numeric_integers_to_expanded_integers (integers_to_expanded_integers)
					)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			ordered_numeric_set := some_integer_set
			numeric_set := ordered_numeric_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # numeric_set
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("set_from_numeric_integers", attached set_from_numeric_integers (numeric_set))
				assert ("set_from_sti_numeric_integers", attached set_from_sti_numeric_integers (numeric_set))
				assert ("set_from_ordered_numeric_integers", attached set_from_ordered_numeric_integers (ordered_numeric_set))
				assert ("set_from_sti_ordered_numeric_integers", attached set_from_sti_ordered_numeric_integers (ordered_numeric_set))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			assert ("set_from_numeric_universe", attached set_from_numeric_universe (Z))
			assert ("set_from_sti_numeric_universe", attached set_from_sti_numeric_universe (Z))
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.is_empty.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_empty.
			-- Test {STI_INTEGER_SET}.is_empty.
		note
			testing: "covers/{STI_SET}.is_empty"
			testing: "covers/{STI_NUMERIC_SET}.is_empty"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_empty"
			testing: "covers/{STI_INTEGER_SET}.is_empty"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_any
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.any.
			-- Test {STI_ORDERED_NUMERIC_SET}.any.
			-- Test {STI_INTEGER_SET}.any.
		note
			testing: "covers/{STI_SET}.any"
			testing: "covers/{STI_NUMERIC_SET}.any"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.any"
			testing: "covers/{STI_INTEGER_SET}.any"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.others.
			-- Test {STI_ORDERED_NUMERIC_SET}.others.
			-- Test {STI_INTEGER_SET}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_NUMERIC_SET}.others"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.others"
			testing: "covers/{STI_INTEGER_SET}.others"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_eq
			-- Test {STI_INTEGER_SET}.eq.
		note
			testing: "covers/{STI_INTEGER_SET}.eq"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_NUMERIC_SET}.element_is_in.
			-- Test {STI_NUMERIC_SET}.element_is_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.element_is_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.element_is_in.
			-- Test {STS_INTEGER_SET}.element_is_in.
			-- Test {STI_INTEGER_SET}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.element_is_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.element_is_in"
			testing: "covers/{STS_INTEGER_SET}.element_is_in"
			testing: "covers/{STI_INTEGER_SET}.element_is_in"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_NUMERIC_SET}.element_is_not_in.
			-- Test {STI_NUMERIC_SET}.element_is_not_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.element_is_not_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.element_is_not_in.
			-- Test {STS_INTEGER_SET}.element_is_not_in.
			-- Test {STI_INTEGER_SET}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STS_INTEGER_SET}.element_is_not_in"
			testing: "covers/{STI_INTEGER_SET}.element_is_not_in"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_in.
			-- Test {STI_NUMERIC_SET}.is_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_in.
			-- Test {STS_INTEGER_SET}.is_in.
			-- Test {STI_INTEGER_SET}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_NUMERIC_SET}.is_in"
			testing: "covers/{STI_NUMERIC_SET}.is_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_in"
			testing: "covers/{STS_INTEGER_SET}.is_in"
			testing: "covers/{STI_INTEGER_SET}.is_in"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_in.
			-- Test {STI_NUMERIC_SET}.is_not_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_in.
			-- Test {STS_INTEGER_SET}.is_not_in.
			-- Test {STI_INTEGER_SET}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.is_not_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_in"
			testing: "covers/{STS_INTEGER_SET}.is_not_in"
			testing: "covers/{STI_INTEGER_SET}.is_not_in"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_has
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.has.
			-- Test {STI_ORDERED_NUMERIC_SET}.has.
			-- Test {STI_INTEGER_SET}.has.
		note
			testing: "covers/{STI_SET}.has"
			testing: "covers/{STI_NUMERIC_SET}.has"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.has"
			testing: "covers/{STI_INTEGER_SET}.has"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_have.
			-- Test {STI_NUMERIC_SET}.does_not_have.
			-- Test {STS_ORDERED_NUMERIC_SET}.does_not_have.
			-- Test {STI_ORDERED_NUMERIC_SET}.does_not_have.
			-- Test {STS_INTEGER_SET}.does_not_have.
			-- Test {STI_INTEGER_SET}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_NUMERIC_SET}.does_not_have"
			testing: "covers/{STI_NUMERIC_SET}.does_not_have"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.does_not_have"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.does_not_have"
			testing: "covers/{STS_INTEGER_SET}.does_not_have"
			testing: "covers/{STI_INTEGER_SET}.does_not_have"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Access)

	test_zero
			-- Test {STI_INTEGER_SET}.Zero.
		note
			testing: "covers/{STI_INTEGER_SET}.zero"
		local
			s: like set_to_be_tested
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}

			s := set_to_be_tested
			assert ("0", properties.zero_ok (s, Zero))
		end

	test_z
			-- Test {STI_INTEGER_SET}.z.
		note
			testing: "covers/{STI_INTEGER_SET}.z"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_integer_universe
			-- Test {STI_INTEGER_SET}.integer_universe.
		note
			testing: "covers/{STI_INTEGER_SET}.integer_universe"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.with.
			-- Test {STI_ORDERED_NUMERIC_SET}.with.
			-- Test {STI_INTEGER_SET}.with.
		note
			testing: "covers/{STI_SET}.with"
			testing: "covers/{STI_NUMERIC_SET}.with"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.with"
			testing: "covers/{STI_INTEGER_SET}.with"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_without
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.without.
			-- Test {STI_ORDERED_NUMERIC_SET}.without.
			-- Test {STI_INTEGER_SET}.without.
		note
			testing: "covers/{STI_SET}.without"
			testing: "covers/{STI_NUMERIC_SET}.without"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.without"
			testing: "covers/{STI_INTEGER_SET}.without"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_INTEGER_SET}.extended.
		note
			testing: "covers/{STI_SET}.extended"
			testing: "covers/{STI_INTEGER_SET}.extended"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.batch_extended.
			-- Test {STI_ORDERED_NUMERIC_SET}.batch_extended.
			-- Test {STI_INTEGER_SET}.batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_NUMERIC_SET}.batch_extended"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.batch_extended"
			testing: "covers/{STI_INTEGER_SET}.batch_extended"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_numeric_batch_extended
			-- Test {STI_INTEGER_SET}.numeric_batch_extended.
		note
			testing: "covers/{STI_INTEGER_SET}.numeric_batch_extended"
		local
			s0: like some_integer_numbers
			s: like set_to_be_tested
			chk_ops, chk_tests: BOOLEAN
			n: NATURAL_32
		do
			s0 := some_integer_numbers
			s := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s0
				print (n) print ('%N')
				s := s | agent s0.does_not_have
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("s0_is_disjoint_s", s0.is_disjoint (s))
				assert ("s_numeric_batch_extended_s0", attached s.numeric_batch_extended (s0))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("s_numeric_batch_extended_s0_ok", properties.numeric_batch_extended_ok (s0, s))

			s0 := some_integer_numbers
			s := set_to_be_tested

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s0
				print (n) print ('%N')
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			if n > max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("numeric_batch_extended", s0.is_disjoint (s) implies attached s.numeric_batch_extended (s0))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("numeric_batch_extended_ok", properties.numeric_batch_extended_ok (s0, s))
		end

feature -- Test routines (Output)

	test_out
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.out.
			-- Test {STI_ORDERED_NUMERIC_SET}.out.
			-- Test {STI_INTEGER_SET}.out.
		note
			testing: "covers/{STI_SET}.out"
			testing: "covers/{STI_NUMERIC_SET}.out"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.out"
			testing: "covers/{STI_INTEGER_SET}.out"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_singleton.
			-- Test {STI_NUMERIC_SET}.is_singleton.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_singleton.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_singleton.
			-- Test {STS_INTEGER_SET}.is_singleton.
			-- Test {STI_INTEGER_SET}.is_singleton.
		note
			testing: "covers/{STS_SET}.is_singleton"
			testing: "covers/{STI_SET}.is_singleton"
			testing: "covers/{STS_NUMERIC_SET}.is_singleton"
			testing: "covers/{STI_NUMERIC_SET}.is_singleton"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_singleton"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_singleton"
			testing: "covers/{STS_INTEGER_SET}.is_singleton"
			testing: "covers/{STI_INTEGER_SET}.is_singleton"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.cardinality.
			-- Test {STI_ORDERED_NUMERIC_SET}.cardinality.
			-- Test {STI_INTEGER_SET}.cardinality.
		note
			testing: "covers/{STI_SET}.cardinality"
			testing: "covers/{STI_NUMERIC_SET}.cardinality"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.cardinality"
			testing: "covers/{STI_INTEGER_SET}.cardinality"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.equals.
			-- Test {STI_INTEGER_SET}.equals.
		note
			testing: "covers/{STI_NUMERIC_SET}.equals"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.equals"
			testing: "covers/{STI_INTEGER_SET}.equals"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.unequals.
			-- Test {STI_NUMERIC_SET}.unequals.
			-- Test {STS_ORDERED_NUMERIC_SET}.unequals.
			-- Test {STI_ORDERED_NUMERIC_SET}.unequals.
			-- Test {STS_INTEGER_SET}.unequals.
			-- Test {STI_INTEGER_SET}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_NUMERIC_SET}.unequals"
			testing: "covers/{STI_NUMERIC_SET}.unequals"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.unequals"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.unequals"
			testing: "covers/{STS_INTEGER_SET}.unequals"
			testing: "covers/{STI_INTEGER_SET}.unequals"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_subset.
			-- Test {STI_INTEGER_SET}.is_subset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_subset"
			testing: "covers/{STI_INTEGER_SET}.is_subset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_subset.
			-- Test {STI_NUMERIC_SET}.is_not_subset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_subset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_subset.
			-- Test {STS_INTEGER_SET}.is_not_subset.
			-- Test {STI_INTEGER_SET}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STS_INTEGER_SET}.is_not_subset"
			testing: "covers/{STI_INTEGER_SET}.is_not_subset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_superset.
			-- Test {STI_INTEGER_SET}.is_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_superset"
			testing: "covers/{STI_INTEGER_SET}.is_superset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_superset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_superset.
			-- Test {STS_INTEGER_SET}.is_not_superset.
			-- Test {STI_INTEGER_SET}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STS_INTEGER_SET}.is_not_superset"
			testing: "covers/{STI_INTEGER_SET}.is_not_superset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_comparable.
			-- Test {STI_INTEGER_SET}.is_comparable.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_comparable"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_comparable"
			testing: "covers/{STI_INTEGER_SET}.is_comparable"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_comparable.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_comparable.
			-- Test {STS_INTEGER_SET}.is_not_comparable.
			-- Test {STI_INTEGER_SET}.is_not_comparable.
		note
			testing: "covers/{STS_SET}.is_not_comparable"
			testing: "covers/{STI_SET}.is_not_comparable"
			testing: "covers/{STS_NUMERIC_SET}.is_not_comparable"
			testing: "covers/{STI_NUMERIC_SET}.is_not_comparable"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_comparable"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_comparable"
			testing: "covers/{STS_INTEGER_SET}.is_not_comparable"
			testing: "covers/{STI_INTEGER_SET}.is_not_comparable"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_strict_subset.
			-- Test {STI_INTEGER_SET}.is_strict_subset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_strict_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_strict_subset"
			testing: "covers/{STI_INTEGER_SET}.is_strict_subset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STS_INTEGER_SET}.is_not_strict_subset.
			-- Test {STI_INTEGER_SET}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STS_INTEGER_SET}.is_not_strict_subset"
			testing: "covers/{STI_INTEGER_SET}.is_not_strict_subset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_strict_superset.
			-- Test {STI_INTEGER_SET}.is_strict_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_strict_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_strict_superset"
			testing: "covers/{STI_INTEGER_SET}.is_strict_superset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STS_INTEGER_SET}.is_not_strict_superset.
			-- Test {STI_INTEGER_SET}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STS_INTEGER_SET}.is_not_strict_superset"
			testing: "covers/{STI_INTEGER_SET}.is_not_strict_superset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_trivial_subset.
			-- Test {STI_INTEGER_SET}.is_trivial_subset.
		note
			testing: "covers/{STI_SET}.is_trivial_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_trivial_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_trivial_subset"
			testing: "covers/{STI_INTEGER_SET}.is_trivial_subset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_trivial_superset
			-- Test {STI_NUMERIC_SET}.is_trivial_superset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_trivial_superset.
			-- Test {STI_INTEGER_SET}.is_trivial_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_trivial_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_trivial_superset"
			testing: "covers/{STI_INTEGER_SET}.is_trivial_superset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_proper_subset.
			-- Test {STI_INTEGER_SET}.is_proper_subset.
		note
			testing: "covers/{STI_SET}.is_proper_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_proper_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_proper_subset"
			testing: "covers/{STI_INTEGER_SET}.is_proper_subset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_proper_superset.
			-- Test {STI_INTEGER_SET}.is_proper_superset.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_proper_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_proper_superset"
			testing: "covers/{STI_INTEGER_SET}.is_proper_superset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.is_disjoint.
			-- Test {STI_INTEGER_SET}.is_disjoint.
		note
			testing: "covers/{STI_NUMERIC_SET}.is_disjoint"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_disjoint"
			testing: "covers/{STI_INTEGER_SET}.is_disjoint"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.intersects.
			-- Test {STI_NUMERIC_SET}.intersects.
			-- Test {STS_ORDERED_NUMERIC_SET}.intersects.
			-- Test {STI_ORDERED_NUMERIC_SET}.intersects.
			-- Test {STS_INTEGER_SET}.intersects.
			-- Test {STI_INTEGER_SET}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_NUMERIC_SET}.intersects"
			testing: "covers/{STI_NUMERIC_SET}.intersects"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.intersects"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.intersects"
			testing: "covers/{STS_INTEGER_SET}.intersects"
			testing: "covers/{STI_INTEGER_SET}.intersects"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_partitioned.
			-- Test {STI_NUMERIC_SET}.is_partitioned.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_partitioned.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_partitioned.
			-- Test {STS_INTEGER_SET}.is_partitioned.
			-- Test {STI_INTEGER_SET}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STI_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STS_INTEGER_SET}.is_partitioned"
			testing: "covers/{STI_INTEGER_SET}.is_partitioned"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists.
			-- Test {STI_INTEGER_SET}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_NUMERIC_SET}.exists"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists"
			testing: "covers/{STI_INTEGER_SET}.exists"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist.
			-- Test {STI_NUMERIC_SET}.does_not_exist.
			-- Test {STS_ORDERED_NUMERIC_SET}.does_not_exist.
			-- Test {STI_ORDERED_NUMERIC_SET}.does_not_exist.
			-- Test {STS_INTEGER_SET}.does_not_exist.
			-- Test {STI_INTEGER_SET}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STS_INTEGER_SET}.does_not_exist"
			testing: "covers/{STI_INTEGER_SET}.does_not_exist"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_unique.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists_unique.
			-- Test {STI_INTEGER_SET}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_NUMERIC_SET}.exists_unique"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists_unique"
			testing: "covers/{STI_INTEGER_SET}.exists_unique"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists_pair.
			-- Test {STI_INTEGER_SET}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists_pair"
			testing: "covers/{STI_INTEGER_SET}.exists_pair"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STI_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STS_ORDERED_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STS_INTEGER_SET}.does_not_exist_pair.
			-- Test {STI_INTEGER_SET}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STS_INTEGER_SET}.does_not_exist_pair"
			testing: "covers/{STI_INTEGER_SET}.does_not_exist_pair"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_distinct_pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists_distinct_pair.
			-- Test {STI_INTEGER_SET}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_distinct_pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists_distinct_pair"
			testing: "covers/{STI_INTEGER_SET}.exists_distinct_pair"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all.
			-- Test {STI_ORDERED_NUMERIC_SET}.for_all.
			-- Test {STI_INTEGER_SET}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_NUMERIC_SET}.for_all"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.for_all"
			testing: "covers/{STI_INTEGER_SET}.for_all"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_pairs.
			-- Test {STI_ORDERED_NUMERIC_SET}.for_all_pairs.
			-- Test {STI_INTEGER_SET}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_pairs"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.for_all_pairs"
			testing: "covers/{STI_INTEGER_SET}.for_all_pairs"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_distinct_pairs.
			-- Test {STI_ORDERED_NUMERIC_SET}.for_all_distinct_pairs.
			-- Test {STI_INTEGER_SET}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_INTEGER_SET}.for_all_distinct_pairs"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Restriction)

	test_without_zero
			-- <Precursor>
			-- Test {STS_ORDERED_NUMERIC_SET}.without_zero.
			-- Test {STI_ORDERED_NUMERIC_SET}.without_zero.
			-- Test {STS_INTEGER_SET}.without_zero.
			-- Test {STI_INTEGER_SET}.without_zero.
		note
			testing: "covers/{STS_NUMERIC_SET}.without_zero"
			testing: "covers/{STI_NUMERIC_SET}.without_zero"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.without_zero"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.without_zero"
			testing: "covers/{STS_INTEGER_SET}.without_zero"
			testing: "covers/{STI_INTEGER_SET}.without_zero"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_non_positive
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.non_positive.
			-- Test {STI_INTEGER_SET}.non_positive.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.non_positive"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.non_positive"
			testing: "covers/{STS_INTEGER_SET}.non_positive"
			testing: "covers/{STI_INTEGER_SET}.non_positive"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_non_negative
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.non_negative.
			-- Test {STI_INTEGER_SET}.non_negative.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.non_negative"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.non_negative"
			testing: "covers/{STS_INTEGER_SET}.non_negative"
			testing: "covers/{STI_INTEGER_SET}.non_negative"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_negative
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.negative.
			-- Test {STI_INTEGER_SET}.negative.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.negative"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.negative"
			testing: "covers/{STS_INTEGER_SET}.negative"
			testing: "covers/{STI_INTEGER_SET}.negative"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_positive
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.positive.
			-- Test {STI_INTEGER_SET}.positive.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.positive"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.positive"
			testing: "covers/{STS_INTEGER_SET}.positive"
			testing: "covers/{STI_INTEGER_SET}.positive"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Interval)

	test_closed_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.closed_interval.
			-- Test {STI_INTEGER_SET}.closed_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.closed_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.closed_interval"
			testing: "covers/{STS_INTEGER_SET}.closed_interval"
			testing: "covers/{STI_INTEGER_SET}.closed_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_left_closed_right_open_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.left_closed_right_open_interval.
			-- Test {STI_INTEGER_SET}.left_closed_right_open_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_closed_right_open_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_closed_right_open_interval"
			testing: "covers/{STS_INTEGER_SET}.left_closed_right_open_interval"
			testing: "covers/{STI_INTEGER_SET}.left_closed_right_open_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_left_open_right_closed_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.left_open_right_closed_interval.
			-- Test {STI_INTEGER_SET}.left_open_right_closed_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_open_right_closed_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_open_right_closed_interval"
			testing: "covers/{STS_INTEGER_SET}.left_open_right_closed_interval"
			testing: "covers/{STI_INTEGER_SET}.left_open_right_closed_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_open_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.open_interval.
			-- Test {STI_INTEGER_SET}.open_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.open_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.open_interval"
			testing: "covers/{STS_INTEGER_SET}.open_interval"
			testing: "covers/{STI_INTEGER_SET}.open_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_left_closed_right_unbounded_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.left_closed_right_unbounded_interval.
			-- Test {STI_INTEGER_SET}.left_closed_right_unbounded_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STS_INTEGER_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STI_INTEGER_SET}.left_closed_right_unbounded_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_left_open_right_unbounded_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.left_open_right_unbounded_interval.
			-- Test {STI_INTEGER_SET}.left_open_right_unbounded_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STS_INTEGER_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STI_INTEGER_SET}.left_open_right_unbounded_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_left_unbounded_right_closed_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.left_unbounded_right_closed_interval.
			-- Test {STI_INTEGER_SET}.left_unbounded_right_closed_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STS_INTEGER_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STI_INTEGER_SET}.left_unbounded_right_closed_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_left_unbounded_right_open_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.left_unbounded_right_open_interval.
			-- Test {STI_INTEGER_SET}.left_unbounded_right_open_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STS_INTEGER_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STI_INTEGER_SET}.left_unbounded_right_open_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_unbounded_interval
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.unbounded_interval.
			-- Test {STI_INTEGER_SET}.unbounded_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.unbounded_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.unbounded_interval"
			testing: "covers/{STS_INTEGER_SET}.unbounded_interval"
			testing: "covers/{STI_INTEGER_SET}.unbounded_interval"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Element comparison)

	test_min
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.min.
			-- Test {STI_INTEGER_SET}.min.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.min"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.min"
			testing: "covers/{STS_INTEGER_SET}.min"
			testing: "covers/{STI_INTEGER_SET}.min"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_max
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.max.
			-- Test {STI_INTEGER_SET}.max.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.max"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.max"
			testing: "covers/{STS_INTEGER_SET}.max"
			testing: "covers/{STI_INTEGER_SET}.max"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.subsets.
			-- Test {STI_ORDERED_NUMERIC_SET}.subsets.
			-- Test {STI_INTEGER_SET}.subsets.
		note
			testing: "covers/{STI_SET}.subsets"
			testing: "covers/{STI_NUMERIC_SET}.subsets"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.subsets"
			testing: "covers/{STI_INTEGER_SET}.subsets"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_powerset
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.powerset.
			-- Test {STI_ORDERED_NUMERIC_SET}.powerset.
			-- Test {STI_INTEGER_SET}.powerset.
		note
			testing: "covers/{STI_SET}.powerset"
			testing: "covers/{STI_NUMERIC_SET}.powerset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.powerset"
			testing: "covers/{STI_INTEGER_SET}.powerset"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_trivial_subsets
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.trivial_subsets.
			-- Test {STI_ORDERED_NUMERIC_SET}.trivial_subsets.
			-- Test {STI_INTEGER_SET}.trivial_subsets.
		note
			testing: "covers/{STI_SET}.trivial_subsets"
			testing: "covers/{STI_NUMERIC_SET}.trivial_subsets"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.trivial_subsets"
			testing: "covers/{STI_INTEGER_SET}.trivial_subsets"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_proper_subsets
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.proper_subsets.
			-- Test {STI_NUMERIC_SET}.proper_subsets.
			-- Test {STS_ORDERED_NUMERIC_SET}.proper_subsets.
			-- Test {STI_ORDERED_NUMERIC_SET}.proper_subsets.
			-- Test {STS_INTEGER_SET}.proper_subsets.
			-- Test {STI_INTEGER_SET}.proper_subsets.
		note
			testing: "covers/{STS_SET}.proper_subsets"
			testing: "covers/{STI_SET}.proper_subsets"
			testing: "covers/{STS_NUMERIC_SET}.proper_subsets"
			testing: "covers/{STI_NUMERIC_SET}.proper_subsets"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.proper_subsets"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.proper_subsets"
			testing: "covers/{STS_INTEGER_SET}.proper_subsets"
			testing: "covers/{STI_INTEGER_SET}.proper_subsets"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.filtered.
			-- Test {STI_ORDERED_NUMERIC_SET}.filtered.
			-- Test {STI_INTEGER_SET}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_NUMERIC_SET}.filtered"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.filtered"
			testing: "covers/{STI_INTEGER_SET}.filtered"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.complemented.
			-- Test {STI_INTEGER_SET}.complemented.
		note
			testing: "covers/{STI_NUMERIC_SET}.complemented"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.complemented"
			testing: "covers/{STI_INTEGER_SET}.complemented"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_complement
			-- <Precursor>
			-- Test {STS_ORDERED_NUMERIC_SET}.complement.
			-- Test {STI_ORDERED_NUMERIC_SET}.complement.
			-- Test {STS_INTEGER_SET}.complement.
			-- Test {STI_INTEGER_SET}.complement.
		note
			testing: "covers/{STS_NUMERIC_SET}.complement"
			testing: "covers/{STI_NUMERIC_SET}.complement"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.complement"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.complement"
			testing: "covers/{STS_INTEGER_SET}.complement"
			testing: "covers/{STI_INTEGER_SET}.complement"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_united
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.united.
			-- Test {STI_INTEGER_SET}.united.
		note
			testing: "covers/{STI_NUMERIC_SET}.united"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.united"
			testing: "covers/{STI_INTEGER_SET}.united"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.intersected.
			-- Test {STI_INTEGER_SET}.intersected.
		note
			testing: "covers/{STI_NUMERIC_SET}.intersected"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.intersected"
			testing: "covers/{STI_INTEGER_SET}.intersected"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_subtracted
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.subtracted.
			-- Test {STI_INTEGER_SET}.subtracted.
		note
			testing: "covers/{STI_NUMERIC_SET}.subtracted"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.subtracted"
			testing: "covers/{STI_INTEGER_SET}.subtracted"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_ORDERED_NUMERIC_SET}.subtracted_symmetricaly.
			-- Test {STI_INTEGER_SET}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_NUMERIC_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.subtracted_symmetricaly"
			testing: "covers/{STI_INTEGER_SET}.subtracted_symmetricaly"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.crossed.
			-- Test {STI_NUMERIC_SET}.crossed.
			-- Test {STS_ORDERED_NUMERIC_SET}.crossed.
			-- Test {STI_ORDERED_NUMERIC_SET}.crossed.
			-- Test {STS_INTEGER_SET}.crossed.
			-- Test {STI_INTEGER_SET}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_NUMERIC_SET}.crossed"
			testing: "covers/{STI_NUMERIC_SET}.crossed"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.crossed"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.crossed"
			testing: "covers/{STS_INTEGER_SET}.crossed"
			testing: "covers/{STI_INTEGER_SET}.crossed"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_squared
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.squared.
			-- Test {STI_NUMERIC_SET}.squared.
			-- Test {STS_ORDERED_NUMERIC_SET}.squared.
			-- Test {STI_ORDERED_NUMERIC_SET}.squared.
			-- Test {STS_INTEGER_SET}.squared.
			-- Test {STI_INTEGER_SET}.squared.
		note
			testing: "covers/{STS_SET}.squared"
			testing: "covers/{STI_SET}.squared"
			testing: "covers/{STS_NUMERIC_SET}.squared"
			testing: "covers/{STI_NUMERIC_SET}.squared"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.squared"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.squared"
			testing: "covers/{STS_INTEGER_SET}.squared"
			testing: "covers/{STI_INTEGER_SET}.squared"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_diagonal
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.diagonal.
			-- Test {STI_ORDERED_NUMERIC_SET}.diagonal.
			-- Test {STI_INTEGER_SET}.diagonal.
		note
			testing: "covers/{STI_SET}.diagonal"
			testing: "covers/{STI_NUMERIC_SET}.diagonal"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.diagonal"
			testing: "covers/{STI_INTEGER_SET}.diagonal"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.raised.
			-- Test {STI_NUMERIC_SET}.raised.
			-- Test {STS_ORDERED_NUMERIC_SET}.raised.
			-- Test {STI_ORDERED_NUMERIC_SET}.raised.
			-- Test {STS_INTEGER_SET}.raised.
			-- Test {STI_INTEGER_SET}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_NUMERIC_SET}.raised"
			testing: "covers/{STI_NUMERIC_SET}.raised"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.raised"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.raised"
			testing: "covers/{STS_INTEGER_SET}.raised"
			testing: "covers/{STI_INTEGER_SET}.raised"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.crossed_tuples.
			-- Test {STI_ORDERED_NUMERIC_SET}.crossed_tuples.
			-- Test {STI_INTEGER_SET}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.crossed_tuples"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.crossed_tuples"
			testing: "covers/{STI_INTEGER_SET}.crossed_tuples"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.singleton_crossed_tuples.
			-- Test {STI_ORDERED_NUMERIC_SET}.singleton_crossed_tuples.
			-- Test {STI_INTEGER_SET}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_INTEGER_SET}.singleton_crossed_tuples"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.mapped.
			-- Test {STI_NUMERIC_SET}.mapped.
			-- Test {STS_ORDERED_NUMERIC_SET}.mapped.
			-- Test {STI_ORDERED_NUMERIC_SET}.mapped.
			-- Test {STS_INTEGER_SET}.mapped.
			-- Test {STI_INTEGER_SET}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_NUMERIC_SET}.mapped"
			testing: "covers/{STI_NUMERIC_SET}.mapped"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.mapped"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.mapped"
			testing: "covers/{STS_INTEGER_SET}.mapped"
			testing: "covers/{STI_INTEGER_SET}.mapped"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.reduced.
			-- Test {STI_NUMERIC_SET}.reduced.
			-- Test {STS_ORDERED_NUMERIC_SET}.reduced.
			-- Test {STI_ORDERED_NUMERIC_SET}.reduced.
			-- Test {STS_INTEGER_SET}.reduced.
			-- Test {STI_INTEGER_SET}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_NUMERIC_SET}.reduced"
			testing: "covers/{STI_NUMERIC_SET}.reduced"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.reduced"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.reduced"
			testing: "covers/{STS_INTEGER_SET}.reduced"
			testing: "covers/{STI_INTEGER_SET}.reduced"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.proper_reduced.
			-- Test {STI_NUMERIC_SET}.proper_reduced.
			-- Test {STS_ORDERED_NUMERIC_SET}.proper_reduced.
			-- Test {STI_ORDERED_NUMERIC_SET}.proper_reduced.
			-- Test {STS_INTEGER_SET}.proper_reduced.
			-- Test {STI_INTEGER_SET}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STI_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STS_INTEGER_SET}.proper_reduced"
			testing: "covers/{STI_INTEGER_SET}.proper_reduced"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.natural_as_integer.
			-- Test {STI_ORDERED_NUMERIC_SET}.natural_as_integer.
			-- Test {STI_INTEGER_SET}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_NUMERIC_SET}.natural_as_integer"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.natural_as_integer"
			testing: "covers/{STI_INTEGER_SET}.natural_as_integer"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_as_singleton
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.as_singleton.
			-- Test {STI_ORDERED_NUMERIC_SET}.as_singleton.
			-- Test {STI_INTEGER_SET}.as_singleton.
		note
			testing: "covers/{STI_SET}.as_singleton"
			testing: "covers/{STI_NUMERIC_SET}.as_singleton"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.as_singleton"
			testing: "covers/{STI_INTEGER_SET}.as_singleton"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.n_times.
			-- Test {STI_ORDERED_NUMERIC_SET}.n_times.
			-- Test {STI_INTEGER_SET}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_NUMERIC_SET}.n_times"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.n_times"
			testing: "covers/{STI_INTEGER_SET}.n_times"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_as_tuple
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.as_tuple.
			-- Test {STI_ORDERED_NUMERIC_SET}.as_tuple.
			-- Test {STI_INTEGER_SET}.as_tuple.
		note
			testing: "covers/{STI_SET}.as_tuple"
			testing: "covers/{STI_NUMERIC_SET}.as_tuple"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.as_tuple"
			testing: "covers/{STI_INTEGER_SET}.as_tuple"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_as_complex_set
			-- Test {STI_INTEGER_SET}.as_complex_set.
		note
			testing: "covers/{STI_INTEGER_SET}.as_complex_set"
		do
			assert ("as_complex_set", attached set_to_be_tested.as_complex_set)
			assert ("integer_set_to_sti_complex_set", attached integer_set_to_sti_complex_set (set_to_be_tested))
			assert ("integer_set_to_complex_set", attached integer_set_to_complex_set (set_to_be_tested))
			assert ("integer_set_to_sti_numeric_complex_set", attached integer_set_to_sti_numeric_complex_set (set_to_be_tested))
			assert ("integer_set_to_numeric_complex_set", attached integer_set_to_numeric_complex_set (set_to_be_tested))
		end

	test_as_real_set
			-- Test {STI_INTEGER_SET}.as_real_set.
		note
			testing: "covers/{STI_INTEGER_SET}.as_real_set"
		do
			assert ("as_real_set", attached set_to_be_tested.as_real_set)
			assert ("integer_set_to_sti_real_set", attached integer_set_to_sti_real_set (set_to_be_tested))
			assert ("integer_set_to_real_set", attached integer_set_to_real_set (set_to_be_tested))
			assert ("integer_set_to_sti_numeric_real_set", attached integer_set_to_sti_numeric_real_set (set_to_be_tested))
			assert ("integer_set_to_numeric_real_set", attached integer_set_to_numeric_real_set (set_to_be_tested))
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_INTEGER_SET}.o.
		note
			testing: "covers/{STI_INTEGER_SET}.o"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_empty_set
			-- Test {STI_INTEGER_SET}.empty_set.
		note
			testing: "covers/{STI_INTEGER_SET}.empty_set"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_singleton
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.singleton.
			-- Test {STI_ORDERED_NUMERIC_SET}.singleton.
			-- Test {STI_INTEGER_SET}.singleton.
		note
			testing: "covers/{STI_SET}.singleton"
			testing: "covers/{STI_NUMERIC_SET}.singleton"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.singleton"
			testing: "covers/{STI_INTEGER_SET}.singleton"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.pair.
			-- Test {STI_INTEGER_SET}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_NUMERIC_SET}.pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.pair"
			testing: "covers/{STI_INTEGER_SET}.pair"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.converted.
			-- Test {STI_ORDERED_NUMERIC_SET}.converted.
			-- Test {STI_INTEGER_SET}.converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_NUMERIC_SET}.converted"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.converted"
			testing: "covers/{STI_INTEGER_SET}.converted"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_numeric_converted
			-- Test {STI_INTEGER_SET}.numeric_converted.
		note
			testing: "covers/{STI_INTEGER_SET}.numeric_converted"
		do
			assert ("converted", attached set_to_be_tested.numeric_converted (some_integer_numbers))
		end

	test_converted_element
			-- Test {STI_INTEGER_SET}.converted_element.
		note
			testing: "covers/{STI_INTEGER_SET}.converted_element"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_unit
			-- Test {STI_INTEGER_SET}.unit.
		note
			testing: "covers/{STI_INTEGER_SET}.unit"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.ored.
			-- Test {STI_NUMERIC_SET}.ored.
			-- Test {STS_ORDERED_NUMERIC_SET}.ored.
			-- Test {STI_ORDERED_NUMERIC_SET}.ored.
			-- Test {STS_INTEGER_SET}.ored.
			-- Test {STI_INTEGER_SET}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_NUMERIC_SET}.ored"
			testing: "covers/{STI_NUMERIC_SET}.ored"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.ored"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.ored"
			testing: "covers/{STS_INTEGER_SET}.ored"
			testing: "covers/{STI_INTEGER_SET}.ored"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.xored.
			-- Test {STI_NUMERIC_SET}.xored.
			-- Test {STS_ORDERED_NUMERIC_SET}.xored.
			-- Test {STI_ORDERED_NUMERIC_SET}.xored.
			-- Test {STS_INTEGER_SET}.xored.
			-- Test {STI_INTEGER_SET}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_NUMERIC_SET}.xored"
			testing: "covers/{STI_NUMERIC_SET}.xored"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.xored"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.xored"
			testing: "covers/{STS_INTEGER_SET}.xored"
			testing: "covers/{STI_INTEGER_SET}.xored"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.iff.
			-- Test {STI_NUMERIC_SET}.iff.
			-- Test {STS_ORDERED_NUMERIC_SET}.iff.
			-- Test {STI_ORDERED_NUMERIC_SET}.iff.
			-- Test {STS_INTEGER_SET}.iff.
			-- Test {STI_INTEGER_SET}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_NUMERIC_SET}.iff"
			testing: "covers/{STI_NUMERIC_SET}.iff"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.iff"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.iff"
			testing: "covers/{STS_INTEGER_SET}.iff"
			testing: "covers/{STI_INTEGER_SET}.iff"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.equality_holds.
			-- Test {STI_ORDERED_NUMERIC_SET}.equality_holds.
			-- Test {STI_INTEGER_SET}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_NUMERIC_SET}.equality_holds"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.equality_holds"
			testing: "covers/{STI_INTEGER_SET}.equality_holds"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
		do
			Precursor {SET_TESTS}
		end

	test_anded
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.anded.
			-- Test {STI_INTEGER_SET}.anded.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.anded"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.anded"
			testing: "covers/{STS_INTEGER_SET}.anded"
			testing: "covers/{STI_INTEGER_SET}.anded"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_number_is_less
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.number_is_less.
			-- Test {STI_INTEGER_SET}.number_is_less.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.number_is_less"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.number_is_less"
			testing: "covers/{STS_INTEGER_SET}.number_is_less"
			testing: "covers/{STI_INTEGER_SET}.number_is_less"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_number_is_less_equal
			-- <Precursor>
			-- Test {STS_INTEGER_SET}.number_is_less_equal.
			-- Test {STI_INTEGER_SET}.number_is_less_equal.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.number_is_less_equal"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.number_is_less_equal"
			testing: "covers/{STS_INTEGER_SET}.number_is_less_equal"
			testing: "covers/{STI_INTEGER_SET}.number_is_less_equal"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_complex_set_has_integer_number
			-- Test {STS_INTEGER_SET}.complex_set_has_integer_number.
			-- Test {STI_INTEGER_SET}.complex_set_has_integer_number.
		note
			testing: "covers/{STS_INTEGER_SET}.complex_set_has_integer_number"
			testing: "covers/{STI_INTEGER_SET}.complex_set_has_integer_number"
		local
			i: like some_integer
			zs: like some_complex_set
			n: like some_complex_set.cardinality
			chk_ops, chk_tests: BOOLEAN
		do
			i := some_integer
			zs := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # zs
				print (n) print ('%N')
				zs := zs & same_complex (i)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("i ∈ zs", set_to_be_tested.complex_set_has_integer_number (zs, i))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			i := some_integer
			zs := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # zs
				print (n) print ('%N')
				zs := zs / same_complex (i)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("i ∉ zs", not set_to_be_tested.complex_set_has_integer_number (zs, i))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			i := some_integer
			zs := some_complex_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # zs
				print (n) print ('%N')
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("complex_set_has_integer_number", set_to_be_tested.complex_set_has_integer_number (zs, i) implies True)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
		end

	test_has_complex_number
			-- Test {STS_INTEGER_SET}.has_complex_number.
			-- Test {STI_INTEGER_SET}.has_complex_number.
		note
			testing: "covers/{STS_INTEGER_SET}.has_complex_number"
			testing: "covers/{STI_INTEGER_SET}.has_complex_number"
		local
			ab: like some_complex
			s: like set_to_be_tested
			chk_ops: BOOLEAN
		do
			ab := same_complex (some_complex.a.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := set_to_be_tested & same_integer (ab.a.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("z ∈ s", s.has_complex_number (ab))

			ab := same_complex (some_complex.a.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := set_to_be_tested / same_integer (ab.a.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("z ∉ s", not s.has_complex_number (ab))

			ab := some_complex
			s := set_to_be_tested
			assert ("has_complex_number", s.has_complex_number (ab) implies True)
		end

	test_real_set_has_integer_number
			-- Test {STS_INTEGER_SET}.real_set_has_integer_number.
			-- Test {STI_INTEGER_SET}.real_set_has_integer_number.
		note
			testing: "covers/{STS_INTEGER_SET}.real_set_has_integer_number"
			testing: "covers/{STI_INTEGER_SET}.real_set_has_integer_number"
		local
			i: like some_integer
			xs: like some_real_set
			n: like some_set.cardinality
			chk_ops, chk_tests: BOOLEAN
		do
			i := some_integer
			xs := some_real_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # xs
				print (n) print ('%N')
				xs := xs & same_real (i)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("i ∈ xs", set_to_be_tested.real_set_has_integer_number (xs, i))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			i := some_integer
			xs := some_real_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # xs
				print (n) print ('%N')
				xs := xs / same_real (i)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("i ∉ xs", not set_to_be_tested.real_set_has_integer_number (xs, i))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end

			i := some_integer
			xs := some_real_set
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # xs
				print (n) print ('%N')
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("real_set_has_integer_number", set_to_be_tested.real_set_has_integer_number (xs, i) implies True)
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
		end

	test_has_real_number
			-- Test {STS_INTEGER_SET}.has_real_number.
			-- Test {STI_INTEGER_SET}.has_real_number.
		note
			testing: "covers/{STS_INTEGER_SET}.has_real_number"
			testing: "covers/{STI_INTEGER_SET}.has_real_number"
		local
			x: like some_real
			s: like set_to_be_tested
			chk_ops: BOOLEAN
		do
			x := same_real (some_real.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := set_to_be_tested & same_integer (x.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("z ∈ s", s.has_real_number (x))

			x := same_real (some_real.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := set_to_be_tested / same_integer (x.truncated_to_integer)
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("z ∉ s", not s.has_real_number (x))

			x := some_real
			s := set_to_be_tested
			assert ("has_real_number", s.has_real_number (x) implies True)
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.second_after_first.
			-- Test {STI_NUMERIC_SET}.second_after_first.
			-- Test {STS_ORDERED_NUMERIC_SET}.second_after_first.
			-- Test {STI_ORDERED_NUMERIC_SET}.second_after_first.
			-- Test {STS_INTEGER_SET}.second_after_first.
			-- Test {STI_INTEGER_SET}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_NUMERIC_SET}.second_after_first"
			testing: "covers/{STI_NUMERIC_SET}.second_after_first"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.second_after_first"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.second_after_first"
			testing: "covers/{STS_INTEGER_SET}.second_after_first"
			testing: "covers/{STI_INTEGER_SET}.second_after_first"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.natural_successor.
			-- Test {STI_NUMERIC_SET}.natural_successor.
			-- Test {STS_ORDERED_NUMERIC_SET}.natural_successor.
			-- Test {STI_ORDERED_NUMERIC_SET}.natural_successor.
			-- Test {STS_INTEGER_SET}.natural_successor.
			-- Test {STI_INTEGER_SET}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_NUMERIC_SET}.natural_successor"
			testing: "covers/{STI_NUMERIC_SET}.natural_successor"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.natural_successor"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.natural_successor"
			testing: "covers/{STS_INTEGER_SET}.natural_successor"
			testing: "covers/{STI_INTEGER_SET}.natural_successor"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.disjunction.
			-- Test {STI_NUMERIC_SET}.disjunction.
			-- Test {STS_ORDERED_NUMERIC_SET}.disjunction.
			-- Test {STI_ORDERED_NUMERIC_SET}.disjunction.
			-- Test {STS_INTEGER_SET}.disjunction.
			-- Test {STI_INTEGER_SET}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_NUMERIC_SET}.disjunction"
			testing: "covers/{STI_NUMERIC_SET}.disjunction"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.disjunction"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.disjunction"
			testing: "covers/{STS_INTEGER_SET}.disjunction"
			testing: "covers/{STI_INTEGER_SET}.disjunction"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.conjunction.
			-- Test {STI_NUMERIC_SET}.conjunction.
			-- Test {STS_ORDERED_NUMERIC_SET}.conjunction.
			-- Test {STI_ORDERED_NUMERIC_SET}.conjunction.
			-- Test {STS_INTEGER_SET}.conjunction.
			-- Test {STI_INTEGER_SET}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_NUMERIC_SET}.conjunction"
			testing: "covers/{STI_NUMERIC_SET}.conjunction"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.conjunction"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.conjunction"
			testing: "covers/{STS_INTEGER_SET}.conjunction"
			testing: "covers/{STI_INTEGER_SET}.conjunction"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_INTEGER_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_INTEGER_SET}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_INTEGER_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_INTEGER_SET}.sets_plus_same_sets_with_element"
		do
			Precursor {ORDERED_NUMERIC_SET_TESTS}
		end

feature {NONE} -- Factory (element to be tested)

	set_to_be_tested: like some_direct_integer_set
			-- <Precursor>
		do
			Result := some_direct_integer_set
		end

feature {NONE} -- Conversion

	set_from_sa (sa: STS_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- <Precursor>
		do
			Result := sa
		end

	set_from_saa (saa: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- <Precursor>
		do
			Result := saa
		end

	set_from_sti_sa (sa: STI_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `sa` converted to a set like `set_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
		end

	set_from_numeric_set (ns: STS_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `ns` converted to a set like `set_to_be_tested'
		do
			Result := ns
		ensure
			same_set: Result ≍ ns
		end

	set_from_sti_numeric_set (ns: STI_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `ns` converted to a set like `set_to_be_tested'
		do
			Result := ns
		ensure
			same_set: Result ≍ ns
		end

	set_from_ordered_numeric_set (ons: STS_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `ons` converted to a set like `set_to_be_tested'
		do
			Result := ons
		ensure
			same_set: Result ≍ ons
		end

	set_from_sti_ordered_numeric_set (ons: STI_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `ons` converted to a set like `set_to_be_tested'
		do
			Result := ons
		ensure
			same_set: Result ≍ ons
		end

	set_from_integer_set (sa: STS_INTEGER_SET): like set_to_be_tested
			-- `sa` converted to a set like `set_to_be_tested'
		do
			Result := sa
		ensure
			same_set: Result ≍ sa
		end

	set_from_universe (u: STS_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: Result ≍ u
		end

	set_from_sti_universe (u: STI_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: Result ≍ u
		end

	set_from_integer_universe (u: STS_INTEGER_UNIVERSE): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: Result ≍ u
		end

	set_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]): like set_to_be_tested
			-- `saa' converted to a set like `set_to_be_tested'
		do
			Result := saa
		ensure
			same_set: Result ≍ saa
		end

	set_from_transformable_integers_to_numeric_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: Result ≍ sic
		end

	set_from_sti_transformable_integers_to_numeric_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: Result ≍ sic
		end

	set_from_transformable_integers_to_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: Result ≍ sic
		end

	set_from_sti_transformable_integers_to_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: Result ≍ sic
		end

	set_from_transformable_integers_to_expanded_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: Result ≍ sic
		end

	set_from_sti_transformable_integers_to_expanded_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: Result ≍ sic
		end

	set_from_transformable_integers_to_numeric_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: Result ≍ sir
		end

	set_from_sti_transformable_integers_to_numeric_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: Result ≍ sir
		end

	set_from_transformable_integers_to_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: Result ≍ sir
		end

	set_from_sti_transformable_integers_to_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: Result ≍ sir
		end

	set_from_transformable_integers_to_expanded_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: Result ≍ sir
		end

	set_from_sti_transformable_integers_to_expanded_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: Result ≍ sir
		end

	set_from_transformable_integers_to_numeric_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: Result ≍ sii
		end

	set_from_sti_transformable_integers_to_numeric_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: Result ≍ sii
		end

	set_from_transformable_integers_to_expanded_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: Result ≍ sii
		end

	set_from_sti_transformable_integers_to_expanded_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: Result ≍ sii
		end

	integer_set_to_sti_complex_set (s: STI_INTEGER_SET): STI_COMPLEX_SET
			-- `s' converted to an {STI_COMPLEX_SET}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.complex_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_complex_number
		end

	integer_set_to_complex_set (s: STI_INTEGER_SET): STS_COMPLEX_SET
			-- `s' converted to an {STS_COMPLEX_SET}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.complex_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_complex_number
		end

	integer_set_to_sti_numeric_complex_set (s: STI_INTEGER_SET): STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
			-- `s' converted to an {STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.complex_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_complex_number
		end

	integer_set_to_numeric_complex_set (s: STI_INTEGER_SET): STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
			-- `s' converted to an {STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.complex_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_complex_number
		end

	integer_set_to_sti_real_set (s: STI_INTEGER_SET): STI_REAL_SET
			-- `s' converted to an {STI_REAL_SET}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.real_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_real_number
		end

	integer_set_to_real_set (s: STI_INTEGER_SET): STS_REAL_SET
			-- `s' converted to an {STS_REAL_SET}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.real_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_real_number
		end

	integer_set_to_sti_numeric_real_set (s: STI_INTEGER_SET): STI_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY]
			-- `s' converted to an {STI_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY]}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.real_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_real_number
		end

	integer_set_to_numeric_real_set (s: STI_INTEGER_SET): STS_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY]
			-- `s' converted to an {STS_NUMERIC_SET [STS_REAL_NUMBER, STS_REAL_EQUALITY]}
		do
			Result := s
		ensure
			every_integer_number: s |∀ agent s.real_set_has_integer_number (Result, ?)
			nothing_else: Result |∀ agent s.has_real_number
		end

	set_from_si (si: STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `si` converted to a set like `set_to_be_tested'
		do
			Result := si
		ensure
			same_set: si ≍ Result
		end

	set_from_sti_si (si: STI_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `si` converted to a set like `set_to_be_tested'
		do
			Result := si
		ensure
			same_set: si ≍ Result
		end

	set_from_sii (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii` converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: sii ≍ Result
		end

	set_from_sti_sii (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii` converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: sii ≍ Result
		end

	set_from_numeric_integers (ni: STS_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `ni` converted to a set like `set_to_be_tested'
		do
			Result := ni
		ensure
			same_set: ni ≍ Result
		end

	set_from_sti_numeric_integers (ni: STI_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `ni` converted to a set like `set_to_be_tested'
		do
			Result := ni
		ensure
			same_set: ni ≍ Result
		end

	set_from_ordered_numeric_integers (oni: STS_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `oni` converted to a set like `set_to_be_tested'
		do
			Result := oni
		ensure
			same_set: oni ≍ Result
		end

	set_from_sti_ordered_numeric_integers (oni: STI_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `oni` converted to a set like `set_to_be_tested'
		do
			Result := oni
		ensure
			same_set: oni ≍ Result
		end

	set_from_numeric_universe (u: STS_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: u ≍ Result
		end

	set_from_sti_numeric_universe (u: STI_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like set_to_be_tested
			-- `u` converted to a set like `set_to_be_tested'
		do
			Result := u
		ensure
			same_set: u ≍ Result
		end

	set_from_transformable_numeric_integers_to_numeric_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: sic ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_numeric_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: sic ≍ Result
		end

	set_from_transformable_numeric_integers_to_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: sic ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: sic ≍ Result
		end

	set_from_transformable_numeric_integers_to_expanded_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: sic ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_expanded_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like set_to_be_tested
			-- `sic' converted to a set like `set_to_be_tested'
		do
			Result := sic
		ensure
			same_set: sic ≍ Result
		end

	set_from_transformable_numeric_integers_to_numeric_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: sir ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_numeric_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: sir ≍ Result
		end

	set_from_transformable_numeric_integers_to_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: sir ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: sir ≍ Result
		end

	set_from_transformable_numeric_integers_to_expanded_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: sir ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_expanded_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like set_to_be_tested
			-- `sir' converted to a set like `set_to_be_tested'
		do
			Result := sir
		ensure
			same_set: sir ≍ Result
		end

	set_from_transformable_numeric_integers_to_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: sii ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: sii ≍ Result
		end

	set_from_transformable_numeric_integers_to_expanded_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: sii ≍ Result
		end

	set_from_sti_transformable_numeric_integers_to_expanded_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like set_to_be_tested
			-- `sii' converted to a set like `set_to_be_tested'
		do
			Result := sii
		ensure
			same_set: sii ≍ Result
		end

feature {NONE} -- Implementation

	max_asserted_tuples: NATURAL
			-- <Precursor>
		once
				check
--					good_divisor: (# C).divisible (Max_count) -- Max_count /= 0 -- TODO: Segmentation violation:
					good_divisor: Max_count /= 0
				end
			Result := # C // Max_count
		ensure then
			class
		end

	max_asserted_subsets: NATURAL = 1024 -- 2 ^ 10
			-- <Precursor>

	max_subsets: NATURAL = 1_048_576 -- 2 ^ 20
			-- <Precursor>

	max_tuples: NATURAL = 46_656 -- 6 ^ 6
			-- <Precursor>

invariant
	Zero: Zero.real_equals (Zero.Zero)

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
