﻿note
	description: "Test suite for {STI_INTEGER_UNIVERSE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	INTEGER_UNIVERSE_TESTS

inherit
	UNIVERSE_TESTS [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]
		rename
			some_integer_ref as some_native_integer_ref,
			some_direct_integer_ref as some_direct_native_integer_ref,
			new_integer_ref as new_native_integer_ref,
			some_integer as some_native_integer,
			some_object_a as some_integer
		undefine
			on_prepare,
			some_native_integer,
			some_element,
			some_equality,
			some_pair,
			some_pair_aa,
			some_set,
			some_set_a,
			same_set_a,
			some_n_tuple
		redefine
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_is_singleton,
			test_out,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_intersects,
			test_is_disjoint,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_converted_element,
			test_unit,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			set_from_sa,
			set_from_saa
		end

	INTEGER_SET_TESTS
		rename
			set_to_be_tested as universe_to_be_tested
		redefine
			properties,
			test_make_empty,
			test_make_singleton,
			test_make_extended,
			test_make_from_set,
			test_make_from_numeric_set,
			test_is_empty,
			test_any,
			test_others,
			test_eq,
			test_element_is_in,
			test_element_is_not_in,
			test_is_in,
			test_is_not_in,
			test_has,
			test_does_not_have,
			test_zero,
			test_z,
			test_integer_universe,
			test_with,
			test_without,
			test_extended,
			test_batch_extended,
			test_numeric_batch_extended,
			test_is_singleton,
			test_out,
			test_cardinality,
			test_equals,
			test_unequals,
			test_is_subset,
			test_is_not_subset,
			test_is_superset,
			test_is_not_superset,
			test_is_comparable,
			test_is_not_comparable,
			test_is_strict_subset,
			test_is_not_strict_subset,
			test_is_strict_superset,
			test_is_not_strict_superset,
			test_is_trivial_subset,
			test_is_trivial_superset,
			test_is_proper_subset,
			test_is_proper_superset,
			test_intersects,
			test_is_disjoint,
			test_is_partitioned,
			test_exists,
			test_does_not_exist,
			test_exists_unique,
			test_exists_pair,
			test_does_not_exist_pair,
			test_exists_distinct_pair,
			test_for_all,
			test_for_all_pairs,
			test_for_all_distinct_pairs,
			test_without_zero,
			test_non_positive,
			test_non_negative,
			test_negative,
			test_positive,
			test_closed_interval,
			test_left_closed_right_open_interval,
			test_left_open_right_closed_interval,
			test_open_interval,
			test_left_closed_right_unbounded_interval,
			test_left_open_right_unbounded_interval,
			test_left_unbounded_right_closed_interval,
			test_left_unbounded_right_open_interval,
			test_unbounded_interval,
			test_min,
			test_max,
			test_subsets,
			test_powerset,
			test_trivial_subsets,
			test_proper_subsets,
			test_filtered,
			test_complemented,
			test_complement,
			test_united,
			test_intersected,
			test_subtracted,
			test_subtracted_symmetricaly,
			test_crossed,
			test_squared,
			test_diagonal,
			test_raised,
			test_crossed_tuples,
			test_singleton_crossed_tuples,
			test_mapped,
			test_reduced,
			test_proper_reduced,
			test_natural_as_integer,
			test_as_singleton,
			test_n_times,
			test_as_tuple,
			test_o,
			test_empty_set,
			test_singleton,
			test_pair,
			test_converted,
			test_numeric_converted,
			test_converted_element,
			test_unit,
			test_as_complex_set,
			test_as_real_set,
			test_ored,
			test_xored,
			test_iff,
			test_equality_holds,
			test_subset_relation_holds,
			test_anded,
			test_number_is_less,
			test_number_is_less_equal,
			test_complex_set_has_integer_number,
			test_has_complex_number,
			test_real_set_has_integer_number,
			test_has_real_number,
			test_second_after_first,
			test_natural_successor,
			test_disjunction,
			test_conjunction,
			test_sets_plus_same_sets_with_element,
			universe_to_be_tested,
			set_from_sa,
			set_from_saa,
			set_from_sti_sa,
			set_from_numeric_set,
			set_from_sti_numeric_set,
			set_from_ordered_numeric_set,
			set_from_sti_ordered_numeric_set,
			set_from_universe,
			set_from_sti_universe,
			set_from_sti_saa,
			set_from_numeric_universe,
			set_from_sti_numeric_universe,
			set_from_integer_set,
			set_from_integer_universe,
			set_from_transformable_integers_to_numeric_complexes,
			set_from_sti_transformable_integers_to_numeric_complexes,
			set_from_transformable_integers_to_complexes,
			set_from_sti_transformable_integers_to_complexes,
			set_from_transformable_integers_to_expanded_complexes,
			set_from_sti_transformable_integers_to_expanded_complexes,
			set_from_transformable_integers_to_numeric_reals,
			set_from_sti_transformable_integers_to_numeric_reals,
			set_from_transformable_integers_to_reals,
			set_from_sti_transformable_integers_to_reals,
			set_from_transformable_integers_to_expanded_reals,
			set_from_sti_transformable_integers_to_expanded_reals,
			set_from_transformable_integers_to_numeric_integers,
			set_from_sti_transformable_integers_to_numeric_integers,
			set_from_transformable_integers_to_expanded_integers,
			set_from_sti_transformable_integers_to_expanded_integers,
			set_from_si,
			set_from_sti_si,
			set_from_sii,
			set_from_sti_sii,
			set_from_numeric_integers,
			set_from_sti_numeric_integers,
			set_from_ordered_numeric_integers,
			set_from_sti_ordered_numeric_integers,
			set_from_transformable_numeric_integers_to_numeric_complexes,
			set_from_sti_transformable_numeric_integers_to_numeric_complexes,
			set_from_transformable_numeric_integers_to_complexes,
			set_from_sti_transformable_numeric_integers_to_complexes,
			set_from_transformable_numeric_integers_to_expanded_complexes,
			set_from_sti_transformable_numeric_integers_to_expanded_complexes,
			set_from_transformable_numeric_integers_to_numeric_reals,
			set_from_sti_transformable_numeric_integers_to_numeric_reals,
			set_from_transformable_numeric_integers_to_reals,
			set_from_sti_transformable_numeric_integers_to_reals,
			set_from_transformable_numeric_integers_to_expanded_reals,
			set_from_sti_transformable_numeric_integers_to_expanded_reals,
			set_from_transformable_numeric_integers_to_integers,
			set_from_sti_transformable_numeric_integers_to_integers,
			set_from_transformable_numeric_integers_to_expanded_integers,
			set_from_sti_transformable_numeric_integers_to_expanded_integers
		end

feature -- Access

	properties: INTEGER_UNIVERSE_PROPERTIES
			-- Object that checks the set-theory properties of {STI_INTEGER_UNIVERSE}
--		once
--			create Result
--		end

feature -- Test routines (Initialization)

	test_default_create
			-- Test {STI_INTEGER_UNIVERSE}.default_create.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.default_create"
		do
			assert ("default_create", attached (create {like Universe_to_be_tested}))
		end

	test_make_empty
			-- Test {STI_UNIVERSE}.make_empty.
			-- Test {STI_INTEGER_UNIVERSE}.make_empty.
		note
			testing: "covers/{STI_UNIVERSE}.make_empty"
			testing: "covers/{STI_INTEGER_UNIVERSE}.make_empty"
		local
			make_empty_is_broken: BOOLEAN
			exp_z: like Exposed_universe_to_be_tested
		do
			if not make_empty_is_broken then
				create exp_z -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				exp_z.make_empty
			end
		rescue
			if {EXCEPTIONS}.tag_name ~ "is_empty" then
				make_empty_is_broken := True
				retry
			end
		end

	test_make_singleton
			-- Test {STI_UNIVERSE}.make_singleton.
			-- Test {STI_INTEGER_UNIVERSE}.make_singleton.
		note
			testing: "covers/{STI_UNIVERSE}.make_singleton"
			testing: "covers/{STI_INTEGER_UNIVERSE}.make_singleton"
		local
			make_singleton_is_broken: BOOLEAN
			exp_z: like Exposed_universe_to_be_tested
		do
			if not make_singleton_is_broken then
				create exp_z -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				exp_z.make_singleton (some_integer)
			end
		rescue
			if {EXCEPTIONS}.recipient_name ~ "make_singleton" then
				make_singleton_is_broken := True
				retry
			end
		end

	test_make_extended
			-- Test {STI_INTEGER_UNIVERSE}.make_extended.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.make_extended"
		local
			exp_z: like Exposed_universe_to_be_tested
			make_extended_got_rescued: PREDICATE [like Exposed_universe_to_be_tested, like some_integer, like some_integer, like some_set_a, like some_set_a]
			i0, i: like some_integer
			s0, s: like some_set_a
			chk_ops: BOOLEAN
		do
			make_extended_got_rescued := agent
				(ia_exp_z: like Exposed_universe_to_be_tested; ia_i0, ia_i: STS_INTEGER_NUMBER; ia_s0, ia_s: like some_set_a): BOOLEAN
				require
					s0_has_no_i0: ia_s0 ∌ ia_i0
					s_has_no_i: ia_s ∌ ia_i
					same_any: ia_i ≍ ia_exp_z.Any
					almost_the_universe: # ia_s = # Z - 1
				local
					i0_s0_failed, i_s0_failed: BOOLEAN
				do
					if not i0_s0_failed then
						ia_exp_z.make_extended (ia_i0, ia_s0)
					elseif not i_s0_failed and ia_s0 ∌ ia_i then
						ia_exp_z.make_extended (ia_i, ia_s0)
					elseif ia_s ∌ ia_i0 then
						ia_exp_z.make_extended (ia_i0, ia_s)
					else
						ia_exp_z.make_extended (ia_i, ia_s)
					end
					Result := True
				ensure
					i0_s0: ia_i0 ≍ ia_exp_z.Any and # ia_s0 = # Z - 1 implies ia_exp_z ≍ ia_s0.extended (ia_i0)
					i_s0: ia_i0 ≭ ia_exp_z.Any and # ia_s0 = # Z - 1 and ia_s0 ∌ ia_i implies ia_exp_z ≍ ia_s0.extended (ia_i)
					i0_s: ia_i0 ≍ ia_exp_z.Any and # ia_s0 /= # Z - 1 implies ia_exp_z ≍ ia_s.extended (ia_i0)
					i_s: ia_i0 ≭ ia_exp_z.Any or # ia_s0 /= # Z - 1 implies ia_exp_z ≍ ia_s.extended (ia_i)
				rescue
					if not i0_s0_failed then
						i0_s0_failed := True
						retry
					elseif not i_s0_failed then
						i_s0_failed := True
						retry
					end
				end

			i := Z.Any
			from
				i0 := some_integer
			until
				i0 ≭ i
			loop
				i0 := some_integer
			end
			s0 := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_z -- Don't mess up with `Z', which is a once object.
				s0 := s0 / i0
				s := same_set_a (exp_z) / i
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("s0_has_no_i0", s0 ∌ i0)
			assert ("s_has_no_i", s ∌ i)
			assert ("same_any", i ≍ exp_z.Any)
			assert ("almost_the_universe", # s = # Z - 1)
			assert ("i0_s0_fail", make_extended_got_rescued (exp_z, i0, i, s0, s))
			assert ("consistent exp_z", Z ≍ exp_z)
			assert ("i0_s0_fail ok", Properties.make_extended_ok (i0, s0))
			assert ("i_s0 try ok", Properties.make_extended_ok (i, s0))
			assert ("i0_s try ok", Properties.make_extended_ok (i0, s))
			assert ("i_s ok", Properties.make_extended_ok (i, s))

			i0 := some_integer
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_z -- Don't mess up with `Z', which is a once object.
				from
					s0 := some_set_a
				until
					exp_z ≭ s0
				loop
					s0 := some_set_a
				end
				s0 := s0 / i0
				s := same_set_a (exp_z) / i
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("s0_has_no_i0", s0 ∌ i0)
			assert ("s_has_no_i", s ∌ i)
			assert ("same_any", i ≍ exp_z.Any)
			assert ("almost_the_universe", # s = # Z - 1)
			assert ("i0_s0_fail", make_extended_got_rescued (exp_z, i0, i, s0, s))
			assert ("consistent exp_z", Z ≍ exp_z)
			assert ("i0_s0_fail ok", Properties.make_extended_ok (i0, s0))
			assert ("i_s0 try ok", Properties.make_extended_ok (i, s0))
			assert ("i0_s try ok", Properties.make_extended_ok (i0, s))
			assert ("i_s ok", Properties.make_extended_ok (i, s))

			i0 := some_integer
			s0 := some_set_a
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_z -- Don't mess up with `Z', which is a once object.
				s0 := s0 / i0
				s := same_set_a (exp_z) / i
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			assert ("s0_has_no_i0", s0 ∌ i0)
			assert ("s_has_no_i", s ∌ i)
			assert ("same_any", i ≍ exp_z.Any)
			assert ("almost_the_universe", # s = # Z - 1)
			assert ("make_extended", make_extended_got_rescued (exp_z, i0, i, s0, s))
			assert ("consistent exp_z", Z ≍ exp_z)
			assert ("i0_s0 try ok", Properties.make_extended_ok (i0, s0))
			assert ("i_s0 try ok", Properties.make_extended_ok (i, s0))
			assert ("i0_s try ok", Properties.make_extended_ok (i0, s))
			assert ("i_s ok", Properties.make_extended_ok (i, s))
		end

	test_make_from_set
			-- Test {STI_INTEGER_UNIVERSE}.make_from_set.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.make_from_set"
		local
			exp_z: like Exposed_universe_to_be_tested
			make_from_set_got_rescued: PREDICATE [like Exposed_universe_to_be_tested, like some_set_a, like some_set_a]
			s0, s: like some_set_a
			chk_ops, chk_tests: BOOLEAN
			n: like some_set.cardinality
		do
			make_from_set_got_rescued := agent (ia_exp_z: like Exposed_universe_to_be_tested; ia_s0, ia_s: like some_set_a): BOOLEAN
				require
					the_universe: # ia_s = # ia_exp_z
				local
					s0_failed: BOOLEAN
				do
					if not s0_failed then
						ia_exp_z.make_from_set (ia_s0)
					else
						ia_exp_z.make_from_set (ia_s)
					end
					Result := True
				ensure
					s0: # ia_s0 = # ia_exp_z implies ia_exp_z ≍ ia_s0
					s: # ia_s0 /= # ia_exp_z implies ia_exp_z ≍ ia_s
				rescue
					if not s0_failed then
						s0_failed := True
						retry
					end
					print (ia_exp_z) print (", ")
					print (ia_s0) print (", ")
					print (ia_s) print ('%N')
				end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_z -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				s0 := some_set_a / some_integer
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			s := same_set_a (exp_z)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_z)
				assert ("s0 is not the universe", make_from_set_got_rescued (exp_z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_z ≍ Z)

			s0 := some_set_a
			s := same_set_a (exp_z)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_z)
				assert ("try s0", make_from_set_got_rescued (exp_z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_z ≍ Z)
		end

	test_make_from_numeric_set
			-- Test {STI_INTEGER_UNIVERSE}.make_from_numeric_set.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.make_from_numeric_set"
		local
			exp_z: like Exposed_universe_to_be_tested
			make_from_numeric_set_got_rescued: PREDICATE [like Exposed_universe_to_be_tested, like some_integer_numbers, like some_integer_numbers]
			s0, s: like some_integer_numbers
			chk_ops, chk_tests: BOOLEAN
			n: like some_set.cardinality
		do
			make_from_numeric_set_got_rescued := agent (ia_exp_z: like Exposed_universe_to_be_tested; ia_s0, ia_s: like some_integer_numbers): BOOLEAN
				require
					the_universe: # ia_s = # ia_exp_z
				local
					s0_failed: BOOLEAN
				do
					if not s0_failed then
						ia_exp_z.make_from_numeric_set (ia_s0)
					else
						ia_exp_z.make_from_numeric_set (ia_s)
					end
					Result := True
				ensure
					s0: # ia_s0 = # ia_exp_z implies ia_s0 ≍ ia_exp_z
					s: # ia_s0 /= # ia_exp_z implies ia_s ≍ ia_exp_z
				rescue
					if not s0_failed then
						s0_failed := True
						retry
					end
				end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				create exp_z -- Don't mess up with `Exposed_universe_to_be_tested', which is a once value.
				s0 := some_integer_numbers / some_integer
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			s := same_integer_numbers (exp_z)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_z)
				assert ("s0 is not the universe", make_from_numeric_set_got_rescued (exp_z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_z ≍ Z)

			s0 := some_integer_numbers
			s := same_integer_numbers (exp_z)
			chk_ops := {ISE_RUNTIME}.check_assert (False)
				n := # s
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)
			if n > Max_asserted_elements then
				chk_tests := {ISE_RUNTIME}.check_assert (False)
			end
				assert ("the_universe", # s = # exp_z)
				assert ("try s0", make_from_numeric_set_got_rescued (exp_z, s0, s))
			if chk_tests then
				chk_tests := {ISE_RUNTIME}.check_assert (True)
			end
			assert ("still the universe", exp_z ≍ Z)
		end

	test_make_from_universe
			-- Test {STI_INTEGER_UNIVERSE}.make_from_universe.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.make_from_universe"
		local
			u: like some_integer_universe
		do
			u := some_integer_universe
			assert ("make_from_universe", attached (create {like universe_to_be_tested}.make_from_universe (u)))
			assert ("universe_from_numeric_universe", attached universe_from_numeric_universe (u))
			assert ("universe_from_sti_numeric_universe", attached universe_from_sti_numeric_universe (u))
			assert ("universe_from_universe", attached universe_from_universe (u))
			assert ("universe_from_sti_universe", attached universe_from_sti_universe (u))
			assert ("universe_from_integer_universe", attached universe_from_integer_universe (u))
		end

feature -- Test routines (Primitive)

	test_is_empty
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_empty.
		note
			testing: "covers/{STI_UNIVERSE}.is_empty"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_empty"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_any
			-- Test {STI_INTEGER_UNIVERSE}.any.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.any"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_others
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.others.
			-- Test {STI_ORDERED_NUMERIC_SET}.others.
			-- Test {STI_INTEGER_SET}.others.
			-- Test {STI_INTEGER_UNIVERSE}.others.
		note
			testing: "covers/{STI_SET}.others"
			testing: "covers/{STI_NUMERIC_SET}.others"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.others"
			testing: "covers/{STI_INTEGER_SET}.others"
			testing: "covers/{STI_INTEGER_UNIVERSE}.others"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_eq
			-- Test {STI_INTEGER_SET}.eq.
			-- Test {STI_INTEGER_UNIVERSE}.eq.
		note
			testing: "covers/{STI_INTEGER_SET}.eq"
			testing: "covers/{STI_INTEGER_UNIVERSE}.eq"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Membership)

	test_element_is_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_in.
			-- Test {STI_SET}.element_is_in.
			-- Test {STS_NUMERIC_SET}.element_is_in.
			-- Test {STI_NUMERIC_SET}.element_is_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.element_is_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.element_is_in.
			-- Test {STS_INTEGER_SET}.element_is_in.
			-- Test {STI_INTEGER_SET}.element_is_in.
			-- Test {STS_INTEGER_UNIVERSE}.element_is_in.
			-- Test {STI_INTEGER_UNIVERSE}.element_is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_SET}.element_is_in"
			testing: "covers/{STI_SET}.element_is_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.element_is_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.element_is_in"
			testing: "covers/{STS_INTEGER_SET}.element_is_in"
			testing: "covers/{STI_INTEGER_SET}.element_is_in"
			testing: "covers/{STS_INTEGER_UNIVERSE}.element_is_in"
			testing: "covers/{STI_INTEGER_UNIVERSE}.element_is_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_element_is_not_in
			-- <Precursor>
			-- Test {STS_SET}.element_is_not_in.
			-- Test {STI_SET}.element_is_not_in.
			-- Test {STS_NUMERIC_SET}.element_is_not_in.
			-- Test {STI_NUMERIC_SET}.element_is_not_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.element_is_not_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.element_is_not_in.
			-- Test {STS_INTEGER_SET}.element_is_not_in.
			-- Test {STI_INTEGER_SET}.element_is_not_in.
			-- Test {STS_INTEGER_UNIVERSE}.element_is_not_in.
			-- Test {STI_INTEGER_UNIVERSE}.element_is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_SET}.element_is_not_in"
			testing: "covers/{STI_SET}.element_is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.element_is_not_in"
			testing: "covers/{STS_INTEGER_SET}.element_is_not_in"
			testing: "covers/{STI_INTEGER_SET}.element_is_not_in"
			testing: "covers/{STS_INTEGER_UNIVERSE}.element_is_not_in"
			testing: "covers/{STI_INTEGER_UNIVERSE}.element_is_not_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_in.
			-- Test {STI_NUMERIC_SET}.is_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_in.
			-- Test {STS_INTEGER_SET}.is_in.
			-- Test {STI_INTEGER_SET}.is_in.
			-- Test {STS_UNIVERSE}.is_in.
			-- Test {STI_UNIVERSE}.is_in.
			-- Test {STS_INTEGER_UNIVERSE}.is_in.
			-- Test {STI_INTEGER_UNIVERSE}.is_in.
		note
			testing: "covers/{STS_SET}.is_in"
			testing: "covers/{STI_SET}.is_in"
			testing: "covers/{STS_NUMERIC_SET}.is_in"
			testing: "covers/{STI_NUMERIC_SET}.is_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_in"
			testing: "covers/{STS_INTEGER_SET}.is_in"
			testing: "covers/{STI_INTEGER_SET}.is_in"
			testing: "covers/{STS_UNIVERSE}.is_in"
			testing: "covers/{STI_UNIVERSE}.is_in"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_in"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_not_in
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_in.
			-- Test {STI_NUMERIC_SET}.is_not_in.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_in.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_in.
			-- Test {STS_INTEGER_SET}.is_not_in.
			-- Test {STI_INTEGER_SET}.is_not_in.
			-- Test {STS_UNIVERSE}.is_not_in.
			-- Test {STI_UNIVERSE}.is_not_in.
			-- Test {STS_INTEGER_UNIVERSE}.is_not_in.
			-- Test {STI_INTEGER_UNIVERSE}.is_not_in.
		note
			testing: "covers/{STS_SET}.is_not_in"
			testing: "covers/{STI_SET}.is_not_in"
			testing: "covers/{STS_NUMERIC_SET}.is_not_in"
			testing: "covers/{STI_NUMERIC_SET}.is_not_in"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_in"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_in"
			testing: "covers/{STS_INTEGER_SET}.is_not_in"
			testing: "covers/{STI_INTEGER_SET}.is_not_in"
			testing: "covers/{STS_UNIVERSE}.is_not_in"
			testing: "covers/{STI_UNIVERSE}.is_not_in"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_not_in"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_not_in"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_has
			-- Test {STS_UNIVERSE}.has.
			-- Test {STI_UNIVERSE}.has.
			-- Test {STS_INTEGER_UNIVERSE}.has.
			-- Test {STI_INTEGER_UNIVERSE}.has.
		note
			testing: "covers/{STS_UNIVERSE}.has"
			testing: "covers/{STI_UNIVERSE}.has"
			testing: "covers/{STS_INTEGER_UNIVERSE}.has"
			testing: "covers/{STI_INTEGER_UNIVERSE}.has"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_does_not_have
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_have.
			-- Test {STI_NUMERIC_SET}.does_not_have.
			-- Test {STS_ORDERED_NUMERIC_SET}.does_not_have.
			-- Test {STI_ORDERED_NUMERIC_SET}.does_not_have.
			-- Test {STS_INTEGER_SET}.does_not_have.
			-- Test {STI_INTEGER_SET}.does_not_have.
			-- Test {STS_UNIVERSE}.does_not_have.
			-- Test {STI_UNIVERSE}.does_not_have.
			-- Test {STS_INTEGER_UNIVERSE}.does_not_have.
			-- Test {STI_INTEGER_UNIVERSE}.does_not_have.
		note
			testing: "covers/{STS_SET}.does_not_have"
			testing: "covers/{STI_SET}.does_not_have"
			testing: "covers/{STS_NUMERIC_SET}.does_not_have"
			testing: "covers/{STI_NUMERIC_SET}.does_not_have"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.does_not_have"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.does_not_have"
			testing: "covers/{STS_INTEGER_SET}.does_not_have"
			testing: "covers/{STI_INTEGER_SET}.does_not_have"
			testing: "covers/{STS_UNIVERSE}.does_not_have"
			testing: "covers/{STI_UNIVERSE}.does_not_have"
			testing: "covers/{STS_INTEGER_UNIVERSE}.does_not_have"
			testing: "covers/{STI_INTEGER_UNIVERSE}.does_not_have"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Access)

	test_zero
			-- Test {STI_INTEGER_SET}.Zero.
			-- Test {STI_INTEGER_UNIVERSE}.Zero.
		note
			testing: "covers/{STI_INTEGER_SET}.zero"
			testing: "covers/{STI_INTEGER_UNIVERSE}.zero"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_z
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.z.
		note
			testing: "covers/{STI_INTEGER_SET}.z"
			testing: "covers/{STI_INTEGER_UNIVERSE}.z"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_integer_universe
			-- <Precursor>
			-- Test {STI_INTEGER_SET}.integer_universe.
		note
			testing: "covers/{STI_INTEGER_SET}.integer_universe"
			testing: "covers/{STI_INTEGER_UNIVERSE}.integer_universe"
		do
			Precursor {INTEGER_SET_TESTS}
		end

feature -- Test routines (Construction)

	test_with
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.with.
		note
			testing: "covers/{STI_UNIVERSE}.with"
			testing: "covers/{STI_INTEGER_UNIVERSE}.with"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_without
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.without.
			-- Test {STI_ORDERED_NUMERIC_SET}.without.
			-- Test {STI_INTEGER_SET}.without.
			-- Test {STI_INTEGER_UNIVERSE}.without.
		note
			testing: "covers/{STI_SET}.without"
			testing: "covers/{STI_UNIVERSE}.without"
			testing: "covers/{STI_NUMERIC_SET}.without"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.without"
			testing: "covers/{STI_INTEGER_SET}.without"
			testing: "covers/{STI_INTEGER_UNIVERSE}.without"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_extended
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.extended.
		note
			testing: "covers/{STI_UNIVERSE}.extended"
			testing: "covers/{STI_INTEGER_UNIVERSE}.extended"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_batch_extended
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.batch_extended.
			-- Test {STI_ORDERED_NUMERIC_SET}.batch_extended.
			-- Test {STI_INTEGER_SET}.batch_extended.
			-- Test {STI_INTEGER_UNIVERSE}.batch_extended.
		note
			testing: "covers/{STI_SET}.batch_extended"
			testing: "covers/{STI_NUMERIC_SET}.batch_extended"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.batch_extended"
			testing: "covers/{STI_INTEGER_SET}.batch_extended"
			testing: "covers/{STI_INTEGER_UNIVERSE}.batch_extended"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_numeric_batch_extended
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.numeric_batch_extended.
		note
			testing: "covers/{STI_INTEGER_SET}.numeric_batch_extended"
			testing: "covers/{STI_INTEGER_UNIVERSE}.numeric_batch_extended"
		local
			s0: like some_integer_numbers
			s: like universe_to_be_tested
		do
			s0 := some_integer_numbers.o
			s := universe_to_be_tested

			assert ("s0_is_disjoint_s", s0.is_disjoint (s)) -- s0 = {}
			assert ("s_numeric_batch_extended_s0", attached s.numeric_batch_extended (s0))
			assert ("s_numeric_batch_extended_s0_ok", Properties.numeric_batch_extended_ok (s0, s))

			s0 := some_integer_numbers
			s := universe_to_be_tested
			assert ("numeric_batch_extended", s0.is_disjoint (s) implies attached s.numeric_batch_extended (s0))
			assert ("numeric_batch_extended_ok", Properties.numeric_batch_extended_ok (s0, s))
		end

feature -- Test routines (Output)

	test_out
			-- Test {STI_INTEGER_UNIVERSE}.out.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.out"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Quality)

	test_is_singleton
			-- Test {STI_INTEGER_UNIVERSE}.is_singleton.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_singleton"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Measurement)

	test_cardinality
			-- Test {STI_INTEGER_UNIVERSE}.cardinality.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.cardinality"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_instance_free_cardinality
			-- Test {STI_INTEGER_UNIVERSE}.instance_free_cardinality.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.instance_free_cardinality"
		do
			assert ("instance_free_cardinality", attached (# Universe_to_be_tested))
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.equals.
		note
			testing: "covers/{STI_UNIVERSE}.equals"
			testing: "covers/{STI_INTEGER_UNIVERSE}.equals"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_unequals
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.unequals.
			-- Test {STI_NUMERIC_SET}.unequals.
			-- Test {STS_ORDERED_NUMERIC_SET}.unequals.
			-- Test {STI_ORDERED_NUMERIC_SET}.unequals.
			-- Test {STS_INTEGER_SET}.unequals.
			-- Test {STI_INTEGER_SET}.unequals.
			-- Test {STS_UNIVERSE}.unequals.
			-- Test {STI_UNIVERSE}.unequals.
			-- Test {STS_INTEGER_UNIVERSE}.unequals.
			-- Test {STI_INTEGER_UNIVERSE}.unequals.
		note
			testing: "covers/{STS_SET}.unequals"
			testing: "covers/{STI_SET}.unequals"
			testing: "covers/{STS_NUMERIC_SET}.unequals"
			testing: "covers/{STI_NUMERIC_SET}.unequals"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.unequals"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.unequals"
			testing: "covers/{STS_INTEGER_SET}.unequals"
			testing: "covers/{STI_INTEGER_SET}.unequals"
			testing: "covers/{STS_UNIVERSE}.unequals"
			testing: "covers/{STI_UNIVERSE}.unequals"
			testing: "covers/{STS_INTEGER_UNIVERSE}.unequals"
			testing: "covers/{STI_INTEGER_UNIVERSE}.unequals"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_subset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_subset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_not_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_subset.
			-- Test {STI_NUMERIC_SET}.is_not_subset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_subset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_subset.
			-- Test {STS_INTEGER_SET}.is_not_subset.
			-- Test {STI_INTEGER_SET}.is_not_subset.
			-- Test {STS_UNIVERSE}.is_not_subset.
			-- Test {STI_UNIVERSE}.is_not_subset.
			-- Test {STS_INTEGER_UNIVERSE}.is_not_subset.
			-- Test {STI_INTEGER_UNIVERSE}.is_not_subset.
		note
			testing: "covers/{STS_SET}.is_not_subset"
			testing: "covers/{STI_SET}.is_not_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_subset"
			testing: "covers/{STS_INTEGER_SET}.is_not_subset"
			testing: "covers/{STI_INTEGER_SET}.is_not_subset"
			testing: "covers/{STS_UNIVERSE}.is_not_subset"
			testing: "covers/{STI_UNIVERSE}.is_not_subset"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_not_subset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_not_subset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_superset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_superset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_not_superset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_superset.
			-- Test {STI_NUMERIC_SET}.is_not_superset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_superset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_superset.
			-- Test {STS_INTEGER_SET}.is_not_superset.
			-- Test {STI_INTEGER_SET}.is_not_superset.
			-- Test {STS_INTEGER_UNIVERSE}.is_not_superset.
			-- Test {STI_INTEGER_UNIVERSE}.is_not_superset.
		note
			testing: "covers/{STS_SET}.is_not_superset"
			testing: "covers/{STI_SET}.is_not_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_superset"
			testing: "covers/{STS_INTEGER_SET}.is_not_superset"
			testing: "covers/{STI_INTEGER_SET}.is_not_superset"
			testing: "covers/{STS_UNIVERSE}.is_not_superset"
			testing: "covers/{STI_UNIVERSE}.is_not_superset"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_not_superset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_not_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_comparable
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_comparable.
		note
			testing: "covers/{STI_UNIVERSE}.is_comparable"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_comparable"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_not_comparable
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_not_comparable.
		note
			testing: "covers/{STI_UNIVERSE}.is_not_comparable"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_not_comparable"
		do
			Precursor {UNIVERSE_TESTS}
			assert ("isp_is_not_comparable_ok", properties.isp_is_not_comparable_ok (Universe_to_be_tested, some_set_a))
		end

	test_is_strict_subset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_strict_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_strict_subset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_strict_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_not_strict_subset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_strict_subset.
			-- Test {STS_INTEGER_SET}.is_not_strict_subset.
			-- Test {STI_INTEGER_SET}.is_not_strict_subset.
			-- Test {STS_UNIVERSE}.is_not_strict_subset.
			-- Test {STI_UNIVERSE}.is_not_strict_subset.
			-- Test {STS_INTEGER_UNIVERSE}.is_not_strict_subset.
			-- Test {STI_INTEGER_UNIVERSE}.is_not_strict_subset.
		note
			testing: "covers/{STS_SET}.is_not_strict_subset"
			testing: "covers/{STI_SET}.is_not_strict_subset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_strict_subset"
			testing: "covers/{STS_INTEGER_SET}.is_not_strict_subset"
			testing: "covers/{STI_INTEGER_SET}.is_not_strict_subset"
			testing: "covers/{STS_UNIVERSE}.is_not_strict_subset"
			testing: "covers/{STI_UNIVERSE}.is_not_strict_subset"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_not_strict_subset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_not_strict_subset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_strict_superset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_strict_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_strict_superset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_strict_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_not_strict_superset
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STI_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_not_strict_superset.
			-- Test {STS_INTEGER_SET}.is_not_strict_superset.
			-- Test {STI_INTEGER_SET}.is_not_strict_superset.
			-- Test {STS_INTEGER_UNIVERSE}.is_not_strict_superset.
			-- Test {STI_INTEGER_UNIVERSE}.is_not_strict_superset.
		note
			testing: "covers/{STS_SET}.is_not_strict_superset"
			testing: "covers/{STI_SET}.is_not_strict_superset"
			testing: "covers/{STS_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STI_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_not_strict_superset"
			testing: "covers/{STS_INTEGER_SET}.is_not_strict_superset"
			testing: "covers/{STI_INTEGER_SET}.is_not_strict_superset"
			testing: "covers/{STS_UNIVERSE}.is_not_strict_superset"
			testing: "covers/{STI_UNIVERSE}.is_not_strict_superset"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_not_strict_superset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_not_strict_superset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_trivial_subset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_trivial_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_trivial_subset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_trivial_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_trivial_superset
			-- Test {STI_UNIVERSE}.is_trivial_superset.
			-- Test {STI_INTEGER_UNIVERSE}.is_trivial_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_trivial_superset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_trivial_superset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_is_proper_subset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_proper_subset.
		note
			testing: "covers/{STI_UNIVERSE}.is_proper_subset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_proper_subset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_proper_superset
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_proper_superset.
		note
			testing: "covers/{STI_UNIVERSE}.is_proper_superset"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_proper_superset"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_is_disjoint
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.is_disjoint.
		note
			testing: "covers/{STI_UNIVERSE}.is_disjoint"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_disjoint"
		do
			Precursor {UNIVERSE_TESTS}
			Precursor {INTEGER_SET_TESTS}
		end

	test_intersects
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.intersects.
			-- Test {STI_NUMERIC_SET}.intersects.
			-- Test {STS_ORDERED_NUMERIC_SET}.intersects.
			-- Test {STI_ORDERED_NUMERIC_SET}.intersects.
			-- Test {STS_INTEGER_SET}.intersects.
			-- Test {STI_INTEGER_SET}.intersects.
			-- Test {STS_UNIVERSE}.intersects.
			-- Test {STI_UNIVERSE}.intersects.
			-- Test {STS_INTEGER_UNIVERSE}.intersects.
			-- Test {STI_INTEGER_UNIVERSE}.intersects.
		note
			testing: "covers/{STS_SET}.intersects"
			testing: "covers/{STI_SET}.intersects"
			testing: "covers/{STS_NUMERIC_SET}.intersects"
			testing: "covers/{STI_NUMERIC_SET}.intersects"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.intersects"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.intersects"
			testing: "covers/{STS_INTEGER_SET}.intersects"
			testing: "covers/{STI_INTEGER_SET}.intersects"
			testing: "covers/{STS_UNIVERSE}.intersects"
			testing: "covers/{STI_UNIVERSE}.intersects"
			testing: "covers/{STS_INTEGER_UNIVERSE}.intersects"
			testing: "covers/{STI_INTEGER_UNIVERSE}.intersects"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Relationship)

	test_is_partitioned
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.is_partitioned.
			-- Test {STI_NUMERIC_SET}.is_partitioned.
			-- Test {STS_ORDERED_NUMERIC_SET}.is_partitioned.
			-- Test {STI_ORDERED_NUMERIC_SET}.is_partitioned.
			-- Test {STS_INTEGER_SET}.is_partitioned.
			-- Test {STI_INTEGER_SET}.is_partitioned.
			-- Test {STS_UNIVERSE}.is_partitioned.
			-- Test {STI_UNIVERSE}.is_partitioned.
			-- Test {STS_INTEGER_UNIVERSE}.is_partitioned.
			-- Test {STI_INTEGER_UNIVERSE}.is_partitioned.
		note
			testing: "covers/{STS_SET}.is_partitioned"
			testing: "covers/{STI_SET}.is_partitioned"
			testing: "covers/{STS_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STI_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.is_partitioned"
			testing: "covers/{STS_INTEGER_SET}.is_partitioned"
			testing: "covers/{STI_INTEGER_SET}.is_partitioned"
			testing: "covers/{STS_UNIVERSE}.is_partitioned"
			testing: "covers/{STI_UNIVERSE}.is_partitioned"
			testing: "covers/{STS_INTEGER_UNIVERSE}.is_partitioned"
			testing: "covers/{STI_INTEGER_UNIVERSE}.is_partitioned"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Quantifier)

	test_exists
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists.
			-- Test {STI_INTEGER_SET}.exists.
			-- Test {STI_INTEGER_UNIVERSE}.exists.
		note
			testing: "covers/{STI_SET}.exists"
			testing: "covers/{STI_NUMERIC_SET}.exists"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists"
			testing: "covers/{STI_INTEGER_SET}.exists"
			testing: "covers/{STI_INTEGER_UNIVERSE}.exists"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_does_not_exist
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist.
			-- Test {STI_NUMERIC_SET}.does_not_exist.
			-- Test {STS_ORDERED_NUMERIC_SET}.does_not_exist.
			-- Test {STI_ORDERED_NUMERIC_SET}.does_not_exist.
			-- Test {STS_INTEGER_SET}.does_not_exist.
			-- Test {STI_INTEGER_SET}.does_not_exist.
			-- Test {STS_UNIVERSE}.does_not_exist.
			-- Test {STI_UNIVERSE}.does_not_exist.
			-- Test {STS_INTEGER_UNIVERSE}.does_not_exist.
			-- Test {STI_INTEGER_UNIVERSE}.does_not_exist.
		note
			testing: "covers/{STS_SET}.does_not_exist"
			testing: "covers/{STI_SET}.does_not_exist"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.does_not_exist"
			testing: "covers/{STS_INTEGER_SET}.does_not_exist"
			testing: "covers/{STI_INTEGER_SET}.does_not_exist"
			testing: "covers/{STS_UNIVERSE}.does_not_exist"
			testing: "covers/{STI_UNIVERSE}.does_not_exist"
			testing: "covers/{STS_INTEGER_UNIVERSE}.does_not_exist"
			testing: "covers/{STI_INTEGER_UNIVERSE}.does_not_exist"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_exists_unique
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_unique.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists_unique.
			-- Test {STI_INTEGER_SET}.exists_unique.
			-- Test {STI_INTEGER_UNIVERSE}.exists_unique.
		note
			testing: "covers/{STI_SET}.exists_unique"
			testing: "covers/{STI_NUMERIC_SET}.exists_unique"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists_unique"
			testing: "covers/{STI_INTEGER_SET}.exists_unique"
			testing: "covers/{STI_INTEGER_UNIVERSE}.exists_unique"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_exists_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists_pair.
			-- Test {STI_INTEGER_SET}.exists_pair.
			-- Test {STI_INTEGER_UNIVERSE}.exists_pair.
		note
			testing: "covers/{STI_SET}.exists_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists_pair"
			testing: "covers/{STI_INTEGER_SET}.exists_pair"
			testing: "covers/{STI_INTEGER_UNIVERSE}.exists_pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_does_not_exist_pair
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STI_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STS_ORDERED_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.does_not_exist_pair.
			-- Test {STS_INTEGER_SET}.does_not_exist_pair.
			-- Test {STI_INTEGER_SET}.does_not_exist_pair.
			-- Test {STS_UNIVERSE}.does_not_exist_pair.
			-- Test {STI_UNIVERSE}.does_not_exist_pair.
			-- Test {STS_INTEGER_UNIVERSE}.does_not_exist_pair.
			-- Test {STI_INTEGER_UNIVERSE}.does_not_exist_pair.
		note
			testing: "covers/{STS_SET}.does_not_exist_pair"
			testing: "covers/{STI_SET}.does_not_exist_pair"
			testing: "covers/{STS_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STI_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.does_not_exist_pair"
			testing: "covers/{STS_INTEGER_SET}.does_not_exist_pair"
			testing: "covers/{STI_INTEGER_SET}.does_not_exist_pair"
			testing: "covers/{STS_UNIVERSE}.does_not_exist_pair"
			testing: "covers/{STI_UNIVERSE}.does_not_exist_pair"
			testing: "covers/{STS_INTEGER_UNIVERSE}.does_not_exist_pair"
			testing: "covers/{STI_INTEGER_UNIVERSE}.does_not_exist_pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_exists_distinct_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.exists_distinct_pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.exists_distinct_pair.
			-- Test {STI_INTEGER_SET}.exists_distinct_pair.
			-- Test {STI_INTEGER_UNIVERSE}.exists_distinct_pair.
		note
			testing: "covers/{STI_SET}.exists_distinct_pair"
			testing: "covers/{STI_NUMERIC_SET}.exists_distinct_pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.exists_distinct_pair"
			testing: "covers/{STI_INTEGER_SET}.exists_distinct_pair"
			testing: "covers/{STI_INTEGER_UNIVERSE}.exists_distinct_pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_for_all
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all.
			-- Test {STI_ORDERED_NUMERIC_SET}.for_all.
			-- Test {STI_INTEGER_SET}.for_all.
			-- Test {STI_INTEGER_UNIVERSE}.for_all.
		note
			testing: "covers/{STI_SET}.for_all"
			testing: "covers/{STI_NUMERIC_SET}.for_all"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.for_all"
			testing: "covers/{STI_INTEGER_SET}.for_all"
			testing: "covers/{STI_INTEGER_UNIVERSE}.for_all"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_for_all_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_pairs.
			-- Test {STI_ORDERED_NUMERIC_SET}.for_all_pairs.
			-- Test {STI_INTEGER_SET}.for_all_pairs.
			-- Test {STI_INTEGER_UNIVERSE}.for_all_pairs.
		note
			testing: "covers/{STI_SET}.for_all_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_pairs"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.for_all_pairs"
			testing: "covers/{STI_INTEGER_SET}.for_all_pairs"
			testing: "covers/{STI_INTEGER_UNIVERSE}.for_all_pairs"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_for_all_distinct_pairs
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.for_all_distinct_pairs.
			-- Test {STI_ORDERED_NUMERIC_SET}.for_all_distinct_pairs.
			-- Test {STI_INTEGER_SET}.for_all_distinct_pairs.
			-- Test {STI_INTEGER_UNIVERSE}.for_all_distinct_pairs.
		note
			testing: "covers/{STI_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_NUMERIC_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_INTEGER_SET}.for_all_distinct_pairs"
			testing: "covers/{STI_INTEGER_UNIVERSE}.for_all_distinct_pairs"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Restriction)

	test_without_zero
			-- Test {STI_INTEGER_UNIVERSE}.without_zero.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.without_zero"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_non_positive
			-- Test {STI_INTEGER_UNIVERSE}.non_positive.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.non_positive"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_non_negative
			-- Test {STI_INTEGER_UNIVERSE}.non_negative.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.non_negative"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_negative
			-- Test {STI_INTEGER_UNIVERSE}.negative.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.negative"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_positive
			-- Test {STI_INTEGER_UNIVERSE}.positive.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.positive"
		do
			Precursor {INTEGER_SET_TESTS}
		end

feature -- Test routines (Interval)

	test_closed_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.closed_interval.
			-- Test {STI_INTEGER_UNIVERSE}.closed_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.closed_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.closed_interval"
			testing: "covers/{STS_INTEGER_SET}.closed_interval"
			testing: "covers/{STI_INTEGER_SET}.closed_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.closed_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.closed_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_left_closed_right_open_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.left_closed_right_open_interval.
			-- Test {STI_INTEGER_UNIVERSE}.left_closed_right_open_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_closed_right_open_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_closed_right_open_interval"
			testing: "covers/{STS_INTEGER_SET}.left_closed_right_open_interval"
			testing: "covers/{STI_INTEGER_SET}.left_closed_right_open_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.left_closed_right_open_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.left_closed_right_open_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_left_open_right_closed_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.left_open_right_closed_interval.
			-- Test {STI_INTEGER_UNIVERSE}.left_open_right_closed_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_open_right_closed_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_open_right_closed_interval"
			testing: "covers/{STS_INTEGER_SET}.left_open_right_closed_interval"
			testing: "covers/{STI_INTEGER_SET}.left_open_right_closed_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.left_open_right_closed_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.left_open_right_closed_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_open_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.open_interval.
			-- Test {STI_INTEGER_UNIVERSE}.open_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.open_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.open_interval"
			testing: "covers/{STS_INTEGER_SET}.open_interval"
			testing: "covers/{STI_INTEGER_SET}.open_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.open_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.open_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_left_closed_right_unbounded_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.left_closed_right_unbounded_interval.
			-- Test {STI_INTEGER_UNIVERSE}.left_closed_right_unbounded_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STS_INTEGER_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STI_INTEGER_SET}.left_closed_right_unbounded_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.left_closed_right_unbounded_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.left_closed_right_unbounded_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_left_open_right_unbounded_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.left_open_right_unbounded_interval.
			-- Test {STI_INTEGER_UNIVERSE}.left_open_right_unbounded_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STS_INTEGER_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STI_INTEGER_SET}.left_open_right_unbounded_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.left_open_right_unbounded_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.left_open_right_unbounded_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_left_unbounded_right_closed_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.left_unbounded_right_closed_interval.
			-- Test {STI_INTEGER_UNIVERSE}.left_unbounded_right_closed_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STS_INTEGER_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STI_INTEGER_SET}.left_unbounded_right_closed_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.left_unbounded_right_closed_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.left_unbounded_right_closed_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_left_unbounded_right_open_interval
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.left_unbounded_right_open_interval.
			-- Test {STI_INTEGER_UNIVERSE}.left_unbounded_right_open_interval.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STS_INTEGER_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STI_INTEGER_SET}.left_unbounded_right_open_interval"
			testing: "covers/{STS_INTEGER_UNIVERSE}.left_unbounded_right_open_interval"
			testing: "covers/{STI_INTEGER_UNIVERSE}.left_unbounded_right_open_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_unbounded_interval
			-- Test {STI_INTEGER_UNIVERSE}.unbounded_interval.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.unbounded_interval"
		do
			Precursor {INTEGER_SET_TESTS}
		end

feature -- Test routines (Element comparison)

	test_min
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.min.
			-- Test {STI_INTEGER_UNIVERSE}.min.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.min"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.min"
			testing: "covers/{STS_INTEGER_SET}.min"
			testing: "covers/{STI_INTEGER_SET}.min"
			testing: "covers/{STS_INTEGER_UNIVERSE}.min"
			testing: "covers/{STI_INTEGER_UNIVERSE}.min"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_max
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.max.
			-- Test {STI_INTEGER_UNIVERSE}.max.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.max"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.max"
			testing: "covers/{STS_INTEGER_SET}.max"
			testing: "covers/{STI_INTEGER_SET}.max"
			testing: "covers/{STS_INTEGER_UNIVERSE}.max"
			testing: "covers/{STI_INTEGER_UNIVERSE}.max"
		do
			Precursor {INTEGER_SET_TESTS}
		end

feature -- Test routines (Operation)

	test_subsets
			-- Test {STI_INTEGER_UNIVERSE}.subsets.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.subsets"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_powerset
			-- Test {STI_INTEGER_UNIVERSE}.powerset.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.powerset"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_trivial_subsets
			-- Test {STI_INTEGER_UNIVERSE}.trivial_subsets.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.trivial_subsets"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_proper_subsets
			-- Test {STI_INTEGER_UNIVERSE}.proper_subsets.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.proper_subsets"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_filtered
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.filtered.
			-- Test {STI_ORDERED_NUMERIC_SET}.filtered.
			-- Test {STI_INTEGER_SET}.filtered.
			-- Test {STI_INTEGER_UNIVERSE}.filtered.
		note
			testing: "covers/{STI_SET}.filtered"
			testing: "covers/{STI_NUMERIC_SET}.filtered"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.filtered"
			testing: "covers/{STI_INTEGER_SET}.filtered"
			testing: "covers/{STI_INTEGER_UNIVERSE}.filtered"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_complemented
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.complemented.
		note
			testing: "covers/{STI_UNIVERSE}.complemented"
			testing: "covers/{STI_INTEGER_UNIVERSE}.complemented"
		do
			Precursor {INTEGER_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_complement
			-- Test {STI_INTEGER_UNIVERSE}.complement.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.complement"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_united
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.united.
		note
			testing: "covers/{STI_UNIVERSE}.united"
			testing: "covers/{STI_INTEGER_UNIVERSE}.united"
		do
			Precursor {INTEGER_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_intersected
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.intersected.
		note
			testing: "covers/{STI_UNIVERSE}.intersected"
			testing: "covers/{STI_INTEGER_UNIVERSE}.intersected"
		do
			Precursor {INTEGER_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_subtracted
			-- Test {STI_NUMERIC_SET}.subtracted.
			-- Test {STI_ORDERED_NUMERIC_SET}.subtracted.
			-- Test {STI_INTEGER_SET}.subtracted.
			-- Test {STI_INTEGER_UNIVERSE}.subtracted.
		note
			testing: "covers/{STI_NUMERIC_SET}.subtracted"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.subtracted"
			testing: "covers/{STI_INTEGER_SET}.subtracted"
			testing: "covers/{STI_INTEGER_UNIVERSE}.subtracted"
		do
			Precursor {INTEGER_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_subtracted_symmetricaly
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.subtracted_symmetricaly.
		note
			testing: "covers/{STI_UNIVERSE}.subtracted_symmetricaly"
			testing: "covers/{STI_INTEGER_UNIVERSE}.subtracted_symmetricaly"
		do
			Precursor {INTEGER_SET_TESTS}
			Precursor {UNIVERSE_TESTS}
		end

	test_crossed
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.crossed.
			-- Test {STI_NUMERIC_SET}.crossed.
			-- Test {STS_ORDERED_NUMERIC_SET}.crossed.
			-- Test {STI_ORDERED_NUMERIC_SET}.crossed.
			-- Test {STS_INTEGER_SET}.crossed.
			-- Test {STI_INTEGER_SET}.crossed.
			-- Test {STS_UNIVERSE}.crossed.
			-- Test {STI_UNIVERSE}.crossed.
			-- Test {STS_INTEGER_UNIVERSE}.crossed.
			-- Test {STI_INTEGER_UNIVERSE}.crossed.
		note
			testing: "covers/{STS_SET}.crossed"
			testing: "covers/{STI_SET}.crossed"
			testing: "covers/{STS_NUMERIC_SET}.crossed"
			testing: "covers/{STI_NUMERIC_SET}.crossed"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.crossed"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.crossed"
			testing: "covers/{STS_INTEGER_SET}.crossed"
			testing: "covers/{STI_INTEGER_SET}.crossed"
			testing: "covers/{STS_UNIVERSE}.crossed"
			testing: "covers/{STI_UNIVERSE}.crossed"
			testing: "covers/{STS_INTEGER_UNIVERSE}.crossed"
			testing: "covers/{STI_INTEGER_UNIVERSE}.crossed"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_squared
			-- Test {STI_INTEGER_UNIVERSE}.squared.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.squared"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_diagonal
			-- Test {STI_INTEGER_UNIVERSE}.diagonal.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.diagonal"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_raised
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.raised.
			-- Test {STI_NUMERIC_SET}.raised.
			-- Test {STS_ORDERED_NUMERIC_SET}.raised.
			-- Test {STI_ORDERED_NUMERIC_SET}.raised.
			-- Test {STS_INTEGER_SET}.raised.
			-- Test {STI_INTEGER_SET}.raised.
			-- Test {STS_UNIVERSE}.raised.
			-- Test {STI_UNIVERSE}.raised.
			-- Test {STS_INTEGER_UNIVERSE}.raised.
			-- Test {STI_INTEGER_UNIVERSE}.raised.
		note
			testing: "covers/{STS_SET}.raised"
			testing: "covers/{STI_SET}.raised"
			testing: "covers/{STS_NUMERIC_SET}.raised"
			testing: "covers/{STI_NUMERIC_SET}.raised"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.raised"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.raised"
			testing: "covers/{STS_INTEGER_SET}.raised"
			testing: "covers/{STI_INTEGER_SET}.raised"
			testing: "covers/{STS_UNIVERSE}.raised"
			testing: "covers/{STI_UNIVERSE}.raised"
			testing: "covers/{STS_INTEGER_UNIVERSE}.raised"
			testing: "covers/{STI_INTEGER_UNIVERSE}.raised"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.crossed_tuples.
			-- Test {STI_ORDERED_NUMERIC_SET}.crossed_tuples.
			-- Test {STI_INTEGER_SET}.crossed_tuples.
			-- Test {STI_INTEGER_UNIVERSE}.crossed_tuples.
		note
			testing: "covers/{STI_SET}.crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.crossed_tuples"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.crossed_tuples"
			testing: "covers/{STI_INTEGER_SET}.crossed_tuples"
			testing: "covers/{STI_INTEGER_UNIVERSE}.crossed_tuples"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_singleton_crossed_tuples
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.singleton_crossed_tuples.
			-- Test {STI_ORDERED_NUMERIC_SET}.singleton_crossed_tuples.
			-- Test {STI_INTEGER_SET}.singleton_crossed_tuples.
			-- Test {STI_INTEGER_UNIVERSE}.singleton_crossed_tuples.
		note
			testing: "covers/{STI_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_NUMERIC_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_INTEGER_SET}.singleton_crossed_tuples"
			testing: "covers/{STI_INTEGER_UNIVERSE}.singleton_crossed_tuples"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Transformation)

	test_mapped
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.mapped.
			-- Test {STI_NUMERIC_SET}.mapped.
			-- Test {STS_ORDERED_NUMERIC_SET}.mapped.
			-- Test {STI_ORDERED_NUMERIC_SET}.mapped.
			-- Test {STS_INTEGER_SET}.mapped.
			-- Test {STI_INTEGER_SET}.mapped.
			-- Test {STS_UNIVERSE}.mapped.
			-- Test {STI_UNIVERSE}.mapped.
			-- Test {STS_INTEGER_UNIVERSE}.mapped.
			-- Test {STI_INTEGER_UNIVERSE}.mapped.
		note
			testing: "covers/{STS_SET}.mapped"
			testing: "covers/{STI_SET}.mapped"
			testing: "covers/{STS_NUMERIC_SET}.mapped"
			testing: "covers/{STI_NUMERIC_SET}.mapped"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.mapped"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.mapped"
			testing: "covers/{STS_INTEGER_SET}.mapped"
			testing: "covers/{STI_INTEGER_SET}.mapped"
			testing: "covers/{STS_UNIVERSE}.mapped"
			testing: "covers/{STI_UNIVERSE}.mapped"
			testing: "covers/{STS_INTEGER_UNIVERSE}.mapped"
			testing: "covers/{STI_INTEGER_UNIVERSE}.mapped"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.reduced.
			-- Test {STI_NUMERIC_SET}.reduced.
			-- Test {STS_ORDERED_NUMERIC_SET}.reduced.
			-- Test {STI_ORDERED_NUMERIC_SET}.reduced.
			-- Test {STS_INTEGER_SET}.reduced.
			-- Test {STI_INTEGER_SET}.reduced.
			-- Test {STS_UNIVERSE}.reduced.
			-- Test {STI_UNIVERSE}.reduced.
			-- Test {STS_INTEGER_UNIVERSE}.reduced.
			-- Test {STI_INTEGER_UNIVERSE}.reduced.
		note
			testing: "covers/{STS_SET}.reduced"
			testing: "covers/{STI_SET}.reduced"
			testing: "covers/{STS_NUMERIC_SET}.reduced"
			testing: "covers/{STI_NUMERIC_SET}.reduced"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.reduced"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.reduced"
			testing: "covers/{STS_INTEGER_SET}.reduced"
			testing: "covers/{STI_INTEGER_SET}.reduced"
			testing: "covers/{STS_UNIVERSE}.reduced"
			testing: "covers/{STI_UNIVERSE}.reduced"
			testing: "covers/{STS_INTEGER_UNIVERSE}.reduced"
			testing: "covers/{STI_INTEGER_UNIVERSE}.reduced"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_proper_reduced
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.proper_reduced.
			-- Test {STI_NUMERIC_SET}.proper_reduced.
			-- Test {STS_ORDERED_NUMERIC_SET}.proper_reduced.
			-- Test {STI_ORDERED_NUMERIC_SET}.proper_reduced.
			-- Test {STS_INTEGER_SET}.proper_reduced.
			-- Test {STI_INTEGER_SET}.proper_reduced.
			-- Test {STS_UNIVERSE}.proper_reduced.
			-- Test {STI_UNIVERSE}.proper_reduced.
			-- Test {STS_INTEGER_UNIVERSE}.proper_reduced.
			-- Test {STI_INTEGER_UNIVERSE}.proper_reduced.
		note
			testing: "covers/{STS_SET}.proper_reduced"
			testing: "covers/{STI_SET}.proper_reduced"
			testing: "covers/{STS_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STI_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.proper_reduced"
			testing: "covers/{STS_INTEGER_SET}.proper_reduced"
			testing: "covers/{STI_INTEGER_SET}.proper_reduced"
			testing: "covers/{STS_UNIVERSE}.proper_reduced"
			testing: "covers/{STI_UNIVERSE}.proper_reduced"
			testing: "covers/{STS_INTEGER_UNIVERSE}.proper_reduced"
			testing: "covers/{STI_INTEGER_UNIVERSE}.proper_reduced"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Conversion)

	test_natural_as_integer
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.natural_as_integer.
			-- Test {STI_ORDERED_NUMERIC_SET}.natural_as_integer.
			-- Test {STI_INTEGER_SET}.natural_as_integer.
			-- Test {STI_INTEGER_UNIVERSE}.natural_as_integer.
		note
			testing: "covers/{STI_SET}.natural_as_integer"
			testing: "covers/{STI_NUMERIC_SET}.natural_as_integer"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.natural_as_integer"
			testing: "covers/{STI_INTEGER_SET}.natural_as_integer"
			testing: "covers/{STI_INTEGER_UNIVERSE}.natural_as_integer"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_as_singleton
			-- Test {STI_INTEGER_UNIVERSE}.as_singleton.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.as_singleton"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_n_times
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.n_times.
			-- Test {STI_ORDERED_NUMERIC_SET}.n_times.
			-- Test {STI_INTEGER_SET}.n_times.
			-- Test {STI_INTEGER_UNIVERSE}.n_times.
		note
			testing: "covers/{STI_SET}.n_times"
			testing: "covers/{STI_NUMERIC_SET}.n_times"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.n_times"
			testing: "covers/{STI_INTEGER_SET}.n_times"
			testing: "covers/{STI_INTEGER_UNIVERSE}.n_times"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_as_tuple
			-- Test {STI_INTEGER_UNIVERSE}.as_tuple.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.as_tuple"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_as_complex_set
			-- Test {STI_INTEGER_SET}.as_complex_set.
			-- Test {STI_INTEGER_UNIVERSE}.as_complex_set.
		note
			testing: "covers/{STI_INTEGER_SET}.as_complex_set"
			testing: "covers/{STI_INTEGER_UNIVERSE}.as_complex_set"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_as_real_set
			-- Test {STI_INTEGER_SET}.as_real_set.
			-- Test {STI_INTEGER_UNIVERSE}.as_real_set.
		note
			testing: "covers/{STI_INTEGER_SET}.as_real_set"
			testing: "covers/{STI_INTEGER_UNIVERSE}.as_real_set"
		do
			Precursor {INTEGER_SET_TESTS}
		end

feature -- Test routines (Factory)

	test_o
			-- Test {STI_INTEGER_SET}.o.
			-- Test {STI_INTEGER_UNIVERSE}.o.
		note
			testing: "covers/{STI_INTEGER_SET}.o"
			testing: "covers/{STI_INTEGER_UNIVERSE}.o"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_empty_set
			-- Test {STI_INTEGER_SET}.empty_set.
			-- Test {STI_INTEGER_UNIVERSE}.empty_set.
		note
			testing: "covers/{STI_INTEGER_SET}.empty_set"
			testing: "covers/{STI_INTEGER_UNIVERSE}.empty_set"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_singleton
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.singleton.
			-- Test {STI_ORDERED_NUMERIC_SET}.singleton.
			-- Test {STI_INTEGER_SET}.singleton.
			-- Test {STI_INTEGER_UNIVERSE}.singleton.
		note
			testing: "covers/{STI_SET}.singleton"
			testing: "covers/{STI_NUMERIC_SET}.singleton"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.singleton"
			testing: "covers/{STI_INTEGER_SET}.singleton"
			testing: "covers/{STI_INTEGER_UNIVERSE}.singleton"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_pair
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.pair.
			-- Test {STI_ORDERED_NUMERIC_SET}.pair.
			-- Test {STI_INTEGER_SET}.pair.
			-- Test {STI_INTEGER_UNIVERSE}.pair.
		note
			testing: "covers/{STI_SET}.pair"
			testing: "covers/{STI_NUMERIC_SET}.pair"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.pair"
			testing: "covers/{STI_INTEGER_SET}.pair"
			testing: "covers/{STI_INTEGER_UNIVERSE}.pair"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_converted
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.converted.
			-- Test {STI_ORDERED_NUMERIC_SET}.converted.
			-- Test {STI_INTEGER_SET}.converted.
			-- Test {STI_INTEGER_UNIVERSE}.converted.
		note
			testing: "covers/{STI_SET}.converted"
			testing: "covers/{STI_NUMERIC_SET}.converted"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.converted"
			testing: "covers/{STI_INTEGER_SET}.converted"
			testing: "covers/{STI_INTEGER_UNIVERSE}.converted"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_numeric_converted
			-- <Precursor>
			-- Test {STI_INTEGER_UNIVERSE}.numeric_converted.
		note
			testing: "covers/{STI_INTEGER_SET}.numeric_converted"
			testing: "covers/{STI_INTEGER_UNIVERSE}.numeric_converted"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_converted_element
			-- Test {STI_INTEGER_SET}.converted_element.
			-- Test {STI_INTEGER_UNIVERSE}.converted_element.
		note
			testing: "covers/{STI_INTEGER_SET}.converted_element"
			testing: "covers/{STI_INTEGER_UNIVERSE}.converted_element"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_unit
			-- Test {STI_INTEGER_SET}.unit.
			-- Test {STI_INTEGER_UNIVERSE}.unit.
		note
			testing: "covers/{STI_INTEGER_SET}.unit"
			testing: "covers/{STI_INTEGER_UNIVERSE}.unit"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Predicate)

	test_ored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.ored.
			-- Test {STI_NUMERIC_SET}.ored.
			-- Test {STS_ORDERED_NUMERIC_SET}.ored.
			-- Test {STI_ORDERED_NUMERIC_SET}.ored.
			-- Test {STS_INTEGER_SET}.ored.
			-- Test {STI_INTEGER_SET}.ored.
			-- Test {STS_UNIVERSE}.ored.
			-- Test {STI_UNIVERSE}.ored.
			-- Test {STS_INTEGER_UNIVERSE}.ored.
			-- Test {STI_INTEGER_UNIVERSE}.ored.
		note
			testing: "covers/{STS_SET}.ored"
			testing: "covers/{STI_SET}.ored"
			testing: "covers/{STS_NUMERIC_SET}.ored"
			testing: "covers/{STI_NUMERIC_SET}.ored"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.ored"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.ored"
			testing: "covers/{STS_INTEGER_SET}.ored"
			testing: "covers/{STI_INTEGER_SET}.ored"
			testing: "covers/{STS_UNIVERSE}.ored"
			testing: "covers/{STI_UNIVERSE}.ored"
			testing: "covers/{STS_INTEGER_UNIVERSE}.ored"
			testing: "covers/{STI_INTEGER_UNIVERSE}.ored"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_xored
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.xored.
			-- Test {STI_NUMERIC_SET}.xored.
			-- Test {STS_ORDERED_NUMERIC_SET}.xored.
			-- Test {STI_ORDERED_NUMERIC_SET}.xored.
			-- Test {STS_INTEGER_SET}.xored.
			-- Test {STI_INTEGER_SET}.xored.
			-- Test {STS_UNIVERSE}.xored.
			-- Test {STI_UNIVERSE}.xored.
			-- Test {STS_INTEGER_UNIVERSE}.xored.
			-- Test {STI_INTEGER_UNIVERSE}.xored.
		note
			testing: "covers/{STS_SET}.xored"
			testing: "covers/{STI_SET}.xored"
			testing: "covers/{STS_NUMERIC_SET}.xored"
			testing: "covers/{STI_NUMERIC_SET}.xored"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.xored"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.xored"
			testing: "covers/{STS_INTEGER_SET}.xored"
			testing: "covers/{STI_INTEGER_SET}.xored"
			testing: "covers/{STS_UNIVERSE}.xored"
			testing: "covers/{STI_UNIVERSE}.xored"
			testing: "covers/{STS_INTEGER_UNIVERSE}.xored"
			testing: "covers/{STI_INTEGER_UNIVERSE}.xored"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_iff
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.iff.
			-- Test {STI_NUMERIC_SET}.iff.
			-- Test {STS_ORDERED_NUMERIC_SET}.iff.
			-- Test {STI_ORDERED_NUMERIC_SET}.iff.
			-- Test {STS_INTEGER_SET}.iff.
			-- Test {STI_INTEGER_SET}.iff.
			-- Test {STS_UNIVERSE}.iff.
			-- Test {STI_UNIVERSE}.iff.
			-- Test {STS_INTEGER_UNIVERSE}.iff.
			-- Test {STI_INTEGER_UNIVERSE}.iff.
		note
			testing: "covers/{STS_SET}.iff"
			testing: "covers/{STI_SET}.iff"
			testing: "covers/{STS_NUMERIC_SET}.iff"
			testing: "covers/{STI_NUMERIC_SET}.iff"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.iff"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.iff"
			testing: "covers/{STS_INTEGER_SET}.iff"
			testing: "covers/{STI_INTEGER_SET}.iff"
			testing: "covers/{STS_UNIVERSE}.iff"
			testing: "covers/{STI_UNIVERSE}.iff"
			testing: "covers/{STS_INTEGER_UNIVERSE}.iff"
			testing: "covers/{STI_INTEGER_UNIVERSE}.iff"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_equality_holds
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.equality_holds.
			-- Test {STI_ORDERED_NUMERIC_SET}.equality_holds.
			-- Test {STI_INTEGER_SET}.equality_holds.
			-- Test {STI_INTEGER_UNIVERSE}.equality_holds.
		note
			testing: "covers/{STI_SET}.equality_holds"
			testing: "covers/{STI_NUMERIC_SET}.equality_holds"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.equality_holds"
			testing: "covers/{STI_INTEGER_SET}.equality_holds"
			testing: "covers/{STI_INTEGER_UNIVERSE}.equality_holds"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_subset_relation_holds
			-- <Precursor>
			-- Test {STI_NUMERIC_SET}.subset_relation_holds.
			-- Test {STI_ORDERED_NUMERIC_SET}.subset_relation_holds.
			-- Test {STI_INTEGER_SET}.subset_relation_holds.
			-- Test {STI_INTEGER_UNIVERSE}.subset_relation_holds.
		note
			testing: "covers/{STI_SET}.subset_relation_holds"
			testing: "covers/{STI_NUMERIC_SET}.subset_relation_holds"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.subset_relation_holds"
			testing: "covers/{STI_INTEGER_SET}.subset_relation_holds"
			testing: "covers/{STI_INTEGER_UNIVERSE}.subset_relation_holds"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_anded
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.anded.
			-- Test {STI_INTEGER_UNIVERSE}.anded.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.anded"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.anded"
			testing: "covers/{STS_INTEGER_SET}.anded"
			testing: "covers/{STI_INTEGER_SET}.anded"
			testing: "covers/{STS_INTEGER_UNIVERSE}.anded"
			testing: "covers/{STI_INTEGER_UNIVERSE}.anded"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_number_is_less
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.number_is_less.
			-- Test {STI_INTEGER_UNIVERSE}.number_is_less.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.number_is_less"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.number_is_less"
			testing: "covers/{STS_INTEGER_SET}.number_is_less"
			testing: "covers/{STI_INTEGER_SET}.number_is_less"
			testing: "covers/{STS_INTEGER_UNIVERSE}.number_is_less"
			testing: "covers/{STI_INTEGER_UNIVERSE}.number_is_less"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_number_is_less_equal
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.number_is_less_equal.
			-- Test {STI_INTEGER_UNIVERSE}.number_is_less_equal.
		note
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.number_is_less_equal"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.number_is_less_equal"
			testing: "covers/{STS_INTEGER_SET}.number_is_less_equal"
			testing: "covers/{STI_INTEGER_SET}.number_is_less_equal"
			testing: "covers/{STS_INTEGER_UNIVERSE}.number_is_less_equal"
			testing: "covers/{STI_INTEGER_UNIVERSE}.number_is_less_equal"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_complex_set_has_integer_number
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.complex_set_has_integer_number.
			-- Test {STI_INTEGER_UNIVERSE}.complex_set_has_integer_number.
		note
			testing: "covers/{STS_INTEGER_SET}.complex_set_has_integer_number"
			testing: "covers/{STI_INTEGER_SET}.complex_set_has_integer_number"
			testing: "covers/{STS_INTEGER_UNIVERSE}.complex_set_has_integer_number"
			testing: "covers/{STI_INTEGER_UNIVERSE}.complex_set_has_integer_number"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_has_complex_number
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.has_complex_number.
			-- Test {STI_INTEGER_UNIVERSE}.has_complex_number.
		note
			testing: "covers/{STS_INTEGER_SET}.has_complex_number"
			testing: "covers/{STI_INTEGER_SET}.has_complex_number"
			testing: "covers/{STS_INTEGER_UNIVERSE}.has_complex_number"
			testing: "covers/{STI_INTEGER_UNIVERSE}.has_complex_number"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_real_set_has_integer_number
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.real_set_has_integer_number.
			-- Test {STI_INTEGER_UNIVERSE}.real_set_has_integer_number.
		note
			testing: "covers/{STS_INTEGER_SET}.real_set_has_integer_number"
			testing: "covers/{STI_INTEGER_SET}.real_set_has_integer_number"
			testing: "covers/{STS_INTEGER_UNIVERSE}.real_set_has_integer_number"
			testing: "covers/{STI_INTEGER_UNIVERSE}.real_set_has_integer_number"
		do
			Precursor {INTEGER_SET_TESTS}
		end

	test_has_real_number
			-- <Precursor>
			-- Test {STS_INTEGER_UNIVERSE}.has_real_number.
			-- Test {STI_INTEGER_UNIVERSE}.has_real_number.
		note
			testing: "covers/{STS_INTEGER_SET}.has_real_number"
			testing: "covers/{STI_INTEGER_SET}.has_real_number"
			testing: "covers/{STS_INTEGER_UNIVERSE}.has_real_number"
			testing: "covers/{STI_INTEGER_UNIVERSE}.has_real_number"
		do
			Precursor {INTEGER_SET_TESTS}
		end

feature -- Test routines (Mapping)

	test_second_after_first
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.second_after_first.
			-- Test {STI_NUMERIC_SET}.second_after_first.
			-- Test {STS_ORDERED_NUMERIC_SET}.second_after_first.
			-- Test {STI_ORDERED_NUMERIC_SET}.second_after_first.
			-- Test {STS_INTEGER_SET}.second_after_first.
			-- Test {STI_INTEGER_SET}.second_after_first.
			-- Test {STS_UNIVERSE}.second_after_first.
			-- Test {STI_UNIVERSE}.second_after_first.
			-- Test {STS_INTEGER_UNIVERSE}.second_after_first.
			-- Test {STI_INTEGER_UNIVERSE}.second_after_first.
		note
			testing: "covers/{STS_SET}.second_after_first"
			testing: "covers/{STI_SET}.second_after_first"
			testing: "covers/{STS_NUMERIC_SET}.second_after_first"
			testing: "covers/{STI_NUMERIC_SET}.second_after_first"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.second_after_first"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.second_after_first"
			testing: "covers/{STS_INTEGER_SET}.second_after_first"
			testing: "covers/{STI_INTEGER_SET}.second_after_first"
			testing: "covers/{STS_UNIVERSE}.second_after_first"
			testing: "covers/{STI_UNIVERSE}.second_after_first"
			testing: "covers/{STS_INTEGER_UNIVERSE}.second_after_first"
			testing: "covers/{STI_INTEGER_UNIVERSE}.second_after_first"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Reduction)

	test_natural_successor
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.natural_successor.
			-- Test {STI_NUMERIC_SET}.natural_successor.
			-- Test {STS_ORDERED_NUMERIC_SET}.natural_successor.
			-- Test {STI_ORDERED_NUMERIC_SET}.natural_successor.
			-- Test {STS_INTEGER_SET}.natural_successor.
			-- Test {STI_INTEGER_SET}.natural_successor.
			-- Test {STS_UNIVERSE}.natural_successor.
			-- Test {STI_UNIVERSE}.natural_successor.
			-- Test {STS_INTEGER_UNIVERSE}.natural_successor.
			-- Test {STI_INTEGER_UNIVERSE}.natural_successor.
		note
			testing: "covers/{STS_SET}.natural_successor"
			testing: "covers/{STI_SET}.natural_successor"
			testing: "covers/{STS_NUMERIC_SET}.natural_successor"
			testing: "covers/{STI_NUMERIC_SET}.natural_successor"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.natural_successor"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.natural_successor"
			testing: "covers/{STS_INTEGER_SET}.natural_successor"
			testing: "covers/{STI_INTEGER_SET}.natural_successor"
			testing: "covers/{STS_UNIVERSE}.natural_successor"
			testing: "covers/{STI_UNIVERSE}.natural_successor"
			testing: "covers/{STS_INTEGER_UNIVERSE}.natural_successor"
			testing: "covers/{STI_INTEGER_UNIVERSE}.natural_successor"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_disjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.disjunction.
			-- Test {STI_NUMERIC_SET}.disjunction.
			-- Test {STS_ORDERED_NUMERIC_SET}.disjunction.
			-- Test {STI_ORDERED_NUMERIC_SET}.disjunction.
			-- Test {STS_INTEGER_SET}.disjunction.
			-- Test {STI_INTEGER_SET}.disjunction.
			-- Test {STS_UNIVERSE}.disjunction.
			-- Test {STI_UNIVERSE}.disjunction.
			-- Test {STS_INTEGER_UNIVERSE}.disjunction.
			-- Test {STI_INTEGER_UNIVERSE}.disjunction.
		note
			testing: "covers/{STS_SET}.disjunction"
			testing: "covers/{STI_SET}.disjunction"
			testing: "covers/{STS_NUMERIC_SET}.disjunction"
			testing: "covers/{STI_NUMERIC_SET}.disjunction"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.disjunction"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.disjunction"
			testing: "covers/{STS_INTEGER_SET}.disjunction"
			testing: "covers/{STI_INTEGER_SET}.disjunction"
			testing: "covers/{STS_UNIVERSE}.disjunction"
			testing: "covers/{STI_UNIVERSE}.disjunction"
			testing: "covers/{STS_INTEGER_UNIVERSE}.disjunction"
			testing: "covers/{STI_INTEGER_UNIVERSE}.disjunction"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_conjunction
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.conjunction.
			-- Test {STI_NUMERIC_SET}.conjunction.
			-- Test {STS_ORDERED_NUMERIC_SET}.conjunction.
			-- Test {STI_ORDERED_NUMERIC_SET}.conjunction.
			-- Test {STS_INTEGER_SET}.conjunction.
			-- Test {STI_INTEGER_SET}.conjunction.
			-- Test {STS_UNIVERSE}.conjunction.
			-- Test {STI_UNIVERSE}.conjunction.
			-- Test {STS_INTEGER_UNIVERSE}.conjunction.
			-- Test {STI_INTEGER_UNIVERSE}.conjunction.
		note
			testing: "covers/{STS_SET}.conjunction"
			testing: "covers/{STI_SET}.conjunction"
			testing: "covers/{STS_NUMERIC_SET}.conjunction"
			testing: "covers/{STI_NUMERIC_SET}.conjunction"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.conjunction"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.conjunction"
			testing: "covers/{STS_INTEGER_SET}.conjunction"
			testing: "covers/{STI_INTEGER_SET}.conjunction"
			testing: "covers/{STS_UNIVERSE}.conjunction"
			testing: "covers/{STI_UNIVERSE}.conjunction"
			testing: "covers/{STS_INTEGER_UNIVERSE}.conjunction"
			testing: "covers/{STI_INTEGER_UNIVERSE}.conjunction"
		do
			Precursor {UNIVERSE_TESTS}
		end

	test_sets_plus_same_sets_with_element
			-- <Precursor>
			-- Test {STS_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_INTEGER_SET}.sets_plus_same_sets_with_element.
			-- Test {STI_INTEGER_SET}.sets_plus_same_sets_with_element.
			-- Test {STS_UNIVERSE}.sets_plus_same_sets_with_element.
			-- Test {STI_UNIVERSE}.sets_plus_same_sets_with_element.
			-- Test {STS_INTEGER_UNIVERSE}.sets_plus_same_sets_with_element.
			-- Test {STI_INTEGER_UNIVERSE}.sets_plus_same_sets_with_element.
		note
			testing: "covers/{STS_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_ORDERED_NUMERIC_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_INTEGER_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_INTEGER_SET}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_UNIVERSE}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_UNIVERSE}.sets_plus_same_sets_with_element"
			testing: "covers/{STS_INTEGER_UNIVERSE}.sets_plus_same_sets_with_element"
			testing: "covers/{STI_INTEGER_UNIVERSE}.sets_plus_same_sets_with_element"
		do
			Precursor {UNIVERSE_TESTS}
		end

feature -- Test routines (Implementation)

	test_i_is_within_interval
			-- Test {STI_INTEGER_UNIVERSE}.i_is_within_interval.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.i_is_within_interval"
		local
			a, b, m, n: like some_exposed_integer.stored_value
		do
			b := next_random_item.as_integer_8
			m := next_random_item.as_integer_8
			a := m ∧ b
			b := m ∨ b
			n := (next_random_item \\ (b.as_integer_32 - a.as_integer_32 + 1) + a.as_integer_32).as_integer_8
			assert ("a ≤ n ≤ b", Exposed_universe_to_be_tested.i_is_within_interval (a, n, b))

			b := next_random_item.as_integer_8
			m := next_random_item.as_integer_8
			a := m ∧ b
			b := m ∨ b
			from
				m := next_random_item.as_integer_8
			until
				m /= a
			loop
				m := next_random_item.as_integer_8
			end
			n := m ∧ a
			a := m ∨ a
			assert ("n < a", not Exposed_universe_to_be_tested.i_is_within_interval (a, n, b))

			b := next_random_item.as_integer_8
			m := next_random_item.as_integer_8
			a := m ∧ b
			b := m ∨ b
			from
				m := next_random_item.as_integer_8
			until
				m /= b
			loop
				m := next_random_item.as_integer_8
			end
			n := m ∨ b
			b := m ∧ b
			assert ("b < n", not Exposed_universe_to_be_tested.i_is_within_interval (a, n, b))

			b := next_random_item.as_integer_8
			from
				m := next_random_item.as_integer_8
			until
				m /= b
			loop
				m := next_random_item.as_integer_8
			end
			a := m ∨ b
			b := m ∧ b
			n := next_random_item.as_integer_8
			assert ("a > b", not Exposed_universe_to_be_tested.i_is_within_interval (a, n, b))

			a := next_random_item.as_integer_8
			b := next_random_item.as_integer_8
			n := next_random_item.as_integer_8
			assert ("i_is_within_interval", Exposed_universe_to_be_tested.i_is_within_interval (a, n, b) implies True)
		end

	test_stored_value_interval
			-- Test {STI_INTEGER_UNIVERSE}.stored_value_interval.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.stored_value_interval"
		local
			a, b, m: like some_exposed_integer.stored_value
		do
			b := next_random_item.as_integer_8
			from
				m := next_random_item.as_integer_8
			until
				m /= b
			loop
				m := next_random_item.as_integer_8
			end
			a := m ∨ b
			b := m ∧ b
			assert ("a > b", Exposed_universe_to_be_tested.stored_value_interval (a, b).is_empty)

			b := next_random_item.as_integer_8
			m := next_random_item.as_integer_8
			a := m ∧ b
			b := m ∨ b
			assert ("a ≤ b", not Exposed_universe_to_be_tested.stored_value_interval (a, b).is_empty)

			a := next_random_item.as_integer_8
			b := next_random_item.as_integer_8
			assert ("stored_value_interval", attached Exposed_universe_to_be_tested.stored_value_interval (a, b))
		rescue
			print (a) print (", ")
			print (b) print ('%N')
		end

	test_integer_from_stored_value
			-- Test {STI_INTEGER_UNIVERSE}.integer_from_stored_value.
		note
			testing: "covers/{STI_INTEGER_UNIVERSE}.integer_from_stored_value"
		do
			assert ("integer_from_stored_value", attached Exposed_universe_to_be_tested.integer_from_stored_value (next_random_item.as_integer_8))
		end

feature {NONE} -- Factory (test element)

	universe_to_be_tested: STI_INTEGER_UNIVERSE
			-- Real universe meant to be under tests
		once
			Result := Z
		ensure then
			class
		end

	exposed_universe_to_be_tested: INTEGER_UNIVERSE
			-- Real universe meant to be under tests, whose features with restricted access are available to be tested.
		once
			Result := Exposed_z
		ensure then
			class
		end

feature {NONE} -- Conversion

	set_from_sa (sa: STS_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `sa` converted to a set like `some_direct_real_set'
		do
			Result := sa
		end

	set_from_saa (saa: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `saa` converted to a set like `some_direct_real_set'
		do
			Result := saa
		end

	set_from_sti_sa (sa: STI_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `sa` converted to a set like `some_direct_real_set'
		do
			Result := sa
		end

	set_from_numeric_set (ns: STS_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `ns` converted to a set like `some_direct_real_set'
		do
			Result := ns
		end

	set_from_sti_numeric_set (ns: STI_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `ns` converted to a set like `some_direct_real_set'
		do
			Result := ns
		end

	set_from_ordered_numeric_set (ons: STS_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `ons` converted to a set like `some_direct_real_set'
		do
			Result := ons
		end

	set_from_sti_ordered_numeric_set (ons: STI_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `ons` converted to a set like `some_direct_real_set'
		do
			Result := ons
		end

	set_from_universe (u: STS_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `u` converted to a set like `some_direct_real_set'
		do
			Result := u
		end

	set_from_sti_universe (u: STI_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `u` converted to a set like `some_direct_real_set'
		do
			Result := u
		end

	set_from_sti_saa (saa: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_INTEGER_EQUALITY]): like some_direct_integer_set
			-- `saa' converted to a set like `some_direct_real_set'
		do
			Result := saa
		end

	set_from_numeric_universe (u: STS_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set -- TODO: Change it.
			-- `u` converted to a set like `some_direct_real_set'
		do
			Result := u
		end

	set_from_sti_numeric_universe (u: STI_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set -- TODO: Change it.
			-- `u` converted to a set like `some_direct_real_set'
		do
			Result := u
		end

	universe_from_numeric_universe (u: STS_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: u ≍ Result
		end

	universe_from_sti_numeric_universe (u: STI_UNIVERSE [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: u ≍ Result
		end

	universe_from_universe (u: STS_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: Result ≍ u
		end

	universe_from_sti_universe (u: STI_UNIVERSE [STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY]): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: Result ≍ u
		end

	universe_from_integer_universe (u: STS_INTEGER_UNIVERSE): like Universe_to_be_tested
			-- `u` converted to a universe like `Universe_to_be_tested'
		do
			Result := u
		ensure
			same_universe: Result ≍ u
		end

	set_from_integer_set (sa: STS_INTEGER_SET): like some_direct_integer_set
			-- `sa` converted to a set like `some_direct_integer_set'
		do
			Result := sa
		end

	set_from_integer_universe (u: STS_INTEGER_UNIVERSE): like some_direct_integer_set
			-- `u` converted to a set like `some_direct_integer_set'
		do
			Result := u
		end

	set_from_transformable_integers_to_numeric_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_sti_transformable_integers_to_numeric_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_transformable_integers_to_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_sti_transformable_integers_to_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_COMPLEX_EQUALITY]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_transformable_integers_to_expanded_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_sti_transformable_integers_to_expanded_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_transformable_integers_to_numeric_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_sti_transformable_integers_to_numeric_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_transformable_integers_to_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_sti_transformable_integers_to_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_REAL_EQUALITY]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_transformable_integers_to_expanded_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_sti_transformable_integers_to_expanded_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_transformable_integers_to_numeric_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_sti_transformable_integers_to_numeric_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_transformable_integers_to_expanded_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_sti_transformable_integers_to_expanded_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_INTEGER_EQUALITY, STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_si (si: STS_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set
			-- `si` converted to a set like `some_direct_integer_set'
		do
			Result := si
		end

	set_from_sti_si (si: STI_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set
			-- `si` converted to a set like `some_direct_integer_set'
		do
			Result := si
		end

	set_from_sii (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii` converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_sti_sii (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii` converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_numeric_integers (ni: STS_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set
			-- `ni` converted to a set like `some_direct_integer_set'
		do
			Result := ni
		end

	set_from_sti_numeric_integers (ni: STI_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set
			-- `ni` converted to a set like `some_direct_integer_set'
		do
			Result := ni
		end

	set_from_ordered_numeric_integers (oni: STS_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set
			-- `oni` converted to a set like `some_direct_integer_set'
		do
			Result := oni
		end

	set_from_sti_ordered_numeric_integers (oni: STI_ORDERED_NUMERIC_SET [STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER]]): like some_direct_integer_set
			-- `oni` converted to a set like `some_direct_integer_set'
		do
			Result := oni
		end

	set_from_transformable_numeric_integers_to_numeric_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_sti_transformable_numeric_integers_to_numeric_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_transformable_numeric_integers_to_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_sti_transformable_numeric_integers_to_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_COMPLEX_EQUALITY]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_transformable_numeric_integers_to_expanded_complexes (
		sic: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_sti_transformable_numeric_integers_to_expanded_complexes (
		sic: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_COMPLEX_NUMBER]]
		): like some_direct_integer_set
			-- `sic' converted to a set like `some_direct_integer_set'
		do
			Result := sic
		end

	set_from_transformable_numeric_integers_to_numeric_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_sti_transformable_numeric_integers_to_numeric_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_transformable_numeric_integers_to_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_sti_transformable_numeric_integers_to_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_REAL_EQUALITY]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_transformable_numeric_integers_to_expanded_reals (
		sir: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_sti_transformable_numeric_integers_to_expanded_reals (
		sir: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_REAL_NUMBER]]
		): like some_direct_integer_set
			-- `sir' converted to a set like `some_direct_integer_set'
		do
			Result := sir
		end

	set_from_transformable_numeric_integers_to_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_sti_transformable_numeric_integers_to_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STS_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_INTEGER_EQUALITY]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_transformable_numeric_integers_to_expanded_integers (
		sii: STS_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

	set_from_sti_transformable_numeric_integers_to_expanded_integers (
		sii: STI_TRANSFORMABLE_SET [STS_INTEGER_NUMBER, STI_INTEGER_NUMBER, STS_NUMERIC_EQUALITY [STS_INTEGER_NUMBER], STS_NUMERIC_EQUALITY [STI_INTEGER_NUMBER]]
		): like some_direct_integer_set
			-- `sii' converted to a set like `some_direct_integer_set'
		do
			Result := sii
		end

invariant
	monomorphic_Universe_to_be_tested: Universe_to_be_tested.generating_type ~ {detachable like Universe_to_be_tested}

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
