note
	description: "Implementation of {STS_COMPLEX_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_COMPLEX_SET

inherit

	STS_COMPLEX_SET [STI_COMPLEX, STI_COMPLEX_EQUALITY]
		undefine
				-- Construction
			with,
			without,
				-- Measurement
			cardinality,
				-- Output
			out,
				-- Comparison
			equals,
			is_strict_subset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
				-- Quantifier
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
				-- Operation
			trivial_subsets,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
				-- Predicate
			equality_holds,
			equality_does_not_hold,
				-- Anchor
			product_anchor,
			square_anchor,
			diagonal_anchor,
			tuple_anchor
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

	STI_SET [STI_COMPLEX, STI_COMPLEX_EQUALITY]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

create
	make_empty,
	make_singleton,
	make_extended

feature -- Access

	Zero: STI_COMPLEX
			-- <Precursor>
		once
			Result := {STI_COMPLEX}.Zero
		ensure then
			class
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STI_COMPLEX_SET
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
