﻿note
	description: "(Partial) implementation of {STS_UNIVERSE}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STI_UNIVERSE [
		A,
		EQ -> STS_EQUALITY [A]
			create
				default_create
			end
		]

inherit
	STS_UNIVERSE [A, EQ]
		undefine
				-- Construction
			without,
				-- Measurement
			cardinality,
				-- Output
			out,
				-- Quantifier
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
				-- Operation
			trivial_subsets,
			subtracted_symmetricaly,
			diagonal,
			crossed,
			crossed_tuples,
				-- Predicate
			equality_holds,
			equality_does_not_hold,
				-- Anchor
			set_anchor,
			subset_anchor,
			product_anchor,
			square_anchor,
			diagonal_anchor,
			tuple_anchor
		redefine -- todo: doubtful optimizations...
				-- Construction
			with,
				-- Comparison
			equals,
			is_comparable,
			is_not_comparable,
			is_strict_subset,
			is_superset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
			intersects,
				-- Operation
			complemented,
			intersected
--				-- Anchor
--			itself
		end

	STI_SET [A, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		undefine
				-- Membership
			has,
				-- Anchor
			itself
		redefine
				-- Construction
			with,
			extended,
				-- Comparison
			equals,
			is_comparable,
			is_not_comparable,
			is_strict_subset,
			is_superset,
			is_trivial_subset,
			is_proper_subset,
			is_disjoint,
			intersects,
				-- Operation
			complemented,
			united,
			intersected
--				-- Anchor
--			itself
		end

feature -- Construction

	with alias "&" (a: A): like itself
			-- <Precursor>
			-- This universe itself
		do
			Result := Current
		end

	extended (a: A): like itself
			-- <Precursor>
			-- NOTICE: The precondition never holds for a universe.
		do
			Result := Current
		ensure then
			impossible_precondition: False
		end

feature -- Comparison

	equals alias "≍" (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			if attached {STS_UNIVERSE [A, EQ]} s then
				Result := True
			else
				Result := Current ⊆ s
			end
		end

	is_comparable alias "⟂" (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := True
		end

	is_not_comparable alias "∥" (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := False
		end

	is_superset alias "⊇" (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := True
		end

	is_strict_subset alias "⊂" (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := False
		end

	is_trivial_subset (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := Current ≍ s
		end

	is_proper_subset (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := False
		end

	is_disjoint (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := False
		end

	intersects (s: STS_SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := True
		end

feature -- Operation

	complemented alias "∁" (s: STS_SET [A, EQ]): like set_anchor
			-- <Precursor>
		do
			Result := o
		end

	united alias "∪" (s: STS_SET [A, EQ]): like itself
			-- <Precursor>
		do
			Result := Current
		end

	intersected alias "∩" (s: STS_SET [A, EQ]): like subset_anchor
			-- <Precursor>
		do
			Result := converted (s)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
