﻿note
	description: "[
		Object that checks whether an implementation of {STS_COMPLEX} bears the properties determined by set theory
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date:$"
	revision: "$Revision$"

deferred class
	STP_COMPLEX_PROPERTIES

--feature -- Access

--	r: STS_SET [STS_REAL, STS_COMPLEX_EQUALITY [STS_REAL]]
--			-- "Universe" of real numbers, i.e. ℝ.

--feature -- Properties (Comparison)

--	equals_ok (z1, z2: STS_COMPLEX): BOOLEAN
--			-- Does {STS_COMPLEX}.equals bear the properties determined by set theory?
--		do
--			r := r & z1.a & z1.b & z2.a & z2.b
--			check
--				definition: z1 ≍ z2 = (|x| r).for_all (
--					agent (
--						xy: STS_ORDERED_PAIR [
--							STS_REAL, STS_REAL,
--							STS_COMPLEX_EQUALITY [STS_REAL],
--							STS_COMPLEX_EQUALITY [STS_REAL]
--							]
--						ia_z1, ia_z2: STS_COMPLEX
--						): BOOLEAN
--						local
--							x, y: STS_REAL
--						do
--							x := xy.a
--							y := xy.b
--							Result := (x ≍ ia_z1.a) = (x ≍ ia_z2.a) and
--								(y ≍ ia_z1.b) = (y ≍ ia_z2.b)
--						end (?, z1, z2)
--					)
--			then
--				Result := True
--			end
--		ensure
--			r: r ⊇ old (r & z1.a & z1.b & z2.a & z2.b)
--		end

--feature -- Properties (Basic operations)

----	reciprocal_ok,
----	inverse_ok (z: STS_COMPLEX): BOOLEAN
----			-- Do {STS_COMPLEX}.reciprocal and {STS_COMPLEX}.inverse bear the properties determined by set theory?
----		do
----			r := r & z.a & z.b
----			if z.one.divisible (z) then
----				check
----						-- z.a * z.a + z.b * z.b /= `z'.`zero'
----					real_divisible: z.a.divisible ((z.a * z.a + z.b * z.b))
----					imaginary_divisible: (- z.b).divisible ((z.a * z.a + z.b * z.b))
----					real: z.reciprocal.a ≍ (z.a / (z.a * z.a + z.b * z.b))
----					imaginary: z.inverse.b ≍ ((- z.b) / (z.a * z.a + z.b * z.b))
----				then
----				end
----			end
----			Result := True
----		ensure
----			r: r ⊇ old (r & z.a & z.b)
----		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
