﻿note
	description: "Set of complex numbers, i.e. a subset of ℂ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_COMPLEX_SET [C -> STS_COMPLEX, EQ -> STS_COMPLEX_EQUALITY [C]]

inherit

	STS_NUMERIC_SET [C, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

--feature -- Access

--	zero: C
--			-- The number zero
--		deferred
--		ensure
--			real: Result.a.value = 0
--			imaginary: Result.b.value = 0
--		end

--feature -- Restriction

--	without_zero: like subset_anchor
--			-- This set deprived of the number zero
--		do
--			Result := Current / zero
--		ensure
--			definition: Result ≍ (Current / zero)
--		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_COMPLEX_SET [C, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
