﻿note
	description: "Set of numbers"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_NUMERIC_SET [
		A -> STS_NUMBER,
		EQ -> STS_EQUALITY [A]
		]

inherit

	STS_SET [A, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Access

	zero: A
			-- The number zero
		deferred
		ensure -- todo: rewrite
			attached {STS_COMPLEX} Result as c
			definition: c ≍ c.zero --  eq (Result, Result.zero)
		end

feature -- Restriction

	without_zero: like subset_anchor
			-- This set deprived of the number zero
			-- todo: why can't I use unary alias "*"?
		do
			Result := Current / zero
		ensure
			definition: Result ≍ (Current / zero)
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_NUMERIC_SET [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
