﻿note
	description: "Set of real numbers, i.e. a subset of ℝ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_REAL_SET [R -> STS_REAL, EQ -> STS_REAL_EQUALITY [R]]

inherit

	STS_SIGNED_NUMERIC_SET [R, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

--feature -- Restriction

--	non_positive: like subset_anchor
--			-- This set deprived of positive numbers, i.e. (<-, 0] * `Current'.
--		do
--			Result := Current | agent number_is_less_equal (?, zero)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less_equal (?, zero))
--		end

--	non_negative: like subset_anchor
--			-- This set deprived of negative numbers, i.e. [0, ->) * `Current'.
--		do
--			Result := Current | agent number_is_less_equal (zero, ?)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less_equal (zero, ?))
--		end

--	negative: like subset_anchor
--			-- The negative numbers in this set, i.e. (<-, 0) * `Current'.
--		do
--			Result := Current | agent number_is_less (?, zero)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less (?, zero))
--		end

--	positive: like subset_anchor
--			-- The positive numbers in this set, i.e. (0, ->) * `Current'.
--		do
--			Result := Current | agent number_is_less (zero, ?)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less (zero, ?))
--		end

--feature -- Interval

--	closed_interval alias "[]" (a, b: R): like subset_anchor
--			-- Set of every number x in this set such that `a' ⊆ x ⊆ `b',
--			-- i.e. [`a', `b'] * `Current'.
--		do
--			Result := Current | agent anded (
--				agent number_is_less_equal (a, ?),
--				agent number_is_less_equal (?, b),
--				?
--				)
--		ensure
--			definition: Result ≍ (
--				Current | agent anded (
--					agent number_is_less_equal (a, ?),
--					agent number_is_less_equal (?, b),
--					?
--					)
--				)
--		end

--	left_closed_right_open_interval (a, b: R): like subset_anchor
--			-- Set of every number x in this set such that `a' ⊆ x < `b',
--			-- i.e. [`a', `b') * `Current'.
--		do
--			Result := Current | agent anded (
--				agent number_is_less_equal (a, ?),
--				agent number_is_less (?, b),
--				?
--				)
--		ensure
--			definition: Result ≍ (
--				Current | agent anded (
--					agent number_is_less_equal (a, ?),
--					agent number_is_less (?, b),
--					?
--					)
--				)
--		end

--	left_open_right_closed_interval (a, b: R): like subset_anchor
--			-- Set of every number x in this set such that `a' < x ⊆ `b',
--			-- i.e. (`a', `b'] * `Current'.
--		do
--			Result := Current | agent anded (
--				agent number_is_less (a, ?),
--				agent number_is_less_equal (?, b),
--				?
--				)
--		ensure
--			definition: Result ≍ (
--				Current | agent anded (
--					agent number_is_less (a, ?),
--					agent number_is_less_equal (?, b),
--					?
--					)
--				)
--		end

--	open_interval alias "()" (a, b: R): like subset_anchor
--			-- Set of every number x in this set such that `a' < x < `b',
--			-- i.e. (`a', `b') * `Current'.
--		do
--			Result := Current | agent anded (
--				agent number_is_less (a, ?),
--				agent number_is_less (?, b),
--				?
--				)
--		ensure
--			definition: Result ≍ (
--				Current | agent anded (
--					agent number_is_less (a, ?),
--					agent number_is_less (?, b),
--					?
--					)
--				)
--		end

--	left_closed_right_unbounded_interval (a: R): like subset_anchor
--			-- Set of every number x in this set such that `a' ⊆ x,
--			-- i.e. [`a', ->) * `Current'.
--		do
--			Result := Current | agent number_is_less_equal (a, ?)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less_equal (a, ?))
--		end

--	left_open_right_unbounded_interval (a: R): like subset_anchor
--			-- Set of every number x in this set such that `a' < x,
--			-- i.e. (`a', ->) * `Current'.
--		do
--			Result := Current | agent number_is_less (a, ?)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less (a, ?))
--		end

--	left_unbounded_right_closed_interval (b: R): like subset_anchor
--			-- Set of every number x in this set such that x ⊆ `b'',
--			-- i.e. (<-, `b'] * `Current'.
--		do
--			Result := Current | agent number_is_less_equal (?, b)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less_equal (?, b))
--		end

--	left_unbounded_right_open_interval (b: R): like subset_anchor
--			-- Set of every number x in this set such that x < `b',
--			-- i.e. (<-, `b') * `Current'.
--		do
--			Result := Current | agent number_is_less (?, b)
--		ensure
--			definition: Result ≍ (Current | agent number_is_less (?, b))
--		end

--	unbounded_interval: like Current
--			-- This set itself, i.e. (<-, ->) * `Current'.
--		do
--			Result := Current
--		ensure
--			definition: Result ≍ Current
--		end

--feature -- Predicate

--	number_is_less (x, y: R): BOOLEAN
--			-- Is `x' less than `y'?
--		do
--			Result := x < y
--		ensure then
--			class
--			definition: Result = (x < y)
--		end

--	number_is_less_equal (x, y: R): BOOLEAN
--			-- Is `x' less than or equal to `y'?
--		do
--			Result := x ⊆ y
--		ensure then
--			class
--			definition: Result = (x ⊆ y)
--		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_REAL_SET [R, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
