﻿note
	description: "Set of signed numbers"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_SIGNED_NUMERIC_SET [
		A -> {STS_NUMBER, COMPARABLE},
		EQ -> STS_EQUALITY [A]
		]

inherit
	STS_ORDERED_NUMERIC_SET [A, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Restriction

	non_positive: like subset_anchor
			-- This set deprived of positive numbers, i.e. (←, 0].
		do
			Result := Current | agent number_is_less_equal (?, zero)
		ensure
			definition: Result ≍ (Current | agent number_is_less_equal (?, zero))
		end

	non_negative: like subset_anchor
			-- This set deprived of negative numbers, i.e. [0, →).
		do
			Result := Current | agent number_is_less_equal (zero, ?)
		ensure
			definition: Result ≍ (Current | agent number_is_less_equal (zero, ?))
		end

	negative: like subset_anchor
			-- The negative numbers in this set, i.e. (←, 0).
		do
			Result := Current | agent number_is_less (?, zero)
		ensure
			definition: Result ≍ (Current | agent number_is_less (?, zero))
		end

	positive: like subset_anchor
			-- The positive numbers in this set, i.e. (0, →).
		do
			Result := Current | agent number_is_less (zero, ?)
		ensure
			definition: Result ≍ (Current | agent number_is_less (zero, ?))
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_SIGNED_NUMERIC_SET [A, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
