﻿note
	description: "Test suite for {STS_COMPLEX_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_COMPLEX_SET_TESTS [
		X,
		C -> STS_COMPLEX,
		B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_C -> STS_COMPLEX_EQUALITY [C]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_NUMBERS_ELEMENT_TESTS [X, C, B, EQ_X, EQ_C, EQ_B]
--		rename
--				-- Test routines (Membership)
--			test_is_in as test_element_is_in,
--				-- Factory (test element)
--			element_to_be_tested as test_complex_set
--				 -- Factory (object)
----			some_object_a as some_complex
--		undefine
--				-- Factory (test element)
--			test_complex_set
--		redefine
--				-- Access
----			properties
--				-- Factory (set [A])
----			some_set_a
----			same_set_a
--		end

----	STT_SET_TESTS [X, C, B, EQ_X, EQ_C, EQ_B]
----		rename
----				-- Factory (test element)
----			test_set as test_complex_set,
----				-- Factory (object)
----			some_object_a as some_complex,
----			some_integer as some_native_integer,
----			some_natural as some_native_natural
----		undefine
----				-- Factory (test element)
----			test_complex_set,
----				-- Factory (element)
----			some_element,
----				-- Factory (object)
----			some_object
----		redefine
----				-- Access
----			properties,
----			-- Factory (set [A])
----			some_set_a
------			same_set_a
----		end

----feature {NONE} -- Access

----	properties: STT_SET_PROPERTIES  [C, EQ_C]
----			-- Object that checks the set-theory properties of {STI_SET}

--feature -- Test routines (Access)

--	test_zero
--			-- Test {STS_COMPLEX_SET}.zero.
--		note
--			testing: "covers/{STS_COMPLEX_SET}.zero"
--		do
--			assert ("zero", attached test_complex_set.zero)
--		end

--feature -- Test routines (Restriction)

--	test_without_zero
--			-- Test {STS_COMPLEX_SET}.without_zero.
--		note
--			testing: "covers/{STS_COMPLEX_SET}.without_zero"
--		do
--			assert ("without_zero", attached test_complex_set.without_zero)
--		end

--feature {NONE} -- Factory (test element)

--	test_complex_set: STS_COMPLEX_SET [C, EQ_C]
--			-- Complex set meant to be under tests
--		deferred
--		end

--feature {NONE} -- Factory (set [A])

----	some_set_a: STI_SET [C, EQ_C]
----			-- <Precursor>
----		do
----			inspect
----				next_random_item \\ 2
----			when 0 then
----				Result := Precursor {STT_NUMBERS_ELEMENT_TESTS}
----			else -- when 1 then
----				Result := some_complex_set
----			end
----		end

----	same_set_a (s: STI_SET [C, EQ_C]): STI_SET [C, EQ_C]
----			-- <Precursor>
----		local
----			l_s: STI_SET [C, EQ_C]
----		do
----			inspect
----				next_random_item \\ 2
----			when 0 then
----				Result := Precursor {STT_NUMBERS_ELEMENT_TESTS}(s)
----			else -- when 1 then
----				from
----					create {like some_complex_set} Result.make_empty
----					l_s := s
----				invariant
----					building_up: Result ≍ (s - l_s)
----				until
----					l_s.is_empty
----				loop
----						check
----							does_not_have: not Result.has (l_s.any) -- Result ≍ (s - l_s)
----						end
----					Result := Result.extended (l_s.any)
----					l_s := l_s.others
----				variant
----					cardinality: (# l_s).as_integer_64
----				end
----			end
----		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
