﻿note
	description: "Test suite for {STS_COMPLEX}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_COMPLEX_TESTS [
		X,
		C -> STS_COMPLEX,
		B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_C -> STS_COMPLEX_EQUALITY [C]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_NUMBERS_ELEMENT_TESTS [X, C, B, EQ_X, EQ_C, EQ_B]
--		rename
--				-- Test routines (Membership)
--			test_is_in as test_element_is_in,
--				-- Factory (test element)
--			element_to_be_tested as test_complex
--		undefine
--				-- Factory (test element)
--			test_complex
--		redefine
--				-- Access
--			properties
--		end

--feature {NONE} -- Access

--	properties: STT_COMPLEX_PROPERTIES
--			-- Object that checks the set-theory properties of {STS_COMPLEX}

--feature -- Test routines (Membership)

--	test_is_in
--			-- Test {STS_COMPLEX}.is_in.
--		note
--			testing: "covers/{STS_COMPLEX}.is_in"
--		local
--			z: like test_complex
--			zs: like some_complexes
--		do
--			z := test_complex
--			zs := some_complex_references & z
--			assert ("same_reference", z ∈ zs))

--			z := test_complex
--			zs := some_complex_objects & z.twin
--			assert ("same_value", z ∈ zs))

--			z := test_complex
--			zs := some_math_complexes & same_complex (z)
--			assert ("same_math_value", z ∈ zs))

--			z := test_complex
--			zs := some_complexes
--			assert ("some_complexes", z ∈ zs) implies True)
--		end

--feature -- Test routines (Access)

--	test_zero
--			-- Test {STS_COMPLEX}.zero.
--		note
--			testing: "covers/{STS_COMPLEX}.zero"
--		do
--			assert ("zero", attached test_complex.zero)
--		end

--	test_one
--			-- Test {STS_COMPLEX}.one.
--		note
--			testing: "covers/{STS_COMPLEX}.one"
--		do
--			assert ("one", attached test_complex.one)
--		end

--feature -- Test routines (Status report)

--	test_is_invertible
--			-- Test {STS_COMPLEX}.is_invertible.
--		note
--			testing: "covers/{STS_COMPLEX}.is_invertible"
--		local
--			z: like test_complex
--		do
--			from
--				z := test_complex
--			until
--				not (z ≍ z.zero) and (
--					z.a.value = 0 and not z.b.value.is_nan or
--					z.b.value = 0 and not z.a.value.is_nan or
--					not z.a.value.is_nan and not z.b.value.is_nan
--					)
--			loop
--				z := test_complex
--			end
--			assert ("z_is_invertible", z.is_invertible)

--			z := test_complex
--			assert ("is_invertible", z.is_invertible implies True)
--		end

--	test_divisible
--			-- Test {STS_COMPLEX}.divisible.
--		note
--			testing: "covers/{STS_COMPLEX}.divisible"
--		local
--			z1: like test_complex
--			z2: like some_complex
--		do
--			from
--				z1 := test_complex
--				z2 := some_complex
--			until
--				not (z2 ≍ z2.zero) and (
--					z2.a.value = 0 and not z2.b.value.is_nan or
--					z2.b.value = 0 and not z2.a.value.is_nan or
--					not z2.a.value.is_nan and not z2.b.value.is_nan
--					)
--			loop
--				z2 := some_complex
--			end
--			assert ("z1_divisible_z2", z1.divisible (z2))

--			z1 := test_complex
--			z2 := some_complex
--			assert ("divisible", z1.divisible (z2) implies True)
--		end

--feature -- Test routines (Comparison)

--	test_is_equal
--			-- Test {STS_COMPLEX}.is_equal.
--		note
--			testing: "covers/{STS_COMPLEX}.is_equal"
--		local
--			z1: like test_complex
--			z2: like some_complex
--		do
--			z1 := test_complex
--			assert ("same_entity", z1 ~ z1)

--			z1 := test_complex
--			z2 := z1.twin
--			assert ("same_object_value", z1 ~ z2)

--			z1 := test_complex
--			z2 := same_complex (z1)
--			assert ("same_complex", z1 ~ z2 implies True)

--			z1 := test_complex
--			z2 := some_complex
--			assert ("some_complex", z1 ~ z2 implies True)
--		end

--	test_equals
--			-- Test {STS_COMPLEX}.equals.
--		note
--			testing: "covers/{STS_COMPLEX}.equals"
--		local
--			z1: like test_complex
--			z2: like some_complex
--		do
--			z1 := test_complex
--			assert ("same_entity", z1 ≍ z1)
--			assert ("same_entity_ok", properties.equals_ok (z1, z1))

--			z1 := test_complex
--			z2 := same_complex (z1)
--			assert ("same_complex", z1 ≍ z2)
--			assert ("same_complex_ok", properties.equals_ok (z1, z2))

--			z1 := test_complex
--			z2 := some_complex
--			assert ("some_complex", z1 ≍ z2 implies True)
--			assert ("some_complex_ok", properties.equals_ok (z1, z2))
--		end

--feature -- Test routines (Basic operations)

--	test_conjugate
--			-- Test {STS_COMPLEX}.conjugate.
--		note
--			testing: "covers/{STS_COMPLEX}.conjugate"
--		do
--			assert ("conjugate", attached test_complex.conjugate)
--		end

--	test_plus
--			-- Test {STS_COMPLEX}.plus.
--		note
--			testing: "covers/{STS_COMPLEX}.plus"
--		do
--			assert ("plus", attached (test_complex + some_complex))
--		end

--	test_identity
--			-- Test {STS_COMPLEX}.identity.
--		note
--			testing: "covers/{STS_COMPLEX}.identity"
--		do
--			assert ("identity", attached (+ test_complex))
--		end

--	test_minus
--			-- Test {STS_COMPLEX}.minus.
--		note
--			testing: "covers/{STS_COMPLEX}.minus"
--		do
--			assert ("minus", attached (test_complex - some_complex))
--		end

--	test_opposite
--			-- Test {STS_COMPLEX}.opposite.
--		note
--			testing: "covers/{STS_COMPLEX}.opposite"
--		do
--			assert ("opposite", attached (- test_complex))
--		end

--	test_product
--			-- Test {STS_COMPLEX}.product.
--		note
--			testing: "covers/{STS_COMPLEX}.product"
--		do
--			assert ("product", attached (test_complex * some_complex))
--		end

--	test_quotient
--			-- Test {STS_COMPLEX}.quotient.
--		note
--			testing: "covers/{STS_COMPLEX}.quotient"
--		local
--			z1: like test_complex
--			z2: like some_complex
--		do
--			from
--				z1 := test_complex
--				z2 := some_complex
--			until
--				z1.divisible (z2)
--			loop
--				z2 := some_complex
--			end
--			assert ("quotient", attached (z1 / z2))
--		end

--	test_reciprocal
--			-- Test {STS_COMPLEX}.reciprocal.
--		note
--			testing: "covers/{STS_COMPLEX}.reciprocal"
--		local
--			z: like test_complex
--		do
--			from
--				z := test_complex
--			until
--				z.is_invertible
--			loop
--				z := test_complex
--			end
--			assert ("reciprocal", attached z.reciprocal)
--		end

--	test_inverse
--			-- Test {STS_COMPLEX}.inverse.
--		note
--			testing: "covers/{STS_COMPLEX}.inverse"
--		local
--			z: like test_complex
--		do
--			from
--				z := test_complex
--			until
--				z.is_invertible
--			loop
--				z := test_complex
--			end
--			assert ("inverse", attached z.inverse)
--		end

--feature {NONE} -- Factory (test element)

--	test_complex: C
--			-- Complex number meant to be under tests
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
