note
	description: "Test suite for {STS_ELEMENT}, adapted to deal with numeric elements and sets."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_NUMBERS_ELEMENT_TESTS [
		X,
		C -> STS_COMPLEX,
		B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_C -> STS_COMPLEX_EQUALITY [C]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_ELEMENT_TESTS [X, C, B, EQ_X, EQ_C, EQ_B]
--		rename
--				-- Factory (object)
--			some_natural as some_native_natural,
--			some_integer as some_native_integer
--		redefine
--				-- Factory (element)
--			some_element,
--				-- Factory (object)
--			some_object
--		end

--feature {NONE} -- Factory (element)

--	some_element: STS_ELEMENT
--			-- <Precursor>
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := Precursor {STT_ELEMENT_TESTS}
--			else -- when 1 then
--				Result := some_complex
--			end
--		end

--feature {NONE} -- Factory (numbers)

--	some_complex: STS_COMPLEX
--			-- Randomly created (polymorphic) complex number
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := some_strict_complex
--			else -- when 1 then
--				Result := some_real
--			end
--		end

--	some_strict_complex: STI_COMPLEX
--			-- Randomly created complex number
--		do
--			create Result.make (some_strict_real, some_strict_real)
--		end

--	same_complex (z: STS_COMPLEX): STS_COMPLEX
--			-- <Precursor>
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				if z.b.value = 0 then
--					Result := same_real (z.a)
--				else
--					Result := z
--				end
--			when 1 then
--				Result := z.twin
--			else -- when 2 then
--				create {STI_COMPLEX} Result.make (z.a.value, z.b.value)
--			end
--		end

--	some_real: STS_REAL
--			-- Randomly created (polymorphic) real number
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := some_strict_real
--			else -- when 1 then
--				Result := --some_rational
--				some_real
--			end
--		end

--	some_strict_real: STI_REAL
--			-- Randomly created real number
--			-- todo: refactor it.
--		do
--			Result := some_native_real
--		end

--	same_real (r: STS_REAL): STS_REAL
--			-- Real  number with the same value as `r`
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				create {STI_REAL} Result.make (r.value)
--			else -- when 1 then
--				Result := r
--			end
--		end

--	some_rational: STS_RATIONAL
--			-- Randomly created (polymorphic) rational number
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := --some_concrete_rational
--				some_rational
--			else -- when 1 then
--				Result := some_integer
--			end
--		end

--	some_strict_rational: STI_RATIONAL
--			-- Randomly created rational number
----		local
----			p, q: STI_INTEGER
--		do
----			from
----				p := some_concrete_integer
----				q := some_concrete_integer
----			until
----				p.divisible (q)
----			loop
----				q := some_concrete_integer
----			end
----			create Result.make (p, q)
--			Result := some_strict_rational
--		end

--	some_integer: STS_INTEGER
--			-- Randomly created (polymorphic) integer number
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := --some_concrete_integer
--				some_integer
--			else -- when 1 then
--				Result := some_natural
--			end
--		end

--	some_strict_integer: STI_INTEGER
--			-- Randomly created integer number
--		do
--			Result := --some_native_integer
--			some_strict_integer
--		end

--	some_natural: STS_NATURAL
--			-- Randomly created (polymorphic) natural number
--			-- todo: fix the type.
--		do
--			Result := --some_concrete_natural
--			some_natural
--		end

--	some_strict_natural: STI_NATURAL
--			-- Randomly created natural number
--		do
--			Result := --some_native_natural
--			some_strict_natural
--		end

--feature {NONE} -- Factory (complex sets)

--	some_complexes: STS_SET [STS_COMPLEX, STS_EQUALITY [STS_COMPLEX]]
--			-- Set of randomly created (polymorphic) complex numbers
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				Result := some_complex_references
--			when 1 then
--				Result := some_complex_objects
--			else -- when 2 then
--				Result := some_math_complexes
----			else -- when 3 then
----				Result := some_complex_set
--			end
--		end

--	some_complex_references: STI_SET [STS_COMPLEX, STS_REFERENCE_EQUALITY [STS_COMPLEX]]
--			-- Set of randomly created (polymorphic) complex numbers, compared by object reference.
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_complex
--			end
--		end

--	some_complex_objects: STI_SET [STS_COMPLEX, STS_OBJECT_EQUALITY [STS_COMPLEX]]
--			-- Set of randomly created (polymorphic) complex numbers, compared by object value.
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_complex
--			end
--		end

--	some_math_complexes: STI_SET [STS_COMPLEX, STS_COMPLEX_EQUALITY [STS_COMPLEX]]
--			-- Set of randomly created (polymorphic) complex numbers, compared by their mathematical value.
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_complex
--			end
--		end

--	some_complex_set: STI_COMPLEX_SET
--			-- Randomly created set of complex numbers
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_strict_complex
--			end
--		end

--feature {NONE} -- Factory (real sets)

--	some_reals: STS_SET [STS_REAL, STS_EQUALITY [STS_REAL]]
--			-- Set of randomly created (polymorphic) real numbers
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				Result := some_real_references
--			when 1 then
--				Result := some_real_objects
--			else -- when 2 then
--				Result := some_math_reals
--			end
--		end

--	some_real_references: STI_SET [STS_REAL, STS_REFERENCE_EQUALITY [STS_REAL]]
--			-- Set of randomly created (polymorphic) real numbers, compared by object reference.
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_real
--			end
--		end

--	some_real_objects: STI_SET [STS_REAL, STS_OBJECT_EQUALITY [STS_REAL]]
--			-- Set of randomly created (polymorphic) real numbers, compared by object value.
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_real
--			end
--		end

--	some_math_reals: STI_SET [STS_REAL, STS_COMPLEX_EQUALITY [STS_REAL]]
--			-- Set of randomly created (polymorphic) real numbers, compared by their mathematical value.
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_real
--			end
--		end

--	some_real_set: STI_REAL_SET
--			-- Randomly created set of real numbers
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_strict_real
--			end
--		end

--feature {NONE} -- Factory (object)

--	some_object: detachable separate ANY
--			-- <Precursor>
--		do
--			inspect
--				next_random_item \\ 3
--			when 0 then
--				Result := Precursor {STT_ELEMENT_TESTS}
--			when 1 then
--				Result := some_native_real
--			else -- when 2 then
--				Result := some_native_real_64
--			end
--		end

--	some_native_real: REAL
--			-- Randomly created native real number
--			-- todo: refactor it.
--		do
--			inspect
--				next_random_item \\ 16
--			when 0 then
--				Result := some_native_integer
--			when 1 then
--				Result := some_native_integer + some_native_integer
--			when 2 then
--				Result := some_native_integer - some_native_integer
--			when 3 then
--				Result := some_native_integer / some_native_integer.to_real
--			when 4 then
--				Result := (some_native_integer ^ some_native_integer).truncated_to_real
--			when 5 then
--				Result := {SINGLE_MATH}.log_2 (some_native_integer)
--			when 6 then
--				Result := {SINGLE_MATH}.cosine (some_native_integer)
--			when 7 then
--				Result := {SINGLE_MATH}.arc_cosine (some_native_integer)
--			when 8 then
--				Result := {SINGLE_MATH}.sine (some_native_integer)
--			when 9 then
--				Result := {SINGLE_MATH}.arc_sine (some_native_integer)
--			when 10 then
--				Result := {SINGLE_MATH}.tangent (some_native_integer)
--			when 11 then
--				Result := {SINGLE_MATH}.arc_tangent (some_native_integer)
--			when 12 then
--				Result := {SINGLE_MATH}.sqrt (some_native_integer)
--			when 13 then
--				Result := {SINGLE_MATH}.exp (some_native_integer)
--			when 14 then
--				Result := {SINGLE_MATH}.log (some_native_integer)
--			else -- when 15 then
--				Result := {SINGLE_MATH}.log10 (some_native_integer)
--			end
--		end

--	some_native_real_64: REAL_64
--			-- Randomly created native real-64 number
--			-- todo: refactor it.
--		do
--			inspect
--				next_random_item \\ 16
--			when 0 then
--				Result := some_native_integer
--			when 1 then
--				Result := some_native_integer + some_native_integer
--			when 2 then
--				Result := some_native_integer - some_native_integer
--			when 3 then
--				Result := some_native_integer / some_native_integer
--			when 4 then
--				Result := some_native_integer ^ some_native_integer
--			when 5 then
--				Result := {DOUBLE_MATH}.log_2 (some_native_integer)
--			when 6 then
--				Result := {DOUBLE_MATH}.cosine (some_native_integer)
--			when 7 then
--				Result := {DOUBLE_MATH}.arc_cosine (some_native_integer)
--			when 8 then
--				Result := {DOUBLE_MATH}.sine (some_native_integer)
--			when 9 then
--				Result := {DOUBLE_MATH}.arc_sine (some_native_integer)
--			when 10 then
--				Result := {DOUBLE_MATH}.tangent (some_native_integer)
--			when 11 then
--				Result := {DOUBLE_MATH}.arc_tangent (some_native_integer)
--			when 12 then
--				Result := {DOUBLE_MATH}.sqrt (some_native_integer)
--			when 13 then
--				Result := {DOUBLE_MATH}.exp (some_native_integer)
--			when 14 then
--				Result := {DOUBLE_MATH}.log (some_native_integer)
--			else -- when 15 then
--				Result := {DOUBLE_MATH}.log10 (some_native_integer)
--			end
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
