note
	description: "Test suite for {STS_REAL_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_REAL_SET_TESTS --[
--		X,
--		R -> STS_REAL,
--		B,
--		EQ_X -> STS_EQUALITY [X]
--			create
--				default_create
--			end,
--		EQ_R -> STS_COMPLEX_EQUALITY [R]
--			create
--				default_create
--			end,
--		EQ_B -> STS_EQUALITY [B]
--			create
--				default_create
--			end
--		]

----inherit
----	STT_COMPLEX_SET_TESTS [X, R, B, EQ_X, EQ_R, EQ_B]
----		rename
----				-- Factory (test element)
----			test_complex_set as test_real_set
----		end

----feature -- Test routines (Restriction)

----	test_non_positive
----			-- Test {STS_REAL_SET}.non_positive.
----		note
----			testing: "covers/{STS_REAL_SET}.non_positive"
----		do
----			assert ("non_positive", attached test_real_set.non_positive)
----		end

----	test_non_negative
----			-- Test {STS_REAL_SET}.non_negative.
----		note
----			testing: "covers/{STS_REAL_SET}.non_negative"
----		do
----			assert ("non_negative", attached test_real_set.non_negative)
----		end

----	test_negative
----			-- Test {STS_REAL_SET}.negative.
----		note
----			testing: "covers/{STS_REAL_SET}.negative"
----		do
----			assert ("negative", attached test_real_set.negative)
----		end

----	test_positive
----			-- Test {STS_REAL_SET}.positive.
----		note
----			testing: "covers/{STS_REAL_SET}.positive"
----		do
----			assert ("positive", attached test_real_set.positive)
----		end

----feature -- Test routines (Interval)

----	test_closed_interval
----			-- Test {STS_REAL_SET}.closed_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.closed_interval"
----		do
----			assert ("closed_interval", attached test_real_set [some_object_a, some_object_a])
----		end

----	test_left_closed_right_open_interval
----			-- Test {STS_REAL_SET}.left_closed_right_open_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.left_closed_right_open_interval"
----		do
----			assert ("left_closed_right_open_interval", attached test_real_set.left_closed_right_open_interval (some_object_a, some_object_a))
----		end

----	test_left_open_right_closed_interval
----			-- Test {STS_REAL_SET}.left_open_right_closed_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.left_open_right_closed_interval"
----		do
----			assert ("left_open_right_closed_interval", attached test_real_set.left_open_right_closed_interval (some_object_a, some_object_a))
----		end

----	test_open_interval
----			-- Test {STS_REAL_SET}.open_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.open_interval"
----		do
----			assert ("open_interval", attached test_real_set (some_object_a, some_object_a))
----		end

----	test_left_closed_right_unbounded_interval
----			-- Test {STS_REAL_SET}.left_closed_right_unbounded_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.left_closed_right_unbounded_interval"
----		do
----			assert ("left_closed_right_unbounded_interval", attached test_real_set.left_closed_right_unbounded_interval (some_object_a))
----		end

----	test_left_open_right_unbounded_interval
----			-- Test {STS_REAL_SET}.left_open_right_unbounded_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.left_open_right_unbounded_interval"
----		do
----			assert ("left_open_right_unbounded_interval", attached test_real_set.left_open_right_unbounded_interval (some_object_a))
----		end

----	test_left_unbounded_right_closed_interval
----			-- Test {STS_REAL_SET}.left_unbounded_right_closed_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.left_unbounded_right_closed_interval"
----		do
----			assert ("left_unbounded_right_closed_interval", attached test_real_set.left_unbounded_right_closed_interval (some_object_a))
----		end

----	test_left_unbounded_right_open_interval
----			-- Test {STS_REAL_SET}.left_unbounded_right_open_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.left_unbounded_right_open_interval"
----		do
----			assert ("left_unbounded_right_open_interval", attached test_real_set.left_unbounded_right_open_interval (some_object_a))
----		end

----	test_unbounded_interval
----			-- Test {STS_REAL_SET}.unbounded_interval.
----		note
----			testing: "covers/{STS_REAL_SET}.unbounded_interval"
----		do
----			assert ("unbounded_interval", attached test_real_set.unbounded_interval)
----		end

----feature -- Test routines (Predicate)

----	test_number_is_less
----			-- Test {STS_REAL_SET}.number_is_less.
----		note
----			testing: "covers/{STS_REAL_SET}.number_is_less"
----		local
----			x, y: R
----		do
----			from
----				x := some_object_a
----				y := some_object_a
----			until
----				x.value < y.value
----			loop
----				x := some_object_a
----				y := some_object_a
----			end
----			assert ("x_number_is_less_y", test_real_set.number_is_less (x, y))

----			x := some_object_a
----			y := some_object_a
----			assert ("number_is_less", test_real_set.number_is_less (x, y) implies True)
----		end

----	test_number_is_less_equal
----			-- Test {STS_REAL_SET}.number_is_less_equal.
----		note
----			testing: "covers/{STS_REAL_SET}.number_is_less_equal"
----		local
----			x, y: R
----		do
----			from
----				x := some_object_a
----				y := some_object_a
----			until
----				x.value ⊆ y.value
----			loop
----				x := some_object_a
----				y := some_object_a
----			end
----			assert ("x_number_is_less_equal_y", test_real_set.number_is_less_equal (x, y))

----			x := some_object_a
----			y := some_object_a
----			assert ("number_is_less_equal", test_real_set.number_is_less_equal (x, y) implies True)
----		end

----feature {NONE} -- Factory (test element)

----	test_real_set: STS_REAL_SET [R, EQ_R]
----			-- Real set meant to be under tests
----		deferred
----		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
