﻿note
	description: "Test suite for {STS_REAL}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_REAL_TESTS --[
--		X,
--		R -> STS_REAL,
--		B,
--		EQ_X -> STS_EQUALITY [X]
--			create
--				default_create
--			end,
--		EQ_R -> STS_COMPLEX_EQUALITY [R]
--			create
--				default_create
--			end,
--		EQ_B -> STS_EQUALITY [B]
--			create
--				default_create
--			end
--		]

----inherit
----	STT_COMPLEX_TESTS [X, R, B, EQ_X, EQ_R, EQ_B]
----		rename
----				-- Test routines (Comparison)
----			test_equals as test_complex_equals,
----				-- Test routines (Status report)
----			test_divisible as test_complex_divisible,
----				-- Test routines (Basic operations)
------			test_conjugate as test_complex_conjugate,
----			test_plus as test_complex_plus,
----			test_minus as test_complex_minus,
----			test_product as test_complex_product,
----			test_quotient as test_complex_quotient,
----				-- Factory (test element)
----			test_complex as test_real
------		redefine
------				-- Test routines (Basic operations)
------			test_reciprocal, test_inverse
----		end

----feature -- Test routines (Access)

----	test_sign
----			-- Test {STS_REAL}.sign.
----		note
----			testing: "covers/{STS_REAL}.sign"
----		do
----			assert ("sign", attached test_real.sign)
----		end

----feature -- Test routines (Status report)

----	test_divisible
----			-- Test {STS_REAL}.divisible.
----		note
----			testing: "covers/{STS_REAL}.divisible"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			from
----				x1 := test_real
----				x2 := some_real
----			until
----				x2.is_invertible
----			loop
----				x2 := some_real
----			end
----			assert ("x1_divisible_x2", x1.divisible (x2))

----			x1 := test_real
----			x2 := some_real
----			assert ("divisible", x1.divisible (x2) implies True)
----		end

----	test_exponentiable
----			-- Test {STS_REAL}.exponentiable.
----		note
----			testing: "covers/{STS_REAL}.exponentiable"
----		do
----			assert ("exponentiable", test_real.exponentiable (some_complex) implies True)
----		end

----feature -- Test routines (Comparison)

----	test_equals
----			-- Test {STS_REAL}.equals.
----		note
----			testing: "covers/{STS_REAL}.equals"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", x1 ≍ x1)

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", x1 ≍ x2)

----			x1 := test_real
----			x2 := some_real
----			assert ("some_real", x1 ≍ x2 implies True)
----		end

----	test_same_value
----			-- Test {STS_REAL}.same_value.
----		note
----			testing: "covers/{STS_REAL}.same_value"
----		local
----			x: like test_real
----			v1, v2: REAL
----		do
----			x := test_real
----			v1 := some_native_real
----			assert ("same_entity",  x.same_value (v1, v1))

----			x := test_real
----			v1 := some_native_real
----			v2 := v1
----			assert ("same_real", x.same_value (v1, v2))

----			x := test_real
----			v1 := some_native_real
----			v2 := some_native_real
----			assert ("same_value", x.same_value (v1, v2) implies True)
----		end

----	test_is_less
----			-- Test {STS_REAL}.is_less.
----		note
----			testing: "covers/{STS_REAL}.is_less"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", not (x1 < x1))

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", not (x1 < x2))

----			x1 := test_real
----			x2 := some_real
----			assert ("is_less", x1 < x2 implies True)
----		end

----	test_is_less_equal
----			-- Test {STS_REAL}.is_less_equal.
----		note
----			testing: "covers/{STS_REAL}.is_less_equal"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", x1 â x1)

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", x1 â x2)

----			x1 := test_real
----			x2 := some_real
----			assert ("is_less_equal", x1 â x2 implies True)
----		end

----	test_is_greater
----			-- Test {STS_REAL}.is_greater.
----		note
----			testing: "covers/{STS_REAL}.is_greater"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", not (x1 > x1))

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", not (x1 > x2))

----			x1 := test_real
----			x2 := some_real
----			assert ("is_greater", x1 > x2 implies True)
----		end

----	test_is_greater_equal
----			-- Test {STS_REAL}.is_greater_equal.
----		note
----			testing: "covers/{STS_REAL}.is_greater_equal"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", x1 â x1)

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", x1 â x2)

----			x1 := test_real
----			x2 := some_real
----			assert ("is_greater_equal", x1 â x2 implies True)
----		end

----	test_three_way_comparison
----			-- Test {STS_REAL}.three_way_comparison.
----		note
----			testing: "covers/{STS_REAL}.three_way_comparison"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", x1.three_way_comparison (x1) = 0)

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", x1.three_way_comparison (x2) = 0)

----			x1 := test_real
----			x2 := some_real
----			assert ("three_way_comparison", attached x1.three_way_comparison (x2))
----		end

----	test_min
----			-- Test {STS_REAL}.min.
----		note
----			testing: "covers/{STS_REAL}.min"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", x1.min (x1) ≍ x1)

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", x1.min (x2) ≍ x1)

----			x1 := test_real
----			x2 := some_real
----			assert ("min", attached x1.min (x2))
----		end

----	test_max
----			-- Test {STS_REAL}.max.
----		note
----			testing: "covers/{STS_REAL}.max"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			x1 := test_real
----			assert ("same_entity", x1.max (x1) ≍ x1)

----			x1 := test_real
----			x2 := same_real (x1)
----			assert ("same_real", x1.max (x2) ≍ x1)

----			x1 := test_real
----			x2 := some_real
----			assert ("min", attached x1.max (x2))
----		end

----feature -- Test routines (Basic operations)

----	test_abs
----			-- Test {STS_REAL}.abs.
----		note
----			testing: "covers/{STS_REAL}.abs"
----		do
----			assert ("abs", attached test_real.abs)
----		end

----	test_plus
----			-- Test {STS_REAL}.plus.
----		note
----			testing: "covers/{STS_REAL}.plus"
----		do
----			assert ("plus", attached (test_real + some_real))
----		end

------	test_identity
------			-- Test {STS_REAL}.identity.
------		note
------			testing: "covers/{STS_REAL}.identity"
------		do
------			assert ("identity", attached (+ test_real))
------		end

----	test_minus
----			-- Test {STS_REAL}.minus.
----		note
----			testing: "covers/{STS_REAL}.minus"
----		do
----			assert ("minus", attached (test_real - some_real))
----		end

------	test_opposite
------			-- Test {STS_REAL}.opposite.
------		note
------			testing: "covers/{STS_REAL}.opposite"
------		do
------			assert ("opposite", attached (- test_real))
------		end

----	test_product
----			-- Test {STS_REAL}.product.
----		note
----			testing: "covers/{STS_REAL}.product"
----		do
----			assert ("product", attached (test_real * some_real))
----		end

----	test_quotient
----			-- Test {STS_REAL}.quotient.
----		note
----			testing: "covers/{STS_REAL}.quotient"
----		local
----			x1: like test_real
----			x2: like some_real
----		do
----			from
----				x1 := test_real
----				x2 := some_real
----			until
----				x1.divisible (x2)
----			loop
----				x2 := some_real
----			end
----			assert ("quotient", attached (x1 / x2))
----		end

------	test_reciprocal
------			-- Test {STS_REAL}.reciprocal.
------		note
------			testing: "covers/{STS_REAL}.reciprocal"
------		local
------			x: like test_real
------		do
------			Precursor {STT_COMPLEX_TESTS}
------			from
------				x := test_real
------			until
------				x.one.divisible (x)
------			loop
------				x := test_real
------			end
------			assert ("reciprocal", attached x.reciprocal)
------		end

------	test_inverse
------			-- Test {STS_REAL}.inverse.
------		note
------			testing: "covers/{STS_REAL}.inverse"
------		local
------			x: like test_real
------		do
------			Precursor {STT_COMPLEX_TESTS}
------			from
------				x := test_real
------			until
------				x.one.divisible (x)
------			loop
------				x := test_real
------			end
------			assert ("inverse", attached x.inverse)
------		end

----	test_power
----			-- Test {STS_REAL}.power.
----		note
----			testing: "covers/{STS_REAL}.power"
----		do
----			assert ("power", attached (test_real ^ some_real))
----		end

----feature -- Test routines (Factory)

----	test_normalized_value
----			-- Test {STS_REAL}.normalized_value.
----		note
----			testing: "covers/{STS_REAL}.normalized_value"
----		do
----			assert ("normalized_value", attached test_real.normalized_value (some_native_real))
----		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
